# DimensionalData

[![](https://img.shields.io/badge/docs-stable-blue.svg)](https://rafaqz.github.io/DimensionalData.jl/stable)
[![](https://img.shields.io/badge/docs-dev-blue.svg)](https://rafaqz.github.io/DimensionalData.jl/dev)
[![CI](https://github.com/rafaqz/DimensionalData.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/rafaqz/DimensionalData.jl/actions/workflows/ci.yml)
[![Codecov](https://codecov.io/gh/rafaqz/DimensionalData.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/rafaqz/DimensionalData.jl/tree/main)
[![Aqua.jl Quality Assurance](https://img.shields.io/badge/Aqua.jl-%F0%9F%8C%A2-aqua.svg)](https://github.com/JuliaTesting/Aqua.jl)

<img src="https://rafaqz.github.io/DimensionalData.jl/dev/logo.png" align="right" style="padding-left:10px;" width="180"/>

> [!TIP]
> Visit the latest documentation at https://rafaqz.github.io/DimensionalData.jl/dev/

DimensionalData.jl provides tools and abstractions for working with datasets that have named dimensions, and optionally a lookup index. It provides no-cost abstractions for named indexing, and fast index lookups.

DimensionalData is a pluggable, generalised version of [AxisArrays.jl](https://github.com/JuliaArrays/AxisArrays.jl) with a cleaner syntax, and additional functionality found in NamedDims.jl. It has similar goals to pythons [xarray](https://xarray.dev/), and is primarily written for use with spatial data in [Rasters.jl](https://github.com/rafaqz/Rasters.jl).

## Installation

```shell
julia>]
pkg> add DimensionalData
```

## Quick start

Start using the package:

```julia
using DimensionalData
```

The basic syntax to create a dimensional array (`DimArray`) is:

```julia
A = DimArray(rand(50, 31), (X(), Y(10.0:40.0)));
```

Or just use `rand` directly, which also works for `zeros`, `ones` and `fill`:

```julia
A = rand(X(10), Y(10.0:20.0))
```
```julia
╭───────────────────────────╮
│ 10×11 DimArray{Float64,2} │
├───────────────────────────┴──────────────────────────────── dims ┐
  ↓ X,
  → Y Sampled{Float64} 10.0:1.0:20.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────┘
 10.0       11.0       12.0        13.0       14.0         …  16.0       17.0       18.0        19.0       20.0
  0.71086    0.689255   0.672889    0.766345   0.00277696      0.773863   0.252199   0.279538    0.808931   0.783528
  0.934464   0.815631   0.815715    0.890573   0.158584        0.304733   0.936321   0.499803    0.839926   0.979722
  ⋮                                                        ⋱                                                ⋮
  0.935495   0.460879   0.0218015   0.703387   0.756411    …   0.431141   0.619897   0.0536918   0.506488   0.170494
  0.800226   0.208188   0.512795    0.421171   0.492668        0.238562   0.4694     0.320596    0.934364   0.147563
```

> [!NOTE]
> Subsetting by index is easy:

```julia
A[Y=1:10, X=1]
```
```julia
╭────────────────────────────────╮
│ 10-element DimArray{Float64,1} │
├────────────────────────────────┴─────────────────────────── dims ┐
  ↓ Y Sampled{Float64} 10.0:1.0:19.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────┘
 10.0  0.130198
 11.0  0.693343
 12.0  0.400656
  ⋮    
 17.0  0.877581
 18.0  0.866406
 19.0  0.605331
```

One can also subset by lookup, using a `Selector`, let's try `At`: 

```julia
A[Y(At(25))]
```
```julia
╭────────────────────────────────╮
│ 50-element DimArray{Float64,1} │
├────────────────────────── dims ┤
  ↓ X
└────────────────────────────────┘
  1  0.5318
  2  0.212491
  3  0.99119
  4  0.373549
  5  0.0987397
  ⋮  
 46  0.503611
 47  0.225421
 48  0.293564
 49  0.976395
 50  0.622586
```

There is also `Near` (for inexact/nearest selection), `Contains` (for `Intervals` containing values), 
`Between` or `..` for range selection, and `Where` for queries, among others.

Plotting with Makie.jl is as easy as:

```julia
using GLMakie, DimensionalData
boxplot(rand(X('a':'d'), Y(2:5:20)))
```

And the plot will have the right ticks and labels.

[See the docs for more details](https://rafaqz.github.io/DimensionalData.jl/stable/)

> [!NOTE]
> Recent changes have greatly reduced the exported API.

Previously exported methods can be brought into global scope by `using`
the sub-modules they have been moved to - `Lookup` and `Dimensions`:

```julia
using DimensionalData
using DimensionalData.Lookup, DimensionalData.Dimensions
```

## Alternative packages

There are a lot of similar Julia packages in this space. AxisArrays.jl, NamedDims.jl, NamedArrays.jl are registered alternative that each cover some of the functionality provided by DimensionalData.jl. DimensionalData.jl should be able to replicate most of their syntax and functionality.

[AxisKeys.jl](https://github.com/mcabbott/AxisKeys.jl) and [AbstractIndices.jl](https://github.com/Tokazama/AbstractIndices.jl) are some other interesting developments. For more detail on why there are so many similar options and where things are headed, read this [thread](https://github.com/JuliaCollections/AxisArraysFuture/issues/1).

The main functionality is explained here, but the full list of features is
listed at the [API](https://rafaqz.github.io/DimensionalData.jl/stable/api/reference) page.

const SelectorOrStandard = Union{SelectorOrInterval,StandardIndices}
const DimensionIndsArrays = Union{AbstractArray{<:Dimension},AbstractArray{<:DimTuple}}
const DimensionalIndices = Union{DimTuple,DimIndices,DimSelectors,Dimension,DimensionIndsArrays}
const _DimIndicesAmb = Union{AbstractArray{Union{}},DimIndices{<:Integer},DimSelectors{<:Integer}}
const IntegerOrCartesian = Union{Integer,CartesianIndex}

# getindex/view/setindex! ======================================================

for f in (:getindex, :view, :dotview)
    _dim_f = Symbol(:_dim_, f)

    # Integer indexing
    if f === :view
        # With one Integer and 0d and 1d we try to rebuild
        @eval @propagate_inbounds Base.$f(A::AbstractBasicDimArray{<:Any,0}, i::Integer) =
            rebuildsliced(Base.$f, A, (i,))
        # One Integer on a vector and we also rebuild
        @eval @propagate_inbounds Base.$f(A::AbstractBasicDimVector, i::Integer) =
            rebuildsliced(Base.$f, A, (i,))
        # More Integers and we rebuild
        @eval @propagate_inbounds Base.$f(A::AbstractBasicDimArray, i1::Integer, i2::Integer, I::Integer...) =
            rebuildsliced(Base.$f, A, (i1, i2, I...))
        # Otherwise its linear indexing, don't rebuild
        @eval @propagate_inbounds Base.$f(A::AbstractBasicDimArray, i::Integer) =
            Base.$f(parent(A), i)
    end
    @eval begin
        ### Selector/Interval indexing
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, i::SelectorOrInterval) = 
            Base.$f(A, dims2indices(A, (i,))...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, i1::SelectorOrStandard, i2::SelectorOrStandard, I::SelectorOrStandard...) =
            Base.$f(A, dims2indices(A, (i1, i2, I...))...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, i::Selector{<:Extents.Extent}) = 
            Base.$f(A, dims2indices(A, i)...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, i::Selector{<:Extents.Extent}) = 
            Base.$f(A, dims2indices(A, i)...)

        # Extent indexing
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, extent::Extents.Extent) =
            Base.$f(A, dims2indices(A, extent)...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, extent::Extents.Extent) =
            Base.$f(A, dims2indices(A, extent)...)

        ### Dimension indexing
        @propagate_inbounds function Base.$f(A::AbstractBasicDimArray; kw...)
            # Need to use one method and check keywords to avoid method overwrites
            if isempty(kw)
                rebuildsliced(Base.$f, A, ())
            else
                $_dim_f(A, _simplify_dim_indices(kw2dims(values(kw))...,)...)
            end
        end
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, d1::DimensionalIndices; kw...) =
            $_dim_f(A, _simplify_dim_indices(d1, kw2dims(values(kw))...)...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, d1::DimensionalIndices, d2::DimensionalIndices, D::DimensionalIndices...; kw...) =
            $_dim_f(A, _simplify_dim_indices(d1, d2, D..., kw2dims(values(kw))...)...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, i::DimensionalIndices) =
            $_dim_f(A, _simplify_dim_indices(i)...)
 
        # All dimension indexing is passed to these underscore methods to minimise ambiguities
        @propagate_inbounds $_dim_f(A::AbstractBasicDimArray, ds::DimTuple) = $_dim_f(A, ds...)
        @propagate_inbounds $_dim_f(A::AbstractBasicDimArray, d1::Dimension, ds::Dimension...) =
            Base.$f(A, dims2indices(A, (d1, ds...))...)
        # Regular non-dimensional indexing
        @propagate_inbounds $_dim_f(A::AbstractBasicDimArray, I...) = Base.$f(A, I...)
        # Catch the edge case dims were passed but did not match - 
        # we want to index with all colons [:, :, ...], not []
        @propagate_inbounds $_dim_f(A::AbstractBasicDimArray{<:Any,N}) where N =
            rebuildsliced(Base.$f, A, ntuple(i -> Colon(), Val(N)))
        @propagate_inbounds function $_dim_f(
            A::AbstractBasicDimArray, 
            d1::Union{Dimension,DimensionIndsArrays}, 
            ds::Union{Dimension,DimensionIndsArrays}...
        )
            return merge_and_index(Base.$f, A, (d1, ds...))
        end
        @propagate_inbounds function $_dim_f(A::AbstractBasicDimArray{<:Any,0}, d1::Dimension, ds::Dimension...)
            Dimensions._extradimswarn((d1, ds...))
            return rebuildsliced(Base.$f, A, ())
        end

        ### Standard indices
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, I::CartesianIndex) =
            Base.$f(A, to_indices(A, (I,))...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, I::CartesianIndex) =
            Base.$f(A, to_indices(A, (I,))...)
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, i1::IntegerOrCartesian, i2::IntegerOrCartesian, Is::IntegerOrCartesian...) =
            Base.$f(A, to_indices(A, (i1, i2, Is...))...)
        # 1D DimArrays dont need linear indexing
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, i::Union{Colon,AbstractArray{<:Integer}}) =
            rebuildsliced(Base.$f, A, (i,))
        @propagate_inbounds Base.$f(A::AbstractBasicDimVector, I::CartesianIndices) = rebuildsliced(Base.$f, A, (I,))
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, I::CartesianIndices) = rebuildsliced(Base.$f, A, (I,))
        @propagate_inbounds Base.$f(A::AbstractBasicDimArray, i1::StandardIndices, i2::StandardIndices, Is::StandardIndices...) =
            rebuildsliced(Base.$f, A, to_indices(A, (i1, i2, Is...)))
    end

    ##### AbstractDimArray only methods
    # Here we know we can just index into the parent object
    # Linear indexing forwards to the parent array as it will break the dimensions
    # AbstractBasicDimArray must defined their own methods
    @eval @propagate_inbounds Base.$f(A::AbstractDimArray, i::Union{Colon,AbstractArray{<:Integer}}) =
        Base.$f(parent(A), i)
    # Except for AbstractDimVector
    @eval @propagate_inbounds Base.$f(A::AbstractDimVector, i::Union{Colon,AbstractArray{<:Integer}}) =
        rebuildsliced(Base.$f, A, (i,))
    if f in (:getindex, :dotview)
        # We only define getindex with Integer on AbstractDimArray
        # AbstractBasicDimArray must defined their own
        @eval @propagate_inbounds Base.$f(A::AbstractDimVector, i::Integer) = Base.$f(parent(A), i)
        @eval @propagate_inbounds Base.$f(A::AbstractDimArray, i::Integer) = Base.$f(parent(A), i)
        @eval @propagate_inbounds Base.$f(A::AbstractDimArray, i1::Integer, i2::Integer, I::Integer...) =
            Base.$f(parent(A), i1, i2, I...)
        @eval @propagate_inbounds Base.$f(A::AbstractDimArray) = Base.$f(parent(A))
    end
    # Special case zero dimensional arrays being indexed with missing dims
    if f == :getindex
        # Catch this before the dimension is converted to ()
        @eval $_dim_f(A::AbstractDimArray{<:Any,0}) = rebuild(A, fill(A[]))
        @eval function $_dim_f(A::AbstractDimArray{<:Any,0}, d1::Dimension, ds::Dimension...)
            Dimensions._extradimswarn((d1, ds...))
            return rebuild(A, fill(A[]))
        end
    end
end

function merge_and_index(f, A, dims)
    dims, inds_arrays = _separate_dims_arrays(_simplify_dim_indices(dims...)...)
    # No arrays here, so abort (dispatch is tricky...)
    length(inds_arrays) == 0 && return f(A, dims...)

    V1 = length(dims) > 0 ? view(A, dims...) : A
    # We have an array of dims of dim tuples
    V2 = reduce(inds_arrays[1:end-1]; init=V1) do A, i
        _merge_and_index(view, A, i)
    end

    return _merge_and_index(f, V2, inds_arrays[end])
end

function _merge_and_index(f, A, inds)
    # Get any other dimensions not passed in
    dims_to_merge = first(inds)
    if length(dims_to_merge) > 1
        if inds isa AbstractVector
            M = mergedims(A, dims_to_merge)
            ods = otherdims(M, DD.dims(A))
            if length(ods) > 0
                mdim = only(ods)
                lazylinear = rebuild(mdim, LazyDims2Linear(inds, DD.dims(A, dims_to_merge)))
                f(M, lazylinear)
            else
                # Index anyway with all Colon() just for type consistency
                f(M, basedims(M)...)
            end
        else
            m_inds = CartesianIndex.(dims2indices.(Ref(A), inds))
            f(A, m_inds)
        end
    else
        f(A, only(dims_to_merge))
    end
end

struct LazyDims2Linear{N,D,A<:AbstractArray{<:Any,N}} <: AbstractArray{Int,N}
    dimtuples::A
    dims::D
end
function LazyDims2Linear(dimtuples::A, dims::D) where {A<:AbstractArray{<:DimTuple,N},D<:DimTuple} where N
    LazyDims2Linear{N,D,A}(dimtuples, dims)
end

dims(A::LazyDims2Linear) = A.dims

Base.size(A::LazyDims2Linear) = size(A.dimtuples)
Base.getindex(A::LazyDims2Linear, I::Integer...) =
    LinearIndices(size(dims(A)))[dims2indices(DD.dims(A), A.dimtuples[I...])...]

function _separate_dims_arrays(d::Dimension, ds...)
    ds, as = _separate_dims_arrays(ds...)
    (ds..., d), as
end
function _separate_dims_arrays(a::AbstractArray, ds...)
    ds, as = _separate_dims_arrays(ds...)
    ds, (a, as...)
end
_separate_dims_arrays() = (), ()

Base.@assume_effects :foldable @inline _simplify_dim_indices(d::Dimension, ds...) =
    (d, _simplify_dim_indices(ds)...)
Base.@assume_effects :foldable @inline _simplify_dim_indices(d::Tuple, ds...) =
    (d..., _simplify_dim_indices(ds)...)
Base.@assume_effects :foldable @inline _simplify_dim_indices(d::AbstractArray{<:Dimension}, ds...) =
    (d, _simplify_dim_indices(ds)...)
Base.@assume_effects :foldable @inline _simplify_dim_indices(d::AbstractArray{<:DimTuple}, ds...) =
    (d, _simplify_dim_indices(ds)...)
Base.@assume_effects :foldable @inline _simplify_dim_indices(::Tuple{}) = ()
Base.@assume_effects :foldable @inline _simplify_dim_indices(d::DimIndices, ds...) =
    (dims(d)..., _simplify_dim_indices(ds)...)
Base.@assume_effects :foldable @inline function _simplify_dim_indices(d::DimSelectors, ds...)
    seldims = map(dims(d), d.selectors) do d, s
        # But the dimension values inside selectors
        rebuild(d, rebuild(s; val=val(d)))
    end
    return (seldims..., _simplify_dim_indices(ds)...)
end
Base.@assume_effects :foldable @inline _simplify_dim_indices() = ()

@inline _unwrap_cartesian(i1::CartesianIndices, I...) = (Tuple(i1)..., _unwrap_cartesian(I...)...)
@inline _unwrap_cartesian(i1::CartesianIndex, I...) = (Tuple(i1)..., _unwrap_cartesian(I...)...)
@inline _unwrap_cartesian(i1, I...) = (i1, _unwrap_cartesian(I...)...)
@inline _unwrap_cartesian() = ()

#### setindex ####

@propagate_inbounds Base.setindex!(A::AbstractDimArray, x) = setindex!(parent(A), x)
@propagate_inbounds Base.setindex!(A::AbstractDimArray, x, i, I...) =
    setindex!(A, x, dims2indices(A, (i, I...))...)
@propagate_inbounds Base.setindex!(A::AbstractDimArray, x, I::DimensionalIndices...; kw...) =
    setindex!(A, x, dims2indices(A, _simplify_dim_indices(I..., kw2dims(values(kw))...))...)
@propagate_inbounds Base.setindex!(A::DimensionalData.AbstractDimArray, x, i1::_DimIndicesAmb, I::_DimIndicesAmb...; kw...) = 
    setindex!(A, x, dims2indices(A, _simplify_dim_indices(i1, I..., kw2dims(values(kw))...))...)
@propagate_inbounds Base.setindex!(A::AbstractDimArray, x, i1::StandardIndices, I::StandardIndices...) =
    setindex!(parent(A), x, i1, I...)

# For @views macro to work with keywords
@propagate_inbounds Base.maybeview(A::AbstractDimArray, args...; kw...) =
    view(A, args...; kw...)
@propagate_inbounds Base.maybeview(A::AbstractDimArray, args::Vararg{Union{Number,Base.AbstractCartesianIndex}}; kw...) =
    view(A, args...; kw...)

# We only own this to_indices dispatch for AbstractBasicDimArray
Base.to_indices(A::AbstractBasicDimArray, inds, (r, args...)::Tuple{<:Type,Vararg}) =
    (Lookups._to_index(inds[1], r), to_indices(A, Base.tail(inds), args)...)

using DimensionalData, Test, Unitful, Extents
using DimensionalData.Lookups, DimensionalData.Dimensions
using Statistics: mean
using DimensionalData.Dimensions: SelOrStandard

dim = Coord([(1.0,1.0,1.0), (1.0,2.0,2.0), (3.0,4.0,4.0), (1.0,3.0,4.0)], (X(), Y(), Z()))
da = DimArray(0.1:0.1:0.4, dim)
da2 = DimArray((0.1:0.1:0.4) * (1:1:3)', (dim, Ti(1u"s":1u"s":3u"s")); metadata=Dict())

@testset "regular indexing" begin
    @test da[Coord()] == da[Coord(:)] == da
    @test da[Coord([1, 2])] == [0.1, 0.2]
    @test da[Coord(4)] == 0.4
    @test da2[Coord(4), Ti(3)] ≈ 1.2
end

@testset "subdim indexing" begin
    @test da[X(At(1))] == da[Coord(X(At(1)))]
    @test da[X(At(1)), Y(At(1))] == da[Coord(X(At(1)), Y(At(1)))]
    @test da[X(At(1)), Y(At(1)), Z(At(1))] == da[Coord(X(At(1)), Y(At(1)), Z(At(1)))]
    @test da[Y(At(1)), Z(At(1))] == da[Coord(Y(At(1)), Z(At(1)))]
    @test da[Z(At(4))] == da[Coord(Z(At(4)))]
end

@testset "merged selector indexing" begin
    @test da[Coord(:, :, :)] == [0.1, 0.2, 0.3, 0.4]
    @test da[Coord(Between(1, 5), :, At(4.0))] == [0.3, 0.4]
    @test da[Coord(:, Between(1, 2), :)] == [0.1, 0.2]
    @test da2[Ti(At(1u"s")), Coord(:, Between(1, 2), :)] == [0.1, 0.2]
    @test da2[Ti(At(2u"s")), Coord(:, Where(>=(3)), :)] == [0.6, 0.8]
    @test_throws ArgumentError da[var=1, Coord(:, Near(1), :)] 
end

@testset "merged dimension indexing" begin
    @test da[Coord(Z(At(1.0)), Y(Between(1, 3)))] == [0.1]
    @test da[Coord(Z(At(1.0)), Y(Between(1, 3)))] == da[Z(At(1.0)), Y(Between(1, 3))]
end

@test lookup(da[Coord(:, Between(1, 2), :)], Coord) == [(1.0,1.0,1.0), (1.0,2.0,2.0)]

@test DimensionalData.bounds(da) == (((1.0, 3.0), (1.0, 4.0), (1.0, 4.0)),)

@testset "merged named reduction" begin
    m = mean(da2; dims=Coord)
    @test size(m) == (1,3)
    @test length(dims(m, Coord)) == 1
    @test dims(m, Coord).val == DimensionalData.NoLookup(Base.OneTo(1))
    pure_mean = mean(da2.data; dims = 1)
    @test vec(pure_mean) == vec(m.data)
end

@testset "merged indexing with intervals" begin
    @test da[Coord(Z(At(1.0)), Y(1..3))] == [0.1]
    @test da[Z(At(1.0)), Y(1..3)] == [0.1]
    @test da2[Ti(At(1u"s")), Coord(X(At(1.0)), Y(At(3.0)), Z(At(4.0)))] == 0.4
    @test da2[Ti(At(1u"s")), X(At(1.0)), Y(1..3)] == [0.1, 0.2, 0.4]
end

@testset "custom merged names" begin
    A = (1:2) * (1:40)'
    merged = Dim{:mymerged}(Dimensions.MergedLookup(map(Tuple, vec(CartesianIndices((1:10, 1:4)))), (Dim{:draw}(), Dim{:chain}())))
    da = DimArray(A, (Dim{:var}(1:2), merged))
    @test da[var=2, mymerged=(Dim{:draw}(At(8)), Dim{:chain}(At(4)))] == 76
    @test da[var=1, mymerged=(draw=At(8), chain=At(1))] == 8 
    @test da[var=1, draw=At(8), chain=At(1)] == 8 
end

@testset "show merged" begin
    sprint(show, dim)
    sp = sprint(show, MIME"text/plain"(), dim)
    @test occursin("Coord", sp)
    sp = sprint(show, MIME"text/plain"(), da)
    @test occursin("Coord", sp)
    @test occursin("X", sp)
    @test occursin("Y", sp)
    @test occursin("Z", sp)
end

@testset "unmerge" begin
    a = DimArray(rand(32, 32, 3), (X,Y,Dim{:band}))
    b = DimStack((;a))
    for a in (a, b)
        merged = mergedims(a, (X, Y) => :geometry)
        unmerged = unmergedims(merged, dims(a))
        perm_unmerged = unmergedims(permutedims(merged, (2,1)), dims(a))
        
        # Test Merge
        @test hasdim(merged, Dim{:band})
        @test hasdim(merged, Dim{:geometry})
        @test !hasdim(merged, X)
        @test !hasdim(merged, Y)
        @test size(merged) == (3, 32 * 32)

        # Test Unmerge
        @test hasdim(unmerged, X)
        @test hasdim(unmerged, Y)
        @test hasdim(unmerged, Dim{:band})
        @test !hasdim(unmerged, Dim{:geometry})
        @test dims(unmerged) == dims(a)
        @test size(unmerged) == size(a)
        @test all(a .== unmerged)
        @test all(a .== perm_unmerged)
    end
end

@testset "indexing with totally random dim on merged lookup still errors" begin
    da = ones(X(1:10), Y(1:10), Dim{:random}(1:10))
    merged = mergedims(da, (X, Y) => :space)
    @test_warn "Z" merged[Z(1)]
end

@testset "hasinternaldimensions trait" begin
    # Test default behavior for regular lookups
    @testset "Regular lookups return false" begin
        @test hasinternaldimensions(NoLookup()) == false
        @test hasinternaldimensions(Sampled(1:10)) == false
        @test hasinternaldimensions(Categorical([:a, :b, :c])) == false
        @test hasinternaldimensions(Cyclic(1:12; cycle=12)) == false
        @test hasinternaldimensions(Sampled(1:10; sampling=Points())) == false
        @test hasinternaldimensions(Sampled(1:10; sampling=Intervals())) == false
    end

    @testset "MergedLookup returns true" begin
        x_dim = X(1:3)
        y_dim = Y(10:10:30)
        merged_data = vec(DimPoints((x_dim, y_dim)))
        merged_lookup = Dimensions.MergedLookup(merged_data, (x_dim, y_dim))
        @test hasinternaldimensions(merged_lookup) == true
    end

    @testset "Extent passthrough for MergedLookup" begin
        # Basic extent with MergedLookup
        x_vals = 1.0:3.0
        y_vals = 10.0:10.0:30.0
        x_dim = X(x_vals)
        y_dim = Y(y_vals)
        
        merged_dims = mergedims((x_dim, y_dim) => :space)
        ext = Extents.extent((merged_dims,))
        
        @test haskey(ext, :X)
        @test haskey(ext, :Y)
        @test ext.X == (1.0, 3.0)
        @test ext.Y == (10.0, 30.0)

        # Mixed regular and merged dimensions
        t_dim = Ti(1:5)
        z_dim = Z(100:100:300)
        all_dims = (t_dim, merged_dims, z_dim)
        ext2 = Extents.extent(all_dims)
        
        @test ext2.Ti == (1, 5)
        @test ext2.Z == (100, 300)
        @test ext2.X == (1.0, 3.0)
        @test ext2.Y == (10.0, 30.0)
    end

    @testset "Multiple merged dimensions extent" begin
        x1_dim = X(1:3)
        y1_dim = Y(10:10:30)
        t_dim = Ti(0.0:0.5:1.0)
        z_dim = Z(-5:5)
        
        merged_space = mergedims((x1_dim, y1_dim) => :space)
        merged_tz = mergedims((t_dim, z_dim) => :timez)
        all_dims = (merged_space, merged_tz)
        
        ext = Extents.extent(all_dims)
        @test ext.X == (1, 3)
        @test ext.Y == (10, 30)
        @test ext.Ti == (0.0, 1.0)
        @test ext.Z == (-5, 5)
    end

    @testset "Extent with subset of dimensions" begin
        x_dim = X(1:5)
        y_dim = Y(10:10:50)
        z_dim = Z(100:100:300)
        
        merged = mergedims((x_dim, y_dim) => :space)
        all_dims = (merged, z_dim)
        
        # Get extent for just the Z dimension
        ext_z = Extents.extent(all_dims, Z)
        @test ext_z.Z == (100, 300)
        @test !haskey(ext_z, :X)
        @test !haskey(ext_z, :Y)
        
        # Get extent for merged dimension by name
        ext_space = Extents.extent(all_dims, :space)
        @test ext_space.X == (1, 5)
        @test ext_space.Y == (10, 50)
        @test !haskey(ext_space, :Z)
    end

    @testset "Operations preserve hasinternaldimensions" begin
        x = X(1:3)
        y = Y(10:10:30)
        data = rand(3, 3)
        
        da = DimArray(data, (x, y))
        merged_da = mergedims(da, (X, Y) => :space)
        
        # Broadcasting preserves trait
        result = merged_da .+ 1
        @test hasinternaldimensions(lookup(dims(result, :space)))
        
        # Slicing with additional dimension preserves trait
        z = Z(1:3)
        data3d = rand(3, 3, 3)
        da3d = DimArray(data3d, (x, y, z))
        merged_da3d = mergedims(da3d, (X, Y) => :space)
        sliced = merged_da3d[Z(At(2))]
        @test hasinternaldimensions(lookup(dims(sliced, :space)))
    end
end

using DimensionalData, Test, Dates
using DimensionalData.Lookups, DimensionalData.Dimensions
using DimensionalData.Lookups: SelectorError

A = zeros(X(4.0:7.0), Y(10.0:12.0))

@testset "DimIndices" begin
    di = @inferred DimIndices(A)
    @testset "indexing returns itself" begin
        @test di[di] isa DimIndices
        @test di[di] == di
    end
    @testset "tuple indexing works" begin
        da = rand(X(1:10), Y(1:10))
        ds = DimSelectors(da)
        @test ds[(X(1),)] == ds[1, :]
    end

    @test eltype(di) == Tuple{X{Int64}, Y{Int64}}
    ci = CartesianIndices(A)
    @test @inferred val.(collect(di)) == Tuple.(collect(ci))
    @test A[di] == view(A, di) == A
    @test @inferred di[4, 3] == (X(4), Y(3))
    @test @inferred di[2] == (X(2), Y(1))
    @test @inferred di[X(1)] == [(X(1), Y(1),), (X(1), Y(2),), (X(1), Y(3),)]
    @test map(ds -> A[ds...] + 2, di) == fill(2.0, 4, 3)
    @test_throws ArgumentError DimIndices(zeros(2, 2))
    @test_throws ArgumentError DimIndices(nothing)
    @test size(di) == (4, 3)
    # Array of indices
    @test @inferred collect(DimIndices(X(1:2))) == [(X(1),), (X(2),)]
    @test @inferred A[di[:]] == vec(A)
    @test @inferred A[di[2:5]] == A[2:5]
    @test @inferred A[reverse(di[2:5])] == A[5:-1:2]
    @test @inferred A[di[2:4, 1:2]] == A[2:4, 1:2]
    A1 = zeros(X(4.0:7.0), Ti(3), Y(10.0:12.0))
    @test @inferred size(A1[di[2:5]]) == (3, 4) 
    @test @inferred size(A1[di[2:4, 1:2], Ti=1]) == (3, 2)
    @test @inferred A1[di] isa DimArray{Float64,3}
    @test @inferred A1[X=1][di] isa DimArray{Float64,2}
    @test @inferred A1[X=1, Y=1] isa DimArray{Float64,1}
    # Indexing with no matching dims still returns a DimArray
    @test @inferred view(A1, X=1, Y=1, Ti=1)[di] == fill(0.0)

    # Convert to vector of DimTuple
    @test @inferred A1[di[:]] isa DimArray{Float64,2}
    @test @inferred size(A1[di[:]]) == (3, 12)
    @test @inferred A1[X=1][di[:]] isa DimArray{Float64,2}
    @test @inferred A1[di[:]] isa DimArray{Float64,2}
    @test @inferred A1[X=1][di[:]] isa DimArray{Float64,2}
    @test @inferred A1[X=1, Y=1][di[:]] isa DimArray{Float64,1}
    # Indexing with no matching dims is like [] (?)
    @test @inferred view(A1, X=1, Y=1, Ti=1)[di[:]] == 0.0

    @testset "zero dimensional" begin
        di0 = DimIndices(())
        @test di0[] == ()
        @test view(di0) == di0
        @test first(di0) == ()
        @test eltype(di0) == Tuple{}
        @test ndims(di0) == 0
        @test dims(di0) == ()
        @test size(di0) == ()
    end
    @testset "keywords error" begin
        @test_throws MethodError DimIndices(A; order=ForwardOrdered())
    end
end

@testset "DimPoints" begin
    dp = @inferred DimPoints(A)
    @test @inferred dp[4, 3] == (7.0, 12.0)
    @test @inferred dp[:, 3] == [(4.0, 12.0), (5.0, 12.0), (6.0, 12.0), (7.0, 12.0)]
    @test @inferred dp[2] == (5.0, 10.0)
    @test @inferred dp[X(1)] == [(4.0, 10.0), (4.0, 11.0), (4.0, 12.0)]
    @test size(dp) == (4, 3)
    @test_throws ArgumentError DimPoints(zeros(2, 2))
    @test_throws ArgumentError DimPoints(nothing)
    # Vector
    @test @inferred DimPoints(X(1.0:2.0)) == [(1.0,), (2.0,)]

    @testset "zero dimensional" begin
        dp0 = DimPoints(())
        @test dp0[] == ()
        @test view(dp0) == dp0
        @test first(dp0) == ()
        @test eltype(dp0) == Tuple{}
        @test ndims(dp0) == 0
        @test dims(dp0) == ()
        @test size(dp0) == ()
    end
end

@testset "DimSelectors" begin
    ds = @inferred DimSelectors(A)

    @testset "selecting returns itself" begin
        @test ds[ds] isa DimSelectors
        @test ds[ds] == ds
    end
    # The selected array is not identical because 
    # the lookups will be vectors and Irregular, 
    # rather than Regular ranges
    @test parent(A[DimSelectors(A)]) == parent(view(A, DimSelectors(A))) == A
    @test lookup(A[DimSelectors(A)], 1) == lookup(view(A, DimSelectors(A)), 1) == parent(lookup(A, 1))
    @test size(ds) == (4, 3)
    @test @inferred ds[4, 3] == (X(At(7.0; atol=eps(Float64))), Y(At(12.0, atol=eps(Float64))))
    @test @inferred ds[2] == (X(At(5.0; atol=eps(Float64))), Y(At(10.0, atol=eps(Float64))))
    @test ds[X(1)] == ds[X(At(4.0))] ==
        [(X(At(4.0; atol=eps(Float64))), Y(At(10.0; atol=eps(Float64))),),
         (X(At(4.0; atol=eps(Float64))), Y(At(11.0; atol=eps(Float64))),),
         (X(At(4.0; atol=eps(Float64))), Y(At(12.0; atol=eps(Float64))),)]
    @test broadcast(ds -> A[ds...] + 2, ds) == fill(2.0, 4, 3)
    @test broadcast(ds -> A[ds...], ds[X(At(7.0))]) == [0.0 for i in 1:3]
    @test_throws ArgumentError DimSelectors(zeros(2, 2))
    @test_throws ArgumentError DimSelectors(nothing)

    @test @inferred DimSelectors(X(1.0:2.0)) ==
        [(X(At(1.0; atol=eps(Float64))),), (X(At(2.0; atol=eps(Float64))),)]

    @testset "zero dimensional" begin
        ds0 = DimSelectors(())
        @test ds0[] == ()
        @test view(ds0) == ds0
        @test first(ds0) == ()
        @test eltype(ds0) == Tuple{}
        @test ndims(ds0) == 0
        @test dims(ds0) == ()
        @test size(ds0) == ()
    end

    @testset "atol" begin
        dsa1 = @inferred DimSelectors(A; atol=0.3)
        dsa2 = @inferred DimSelectors(A; selectors=At(; atol=0.3))
        dsa3 = @inferred DimSelectors(A; selectors=At(; atol=0.3), atol=0.000001)
        for dsa in (dsa1, dsa2, dsa3)
            # Mess up the lookups a little...
            B = zeros(X(4.25:1:7.27), Y(9.95:1:12.27))
            @test dsa[4, 3] == (X(At(7.0; atol=0.3)), Y(At(12.0, atol=0.3)))
            @test broadcast(ds -> B[ds...] + 2, dsa) == fill(2.0, 4, 3)
            @test broadcast(ds -> B[ds...], dsa[X(At(7.0))]) == [0.0 for i in 1:3]
            @test_throws SelectorError broadcast(ds -> B[ds...] + 2, ds) == fill(2.0, 4, 3)
            @test_throws ArgumentError DimSelectors(zeros(2, 2))
            @test_throws ArgumentError DimSelectors(nothing)
        end
    end

    @testset "mixed atol" begin
        dsa2 = @inferred DimSelectors(A; atol=(0.1, 0.2))
        # Mess up the lookups again
        C = zeros(X(4.05:7.05), Y(10.15:12.15))
        @test @inferred dsa2[4, 3] == (X(At(7.0; atol=0.1)), Y(At(12.0, atol=0.2)))
        @test collect(dsa2[X(1)]) == [(X(At(4.0; atol=0.1)), Y(At(10.0; atol=0.2)),),
                                     (X(At(4.0; atol=0.1)), Y(At(11.0; atol=0.2)),),
                                     (X(At(4.0; atol=0.1)), Y(At(12.0; atol=0.2)),)]
        @test @inferred broadcast(ds -> C[ds...] + 2, dsa2) == fill(2.0, 4, 3)
        @test @inferred broadcast(ds -> C[ds...], dsa2[X(At(7.0))]) == [0.0 for i in 1:3]
        # without atol it errors
        @test_throws SelectorError broadcast(ds -> C[ds...] + 2, ds) == fill(2.0, 4, 3)
        # no dims errors
        @test_throws ArgumentError DimSelectors(zeros(2, 2))
        @test_throws ArgumentError DimSelectors(nothing)
        # Only Y can handle errors > 0.1
        D = zeros(X(4.15:7.15), Y(10.15:12.15))
        @test_throws SelectorError broadcast(ds -> D[ds...] + 2, dsa2) == fill(2.0, 4, 3)
    end

    @testset "mixed selectors" begin
        dsa2 = @inferred DimSelectors(A; selectors=(Near(), At()), atol=0.2)
        # Mess up the lookups again
        C = zeros(X(4.05:7.05), Y(10.15:12.15))
        @test dsa2[4, 3] == (X(Near(7.0)), Y(At(12.0, atol=0.2)))
        @test collect(dsa2[X(1)]) == [(X(Near(4.0)), Y(At(10.0; atol=0.2)),),
                                     (X(Near(4.0)), Y(At(11.0; atol=0.2)),),
                                     (X(Near(4.0)), Y(At(12.0; atol=0.2)),)]
        @test @inferred broadcast(ds -> C[ds...] + 2, dsa2) == fill(2.0, 4, 3)
        @test @inferred broadcast(ds -> C[ds...], dsa2[X(At(7.0))]) == [0.0 for i in 1:3]
        # without atol it errors
        @test_throws SelectorError broadcast(ds -> C[ds...] + 2, ds) == fill(2.0, 4, 3)
        # no dims errors
        @test_throws ArgumentError DimSelectors(zeros(2, 2))
        @test_throws ArgumentError DimSelectors(nothing)
        D = zeros(X(4.15:7.15), Y(10.15:12.15))
        # This works with `Near`
        @test @inferred broadcast(ds -> D[ds...] + 2, dsa2) == fill(2.0, 4, 3)
    end
end

@testset "DimExtensionArray" begin
    A = DimArray(((1:4) * (1:3)'), (X(4.0:7.0), Y(10.0:12.0)); name=:foo)
    ex = DimensionalData.DimExtensionArray(A, (dims(A)..., Z(1:10), Ti(DateTime(2000):Month(1):DateTime(2000, 12); sampling=Intervals(Start()))))
    @test isintervals(dims(ex, Ti))
    @test ispoints(dims(ex, (X, Y, Z)))
    @test DimArray(ex) isa DimArray{Int,4,<:Tuple{<:X,<:Y,<:Z,<:Ti},<:Tuple,Array{Int,4}}
    @test @inferred DimArray(ex[X=1, Y=1]) isa DimArray{Int,2,<:Tuple{<:Z,<:Ti},<:Tuple,Array{Int,2}}
    @test @inferred all(DimArray(ex[X=4, Y=2]) .=== A[X=4, Y=2])
    @test @inferred ex[Z=At(10), Ti=At(DateTime(2000))] == A
    @test @inferred vec(ex) == mapreduce(_ -> vec(A), vcat, 1:prod(size(ex[X=1, Y=1])))
    ex1 = DimensionalData.DimExtensionArray(A, (Z(1:10), dims(A)..., Ti(DateTime(2000):Month(1):DateTime(2000, 12); sampling=Intervals(Start()))))
    @test vec(ex1) == mapreduce(_ -> mapreduce(i -> map(_ -> A[i], 1:size(ex1, Z)), vcat, 1:prod((size(ex1, X), size(ex1, Y)))), vcat, 1:size(ex1, Ti))

    v = DimVector(5:10, X; name=:vec)
    @test v[4] == 8
    @test view(v, 4) == fill(8)
    @test v[1:3] == 5:7
end

@testset "DimSlices" begin
    A = DimArray(((1:4) * (1:3)'), (X(4.0:7.0), Y(10.0:12.0)); name=:foo)
    ds = DimensionalData.DimSlices(A; dims=X)
    @test ds == ds[X=:]
    # Works just like Slices
    @test sum(ds) == sum(eachslice(A; dims=X))
    @test ds == ds[X=:]
    @test ds[X=At(7.0)] == [4, 8, 12]
    # Works just like Slices
    @test sum(ds) == sum(eachslice(A; dims=X))
    @test axes(ds) == axes(eachslice(A; dims=X))
    ds0 = DimensionalData.DimSlices(A; dims=());
    @test sum(ds0) == sum(eachslice(parent(A); dims=()))
    @test axes(ds0) == axes(eachslice(parent(A); dims=()))
end

struct DimUnitRange{T,R<:AbstractUnitRange{T},D<:Dimension} <: AbstractUnitRange{T}
    range::R
    dim::D
end
DimUnitRange{T}(r::DimUnitRange{T}) where {T<:Integer} = r
DimUnitRange{T}(r::DimUnitRange) where {T<:Integer} =
    DimUnitRange(AbstractUnitRange{T}(parent(r)), dims(r))

@inline dims(r::DimUnitRange) = r.dim
@inline dims(rs::Tuple{DimUnitRange,Vararg{DimUnitRange}}) = map(dims, rs)

Base.parent(r::DimUnitRange) = r.range

function Base.reduced_index(dur::DimUnitRange) 
    r = Base.reduced_index(parent(dur))
    d = dims(dur)
    d1 = if isreverse(d)
        d[end:end]
    else
        d[begin:begin]
    end
    return DimUnitRange(r, d1)
end

# this is necessary to ensure that keyword syntax for DimArray works correctly
Base.Slice(r::DimUnitRange) = Base.Slice(parent(r))

Base.show(io::IO, r::DimUnitRange) = print(io, basetypeof(r.dim), "(", r.range, ")") # concise presentation

# the below are adapted from OffsetArrays
# https://github.com/JuliaArrays/OffsetArrays.jl/blob/master/src/axes.jl

for f in [:length, :isempty, :first, :last]
    @eval @inline Base.$f(r::DimUnitRange) = Base.$f(parent(r))
end
@inline Base.axes(r::DimUnitRange) = (r,)
@inline Base.iterate(r::DimUnitRange, i...) = iterate(parent(r), i...)
@inline Base.getindex(r::DimUnitRange, i::Integer) = getindex(parent(r), i)

# Conversions to an AbstractUnitRange{Int} (and to an OrdinalRange{Int,Int} on Julia v"1.6") are necessary
# to evaluate CartesianIndices for BigInt ranges, as their axes are also BigInt ranges
Base.AbstractUnitRange{T}(r::DimUnitRange) where {T<:Integer} = DimUnitRange{T}(r)

@inline function Base.checkindex(::Type{Bool}, r::DimUnitRange, i::Real)
    return Base.checkindex(Bool, parent(r), i)
end

# Base methods

"""
    Base.copy!(dst::AbstractArray, src::AbstractDimStack, key::Key)

Copy the stack layer `key` to `dst`, which can be any `AbstractArray`.

## Example

Copy the `:humidity` layer from `stack` to `array`.

```julia
copy!(array, stack, :humidity)
```
"""
Base.copy!(dst::AbstractArray, src::AbstractDimStack, key) = copy!(dst, src[key])

"""
    Base.copy!(dst::AbstractDimStack, src::AbstractDimStack, [keys=keys(dst)])

Copy all or a subset of layers from one stack to another.

## Example

Copy just the `:sea_surface_temp` and `:humidity` layers from `src` to `dst`.

```julia
copy!(dst::AbstractDimStack, src::AbstractDimStack, keys=(:sea_surface_temp, :humidity))
```
"""
function Base.copy!(dst::AbstractDimStack, src::AbstractDimStack, keys=keys(dst))
    # Check all keys first so we don't copy anything if there is any error
    for key in keys
        key in Base.keys(dst) || throw(ArgumentError("key $key not found in dest keys"))
        key in Base.keys(src) || throw(ArgumentError("key $key not found in source keys"))
    end
    for key in keys
        copy!(dst[key], src[key])
    end
end

function Base.copyto!(
    dst::Array{<:DimStack,3}, dstI::CartesianIndices, 
    src::DimSlices{<:DimStack}, srcI::CartesianIndices
)
    dst[dstI] = src[srcI]
end

"""
    Base.eachslice(stack::AbstractDimStack; dims, drop=true)

Create a generator that iterates over dimensions `dims` of `stack`, returning stacks that
select all the data from the other dimensions in `stack` using views.

The generator has `size` and `axes` equivalent to those of the provided `dims`.

# Examples

```jldoctest; setup = :(using DimensionalData)
julia> ds = DimStack((
           x=DimArray(randn(2, 3, 4), (X([:x1, :x2]), Y(1:3), Z)),
           y=DimArray(randn(2, 3, 5), (X([:x1, :x2]), Y(1:3), Ti))
       ));

julia> slices = eachslice(ds; dims=(Z, X));

julia> size(slices)
(4, 2)

julia> map(dims, axes(slices))
(↓ Z,
→ X Categorical{Symbol} [:x1, :x2] ForwardOrdered)

julia> first(slices)
┌ 3×5 DimStack ┐
├──────────────┴─────────────────────────────────── dims ┐
  ↓ Y Sampled{Int64} 1:3 ForwardOrdered Regular Points,
  → Ti
├──────────────────────────────────────────────── layers ┤
  :x eltype: Float64 dims: Y size: 3
  :y eltype: Float64 dims: Y, Ti size: 3×5
└────────────────────────────────────────────────────────┘
```
"""
function Base.eachslice(s::AbstractDimStack; dims, drop=true)
    dimtuple = _astuple(dims)
    if !(dimtuple == ()) 
        all(hasdim(s, dimtuple)) || throw(DimensionMismatch("A doesn't have all dimensions $dims"))
    end
    # Avoid getting DimUnitRange from `axes(s)`
    axisdims = map(DD.dims(s, dimtuple)) do d
        rebuild(d, axes(lookup(d), 1)) 
    end
    return DimSlices(s; dims=axisdims, drop)
end


"""
    Base.cat(stacks::AbstractDimStack...; [keys=keys(stacks[1])], dims)

Concatenate all or a subset of layers for all passed in stacks.

# Keywords

- `keys`: `Tuple` of `Symbol` for the stack keys to concatenate.
- `dims`: Dimension of child array to concatenate on.

# Example

Concatenate the :sea_surface_temp and :humidity layers in the time dimension:

```julia
cat(stacks...; keys=(:sea_surface_temp, :humidity), dims=Ti)
```
"""
function Base.cat(s1::AbstractDimStack, stacks::AbstractDimStack...; keys=keys(s1), dims)
    vals = Tuple(cat((s[k] for s in (s1, stacks...))...; dims) for k in keys)
    rebuild_from_arrays(s1, vals)
end

# Methods with no arguments that return a DimStack
for (mod, fnames) in
    (:Base => (:inv, :adjoint, :transpose, :permutedims, :PermutedDimsArray), :LinearAlgebra => (:Transpose,))
    for fname in fnames
        @eval function ($mod.$fname)(s::AbstractDimStack)
            maplayers(s) do l
                ndims(l) > 1 ? ($mod.$fname)(l) : l
            end
        end
    end
end

# Methods with an argument that return a DimStack
for fname in (:rotl90, :rotr90, :rot180)
    @eval (Base.$fname)(s::AbstractDimStack, args...) =
        maplayers(A -> (Base.$fname)(A, args...), s)
end
for fname in (:PermutedDimsArray, :permutedims)
    @eval function (Base.$fname)(s::AbstractDimStack, perm)
        maplayers(s) do l
            lperm = dims(l, dims(s, perm))
            length(lperm) > 1 ? (Base.$fname)(l, lperm) : l
        end
    end
end

# Methods with keyword arguments that return a DimStack
for (mod, fnames) in
    (:Base => (:sum, :prod, :maximum, :minimum, :extrema, :dropdims),
     :Statistics => (:mean, :median, :std, :var))
    for fname in fnames
        @eval function ($mod.$fname)(s::AbstractDimStack; dims=:, kw...)
            maplayers(s) do A
                layer_dims = dims isa Colon ? dims : commondims(A, dims)
                $mod.$fname(A; dims=layer_dims, kw...)
            end
        end
    end
end
for fname in (:cor, :cov)
    @eval function (Statistics.$fname)(s::AbstractDimStack; dims=1, kw...)
        d = DD.dims(s, dims)
        maplayers(s) do A
            layer_dims = only(commondims(A, d))
            Statistics.$fname(A; dims=layer_dims, kw...)
        end
    end
end

# Methods that take a function
for (mod, fnames) in (:Base => (:reduce, :sum, :prod, :maximum, :minimum, :extrema),
                      :Statistics => (:mean,))
    for fname in fnames
        _fname = Symbol(:_, fname)
        @eval function ($mod.$fname)(f::Function, s::AbstractDimStack; dims=Colon())
            maplayers(s) do A
                layer_dims = dims isa Colon ? dims : commondims(A, dims) 
                $mod.$fname(f, A; dims=layer_dims) 
            end
        end
    end
end

for fname in (:one, :oneunit, :zero, :copy)
    @eval function (Base.$fname)(s::AbstractDimStack, args...)
        maplayers($fname, s)
    end
end

Base.reverse(s::AbstractDimStack; dims=:) = maplayers(A -> reverse(A; dims=dims), s)

# Random
Random.Sampler(RNG::Type{<:AbstractRNG}, st::AbstractDimStack, n::Random.Repetition) =
    Random.SamplerSimple(st, Random.Sampler(RNG, DimIndices(st), n))

Random.rand(rng::AbstractRNG, sp::Random.SamplerSimple{<:AbstractDimStack,<:Random.Sampler}) =
    @inbounds return sp[][rand(rng, sp.data)...]

module DimensionalDataStatsBaseExt

using DimensionalData
using Statistics
using StatsBase

const DD = DimensionalData

Statistics.mean(A::AbstractDimArray, w::StatsBase.AbstractWeights; dims=:) =
    _weighted(mean, A, w, dims)
# For ambiguity
Statistics.mean(A::AbstractDimArray, w::StatsBase.UnitWeights; dims=:) =
    _weighted(mean, A, w, dims)

Base.sum(A::AbstractDimArray, w::AbstractWeights{<:Real}; dims=:) =
    _weighted(sum, A, w, dims)

function _weighted(f::F, A, w, dims) where F
    if dims isa Colon
        return f(parent(A), w; dims=:)
    else
        data = f(parent(A), w; dims=dimnum(A, dims))
        return rebuild(A, data, DD.reducedims(A, dims))
    end
end

end

# These are all the function that you can call on objects and call function(dims(obs, args...))
const INTERFACE_QUERY_FUNCTION_NAMES = (:lookup, :order, :sampling, :span, :bounds, :intervalbounds, :locus)

"""
    Dimension 

Abstract supertype of all dimension types.

Example concrete implementations are [`X`](@ref), [`Y`](@ref), [`Z`](@ref),
[`Ti`](@ref) (Time), and the custom [`Dim`](@ref) dimension.

`Dimension`s label the axes of an `AbstractDimArray`,
or other dimensional objects, and are used to index into an array.

They may also wrap lookup values for each array axis.
This may be any `AbstractVector` matching the array axis length,
but will usually be converted to a `Lookup` when use in a constructed
object.

A `Lookup` gives more details about the dimension, such as that it is
[`Categorical`](@ref) or [`Sampled`](@ref) as [`Points`](@ref) or
[`Intervals`](@ref) along some transect. DimensionalData will
attempt to guess the lookup from the passed-in index value.

Example:

```jldoctest Dimension
using DimensionalData, Dates

x = X(2:2:10)
y = Y(['a', 'b', 'c'])
ti = Ti(DateTime(2021, 1):Month(1):DateTime(2021, 12))

A = DimArray(zeros(3, 5, 12), (y, x, ti))

# output

┌ 3×5×12 DimArray{Float64, 3} ┐
├─────────────────────────────┴────────────────────────────────────────── dims ┐
  ↓ Y Categorical{Char} ['a', …, 'c'] ForwardOrdered,
  → X Sampled{Int64} 2:2:10 ForwardOrdered Regular Points,
  ↗ Ti Sampled{DateTime} DateTime("2021-01-01T00:00:00"):Month(1):DateTime("2021-12-01T00:00:00") ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────────────┘
[:, :, 1]
 ↓ →   2    4    6    8    10
  'a'  0.0  0.0  0.0  0.0   0.0
  'b'  0.0  0.0  0.0  0.0   0.0
  'c'  0.0  0.0  0.0  0.0   0.0
```

For simplicity, the same `Dimension` types are also used as wrappers
in `getindex`, like:

```jldoctest Dimension
x = A[X(2), Y(3)]

# output

┌ 12-element DimArray{Float64, 1} ┐
├─────────────────────────────────┴────────────────────────────────────── dims ┐
  ↓ Ti Sampled{DateTime} DateTime("2021-01-01T00:00:00"):Month(1):DateTime("2021-12-01T00:00:00") ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────────────┘
 2021-01-01T00:00:00  0.0
 2021-02-01T00:00:00  0.0
 2021-03-01T00:00:00  0.0
 2021-04-01T00:00:00  0.0
 2021-05-01T00:00:00  0.0
 ⋮
 2021-08-01T00:00:00  0.0
 2021-09-01T00:00:00  0.0
 2021-10-01T00:00:00  0.0
 2021-11-01T00:00:00  0.0
 2021-12-01T00:00:00  0.0
```

A `Dimension` can also wrap [`Selector`](@ref).

```jldoctest Dimension
x = A[X(Between(3, 4)), Y(At('b'))]

# output

┌ 1×12 DimArray{Float64, 2} ┐
├───────────────────────────┴──────────────────────────────────────────── dims ┐
  ↓ X Sampled{Int64} 4:2:4 ForwardOrdered Regular Points,
  → Ti Sampled{DateTime} DateTime("2021-01-01T00:00:00"):Month(1):DateTime("2021-12-01T00:00:00") ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────────────┘
 ↓ →   2021-01-01T00:00:00   2021-02-01T00:00:00  …   2021-12-01T00:00:00
 4    0.0                   0.0                      0.0
```
"""
abstract type Dimension{T} end

"""
    IndependentDim <: Dimension

Abstract supertype for independent dimensions. These will plot on the X axis.
"""
abstract type IndependentDim{T} <: Dimension{T} end

"""
    DependentDim <: Dimension

Abstract supertype for dependent dimensions. These will plot on the Y axis.
"""
abstract type DependentDim{T} <: Dimension{T} end

"""
    XDim <: IndependentDim

Abstract supertype for all X dimensions.
"""
abstract type XDim{T} <: IndependentDim{T} end

"""
    YDim <: DependentDim

Abstract supertype for all Y dimensions.
"""
abstract type YDim{T} <: DependentDim{T} end

"""
    ZDim <: DependentDim

Abstract supertype for all Z dimensions.
"""
abstract type ZDim{T} <: DependentDim{T} end

"""
    TimeDim <: IndependentDim

Abstract supertype for all time dimensions.

In a `TimeDime` with `Interval` sampling the locus will automatically
be set to `Start()`. Dates and times generally refer to the start of a
month, hour, second etc., not the central point as is more common with spatial data.
`"""
abstract type TimeDim{T} <: IndependentDim{T} end

ConstructionBase.constructorof(d::Type{<:Dimension}) = basetypeof(d)

const DimType = Type{<:Dimension}
const DimTuple = Tuple{Dimension,Vararg{Dimension}}
const MaybeDimTuple = Tuple{Vararg{Dimension}}
const SymbolTuple = Tuple{Symbol,Vararg{Symbol}}
const DimTypeTuple = Tuple{DimType,Vararg{DimType}}
const VectorOfDim = Vector{<:Union{Dimension,DimType,Symbol}}
const DimOrDimType = Union{Dimension,DimType,Symbol}
const AllDims = Union{Symbol,Dimension,DimTuple,SymbolTuple,DimType,DimTypeTuple,VectorOfDim}

# DimensionalData interface methods

struct AutoVal{T,K}
    val::T
    kw::K
end
val(av::AutoVal) = av.val

"""
    rebuild(dim::Dimension, val) => Dimension
    rebuild(dim::Dimension; val=val(dim)) => Dimension

Rebuild dim with fields from `dim`, and new fields passed in.
"""
function rebuild(dim::D, val) where D <: Dimension
    ConstructionBase.constructorof(D)(val)
end

dims(dim::Union{Dimension,DimType,Val{<:Dimension}}) = dim
dims(dims::DimTuple) = dims
dims(::Tuple{}) = ()
dims(x) = nothing
dims(x::AbstractArray) = dims(axes(x))

val(dim::Dimension) = dim.val
refdims(x) = ()

lookup(dim::Dimension{<:AbstractArray}) = val(dim)
lookup(dim::Union{DimType,Val{<:Dimension}}) = NoLookup()

name(dim::Dimension) = name(typeof(dim))
name(dim::Val{D}) where D = name(D)
name(dim::Type{D}) where D<:Dimension = nameof(D)
name(s::Symbol) = s

label(x) = string(name(x))

# Lookups methods
for func in (:order, :span, :sampling, :locus, :metadata, :bounds)
    @eval ($func)(dim::Dimension) = ($func)(lookup(dim))
end
# Dispatch on Tuple{<:Dimension}, and map to single dim methods
for f in (:val, :metadata, :name, :label, :units, INTERFACE_QUERY_FUNCTION_NAMES...)
    @eval begin
        $f(ds::Tuple) = map($f, ds)
        $f(::Tuple{}) = ()
        $f(ds::Tuple, i1, I...) = $f(ds, (i1, I...))
        $f(ds::Tuple, I) = $f(dims(ds, name2dim(I)))
    end
end
Lookups.intervalbounds(dim::Dimension, args...) = intervalbounds(val(dim), args...)
for f in (:shiftlocus, :maybeshiftlocus)
    @eval function Lookups.$f(locus::Locus, x; dims=Dimensions.dims(x))
        newdims = map(Dimensions.dims(x, dims)) do d
            Lookups.$f(locus, d)
        end
        return setdims(x, newdims)
    end
    @eval Lookups.$f(locus::Locus, d::Dimension) =
        rebuild(d, Lookups.$f(locus, lookup(d)))
end

function hasselection(x, selectors::Union{DimTuple,SelTuple,Selector,Dimension})
    hasselection(dims(x), selectors)
end
hasselection(x::Nothing, selectors::Union{DimTuple,SelTuple,Selector,Dimension}) = false
function hasselection(ds::DimTuple, seldims::DimTuple)
    sorted = dims(seldims, ds)
    hasselection(dims(ds, sorted), map(val, sorted))
end
hasselection(ds::DimTuple, selectors::SelTuple) = all(map(hasselection, ds, selectors))
hasselection(ds::DimTuple, selector::Dimension) = hasselection(dims(ds, selector), selector)
function hasselection(ds::DimTuple, selector::Selector)
    throw(ArgumentError("Cannot select from multiple Dimensions with a single Selector"))
end
hasselection(dim::Dimension, seldim::Dimension) = hasselection(dim, val(seldim))
hasselection(dim::Dimension, sel::Selector) = hasselection(lookup(dim), sel)

@inline function selectindices(x, selectors; kw...)
    if dims(x) isa Nothing
        # This object has no dimensions and no `selectindices` method.
        # Just return whatever selectors is, maybe the underlying array can use it.
        return selectors
    else
        # Otherwise select indices based on the object `Dimension`s
        return selectindices(dims(x), selectors; kw...)
    end
end
@inline selectindices(ds::Tuple, sel...; kw...) = selectindices(ds, sel; kw...)
# Cant get this to compile away without a generated function
# The nothing handling is for if `err=_False`, and we want to combine
# multiple `nothing` into a single `nothing` return value
@generated function selectindices(ds::Tuple, sel::Tuple; kw...) 
    tuple_exp = Expr(:tuple)
    for i in eachindex(ds.parameters)
        expr = quote 
            x = selectindices(ds[$i], sel[$i]; kw...)
            isnothing(x) && return nothing
            x
        end
        push!(tuple_exp.args, expr)
    end
    return tuple_exp
end
@inline selectindices(ds::Tuple, sel::Tuple{}; kw...) = () 
@inline selectindices(dim::Dimension, sel; kw...) = selectindices(val(dim), sel; kw...)

# Base methods
const ArrayOrVal = Union{AbstractArray,Val}

Base.parent(d::Dimension) = val(d)
Base.eltype(d::Type{<:Dimension{T}}) where T = T
Base.eltype(d::Type{<:Dimension{A}}) where A<:AbstractArray{T} where T = T
Base.size(d::Dimension, args...) = size(val(d), args...)
Base.axes(d::Dimension) = (val(d) isa DimUnitRange ? val(d) : DimUnitRange(axes(val(d), 1), d),)
Base.axes(d::Dimension, i) = axes(d)[i]
Base.eachindex(d::Dimension) = eachindex(val(d))
Base.length(d::Dimension) = length(val(d))
Base.ndims(d::Dimension) = 0
Base.parentindices(d::Dimension{<:AbstractArray}) = parentindices(parent(d))
Base.ndims(d::Dimension{<:AbstractArray}) = ndims(val(d))
Base.iterate(d::Dimension{<:AbstractArray}, args...) = iterate(lookup(d), args...)
Base.first(d::Dimension) = val(d)
Base.first(d::Dimension{<:AbstractArray}) = first(lookup(d))
Base.last(d::Dimension) = val(d)
Base.last(d::Dimension{<:AbstractArray}) = last(lookup(d))
Base.IteratorSize(d::Dimension{<:AbstractArray}) = Base.IteratorSize(parent(d))
Base.firstindex(d::Dimension) = 1
Base.lastindex(d::Dimension) = 1
Base.firstindex(d::Dimension{<:AbstractArray}) = firstindex(lookup(d))
Base.lastindex(d::Dimension{<:AbstractArray}) = lastindex(lookup(d))
Base.step(d::Dimension) = step(lookup(d))
Base.Array(d::Dimension{<:AbstractArray}) = collect(lookup(d))
function Base.:(==)(d1::Dimension, d2::Dimension)
    basetypeof(d1) == basetypeof(d2) && val(d1) == val(d2)
end

Lookups.ordered_first(d::Dimension{<:AbstractArray}) = ordered_first(lookup(d))
Lookups.ordered_last(d::Dimension{<:AbstractArray}) = ordered_last(lookup(d))
Lookups.ordered_firstindex(d::Dimension{<:AbstractArray}) = ordered_firstindex(lookup(d))
Lookups.ordered_lastindex(d::Dimension{<:AbstractArray}) = ordered_lastindex(lookup(d))

Base.size(dims::DimTuple) = map(length, dims)
Base.CartesianIndices(dims::DimTuple) = CartesianIndices(map(d -> axes(d, 1), dims))

# Extents.jl
#=
The complexity in this function is due to the fact that some lookups
may have internal dimensions (see [hasinternaldimensions](@ref)).
=#
function Extents.extent(ids::DimTuple, args...)
    ds = _astuple(dims(ids, args...))
    # Obtain all dims which do _not_ have internal dimensions
    regulardims = dims(ds, x -> !hasinternaldimensions(lookup(x)))    
    # Their bounds are simple to obtain from `bounds`
    regular_bounds = map(bounds, regulardims)
    regular_bounds_nt = NamedTuple{map(name, regulardims)}(regular_bounds)
    
    # Now, for the dimensions which do have internal dimensions, we need to
    # obtain the bounds for each of the internal dimensions.
    multidims = otherdims(ds, regulardims)
    # Then, we get the `bounds` for each of the complex / higher order dimensions.
    # `bounds` here returns an `ndims`-tuple of 2-tuples, unlike a simple 2-tuple for a regular dimension.
    multidim_raw_bounds = map(bounds, multidims) # we trust that bounds will give us a tuple of bounds one for each enclosed dimension
    # This gets us the list of "base dimensions" for each of the lookups.
    multidim_dims = combinedims(map(dims, multidims)...; length = false)
    # We then determine the "true" bounds for each of the base dimensions in `multidim_dims`,
    # knowing that some lookups might "overlap" in their internal dimensions.
    # For each base dimension,
    multidim_bounds = map(multidim_dims) do outdim
        # loop over the tuples of (multidim, multidim_raw_bounds) and reduce those to a single 2-tuple.
        foldl(map(tuple, multidims, multidim_raw_bounds); init = (nothing, nothing)) do (minval, maxval), (dim, bounds)
            # If the current dim "contains" the `outdim` we are interested in, then:
            if hasdim(dim, outdim)
                if isnothing(minval) && isnothing(maxval)
                    # Initialize the bounds to the bounds of the current dimension,
                    # if no previous lookup has contained the `outdim`.
                    bounds[dimnum(dim, outdim)]
                else
                    # Otherwise, update the bounds to the minimum and maximum of the current and previous bounds.
                    this_dim_bounds = bounds[dimnum(dim, outdim)]
                    (min(minval, this_dim_bounds[1]), max(maxval, this_dim_bounds[2]))
                end
            else
                # Equivalent of a no-op, because the current dim does not contain the `outdim` we are interested in.
                (minval, maxval)
            end
        end
    end
    # Finally, create a NamedTuple of the bounds for each of the base dimensions,
    # as Extents.jl expects.
    multidim_bounds_nt = NamedTuple{map(name, multidim_dims)}(multidim_bounds)
    # Return the union of the base dimensions and the multidim dimensions.
    return Extents.Extent(merge(regular_bounds_nt, multidim_bounds_nt))
end

dims(extent::Extents.Extent{K}) where K = map(rebuild, name2dim(K), values(extent))
dims(extent::Extents.Extent, ds) = dims(dims(extent), ds)

# Produce a 2 * length(dim) matrix of interval bounds from a dim
dim2boundsmatrix(dim::Dimension)  = dim2boundsmatrix(lookup(dim))
function dim2boundsmatrix(lookup::Lookup)
    samp = sampling(lookup)
    samp isa Intervals || error("Cannot create a bounds matrix for $(nameof(typeof(samp)))")
    _dim2boundsmatrix(locus(lookup), span(lookup), lookup)
end

_dim2boundsmatrix(::Locus, span::Explicit, lookup) = val(span)
function _dim2boundsmatrix(::Locus, span::Regular, lookup)
    # Only offset starts and reuse them for ends, 
    # so floating point error is the same.
    starts = Lookups._shiftlocus(Start(), lookup)
    dest = Array{eltype(starts),2}(undef, 2, length(starts))
    # Use `bounds` as the start/end values
    if order(lookup) isa ReverseOrdered
        for i in 1:length(starts) - 1
            dest[1, i] = dest[2, i + 1] = starts[i + firstindex(starts) - 1]
        end
        dest[1, end], dest[2, 1] = bounds(lookup)
    else
        for i in 1:length(starts) - 1
            dest[1, i + 1] = dest[2, i] = starts[i + firstindex(starts)]
        end
        dest[1, 1], dest[2, end] = bounds(lookup)
    end
    return dest
end
@noinline _dim2boundsmatrix(::Center, span::Regular{Dates.TimeType}, lookupj) =
    error("Cannot convert a Center TimeType index to Explicit automatically: use a bounds matrix e.g. Explicit(bnds)")
@noinline _dim2boundsmatrix(::Start, span::Irregular, lookupj) =
    error("Cannot convert Irregular to Explicit automatically: use a bounds matrix e.g. Explicit(bnds)")

"""
    Dim{S}(val=:)

A generic dimension. For use when custom dims are required when loading
data from a file. Can be used as keyword arguments for indexing.

Dimension types take precedence over same named `Dim` types when indexing
with symbols, or e.g. creating Tables.jl keys.

```jldoctest; setup = :(using DimensionalData)
julia> dim = Dim{:custom}(['a', 'b', 'c'])
custom ['a', …, 'c']
```
"""
struct Dim{S,T} <: Dimension{T}
    val::T
    function Dim{S}(val; kw...) where {S}
        if length(kw) > 0
            val = AutoVal(val, values(kw))
        end
        new{S,typeof(val)}(val)
    end
    function Dim{S}(val::AbstractArray; kw...) where S
        if length(kw) > 0
            val = AutoLookup(val, values(kw))
        end
        Dim{S,typeof(val)}(val)
    end
    function Dim{S,T}(val::T) where {S,T}
        new{S,T}(val)
    end
end
Dim{S}() where S = Dim{S}(:)

name(::Type{<:Dim{S}}) where S = S
basetypeof(::Type{<:Dim{S}}) where S = Dim{S}
name2dim(s::Val{S}) where S = Dim{S}()

"""
    AnonDim <: Dimension

    AnonDim()

Anonymous dimension. Used when extra dimensions are created,
such as during transpose of a vector.
"""
struct AnonDim{T} <: Dimension{T}
    val::T
end
AnonDim() = AnonDim(Colon())
AnonDim(val, arg1, args...) = AnonDim(val)

metadata(::AnonDim) = NoMetadata()

"""
    @dim typ [supertype=Dimension] [label::String=string(typ)]

Macro to easily define new dimensions. 

The supertype will be inserted into the type of the dim. 
The default is simply `YourDim <: Dimension`. 

Making a Dimension inherit from `XDim`, `YDim`, `ZDim` or `TimeDim` will affect
automatic plot layout and other methods that dispatch on these types. `<: YDim`
are plotted on the Y axis, `<: XDim` on the X axis, etc.

`label` is used in plots and similar, 
if the dimension is short for a longer word.

Example:
```jldoctest
using DimensionalData
using DimensionalData: @dim, YDim, XDim
@dim Lat YDim "Latitude"
@dim Lon XDim "Longitude"
# output

```
"""
macro dim end
macro dim(typ::Symbol, args...)
    dimmacro(typ::Symbol, Dimension, args...)
end
macro dim(typ::Symbol, supertyp::Symbol, args...)
    dimmacro(typ, supertyp, args...)
end

function dimmacro(typ, supertype, label::String=string(typ))
    quote
        Base.@__doc__ struct $typ{T} <: $supertype{T}
            val::T
            function $typ(val; kw...)
                if length(kw) > 0
                    val = $Dimensions.AutoVal(val, values(kw))
                end
                new{typeof(val)}(val)
            end
            $typ{T}(val::T; kw...) where T = new(val::T)
        end
        function $typ(val::AbstractArray; kw...)
            if length(kw) > 0
                val = $Dimensions.AutoLookup(val, values(kw))
            end
            $typ{typeof(val)}(val)
        end
        $typ() = $typ(:)
        $Dimensions.name(::Type{<:$typ}) = $(QuoteNode(Symbol(typ)))
        $Dimensions.name2dim(::Val{$(QuoteNode(typ))}) = $typ()
        $Dimensions.label(::$typ) = $label
        $Dimensions.label(::Type{<:$typ}) = $label
    end |> esc
end

# Define some common dimensions.

"""
    X <: XDim

    X(val=:)

X [`Dimension`](@ref). `X <: XDim <: IndependentDim`

## Examples

```julia
xdim = X(2:2:10)
```

```julia
val = A[X(1)]
```

```julia
mean(A; dims=X)
```
"""
@dim X XDim

"""
    Y <: YDim

    Y(val=:)

Y [`Dimension`](@ref). `Y <: YDim <: DependentDim`

## Examples

```julia
ydim = Y(['a', 'b', 'c'])
```

```julia
val = A[Y(1)]
```

```julia
mean(A; dims=Y)
```
"""
@dim Y YDim

"""
    Z <: ZDim

    Z(val=:)

Z [`Dimension`](@ref). `Z <: ZDim <: Dimension`

## Example:
```julia
zdim = Z(10:10:100)
```

```julia
val = A[Z(1)]
```

```julia
mean(A; dims=Z)
```
"""
@dim Z ZDim

"""m
    Ti <: TimeDim
    
    Ti(val=:)

Time [`Dimension`](@ref). `Ti <: TimeDim <: IndependentDim`

`Time` is already used by Dates, and `T` is a common type parameter,
We use `Ti` to avoid clashes.

## Example:
```julia
timedim = Ti(DateTime(2021, 1):Month(1):DateTime(2021, 12))
```

```julia
val = A[Ti(1)]
```

```julia
mean(A; dims=Ti)
```
"""
@dim Ti TimeDim "Time"

const Time = Ti # For some backwards compat

const IDim = Dimension{<:StandardIndices}
const MaybeDimTuple = Tuple{Vararg{Dimension}}

"""
    AbstractBasicDimArray <: AbstractArray

The abstract supertype for all arrays with a `dims` method that 
returns a `Tuple` of `Dimension`

Only keyword `rebuild` is guaranteed to work with `AbstractBasicDimArray`.
"""
abstract type AbstractBasicDimArray{T,N,D<:MaybeDimTuple} <: AbstractArray{T,N} end

const AbstractBasicDimVector = AbstractBasicDimArray{T,1} where T
const AbstractBasicDimMatrix = AbstractBasicDimArray{T,2} where T
const AbstractBasicDimVecOrMat = Union{AbstractBasicDimVector,AbstractBasicDimMatrix}

refdims(::AbstractBasicDimArray) = ()
name(::AbstractBasicDimArray) = NoName()
metadata(::AbstractBasicDimArray) = NoMetadata()

# DimensionalData.jl interface methods ####################################################

for func in INTERFACE_QUERY_FUNCTION_NAMES  
    @eval ($func)(A::AbstractBasicDimArray, args...) = ($func)(dims(A), args...)
end

Extents.extent(A::AbstractBasicDimArray, args...) = Extents.extent(dims(A), args...) 

Base.size(A::AbstractBasicDimArray) = map(length, dims(A))
Base.size(A::AbstractBasicDimArray, dims::DimOrDimType) = size(A, dimnum(A, dims))
Base.axes(A::AbstractBasicDimArray) = map(d -> axes(d, 1), dims(A))
Base.axes(A::AbstractBasicDimArray, dims::DimOrDimType) = axes(A, dimnum(A, dims))
# This is too slow using the default, as it calls `axes` and makes DimUnitRanges
Base.CartesianIndices(s::AbstractBasicDimArray) = CartesianIndices(map(first ∘ axes, lookup(s)))

Base.checkbounds(::Type{Bool}, A::AbstractBasicDimArray, d1::IDim, dims::IDim...) =
    Base.checkbounds(Bool, A, dims2indices(A, (d1, dims...))...)
Base.checkbounds(A::AbstractBasicDimArray, d1::IDim, dims::IDim...) =
    Base.checkbounds(A, dims2indices(A, (d1, dims...))...)

"""
    AbstractDimArray <: AbstractBasicArray

Abstract supertype for all "dim" arrays.

These arrays return a `Tuple` of [`Dimension`](@ref)
from a [`dims`](@ref) method, and can be rebuilt using [`rebuild`](@ref).

`parent` must return the source array.

They should have [`metadata`](@ref), [`name`](@ref) and [`refdims`](@ref)
methods, although these are optional.

A [`rebuild`](@ref) method for `AbstractDimArray` must accept
`data`, `dims`, `refdims`, `name`, `metadata` arguments.

Indexing `AbstractDimArray` with non-range `AbstractArray` has undefined effects
on the `Dimension` index. Use forward-ordered arrays only"
"""
abstract type AbstractDimArray{T,N,D<:Tuple,A} <: AbstractBasicDimArray{T,N,D} end

const AbstractDimVector = AbstractDimArray{T,1} where T
const AbstractDimMatrix = AbstractDimArray{T,2} where T
const AbstractDimVecOrMat = Union{AbstractDimVector,AbstractDimMatrix}

# DimensionalData.jl interface methods ####################################################
 
"""
    rebuild(A::AbstractDimArray, data, [dims, refdims, name, metadata]) => AbstractDimArray
    rebuild(A::AbstractDimArray; kw...) => AbstractDimArray

Rebuild and `AbstractDimArray` with some field changes. All types
that inherit from `AbstractDimArray` must define this method if they
have any additional fields or alternate field order.

Implementations can discard arguments like `refdims`, `name` and `metadata`.

Additional arguments can be added to the keyword argument method. 

For readability it is preferable to use keyword versions for any more than a few arguments.
"""
@inline function rebuild(
    A::AbstractDimArray, data, dims::Tuple=dims(A), refdims=refdims(A), name=name(A)
)
    rebuild(A, data, dims, refdims, name, metadata(A))
end

# Standard fields
dims(A::AbstractDimArray) = A.dims
refdims(A::AbstractDimArray) = A.refdims
data(A::AbstractDimArray) = A.data # Don't use this method directly, use `parent`
name(A::AbstractDimArray) = A.name
metadata(A::AbstractDimArray) = A.metadata

layerdims(A::AbstractDimArray) = basedims(A)

"""
    rebuildsliced(f::Function, A::AbstractBasicDimArray, I)

Rebuild `AbstractDimArray` where `f` is `getindex` , `view` or `dotview`.

This does not need to be defined for `AbstractDimArray`, as `f`
is simply called on the parent array, dims and refdims are sliced with `slicedims`, 
and `rebuild` is called.

However for custom `AbstractBasicDimArray`, `rebuildsliced` methods are needed
to define slicing behavior, as there not be a parent array.
"""
@propagate_inbounds rebuildsliced(A::AbstractBasicDimArray, args...) = rebuildsliced(getindex, A, args...)
@propagate_inbounds function rebuildsliced(f::Function, A::AbstractDimArray, I::Tuple, name=name(A))
    I1 = to_indices(A, I)
    data = f(parent(A), I1...)
    return rebuildsliced(f, A, data, I1, name)
end
@propagate_inbounds function rebuildsliced(f::Function, A::AbstractDimArray, data::AbstractArray, I::Tuple, name=name(A))
    I1 = to_indices(A, I)
    return rebuild(A, data, slicedims(f, A, I1)..., name)
end

# Array interface methods ######################################################

Base.size(A::AbstractDimArray) = size(parent(A))
Base.axes(A::AbstractDimArray) = map(Dimensions.DimUnitRange, axes(parent(A)), dims(A))
Base.iterate(A::AbstractDimArray, args...) = iterate(parent(A), args...)
Base.IndexStyle(A::AbstractDimArray) = Base.IndexStyle(parent(A))
Base.parent(A::AbstractDimArray) = data(A)
Base.parentindices(A::AbstractDimArray) = parentindices(parent(A))
Base.vec(A::AbstractDimArray) = vec(parent(A))
Base.unsafe_convert(::Type{Ptr{T}}, x::AbstractDimArray) where {T} = Base.unsafe_convert(Ptr{T}, parent(x))
Base.strides(x::AbstractDimArray) = strides(parent(x))

# Only compare data and dim - metadata and refdims can be different
Base.:(==)(A1::AbstractDimArray, A2::AbstractDimArray) =
    dims(A1) == dims(A2) && parent(A1) == parent(A2)
Base.isequal(A1::AbstractDimArray, A2::AbstractDimArray) =
    isequal(dims(A1), dims(A2)) && isequal(parent(A1), parent(A2))
# undef constructor for Array, using dims 
function Base.Array{T}(x::UndefInitializer, d1::Dimension, dims::Dimension...) where T 
    Base.Array{T}(x, (d1, dims...))
end
Base.Array{T}(x::UndefInitializer, dims::DimTuple; kw...) where T = Array{T}(x, size(dims))

function Base.NamedTuple(A1::AbstractDimArray, As::AbstractDimArray...) 
    arrays = (A1, As...)
    keys = map(Symbol ∘ name, arrays)
    return NamedTuple{keys}(arrays)
end

# Dummy `read` methods that does nothing.
# This can be used to actually read `AbstractDimArray` subtypes that dont hold in-memory Arrays.
Base.read(A::AbstractDimArray) = A

# Methods that create copies of an AbstractDimArray #######################################

# Need to cover a few type signatures to avoid ambiguity with base
function Base.similar(A::AbstractDimArray; 
    data=similar(parent(A)), 
    dims=dims(A), refdims=refdims(A), name=_noname(A), metadata=metadata(A), kw...
)
    rebuild(A; data, dims=format(dims, data), refdims, name, metadata, kw...)
end
function Base.similar(A::AbstractDimArray, ::Type{T}; 
    data=similar(parent(A), T),
    dims=dims(A), refdims=refdims(A), name=_noname(A), metadata=metadata(A), kw...
) where T
    rebuild(A; data, dims=format(dims, data), refdims, name, metadata, kw...)
end

# We avoid calling `parent` for AbstractBasicDimArray as we don't know what it is/if there is one
function Base.similar(A::AbstractBasicDimArray{T,N}; 
    data=similar(Array{T,N}, size(A)),
    dims=dims(A), refdims=refdims(A), name=_noname(A), metadata=NoMetadata(), kw...
) where {T,N}
    dimconstructor(dims)(data, dims; refdims, name, metadata, kw...)
end
function Base.similar(A::AbstractBasicDimArray{<:Any,N}, ::Type{T}; 
    data=similar(Array{T,N}, size(A)),
    dims=dims(A), refdims=refdims(A), name=_noname(A), metadata=NoMetadata(), kw...
) where {T,N}
    dimconstructor(dims)(data, dims; refdims, name, metadata, kw...)
end
# We can't resize the dims or add missing dims, so return the unwraped Array type?
# An alternative would be to fill missing dims with `Anon`, and keep existing
# dims but strip the Lookup? It just seems a little complicated when the methods
# below using DimTuple work better anyway.
Base.similar(A::AbstractDimArray, I::Tuple{Int,Vararg{Int}}; kw...) = 
    similar(A, eltype(A), I; kw...)
Base.similar(A::AbstractDimArray, ::Type{T}, i::Int, I::Vararg{Int}; kw...) where T =
    similar(A, T, (i, I...); kw...)
Base.similar(A::AbstractDimArray, ::Type{T}, I::Tuple{Int,Vararg{Int}}; kw...) where T =
    similar(parent(A), T, I)

const MaybeDimUnitRange = Union{Integer,Base.OneTo,Dimensions.DimUnitRange}
# when all axes are DimUnitRanges we can return an `AbstractDimArray`
# This code covers the likely most common cases where at least one DimUnitRange is in the
# first 4 axes of the array being created. If all of the axes are DimUnitRange, then an
# AbstractDimArray is returned. Otherwise an array like the parent array is returned.
# This ensures no ambiguity with each other and Base without type piracy.
for s1 in (:(Dimensions.DimUnitRange), :MaybeDimUnitRange)
    s1 === :MaybeDimUnitRange || @eval begin
        function Base.similar(
            A::AbstractArray, ::Type{T}, shape::Tuple{$s1,Vararg{MaybeDimUnitRange}}; kw...
        ) where T
            _similar(A, T, shape; kw...)
        end
        function Base.similar(
            ::Type{T}, shape::Tuple{$s1,Vararg{MaybeDimUnitRange}}; kw...
        ) where T<:AbstractArray
            _similar(T, shape; kw...)
        end
    end
    for s2 in (:(Dimensions.DimUnitRange), :MaybeDimUnitRange)
        all(Base.Fix2(===, :MaybeDimUnitRange), (s1, s2)) || @eval begin
            function Base.similar(
                A::AbstractArray, T::Type, shape::Tuple{$s1,$s2,Vararg{MaybeDimUnitRange}}; kw...
            )
                _similar(A, T, shape; kw...)
            end
            function Base.similar(
                T::Type{<:AbstractArray}, shape::Tuple{$s1,$s2,Vararg{MaybeDimUnitRange}}; kw...
            )
                _similar(T, shape; kw...)
            end
        end
        for s3 in (:(Dimensions.DimUnitRange), :MaybeDimUnitRange)
            all(Base.Fix2(===, :MaybeDimUnitRange), (s1, s2, s3)) || @eval begin
                function Base.similar(
                    A::AbstractArray, T::Type, shape::Tuple{$s1,$s2,$s3,Vararg{MaybeDimUnitRange}}; kw...
                )
                    _similar(A, T, shape; kw...)
                end
                function Base.similar(
                    T::Type{<:AbstractArray}, shape::Tuple{$s1,$s2,$s3,Vararg{MaybeDimUnitRange}}; kw...
                )
                    _similar(T, shape; kw...)
                end        
            end    
            for s4 in (:(Dimensions.DimUnitRange), :MaybeDimUnitRange)
                all(Base.Fix2(===, :MaybeDimUnitRange), (s1, s2, s3, s4)) && continue
                @eval begin
                    function Base.similar(
                        A::AbstractArray, T::Type, shape::Tuple{$s1,$s2,$s3,$s4,Vararg{MaybeDimUnitRange}}; kw...
                    )
                        _similar(A, T, shape; kw...)
                    end
                    function Base.similar(
                        T::Type{<:AbstractArray}, shape::Tuple{$s1,$s2,$s3,$s4,Vararg{MaybeDimUnitRange}}; kw...
                    )
                        _similar(T, shape; kw...)
                    end            
                end
            end
        end
    end
end

function _similar(A::AbstractDimArray, T::Type, shape::Tuple; 
    dims=dims(shape), refdims=(), name=_noname(A), metadata=metadata(A), kw...
)
    data = similar(parent(A), T, map(_parent_range, shape))
    shape isa Tuple{Vararg{Dimensions.DimUnitRange}} || return data
    rebuild(A; data, dims, refdims, name, metadata, kw...)
end
function _similar(A::AbstractArray, T::Type, shape::Tuple; kw...)
    data = similar(parent(A), T, map(_parent_range, shape))
    shape isa Tuple{Vararg{Dimensions.DimUnitRange}} || return data
    C = dimconstructor(dims(shape))
    return C(data, dims(shape); kw...)
end
function _similar(::Type{T}, shape::Tuple; kw...) where {T<:AbstractArray}
    data = similar(T, map(_parent_range, shape))
    shape isa Tuple{Vararg{Dimensions.DimUnitRange}} || return data
    C = dimconstructor(dims(shape))
    return C(data, dims(shape); kw...)
end

# With Dimensions we can return an `AbstractDimArray`
Base.similar(A::AbstractBasicDimArray, d1::Dimension, D::Dimension...; kw...) =
    Base.similar(A, eltype(A), (d1, D...); kw...)
Base.similar(A::AbstractBasicDimArray, ::Type{T}, d1::Dimension, D::Dimension...; kw...) where T =
    Base.similar(A, T, (d1, D...); kw...)
Base.similar(A::AbstractBasicDimArray, D::DimTuple; kw...) = 
    Base.similar(A, eltype(A), D; kw...) 
function Base.similar(A::AbstractBasicDimArray, ::Type{T}, D::DimTuple; kw...) where T
    data = _arraytype(T)(undef, _dimlength(D))
    dimconstructor(D)(data, D; kw...)
end
function Base.similar(A::AbstractBasicDimArray, ::Type{T}, D::Tuple{};
    refdims=(), name=_noname(A), metadata=NoMetadata(), kw...
) where T
    data = _arraytype(T)(undef, _dimlength(D))
    dimconstructor(D)(data, (); refdims, name, metadata, kw...)
end

function Base.similar(A::AbstractDimArray, ::Type{T}, D::DimTuple; 
    refdims=(), name=_noname(A), metadata=NoMetadata(), kw...
) where T
    data = _arraytype(T)(undef, _dimlength(D))
    dims = _maybestripval(D)
    return rebuild(A; data, dims, refdims, metadata, name, kw...)
end
function Base.similar(A::AbstractDimArray, ::Type{T}, D::Tuple{};
    refdims=(), name=_noname(A), metadata=NoMetadata(), kw...
) where T
    data = similar(parent(A), T, ())
    rebuild(A; data, dims=(), refdims, metadata, name, kw...)
end

Base.similar(A::AbstractBasicDimArray, shape::Int...; kw...) =
    similar(A, eltype(A), shape; kw...)
Base.similar(A::AbstractBasicDimArray, shape::Tuple{Vararg{Int}}; kw...) = 
    similar(A, eltype(A), shape; kw...)
Base.similar(A::AbstractBasicDimArray, ::Type{T}, shape::Int...; kw...) where T =
    similar(A, T, shape; kw...)
Base.similar(A::AbstractBasicDimArray, ::Type{T}, shape::Tuple{Vararg{Int}}; kw...) where T =
    _arraytype(T)(undef, shape)
Base.similar(A::AbstractDimArray, ::Type{T}, shape::Tuple{Vararg{Int}}; kw...) where T =
    similar(parent(A), T, shape)

_arraytype(::Type{T}) where T = Array{T}
_arraytype(::Type{Bool}) = BitArray

# Keep the same type in `similar`
_noname(A::AbstractBasicDimArray) = _noname(name(A))
_noname(s::String) = ""
_noname(::NoName) = NoName()
_noname(::Symbol) = Symbol("")
_noname(name::Name) = name # Keep the name so the type doesn't change

_parent_range(r::Dimensions.DimUnitRange) = parent(r)
_parent_range(r) = r

for func in (:copy, :one, :oneunit, :zero)
    @eval begin
        (Base.$func)(A::AbstractDimArray; kw...) = rebuild(A; data=($func)(parent(A)), kw...)
    end
end

Base.Array(A::AbstractDimArray) = Array(parent(A))
Base.collect(A::AbstractDimArray) = collect(parent(A))

_maybeunwrap(A::AbstractDimArray) = parent(A)
_maybeunwrap(A::AbstractArray) = A

for (d, s) in ((:AbstractDimArray, :AbstractDimArray),
               (:AbstractDimArray, :AbstractArray),
               (:AbstractArray, :AbstractDimArray))
    @eval begin
        Base.copy!(dst::$d{T,N}, src::$s{T,N}) where {T,N} = (copy!(_maybeunwrap(dst), _maybeunwrap(src)); dst)
        Base.copy!(dst::$d{T,1}, src::$s{T,1}) where T = (copy!(_maybeunwrap(dst), _maybeunwrap(src)); dst)
        Base.copyto!(dst::$d, src::$s) = (copyto!(_maybeunwrap(dst), _maybeunwrap(src)); dst)
        Base.copyto!(dst::$d, dstart::Integer, src::$s) =
            (copyto!(_maybeunwrap(dst), dstart, _maybeunwrap(src)); dst)
        Base.copyto!(dst::$d, dstart::Integer, src::$s, sstart::Integer) =
            (copyto!(_maybeunwrap(dst), dstart, _maybeunwrap(src), sstart); dst)
        Base.copyto!(dst::$d, dstart::Integer, src::$s, sstart::Integer, n::Integer) =
            (copyto!(_maybeunwrap(dst), dstart, _maybeunwrap(src), sstart, n); dst)
        Base.copyto!(dst::$d{T1,N}, Rdst::CartesianIndices{N}, src::$s{T2,N}, Rsrc::CartesianIndices{N}) where {T1,T2,N} =
            (copyto!(_maybeunwrap(dst), Rdst, _maybeunwrap(src), Rsrc); dst)
    end
end
# Ambiguity
Base.copyto!(dst::AbstractDimArray{T,2} where T, src::LinearAlgebra.AbstractQ) =
    (copyto!(parent(dst), src); dst)
Base.copyto!(dst::PermutedDimsArray, src::AbstractDimArray) = 
    (copyto!(dst, parent(src)); dst)

# Concrete implementation ######################################################

"""
    DimArray <: AbstractDimArray

    DimArray(data, dims, refdims, name, metadata)
    DimArray(data, dims::Tuple; refdims=(), name=NoName(), metadata=NoMetadata())
    DimArray(gen; kw...)

The main concrete subtype of [`AbstractDimArray`](@ref).

`DimArray` maintains and updates its `Dimension`s through transformations and
moves dimensions to reference dimension `refdims` after reducing operations
(like e.g. `mean`).

## Arguments

- `data`: An `AbstractArray` or a table with coordinate columns corresponding to `dims`.
- `gen`: A generator expression. Where source iterators are `Dimension`s the dim args or kw is not needed.
- `dims`: A `Tuple` of `Dimension`
- `name`: A string name for the array. Shows in plots and tables.
- `refdims`: refence dimensions. Usually set programmatically to track past
    slices and reductions of dimension for labelling and reconstruction.
- `metadata`: `Dict` or `Metadata` object, or `NoMetadata()`
- `selector`: The coordinate selector type to use when materializing from a table.

Indexing can be done with all regular indices, or with [`Dimension`](@ref)s
and/or [`Selector`](@ref)s. 

Indexing `AbstractDimArray` with non-range `AbstractArray` has undefined effects
on the `Dimension` index. Use forward-ordered arrays only"

Note that the generator expression syntax requires usage of the semi-colon `;`
to distinguish generator dimensions from keywords.

Example:

```jldoctest dimarray; setup = :(using Random; Random.seed!(123))
julia> using Dates, DimensionalData

julia> ti = Ti(DateTime(2001):Month(1):DateTime(2001,12));

julia> x = X(10:10:100);

julia> A = DimArray(rand(12,10), (ti, x), name="example");

julia> A[X(Near([12, 35])), Ti(At(DateTime(2001,5)))]
┌ 2-element DimArray{Float64, 1} example ┐
├────────────────────────────────────────┴──────────────── dims ┐
  ↓ X Sampled{Int64} [10, 40] ForwardOrdered Irregular Points
└───────────────────────────────────────────────────────────────┘
 10  0.253849
 40  0.637077

julia> A[Near(DateTime(2001, 5, 4)), Between(20, 50)]
┌ 4-element DimArray{Float64, 1} example ┐
├────────────────────────────────────────┴────────────── dims ┐
  ↓ X Sampled{Int64} 20:10:50 ForwardOrdered Regular Points
└─────────────────────────────────────────────────────────────┘
 20  0.774092
 30  0.823656
 40  0.637077
 50  0.692235
```

Generator expression:

```jldoctest dimarray
julia> DimArray((x, y) for x in X(1:3), y in Y(1:2); name = :Value)
┌ 3×2 DimArray{Tuple{Int64, Int64}, 2} Value ┐
├────────────────────────────────────────────┴───── dims ┐
  ↓ X Sampled{Int64} 1:3 ForwardOrdered Regular Points,
  → Y Sampled{Int64} 1:2 ForwardOrdered Regular Points
└────────────────────────────────────────────────────────┘
 ↓ →  1        2
 1     (1, 1)   (1, 2)
 2     (2, 1)   (2, 2)
 3     (3, 1)   (3, 2)
```
"""
struct DimArray{T,N,D<:Tuple,R<:Tuple,A<:AbstractArray{T,N},Na,Me} <: AbstractDimArray{T,N,D,A}
    data::A
    dims::D
    refdims::R
    name::Na
    metadata::Me
    function DimArray(
        data::A, dims::D, refdims::R, name::Na, metadata::Me
    ) where {D<:Tuple,R<:Tuple,A<:AbstractArray{T,N},Na,Me} where {T,N}
        checkdims(data, dims)
        new{T,N,D,R,A,Na,Me}(data, dims, refdims, name, metadata)
    end
end
# 2 arg version
DimArray(data::AbstractArray, dims; kw...) = DimArray(data, (dims,); kw...)
function DimArray(data::AbstractArray, dims::Union{Tuple,NamedTuple}; 
    refdims=(), name=NoName(), metadata=NoMetadata()
)
    DimArray(data, format(dims, data), refdims, name, metadata)
end
# All keyword argument version
function DimArray(; data, dims, refdims=(), name=NoName(), metadata=NoMetadata())
    DimArray(data, dims; refdims, name, metadata)
end
# Construct from another AbstractDimArray
function DimArray(A::AbstractDimArray;
    data=parent(A), dims=dims(A), refdims=refdims(A), name=name(A), metadata=metadata(A)
)
    DimArray(data, dims; refdims, name, metadata)
end
DimArray{T}(A::AbstractDimArray; kw...) where T = DimArray(convert.(T, A))
DimArray{T}(A::AbstractDimArray{T}; kw...) where T = DimArray(A; kw...)
DimArray{T}(x::UndefInitializer, dims::Dimension...; kw...) where T = DimArray{T}(x, dims; kw...)
DimArray{T}(x::UndefInitializer, dims::MaybeDimTuple; kw...) where T = DimArray(Array{T}(undef, map(length, dims)), dims; kw...)
# We collect other kinds of AbstractBasicDimArray 
# to avoid complicated nesting of dims
function DimArray(A::AbstractBasicDimArray;
    data=parent(A), dims=dims(A), refdims=refdims(A), name=name(A), metadata=metadata(A)
)
    newdata = collect(data)
    DimArray(newdata, format(dims, newdata); refdims, name, metadata)
end
# Tables
# Write a single column from a table with one or more coordinate columns to a DimArray
function DimArray(table, dims; kw...)
    # Confirm that the Tables interface is implemented
    Tables.istable(table) || throw(ArgumentError("`obj` must be an `AbstractArray` or satisfy the `Tables.jl` interface."))
    table = Tables.columnaccess(table) ? table : Tables.columns(table)
    dimarray_from_table(DimArray, table, guess_dims(table, dims); kw...)
end
# Same as above, but guess dimension names from scratch
function DimArray(table; kw...)
    # Confirm that the Tables interface is implemented
    Tables.istable(table) || throw(ArgumentError("`table` must satisfy the `Tables.jl` interface."))
    table = Tables.columnaccess(table) ? table : Tables.columns(table)
    # Use default dimension 
    return dimarray_from_table(DimArray, table, guess_dims(table; kw...); kw...)
end
# Special-case for AbstractVectors - these might be tables
function DimArray(data::AbstractVector, dims::Tuple; 
    refdims=(), name=NoName(), metadata=NoMetadata(), kw...
)
    if !(data isa AbstractBasicDimArray) && Tables.istable(data) && 
        all(map(d -> Dimensions.name(d) in Tables.schema(data).names, dims))
        table = Tables.columns(data)
        dims = guess_dims(table, dims; kw...)
        return dimarray_from_table(DimArray, table, dims; refdims, name, metadata, kw...)
    else
        return DimArray(data, format(dims, data), refdims, name, metadata)
    end
end

function dimarray_from_table(::Type{T}, table, dims; 
    name=NoName(), 
    selector=nothing, 
    precision=6, 
    missingval=missing, 
    kw...
) where T <: AbstractDimArray
    # Determine row indices based on coordinate values
    indices = coords_to_indices(table, dims; selector, atol=10.0^-precision)

    # Extract the data column correspondong to `name`
    col = name == NoName() ? data_col_names(table, dims) |> first : Symbol(name)
    data = Tables.getcolumn(table, col)

    # Restore array data
    array = restore_array(data, indices, dims, missingval)

    # Return DimArray
    return T(array, dims, name=col; kw...)
end

"""
    DimArray(f::Function, dim::Dimension; [name])

Apply function `f` across the values of the dimension `dim`
(using `broadcast`), and return the result as a dimensional array with
the given dimension. Optionally provide a name for the result.
"""
function DimArray(f::Function, dim::Dimension; name=Symbol(nameof(f), "(", name(dim), ")"))
    DimArray(f.(val(dim)), (dim,); name)
end

DimArray(itr::Base.Generator; kwargs...) = rebuild(collect(itr); kwargs...)

const DimVector = DimArray{T,1} where T
const DimMatrix = DimArray{T,2} where T
const DimVecOrMat = Union{DimVector,DimMatrix}

DimVector(A::AbstractVector, dim::Dimension, args...; kw...) = 
    DimArray(A, (dim,), args...; kw...)
DimVector(A::AbstractVector, args...; kw...) = DimArray(A, args...; kw...)
DimVector(f::Function, dim::Dimension; kw...) = 
    DimArray(f::Function, dim::Dimension; kw...) 
DimMatrix(A::AbstractMatrix, args...; kw...) = DimArray(A, args...; kw...)

Base.convert(::Type{DimArray}, A::AbstractDimArray) = DimArray(A)
Base.convert(::Type{DimArray{T}}, A::AbstractDimArray) where {T} = DimArray{T}(A)

checkdims(A::AbstractArray{<:Any,N}, dims::Tuple) where N = checkdims(N, dims)
checkdims(::Type{<:AbstractArray{<:Any,N}}, dims::Tuple) where N = checkdims(N, dims)
checkdims(n::Integer, dims::Tuple) = length(dims) == n || _dimlengtherror(n, length(dims))

@noinline _dimlengtherror(na, nd) =
    throw(ArgumentError("axes of the array ($na) do not match number of dimensions ($nd)")) 

"""
    rebuild(A::DimArray, data, dims, refdims, name, metadata) => DimArray
    rebuild(A::DimArray; kw...) => DimArray

Rebuild a `DimArray` with new fields. Handling partial field
update is dealt with in `rebuild` for `AbstractDimArray`.
"""
@inline function rebuild(
    A::DimArray, data::AbstractArray, dims::Tuple, refdims::Tuple, name, metadata
)
    DimArray(data, dims, refdims, name, metadata)
end


"""
    Base.fill(x, dims::Dimension...; kw...) => DimArray
    Base.fill(x, dims::Tuple{Vararg{Dimension}}; kw...) => DimArray

Create a [`DimArray`](@ref) with a fill value of `x`.

There are two kinds of `Dimension` value acepted:
- A `Dimension` holding an `AbstractVector` will set the dimension index to 
  that `AbstractVector`, and detect the dimension lookup.
- A `Dimension` holding an `Integer` will set the length of the axis,
  and set the dimension lookup to [`NoLookup`](@ref).

Keywords are the same as for [`DimArray`](@ref).

# Example

```jldoctest
julia> using DimensionalData, Random; Random.seed!(123);

julia> fill(true, X(2), Y(4))
┌ 2×4 DimArray{Bool, 2} ┐
├───────────────── dims ┤
  ↓ X, → Y
└───────────────────────┘
 1  1  1  1
 1  1  1  1
```
"""
Base.fill

"""
    Base.rand(x, dims::Dimension...; kw...) => DimArray
    Base.rand(x, dims::Tuple{Vararg{Dimension}}; kw...) => DimArray
    Base.rand(r::AbstractRNG, x, dims::Tuple{Vararg{Dimension}}; kw...) => DimArray
    Base.rand(r::AbstractRNG, x, dims::Dimension...; kw...) => DimArray

Create a [`DimArray`](@ref) of random values.

There are two kinds of `Dimension` value acepted:
- A `Dimension` holding an `AbstractVector` will set the dimension index to 
  that `AbstractVector`, and detect the dimension lookup.
- A `Dimension` holding an `Integer` will set the length of the axis,
  and set the dimension lookup to [`NoLookup`](@ref).

Keywords are the same as for [`DimArray`](@ref).

# Example

```jldoctest; setup = :(using Random; Random.seed!(123))
julia> using DimensionalData

julia> rand(Bool, X(2), Y(4))
┌ 2×4 DimArray{Bool, 2} ┐
├───────────────── dims ┤
  ↓ X, → Y
└───────────────────────┘
 0  0  0  0
 1  0  0  1

julia> rand(X([:a, :b, :c]), Y(100.0:50:200.0))
┌ 3×3 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────────── dims ┐
  ↓ X Categorical{Symbol} [:a, …, :c] ForwardOrdered,
  → Y Sampled{Float64} 100.0:50.0:200.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────┘
 ↓ →  100.0       150.0       200.0
  :a    0.443494    0.253849    0.867547
  :b    0.745673    0.334152    0.0802658
  :c    0.512083    0.427328    0.311448
```
"""
Base.rand

"""
    Base.zeros(x, dims::Dimension...; kw...) => DimArray
    Base.zeros(x, dims::Tuple{Vararg{Dimension}}; kw...) => DimArray

Create a [`DimArray`](@ref) of zeros.

There are two kinds of `Dimension` value acepted:
- A `Dimension` holding an `AbstractVector` will set the dimension index to 
  that `AbstractVector`, and detect the dimension lookup.
- A `Dimension` holding an `Integer` will set the length of the axis,
  and set the dimension lookup to [`NoLookup`](@ref).

Keywords are the same as for [`DimArray`](@ref).

# Example

```jldoctest
julia> using DimensionalData

julia> zeros(Bool, X(2), Y(4))
┌ 2×4 DimArray{Bool, 2} ┐
├───────────────── dims ┤
  ↓ X, → Y
└───────────────────────┘
 0  0  0  0
 0  0  0  0

julia> zeros(X([:a, :b, :c]), Y(100.0:50:200.0))
┌ 3×3 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────────── dims ┐
  ↓ X Categorical{Symbol} [:a, …, :c] ForwardOrdered,
  → Y Sampled{Float64} 100.0:50.0:200.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────┘
 ↓ →  100.0  150.0  200.0
  :a    0.0    0.0    0.0
  :b    0.0    0.0    0.0
  :c    0.0    0.0    0.0

```
"""
Base.zeros

"""
    Base.ones(x, dims::Dimension...; kw...) => DimArray
    Base.ones(x, dims::Tuple{Vararg{Dimension}}; kw...) => DimArray

Create a [`DimArray`](@ref) of ones.

There are two kinds of `Dimension` value acepted:
- A `Dimension` holding an `AbstractVector` will set the dimension index to 
  that `AbstractVector`, and detect the dimension lookup.
- A `Dimension` holding an `Integer` will set the length of the axis,
  and set the dimension lookup to [`NoLookup`](@ref).

Keywords are the same as for [`DimArray`](@ref).

# Example

```jldoctest
julia> using DimensionalData

julia> ones(Bool, X(2), Y(4))
┌ 2×4 DimArray{Bool, 2} ┐
├───────────────── dims ┤
  ↓ X, → Y
└───────────────────────┘
 1  1  1  1
 1  1  1  1

julia> ones(X([:a, :b, :c]), Y(100.0:50:200.0))
┌ 3×3 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────────── dims ┐
  ↓ X Categorical{Symbol} [:a, …, :c] ForwardOrdered,
  → Y Sampled{Float64} 100.0:50.0:200.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────┘
 ↓ →  100.0  150.0  200.0
  :a    1.0    1.0    1.0
  :b    1.0    1.0    1.0
  :c    1.0    1.0    1.0

```
"""
Base.ones

# Dimension only DimArray creation methods

for f in (:zeros, :ones, :rand)
    @eval begin
        Base.$f(dim1::Dimension, dims::Dimension...; kw...) = $f((dim1, dims...); kw...)
        Base.$f(dims::DimTuple; kw...) = $f(Float64, dims; kw...)
    end
end
for f in (:trues, :falses)
    @eval begin
        Base.$f(dim1::Dimension, dims::Dimension...; kw...) = $f((dim1, dims...); kw...)
        function Base.$f(dims::DimTuple; kw...)
            C = dimconstructor(dims)
            C($f(_dimlength(dims)), _maybestripval(dims); kw...)
        end
    end
end
# Type specific DimArray creation methods
for f in (:zeros, :ones, :rand)
    @eval begin
        Base.$f(::Type{T}, d1::Dimension, dims::Dimension...; kw...) where T = 
            $f(T, (d1, dims...); kw...)
        function Base.$f(::Type{T}, dims::DimTuple; kw...) where T
            C = dimconstructor(dims)
            C($f(T, _dimlength(dims)), _maybestripval(dims); kw...)
        end
    end
end
# Arbitrary object DimArray creation methods
for f in (:fill, :rand)
    @eval begin
        Base.$f(x, d1::Dimension, dims::Dimension...; kw...) = $f(x, (d1, dims...); kw...)
        function Base.$f(x, dims::DimTuple; kw...)
            A = $f(x, _dimlength(dims))
            C = dimconstructor(dims)
            C(A, _maybestripval(dims); kw...)
        end
    end
end
# AbstractRNG rand DimArray creation methods
Base.rand(r::AbstractRNG, x, d1::Dimension, dims::Dimension...; kw...) = 
    rand(r, x, (d1, dims...); kw...)
function Base.rand(r::AbstractRNG, x, dims::DimTuple; kw...)
    C = dimconstructor(dims)
    C(rand(r, x, _dimlength(dims)), _maybestripval(dims); kw...)
end
function Base.rand(r::AbstractRNG, d1::Dimension, dims::Dimension...; kw...)
    rand(r, (d1, dims...); kw...)
end
function Base.rand(r::AbstractRNG, ::Type{T}, d1::Dimension, dims::Dimension...; kw...) where T
    rand(r, T, (d1, dims...); kw...)
end
function Base.rand(r::AbstractRNG, dims::DimTuple; kw...)
    C = dimconstructor(dims)
    C(rand(r, _dimlength(dims)...), _maybestripval(dims); kw...)
end
function Base.rand(r::AbstractRNG, ::Type{T}, dims::DimTuple; kw...) where T
    C = dimconstructor(dims)
    C(rand(r, T, _dimlength(dims)), _maybestripval(dims); kw...)
end

function _dimlength(
    dims::Tuple{<:Dimension{<:Lookups.ArrayLookup},Vararg{Dimension{<:Lookups.ArrayLookup}}}
) 
    lookups = lookup(dims)
    sz1 = size(first(lookups).matrix)
    foreach(lookups) do l
        sz = size(l.matrix)
        sz1 == sz || throw(ArgumentError("ArrayLookup matrix sizes must match. Got $sz1 and $sz"))
    end
    return sz1
end
_dimlength(dims::Tuple) = map(_dimlength, dims)
_dimlength(dim::Dimension{<:AbstractArray}) = length(dim)
_dimlength(dim::Dimension{<:Val{Keys}}) where Keys = length(Keys)
_dimlength(dim::Dimension{<:Integer}) = val(dim)
@noinline _dimlength(dim::Dimension) =
    throw(ArgumentError("$(basetypeof(dim)) must hold an Integer or an AbstractArray, instead holds: $(val(dim))"))

function _maybestripval(dims)
    dims = map(dims) do d
        val(d) isa AbstractArray ? d : basetypeof(d)()
    end
end

# dimconstructor
# Allow customising constructors based on dimension types
# Thed default constructor is DimArray
dimconstructor(dims::DimTuple) = dimconstructor(tail(dims)) 
dimconstructor(::Tuple{}) = DimArray 

"""
    mergedims(old_dims => new_dim) => Dimension

Return a dimension `new_dim` whose indices are a [`MergedLookup`](@ref) of the indices of
`old_dims`.
"""
function mergedims((old_dims, new_dim)::Pair)
    data = vec(DimPoints(_astuple(old_dims)))
    return rebuild(basedims(new_dim), MergedLookup(data, _astuple(old_dims)))
end

"""
    mergedims(dims, old_dims => new_dim, others::Pair...) => dims_new

If dimensions `old_dims`, `new_dim`, etc. are found in `dims`, then return new `dims_new`
where all dims in `old_dims` have been combined into a single dim `new_dim`.
The returned dimension will keep only the name of `new_dim`. Its coords will be a
[`MergedLookup`](@ref) of the coords of the dims in `old_dims`. New dimensions are always
placed at the end of `dims_new`. `others` contains other dimension pairs to be merged.

# Example

```jldoctest
julia> using DimensionalData

julia> ds = (X(0:0.1:0.4), Y(10:10:100), Ti([0, 3, 4]))
(↓ X 0.0:0.1:0.4,
→ Y 10:10:100,
↗ Ti [0, …, 4])

julia> mergedims(ds, (X, Y) => :space)
(↓ Ti [0, …, 4],
→ space MergedLookup{Tuple{Float64, Int64}} [(0.0, 10), …, (0.4, 100)] (↓ X, → Y))
```
"""
function mergedims(x, dt1::Tuple, dts::Tuple...)
    pairs = map((dt1, dts...)) do ds
        ds => Dim{Symbol(map(name, ds)...)}()
    end
    mergedims(x, pairs...)
end
function mergedims(all_dims, dim_pairs::Pair...)
    # filter out dims completely missing
    dim_pairs = map(x -> _filter_dims(all_dims, first(x)) => last(x), dim_pairs)
    dim_pairs_complete = filter(dim_pairs) do (old_dims,)
        dims_present = dims(all_dims, _astuple(old_dims))
        isempty(dims_present) && return false
        all(hasdim(dims_present, old_dims)) || throw(ArgumentError(
            "Not all dimensions $old_dims found in $(map(basetypeof, all_dims))"
        ))
        return true
    end
    isempty(dim_pairs_complete) && return all_dims
    dim_pairs_concrete = map(dim_pairs_complete) do (old_dims, new_dim)
        return dims(all_dims, _astuple(old_dims)) => new_dim
    end
    # throw error if old dim groups overlap
    old_dims_tuples = map(first, dim_pairs_concrete)
    if !dimsmatch(_cat_tuples(old_dims_tuples...), combinedims(old_dims_tuples...))
        throw(ArgumentError("Dimensions to be merged are not all unique"))
    end
    return _mergedims(all_dims, dim_pairs_concrete...)
end

"""
    mergedims(A::AbstractDimArray, dim_pairs::Pair...) => AbstractDimArray
    mergedims(A::AbstractDimStack, dim_pairs::Pair...) => AbstractDimStack

Return a new array or stack whose dimensions are the result of [`mergedims(dims(A), dim_pairs)`](@ref).
"""
function mergedims(A::AbstractDimArray, dim_pairs::Pair...)
    isempty(dim_pairs) && return A
    all_dims = dims(A)
    dims_new = mergedims(all_dims, dim_pairs...)
    dimsmatch(all_dims, dims_new) && return A
    dims_perm = _unmergedims(dims_new, map(last, dim_pairs))
    Aperm = PermutedDimsArray(A, dims_perm)
    data_merged = reshape(parent(Aperm), map(length, dims_new))
    return rebuild(A, data_merged, dims_new)
end

"""
    unmergedims(merged_dims::Tuple{Vararg{Dimension}}) => Tuple{Vararg{Dimension}}

Return the unmerged dimensions from a tuple of merged dimensions. However, the order of the original dimensions are not necessarily preserved.
"""
function unmergedims(merged_dims::Tuple{Vararg{Dimension}})
    reduce(map(dims, merged_dims), init=()) do acc, x
        x isa Tuple ? (acc..., x...) : (acc..., x)
    end
end

"""
    unmergedims(A::AbstractDimArray, original_dims) => AbstractDimArray
    unmergedims(A::AbstractDimStack, original_dims) => AbstractDimStack

Return a new array or stack whose dimensions are restored to their original prior to calling [`mergedims(A, dim_pairs)`](@ref).
"""
function unmergedims(A::AbstractBasicDimArray, original_dims)
    merged_dims = dims(A)
    unmerged_dims = unmergedims(merged_dims)
    reshaped = reshape(parent(A), size(unmerged_dims))
    permuted = permutedims(reshaped, dimnum(unmerged_dims, original_dims))
    return DimArray(permuted, original_dims)
end

function _mergedims(all_dims, dim_pair::Pair, dim_pairs::Pair...)
    old_dims, new_dim = dim_pair
    dims_to_merge = dims(all_dims, _astuple(old_dims))
    merged_dim = mergedims(dims_to_merge => new_dim)
    all_dims_new = (otherdims(all_dims, dims_to_merge)..., merged_dim)
    isempty(dim_pairs) && return all_dims_new
    return _mergedims(all_dims_new, dim_pairs...)
end

function _unmergedims(all_dims, merged_dims)
    _merged_dims = dims(all_dims, merged_dims)
    unmerged_dims = map(all_dims) do d
        hasdim(_merged_dims, d) || return _astuple(d)
        return dims(lookup(d))
    end
    return _cat_tuples(unmerged_dims...)
end

_unmergedims(all_dims, dim_pairs::Pair...) = _cat_tuples(replace(all_dims, dim_pairs...))

_cat_tuples(tuples...) = mapreduce(_astuple, (x, y) -> (x..., y...), tuples)

_filter_dims(alldims, dims) = filter(dim -> hasdim(alldims, dim), dims)

abstract type MultiDimensionalLookup{T} <: Lookup{T,1} end
hasinternaldimensions(::MultiDimensionalLookup) = true

"""
    MergedLookup <: MultiDimensionalLookup <: Lookup

    MergedLookup(data, dims; [metadata])

A [`Lookup`](@ref) that holds multiple combined dimensions.

`MergedLookup` can be indexed with [`Selector`](@ref)s like `At`, 
`Between`, and `Where` although `Near` has undefined meaning.

## Examples
The easiest way to create a `MergedLookup` is to use the `mergedims` function:

```julia
da = rand(X(1:3), Y(1:3), Ti(1:3))
merged = mergedims(da, (X, Y) => :space)

julia> merged = mergedims(da, (X, Y) => :space)
┌ 3×9 DimArray{Float64, 2} ┐
├──────────────────────────┴─────────────────────────────────────────────────────────────────────────────── dims ┐
  ↓ Ti    Sampled{Int64} 1:3 ForwardOrdered Regular Points,
  → space MergedLookup{Tuple{Int64, Int64}} [(1, 1), (2, 1), …, (2, 3), (3, 3)] ↓ X, → Y
└────────────────────────────────────────────────────────────────────────────────────────────────────────────────┘
 ↓ →   (1, 1)    (2, 1)   (3, 1)    (1, 2)    (2, 2)    (3, 2)    (1, 3)     (2, 3)     (3, 3)
 ⋮                                           ⋮                                         
 3    0.832755  0.89284  0.184938  0.434221  0.552545  0.612124  0.0630973  0.0365063  0.103989
```

Then, you can index into the merged dimensions in two ways: by referring specifically to the merged dimension,
```julia
merged[space=1:2]
merged[space=(X(At(1)), Y(At(2))), Ti(At(2))]
```

or by using the `Coord` type, which is able to infer the merged lookup from the dimension names:
```julia
merged[space=(X(At(1)), Y(At(2))), Ti(At(2))]
```

or by directly passing selectors for the merged dimensions:
```julia
merged[X(At(1)), Y(At(2)), Ti(At(2))] == merged[space=(X(At(1)), Y(At(2))), Ti(At(2))]
```

This allows quite a bit of very powerful behaviour!

## Arguments

- `data`: A `Vector` of `Tuple`.
- `dims`: A `Tuple` of [`Dimension`](@ref) indicating the dimensions in the tuples in `data`.

## Keywords

- `metadata`: a `Dict` or `Metadata` object to attach dimension metadata.

"""
struct MergedLookup{T,A<:AbstractVector{T},D,Me} <: MultiDimensionalLookup{T}
    data::A
    dims::D
    metadata::Me
end
MergedLookup(data, dims; metadata=NoMetadata()) = MergedLookup(data, dims, metadata)

hasinternaldimensions(::MergedLookup) = true
order(m::MergedLookup) = Unordered()
dims(m::MergedLookup) = m.dims
dims(d::Dimension{<:MergedLookup}) = dims(val(d))

# Lookup interface methods

Lookups.bounds(d::Dimension{<:MergedLookup}) =
    isempty(val(d)) ? () : ntuple(i -> extrema((x[i] for x in val(d))), length(first(d)))

# Return an `Int` or  Vector{Bool}
Lookups.selectindices(lookup::MergedLookup, sel::DimTuple) =
    selectindices(lookup, map(_val_or_nothing, sortdims(sel, dims(lookup))))
function Lookups.selectindices(lookup::MergedLookup, sel::NamedTuple{K}) where K
    dimsel = map(rebuild, map(name2dim, K), values(sel))
    selectindices(lookup, dimsel) 
end
Lookups.selectindices(lookup::MergedLookup, sel::StandardIndices) = sel
function Lookups.selectindices(lookup::MergedLookup, sel::Tuple)
    if (length(sel) == length(dims(lookup))) && all(map(s -> s isa At, sel))
        i = findfirst(x -> all(map(_matches, sel, x)), lookup)
        isnothing(i) && _coord_not_found_error(sel)
        return i
    else
        return [_matches(sel, x) for x in lookup]
    end
end

@inline Lookups.reducelookup(l::MergedLookup) = NoLookup(OneTo(1))

function Lookups.show_properties(io::IO, mime, lookup::MergedLookup)
    print(io, " ")
    show(IOContext(io, :inset => "", :dimcolor => 244), mime, basedims(lookup))
end

# Dimension methods

@inline _reducedims(lookup::MergedLookup, dim::Dimension) =
    rebuild(dim, [map(x -> zero(x), dim.val[1])])

function _format(dim::Dimension{<:MergedLookup}, axis::AbstractRange)
    checkaxis(dim, axis)
    return dim
end

# Local functions

@noinline _coord_not_found_error(sel) = error("$(map(val, sel)) not found in coord lookup")

_val_or_nothing(::Nothing) = nothing
_val_or_nothing(d::Dimension) = val(d)


_matches(sel::Tuple, x) = all(map(_matches, sel, x))
_matches(sel::Dimension, x) = _matches(val(sel), x)
_matches(sel::Between, x) = _matches(Interval(val(sel)...), x)
_matches(sel::Touches, x) = (x >= first(sel)) & (x <= last(sel))
_matches(sel::Lookups.AbstractInterval, x) = x in sel
_matches(sel::At, x) = x == val(sel)
_matches(sel::Colon, x) = true
_matches(sel::Nothing, x) = true
_matches(sel::Where, x) = sel.f(x)
@noinline _matches(::Near, x) = throw(ArgumentError("`Near` is not implemented for coordinates"))


# TODO: Do we still need `Coord` as a dimension?

const SelOrStandard = Union{Selector,StandardIndices}

struct Coord{T} <: Dimension{T}
    val::T
end
function Coord(val::T, dims::Tuple) where {T<:AbstractVector}
    length(dims) == length(first(val)) || throw(ArgumentError("Number of dims must match number of points"))
    lookup = MergedLookup(val, name2dim(dims))
    Coord(lookup)
end
Coord(s1::SelOrStandard, s2::SelOrStandard, sels::SelOrStandard...) = Coord((s1, s2, sels...))
Coord(sel::Selector) = Coord((sel,))
Coord(d1::Dimension, dims::Dimension...) = Coord((d1, dims...))
Coord() = Coord(:)

using DimensionalData, Interfaces, Test, Dates

@test_throws MethodError name(nothing) 
@test_throws MethodError name(Nothing)
@test dims(1) == nothing
@test dims(nothing) == nothing
@test refdims(1) == ()

# @test Interfaces.test(DimensionalData)
@test Interfaces.test(DimensionalData.DimArrayInterface)
@test Interfaces.test(DimensionalData.DimStackInterface)

# For when BaseInterfaces registered...
# using BaseInterfaces
# @implements ArrayInterface{(:setindex!,:similar_type,:similar_eltype)} AbstractDimArray [
#     rand(X(10)), 
#     rand(Y(1:10), Ti(DateTime(2000):Month(1):DateTime(2000, 12))), 
#     rand(X(1:7), Y(1:8), Z('a':'h'))
# ]
# @test BaseInterfaces.test(AbstractDimArray)

# getindex/view/setindex! ======================================================

#### getindex ####
#
function _maybe_extended_layers(s)
    if hassamedims(s)
        values(s)
    else
        map(A -> DimExtensionArray(A, dims(s)), values(s))
    end
end

# Symbol key
for f in (:getindex, :view, :dotview)
    @eval Base.@constprop :aggressive @propagate_inbounds Base.$f(s::AbstractDimStack, key::Symbol) =
        DimArray(data(s)[key], dims(s, layerdims(s)[key]), refdims(s), key, layermetadata(s, key))
    @eval Base.@constprop :aggressive @propagate_inbounds function Base.$f(s::AbstractDimStack, keys::NTuple{<:Any,Symbol})
        rebuild_from_arrays(s, NamedTuple{keys}(map(k -> s[k], keys)))
    end
    @eval Base.@constprop :aggressive @propagate_inbounds function Base.$f(
        s::AbstractDimStack, keys::Union{<:Not{Symbol},<:Not{<:NTuple{<:Any,Symbol}}}
    )
        rebuild_from_arrays(s, layers(s)[keys]) 
    end
end

Base.@assume_effects :effect_free @propagate_inbounds function Base.getindex(s::AbstractVectorDimStack, i::Union{AbstractVector,Colon})
    # Use dimensional indexing
    Base.getindex(s, rebuild(only(dims(s)), i))
end
Base.@assume_effects :effect_free @propagate_inbounds function Base.getindex(
    s::AbstractDimStack{<:Any,T}, i::Union{AbstractArray,Colon}
) where {T}
    ls = _maybe_extended_layers(s)
    inds = to_indices(first(ls), (i,))[1]
    out = similar(inds, T)
    for (i, ind) in enumerate(inds)
        out[i] = T(map(v -> v[ind], ls))
    end
    return out
end
@propagate_inbounds function Base.getindex(s::AbstractDimStack{<:Any,<:Any,N}, i::Integer) where N
    if N == 1 && hassamedims(s)
        # This is a few ns faster when possible
        map(l -> l[i], data(s))
    else
        # Otherwise use dimensional indexing
        s[DimIndices(s)[i]]
    end
end

@propagate_inbounds function Base.view(s::AbstractVectorDimStack, i::Union{AbstractVector{<:Integer},Colon,Integer})
    Base.view(s, DimIndices(s)[i])
end
@propagate_inbounds function Base.view(s::AbstractDimStack, i::Union{AbstractArray{<:Integer},Colon,Integer})
    # Pretend the stack is an AbstractArray so `SubArray` accepts it.
    Base.view(OpaqueArray(s), i)
end

for f in (:getindex, :view, :dotview)
    _dim_f = Symbol(:_dim_, f)
    @eval begin
        @propagate_inbounds function Base.$f(s::AbstractDimStack, i)
            Base.$f(s, to_indices(CartesianIndices(s), Lookups._construct_types(i))...)
        end
        @propagate_inbounds function Base.$f(s::AbstractDimStack, i::AbstractArray{<:CartesianIndex})
            Base.$f(s, Base.$f(LinearIndices(s), i))
        end
        @propagate_inbounds function Base.$f(s::AbstractDimStack, i::Union{SelectorOrInterval,Extents.Extent})
            Base.$f(s, dims2indices(s, i)...)
        end
        @propagate_inbounds function Base.$f(s::AbstractVectorDimStack, i::Union{CartesianIndices,CartesianIndex})
            I = to_indices(CartesianIndices(s), (i,))
            Base.$f(s, I...)
        end
        @propagate_inbounds function Base.$f(s::AbstractDimStack, i::Union{CartesianIndices,CartesianIndex})
            I = to_indices(CartesianIndices(s), (i,))
            Base.$f(s, I...)
        end
        @propagate_inbounds function Base.$f(s::AbstractDimStack, i1, i2, Is...)
            I = to_indices(CartesianIndices(s), Lookups._construct_types(i1, i2, Is...))
            # Check we have the right number of dimensions
            if length(dims(s)) > length(I)
                throw(BoundsError(dims(s), I))
            elseif length(dims(s)) < length(I)
                # Allow trailing ones
                if all(i -> i isa Integer && i == 1, I[length(dims(s))+1:end])
                    I = I[1:length(dims(s))]
                else
                    throw(BoundsError(dims(s), I))
                end
            end
            # Convert to Dimension wrappers to handle mixed size layers
            Base.$f(s, map(rebuild, dims(s), I)...)
        end
        @propagate_inbounds function Base.$f(
            s::AbstractDimStack, D::DimensionalIndices...; kw...
        )
            $_dim_f(s, _simplify_dim_indices(D..., kw2dims(values(kw))...)...)
        end
        # Ambiguities
        @propagate_inbounds function Base.$f(s::DimensionalData.AbstractVectorDimStack, 
            i::Union{AbstractVector{<:DimensionalData.Dimensions.Dimension},
            AbstractVector{<:Tuple{DimensionalData.Dimensions.Dimension, Vararg{DimensionalData.Dimensions.Dimension}}}, 
            DimensionalData.DimIndices{T,1} where T, DimensionalData.DimSelectors{T,1} where T}
        )
            $_dim_f(s, _simplify_dim_indices(i)...)
        end


        @propagate_inbounds function $_dim_f(
            A::AbstractDimStack, a1::Union{Dimension,DimensionIndsArrays}, args::Union{Dimension,DimensionIndsArrays}...
        )
            return merge_and_index(Base.$f, A, (a1, args...))
        end
        # Handle zero-argument getindex, this will error unless all layers are zero dimensional
        @propagate_inbounds function $_dim_f(s::AbstractDimStack)
            map(Base.$f, data(s))
        end
        Base.@assume_effects :foldable @propagate_inbounds function $_dim_f(
            s::AbstractDimStack{K, NT}, d1::Dimension, ds::Dimension...
        ) where {K, NT <: NamedTuple{K, T}} where T
            D = (d1, ds...)
            extradims = otherdims(D, dims(s))
            length(extradims) > 0 && Dimensions._extradimswarn(extradims)
            function f(A) 
                layerdims = dims(D, dims(A))
                I = length(layerdims) > 0 ? layerdims : map(_ -> :, size(A))
                Base.$f(A, I...)
            end
            newlayers = unrolled_map(f, values(s))
            # Decide to rewrap as an AbstractDimStack, or return a scalar
            if newlayers isa T
                # All scalars, return as-is
                NamedTuple{K}(newlayers)
            else
                # TODO rethink this for many-layered stacks
                # Some scalars, re-wrap them as zero dimensional arrays
                non_scalar_layers = unrolled_map(values(s), newlayers) do l, nl
                    nl isa AbstractDimArray ? nl : rebuild(l, fill(nl), ())
                end
                rebuildsliced(Base.$f, s, NamedTuple{K}(non_scalar_layers), (dims2indices(dims(s), D)))
            end 
        end
    end
end

@generated function _any_dimarray(v::Union{NamedTuple,Tuple})
    any(T -> T <: AbstractDimArray, v.types)
end

#### setindex ####
@propagate_inbounds Base.setindex!(s::AbstractDimStack, xs, I...; kw...) =
    map((A, x) -> setindex!(A, x, I...; kw...), layers(s), xs)
@propagate_inbounds Base.setindex!(s::AbstractDimStack, xs::NamedTuple, i::Integer; kw...) =
    hassamedims(s) ? _map_setindex!(s, xs, i; kw...) : _setindex_mixed!(s, xs, i; kw...)
@propagate_inbounds Base.setindex!(s::AbstractDimStack, xs::NamedTuple, i::Colon; kw...) =
    hassamedims(s) ? _map_setindex!(s, xs, i; kw...) : _setindex_mixed!(s, xs, i; kw...)
@propagate_inbounds Base.setindex!(s::AbstractDimStack, xs::NamedTuple, i::AbstractArray; kw...) =
    hassamedims(s) ? _map_setindex!(s, xs, i; kw...) : _setindex_mixed!(s, xs, i; kw...)
@propagate_inbounds Base.setindex!(s::AbstractDimStack, xs::NamedTuple, i::DimensionIndsArrays; kw...) =
    _map_setindex!(s, xs, i; kw...)
@propagate_inbounds Base.setindex!(s::AbstractDimStack, xs::NamedTuple, I...; kw...) =
    _map_setindex!(s, xs, I...; kw...)

_map_setindex!(s, xs, i...; kw...) = map((A, x) -> setindex!(A, x, i...; kw...), layers(s), xs)

_setindex_mixed!(s::AbstractDimStack, x::NamedTuple, i::AbstractArray) =
    map(A -> setindex!(A, x, DimIndices(dims(s))[i]), layers(s))
_setindex_mixed!(s::AbstractDimStack, x::NamedTuple, i::Integer) =
    map(A -> setindex!(A, x, DimIndices(dims(s))[i]), layers(s))
function _setindex_mixed!(s::AbstractDimStack, x::NamedTuple, i::Colon)
    map(DimIndices(dims(s))) do D
        map(layers(s), x) do A, x
            A[D] = x
        end
    end
end

@noinline _keysmismatch(K1, K2) = throw(ArgumentError("NamedTuple keys $K2 do not mach stack keys $K1"))

# For @views macro to work with keywords
Base.maybeview(A::AbstractDimStack, args...; kw...) = view(A, args...; kw...)

function merge_and_index(f, s::AbstractDimStack, ds)
    ds, inds_arrays = _separate_dims_arrays(_simplify_dim_indices(ds...)...)
    # No arrays here, so abort (dispatch is tricky...)
    length(inds_arrays) == 0 && return f(s, ds...)
    inds = first(inds_arrays)

    V = length(ds) > 0 ? view(s, ds...) : s
    if !(length(dims(first(inds))) == length(dims(V)))
        throw(ArgumentError("When indexing an AbstractDimStack with an Array all dimensions must be used")) 
    end
    mdim = only(mergedims(dims(V),  dims(V)))
    newlayers = map(layers(V)) do l
        l1 = all(hasdim(l, dims(V))) ? l : DimExtensionArray(l, dims(V))
        view(l1, inds)
    end
    return rebuild_from_arrays(s, newlayers)
end

using DimensionalData
using Test

using OffsetArrays
using ImageFiltering
using ImageTransformations
using ArrayInterface
using StatsBase
using DiskArrays

using DimensionalData.Lookups

@testset "ArrayInterface" begin
    a = [1 2; 3 4]
    dimz = X(143.0:2.0:145.0), Y(-38.0:2.0:-36.0)
    da = DimArray(a, dimz)
    @test ArrayInterface.parent_type(typeof(da)) == Matrix{Int}
end

@testset "OffsetArray" begin
    a = [1 2 3 4
         3 4 5 6
         4 5 6 7]
    oa = OffsetArray(a, -1:1, 5:8)
    @testset "Regular dimensions don't work: axes must match" begin
        dimz = (X(100:100:300), Y([:a, :b, :c, :d]))
        @test_throws DimensionMismatch DimArray(oa, dimz)
    end
    odimz = (X(OffsetArray(100:100:300, -1:1)), Y(OffsetArray([:a, :b, :c, :d], 5:8)))
    oda = DimArray(oa, odimz)
    size(DimensionalData.LazyLabelledPrintMatrix(oda[Y=End]))
    size(oda[Y=End])
    @testset "Indexing and selectors work with offsets" begin
        @test axes(oda) == (-1:1, 5:8)
        @test oda[-1, 5] == oa[-1, 5] == 1
        @test oda[Near(105), At(:a)] == oa[-1, 5] == 1
        @test oda[At(200), At(:a)] == oa[0, 5] == 3
        @test oda[Between(100, 250), At(:a)] == oa[-1:0, 5] == [1, 3]
    end
    @testset "And when sampling is Regular" begin
        odimz_r = (X(OffsetArray(100:100:300, -1:1); span=Regular(100)), Y(OffsetArray([1.0, 2.0, 3.0, 4.0], 5:8); span=Regular(1)))
        oda_r = DimArray(oa, odimz_r)
        @test oda_r[At(100), At(1.0)] == oa[-1, 5] == 1
        @test oda_r[At(200), At(3.0)] == oa[0, 7] == 5
        @test oda_r[Between(100, 250), At(1)] == oa[-1:0, 5] == [1, 3]
    end
    @testset "Subsetting reverts to a regular array and dims" begin
        @test axes(oda[0:1, 7:8]) == (1:2, 1:2)
        @test axes.(dims(oda[0:1, 7:8])) == ((1:2,), (1:2,))
    end
    @testset "show" begin
        s = sprint(show, MIME("text/plain"), oda)
        s = sprint(show, MIME("text/plain"), oda; context=:displaysize=>(10, 10))
        s = sprint(show, MIME("text/plain"), oda; context=:displaysize=>(100, 100))
        @test occursin(":a", s)
    end
    @testset "3 dimensions" begin
        z = Z(OffsetArray('a':'j', -10:-1))
        oa3 = OffsetArray(zeros(10, 3, 4), -10:-1, -1:1, 5:8)
        oda3 = DimArray(oa3, (z, odimz...))
        s = sprint(show, MIME("text/plain"), oda3)
        @test occursin("'d'", s)
        @test occursin("'a'", s)
        @test occursin("'j'", s)
        s = sprint(show, MIME("text/plain"), oda3; context=:displaysize=>(15, 25))
        @test_broken !occursin("'d'", s) # Not sure what happened here?
    end
end

@testset "ImageFiltering and ImageTransformations" begin
    da = DimArray(randn(10, 10), (X, Y))

    # We are just testing that they actually run
    imfilter(da, Kernel.gaussian(1.0)) isa DimArray 
    # Array is a different size so the index is changed.
    # But we cant handle this without a dependency.
    # Maybe some tricks with ArrayInterface.jl can solve this.
    imresize(da, ratio=2) isa Matrix
    imresize(parent(dims(da, X)), ratio=2)
    imrotate(da, 0.3)
end

@testset "StatsBase" begin
    da = rand(X(1:10), Y(1:3))
    w = weights([0.3, 0.3, 0.4])
    @test mean(da, w; dims=Y) == mean(parent(da), w; dims=2)
    @test sum(da, w; dims=Y) == sum(parent(da), w; dims=2)
    w2 = weights(collect(1:10) * [0.3, 0.3, 0.4]')
    @test mean(da, w2; dims=:) == mean(da, w2) == mean(parent(da), w2; dims=:)
    @test sum(da, w2; dims=:) == sum(da, w2) == sum(parent(da), w2; dims=:)
end

@testset "DiskArrays" begin
    raw_data = rand(100, 100, 2)
    chunked_data = DiskArrays.TestTypes.ChunkedDiskArray(raw_data, (10, 10, 2))
    ds = (X(1.0:100), Y(collect(10:10:1000); span=Regular(10)), Z())
    da = DimArray(chunked_data, ds)
    st = DimStack((a = da, b = da))

    @testset "cache" begin
        @test parent(da) isa DiskArrays.TestTypes.ChunkedDiskArray
        @test DiskArrays.cache(da) isa DimArray
        @test parent(DiskArrays.cache(da)) isa DiskArrays.CachedDiskArray
        @test da == DiskArrays.cache(da)
    end
    @testset "chunks" begin
        @test DiskArrays.haschunks(da) == DiskArrays.haschunks(chunked_data)
        @test DiskArrays.eachchunk(da) == DiskArrays.eachchunk(chunked_data)
    end
    @testset "isdisk" begin
        @test DiskArrays.isdisk(da)
        @test !DiskArrays.isdisk(rand(X(5), Y(4)))
        @test DiskArrays.isdisk(st)
        @test !DiskArrays.isdisk(DimStack((a=rand(X(5), Y(4)), b=rand(X(5)))))
    end
    @testset "pad" begin
        p = DiskArrays.pad(da, (; X=(2, 3), Y=(40, 50)); fill=1.0)
        pst = DiskArrays.pad(st, (; X=(2, 3), Y=(40, 50)); fill=1.0)
        dims(p)
        @test size(p) == size(pst) == 
            map(length, dims(p)) == map(length, dims(pst)) == 
            size(da) .+ (5, 90, 0) == (105, 190, 2)
        @test dims(p) == dims(pst) == map(DimensionalData.format, (X(-1.0:103.0), Y(collect(-390:10:1500); span=Regular(10)), Z(NoLookup(Base.OneTo(2)))))
        @test sum(p) ≈ sum(da) + prod(size(p)) - prod(size(da))
        maplayers(pst) do A
            @test sum(A) ≈ sum(da) + prod(size(A)) - prod(size(da))
        end
    end
    @testset "PermutedDimsArray and PermutedDiskArray" begin
        @test parent(PermutedDimsArray(modify(Array, da), (3, 1, 2))) isa PermutedDimsArray
        @test parent(PermutedDimsArray(da, (3, 1, 2))) isa DiskArrays.PermutedDiskArray
    end

    @testset "mockchunks" begin
        damockchunked = DiskArrays.mockchunks(da, DiskArrays.GridChunks(da, (20,20)))
        @test size(DiskArrays.eachchunk(damockchunked)) == (5,5)
    end
end

# Interfaces.jl interface

function rebuild_all(A::AbstractDimArray)
    # argument version
    A1 = rebuild(A, parent(A), dims(A), refdims(A), name(A), metadata(A))
    # keyword version, will work magically using ConstructionBase.jl if you use the same fieldnames.
    # If not, define it and remap these names to your fields.
    A2 = rebuild(A; data=parent(A), dims=dims(A), refdims=refdims(A), name=name(A), metadata=metadata(A))
    # all should be identical. If any fields are not used, they will always be `nothing` or `()` for `refdims`
    return parent(A) === parent(A1) === parent(A2) &&
        dims(A) === dims(A1) === dims(A2) &&
        refdims(A) === refdims(A1) === refdims(A2) &&
        metadata(A) === metadata(A1) === metadata(A2) &&
        name(A) === name(A1) === name(A2)
end

function rebuild_all(A::AbstractDimStack)
    # argument version
    A1 = rebuild(A, parent(A), dims(A), refdims(A), layerdims(A), metadata(A), layermetadata(A))
    # keyword version, will work magically using ConstructionBase.jl if you use the same fieldnames.
    # If not, define it and remap these names to your fields.
    A2 = rebuild(A; data=parent(A), dims=dims(A), refdims=refdims(A), metadata=metadata(A))
    # all should be identical. If any fields are not used, they will always be `nothing` or `()` for `refdims`
    return parent(A) === parent(A1) === parent(A2) &&
        dims(A) === dims(A1) === dims(A2) &&
        refdims(A) === refdims(A1) === refdims(A2) &&
        metadata(A) === metadata(A1) === metadata(A2)
end

array_tests = (;
    mandatory = (
        dims = (
            "defines a `dims` method" => A -> dims(A) isa Tuple{Vararg{Dimension}},
            "dims are updated on getindex" => A -> dims(view(A, rebuild(first(dims(A)), 1))) == Base.tail(dims(A)),
        ),
        refdims_base = "`refdims` returns a tuple of Dimension or empty" => 
            A -> refdims(A) isa Tuple{Vararg{Dimension}},
        ndims = "number of dims matches dimensions of array" => 
            A -> length(dims(A)) == ndims(A),
        size = "length of dims matches dimensions of array" => 
            A -> map(length, dims(A)) == size(A),
        rebuild_parent = "rebuild parent from args" =>
            A -> parent(rebuild(A, reverse(A; dims=1))) == reverse(A; dims=1),
        rebuild_dims = "rebuild paaarnet and dims from args" =>
            A -> dims(rebuild(A, parent(A), map(reverse, dims(A)))) == map(reverse, dims(A)),
        rebuild_parent_kw = "rebuild parent from args" =>
            A -> parent(rebuild(A; data=reverse(A; dims=1))) == reverse(A; dims=1),
        rebuild_dims_kw = "rebuild dims from args" =>
            A -> dims(rebuild(A; dims=map(reverse, dims(A)))) == map(reverse, dims(A)),
        rebuild="all rebuild arguments and keywords are accepted" => rebuild_all,
    ),
    optional = (;
        refdims = (
            "refdims are updated in args rebuild" =>
              A -> refdims(rebuild(A, parent(A), dims(A), refdims(A))) == refdims(A),
            "refdims are updated in kw rebuild" =>
              A -> refdims(rebuild(A; refdims=refdims(A))) == refdims(A),
            "dropped dimensions are added to refdims" =>
                  A -> refdims(view(A, rebuild(first(dims(A)), 1))) isa Tuple{<:Dimension},
        ),
        name = (
            "rebuild updates name in arg rebuild" =>
                A -> DD.name(rebuild(A, parent(A), DD.dims(A), DD.refdims(A), DD.name(A))) === DD.name(A),
            "rebuild updates name in kw rebuild" =>
                A -> DD.name(rebuild(A; name=DD.name(A))) === DD.name(A),
        ),
        metadata = (
            "rebuild updates metadata in arg rebuild" =>
                A -> metadata(rebuild(A, parent(A), DD.dims(A), refdims(A), name(A), metadata(A))) === metadata(A),
            "rebuild updates metadata in kw rebuild" =>
                A -> metadata(rebuild(A; metadata=metadata(A))) === metadata(A),
        )
    )
)

stack_tests = (;
    mandatory = (
        dims = (
            "defines a `dims` method" => A -> dims(A) isa Tuple{Vararg{Dimension}},
            "dims are updated on getindex" => A -> dims(view(A, rebuild(first(dims(A)), 1))) == Base.tail(dims(A)),
        ),
        refdims_base = "`refdims` returns a tuple of Dimension or empty" =>
            A -> refdims(A) isa Tuple{Vararg{Dimension}},
        ndims = "number of dims matches ndims of stack" =>
            A -> length(dims(A)) == ndims(A),
        size = "length of dims matches size of stack" =>
            A -> map(length, dims(A)) == size(A),
        rebuild_parent = "rebuild parent from args" =>
            A -> parent(rebuild(A, map(a -> reverse(a; dims=1), parent(A)))) == map(a -> reverse(a; dims=1), parent(A)),
        rebuild_dims = "rebuild paaarnet and dims from args" =>
            A -> dims(rebuild(A, parent(A), map(reverse, dims(A)))) == map(reverse, dims(A)),
        rebuild_layerdims = "rebuild paaarnet and dims from args" =>
            A -> layerdims(rebuild(A, parent(A), dims(A), refdims(A), layerdims(A))) == layerdims(A),
        rebuild_dims_kw = "rebuild dims from args" =>
            A -> dims(rebuild(A; dims=map(reverse, dims(A)))) == map(reverse, dims(A)),
        rebuild_parent_kw = "rebuild parent from args" =>
            A -> parent(rebuild(A; data=map(a -> reverse(a; dims=1), parent(A)))) == map(a -> reverse(a; dims=1), parent(A)),
        rebuild_layerdims_kw = "rebuild parent from args" =>
            A -> layerdims(rebuild(A; layerdims=map(reverse, layerdims(A)))) == map(reverse, layerdims(A)),
        rebuild="all rebuild arguments and keywords are accepted" => rebuild_all,
    ),
    optional = (;
        refdims = (
            "refdims are updated in args rebuild" =>
              A -> refdims(rebuild(A, parent(A), dims(A), refdims(A))) == refdims(A),
            "refdims are updated in kw rebuild" =>
              A -> refdims(rebuild(A; refdims=refdims(A))) == refdims(A),
            "dropped dimensions are added to refdims" =>
                  A -> refdims(view(A, rebuild(first(dims(A)), 1))) isa Tuple{<:Dimension},
        ),
        metadata = (
            "rebuild updates metadata in arg rebuild" =>
                A -> metadata(rebuild(A, parent(A), DD.dims(A), refdims(A), layerdims(A), metadata(A))) === metadata(A),
            "rebuild updates metadata in kw rebuild" =>
                A -> metadata(rebuild(A; metadata=metadata(A))) === metadata(A),
        )
    )
)


const array_docs = """
This is an early stage of inteface definition, many things are not yet tested.

Pass constructed AbstractDimArrays as test data.

They must not be zero dimensional, and should test at least 1, 2, and 3 dimensions.
"""

const stack_docs = """
This is an early stage of inteface definition, many things are not yet tested.

Pass constructed AbstractDimArrays as test data.

They must not be zero dimensional, and should test at least 1, 2, and 3 dimensions.
"""

Interfaces.@interface DimArrayInterface AbstractDimArray array_tests array_docs
Interfaces.@interface DimStackInterface AbstractDimStack stack_tests stack_docs


# Interfaces.jl implementations

Interfaces.@implements DimArrayInterface{(:refdims,:name,:metadata)} DimArray [rand(X(10), Y(10)), zeros(Z(10))]
Interfaces.@implements DimStackInterface{(:refdims,:metadata)} DimStack [DimStack(zeros(Z(10))), DimStack(rand(X(10), Y(10))), DimStack(rand(X(10), Y(10)), rand(X(10)))]

using DimensionalData, Test

using DimensionalData: Name, NoName

@testset "Name" begin
    @test Name(:x) === Name{:x}()
    @test Symbol(Name(:x)) === :x
    @test string(Name(:x)) === "x"
    @test Name(Name(:x)) === Name(:x)
end

@testset "NoName" begin
    @test Symbol(NoName()) === Symbol("")
    @test string(NoName()) === ""
    @test Name(NoName()) === NoName()
end

using DimensionalData, Test, SparseArrays, LinearAlgebra
using DimensionalData: AbstractDimArray

@testset "SparseArrays Extension" begin
    # Test data setup
    dims2d = (X(1:4), Y(1:3))
    dims1d = (X(1:5),)
    
    @testset "copyto! from CHOLMOD.Dense to DimArray" begin
        # Create test data for CHOLMOD.Dense types
        src_float64 = SparseArrays.CHOLMOD.Dense(rand(Float64, 4, 3))
        src_complexf64 = SparseArrays.CHOLMOD.Dense(rand(ComplexF64, 4, 3))
        src_other = SparseArrays.CHOLMOD.Dense(rand(Float32, 4, 3))
        
        # Test 2D DimArray with Float64
        dst2d_f64 = DimArray(zeros(Float64, 4, 3), dims2d)
        result = copyto!(dst2d_f64, src_float64)
        @test result === dst2d_f64
        @test parent(dst2d_f64) == src_float64
        @test dims(dst2d_f64) == dims2d
        
        # Test 2D DimArray with ComplexF64
        dst2d_cf64 = DimArray(zeros(ComplexF64, 4, 3), dims2d)
        result = copyto!(dst2d_cf64, src_complexf64)
        @test result === dst2d_cf64
        @test parent(dst2d_cf64) == src_complexf64
        @test dims(dst2d_cf64) == dims2d
        
        # Test generic DimArray (any type, any dimensions)
        # TODO: this hits what looks like a julia bug in cholmod.jl `copyto!`? 
        # dst_generic = DimArray(zeros(Float32, 4, 3), dims2d)
        # result = copyto!(dst_generic, src_other)
        # @test result === dst_generic
        # @test parent(dst_generic) == src_other
        # @test dims(dst_generic) == dims2d
        
        # Test 1D DimArray with Float64
        # Note: CHOLMOD.Dense always creates 2D arrays, so we need to compare with vec()
        src_1d_f64 = SparseArrays.CHOLMOD.Dense(rand(Float64, 5))
        dst1d_f64 = DimArray(zeros(Float64, 5), dims1d)
        result = copyto!(dst1d_f64, src_1d_f64)
        @test result === dst1d_f64
        @test parent(dst1d_f64) == vec(src_1d_f64)
        @test dims(dst1d_f64) == dims1d
    end
    
    @testset "copyto! from DimArray to SparseArrays.AbstractCompressedVector" begin
        src_da = DimArray(rand(Float64, 5), dims1d)
        dst_sparse = spzeros(Float64, 5)
        
        result = copyto!(dst_sparse, src_da)
        @test result === dst_sparse
        @test dst_sparse == parent(src_da)
    end
    
    @testset "copyto! from SparseArrays.AbstractSparseMatrixCSC to DimArray" begin
        src_sparse = sprand(Float64, 4, 3, 0.5)
        dst_da = DimArray(zeros(Float64, 4, 3), dims2d)
        
        result = copyto!(dst_da, src_sparse)
        @test result === dst_da
        @test parent(dst_da) == src_sparse
        @test dims(dst_da) == dims2d
    end
    
    @testset "copyto! with CartesianIndices" begin
        src_sparse = sprand(Float64, 2, 2, 0.8)
        dst_da = DimArray(zeros(Float64, 4, 3), dims2d)
        
        # Copy to a subset of the destination
        dst_indices = CartesianIndices((1:2, 1:2))
        src_indices = CartesianIndices((1:2, 1:2))
        
        result = copyto!(dst_da, dst_indices, src_sparse, src_indices)
        @test result === dst_da
        @test parent(dst_da)[1:2, 1:2] == src_sparse[1:2, 1:2]
        @test dims(dst_da) == dims2d
    end
    
    @testset "copy! from DimArray to SparseArrays.AbstractCompressedVector" begin
        src_da = DimArray(rand(Float64, 5), dims1d)
        dst_compressed = spzeros(Float64, 5)
        
        result = copy!(dst_compressed, src_da)
        @test result === dst_compressed
        @test dst_compressed == parent(src_da)
    end
    
    @testset "copy! from DimArray to SparseArrays.SparseVector" begin
        src_da = DimArray(rand(Float64, 5), dims1d)
        dst_sparse_vec = spzeros(Float64, 5)
        
        result = copy!(dst_sparse_vec, src_da)
        @test result === dst_sparse_vec
        @test dst_sparse_vec == parent(src_da)
    end
    
    @testset "Integration with existing copyto! functionality" begin
        # Ensure that the SparseArrays extension doesn't break existing copyto! functionality
        da1 = DimArray(rand(4, 3), dims2d)
        da2 = DimArray(zeros(4, 3), dims2d)
        
        result = copyto!(da2, da1)
        @test result === da2
        @test parent(da2) == parent(da1)
        @test dims(da2) == dims2d
    end
end

module DimensionalDataAdaptExt

using DimensionalData
using DimensionalData.Dimensions
using DimensionalData.Lookups
import Adapt

const DD = DimensionalData

# Metadata nearly always contains strings, which break GPU compat.
# For now just remove everything, but we could strip all strings
# and replace Dict with NamedTuple.
# This might also be a problem with non-GPU uses of Adapt.jl where keeping
# the metadata is fine.
Adapt.adapt_structure(to, m::Metadata) = NoMetadata()

# Span types
Adapt.adapt_structure(to, s::Span) = s
Adapt.adapt_structure(to, s::Explicit) = Explicit(Adapt.adapt_structure(to, val(s)))

# Lookup types
function Adapt.adapt_structure(to, l::Lookup)
    rebuild(l; data=Adapt.adapt(to, parent(l)))
end

function Adapt.adapt_structure(to, l::AbstractSampled)
    rebuild(l; data=Adapt.adapt(to, parent(l)), metadata=NoMetadata(), span=Adapt.adapt(to, span(l)))
end

function Adapt.adapt_structure(to, l::AbstractCategorical)
    rebuild(l; data=Adapt.adapt(to, parent(l)), metadata=NoMetadata())
end

# Dimension types
Adapt.adapt_structure(to, dim::Dimension) = rebuild(dim; val=Adapt.adapt(to, val(dim)))

# DimArray
function Adapt.adapt_structure(to, A::DD.AbstractDimArray)
    rebuild(A,
        data=Adapt.adapt(to, parent(A)),
        dims=Adapt.adapt(to, dims(A)),
        refdims=Adapt.adapt(to, refdims(A)),
        name=DD.Name(name(A)),
        metadata=Adapt.adapt(to, metadata(A)),
    )
end

# DimStack
Adapt.adapt_structure(to, s::DD.AbstractDimStack) = DD.maplayers(A -> Adapt.adapt(to, A), s)

end # module

"""
    Dimensions

Sub-module for [`Dimension`](@ref)s wrappers,
and operations on them used in DimensionalData.jl.

To load `Dimensions` types and methods into scope:

```julia
using DimensionalData
using DimensionalData.Dimensions
```
"""
module Dimensions

import ConstructionBase, Extents, IntervalSets
using Dates 

include("../Lookups/Lookups.jl")

using .Lookups

import .Lookups: rebuild, order, span, sampling, locus, val, set, _set,
    metadata, bounds, intervalbounds, units, basetypeof, unwrap, selectindices, hasselection, hasinternaldimensions,
    shiftlocus, maybeshiftlocus, ordered_first, ordered_last, ordered_firstindex, ordered_lastindex, 
    promote_first, _remove
using .Lookups: StandardIndices, SelTuple, CategoricalEltypes,
    LookupTrait, AllMetadata, LookupSetters, AbstractBeginEndRange,
    SelectorOrInterval, Interval, Begin, End, LazyMath
import .Lookups: Safety, Safe, Unsafe

using Base: tail, OneTo, @propagate_inbounds

export name, label, dimnum, hasdim, hasselection, otherdims, commondims, combinedims,
    setdims, swapdims, sortdims, lookup, set, format, rebuild, name2dim,
    basetypeof, basedims, dims2indices, slicedims, dimsmatch, comparedims, reducedims

export Dimension, IndependentDim, DependentDim, XDim, YDim, ZDim, TimeDim,
    X, Y, Z, Ti, Dim, AnonDim, Coord, MergedLookup, AutoVal

export @dim

include("dimension.jl")
include("predicates.jl")
include("dimunitrange.jl")
include("primitives.jl")
include("format.jl")
include("indexing.jl")
include("set.jl")
include("show.jl")
include("merged.jl")

end

using DimensionalData, Test , Unitful, SparseArrays, Dates, Random
using DimensionalData: layerdims, checkdims
using LinearAlgebra

using DimensionalData.Lookups, DimensionalData.Dimensions

a = [1 2; 3 4]
a2 = [1 2 3 4
      3 4 5 6
      4 5 6 7]
xmeta = Metadata(:meta => "X")
ymeta = Metadata(:meta => "Y")
tmeta = Metadata(:meta => "T")
ameta = Metadata(:meta => "da")
dimz = (X(Sampled(143.0:2.0:145.0; order=ForwardOrdered(), metadata=xmeta)),
        Y(Sampled(-38.0:2.0:-36.0; order=ForwardOrdered(), metadata=ymeta)))
dimz2 = (Dim{:row}(10:10:30), Dim{:column}(-20:10:10))

refdimz = (Ti(1:1; metadata=tmeta),)
da = @test_nowarn DimArray(a, dimz; refdims=refdimz, name=:test, metadata=ameta)
val(dims(da, 1)) |> typeof
da2 = DimArray(a2, dimz2; refdims=refdimz, name=:test2)

@testset "checkbounds" begin
    @test @inferred checkbounds(Bool, da, X(2), Y(1)) == true
    @test @inferred checkbounds(Bool, da, X(10), Y(1)) == false
    checkbounds(da, X(2), Y(1))
    @test_throws BoundsError checkbounds(da, X(10), Y(20))
    @test_throws BoundsError checkbounds(da, X(1:10), Y(2:20))
end

@testset "checkdims" begin
    @test checkdims(da2, dimz2)
    @test checkdims(typeof(da2), dimz2)
    @test checkdims(2, dimz2)
    @test_throws ArgumentError checkdims(3, dimz2)
end

@testset "rebuild" begin
    @test @inferred rebuild(da2, parent(da2)) === da2
    @test @inferred rebuild(da2; dims=dims(da2)) === da2
    @test_throws ArgumentError rebuild(da2; dims=dims(da2, (Y,))) === da2
end

@testset "size and axes" begin
    row_dims = (1, Dim{:row}(), Dim{:row}, :row, dimz2[1])
    for dim in row_dims
        @test size(da2, dim) == 3
        @test axes(da2, dim) == 1:3
        @test axes(da2, dim) isa Dimensions.DimUnitRange
        @test dims(axes(da2, dim)) === dims(da2, dim)
        @test firstindex(da2, dim) == 1
        @test lastindex(da2, dim) == 3
    end
    @test size(da2, :column) == 4
    @test axes(da2, :column) == 1:4
    @test axes(da2, :column) isa Dimensions.DimUnitRange
    @test dims(axes(da2, :column)) === dims(da2, :column)
    @test size(da2) == (3, 4)
    @test axes(da2) == (1:3, 1:4)
    @test axes(da2) isa Tuple{Dimensions.DimUnitRange, Dimensions.DimUnitRange}
    @test firstindex(da2) == 1
    @test lastindex(da2) == 12
    @inferred axes(da2, Dim{:column})
    @test IndexStyle(da) == IndexLinear()
end

@testset "Pointer conversion" begin
    x = rand(X(10))
    @test Base.unsafe_convert(Ptr{Float64}, x) == pointer(parent(x)) == pointer(x)
    @test strides(x) == (1,)
end

@testset "interface methods" begin
    lx = Sampled(143.0:2.0:145.0, ForwardOrdered(), Regular(2.0), Points(), xmeta) 
    ly = Sampled(-38.0:2.0:-36.0, ForwardOrdered(), Regular(2.0), Points(), ymeta)
    @test dims(da) == (X(lx), Y(ly))
    @test dims(da, X) == X(lx)
    @test refdims(da) == refdimz
    @test name(da) == :test
    @test metadata(da) == ameta
    @test lookup(da) == (lx, ly)
    @test order(da) == (ForwardOrdered(), ForwardOrdered())
    @test sampling(da) == (Points(), Points())
    @test span(da) == (Regular(2.0), Regular(2.0))
    @test locus(da) == (Center(), Center())
    @test bounds(da) == ((143.0, 145.0), (-38.0, -36.0))
    @test layerdims(da) == (X(), Y())
    @test parent(lookup(da, Y)) === -38.0:2:-36.0
    @test_broken @inferred set(da, X => Intervals(), Y => Intervals())
    da_intervals = set(da, X => Intervals(), Y => Intervals())
    @test intervalbounds(da_intervals) == ([(142.0, 144.0), (144.0, 146.0)], [(-39.0, -37.0), (-37.0, -35.0)])
end

@testset "copy and friends" begin
    dac = @inferred copy(da2)
    @test dac == da2
    @test dims(dac) == dims(da2)
    @test refdims(dac) == refdims(da2) == (Ti(1:1),)
    @test name(dac) == name(da2) == :test2
    @test metadata(dac) == metadata(da2)
    dadc = deepcopy(da2)
    @test dadc == da2
    @test dims(dadc) == dims(da2)
    @test refdims(dadc) == refdims(da2) == (Ti(1:1),)
    @test name(dadc) == name(da2) == :test2
    @test metadata(dadc) == metadata(da2)

    o = one(da)
    @test o == [1 0; 0 1]
    @test dims(o) == dims(da) 

    ou = oneunit(da)
    @test ou == [1 0; 0 1]
    @test dims(ou) == dims(da) 

    z = zero(da)
    @test z == [0 0; 0 0]
    @test dims(z) == dims(da) 

    @test Array(da) == [1 2; 3 4]
    @test Array(da) isa Array{Int,2}
    @test collect(da) == [1 2; 3 4]
    @test collect(da) isa Array{Int,2}
    @test vec(da) == [1, 3, 2, 4]
    @test vec(da) isa Array{Int,1}

    # This should do nothing
    A = read(da2)
    @test A === da2
end

@testset "similar" begin
    @testset "similar with no args" begin
        da_sim = similar(da)
        @test parent(da_sim) !== parent(da) # check if the same memory
        @test eltype(da_sim) == eltype(da)
        @test size(da_sim) == size(da)
        @test dims(da_sim) === dims(da)
        @test refdims(da_sim) === refdims(da)
        @test metadata(da_sim) === metadata(da)
    end

    @testset "similar with keywords" begin
        for x in (da, DimPoints(da))
            md = Dict(:new_meta => "b")
            rd = (format(Ti(1:1)),)
            da_named = similar(x; name=:new_name, metadata=md, refdims=rd)
            @test name(da_named) === :new_name
            @test metadata(da_named) === md
            @test refdims(da_named) === rd
            da_float_named = similar(x, Float64; name=:new_name, metadata=md, refdims=rd)
            @test eltype(da_float_named) === Float64
            @test name(da_float_named) === :new_name
            @test metadata(da_float_named) === md
            @test refdims(da_float_named) === rd
        end
    end

    @testset "similar with a type" begin
        da_float = @inferred similar(da, Float64)
        @test parent(da_float) !== parent(da) # check if the same memory
        @test eltype(da_float) == Float64
        @test size(da_float) == size(da)
        @test dims(da_float) === dims(da)
        @test refdims(da_float) === refdims(da)
        @test metadata(da_float) === metadata(da)
    end

    @testset "similar with a size" begin
        # Changing the axis size removes dims.
        # TODO we can keep dims, but with NoLookup?
        da_size = @inferred similar(da2, (5, 5))
        @test eltype(da_size) == Int
        @test size(da_size) == (5, 5)
        da_size_splat = similar(da2, 5, 5)
        @test eltype(da_size_splat) == Int
        @test size(da_size_splat) == (5, 5)
        da_size_float = similar(da2, Float64, (10, 10))
        @test eltype(da_size_float) == Float64
        @test size(da_size_float) == (10, 10)
        @test typeof(da_size_float) <: Array{Float64,2}
        da_size_float_splat = similar(da2, Float64, 10, 10)
        @test size(da_size_float_splat) == (10, 10)
        @test typeof(da_size_float_splat)  <: Array{Float64,2}
    end

    @testset "similar with sparse arrays" begin
        # Test that SparseArrays extension is properly loaded
        if !hasmethod(copyto!, (DimArray{Float64,2}, SparseArrays.AbstractSparseMatrixCSC{Float64}))
            @warn "SparseArrays extension not loaded, skipping related tests"
            return
        end
        
        sda = @inferred DimArray(sprand(Float64, 10, 10, 0.5), (X(), Y()))
        sparse_size_int = similar(sda, Int64, (5, 5))
        @test eltype(sparse_size_int) == Int64 != eltype(sda)
        @test size(sparse_size_int) == (5, 5)
        @test sparse_size_int isa SparseMatrixCSC
        
        # Test that basic copyto! works with sparse arrays
        dst = DimArray(zeros(Float64, 10, 10), (X(1:10), Y(1:10)))
        result = copyto!(dst, parent(sda))
        @test result === dst
        @test parent(dst) == parent(sda)
    end

    @testset "similar with dims" begin
        da_sim_dims = @inferred similar(da, dims(da))
        da_sim_dims_splat = @inferred similar(da, dims(da)...)
        for A in (da_sim_dims, da_sim_dims_splat)
            @test eltype(A) == eltype(da)
            @test size(A) == size(da)
            @test dims(A) === dims(da)
            @test refdims(A) == ()
        end
        da_sim_type_dims = @inferred similar(da2, Bool, dims(da))
        da_sim_type_dims_splat = @inferred similar(da2, Bool, dims(da)...)
        for A in (da_sim_type_dims, da_sim_type_dims_splat)
            @test eltype(A) == Bool
            @test size(A) == size(da)
            @test dims(A) === dims(da)
            @test refdims(A) == ()
            @test metadata(A) == NoMetadata()
        end
    end

    @testset "similar with DimArray and its axes" begin
        da_all = similar(da, Bool, axes(da))
        @test eltype(da_all) === Bool
        @test size(da_all) == size(da)
        @test dims(da_all) === dims(da)
        @test refdims(da_all) == ()
        @test metadata(da_all) == metadata(da)

        da_first = similar(da, Missing, (axes(da, 1),))   
        @test eltype(da_first) === Missing
        @test size(da_first) == (size(da, 1),)
        @test dims(da_first) === (dims(da, 1),)
        @test refdims(da_first) == ()
        @test metadata(da_first) == metadata(da)

        da_last = similar(da, Nothing, (axes(da, 2),))
        @test eltype(da_last) === Nothing
        @test size(da_last) == (size(da, 2),)
        @test dims(da_last) === (dims(da, 2),)
        @test refdims(da_last) == ()
        @test metadata(da_last) == metadata(da)
    end

    @testset "similar with DimArray and new axes" begin
        ax = Dimensions.DimUnitRange(Base.OneTo(2), Dim{:foo}([:a, :b]))
        da_sim = similar(da, ax)
        @test eltype(da_sim) === eltype(da)
        @test size(da_sim) == (2,)
        @test dims(da_sim) == (dims(ax),)
        @test refdims(da_sim) == ()
        @test metadata(da_sim) == metadata(da)
    end

    @testset "similar with AbstractArray and DimUnitRange" begin
        da_sim = @inferred similar(trues(2), axes(da))
        @test da_sim isa DimArray{Bool,2}
        @test size(da_sim) == size(da)
        @test parent(da_sim) isa BitMatrix
        @test dims(da_sim) == dims(da)

        da_sim2 = @inferred similar(trues(2), Float64, axes(da))
        @test da_sim2 isa DimArray{Float64,2}
        @test size(da_sim2) == size(da)
        @test dims(da_sim2) == dims(da)
    end

    @testset "similar with AbstractArray type and DimUnitRange" begin
        da_sim = similar(BitArray, axes(da))
        @test da_sim isa DimArray{Bool,2}
        @test size(da_sim) == size(da)
        @test parent(da_sim) isa BitMatrix
        @test dims(da_sim) == dims(da)
    end

    @testset "similar with mixed DimUnitRange and Base.OneTo" begin
        x = randn(10)
        T = ComplexF64
        ax1 = Base.OneTo(2)
        ax1 = axes(X(1:2), 1)
        ax2 = Base.OneTo(2)
        ax2 = axes(X(1:2), 1)
        for ax1 in (Base.OneTo(2), axes(X(1:2), 1))
            s11 = @inferred(similar(x, (ax1,)))
            s12 = @inferred(similar(x, T, (ax1,)))
            s13 = @inferred(similar(BitArray, (ax1,)))
            if ax1 isa Base.OneTo
                @test s11 isa Vector{Float64}
                @test s12 isa Vector{T}
                @test s13 isa BitVector
                @test size(s11) == size(s12) == size(s13) == (length(ax1),)
            else
                @test s11 isa DimArray{Float64,1}
                @test s12 isa DimArray{T,1}
                @test s13 isa DimArray{Bool,1}
                @test parent(s13) isa BitVector
                @test dims(s11) == dims(s12) == dims(s13) == (dims(ax1),)
            end
            for ax2 in (Base.OneTo(3), axes(Y(1:3), 1))
                s21 = @inferred(similar(x, (ax1, ax2)))
                s22 = @inferred(similar(x, T, (ax1, ax2)))
                s23 = @inferred(similar(BitArray, (ax1, ax2)))
                if ax1 isa Base.OneTo || ax2 isa Base.OneTo
                    @test s21 isa Matrix{Float64}
                    @test s22 isa Matrix{T}
                    @test s23 isa BitMatrix
                    @test size(s21) == size(s22) == size(s23) == (length(ax1), length(ax2))
                else
                    @test s21 isa DimArray{Float64,2}
                    @test s22 isa DimArray{T,2}
                    @test s23 isa DimArray{Bool,2}
                    @test parent(s23) isa BitMatrix
                    @test dims(s21) == dims(s22) == dims(s23) == (dims(ax1), dims(ax2))
                end
                for ax3 in (Base.OneTo(4), axes(Z(1:4), 1))
                    s31 = @inferred(similar(x, (ax1, ax2, ax3)))
                    s32 = @inferred(similar(x, T, (ax1, ax2, ax3)))
                    s33 = @inferred(similar(BitArray, (ax1, ax2, ax3)))
                    if ax1 isa Base.OneTo || ax2 isa Base.OneTo || ax3 isa Base.OneTo
                        @test s31 isa Array{Float64,3}
                        @test s32 isa Array{T,3}
                        @test s33 isa BitArray{3}
                        @test size(s31) == size(s32) == size(s33) == map(length, (ax1, ax2, ax3))
                    else
                        @test s31 isa DimArray{Float64,3}
                        @test s32 isa DimArray{T,3}
                        @test s33 isa DimArray{Bool,3}
                        @test parent(s33) isa BitArray{3}
                        @test dims(s31) == dims(s32) == dims(s33) == map(dims, (ax1, ax2, ax3))
                    end
                    for ax4 in (Base.OneTo(5), axes(Ti(1:5), 1))
                        s41 = @inferred(similar(x, (ax1, ax2, ax3, ax4)))
                        s42 = @inferred(similar(x, T, (ax1, ax2, ax3, ax4)))
                        s43 = @inferred(similar(BitArray, (ax1, ax2, ax3, ax4)))
                        if ax1 isa Base.OneTo || ax2 isa Base.OneTo || ax3 isa Base.OneTo || ax4 isa Base.OneTo
                            @test s41 isa Array{Float64,4}
                            @test s42 isa Array{T,4}
                            @test s43 isa BitArray{4}
                            @test size(s41) == size(s42) == size(s43) == map(length, (ax1, ax2, ax3, ax4))
                        else
                            @test s41 isa DimArray{Float64,4}
                            @test s42 isa DimArray{T,4}
                            @test s43 isa DimArray{Bool,4}
                            @test parent(s43) isa BitArray{4}
                            @test dims(s41) == dims(s42) == dims(s43) == map(dims, (ax1, ax2, ax3, ax4))
                        end
                    end
                end
            end
        end
    end
end

@testset "replace" begin
    dar = replace(da, 1 => 99) 
    dar isa DimArray
    @test dar == [99 2; 3 4]

    dar = copy(da)
    replace!(dar, 4 => 99)
    @test dar == [1 2; 3 99]
end

@testset "broadcast" begin
    da = DimArray(ones(Int, 5, 2, 4), (Y(10:2:18), Ti(10:11), X(1:4)))
    dab = da .* 2.0
    @test dab == fill(2.0, 5, 2, 4)
    @test eltype(dab) <: Float64
    @test dims(dab) ==
        (Y(Sampled(10:2:18, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
         Ti(Sampled(10:11, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
         X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())))
    dab = da .+ fill(10, 5, 2, 4)
    @test dab == fill(11, 5, 2, 4)
    @test eltype(dab) <: Int
end

@testset "eachindex" begin
    # Should have linear index
    da = DimArray(ones(5, 2, 4), (Y(10:2:18), Ti(10:11), X(1:4)))
    @test eachindex(da) == eachindex(parent(da))
    @test eachindex(da[:, 1, 1]) == eachindex(parent(da)[:, 1, 1])
    @test eachindex(da[:, 1, 1]) isa Dimensions.DimUnitRange
    @test dims(eachindex(da[:, 1, 1])) == dims(da,1)
    # Should have cartesian index
    sda = DimArray(sprand(10, 10, .1), (Y(1:10), X(1:10)))
    @test eachindex(sda) == eachindex(parent(sda))
end

@testset "convert" begin
    # To Array
    ac = convert(Array, da2)
    @test ac isa Array{Int,2}
    @test ac == a2
    # To DimArray
    @test all(convert(DimArray{Float32}, da) .=== Float32.(da))
    @test convert(DimArray{eltype(da)}, da) === convert(DimArray, da) === da
end

@testset "copy!" begin
    dimz = dims(da2)
    A = zero(a2)
    sp = sprand(Int, 4, 0.5)
    db = DimArray(deepcopy(A), dimz)
    dc = DimArray(deepcopy(A), dimz)

    @test copy!(A, da2) isa Matrix
    @test A == parent(da2)
    @test copy!(db, da2) isa DimMatrix
    @test parent(db) == parent(da2)
    @test copy!(dc, a2) isa DimMatrix
    @test parent(db) == a2
    # Sparse vector has its own method for ambiguity
    copy!(sp, da2[1, :])
    @test sp == parent(da2[1, :])

    @testset "vector copy! (ambiguity fix)" begin
        v = zeros(3)
        dv = DimArray(zeros(3), X)
        @test copy!(v, DimArray([1.0, 2.0, 3.0], X)) isa Vector
        @test v == [1.0, 2.0, 3.0]
        @test copy!(dv, DimArray([9.9, 9.9, 9.9], X)) isa DimVector
        @test dv == [9.9, 9.9, 9.9]
        @test copy!(dv, [5.0, 5.0, 5.0]) isa DimVector
        @test dv == [5.0, 5.0, 5.0]
    end
end

@testset "copyto!" begin
    A = zero(a2)
    da = DimArray(ones(size(A)), dims(da2))
    @test copyto!(A, da) isa Matrix
    @test all(A .== 1)
    @test copyto!(da, 1, zeros(5, 5), 1, 12) isa DimMatrix
    @test all(da .== 0)
    x = reshape(10:10:40, 1, 4)
    @test copyto!(da, CartesianIndices(view(da, 1:1, 1:4)), x, CartesianIndices(x)) isa DimMatrix
    @test da[1, 1:4] == 10:10:40
    @test copyto!(A, CartesianIndices(view(da, 1:1, 1:4)), DimArray(x, (X, Y)), CartesianIndices(x)) isa Matrix
    @test A[1, 1:4] == 10:10:40
    @test copyto!(A, 10, da, 10) isa Matrix
    @test A[:,4] == [40, 0,0]
    @test copyto!(da, 10, a2, 11) isa DimMatrix
    @test da[:,4] == [6,7,0]
end

@testset "copy_similar" begin
    A = rand(Float32, X(10), Y(5))
    cp = LinearAlgebra.copy_similar(A, Float64)
    @test cp isa DimMatrix{Float64,<:Tuple{<:X,<:Y}}
    @test A == cp
end

@testset "constructor" begin
    da = DimArray(; data=rand(5, 4), dims=(X, Y))
    @test_throws DimensionMismatch DimArray(1:5, X(1:6))
    @test_throws DimensionMismatch DimArray(1:5, (X(1:5), Y(1:2)))
    da_reconstructed = DimArray(da)
    @test da == da_reconstructed
    @test dims(da) == dims(da_reconstructed)
    @test DimArray(zeros(5, 4), (X(1:5), Y(1:4))) ==
        DimArray(zeros(5, 4), (X => 1:5, Y => 1:4)) ==
        DimArray(zeros(5, 4), (:X => 1:5, :Y => 1:4)) ==
        DimArray(zeros(5, 4), (X = 1:5, Y = 1:4))
end

@testset "DimVector and DimMatrix" begin
    dv = DimVector([1, 2, 3], X);
    @test dv isa DimArray{Int,1}
    @test dv isa DimVector
    @test dv isa DimVecOrMat
    @test dv isa AbstractDimVector
    @test dv isa AbstractDimVecOrMat
    dm = DimMatrix(zeros(3, 4), (X(), Y()));
    @test dm isa DimArray{Float64,2}
    @test dm isa DimMatrix
    @test dm isa DimVecOrMat
    @test dm isa AbstractDimMatrix
    @test dm isa AbstractDimVecOrMat
end

@testset "fill constructor" begin
    da = fill(5.0, X(4), Y(40.0:10.0:80.0))
    @test parent(da) == fill(5.0, (4, 5))
    @test dims(da) == (
         X(NoLookup(Base.OneTo(4))), 
         Y(Sampled(40.0:10.0:80.0, ForwardOrdered(), Regular(10.0), Points(), NoMetadata()))
    )
    @test_throws ArgumentError fill(5.0, (X(:e), Y(8)))
end


@testset "generator constructor" begin
    Xs = X(10:10:50)
    Ys = Y(0.0:0.1:1.0)
    Zs = Z(100:10:500)
    name = :Value

    A = [(x, y) for x in Xs, y in Ys]
    @test dims(A) == (Xs, Ys)
    @test size(A) == (Xs, Ys) .|> length

    A = DimArray(x for x in Xs)
    @test dims(A) == (Xs,)
    @test size(A) == (Xs,) .|> length

    A = DimArray(x for x in Xs; name)
    @test dims(A) == (Xs,)
    @test size(A) == (Xs,) .|> length
    @test A.name == name

    A = DimArray((x, y) for x in Xs, y in Ys)
    @test dims(A) == (Xs, Ys)
    @test size(A) == (Xs, Ys) .|> length

    A = DimArray((x, y) for x in Xs, y in Ys; name)
    @test dims(A) == (Xs, Ys)
    @test size(A) == (Xs, Ys) .|> length
    @test A.name == name

    A = DimArray((x, y, z) for x in Xs, y in Ys, z in Zs)
    @test dims(A) == (Xs, Ys, Zs)
    @test size(A) == (Xs, Ys, Zs) .|> length

    A = DimArray((x, y, z) for x in Xs, y in Ys, z in Zs; name)
    @test dims(A) == (Xs, Ys, Zs)
    @test size(A) == (Xs, Ys, Zs) .|> length
    @test A.name == name
end

@testset "ones, zeros, trues, falses constructors" begin
    da = @inferred zeros(X(4), Y(40.0:10.0:80.0; order=ForwardOrdered()); metadata=(a=1, b=2))
    @test eltype(da) <: Float64
    @test metadata(da) == (a=1, b=2)
    @test all(==(0), da) 
    ti = Ti(Date(2001):Year(1):Date(2004))
    da = ones(Int32, ti)
    @test size(da) == (4,)
    @test eltype(da) <: Int32
    @test all(==(1), da) 
    @test dims(da) == (Ti(Sampled(Date(2001):Year(1):Date(2004), ForwardOrdered(), Regular(Year(1)), Points(), NoMetadata())),)
    da = trues(ti)
    @test size(da) == (4,)
    @test eltype(da) <: Bool
    @test all(==(true), da) 
    @test dims(da) == (Ti(Sampled(Date(2001):Year(1):Date(2004), ForwardOrdered(), Regular(Year(1)), Points(), NoMetadata())),)
    da = falses(ti)
    @test size(da) == (4,)
    @test eltype(da) <: Bool
    @test all(==(false), da) 
    @test dims(da) == (Ti(Sampled(Date(2001):Year(1):Date(2004), ForwardOrdered(), Regular(Year(1)), Points(), NoMetadata())),)

    for f in (ones, zeros, trues, falses)
        da = f(X(4), Y(40.0:10.0:80.0); metadata=(a=1, b=2))
        @test size(da) == (4, 5)
        @test metadata(da) == (a=1, b=2)
        @test dims(da) == (
             X(NoLookup(Base.OneTo(4))), 
             Y(Sampled(40.0:10.0:80.0, ForwardOrdered(), Regular(10.0), Points(), NoMetadata()))
        )
    end
end

@testset "undef Array constructor" begin
    A = Array{Bool}(undef, dimz...)
    @test eltype(A) === Bool
    @test size(A) === size(da)
    @test A isa Array
    A = DimArray{Int}(undef, dimz...)
    @test eltype(A) === Int
    @test size(A) === size(da)
    @test A isa DimArray
    @test dims(A) === dims(da)
    A = DimArray{Int}(undef, dimz)
    @test eltype(A) === Int
    @test size(A) === size(da)
    @test A isa DimArray
    @test dims(A) === dims(da)
end

@testset "rand constructors" begin
    da = @inferred rand(1:10, X(8), Y(11:20); metadata=(a=1, b=2))
    @test size(da) == (8, 10)
    @test eltype(da) <: Int
    @test metadata(da) == (a=1, b=2)
    @test dims(da) == (
         X(NoLookup(Base.OneTo(8))), 
         Y(Sampled(11:20, ForwardOrdered(), Regular(1), Points(), NoMetadata()))
    )
    da = @inferred rand(X([:a, :b]; order=ForwardOrdered()), Y(3))
    @test size(da) == (2, 3)
    @test eltype(da) <: Float64
    da = rand(Bool, X([:a, :b]), Y(3))
    @test size(da) == (2, 3)
    @test eltype(da) <: Bool
    da = rand(MersenneTwister(), Float32, X([:a, :b]), Y(3))
    @test size(da) == (2, 3)
    @test eltype(da) <: Float32
    da = rand(MersenneTwister(), 1:2, X([:a, :b]), Y(3))
    @test eltype(da) <: Int
    @test size(da) == (2, 3)
    @test maximum(da) in (1, 2)
    @test minimum(da) in (1, 2)
    da = rand(MersenneTwister(), X([:a, :b]), Y(3))
    @test size(da) == (2, 3)
    @test eltype(da) <: Float64
end

@testset "NamedTuple" begin
    @test NamedTuple(da) == (; test=da)
    @test NamedTuple(da, da2) == (; test=da, test2=da2)
    da3 = DimArray(a2, dimz2; refdims=refdimz, name=DimensionalData.Name(:test3))
    @test NamedTuple(da, da3) == (; test=da, test3=da3)
end

@testset "Base.dataids and mightalias" begin
    a = rand(X(3), Y(2))
    @test Base.dataids(a) == Base.dataids(parent(a))
    @test Base.mightalias(a, parent(a))
end

@testset "isequal and == with missing" begin
    a = [missing 0; 0 0]
    ba = [missing 0 0; 0 0 0]

    da = DimArray(a, (X(1:2), Y(1:2)))
    dba = DimArray(ba, (X(1:2), Y(1:3)))

    @test ismissing(dba[:,1:2] == da)
    @test (dba == da) == false
    @test isequal(dba, da) == false
    @test isequal(dba[:,1:2], da)
    @test isequal(da, dba[:,2:3]) == false
    dshift = DimArray(a, (X(10:11), Y(2:3)))
    @test isequal(da, dshift) == false
    @test (da == dshift) == false
end

"""
    DimensionalDataDiskArraysExt

Extend some methods of DiskArrays (`cache`, etc) to work on the base data of any DimArray.  
"""
module DimensionalDataDiskArraysExt

using DimensionalData
import DimensionalData: AbstractBasicDimArray
import DiskArrays

const DD = DimensionalData

DiskArrays.haschunks(da::AbstractBasicDimArray) = DiskArrays.haschunks(parent(da))
DiskArrays.eachchunk(da::AbstractBasicDimArray) = DiskArrays.eachchunk(parent(da))

# Only define methods if they are available, 
# to avoid dropping older DiskArrays versions
# TODO remove these checks when we drop DiskArrays below 0.4.8
@static if isdefined(DiskArrays, :isdisk)
    DiskArrays.isdisk(x::AbstractDimArray) = DiskArrays.isdisk(parent(x))
    DiskArrays.isdisk(x::AbstractDimStack) = any(map(DiskArrays.isdisk, layers(x)))
end

@static if isdefined(DiskArrays, :cache)
    DiskArrays.cache(x::Union{AbstractDimStack,AbstractDimArray}; kw...) = 
        modify(A -> DiskArrays.cache(A; kw...), x)
end

@static if isdefined(DiskArrays, :pad)
    DiskArrays.pad(x::Union{AbstractDimArray,AbstractDimStack}, padding::Tuple{Vararg{Tuple{<:Integer,<:Integer}}}; kw...) =
        DiskArrays.pad(x, map(rebbuild, dims(x, padding)))
    DiskArrays.pad(x::Union{AbstractDimArray,AbstractDimStack}, padding::NamedTuple; kw...) =
        DiskArrays.pad(x, DD.kw2dims(padding); kw...)
    DiskArrays.pad(x::Union{AbstractDimArray,AbstractDimStack}, p1::Pair, pairs::Pair...; kw...) =
        DiskArrays.pad(x, DD.Dimensions.pairs2dims(p1, pairs...); kw...)
    function DiskArrays.pad(x::AbstractDimStack, padding::DD.DimTuple; kw...)
        DD.maplayers(x) do A
            DiskArrays.pad(A, padding; kw...)
        end
    end
    function DiskArrays.pad(x::AbstractDimArray, padding::DD.DimTuple; kw...)
        tuple_padding = map(DD.dims(x)) do d
            hasdim(padding, d) ? map(Int, val(DD.dims(padding, d))) : (0, 0)
        end
        paddeddims = map(DD.dims(x)) do d
            if hasdim(padding, d) 
                DiskArrays.pad(d, val(DD.dims(padding, d)))
            else
                d
            end
        end
        paddeddata = DiskArrays.pad(parent(x), tuple_padding; kw...)
        return rebuild(x; data=paddeddata, dims=paddeddims)
    end
    DiskArrays.pad(d::DD.Dimension, padding::Tuple{<:Integer,<:Integer}) = 
        rebuild(d, DiskArrays.pad(lookup(d), padding))
    DiskArrays.pad(l::DD.AbstractNoLookup, (startpad, stoppad)::Tuple{<:Integer,<:Integer}) =
        DD.NoLookup(Base.OneTo(length(l) + startpad + stoppad))
    function DiskArrays.pad(l::DD.Lookup, padding::Tuple{<:Integer,<:Integer})
        (DD.issampled(l) && DD.isregular(l)) || throw(ArgumentError("Can only pad `Regular` `AbstractSampled` lookups"))
        rebuild(l; data=_pad(parent(l), step(l), padding))
        # Use ranges for math because they have TwicePrecision magic
        # Define a range down to the lowest value,
        # but anchored at the existing value
    end

    _pad(l::AbstractRange, step, (startpad, stoppad)::Tuple{<:Integer,<:Integer}) =
        (first(l) - startpad * step):step:(last(l) + stoppad * step)
    _pad(l::AbstractUnitRange, step, (startpad, stoppad)::Tuple{<:Integer,<:Integer}) =
        (first(l) - startpad):(last(l) + stoppad)
    function _pad(l::AbstractVector, step, (startpad, stoppad)::Tuple{<:Integer,<:Integer})
        # First pad as a range
        range = parent(_pad(first(l):step:last(l), step, (startpad, stoppad)))
        # Then convert back to vector
        data = collect(range)
        # And fill the middle with the values from the original vector
        # This prevents floating point error changing the original values
        data[startpad+1:end-stoppad] .= l
        # Rebuild the lookup with the padded data
        return data
    end
end

@inline function DimensionalData.lazypermutedims(A::AbstractArray, perm) 
    # For DiskArrays `permutedims` is lazy
    if DiskArrays.isdisk(A)
        permutedims(A, perm)
    else
        DimensionalData._permuteddimsarray(A, perm)
    end
end

@static if isdefined(DiskArrays, :mockchunks)
    DiskArrays.mockchunks(x::AbstractDimArray, chunks) = 
        modify(A -> DiskArrays.mockchunks(A, chunks), x)
end

DD.can_show_data(A::DiskArrays.AbstractDiskArray) = false

end

module DimensionalDataPythonCallExt

using DimensionalData
import DimensionalData as DD
import PythonCall
import PythonCall: Py, PyArray, pyis, pyconvert, pytype, pybuiltins, pylen


function PythonCall.pyconvert(::Type{DimArray}, x::Py, d=nothing; copy=false)
    x_pytype = string(pytype(x).__name__)
    if x_pytype != "DataArray"
        if isnothing(d)
            throw(ArgumentError("Cannot convert $(pytype(x)) to a DimArray, it must be an xarray.DataArray"))
        else
            return d
        end
    end

    # Transpose here so that the fast axis remains the same in the Julia array
    data_py = PyArray(x.data.T; copy=false)
    data = copy ? pyconvert(Array, data_py) : data_py

    dim_names = Symbol.(collect(x.dims))
    coord_names = Symbol.(collect(x.coords.keys()))
    new_dims = Dim[]
    for dim in reverse(dim_names) # Iterate in reverse order because of row/col major
        if dim in coord_names
            coord_py = PyArray(getproperty(x, dim).data; copy=false)
            coord = copy ? pyconvert(Array, coord_py) : coord_py
            push!(new_dims, Dim{dim}(coord))
        else
            push!(new_dims, Dim{dim}())
        end
    end

    metadata = pylen(x.attrs) == 0 ? DD.NoMetadata() : pyconvert(Dict, x.attrs)

    array_name = pyis(x.name, pybuiltins.None) ? DD.NoName() : string(x.name)

    return DimArray(data, Tuple(new_dims); name=array_name, metadata)
end

function PythonCall.pyconvert(::Type{DimStack}, x::Py, d=nothing; copy=false)
    x_pytype = string(pytype(x).__name__)
    if x_pytype != "Dataset"
        if isnothing(d)
            throw(ArgumentError("Cannot convert $(x) to a DimStack, it must be an xarray.Dataset"))
        else
            return d
        end
    end

    variable_names = Symbol.(collect(x.data_vars.keys()))
    arrays = Dict{Symbol, DimArray}()
    for name in variable_names
        arrays[name] = pyconvert(DimArray, getproperty(x, name); copy)
    end

    metadata = pyconvert(Dict, x.attrs)

    return DimStack(NamedTuple(arrays); metadata)
end

# Precompile main calls to pyconvert(::DimArray) with copy=true and copy=false
precompile(Tuple{typeof(PythonCall.Core.pyconvert), Type{DimensionalData.DimArray{T, N, D, R, A, Na, Me} where Me where Na where A<:AbstractArray{T, N} where R<:Tuple where D<:Tuple where N where T}, PythonCall.Core.Py})
precompile(Tuple{typeof(Core.kwcall), NamedTuple{(:copy,), Tuple{Bool}}, typeof(PythonCall.Core.pyconvert), Type{DimensionalData.DimArray{T, N, D, R, A, Na, Me} where Me where Na where A<:AbstractArray{T, N} where R<:Tuple where D<:Tuple where N where T}, PythonCall.Core.Py})

# Precompile lower-level conversion calls for common types and dimensions
for T in (Int32, Int64, UInt32, UInt64, Float32, Float64)
    for N in (1, 2, 3, 4, 5)
        precompile(Tuple{typeof(PythonCall.Core.pyconvert), Type{Array{T, N}}, PythonCall.Core.Py})
    end
end

end

# Array info
for (m, f) in ((:Base, :size), (:Base, :axes), (:Base, :firstindex), (:Base, :lastindex))
    @eval begin
        @inline $m.$f(A::AbstractBasicDimArray, dims::AllDims) = $m.$f(A, dimnum(A, dims))
    end
end

# Reducing methods

# With a function arg version
for (m, f) in ((:Base, :sum), (:Base, :prod), (:Base, :maximum), (:Base, :minimum),
               (:Base, :extrema), (:Statistics, :mean))
    _f = Symbol('_', f)
    @eval begin
        # Base methods
        @inline $m.$f(A::AbstractDimArray; dims=:, kw...) = $_f(A, dims; kw...)
        @inline $m.$f(f, A::AbstractDimArray; dims=:, kw...) = $_f(f, A, dims; kw...)
        # Local dispatch methods
        # - Return a reduced DimArray
        @inline function $_f(A::AbstractDimArray, dims; kw...)
            rebuild(A, $m.$f(parent(A); dims=dimnum(A, dims), kw...), reducedims(A, dims))
        end
        @inline function $_f(f, A::AbstractDimArray, dims; kw...)
            rebuild(A, $m.$f(f, parent(A); dims=dimnum(A, dims), kw...), reducedims(A, dims))
        end
        # - Return a scalar
        @inline $_f(A::AbstractDimArray, dims::Colon; kw...) = $m.$f(parent(A); dims, kw...)
        @inline $_f(f, A::AbstractDimArray, dims::Colon; kw...) = $m.$f(f, parent(A); dims, kw...)
    end
end
# With no function arg version
for (m, f) in ((:Statistics, :std), (:Statistics, :var))
    _f = Symbol('_', f)
    @eval begin
        # Base methods
        $m.$f(A::AbstractDimArray; corrected::Bool=true, mean=nothing, dims=:) =
            $_f(A, corrected, mean, dims)
        # Local dispatch methods - Returns a reduced array
        @inline $_f(A::AbstractDimArray, corrected, mean, dims) =
            rebuild(A, $m.$f(parent(A); corrected=corrected, mean=mean, dims=dimnum(A, _astuple(dims))), reducedims(A, dims))
        # - Returns a scalar
        @inline $_f(A::AbstractDimArray, corrected, mean, dims::Colon) =
            $m.$f(parent(A); corrected=corrected, mean=mean, dims=:)
    end
end
for (m, f) in ((:Statistics, :median), (:Base, :any), (:Base, :all))
    _f = Symbol('_', f)
    @eval begin
        @inline $m.$f(A::AbstractDimArray; dims=:) = $_f(A, dims)
        # Local dispatch methods - Returns a reduced array
        @inline $_f(A::AbstractDimArray, dims) =
            rebuild(A, $m.$f(parent(A); dims=dimnum(A, _astuple(dims))), reducedims(A, dims))
        # - Returns a scalar
        @inline $_f(A::AbstractDimArray, dims::Colon) = $m.$f(parent(A); dims=:)
    end
end

function Base.mapreduce(f, op, A::AbstractDimArray; dims=Base.Colon(), kw...)
    dims === Colon() && return mapreduce(f, op, parent(A); kw...)
    ds = DD.dims(A, dims)
    # Dimnum will fail on `Int` not in dims(A)
    dim_ints = if dims isa Tuple && all(x -> x isa Integer, dims) 
        _check_valid_region(dims)
        dims
    else
        dimnum(A, ds)
    end
    data = mapreduce(f, op, parent(A); dims=dim_ints, kw...)
    rebuild(A, data, reducedims(A, ds))
end

# Copied from Base reducedim.jl
function _check_valid_region(region)
    for d in region
        isa(d, Integer) || throw(ArgumentError("reduced dimension(s) must be integers"))
        Int(d) < 1 && throw(ArgumentError("region dimension(s) must be ≥ 1, got $d"))
    end
end


# TODO: Unfortunately Base/accumulate.jl kw methods all force dims to be Integer.
# accumulate wont work unless that is relaxed, or we copy half of the file here.
# Base._accumulate!(op, B, A, dims::AllDims, init::Union{Nothing, Some}) =
    # Base._accumulate!(op, B, A, dimnum(A, dims), init)

# Dimension dropping

function Base.dropdims(A::AbstractDimArray; dims)
    dims = DD.dims(A, dims)
    data = Base.dropdims(parent(A); dims=dimnum(A, dims))
    rebuildsliced(view, A, data, _dropinds(A, dims))
end

@inline _dropinds(A, dims::Tuple) = dims2indices(A, map(d -> rebuild(d, 1), dims))
@inline _dropinds(A, dim::Dimension) = dims2indices(A, rebuild(dim, 1))


# Function application

#= TODO better `comparedims` here. 
- What if one of these is not an `AbstractDimArray` but the rest are?
- Should we check values as well like broadcast and matmul?
- There are less problems with type stability in `map` as we can just 
    take dims from the first, there are no length 1 dims.
=#
function Base.map(f, A1::AbstractDimArray, As::AbstractDimArray...)
    comparedims(A1, As...)
    newdata = map(f, map(parent, (A1, As...))...)
    return rebuild(A1; data=newdata)
end


@inline function Base.mapslices(f, A::AbstractDimArray; dims=1, kw...)
    # Run `mapslices` on the parent array
    dimnums = dimnum(A, _astuple(dims))
    newdata = mapslices(f, parent(A); dims=dimnums, kw...)
    ds = DD.dims(A, _astuple(dims))
    # Run one slice with dimensions to get the transformed dim
    d_inds = map(d -> rebuild(d, 1), otherdims(A, ds))
    example_dims = length(d_inds) > 0 ? DD.dims(f(view(A, d_inds...))) : ()
    replacement_dims = if isnothing(example_dims) || length(example_dims) != length(ds)
        map(d -> rebuild(d, NoLookup()), ds)
    else
        example_dims
    end
    newdims = format(setdims(DD.dims(A), replacement_dims), newdata)

    return rebuild(A, newdata, newdims)
end

"""
    Base.eachslice(A::AbstractDimArray; dims,drop=true)

Create a generator that iterates over dimensions `dims` of `A`, returning arrays that
select all the data from the other dimensions in `A` using views.

The generator has `size` and `axes` equivalent to those of the provided `dims` if `drop=true`.
Otherwise it will have the same dimensionality as the underlying array with inner dimensions having size 1.
"""
@inline function Base.eachslice(A::AbstractDimArray; dims, drop=true)
    dimtuple = _astuple(dims)
    if !(dimtuple == ()) 
        all(hasdim(A, dimtuple...)) || throw(DimensionMismatch("A doesn't have all dimensions $dims"))
    end
    _eachslice(A, dimtuple, drop)
end
Base.@constprop :aggressive function _eachslice(A::AbstractDimArray{T,N}, dims, drop) where {T,N}
    slicedims = Dimensions.dims(A, dims)
    Adims = Dimensions.dims(A)
    if drop
        ax = map(dim -> axes(A, dim), slicedims)
        slicemap = map(Adims) do dim
            hasdim(slicedims, dim) ? dimnum(slicedims, dim) : (:)
        end
        return Slices(A, slicemap, ax)
    else
        ax = map(Adims) do dim
            hasdim(slicedims, dim) ? axes(A, dim) : axes(reducedims(dim, dim), 1)
        end
        slicemap = map(Adims) do dim
            hasdim(slicedims, dim) ? dimnum(A, dim) : (:)
        end
        return Slices(A, slicemap, ax)
    end
end


# works for arrays and for stacks
function _eachslice(x, dims::Tuple)
    slicedims = Dimensions.dims(x, dims)
    return (view(x, d...) for d in DimIndices(slicedims))
end

# These just return the parent for now
function Base.sort(A::AbstractDimVector; kw...)
    newdims = (set(only(dims(A)), NoLookup()),)
    newdata = sort(parent(A); kw...)
    return rebuild(A, newdata, newdims)
end
function Base.sort(A::AbstractDimArray; dims, kw...)
    newdata = sort(parent(A); dims=dimnum(A, dims), kw...)
    replacement_dims = map(DD.dims(A, _astuple(dims))) do d
        set(d, NoLookup())
    end
    newdims = setdims(DD.dims(A), replacement_dims)
    return rebuild(A, newdata, newdims)
end

function Base.sortslices(A::AbstractDimArray; dims, kw...)
    newdata = sortslices(parent(A); dims=dimnum(A, dims), kw...)
    replacement_dims = map(DD.dims(A, _astuple(dims))) do d
        set(d, NoLookup())
    end
    newdims = setdims(DD.dims(A), replacement_dims)
    return rebuild(A, newdata, newdims)
end

                
Base.cumsum(A::AbstractDimVector) = rebuild(A, Base.cumsum(parent(A)))
Base.cumsum(A::AbstractDimArray; dims) = rebuild(A, cumsum(parent(A); dims=dimnum(A, dims)))
Base.cumsum!(B::AbstractArray, A::AbstractDimVector) = cumsum!(B, parent(A))
Base.cumsum!(B::AbstractArray, A::AbstractDimArray; dims) = cumsum!(B, parent(A); dims=dimnum(A, dims))

# Duplicated dims

for fname in (:cor, :cov)
    @eval function Statistics.$fname(A::AbstractDimArray{<:Any,2}; dims=1, kw...)
        newdata = Statistics.$fname(parent(A); dims=dimnum(A, dims), kw...)
        removed_idx = dimnum(A, dims)
        newrefdims = $dims(A)[removed_idx]
        newdim = $dims(A)[3 - removed_idx]
        rebuild(A, newdata, (newdim, newdim), (newrefdims,))
    end
end

# Rotations

Base.rotl90(A::AbstractDimMatrix) = rebuild(A, rotl90(parent(A)), _rotdims_90(dims(A)))
function Base.rotl90(A::AbstractDimMatrix, k::Integer)
    rebuild(A, rotl90(parent(A), k), _rotdims_k(dims(A), k))
end

Base.rotr90(A::AbstractDimMatrix) = rebuild(A, rotr90(parent(A)), _rotdims_270(dims(A)))
function Base.rotr90(A::AbstractDimMatrix, k::Integer)
    rebuild(A, rotr90(parent(A), k), _rotdims_k(dims(A), -k))
end

Base.rot180(A::AbstractDimMatrix) = rebuild(A, rot180(parent(A)), _rotdims_180(dims(A)))

# Not type stable - but we have to lose type stability somewhere when
# dims are being swapped, by an Int value, so it may as well be here
function _rotdims_k(dims, k)
    k = mod(k, 4)
    k == 1 ? _rotdims_90(dims) :
    k == 2 ? _rotdims_180(dims) :
    k == 3 ? _rotdims_270(dims) : dims
end

_rotdims_90((dim_a, dim_b)) = reverse(dim_b), dim_a
_rotdims_180((dim_a, dim_b)) = reverse(dim_a), reverse(dim_b)
_rotdims_270((dim_a, dim_b)) = dim_b, reverse(dim_a)

# Dimension reordering

for (pkg, fname) in [(:Base, :permutedims), (:Base, :adjoint),
                     (:Base, :transpose), (:LinearAlgebra, :Transpose)]
    @eval begin
        @inline $pkg.$fname(A::AbstractDimArray{<:Any,2}) =
            rebuild(A, $pkg.$fname(parent(A)), reverse(dims(A)))
        @inline $pkg.$fname(A::AbstractDimArray{<:Any,1}) =
            rebuild(A, $pkg.$fname(parent(A)), (AnonDim(NoLookup(Base.OneTo(1))), dims(A)...))
    end
end
@inline function Base.permutedims(A::AbstractDimArray, perm)
    rebuild(A, permutedims(parent(A), dimnum(A, Tuple(perm))), sortdims(dims(A), Tuple(perm)))
end
@inline Base.PermutedDimsArray(A::AbstractDimArray{T,N}, perm) where {T,N} =
    lazypermutedims(A, perm)

# We add a method for this in the DiskArrays extension
@inline lazypermutedims(A, perm) = _permuteddimsarray(A, perm)

@inline function _permuteddimsarray(A::AbstractDimArray, perm)
    T = eltype(A)
    N = ndims(A)
    perm_inds = dimnum(A, Tuple(perm))
    iperm_inds = invperm(perm_inds)
    data = parent(A)
    data_perm = PermutedDimsArray{T,N,perm_inds,iperm_inds,typeof(data)}(data)
    rebuild(A, data_perm, sortdims(dims(A), Tuple(perm)))
end

# Concatenation
Base.cat(A1::AbstractDimArray, As::AbstractDimArray...; dims) = _cat(dims, A1, As...)

function _cat(catdim::Union{Int,Symbol,DimOrDimType}, A1::AbstractDimArray, As::AbstractDimArray...)
    _cat((catdim,), A1, As...)
end
function _cat(catdims::Tuple, A1::AbstractDimArray, As::AbstractDimArray...)
    Xin = (A1, As...)
    newcatdims = map(catdims) do catdim
        # If catdim is already constructed, its the new dimension
        if catdim isa Dimension
            return catdim
        end
        # Otherwise build a new dimension/lookup
        if catdim isa Int
            if hasdim(A1, catdim)
                catdim = basedims(dims(A1, catdim))
            else
                return AnonDim(NoLookup()) # TODO: handle larger dimension extensions, this is half broken
            end
        else
            catdim = basedims(name2dim(catdim))
        end
        # Dimension Types and Symbols
        if all(x -> hasdim(x, catdim), Xin)
            # We concatenate an existing dimension
            newcatdim = if lookup(A1, catdim) isa NoLookup
                rebuild(catdim, NoLookup())
            else
                # vcat the index for the catdim in each of Xin
                joindims = map(A -> dims(A, catdim), Xin)
                if !check_cat_lookups(joindims...) 
                    return rebuild(catdim, NoLookup())
                end
                _vcat_dims(joindims...)
            end
        else
            # Concatenate new dims
            if all(map(x -> hasdim(refdims(x), catdim), Xin))
                if catdim isa Dimension && val(catdim) isa AbstractArray && !(lookup(catdim) isa NoLookup{AutoValues})
                    # Combine the refdims properties with the passed in catdim
                    set(refdims(first(Xin), catdim), catdim)
                else
                    # vcat the refdims
                    _vcat_dims(map(x -> refdims(x, catdim), Xin)...)
                end
            else
                # Use the catdim as the new dimension
                catdim
            end
        end
    end

    inserted_dims = dims(newcatdims, dims(A1))
    appended_dims = otherdims(newcatdims, inserted_dims)

    inserted_dnums = dimnum(A1, inserted_dims)
    appended_dnums = ntuple(i -> i + length(dims(A1)), length(appended_dims))
    cat_dnums = (inserted_dnums..., appended_dnums...)

    # Warn if dims or val do not match, and cat the parent
    if !comparedims(map(x -> otherdims(x, newcatdims), Xin)...;
        order=true, val=true, msg=Dimensions.Warn(" Can't `cat` AbstractDimArray, applying to `parent` object.")
    )
        return Base.cat(map(parent, Xin)...; dims=cat_dnums)
    end

    updated_dims = setdims(dims(A1), inserted_dims)
    newdims = (updated_dims..., appended_dims...)
    newrefdims = otherdims(refdims(A1), newcatdims)
    newA = Base.cat(map(parent, Xin)...; dims=cat_dnums)
    return rebuild(A1, newA, format(newdims, newA), newrefdims)
end

function Base.hcat(As::Union{AbstractDimVector,AbstractDimMatrix}...)
    Base.cat(As; dims=2)
    A1 = first(As)
    catdim = if A1 isa AbstractDimVector
        AnonDim(NoLookup())
    else
        joindims = map(last ∘ dims, As)
        check_cat_lookups(joindims...) || return Base.hcat(map(parent, As)...)
        _vcat_dims(joindims...)
    end
    noncatdim = dims(A1, 1)
    # Make sure this is the same dimension for all arrays
    if !comparedims(map(x -> dims(x, 1), As)...;
        val=true, msg=Dimensions.Warn(" Can't `hcat` AbstractDimArray, applying to `parent` object.")
    )
        return Base.hcat(map(parent, As)...)
    end
    newdims = (noncatdim, catdim)
    newA = hcat(map(parent, As)...)
    return rebuild(A1, newA, format(newdims, newA))
end

function Base.vcat(As::Union{AbstractDimVector,AbstractDimMatrix}...)
    A1 = first(As)
    firstdims = map(first ∘ dims, As)
    check_cat_lookups(firstdims...) || return Base.vcat(map(parent, As)...)
    newdims = if A1 isa AbstractDimVector
        catdim = _vcat_dims(firstdims...)
        (catdim,)
    else
        # Make sure this is the same dimension for all arrays
        if !comparedims(map(x -> dims(x, 2), As)...; 
            val=true, msg=Dimensions.Warn(" Can't `vcat` AbstractDimArray, applying to `parent` object.")
        )
            return Base.vcat(map(parent, As)...)
        end
        catdim = _vcat_dims(firstdims...)
        noncatdim = dims(A1, 2)
        (catdim, noncatdim)
    end
    newA = vcat(map(parent, As)...)
    return rebuild(A1, newA, format(newdims, newA))
end

function Base.vcat(d1::Dimension, ds::Dimension...)
    dims = (d1, ds...)
    comparedims(dims...; length=false)
    check_cat_lookups(dims...) || return Base.vcat(map(parent, dims)...)
    return _vcat_dims(d1, ds...)
end

check_cat_lookups(dims::Dimension...) =
    _check_cat_lookups(basetypeof(first(dims)), lookup(dims)...)

# Lookups may need adjustment for `cat`
_check_cat_lookups(D, lookups::Lookup...) = _check_cat_lookup_order(D, lookups...)
_check_cat_lookups(D, l1::NoLookup, lookups::NoLookup...) = true
function _check_cat_lookups(D, l1::AbstractSampled, lookups::AbstractSampled...)
    length(lookups) > 0 || return true
    _check_cat_lookup_order(D, l1, lookups...) || return false
    _check_cat_lookups(D, span(l1), l1, lookups...)
end
function _check_cat_lookups(D, ::Regular, lookups...)
    length(lookups) > 1 || return true
    lastval = last(first(lookups))
    s = step(first(lookups))
    map(Base.tail(lookups)) do l
        if !(span(l) isa Regular)
            _mixed_span_warn(D, Regular, span(l))
            return false
        end
        if !(step(span(l)) == s)
            @warn _cat_warn_string(D, "step sizes $(step(span(l))) and $s do not match")
            return false
        end
        _check_cat_step_join(D, lastval, first(l), s) || return false
        lastval = last(l)
        return true
    end |> all
end

function _check_cat_step_join(D, lastval::Number, firstval::Number, steplen)
    if !(lastval + steplen ≈ firstval)
        @warn _cat_warn_string(D, "`Regular` lookups do not join with the correct step size: $(lastval) + $steplen ≈ $firstval should hold")
        return false
    end
    return true
end

function _check_cat_step_join(D, lastval, firstval, steplen)
    if lastval + steplen != firstval
        @warn _cat_warn_string(D, "`Regular` lookups do not join with the correct step size: $(lastval) + $steplen == $firstval should hold since isapprox is not defined")
        return false
    end
    return true
end

function _check_cat_lookups(D, ::Explicit, lookups...)
    map(lookups) do l
        span(l) isa Explicit || _mixed_span_warn(D, Explicit, span(l))
    end |> all
end
function _check_cat_lookups(D, ::Irregular, lookups...)
    map(lookups) do l
        span(l) isa Irregular || _mixed_span_warn(D, Irregular, span(l))
    end |> all
end

function _check_cat_lookup_order(D, lookups::Lookup...)
    length(lookups) > 1 || return true
    l1 = first(lookups)
    length(l1) == 0 && return _check_cat_lookup_order(D, Base.tail(lookups)...)
    L = basetypeof(l1)
    x = last(l1)
    if isordered(l1)
        map(Base.tail(lookups)) do lookup
            length(lookup) > 0 || return true
            if isforward(lookup)
                if isreverse(l1)
                    _cat_mixed_ordered_warn(D)
                    return false
                elseif length(lookup) == 0 || first(lookup) > x
                    x = last(lookup)
                    return true
                else
                    x = last(lookup)
                    _cat_lookup_overlap_warn(D, first(lookup), x)
                    return false
                end
            else
                if isforward(l1)
                    _cat_mixed_ordered_warn(D)
                    return false
                elseif length(lookup) == 0 || first(lookup) < x
                    x = last(lookup)
                    return true
                else
                    x = last(lookup)
                    _cat_lookup_overlap_warn(D, first(lookup), x)
                    return false
                end
            end
        end |> all
    else
        intr = intersect(lookups...)
        if length(intr) == 0
            return true
        else
            _cat_lookup_intersect_warn(D, intr)
            return false
        end
    end
end

function _vcat_dims(d1::Dimension, ds::Dimension...)
    dims = (d1, ds...)
    newlookup = _vcat_lookups(lookup(dims)...)
    return rebuild(d1, newlookup)
end

# Lookups may need adjustment for `cat`
function _vcat_lookups(lookups::Lookup...)
    newindex = _vcat_index(lookups...)
    return rebuild(lookups[1]; data=newindex)
end
function _vcat_lookups(lookups::AbstractSampled...)
    newindex = _vcat_index(lookups...)
    newlookup = _vcat_lookups(sampling(first(lookups)), span(first(lookups)), lookups...)
    return rebuild(newlookup; data=newindex)
end
function _vcat_lookups(::Any, ::Regular, lookups...)
    first(lookups)
end
function _vcat_lookups(::Intervals, ::Explicit, lookups...)
    len = mapreduce(+, lookups) do l
        size(val(span(l)), 2)
    end
    combined_span_mat = similar(val(span(first(lookups))), 2, len)
    i = 1
    foreach(lookups) do l
        span_mat = val(span(l))
        l = size(span_mat, 2)
        combined_span_mat[:, i:i+l - 1] .= span_mat
        i += l
    end
    rebuild(first(lookups); span=Explicit(combined_span_mat))
end
function _vcat_lookups(::Intervals, ::Irregular, lookups...)
    allbounds = map(bounds ∘ span, lookups)
    newbounds = minimum(map(first, allbounds)), maximum(map(last, allbounds))
    rebuild(lookups[1]; span=Irregular(newbounds))
end
function _vcat_lookups(::Points, ::Irregular, lookups...)
    rebuild(first(lookups); span=Irregular(nothing, nothing))
end

_vcat_index(A1::NoLookup, A::NoLookup...) = OneTo(mapreduce(length, +, (A1, A...)))
# TODO: handle vcat OffsetArrays?
# Otherwise just vcat. TODO: handle order breaking vcat?
# function _vcat_index(lookup::Lookup, lookups...)
    # _vcat_index(span(lookup), lookup, lookups...)
# end
function _vcat_index(lookup1::Lookup, lookups::Lookup...)
    shifted = map((lookup1, lookups...)) do l
        parent(maybeshiftlocus(locus(lookup1), l))
    end
    return reduce(vcat, shifted)
end

@noinline _cat_mixed_ordered_warn(D) = @warn _cat_warn_string(D, "`Ordered` lookups are mixed `ForwardOrdered` and `ReverseOrdered`")
@noinline _cat_lookup_overlap_warn(D, x1, x2) = @warn _cat_warn_string(D, "`Ordered` lookups are misaligned at $x2 and $x1")
@noinline _cat_lookup_intersect_warn(D, intr) = @warn _cat_warn_string(D, "`Unorderd` lookups share values: $intr")

@noinline _mixed_span_error(D, S, span) = throw(DimensionMismatch(_span_string(D, S, span)))
@noinline function _mixed_span_warn(D, S, span)
    @warn _span_string(D, S, span)
    return false
end
_span_string(D, S, span) = _cat_warn_string(D, "not all lookups have `$S` spans. Found $(basetypeof(span))")
_cat_warn_string(D, message) = """
`cat` cannot concatenate `Dimension`s, falling back to `parent` type:
$message on dimension $D. 

To fix for `AbstractDimArray`, pass new lookup values as `cat(As...; dims=$D(newlookupvals))` keyword or `dims=$D()` for empty `NoLookup`.
"""

function Base.inv(A::AbstractDimArray{T,2}) where T
    newdata = inv(parent(A))
    newdims = reverse(dims(A))
    rebuild(A, newdata, newdims)
end

# Index breaking

# TODO: change the index and traits of the reduced dimension and return a DimArray.
Base.unique(A::AbstractDimArray; dims::Union{DimOrDimType,Int,Colon}=:) = _unique(A, dims)
Base.unique(A::AbstractDimArray{<:Any,1}) = unique(parent(A))

_unique(A::AbstractDimArray, dims) = unique(parent(A); dims=dimnum(A, dims))
_unique(A::AbstractDimArray, dims::Colon) = unique(parent(A); dims=:)

Base.diff(A::AbstractDimVector; dims=1) = _diff(A, dimnum(A, dims))
Base.diff(A::AbstractDimArray; dims) = begin
    _diff(A, dimnum(A, dims))
end

@inline function _diff(A::AbstractDimArray{<:Any,N}, dims::Integer) where {N}
    r = axes(A)
    # Copied from Base.diff
    r0 = ntuple(i -> i == dims ? UnitRange(1, last(r[i]) - 1) : UnitRange(r[i]), N)
    data = diff(parent(A); dims=dimnum(A, dims))
    rebuildsliced(getindex, A, data, r0)
end

# Forward `replace` to parent objects
function Base._replace!(new::Base.Callable, res::AbstractDimArray, A::AbstractDimArray, count::Int)
    Base._replace!(new, parent(res), parent(A), count)
    return res
end

Base.reverse(A::AbstractDimArray; dims=:) = _reverse(A, dims)

function _reverse(A::AbstractDimArray, ::Colon)
    newdims = _reverse(DD.dims(A))
    newdata = reverse(parent(A))
    # Use setdims here because newdims is not all the dims
    setdims(rebuild(A, newdata), newdims)
end
function _reverse(A::AbstractDimArray, dims)
    newdims = _reverse(DD.dims(A, dims))
    newdata = reverse(parent(A); dims=dimnum(A, dims))
    # Use setdims here because newdims is not all the dims
    setdims(rebuild(A, newdata), newdims)
end
_reverse(dims::Tuple{Vararg{Dimension}}) = map(d -> reverse(d), dims)
_reverse(dim::Dimension) = reverse(dim)

# Dimension
Base.reverse(dim::Dimension) = rebuild(dim, reverse(lookup(dim)))

Base.dataids(A::AbstractDimArray) = Base.dataids(parent(A))

# We need to override copy_similar because our `similar` doesn't work with size changes
# Fixed in Base in https://github.com/JuliaLang/julia/pull/53210
LinearAlgebra.copy_similar(A::AbstractDimArray, ::Type{T}) where {T} = copyto!(similar(A, T), A)

using DimensionalData, Test, Dates
using DimensionalData.Lookups, DimensionalData.Dimensions
using DimensionalData: LazyLabelledPrintMatrix, ShowWith, showrowlabel, showcollabel, showarrows
using DiskArrays.TestTypes: AccessCountDiskArray, getindex_count

# define dims with both long name and Type name
@dim Lon "Longitude"
@dim Lat "Latitude"

timespan = DateTime(2001):Month(1):DateTime(2001,12)
t = Ti(timespan)
x = Lon(Vector(0.5:10.0:359.5))
y = Lat(Vector{Union{Float32, Missing}}(-89.5:10.0:89.5))
n = Dim{:n}(NoLookup(Base.OneTo(10)))
z = Z('a':'d')
ds = (x, y, z, t, n)
A = DimArray(rand(length.(ds)...), ds; refdims=(Dim{:refdim}(1),), name=:test)
ds = dims(A)

@testset "LazyLabelledPrintMatrix" begin
    A = LazyLabelledPrintMatrix(zeros(X(5)))
    @test size(A) == (5, 1)
    @test collect(A) == [0.0 0.0 0.0 0.0 0.0]'
    A = LazyLabelledPrintMatrix(zeros(X(10:10:50)) .+ (1.0:1:5.0))
    @test size(A) == (5, 2)
    @test collect(A) == [
        showrowlabel(10) 1.0
        showrowlabel(20) 2.0
        showrowlabel(30) 3.0
        showrowlabel(40) 4.0
        showrowlabel(50) 5.0
    ]
    A = LazyLabelledPrintMatrix(zeros(X(5), Y(10:10:30)))
    @test size(A) == (6, 3)
    @test collect(A) == [
         showcollabel(10) showcollabel(20) showcollabel(30)
         0.0              0.0              0.0
         0.0              0.0              0.0
         0.0              0.0              0.0
         0.0              0.0              0.0
         0.0              0.0              0.0
    ]
    A = LazyLabelledPrintMatrix(zeros(X(1:5), Y(3)))
    @test size(A) == (5, 4)
    @test collect(A) == [
         showrowlabel(1) 0.0              0.0              0.0
         showrowlabel(2) 0.0              0.0              0.0
         showrowlabel(3) 0.0              0.0              0.0
         showrowlabel(4) 0.0              0.0              0.0
         showrowlabel(5) 0.0              0.0              0.0
    ]
    A = LazyLabelledPrintMatrix(zeros(X(1:5), Y(10:10:30)))
    @test size(A) == (6, 4)
    @test collect(A) == [
         showarrows()    showcollabel(10) showcollabel(20) showcollabel(30)
         showrowlabel(1) 0.0              0.0              0.0
         showrowlabel(2) 0.0              0.0              0.0
         showrowlabel(3) 0.0              0.0              0.0
         showrowlabel(4) 0.0              0.0              0.0
         showrowlabel(5) 0.0              0.0              0.0
    ]
end

@testset "dims" begin
    sv = sprint(show, MIME("text/plain"), X())
    @test occursin("X", sv)
    sv = sprint(show, MIME("text/plain"), X(fill(0)))
    @test occursin("X", sv)
    sv = sprint(show, MIME("text/plain"), X(1:5))
    @test occursin("X", sv)
end

@testset "show lookups" begin
    cl = Categorical([:a, :b]; order=Unordered())
    sv = sprint(show, MIME("text/plain"), cl)
    @test occursin("Categorical", sv)
    @test occursin("Unordered", sv)
    @test occursin("wrapping:", sv)
    @test occursin(sprint(show, MIME("text/plain"), parent(cl)), sv)
    sl = Sampled(1:2; order=ForwardOrdered(), span=Regular(), sampling=Points())
    sv = sprint(show, MIME("text/plain"), sl)
    @test occursin("Sampled", sv)
    @test occursin("Ordered", sv)
    @test occursin("Regular", sv)
    @test occursin("Points", sv)
    @test occursin("wrapping:", sv)
    @test occursin(sprint(show, MIME("text/plain"), parent(sl)), sv)
    sv = sprint(show, MIME("text/plain"), NoLookup())
    @test occursin("NoLookup", sv)
    # Lookup tuple
    ls = lookup(ds)
    sv = sprint(show, MIME("text/plain"), ls)
    @test occursin("Categorical", sv)
    @test occursin("Sampled", sv)
    sv = sprint(show, MIME("text/plain"), Transformed(identity))
    @test occursin("Transformed", sv)
    nds = (X(NoLookup(Base.OneTo(10))), Y(NoLookup(Base.OneTo(5))))
    sv = sprint(show, MIME("text/plain"), nds)
    @test sv == "(↓ X, → Y)"
end

@testset "Selectors" begin
    @testset "At" begin
        s = sprint(show, MIME("text/plain"), At(1))
        @test s == "At(1)"
        s = sprint(show, MIME("text/plain"), At(1, atol=0.1))
        @test s == "At(1; atol=0.1)"
        s = sprint(show, MIME("text/plain"), Near(1))
        @test s == "Near(1)"
        s = sprint(show, MIME("text/plain"), Near())
        @test s == "Near()"
        s = sprint(show, MIME("text/plain"), Contains(1))
        @test s == "Contains(1)"
        s = sprint(show, MIME("text/plain"), Contains())
        @test s == "Contains()"
        s = sprint(show, MIME("text/plain"), Between(1,2))
        @test s == "Between((1, 2))"
        s = sprint(show, MIME("text/plain"), Where(>=(10)))
        @test startswith(s, "Where")
        @test occursin(">=", s)
        s = sprint(show, MIME("text/plain"), All(At(10), At(20)))
        s == "All((At(10), At(20)))"
    end
end

@testset "DimSelectors" begin
    a = rand(X(1:10), Y(4:11))
    d = DimSelectors(a, selectors=Near())
    sd = sprint(show, MIME("text/plain"), d)
    @test occursin("DimSelectors", sd)
    @test occursin("10×8", sd)
    @test occursin("(Near(), Near())", sd)
    @test occursin("X Near(1)", sd)
end

@testset "BeginEnd" begin
    lplus = Begin+6
    slp = sprint(show, MIME("text/plain"), lplus)
    @test slp == "(Begin+6)"
    lplusr = 6+Begin
    slpr = sprint(show, MIME("text/plain"), lplusr)
    @test slpr == "(6+Begin)"
    ldiv = div(End,2)
    sld = sprint(show, MIME("text/plain"), ldiv)
    @test sld == "(End÷2)"
    ldivnest = (End÷2) +1
    sldn = sprint(show, MIME("text/plain"), ldivnest)
    @test sldn == "((End÷2)+1)"
    berange = Begin:(End-1)
    sber = sprint(show, MIME("text/plain"), berange)
    @test sber == "Begin:(End-1)"
    bserange = Begin:3:End
    sbser = sprint(show, MIME("text/plain"), bserange)
    @test sbser == "Begin:3:End"
    lmax = max(3,Begin)
    slmax = sprint(show, MIME("text/plain"), lmax)
    @test slmax == "max(3, Begin)"
    lmax = max(Begin,3)
    slmax = sprint(show, MIME("text/plain"), lmax)
    @test slmax == "max(Begin, 3)"
    lmin = min(3,Begin)
    slmin = sprint(show, MIME("text/plain"), lmin)
    @test slmin == "min(3, Begin)"
    lmin = min(Begin,3)
    slmin = sprint(show, MIME("text/plain"), lmin)
    @test slmin == "min(Begin, 3)"
end

@testset "arrays" begin
    d, str = Lat(), "Lat"
    for (d, str) in ((Ti(), "Ti"), (Lat(), "Lat"), (Lon(), "Lon"), (:n, "n"), (Z(), "Z")) 
        s1 = sprint(show, MIME("text/plain"), A)
        s2 = sprint(show, MIME("text/plain"), dims(A, ds))
        s3 = sprint(show, MIME("text/plain"), dims(A, ds))
        @test occursin("DimArray", s1)
        for s in (s1, s2, s3)
            @test occursin(str, s)
            @test occursin(str, s)
        end
    end

    s1 = sprint(show, MIME("text/plain"), A)
    @test occursin("test", s1)

    # Does it propagate after indexing?
    F = A[Ti(1:4)]
    s2 = sprint(show, MIME("text/plain"), F)
    @test occursin("test", s2)

    # Does it propagate after e.g. reducing operations?
    G = sum(A; dims = Ti)
    s3 = sprint(show, MIME("text/plain"), G)
    @test occursin("test", s3)

    # It should NOT propagate after binary operations
    B = DimArray(rand(length.(ds)...), ds; name=:test2)
    C = A .+ B
    s4 = sprint(show, MIME("text/plain"), C)
    @test !occursin("test", s4)

    # Test that broadcasted setindex! retains name
    D = DimArray(ones(length.(ds)...), ds; name=:olo)
    @. D = A + B
    s5 = sprint(show, MIME("text/plain"), D)
    @test occursin("olo", s5)

    # Test zero dim show
    D = DimArray([x for x in 1], (); name=:zero)
    sz = sprint(show, MIME("text/plain"), D)
    @test occursin("zero", sz)

    # Test vector show
    D = DimArray(ones(length(t)), t; name=:vec)
    sv = sprint(show, MIME("text/plain"), D)
    @test occursin("1", sv)
    @test occursin("vec", sv)

    # Test matrix show
    D = ones()
    D = DimArray(ones(X(5), Y(5)); name=:vec)
    sv = sprint(show, MIME("text/plain"), D)
    @test occursin("1", sv)

    # Test higher-dimensional data.
    D = DimArray(rand(2, 2, 2), (x = [(1, 1), (1, 2)], y = ['a', 'b'], z = [2, "b"]))
    sv = sprint(show, MIME("text/plain"), D)
    @test occursin('a', sv) && occursin('b', sv)
    @test occursin("(1, 1)", sv) && occursin("(1, 2)", sv)

    # Test trailing zero dimension
    @test_nowarn sprint(show, MIME("text/plain"), ones(X(1), Y(1), Z(0)))
    @test_nowarn sprint(show, MIME("text/plain"), ones(X(1), Y(0), Z(1)))
    @test_nowarn sprint(show, MIME("text/plain"), ones(X(0), Y(0), Z(0)))
end

@testset "stack" begin
    st = DimStack(A; metadata=Dict(:x => 1))
    sv = sprint(show, MIME("text/plain"), st)
    @test occursin("DimStack", sv)
    @test occursin("Lon", sv)
    @test occursin("Lat", sv)
    @test occursin("Ti", sv)
    @test occursin("Z", sv)
    @test occursin("test", sv)
    @test occursin(":x => 1", sv)
end

@testset "DimTree" begin
     xdim, ydim = map(DimensionalData.format, (X(1:10), Y(1:15)))
     z1, z2 = map(DimensionalData.format, (Z(["A", "B", "C"]), Z(["C", "D"])))
     a = rand(xdim, ydim; name=:a)
     b = rand(Float32, xdim, ydim; name=:b)
     c = rand(Int, xdim, ydim, z1; name=:c)
     d = rand(Int, xdim, z2; name=:d)
     dt = DimTree(a, b)
    sv = sprint(show, MIME("text/plain"), dt)
    @test occursin("DimTree", sv)
    @test occursin("layers", sv)
    dt.mybranch = DimTree(c)
    sc = sprint(show, MIME("text/plain"), dt)
    @test occursin("branches", sc)
    @test occursin("mybranch", sc)
    @test occursin(":c", sc)

end

@testset "DiskArray show" begin
    da = AccessCountDiskArray(rand(10,10))
    dd = DimArray(da, (X(1:10), Y(1:10)))
    sc = sprint(show, MIME("text/plain"), dd)
    @test getindex_count(da) == 0 
end

const DimArrayOrStack = Union{AbstractDimArray,AbstractDimStack}

"""
    set(x, val)
    set(x, dims::Pairs...)
    set(x, dims::Tuple{Vararg{Dimension}})
    set(x; kw...)

Set the properties of an object, its internal data or the traits 
of its dimensions and lookup index, returning a new, rebuild object.

Related properties will be updated to match the change, for example,
changing the order of a lookup from ForwardOrdered to ReverseOrdered will reverse the
data as well. See [`unsafe_set`](@ref) for a version that makes the specified change.

`x` can be a `AbstractDimArray`, `AbstractDimStack`, `Dimension`, `Lookup` or
`LookupTrait`.

As DimensionalData is so strongly typed you do not need to specify what field
of a [`Lookup`](@ref) to `set` - there is usually no ambiguity.

## Updating object dimensions

To swap or alter the `Lookup` of an objects dimensions, you need to specify the dimension.
This can be done using `set(obj, X => val)` pairs or `set(obj, X(val))` wrapped arguments.

You can also update all dimensions by passing a lookup trait 
e.g. `set(obj, ForwardOrdered)`. This will be set for all dimensions.

When a `Dimension` or `Lookup` is passed to `set` to replace the
existing ones, fields that were not set will keep their original values.

## Updating object data

Passing an `AbstractArray` to `set` will update the data of the object.

## Updating object fields

Keywords can be passed to `set` to update the fields of an object,
working like keyword `rebuild` but updating related fields where needed.

Fields are always the same as keywords for the objects constructor.

## Examples

Update the data in a `DimArray`:

```jldoctest set
julia> using DimensionalData; const DD = DimensionalData;

julia> da = DimArray(zeros(3, 4), (custom=10.0:010.0:30.0, Z=-20:010.0:10.0));

julia> set(da, ones(3, 4))
┌ 3×4 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────────────── dims ┐
  ↓ custom Sampled{Float64} 10.0:10.0:30.0 ForwardOrdered Regular Points,
  → Z Sampled{Float64} -20.0:10.0:10.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────────┘
  ↓ →  -20.0  -10.0  0.0  10.0
 10.0    1.0    1.0  1.0   1.0
 20.0    1.0    1.0  1.0   1.0
 30.0    1.0    1.0  1.0   1.0
```

Change the `Dimension` wrapper type:

```jldoctest set
julia> set(da, :Z => Ti, :custom => Z)
┌ 3×4 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────────── dims ┐
  ↓ Z Sampled{Float64} 10.0:10.0:30.0 ForwardOrdered Regular Points,
  → Ti Sampled{Float64} -20.0:10.0:10.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────┘
  ↓ →  -20.0  -10.0  0.0  10.0
 10.0    0.0    0.0  0.0   0.0
 20.0    0.0    0.0  0.0   0.0
 30.0    0.0    0.0  0.0   0.0
```

Change the dimension lookup values:

```jldoctest set
julia> set(da, Z => [:a, :b, :c, :d], :custom => [4, 5, 6])
┌ 3×4 DimArray{Float64, 2} ┐
├──────────────────────────┴──────────────────────────────────── dims ┐
  ↓ custom Sampled{Int64} [4, …, 6] ForwardOrdered Irregular Points,
  → Z Sampled{Symbol} [:a, …, :d] ForwardOrdered Irregular Points
└─────────────────────────────────────────────────────────────────────┘
 ↓ →   :a   :b   :c   :d
 4    0.0  0.0  0.0  0.0
 5    0.0  0.0  0.0  0.0
 6    0.0  0.0  0.0  0.0
```

Change the `Lookup` type:

```jldoctest set
julia> set(da, Z => DD.NoLookup(), :custom => DD.Sampled())
┌ 3×4 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────────────── dims ┐
  ↓ custom Sampled{Float64} 10.0:10.0:30.0 ForwardOrdered Regular Points,
  → Z
└──────────────────────────────────────────────────────────────────────────┘
 10.0  0.0  0.0  0.0  0.0
 20.0  0.0  0.0  0.0  0.0
 30.0  0.0  0.0  0.0  0.0
```

Change the `Sampling` trait:

```jldoctest set
julia> set(da, :custom => DD.Irregular(10, 12), Z => DD.Regular(9.9))
┌ 3×4 DimArray{Float64, 2} ┐
├──────────────────────────┴─────────────────────────────────────────── dims ┐
  ↓ custom Sampled{Float64} 10.0:10.0:30.0 ForwardOrdered Irregular Points,
  → Z Sampled{Float64} -20.0:10.0:10.0 ForwardOrdered Regular Points
└────────────────────────────────────────────────────────────────────────────┘
  ↓ →  -20.0  -10.0  0.0  10.0
 10.0    0.0    0.0  0.0   0.0
 20.0    0.0    0.0  0.0   0.0
 30.0    0.0    0.0  0.0   0.0
```

Set the name of a `DimArray`:

```jldoctest set
julia> set(da; name=:newname)
┌ 3×4 DimArray{Float64, 2} newname ┐
├──────────────────────────────────┴───────────────────────────────── dims ┐
  ↓ custom Sampled{Float64} 10.0:10.0:30.0 ForwardOrdered Regular Points,
  → Z Sampled{Float64} -20.0:10.0:10.0 ForwardOrdered Regular Points
└──────────────────────────────────────────────────────────────────────────┘
  ↓ →  -20.0  -10.0  0.0  10.0
 10.0    0.0    0.0  0.0   0.0
 20.0    0.0    0.0  0.0   0.0
 30.0    0.0    0.0  0.0   0.0
```
"""
set(x::DimArrayOrStack, args...; kw...) = 
    _set(Safe(), _set(Safe(), x, args...); kw...)
set(x::DimArrayOrStack, ::Type{T}) where T = set(x, T())

"""
    unsafe_set(x, val)
    unsafe_set(x, dims::Pairs...)
    unsafe_set(x, dims::Tuple{Vararg{Dimension}})
    unsafe_set(x; kw...)

Set the properties of an object, its internal data or the traits
of its dimensions and lookup index, returning a new, rebuild object.

Works the same as [`set`](@ref) but does not update other 
properties to match any changes.

It is usually type stable and can be faster than `set`,
but can produce broken objects if used incorrectly.

`unsafe_set` with keywords is identical to `rebuild`.
"""
unsafe_set(x::DimArrayOrStack, args...; kw...) = 
    _set(Unsafe(), _set(Unsafe(), x, args...); kw...)
unsafe_set(x::DimArrayOrStack, ::Type{T}) where T = unsafe_set(x, T())

# Keywords are passed to rebuild, but with checks
function _set(s::Safety, A::AbstractDimArray;
    data=nothing, dims=nothing, kw...
)
    A1 = isnothing(data) ? A : _set_dimarray_data(s, A, data)
    A2 = isnothing(dims) ? A1 : _set(s, A1, dims)
    # Just `rebuild` everything else, it's assumed to have no interactions.
    # Package developers note: if other fields do interact, implement this
    # method for your own `AbstractDimArray` type.
    return rebuild(A2; kw...)
end
function _set(s::Safety, st::AbstractDimStack;
    data=nothing, dims=nothing, kw...
)
    st1 = isnothing(data) ? st : _set_dimstack_data(s, st, data)
    st2 = isnothing(dims) ? st1 : _set(s, st1, dims)
    # Just `rebuild` everything else, it's assumed to have no interactions.
    # Package developers note: if other fields do interact, implement this
    # method for your own `AbstractDimStack` type.
    return rebuild(st2; kw...)
end

# Dimensions and pairs are set for dimensions 
# Short circuit here to avoid multiple allocations
function _set(
    s::Safety, A::AbstractDimArray, args::Union{Dimension,DimTuple,Pair}...
)
    newdims = _set(s, dims(A), args...)
    return rebuild(_rebuild_maybe_reorder(s, A, newdims); dims=newdims)
end
function _set(
    s::Safety, st::AbstractDimStack, args::Union{Dimension,DimTuple,Pair}...
)
    newdims = _set(s, dims(st), args...)
    if dimsmatch(newdims, dims(st))
        _rebuild_maybe_reorder(s, st, newdims)
    else
        dim_updates = map(rebuild, basedims(st), basedims(newdims))
        lds = map(layerdims(st)) do lds
            # Swap out the dims with the updated dims
            # that match the dims of this layer
            map(val, dims(dim_updates, lds))
        end
        # After renaming, deduplicate any dimensions that now have the same type
        deduped = _dedup_dims(newdims)
        rebuild(_rebuild_maybe_reorder(s, st, deduped); dims=deduped, layerdims=lds)
    end
end
# Single traits are set for all dimensions
_set(s::Safety, A::DimArrayOrStack, x::LookupTrait) = 
    _set(s, A, map(d -> basedims(d) => x, dims(A))...)
# Single lookups are set for all dimensions.
_set(s::Safety, A::AbstractDimArray, x::Lookup) = 
    _set(s, A, map(d -> rebuild(d, x), dims(A))...)
_set(s::Safety, A::AbstractDimStack, x::Lookup) = 
    _set(s, A, map(d -> rebuild(d, x), dims(A))...)
# Arrays are set as data for AbstractDimArray
_set(s::Safety, A::AbstractDimArray, newdata::AbstractArray) =
    _set_dimarray_data(s, A, newdata)
# AutoValues means keep existing data
_set(::Safety, A::AbstractDimArray, ::Lookups.AutoValues) = A
_set(s::Safety, A::AbstractDimStack, newdata::NamedTuple) =
    _set_dimstack_data(s, A, newdata)

# Check dimensions for Safe
function _set_dimarray_data(::Safe, A, data)
    checkaxis(dims(A), axes(data))
    rebuild(A; data)
end
# Just rebuild for Unsafe
_set_dimarray_data(::Unsafe, A, data) = rebuild(A; data)

# NamedTuples are set as data for AbstractDimStack
function _set_dimstack_data(::Safe, st, newdata)
    # Allow updating subsets of data for NamedTuple
    newdata1 = if parent(st) isa NamedTuple && newdata isa NamedTuple
        ConstructionBase.setproperties(parent(st), newdata)
    else
        keys(st) === keys(newdata) || _keyerr(keys(st), keys(newdata))
        newdata
    end
    # Make sure the data matches the dimensions
    map(layerdims(st), newdata1) do lds, nd
        # TODO a message with the layer name could help here
        checkaxis(dims(st, lds), axes(nd))
    end
    return rebuild(st; data=newdata1)
end
# Just rebuild for Unsafe
_set_dimstack_data(::Unsafe, st, data) = rebuild(st; data)

@noinline _axiserr(a, b) = _axiserr(axes(a), axes(b))
@noinline _axiserr(a::Tuple, b::Tuple) = 
    throw(ArgumentError("passed in axes $b do not match the currect axes $a"))
@noinline _keyerr(ka, kb) = throw(ArgumentError("keys $ka and $kb do not match"))

_rebuild_maybe_reorder(::Unsafe, A, newdims) = A
# Handle any changes to order
function _rebuild_maybe_reorder(::Safe, A, newdims)
    if map(order, dims(A)) == map(order, newdims)
        rebuild(A; dims=newdims)
    else
        A1 = reorder(A, map(rebuild, dims(A), order(newdims)))
        rebuild(A; data=parent(A1), dims=newdims)
    end
end

# Deduplicate dimensions that have the same type (e.g., after renaming Z to X)
# Keep the first occurrence of each dimension type
_dedup_dims(dims::Tuple) = foldl(dims; init=()) do acc, d
    any(x -> basetypeof(x) === basetypeof(d), acc) ? acc : (acc..., d)
end

"""
    Lookups

Module for [`Lookup`](@ref)s and [`Selector`](@ref)s used in DimensionalData.jl

`Lookup` defines traits and `AbstractArray` wrappers
that give specific behaviours for a lookup index when indexed with [`Selector`](@ref).

For example, these allow tracking over array order so fast indexing works even when 
the array is reversed.

To load `Lookup` types and methods into scope:

```julia
using DimensionalData
using DimensionalData.Lookups
```
"""
module Lookups

using Dates, IntervalSets, Extents
import ConstructionBase
import InvertedIndices

using InvertedIndices: Not
using Base: tail, OneTo, @propagate_inbounds

export order, sampling, span, bounds, dim,
    metadata, units, sort, val, locus, intervalbounds

export hasselection, selectindices

export reducelookup, shiftlocus, maybeshiftlocus, promote_first

export issampled, iscategorical, iscyclic, isnolookup, isintervals, ispoints, isregular,
    isexplicit, isstart, iscenter, isend, isordered, isforward, isreverse, hasinternaldimensions

export Selector
export At, Between, Touches, Contains, Near, Where, All
export ..
export Not

export LookupTrait
export Order, Ordered, ForwardOrdered, ReverseOrdered, Unordered, AutoOrder
export Sampling, Points, Intervals, AutoSampling, NoSampling
export Span, Regular, Irregular, Explicit, AutoSpan, NoSpan
export Position, Locus, Center, Start, End, AutoLocus, AutoPosition
export Metadata, NoMetadata
export AutoStep, AutoBounds, AutoValues

export Lookup
export AutoLookup, AbstractNoLookup, NoLookup
export Aligned, AbstractSampled, Sampled, AbstractCyclic, Cyclic, AbstractCategorical, Categorical
export Unaligned, Transformed, ArrayLookup

# Deprecated
export LookupArray

# As much as possible keyword rebuild is automatic
rebuild(x; kw...) = ConstructionBase.setproperties(x, (; kw...))

include("lookup_traits.jl")
include("metadata.jl")
include("lookup_arrays.jl")
include("beginend.jl")
include("predicates.jl")
include("selector.jl")
include("indexing.jl")
include("methods.jl")
include("utils.jl")
include("set.jl")
include("show.jl")

end

### Shared utils

"""
    refdims_title(A::AbstractDimArray)
    refdims_title(refdims::Tuple)
    refdims_title(refdim::Dimension)

Generate a title string based on reference dimension values.
"""
function refdims_title end
refdims_title(A::AbstractArray; kw...) = refdims_title(refdims(A); kw...)
function refdims_title(refdims::Tuple; kw...)
    join(map(rd -> refdims_title(rd; kw...), refdims), ", ")
end
function refdims_title(refdim::Dimension; kw...)
    string(label(refdim), ": ", refdims_title(lookup(refdim), refdim; kw...))
end
function refdims_title(lookup::AbstractSampled, refdim::Dimension; kw...)
    start, stop = map(string, bounds(refdim))
    if start == stop
        start
    else
         "$start to $stop"
    end
end
function refdims_title(lookup::Lookup, refdim::Dimension; kw...)
    if parent(refdim) isa AbstractArray
        string(first(parent(refdim)))
    else
        string(parent(refdim))
    end
end

const PLOT_DIMENSION_ORDER = (TimeDim, XDim, IndependentDim, IndependentDim, YDim, ZDim, DependentDim, DependentDim, Dimension, Dimension, Dimension)
forward_order_plot_dims(x) = dims(dims(x), PLOT_DIMENSION_ORDER)
reverse_order_plot_dims(x) = reverse(forward_order_plot_dims(reverse(dims(x))))

using DimensionalData, Test, Unitful
using Dates
using DimensionalData.Lookups, DimensionalData.Dimensions
using DimensionalData.Lookups: _slicespan, isrev, _bounds
using DimensionalData.Dimensions: _slicedims

@testset "locus" begin
    @test locus(NoSampling()) == Center()
    @test locus(NoLookup()) == Center()
    @test locus(Categorical()) == Center()
    @test locus(Sampled(; sampling=Points())) == Center()
    @test locus(Sampled(; sampling=Intervals(Center()))) == Center()
    @test locus(Sampled(; sampling=Intervals(Start()))) == Start()
    @test locus(Sampled(; sampling=Intervals(End()))) == End()
end

@testset "equality" begin
    ind = 10:14
    n = NoLookup(ind)
    c = Categorical(ind; order=ForwardOrdered())
    cr = Categorical(reverse(ind); order=ReverseOrdered())
    s = Sampled(ind; order=ForwardOrdered(), sampling=Points(), span=Regular(1))
    si = Sampled(ind; order=ForwardOrdered(), sampling=Intervals(), span=Regular(1))
    sir = Sampled(ind; order=ForwardOrdered(), sampling=Intervals(), span=Irregular())
    sr = Sampled(reverse(ind); order=ReverseOrdered(), sampling=Points(), span=Regular(1))
    @test n == n
    @test c == c
    @test s == s
    @test n != s
    @test n != c
    @test c != s
    @test sr != s
    @test si != s
    @test sir != s
    @test cr != c
end

@testset "isrev" begin
    @test isrev(ForwardOrdered()) == false
    @test isrev(ReverseOrdered()) == true
    @test isrev(Unordered()) == false
    @test_throws MethodError isrev(1)
end

@testset "reverse" begin
    @test reverse(ForwardOrdered()) == ReverseOrdered()
    @test reverse(ReverseOrdered()) == ForwardOrdered()
    @test reverse(Unordered()) == Unordered()
    lu = Sampled(order=ForwardOrdered(), span=Regular(1))
    @test order(reverse(lu)) == ReverseOrdered()
    lu = Categorical(order=ReverseOrdered())
    @test order(reverse(lu)) == ForwardOrdered()
end

@testset "getindex" begin
    ind = [10.0, 20.0, 30.0, 40.0, 50.0]

    @testset "Irregular forwards" begin
        m = Sampled(ind, order=ForwardOrdered(), span=Irregular((10.0, 60.0)), sampling=Intervals(Start()))
        mr = Sampled(ind, order=ForwardOrdered(), span=Regular(10.0), sampling=Intervals(Start()))
        @test bounds(getindex(m, 3:3)) == (30.0, 40.0)
        @test bounds(getindex(m, 1:5)) == (10.0, 60.0)
        @test bounds(getindex(m, 2:3)) == (20.0, 40.0)
        m = Sampled(ind, ForwardOrdered(), Irregular((0.0, 50.0)), Intervals(End()), NoMetadata())
        mr = Sampled(ind, ForwardOrdered(), Regular(10.0), Intervals(End()), NoMetadata())
        @test bounds(getindex(m, 3:3)) == (20.0, 30.0)
        @test bounds(getindex(m, 1:5)) == (0.0, 50.0)
        @test bounds(getindex(m, 2:3)) == (10.0, 30.0)
        m = Sampled(ind, ForwardOrdered(), Irregular((5.0, 55.0)), Intervals(Center()), NoMetadata())
        mr = Sampled(ind, ForwardOrdered(), Regular(10.0), Intervals(Center()), NoMetadata())
        @test bounds(getindex(m, 3:3)) == bounds(getindex(mr, 3:3)) == (25.0, 35.0)
        @test bounds(getindex(m, 1:5)) == bounds(getindex(mr, 1:5)) == (5.0, 55.0)
        @test bounds(getindex(m, 2:3)) == bounds(getindex(mr, 2:3)) == (15.0, 35.0)
    end

    @testset "Irregular reverse" begin
        revind = [50.0, 40.0, 30.0, 20.0, 10.0]
        m = Sampled(revind; order=ReverseOrdered(), span=Irregular(10.0, 60.0), sampling=Intervals(Start()))
        mr = Sampled(revind; order=ReverseOrdered(), span=Regular(-10.0), sampling=Intervals(Start()))
        @test bounds(getindex(m, 1:5)) == bounds(getindex(mr, 1:5)) == (10.0, 60.0)
        @test bounds(getindex(m, 1:2)) == bounds(getindex(mr, 1:2)) == (40.0, 60.0)
        @test bounds(getindex(m, 2:3)) == bounds(getindex(mr, 2:3)) == (30.0, 50.0)
        m = Sampled(revind, ReverseOrdered(), Irregular(0.0, 50.0), Intervals(End()), NoMetadata())
        mr = Sampled(revind, ReverseOrdered(), Regular(-10.0), Intervals(End()), NoMetadata())
        @test bounds(getindex(m, 1:5)) == bounds(getindex(mr, 1:5)) == (0.0, 50.0)
        @test bounds(getindex(m, 1:2)) == bounds(getindex(mr, 1:2)) == (30.0, 50.0)
        @test bounds(getindex(m, 2:3)) == bounds(getindex(mr, 2:3)) == (20.0, 40.0)
        m = Sampled(revind, ReverseOrdered(), Irregular(5.0, 55.0), Intervals(Center()), NoMetadata())
        mr = Sampled(revind, ReverseOrdered(), Regular(-10.0), Intervals(Center()), NoMetadata())
        @test bounds(getindex(m, 1:5)) == bounds(getindex(mr, 1:5)) == (5.0, 55.0)
        @test bounds(getindex(m, 1:2)) == bounds(getindex(mr, 1:2)) == (35.0, 55.0)
        @test bounds(getindex(m, 2:3)) == bounds(getindex(mr, 2:3)) == (25.0, 45.0)
    end

    @testset "Irregular with no bounds" begin
        m = Sampled(ind, ForwardOrdered(), Irregular(nothing, nothing), Intervals(Start()), NoMetadata())
        @test bounds(getindex(m, 3:3)) == (30.0, 40.0)
        @test bounds(getindex(m, 2:4)) == (20.0, 50.0)
        # TODO should this be built into `identify` to at least get one bound?
        @test bounds(getindex(m, 1:5)) == (10.0, nothing)
        m = Sampled(ind, ForwardOrdered(), Irregular(nothing, nothing), Intervals(End()), NoMetadata())
        @test bounds(getindex(m, 3:3)) == (20.0, 30.0)
        @test bounds(getindex(m, 2:4)) == (10.0, 40.0)
        @test bounds(getindex(m, 1:5)) == (nothing, 50.0)
        m = Sampled(ind, ForwardOrdered(), Irregular(nothing, nothing), Intervals(Center()), NoMetadata())
        @test bounds(getindex(m, 3:3)) == (25.0, 35.0)
        @test bounds(getindex(m, 2:4)) == (15.0, 45.0)
        @test bounds(getindex(m, 1:5)) == (nothing, nothing)
    end

end

@testset "bounds and intervalbounds" begin
    @testset "Intervals" begin
        @testset "Regular bounds are calculated from interval type and span value" begin
            @testset "Forward Center DateTime" begin
                ind = DateTime(2000):Month(1):DateTime(2000, 11)
                dim = format(X(ind; sampling=Intervals(Center())))
                @test bounds(dim) == (DateTime(1999, 12, 16, 12), DateTime(2000, 11, 16))
                @test intervalbounds(dim, 3) == (DateTime(2000, 03, 15, 12), DateTime(2000, 02, 14, 12))
            end
            @testset "Reverse Center DateTime" begin
                ind = DateTime(2000, 11):Month(-1):DateTime(2000, 1)
                dim = format(X(ind; sampling=Intervals(Center())))
                @test bounds(dim) == (DateTime(1999, 12, 16, 12), DateTime(2000, 11, 16))
                @test intervalbounds(dim, 3) == (DateTime(2000, 09, 16, 12), DateTime(2000, 08, 17))
            end
            @testset "forward ind" begin
                ind = 10.0:10.0:50.0
                dim = X(Sampled(ind, order=ForwardOrdered(), sampling=Intervals(Start()), span=Regular(10.0)))
                @test bounds(dim) == (10.0, 60.0)
                @test intervalbounds(dim, 2) == (20.0, 30.0)
                @test intervalbounds(dim) == [
                    (10.0, 20.0)
                    (20.0, 30.0)
                    (30.0, 40.0)
                    (40.0, 50.0)
                    (50.0, 60.0)
                ]
                dim = X(Sampled(ind, order=ForwardOrdered(), sampling=Intervals(End()), span=Regular(10.0)))
                @test bounds(dim) == (0.0, 50.0)
                @test intervalbounds(dim, 2) == (10.0, 20.0)
                @test intervalbounds(dim) == [
                    (0.0, 10.0)
                    (10.0, 20.0)
                    (20.0, 30.0)
                    (30.0, 40.0)
                    (40.0, 50.0)
                ]
                dim = X(Sampled(ind, order=ForwardOrdered(), sampling=Intervals(Center()), span=Regular(10.0)))
                @test bounds(dim) == (5.0, 55.0)
                @test intervalbounds(dim, 2) == (15.0, 25.0)
                @test intervalbounds(dim) == [
                    (5.0, 15.0)
                    (15.0, 25.0)
                    (25.0, 35.0)
                    (35.0, 45.0)
                    (45.0, 55.0)
                ]
                # Test non keyword constructors too
                dim = X(Sampled(ind, ForwardOrdered(), Regular(10.0), Intervals(Start()), NoMetadata()))
                @test bounds(dim) == (10.0, 60.0)                                        
                dim = X(Sampled(ind, ForwardOrdered(), Regular(10.0), Intervals(End()), NoMetadata()))
                @test bounds(dim) == (0.0, 50.0)                                         
                dim = X(Sampled(ind, ForwardOrdered(), Regular(10.0), Intervals(Center()), NoMetadata()))
                @test bounds(dim) == (5.0, 55.0)
            end
            @testset "reverse ind" begin
                revind = [10.0, 9.0, 8.0, 7.0, 6.0]
                dim = X(Sampled(revind, ReverseOrdered(), Regular(-1.0), Intervals(Start()), NoMetadata()))
                @test bounds(dim) == (6.0, 11.0)
                @test intervalbounds(dim, 2) == (9.0, 10.0)
                @test intervalbounds(dim) == [
                    (10.0, 11.0)
                    (9.0, 10.0)
                    (8.0, 9.0)
                    (7.0, 8.0)
                    (6.0, 7.0)
                ]
                dim = X(Sampled(revind, ReverseOrdered(), Regular(-1.0), Intervals(End()), NoMetadata()))
                @test bounds(dim) == (5.0, 10.0)
                @test intervalbounds(dim, 2) == (8.0, 9.0)
                @test intervalbounds(dim) == [
                    (9.0, 10.0)
                    (8.0, 9.0)
                    (7.0, 8.0)
                    (6.0, 7.0)
                    (5.0, 6.0)
                ]
                dim = X(Sampled(revind, ReverseOrdered(), Regular(-1.0), Intervals(Center()), NoMetadata()))
                @test bounds(dim) == (5.5, 10.5)
                @test intervalbounds(dim, 2) == (8.5, 9.5)
                @test intervalbounds(dim) == [
                    (9.5, 10.5)
                    (8.5, 9.5)
                    (7.5, 8.5)
                    (6.5, 7.5)
                    (5.5, 6.5)
                ]
            end
        end
        @testset "Irregular bounds are whatever is stored in span" begin
            ind = 10.0:10.0:50.0
            dim = X(Sampled(ind, ForwardOrdered(), Irregular(10.0, 50000.0), Intervals(Start()), NoMetadata()))
            @test bounds(dim) == (10.0, 50000.0)
            @test bounds(getindex(dim, 2:3)) == (20.0, 40.0)
            @test intervalbounds(dim) == [
                (10.0, 20.0)
                (20.0, 30.0)
                (30.0, 40.0)
                (40.0, 50.0)
                (50.0, 50000.0)
            ]
        end
        @testset "Explicit bounds are is stored in span matrix" begin
            ind = 10.0:10.0:50.0
            bnds = vcat(ind', (20.0:10.0:60.0)')
            dim = X(Sampled(ind, ForwardOrdered(), Explicit(bnds), Intervals(Start()), NoMetadata()))
            @test bounds(dim) == (10.0, 60.0)
            @test bounds(_slicedims(getindex, dim, 2:3)[1][1]) == (20.0, 40.0)
            @test intervalbounds(dim) == [
                (10.0, 20.0)
                (20.0, 30.0)
                (30.0, 40.0)
                (40.0, 50.0)
                (50.0, 60.0)
            ]
        end
    end

    @testset "Points" begin
        ind = 10:15
        dim = X(Sampled(ind; order=ForwardOrdered(), sampling=Points()))
        @test bounds(dim) == (10, 15)
        ind = 15:-1:10
        dim = X(Sampled(ind; order=ReverseOrdered(), sampling=Points()))
        last(dim), first(dim)
        @test bounds(dim) == (10, 15)
        dim = X(Sampled(ind; order=Unordered(), sampling=Points()))
        @test bounds(dim) == (nothing, nothing)
        @test intervalbounds(dim) == collect(zip(15:-1:10, 15:-1:10))
    end

    @testset "Categorical" begin
        ind = [:a, :b, :c, :d]
        dim = X(Categorical(ind; order=ForwardOrdered()))
        @test order(dim) == ForwardOrdered()
        @test_throws ErrorException step(dim)
        @test span(dim) == NoSpan()
        @test sampling(dim) == NoSampling()
        @test dims(lookup(dim)) === nothing
        @test locus(dim) == Center()
        @test bounds(dim) == (:a, :d)
        dim = X(Categorical(ind; order=ReverseOrdered()))
        @test bounds(dim) == (:d, :a)
        @test order(dim) == ReverseOrdered()
        dim = X(Categorical(ind; order=Unordered()))
        @test bounds(dim) == (nothing, nothing)
        @test order(dim) == Unordered()
        @test_throws ErrorException intervalbounds(dim)
    end

    @testset "Cyclic" begin
        vals = -180.0:1:179.0
        l = Cyclic(vals; cycle=360.0, order=ForwardOrdered(), span=Regular(1.0), sampling=Intervals(Start()))
        dim = X(l)
        @test order(dim) == ForwardOrdered()
        @test step(dim) == 1.0
        @test span(dim) == Regular(1.0)
        @test sampling(dim) == Intervals(Start())
        @test locus(dim) == Start()
        @test bounds(dim) == (-Inf, Inf)
        # Indexing with AbstractArray returns Sampled
        for f in (getindex, view, Base.dotview)
            @test f(l, 1:10) isa Sampled
        end
        # TODO clarify intervalbounds - we cant return the whole set to typemax, so we return onecycle?
        # @test intervalbounds(dim) 
        dim = X(Cyclic(reverse(vals); cycle=360.0, order=ReverseOrdered(), span=Regular(1.0), sampling=Intervals(Start())))
        @test bounds(dim) == (typemin(Float64), typemax(Float64))
        @test order(dim) == ReverseOrdered()
        @test bounds(dim) == (-Inf, Inf)
        @test_throws ArgumentError Cyclic(vals; cycle=360, order=Unordered())
    end

end

@testset "dims2indices with Transformed" begin
    tdimz = X(Transformed(identity)), Y(Transformed(identity)), Z(NoLookup(1:1))
    @test dims2indices(tdimz, (X(1), Y(2), Z())) == (1, 2, Colon())
end

@testset "Pointer conversion" begin
    x = Sampled(rand(10))
    @test Base.unsafe_convert(Ptr{Float64}, x) == pointer(parent(x)) == pointer(x)
    @test strides(x) == (1,)
end

using DimensionalData, Test, Dates
using DimensionalData.Lookups, DimensionalData.Dimensions
using .Lookups: shiftlocus, maybeshiftlocus
using DimensionalData: uniquekeys

@testset "reverse" begin
    @testset "dimension" begin
        revdima = reverse(X(Sampled(10:10:20; order=ForwardOrdered(), span=Regular(10))))
        @test lookup(revdima) == 20:-10:10
        @test order(revdima) === ReverseOrdered()
        @test span(revdima) === Regular(-10)
    end

    A = [1 2 3; 4 5 6]
    da = DimArray(A, (X(10:10:20), Y(300:-100:100)); name=:test)
    s = DimStack(da)

    rev_y = reverse(da; dims=Y)
    @test rev_y == [3 2 1; 6 5 4]
    @test lookup(rev_y, X) == 10:10:20
    @test lookup(rev_y, Y) == 100:100:300
    @test span(rev_y, Y) == Regular(100)
    @test order(rev_y, Y) == ForwardOrdered()
    @test order(rev_y, X) == ForwardOrdered()

    rev = reverse(da; dims=:)
    @test parent(rev) == reverse(parent(da))
    @test all(lookup(rev, d) == reverse(lookup(da, d)) for d in (X,Y))
    @test all(span(rev, d) == reverse(span(da, d)) for d in (X,Y))
    @test all(order(rev, d) == reverse(order(da, d)) for d in (X,Y))
    @test rev == reverse(da; dims=(X,Y))


    @testset "NoLookup is not reversed" begin
        da = DimArray(A, (X(), Y()))
        revd = reverse(da)
        @test lookup(revd) == axes(da)
    end

    @testset "stack" begin
        dimz = (X([:a, :b]), Y(10.0:10.0:30.0))
        da1 = DimArray(A, dimz; name=:one)
        da2 = DimArray(Float32.(2A), dimz; name=:two)
        da3 = DimArray(Int.(3A), dimz; name=:three)

        s = DimStack((da1, da2, da3))
        rev_s = reverse(s; dims=X)
        @test rev_s[:one] == [4 5 6; 1 2 3]
        @test rev_s[:three] == [12 15 18; 3 6 9]
    end
end

@testset "reorder" begin
    A = [1 2 3; 4 5 6]
    da = DimArray(A, (X(10:10:20), Y(300:-100:100)); name=:test)
    s = DimStack(da)

    reo = reorder(da, ReverseOrdered())
    @test reo == [4 5 6; 1 2 3]
    @test lookup(reo, X) == 20:-10:10
    @test lookup(reo, Y) == 300:-100:100
    @test order(reo, X) == ReverseOrdered()
    @test order(reo, Y) == ReverseOrdered()

    reo = reorder(da, X=>ForwardOrdered(), Y=>ReverseOrdered())
    @test reo == A
    @test lookup(reo, X) == 10:10:20
    @test lookup(reo, Y) == 300:-100:100
    @test order(reo, X) == ForwardOrdered()
    @test order(reo, Y) == ReverseOrdered()

    reo = reorder(da, X=>ReverseOrdered(), Y=>ForwardOrdered())
    @test reo == [6 5 4; 3 2 1]
    @test lookup(reo, X) == 20:-10:10
    @test lookup(reo, Y) == 100:100:300
    @test order(reo, X) == ReverseOrdered()
    @test order(reo, Y) == ForwardOrdered()

    revallis = reverse(da; dims=(X, Y))
    @test all(lookup(revallis) .== (20:-10:10, 100:100:300))
    @test order(revallis) == (ReverseOrdered(), ForwardOrdered())

    d = reorder(dims(da, Y), ForwardOrdered()) 
    @test order(d) isa ForwardOrdered
    @test lookup(d) == 100:100:300

    # reorder with dimension lookups
    rev = reverse(da, dims=Y)
    reo = reorder(rev, da)
    @test rev != da
    @test reo == da
    @test dims(reo) == dims(da)
    @test_throws MethodError reorder(rev, :test)
    rev_s = reverse(s, dims=Y)
    reo_s = reorder(rev_s, da)
    @test rev_s != s
    @test reo_s == s
    @test dims(reo_s) == dims(s)

    @testset "reorder handles extra dimensions" begin
        @test reorder(da[X=1], X=>ReverseOrdered(), Y=>ForwardOrdered()) == rev[X=1]
        @test reorder(rev_s[X=1], da) == s[X=1]
    end

    @testset "unordered are sorted" begin
        x, y = X([:a, :c, :b]), Y([1, 4, 2, 3])
        A = rand(x, y)
        Af = reorder(A, ForwardOrdered())
        @test parent(Af) == A[X=[1, 3, 2], Y=[1, 3, 4, 2]]
        @test lookup(Af) == lookup(reorder(dims(A), ForwardOrdered())) ==
         (Categorical([:a, :b, :c], ForwardOrdered(), NoMetadata()), 
            Sampled([1, 2, 3, 4], ForwardOrdered(), Irregular(nothing,nothing), Points(), NoMetadata()))
    end
end

@testset "modify" begin
    A = [1 2 3; 4 5 6]
    dimz = (X(10:10:20), Y(300:-100:100))
    @testset "array" begin
        da = DimArray(A, dimz)
        mda = modify(A -> A .> 3, da)
        @test dims(mda) === dims(da)
        @test mda == [false false false; true true true]
        @test typeof(parent(mda)) == BitArray{2}
        @test_throws ErrorException modify(A -> A[1, :], da)
    end
    @testset "stack" begin
        da1 = DimArray(A, dimz; name=:da1)
        da2 = DimArray(2A, dimz; name=:da2)
        s = DimStack(da1, da2)
        ms = modify(A -> A .> 3, s)
        @test parent(ms) == (da1=[false false false; true true true],
                             da2=[false true  true ; true true true])
        @test typeof(parent(ms[:da2])) == BitArray{2}
    end
    @testset "dimension" begin
        dim = X(Sampled(10:10:20))
        mdim = modify(x -> 3 .* x, dim)
        @test lookup(mdim) == 30:30:60 # in Julia 1.6: typeof(30:30:60)==StepRange ; in Julia 1.7 typeof(30:30:60)==StepRangeLen
        da = DimArray(A, dimz)
        mda = modify(y -> vec(4 .* y), da, Y)
        @test lookup(mda, Y) == [1200.0, 800.0, 400.0]
    end
end

@testset "broadcast_dims" begin
    A2 = [1 2 3; 4 5 6]
    B1 = [1, 2, 3]
    da2 = DimArray(A2, (X([20, 30]), Y([:a, :b, :c])))
    db1 = DimArray(B1, (Y([:a, :b, :c]),))
    dc1 = broadcast_dims(+, db1, db1)
    @test dc1 == [2, 4, 6]
    dc2 = broadcast_dims(+, da2, db1)
    @test dc2 == [2 4 6; 5 7 9]
    dc4 = broadcast_dims(+, da2, db1)

    A3 = cat([1 2 3; 4 5 6], [11 12 13; 14 15 16]; dims=3)
    da3 = DimArray(A3, (X, Y, Z))
    db2 = DimArray(A2, (X, Y))
    dc3 = broadcast_dims(+, da3, db2)
    @test dc3 == cat([2 4 6; 8 10 12], [12 14 16; 18 20 22]; dims=3)

    A3 = cat([1 2 3; 4 5 6], [11 12 13; 14 15 16]; dims=3)
    da3 = DimArray(A3, (X([20, 30]), Y([:a, :b, :c]), Z(10:10:20)))
    db1 = DimArray(B1, (Y([:a, :b, :c]),))
    dc3 = broadcast_dims(+, da3, db1)
    @test dc3 == cat([2 4 6; 5 7 9], [12 14 16; 15 17 19]; dims=3)

    @testset "works with permuted dims" begin
        db2p = permutedims(da2)
        dc3p = broadcast_dims(+, da3, db2p)
        @test dc3p == cat([2 4 6; 8 10 12], [12 14 16; 18 20 22]; dims=3)
    end

    @test_throws DimensionMismatch broadcast_dims!(+, db1, zeros(Z(3)))
    @test broadcast_dims(+, db1, ones(Z(3))) == [2.0 2.0 2.0; 3.0 3.0 3.0; 4.0 4.0 4.0]

    @testset "works with 0-dimensional arrays" begin
        da4 = DimArray(fill(4), ())
        @test broadcast_dims(+, da4, da4) == DimArray(fill(8), ())
        @test broadcast_dims(*, da4, da3) == parent(da4) .* parent(da3)
        @test dims(broadcast_dims(*, da4, da3)) == dims(da3)
    end

    @testset "DimStack" begin
        A3 = cat([1 2 3; 4 5 6], [11 12 13; 14 15 16]; dims=3)
        da3 = DimArray(A3, (X([20, 30]), Y([:a, :b, :c]), Z(10:10:20)))
        db1 = DimArray(B1, (Y([:a, :b, :c]),))
        stack1 = DimStack(da3, db1)
        stack2 = DimStack(da3, db1, dc3)
        @test broadcast_dims(+, stack1, da3, db1) == broadcast_dims(+, da3, db1, stack1)
        @test broadcast_dims(+, stack1, da3, db1).layer1 == broadcast_dims(+, stack1.layer1, da3, db1)
        @test broadcast_dims(+, stack1, da3, stack1, db1) == broadcast_dims(+, da3, stack1, db1, stack1)
        # Cant mix numvers of stack layers
        @test_throws ArgumentError broadcast_dims(+, stack1, da3, db1, stack2)
    end
end

@testset "shiftlocus" begin
    dim = X(Sampled(1.0:3.0, ForwardOrdered(), Regular(1.0), Intervals(Center()), NoMetadata()))
    @test parent(lookup(shiftlocus(Start(), dim))) === 0.5:1.0:2.5
    @test parent(lookup(shiftlocus(End(), dim))) === 1.5:1.0:3.5
    @test parent(lookup(shiftlocus(Center(), dim))) === 1.0:1.0:3.0
    @test locus(shiftlocus(Start(), dim)) === Start()
    @test locus(shiftlocus(End(), dim)) === End()
    @test locus(shiftlocus(Center(), dim)) === Center()
    dim = X(Sampled([3, 4, 5], ForwardOrdered(), Regular(1), Intervals(Start()), NoMetadata()))
    @test val(shiftlocus(End(), dim)) == [4, 5, 6]
    @test val(shiftlocus(Center(), dim)) == [3.5, 4.5, 5.5]
    @test val(shiftlocus(Start(), dim)) == [3, 4, 5]
    dim = X(Sampled([3, 4, 5], ForwardOrdered(), Regular(1), Intervals(End()), NoMetadata()))
    @test val(shiftlocus(End(), dim)) == [3, 4, 5]
    @test val(shiftlocus(Center(), dim)) == [2.5, 3.5, 4.5]
    @test val(shiftlocus(Start(), dim)) == [2, 3, 4]

    dates = DateTime(2000):Month(1):DateTime(2000, 12)
    ti = Ti(Sampled(dates, ForwardOrdered(), Regular(Month(1)), Intervals(Start()), NoMetadata()))
    @test lookup(shiftlocus(Center(), ti)) == dates .+ (dates .+ Month(1) .- dates) ./ 2

    bnds = vcat((0.5:2.5)', (1.5:3.5)')
    dim = X(Sampled(1.0:3.0, ForwardOrdered(), Explicit(bnds), Intervals(Center()), NoMetadata()))
    start_dim = shiftlocus(Start(), dim)
    @test lookup(start_dim) == [0.5, 1.5, 2.5]
    @test locus(start_dim) == Start()
    end_dim = shiftlocus(End(), start_dim)
    @test lookup(end_dim) == [1.5, 2.5, 3.5]
    @test locus(end_dim) == End()
    center_dim = shiftlocus(Center(), end_dim)
    @test lookup(center_dim) == lookup(dim)
    @test locus(center_dim) == Center()
end

@testset "maybeshiftlocus" begin
    dim = X(Sampled(1.0:3.0, ForwardOrdered(), Regular(1.0), Intervals(Center()), NoMetadata()))
    @test val(maybeshiftlocus(Start(), dim)) == 0.5:1.0:2.5
    dim = X(Sampled(1.0:3.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))
    @test val(maybeshiftlocus(Start(), dim)) == 1.0:3.0
end

@testset "dim2boundsmatrix" begin
    @testset "Regular span" begin
        dim = X(Sampled(1.0:3.0, ForwardOrdered(), Regular(1.0), Intervals(Center()), NoMetadata()))
        @test Dimensions.dim2boundsmatrix(dim) == [0.5 1.5 2.5
                                                   1.5 2.5 3.5]
        dim = X(Sampled(1.0:3.0, ForwardOrdered(), Regular(1.0), Intervals(Start()), NoMetadata()))
        @test Dimensions.dim2boundsmatrix(dim) == [1.0 2.0 3.0
                                                   2.0 3.0 4.0]
        dim = X(Sampled(3.0:-1:1.0, ReverseOrdered(), Regular(-1.0), Intervals(End()), NoMetadata()))
        @test Dimensions.dim2boundsmatrix(dim) == [2.0 1.0 0.0
                                                   3.0 2.0 1.0]
        dim = X(Sampled(LinRange(3.0, 1.0, 3), ReverseOrdered(), Regular(-1.0), Intervals(Center()), NoMetadata()))
        @test Dimensions.dim2boundsmatrix(dim) == [2.5 1.5 0.5
                                                   3.5 2.5 1.5]
        rnge = LinRange(59.95, -40.05, 1001)
        dim = X(Sampled(rnge; order=ReverseOrdered(), span=Regular(step(rnge)), sampling=Intervals(Center())))
        @test Dimensions.selectindices(dim, Contains(7.35)) == 527
        mat = Dimensions.dim2boundsmatrix(dim) 
        dim = X(Sampled(rnge; order=ReverseOrdered(), span=Explicit(mat), sampling=Intervals(Center())))
        @test Dimensions.selectindices(dim, Contains(7.35)) == 527
    end
    @testset "Explicit span" begin
        dim = X(Sampled(1.0:3.0, ForwardOrdered(),
                Explicit([0.0 1.0 2.0; 1.0 2.0 3.0]), Intervals(End()), NoMetadata()))
        @test Dimensions.dim2boundsmatrix(dim) == [0.0 1.0 2.0
                                                   1.0 2.0 3.0]
    end
end

@testset "uniquekeys" begin
    da1 = rand(X(2), Y(2); name=:name1)
    da2 = rand(X(2), Y(2); name=:name1)
    da3 = rand(X(2), Y(2); name=:name2)
    @test uniquekeys([da1, da2, da3]) == [:layer1, :layer2, :name2] # Should we keep thoe original name?
    @test uniquekeys((da1, da2, da3)) == (:layer1, :layer2, :name2) # Should we keep thoe original name?
    @test uniquekeys([:name1, :name1, :name2]) == [:layer1, :layer2, :name2] # Should we keep thoe original name?
    @test uniquekeys((:name1, :name1, :name2)) == (:layer1, :layer2, :name2) 
    @test uniquekeys(Symbol[]) == Symbol[]
    @test uniquekeys(()) == ()
end

const DimSetters = Union{Lookup,LookupSetters,Tuple,Dimension,Symbol}

set(dim::Dimension, x::DimSetters) = _set(Safe(), dim, x)
set(dims::DimTuple, x::DimSetters) = _set(Safe(), dims, x)
set(dims::DimTuple, p::Pair) = _set(Safe(), dims, p)
set(dims::DimTuple, a1::Union{Dimension,Pair}, a2::Union{Dimension,Pair}, args::Union{Dimension,Pair}...) =
    _set(Safe(), dims, a1, a2, args...)

unsafe_set(dim::Dimension, x::DimSetters) = _set(Unsafe(), dim, x)
unsafe_set(dims::DimTuple, x::DimSetters) = _set(Unsafe(), dims, x)
unsafe_set(dims::DimTuple, p::Pair) = _set(Unsafe(), dims, p)
unsafe_set(dims::DimTuple, a1::Union{Dimension,Pair}, a2::Union{Dimension,Pair}, args::Union{Dimension,Pair}...) =
    _set(Unsafe(), dims, a1, a2, args...)

_set(s::Safety, dims::DimTuple, l::LookupSetters) =
    _set(s, dims, map(d -> rebuild(d, l), dims)...)

# Convert pairs to wrapped dims and set
_set(s::Safety, dims::DimTuple, p::Pair, ps::Pair...) =
    _set(s, dims, (p, ps...))
_set(s::Safety, dims::DimTuple, ps::Tuple{Vararg{Pair}}) =
    _set(s, dims, pairs2dims(ps...))
_set(s::Safety, dims::DimTuple, ::Tuple{}) = dims
_set(s::Safety, dims::DimTuple, newdims::Dimension...) =
    _set(s, dims, newdims)
# Set dims with (possibly unsorted) wrapper vals
_set(s::Safety, dims::DimTuple, wrappers::DimTuple) = begin
    # Check the dimension types match
    map(wrappers) do w
        hasdim(dims, w) || _wrongdimserr(dims, w)
    end
    # Missing dims return `nothing` from sortdims
    newdims = map(dims, sortdims(wrappers, dims)) do d, w
        _set(s, d, w)
    end
    # Swaps existing dims with non-nothing new dims
    swapdims(dims, newdims)
end

# Set things wrapped in dims
_set(s::Safety, dim::Dimension, wrapper::Dimension{<:DimSetters}) = begin
    rewrapped = _set(s, dim, basetypeof(wrapper))
    _set(s, rewrapped, val(wrapper))
end
_set(s::Safety, dim::Dimension, l::Union{Lookup,LookupSetters}) =
    rebuild(dim, _set(s, val(dim), l))
# Set the dim, checking the lookup
_set(s::Safety, dim::Dimension, newdim::Dimension) =
    _set(s, newdim, _set(s, val(dim), val(newdim)))
_set(s::Safety, dim::Dimension, newdim::Dimension{<:Type}) =
    _set(s, dim, val(newdim)())
_set(s::Safety, dim::Dimension, key::Symbol) = _set(s, dim, name2dim(key))
_set(s::Safety, dim::Dimension, x) = rebuild(dim, _set(s, val(dim), x))
_set(s::Safety, dim::Dimension, ::Type{T}) where T = _set(s, dim, T())

# Metadata
_set(s::Safety, dim::Dimension, newmetadata::AllMetadata) =
    rebuild(dim, _set(s, lookup(dim), newmetadata))

_set(::Safety, x::Dimension, ::Nothing) = x
_set(::Safety, ::Nothing, x::Dimension) = x
_set(::Safety, ::Nothing, ::Nothing) = nothing
_set(::Safety, x, ::Nothing) = x
_set(::Safety, ::Nothing, x) = x
# For ambiguity
_set(::Safety, dims::DimTuple, ::Nothing) = dims
_set(::Safety, dims::Lookup, ::Nothing) = dims

@noinline _wrongdimserr(dims, w) =
    throw(ArgumentError("dim $(basetypeof(w))) not in $(map(basetypeof, dims))"))

# reverse
Base.reverse(lookup::NoLookup) = lookup
Base.reverse(lookup::AutoLookup) = lookup
function Base.reverse(lookup::AbstractCategorical)
    i = reverse(parent(lookup))
    o = reverse(order(lookup))
    rebuild(lookup; data=i, order=o)
end
function Base.reverse(lookup::AbstractSampled)
    i = reverse(parent(lookup))
    o = reverse(order(lookup))
    sp = reverse(span(lookup))
    rebuild(lookup; data=i, order=o, span=sp)
end

# Order
Base.reverse(::ReverseOrdered) = ForwardOrdered()
Base.reverse(::ForwardOrdered) = ReverseOrdered()
Base.reverse(o::Unordered) = Unordered()

# Span
Base.reverse(span::Irregular) = span
Base.reverse(span::Regular) = Regular(-step(span))
Base.reverse(span::Explicit) = Explicit(reverse(val(span), dims=2))

# Base show
function Base.summary(io::IO, tree::AbstractDimTree)
    print(io, nameof(typeof(tree)))
end

function Base.show(io::IO, mime::MIME"text/plain", tree::AbstractDimTree)
    blockwidth = show_main(io, mime, tree)
    ctx = IOContext(io, :blockwidth => blockwidth)
    show_branches(ctx, mime, tree)
    show_after(ctx, mime, tree)
    return nothing
end

# Show customisation interface
function show_main(io, mime, tree::AbstractDimTree)
    lines, blockwidth, displaywidth = print_top(io, mime, tree)
    if !isempty(data(tree))
        blockwidth, _ = print_layers_block(io, mime, tree; blockwidth, displaywidth)
    end
    _, blockwidth, _  = print_metadata_block(io, mime, metadata(tree); 
        displaywidth, blockwidth=min(displaywidth-2, blockwidth)
    )
    return blockwidth
end

function show_branches(io, mime, tree::AbstractDimTree)
    blockwidth = get(io, :blockwidth, 0)
    if !isempty(branches(tree))
        blockwidth = print_block_separator(io, "branches", blockwidth, blockwidth)
        println(io)
        for key in keys(branches(tree))
            print_branch(io, branches(tree)[key], key)
        end
    end
    return blockwidth
end

function print_branch(io, branch::AbstractDimTree, key::Symbol; tab="  ", indent="    ")
    pkey = ":" * rpad(key, _keylen(keys(branch)))
    print(io, tab)
    printstyled(io, pkey, color=dimcolor(7))
    field_dims = DD.dims(branch)
    if !isempty(field_dims)
        colors = map(dimcolor, eachindex(field_dims))
        printstyled(io, " dims: "; color=:light_black)
        for (i, (dim, color)) in enumerate(zip(field_dims, colors))
            Dimensions.print_dimname(IOContext(io, :dimcolor => color), dim)
            i != length(field_dims) && print(io, ", ")
        end
        printstyled(io, " size: "; color=:light_black)
        print_sizes(io, size(field_dims); colors)
        if !isempty(keys(branch))
            printstyled(io, " layers: "; color=:light_black)
            printstyled(io, join(map(k -> string(":", k), keys(branch)), ", "); color=dimcolor(7))
        end
    end
    # Print the branches of the branch
    ks = collect(keys(branches(branch)))
    println(io)
    if length(ks) > 0
        for key1 in ks[1:end-1]
            printstyled(io, indent, "├─ "; color=:light_black)
            print_branch(io, branches(branch)[key1], key1; tab="", indent=indent * "│    ")
        end
        printstyled(io, indent, "└─ "; color=:light_black)
        print_branch(io, branches(branch)[last(ks)], last(ks); tab="", indent=indent * "    ")
    end
end

function show_after(io, mime, tree::AbstractDimTree)
    blockwidth = get(io, :blockwidth, 0)
    print_block_close(io, blockwidth)
end

using DimensionalData
using DimensionalData.Dimensions
using DimensionalData.Lookups
using Test
using Extents

@testset "hasinternaldimensions trait" begin
    # Test default behavior for regular lookups
    @testset "Regular lookups return false" begin
        @test hasinternaldimensions(NoLookup()) == false
        @test hasinternaldimensions(Sampled(1:10)) == false
        @test hasinternaldimensions(Categorical([:a, :b, :c])) == false
        @test hasinternaldimensions(Cyclic(1:12; cycle=12)) == false
        # Test with different span types
        @test hasinternaldimensions(Sampled(1:10; sampling=Points())) == false
        @test hasinternaldimensions(Sampled(1:10; sampling=Intervals())) == false
    end

    @testset "MergedLookup returns true" begin
        x_dim = X(1:3)
        y_dim = Y(10:10:30)
        merged_data = vec(DimPoints((x_dim, y_dim)))
        merged_lookup = MergedLookup(merged_data, (x_dim, y_dim))
        @test hasinternaldimensions(merged_lookup) == true
    end

    @testset "MultiDimensionalLookup abstract type" begin
        # Create a custom MultiDimensionalLookup for testing
        struct TestMultiDimLookup{T} <: DimensionalData.Dimensions.MultiDimensionalLookup{T}
            data::Vector{T}
        end
        
        test_lookup = TestMultiDimLookup([1, 2, 3])
        @test hasinternaldimensions(test_lookup) == true
    end
end

@testset "Extent passthrough for MergedLookup" begin
    @testset "Basic extent with MergedLookup" begin
        # Create dimensions that will be merged
        x_vals = 1.0:3.0
        y_vals = 10.0:10.0:30.0
        x_dim = X(x_vals)
        y_dim = Y(y_vals)
        
        # Create a merged dimension
        merged_dims = mergedims((x_dim, y_dim) => :space)
        
        # Calculate extent
        ext = Extents.extent((merged_dims,))
        
        # Check that extent has the original dimension names
        @test haskey(ext, :X)
        @test haskey(ext, :Y)
        
        # Check bounds are correct
        @test ext.X == (1.0, 3.0)
        @test ext.Y == (10.0, 30.0)
    end

    @testset "Mixed regular and merged dimensions" begin
        # Regular dimensions
        t_dim = Ti(1:5)
        z_dim = Z(100:100:300)
        
        # Dimensions to merge
        x_dim = X(1.0:3.0)
        y_dim = Y(10.0:10.0:30.0)
        
        # Create mixed tuple with regular and merged dims
        merged_space = mergedims((x_dim, y_dim) => :space)
        all_dims = (t_dim, merged_space, z_dim)
        
        # Calculate extent
        ext = Extents.extent(all_dims)
        
        # Check regular dimensions
        @test ext.Ti == (1, 5)
        @test ext.Z == (100, 300)
        
        # Check merged dimensions are expanded
        @test ext.X == (1.0, 3.0)
        @test ext.Y == (10.0, 30.0)
    end

    @testset "Multiple merged dimensions" begin
        # First pair to merge
        x1_dim = X(1:3)
        y1_dim = Y(10:10:30)
        
        # Second pair to merge (using different dimension types)
        t_dim = Ti(0.0:0.5:1.0)
        z_dim = Z(-5:5)
        
        # Create two merged dimensions
        merged_space = mergedims((x1_dim, y1_dim) => :space)
        merged_tz = mergedims((t_dim, z_dim) => :timez)
        
        all_dims = (merged_space, merged_tz)
        
        # Calculate extent
        ext = Extents.extent(all_dims)
        
        # Check all original dimensions are present
        @test ext.X == (1, 3)
        @test ext.Y == (10, 30)
        @test ext.Ti == (0.0, 1.0)
        @test ext.Z == (-5, 5)
    end

    @testset "Extent with subset of dimensions" begin
        x_dim = X(1:5)
        y_dim = Y(10:10:50)
        z_dim = Z(100:100:300)
        
        merged = mergedims((x_dim, y_dim) => :space)
        all_dims = (merged, z_dim)
        
        # Get extent for just the Z dimension
        ext_z = Extents.extent(all_dims, Z)
        @test ext_z.Z == (100, 300)
        @test !haskey(ext_z, :X)
        @test !haskey(ext_z, :Y)
        
        # Get extent for merged dimension by name
        ext_space = Extents.extent(all_dims, :space)
        @test ext_space.X == (1, 5)
        @test ext_space.Y == (10, 50)
        @test !haskey(ext_space, :Z)
    end
end

@testset "Multidimensional lookup indexing" begin
    @testset "dims2indices with MergedLookup" begin
        # Create a DimArray with merged dimensions
        x_dim = X(1:3)
        y_dim = Y(10:10:30)
        regular_data = rand(3, 3)
        
        # Create array and merge dimensions
        da = DimArray(regular_data, (x_dim, y_dim))
        merged_da = mergedims(da, (X, Y) => :space)
        
        # Test that indexing with original dimension selectors works
        # This should use the multidimensional indexing path
        result = merged_da[X(At(2)), Y(At(20))]
        @test result isa Number
        
        # Near selector is intentionally unsupported for MergedLookup
        @test_throws ArgumentError merged_da[X(Near(2.1)), Y(Near(19))]
    end

    @testset "otherdims filtering for multidimensional lookups" begin
        x_dim = X(1:3)
        y_dim = Y(10:10:30)
        z_dim = Z(100:100:300)
        
        merged = mergedims((x_dim, y_dim) => :space)
        all_dims = (merged, z_dim)
        
        # Get dims that are not multidimensional
        regular_dims = Dimensions.dims(all_dims, d -> !hasinternaldimensions(lookup(d)))
        @test length(regular_dims) == 1
        @test first(regular_dims) isa Z
        
        # Get dims that are multidimensional
        multi_dims = Dimensions.dims(all_dims, d -> hasinternaldimensions(lookup(d)))
        @test length(multi_dims) == 1
        @test first(multi_dims) isa Dim{:space}
    end
end

@testset "Edge cases and error handling" begin
    @testset "Empty merged dimensions" begin
        # Test with empty vector
        empty_merged = MergedLookup(Vector{Tuple{Float64,Float64}}(), ())
        @test hasinternaldimensions(empty_merged) == true
        
        # Extent should handle empty merged lookups gracefully
        dim_with_empty = Dim{:empty}(empty_merged)
        @test_nowarn Extents.extent((dim_with_empty,))
    end

    @testset "Single dimension in MergedLookup" begin
        # Merge a single dimension (edge case)
        x_dim = X(1:5)
        single_merged = mergedims(x_dim => :single)
        
        @test hasinternaldimensions(lookup(single_merged)) == true
        
        # Extent should still work
        ext = Extents.extent((single_merged,))
        @test ext.X == (1, 5)
    end

    @testset "Nested merged dimensions handling" begin
        # This is likely not supported, but test for graceful behavior
        x_dim = X(1:3)
        y_dim = Y(10:10:30)
        z_dim = Z(100:100:300)
        
        # First merge
        merged_xy = mergedims((x_dim, y_dim) => :space2d)
        
        # Try to merge again with another dimension
        # This might not be intended usage but shouldn't crash
        all_dims = (merged_xy, z_dim)
        ext = Extents.extent(all_dims)
        
        @test ext.X == (1, 3)
        @test ext.Y == (10, 30)
        @test ext.Z == (100, 300)
    end
end

@testset "Integration with DimArray operations" begin
    @testset "Broadcasting with merged dimensions" begin
        x = X(1:3)
        y = Y(10:10:30)
        data = rand(3, 3)
        
        da = DimArray(data, (x, y))
        merged_da = mergedims(da, (X, Y) => :space)
        
        # Broadcasting should preserve merged structure
        result = merged_da .+ 1
        @test size(result) == size(merged_da)
        @test dims(result) == dims(merged_da)
        @test hasinternaldimensions(lookup(dims(result, :space)))
    end

    @testset "Slicing preserves multidimensional trait" begin
        x = X(1:5)
        y = Y(10:10:50)
        z = Z(1:3)
        data = rand(5, 5, 3)
        
        da = DimArray(data, (x, y, z))
        merged_da = mergedims(da, (X, Y) => :space)
        
        # Slice on Z dimension
        sliced = merged_da[Z(At(2))]
        
        # Check that space dimension still has multidimensional trait
        space_dim = dims(sliced, :space)
        @test hasinternaldimensions(lookup(space_dim))
        
        # Check extent still works
        ext = Extents.extent(dims(sliced))
        @test haskey(ext, :X)
        @test haskey(ext, :Y)
    end
end

@testset "Performance considerations" begin
    @testset "Extent calculation performance" begin
        # Create larger dimensions for performance testing
        x = X(1:100)
        y = Y(1:100)
        z = Z(1:50)
        t = Ti(1:200)
        
        # Mix of regular and merged dimensions
        merged_xy = mergedims((x, y) => :space)
        all_dims = (merged_xy, z, t)
        
        # This should complete quickly even with larger dimensions
        @test_nowarn @time ext = Extents.extent(all_dims)
        
        # Verify correctness
        ext = Extents.extent(all_dims)
        @test ext.X == (1, 100)
        @test ext.Y == (1, 100)
        @test ext.Z == (1, 50)
        @test ext.Ti == (1, 200)
    end
end

ENV["JULIA_CONDAPKG_ENV"] = "@dimensionaldata-tests"
ENV["JULIA_CONDAPKG_BACKEND"] = "MicroMamba"
ENV["JULIA_CONDAPKG_VERBOSITY"] = -1

# If you've already run the tests once to create the test Python environment,
# you can comment out the lines above and uncomment the lines below. That will
# re-use the environment without re-resolving it, which is a bit faster.
# ENV["JULIA_PYTHONCALL_EXE"] = joinpath(Base.DEPOT_PATH[1], "conda_environments", "dimensionaldata-tests", "bin", "python")
# ENV["JULIA_CONDAPKG_BACKEND"] = "Null"

# Copy CondaPkg.toml to the test project so that it gets found by CondaPkg
# during the tests. If this was instead in the project directory it would also
# be used by CondaPkg outside of the tests, which we don't want.
cp(joinpath(@__DIR__, "CondaPkg.toml"), joinpath(dirname(Base.active_project()), "CondaPkg.toml"))

using DimensionalData, Test, PythonCall
import DimensionalData.Dimensions: NoLookup, NoMetadata


xr = pyimport("xarray")
np = pyimport("numpy")

data = rand(10, 5)
times = sort(rand(10))
x = xr.DataArray(data,
                 dims=("time", "length"),
                 coords=Dict("time" => times),
                 name="data",
                 attrs=Dict("motor" => "hexapod",
                            "pos" => 0.48,
                            "foo" => np.array([1, 2, 3])))

data2 = rand(10, 2)
x2 = xr.DataArray(data2,
                  dims=("time", "mass"),
                  coords=Dict("time" => times),
                  name="data2",
                  attrs=Dict("motor" => "delay",
                             "pos" => 0.48))

@testset "DataArray to DimArray" begin
    y = pyconvert(DimArray, x)
    @test name(y) == "data"
    @test name.(dims(y)) == (:length, :time)
    @test lookup(y, :time) == times
    @test_broken lookup(y, :length) == NoLookup()
    @test metadata(y) == Dict("motor" => "hexapod",
                              "pos" => 0.48,
                              "foo" => [1, 2, 3])

    # Test the zero-copy support
    y[1, 1] = 42f0
    @test parent(y) isa PyArray
    @test pyconvert(Float32, x[0, 0].item()) == 42f0

    # Test copying
    y_copy = pyconvert(DimArray, x; copy=true)
    @test y == y_copy
    @test parent(y_copy) isa Array

    @test_throws ArgumentError pyconvert(DimArray, xr)
    @test pyconvert(DimArray, xr, 42) == 42

    # Sanity test for higher-dimensional arrays
    x3 = xr.DataArray(np.random.rand(2, 5, 5, 3).astype(np.float32),
                      dims=("w", "x", "y", "z"),
                      coords=Dict("w" => [1, 2], "z" => [1, 2, 3]))
    y = pyconvert(DimArray, x3)
    @test lookup(y, :w) == [1, 2]
    @test lookup(y, :z) == [1, 2, 3]
end

@testset "Dataset to DimStack" begin
    dataset = xr.Dataset(Dict("x" => x, "x2" => x2),
                         attrs=Dict("source" => "interwebs"))
    z = pyconvert(DimStack, dataset)

    @test name(z) == (:x2, :x)
    @test name.(dims(z)) == (:mass, :time, :length)
    @test lookup(z, :time) == times
    @test metadata(z) == Dict("source" => "interwebs")

    @test_throws ArgumentError pyconvert(DimStack, x)
    @test pyconvert(DimStack, x, 42) == 42
end

@testset "DimArray to Python conversion" begin
    # Test __array_interface__ specifically because this is what allows for a
    # zero-copy conversion.
    x = rand(X(rand(10)), Y(10))
    x_lookup = lookup(x, X)
    @test @pyeval(x => "x.__array_interface__") isa Py
    @test @pyeval(x_lookup => "x_lookup.__array_interface__") isa Py
end

using DimensionalData, Test, Dates, Statistics, IntervalSets

using DimensionalData.Dimensions
using DimensionalData.Lookups
const DD = DimensionalData

days = DateTime(2000):Day(1):DateTime(2000, 12, 31)
A = DimArray((1:6) * (1:366)', (X(1:0.2:2), Ti(days)))
st = DimStack((a=A, b=A, c=A[X=1]))

@testset "group eltype matches indexed values" begin
    da = rand(X(1:10), Y(1:10))
    grps = groupby(da, X => isodd)
    @test first(grps) isa eltype(grps) # false
end

@testset "groupby name is set" begin
    da = rand(X(1:10), Y(1:10))
    grps = groupby(da, X=>isodd, name="isodd")
    @test name(grps) == "isodd"
end
@testset "manual groupby comparisons" begin
    # Group by month and even/odd Y axis values
    months = DateTime(2000):Month(1):DateTime(2000, 12, 31)
    manualmeans = map(months) do m
        mean(A[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1])
    end
    @test mean.(groupby(A, Ti=>month)) == manualmeans
    combinedmeans = combine(mean, groupby(A, Ti=>month))
    @test combinedmeans isa DimArray
    @test combinedmeans == manualmeans
    manualmeans_st = map(months) do m
        mean(st[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1])
    end
    @test mean.(groupby(st, Ti=>month)) == manualmeans_st
    combinedmeans_st = combine(mean, groupby(st, Ti=>month))
    @test combinedmeans_st isa DimStack{(:a, :b, :c), @NamedTuple{a::Float64, b::Float64, c::Float64}}
    @test collect(combinedmeans_st) == manualmeans_st

    manualsums = mapreduce(hcat, months) do m
        vcat(sum(A[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1, X=1 .. 1.5]), 
             sum(A[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1, X=1.5 .. 2])
        )
    end |> permutedims
    gb_sum = sum.(groupby(A, Ti=>month, X => >(1.5)))
    @test dims(gb_sum, Ti) == Ti(Sampled([1:12...], ForwardOrdered(), Irregular((nothing, nothing)), Points(), NoMetadata()))
    @test typeof(dims(gb_sum, X)) ==
        X{Sampled{Bool, DimensionalData.HiddenVector{Bool, BitVector, Vector{Vector{Int64}}}, ForwardOrdered, Irregular{Tuple{Nothing, Nothing}}, Points, NoMetadata}}
    @test gb_sum == manualsums
    combined_sum = combine(sum, groupby(A, Ti=>month, X => >(1.5)))
    @test collect(combined_sum) == manualsums

    manualsums_st = mapreduce(hcat, months) do m
        vcat(sum(st[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1, X=1 .. 1.5]), 
             sum(st[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1, X=1.5 .. 2])
        )
    end |> permutedims
    gb_sum_st = sum.(groupby(st, Ti=>month, X => >(1.5))) 
    @test dims(gb_sum_st, Ti) == Ti(Sampled([1:12...], ForwardOrdered(), Irregular((nothing, nothing)), Points(), NoMetadata()))
    @test gb_sum_st == manualsums_st
    combined_sum_st = combine(sum, groupby(st, Ti=>month, X => >(1.5)))
    @test collect(combined_sum_st) == manualsums_st

    @test_throws ArgumentError groupby(st, Ti=>month, Y=>isodd)
end

@testset "partial reductions in combine" begin
    months = DateTime(2000):Month(1):DateTime(2000, 12, 31)
    using BenchmarkTools
    manualmeans = cat(map(months) do m
        mean(A[Ti=dayofyear(m):dayofyear(m)+daysinmonth(m)-1]; dims=Ti)
    end...; dims=Ti(collect(1:12)))
    combinedmeans = combine(mean, groupby(A, Ti()=>month); dims=Ti())
    @test combinedmeans == manualmeans
end

@testset "bins" begin
    seasons = DateTime(2000):Month(3):DateTime(2000, 12, 31)
    manualmeans = map(seasons) do s
        range = dayofyear(s):dayofyear(s)+daysinmonth(s)+daysinmonth(s+Month(1))+daysinmonth(s+Month(2))-1
        mean(A[Ti=range])
    end
    @test mean.(groupby(A, Ti=>Bins(month, ranges(1:3:12)))) == manualmeans
    @test mean.(groupby(A, Ti=>Bins(month, intervals(1:3:12)))) == manualmeans
    @test mean.(groupby(A, Ti=>Bins(month, 4))) == manualmeans
    @test combine(mean, groupby(A, Ti=>Bins(month, ranges(1:3:12)))) == manualmeans
    @test mean.(groupby(A, Ti=>CyclicBins(month; cycle = 12, step = 3))) == manualmeans
    @test CyclicBins(; step = 3, cycle = 12) === CyclicBins(identity; step = 3, cycle = 12)
end

@testset "dimension matching groupby" begin
    dates = DateTime(2000):Month(1):DateTime(2000, 12, 31)
    xs = 1.0:1:3.0
    B = rand(X(xs; sampling=Intervals(Start())), Ti(dates; sampling=Intervals(Start())))
    gb = groupby(A, B)
    @test size(gb) === size(B) === size(mean.(gb))
    @test parent(lookup(gb, X)) == parent(lookup(B, X)) == parent(lookup(mean.(gb), X))
    manualmeans = mapreduce(hcat, intervals(dates)) do d
        map(intervals(xs)) do x
            mean(A[X=x, Ti=d])
        end
    end
    @test isequal(collect(mean.(gb)), manualmeans)
    @test isequal(mean.(gb), manualmeans)
    @test isequal(combine(mean, gb), manualmeans)
end

@testset "broadcast_dims runs after groupby" begin
    dimlist = (
        Ti(Date("2021-12-01"):Day(1):Date("2022-12-31")),
        X(range(1, 10, length=10)),
        Y(range(1, 5, length=15)),
        Dim{:Variable}(["var1", "var2"])
    )
    data = rand(396, 10, 15, 2)
    A = DimArray(data, dimlist)
    month_length = DimArray(daysinmonth, dims(A, Ti))
    g_tempo = DimensionalData.groupby(month_length, Ti => seasons(; start=December))
    sum_days = sum.(g_tempo, dims=Ti)
    @test sum_days isa DimArray
    weights = map(./, g_tempo, sum_days)
    @test sum_days isa DimArray
    G = DimensionalData.groupby(A, Ti=>seasons(; start=December))
    G_w = broadcast_dims.(*, weights, G)
    @test G_w isa DimArray
    @test G_w[1] isa DimArray
end

module DimensionalDataAbstractFFTsExt

using DimensionalData
using AbstractFFTs, LinearAlgebra

const DD = DimensionalData

import LinearAlgebra: *

struct Inverse end
struct Forward end
struct RealFFT end
struct ComplexFFT end

const NotQuantity = Union{<:Real,Complex{<:Real}}

"""
    reinterpret_into_datatype(T, vec)

Convinience function to reinterpret a vector of Quantity{T} into a vector of T.
"""
function reinterpret_into_datatype(T::Type{<:NotQuantity}, vec)
    return reinterpret(T, vec)
end,
function reinterpret_into_datatype(T::Type{<:Number}, vec)
    return reinterpret_into_datatype(one(T), vec)
end,
function reinterpret_into_datatype(val::T, vec) where {T<:NotQuantity}
    return reinterpret_into_datatype(T, vec)
end

"""
    DDPlan{T, X, I, F, P<:AbstractFFTs.Plan, A}

Plan for performing FFTs on DimensionalArray. DDPlan wraps an AbstractFFTs.Plan and stores additional information related with the lookups dimensions of the input data. A temporary array `temp` is used to store intermediate results to avoid uncessary allocations when performing multiples FFTs with the same plan.
    T - Data type of the plan.
    X - Data type of the scaling factor related with the dx of the Fourier transform (function get_scale_factor).
    I - Inverse or Forward transform.
    F - Type of the FFT (RealFFT or ComplexFFT).
    P - Type of the AbstractFFTs.Plan that is wrapped.
    A - Type of the temporary array used to store intermediate results. Must match the size of the data in Fourier space.
"""
struct DDPlan{T,X,I,F,P<:AbstractFFTs.Plan,A} <: AbstractFFTs.Plan{T}
    p::P
    temp::A
    function DDPlan{X,I,F}(p::P, temp::A) where {X,I,F,P<:AbstractFFTs.Plan{T},A} where {T}
        return new{T,X,I,F,P,A}(p, temp)
    end
end

AbstractFFTs.fftdims(plan::DDPlan) = AbstractFFTs.fftdims(plan.p)
AbstractFFTs.output_size(plan::DDPlan) = AbstractFFTs.output_size(plan.p)
Base.size(plan::DDPlan) = size(plan.p)

is_inverse_transform(plan::DDPlan{<:Any,<:Any,Inverse}) = true
is_inverse_transform(plan::DDPlan{<:Any,<:Any,Forward}) = false

"""
    _step(lookup)

Simple wrapper to get the step of the lookup dimensions.
"""
function _step(lookup)
    if !DD.Lookups.isregular(lookup)
        throw(
            ArgumentError(
                "The spacing of the lookup along the dimensions to which FFT will be applied must be regular.",
            ),
        )
    end
    return step(lookup)
end,
function _step(x::DD.Dimensions.Dimension{<:AbstractFFTs.Frequencies})
    return step(parent(lookup(x)))
end,
function _step(
    x::DimensionalData.Dimensions.Dimension{
        <:DimensionalData.Dimensions.Lookups.Sampled{<:Any,<:Frequencies{<:Any}}
    },
)
    return step(parent(lookup(x)))
end

"""
    _fftfreq(dd_lookup)

Returns a dimension with the frequencies for a single lookup dimension of the FFT.
"""
function _fftfreq(dd_lookup)
    return DD.basetypeof(dd_lookup)(fftfreq(length(dd_lookup), 1 / _step(dd_lookup)))
end

"""
    _ifftfreq(dd_lookup)
Returns a dimension with the lookup for a single frequency lookup dimension for the inverse FFT.
"""
function _ifftfreq(dd_lookup)
    len = length(dd_lookup)
    dx = 1 / _step(dd_lookup) / len
    return DD.basetypeof(dd_lookup)(range(zero(dx); step=dx, length=len))
end

"""
    _rfftfreq(dd_lookup)
Returns a dimension with the frequencies for a single lookup dimension of the real FFT.
"""
function _rfftfreq(dd_lookup)
    return DD.basetypeof(dd_lookup)(rfftfreq(length(dd_lookup), 1 / _step(dd_lookup)))
end

"""
    _irfftfreq(dd_lookup, len)
Returns a dimension with the lookup for a single frequency lookup dimension for the inverse real FFT.
"""
function _irfftfreq(dd_lookup, len::Integer)
    dx = 1 / _step(dd_lookup) / len
    return DD.basetypeof(dd_lookup)(range(zero(dx); step=dx, length=len))
end

"""
    get_fft_frequencies_dim(::Type{<:DDPlan{<:Any, <:Any, I, R}}, dd_lookup, is_fft_dim, is_first_fft_dim, len) where {I,R}

Returns the lookup dimension of the FFT data for a single dimension. For real FFTs, needs to now the order of the dimension to return the correct frequencies. `is_fft_dim` indicates if the dimension is a FFT dimension, and `is_first_fft_dim` indicates if it is the first FFT dimension. `len` is the length of the output data.

"""
function get_fft_frequencies_dim(
    ::Type{<:DDPlan{<:Any,<:Any,Forward,R}}, dd_lookup, is_fft_dim, is_first_fft_dim, len
) where {R}
    if is_fft_dim
        if is_first_fft_dim
            if R == RealFFT
                _rfftfreq(dd_lookup)
            else
                _fftfreq(dd_lookup)
            end
        else
            _fftfreq(dd_lookup)
        end
    else
        dd_lookup
    end
end,
function get_fft_frequencies_dim(
    ::Type{<:DDPlan{<:Any,<:Any,Inverse,R}}, dd_lookup, is_fft_dim, is_first_fft_dim, len
) where {R}
    if is_fft_dim
        if is_first_fft_dim
            if R == RealFFT
                _irfftfreq(dd_lookup, len)
            else
                _ifftfreq(dd_lookup)
            end
        else
            _ifftfreq(dd_lookup)
        end
    else
        dd_lookup
    end
end

"""
    get_freqs(plan::P, dd::DD.AbstractDimArray{<:Any, N}) where {P<:AbstractFFTs.Plan, N}
Returns the lookups of the transformed data for all dimensions of the input `dd` that are transformed by the FFT plan `plan`. The lookups are returned as a tuple of dimensions, one for each dimension of the input data.
"""
@noinline function get_freqs(
    plan::P, dd::DD.AbstractDimArray{<:Any,N}
) where {P<:AbstractFFTs.Plan,N}
    fft_dims = AbstractFFTs.fftdims(plan)
    is_fft_dims = ntuple(i -> i in fft_dims, N)
    is_first_fft_dim = ntuple(i -> i == first(fft_dims), N)
    out_size = AbstractFFTs.output_size(plan)
    return ntuple(
        i -> get_fft_frequencies_dim(
            P, dims(dd, i), is_fft_dims[i], is_first_fft_dim[i], out_size[i]
        ),
        N,
    )
end

"""
    get_scale_factor(plan::P, dd::DD.AbstractDimArray{T, N}) where {T,P<:AbstractFFTs.Plan, N}

Return the scaling factor of the transform associated with the dx of the Fourier transform which is not included in non-DimensionalData transforms.
"""
function get_scale_factor(
    plan::P, dd::DD.AbstractDimArray{T,N}
) where {T,P<:AbstractFFTs.Plan,N}
    fft_dims = AbstractFFTs.fftdims(plan)
    is_fft_dims = ntuple(i -> i in fft_dims, N)
    steps_dd = ntuple(i -> is_fft_dims[i] ? _step(dims(dd, i)) : 1, N)
    return prod(steps_dd)
end

function (*)(plan::DDPlan{<:Any,X}, dd::DD.AbstractDimArray{T}) where {T,X}
    lookups = get_freqs(plan, dd)
    input_to_plan = if is_inverse_transform(plan)
        copyto!(parent(plan.temp), parent(dd))
        correct_phase_reference!(plan.temp, plan, lookups, 1)
        plan.temp
    else
        dd
    end

    _fft_dd = plan.p * reinterpret_into_datatype(T, parent(input_to_plan))
    fft_dd = reinterpret(
        typeof(Integer(real(oneunit(T)) * oneunit(X)) * oneunit(eltype(_fft_dd))), _fft_dd
    )
    dd_out = DimArray(fft_dd, lookups)
    if !is_inverse_transform(plan)
        correct_phase_reference!(dd_out, plan, lookup(dd), -1)
    end
    return dd_out
end
function LinearAlgebra.mul!(
    dd_out::DD.AbstractDimArray{Tout,N},
    plan::DDPlan{<:Any,Tp},
    dd_in::DD.AbstractDimArray{Tin,N},
) where {N,Tin,Tout,Tp}
    lookups_out = get_freqs(plan, dd_in)
    if !all(i -> dims(dd_out, i) == lookups_out[i], 1:N)
        throw(
            ArgumentError("The lookups of the output and input DimensionalData must match.")
        )
    end
    input_to_plan = if is_inverse_transform(plan)
        copyto!(parent(plan.temp), parent(dd_in))
        correct_phase_reference!(plan.temp, plan, lookups_out, 1)
        plan.temp
    else
        dd_in
    end

    LinearAlgebra.mul!(
        reinterpret_into_datatype(Tout, parent(dd_out)),
        plan.p,
        reinterpret_into_datatype(Tin, parent(input_to_plan)),
    )
    if !is_inverse_transform(plan)
        correct_phase_reference!(dd_out, plan, lookup(dd_in), -1)
    end

    # Corrects for the unit of the output. For example, if the input is g*s and the output is kg*s.
    correct_unit = real(oneunit(Tin) * oneunit(Tp) / oneunit(Tout))
    dd_out .*= correct_unit # Also used as a check to ensure that the output has the correct units.

    return dd_out
end

"""
    correct_phase_reference!(dd::DD.AbstractDimArray{<:Any, N}, plan::DDPlan, lookup_refs, phase_scaling) where N = nothing

Multiply the input `dd` by a phase ramp to account to account for the spatial sampling of the input spatial data.
"""
function correct_phase_reference!(
    dd::DD.AbstractDimArray{<:Any,N}, plan::DDPlan, lookup_refs, phase_scaling
) where {N}
    for i in fftdims(plan)
        @d dd .*= exp.((im * 2π * phase_scaling * first(lookup_refs[i])) .* dims(dd, i))
    end
end

for i in (:fft, :ifft, :rfft)
    signal = i == :ifft ? "i" : "-i"
    fft_freq = i == :ifft ? "ifftfreq" : "fftfreq"
    docsstring = """
          fft(A [, dims])

        Performs a multidimensional $(i) of the array `A`. The optional `dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to transform along. A one-dimensional $(i) computes the one-dimensional discrete Fourier transform (DFT) as defined by:

        ```math
        \\operatorname{DFT}(A)[k] =
        \\sum_{n=1}^{\\operatorname{length}(A)} \\exp\\left($(signal)2\\pi x[n]f[k] \\right) A[n] dx.
        ```
        where `x` is the lookup dimension of the input data, `f` is the lookup dimension of the output data, and `dx` is the step of the lookup dimension of the input data.

        Return a DimensionalData array with the transformed data, where the lookup dimensions are the output of $(fft_freq)
        """
    @eval begin
        function AbstractFFTs.$i(
            dd::AbstractDimArray{<:Any,N}, dims=ntuple(identity, N); kwargs...
        ) where {N}
            plan = $(Symbol(:plan_, i))(dd, dims; kwargs...)
            return plan * dd
        end
    end
end

"""
    irfft(A [, dims])

    Performs a multidimensional ifft of the array `A`. The optional `dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to transform along. A one-dimensional irfft computes the one-dimensional discrete Fourier transform (DFT) as defined by:

        ```math
        \\operatorname{DFT}(A)[k] =
        \\sum_{n=1}^{\\operatorname{length}(A)} \\exp\\left(i2\\pi x[n]f[k] \\right) A[n] dx.
        ```
        where `x` is the lookup dimension of the input data, `f` is the lookup dimension of the output data, and `dx` is the step of the lookup dimension of the input data.

        Return a DimensionalData array with the transformed data, where the lookup dimensions are the output of ifftfreq
"""
function AbstractFFTs.irfft(
    dd::AbstractDimArray{<:Any,N}, len::Integer, dims=ntuple(identity, N); kwargs...
) where {N}
    plan = plan_irfft(dd, len, dims; kwargs...)
    return plan * dd
end

"""
    plan_fft(dd::AbstractDimArray{T, N}, dd_dims = ntuple(identity, N); kwargs...) where {T,N}

Return the plan for performing a multidimensional FFT on the input DimensionalData array `dd`. The optional `dd_dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to transform along. The plan is a DDPlan object that contains all the information needed to compute the FFT quickly.
"""
function AbstractFFTs.plan_fft(
    dd::AbstractDimArray{T,N}, dd_dims=ntuple(identity, N); kwargs...
) where {T,N}
    dims = DD.dimnum(dd, dd_dims)

    p = AbstractFFTs.plan_fft(reinterpret_into_datatype(T, parent(dd)), dims; kwargs...)
    s = get_scale_factor(p, dd)
    unitless_s = s / oneunit(s)
    return DDPlan{typeof(s),Forward,ComplexFFT}(
        AbstractFFTs.ScaledPlan(p, unitless_s), similar(dd, complex(T))
    )
end

"""
    plan_rfft(dd::AbstractDimArray{T, N}, dd_dims = ntuple(identity, N); kwargs...) where {T,N}

Return the plan for performing a multidimensional real FFT on the input DimensionalData array `dd`. The optional `dd_dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to transform along. The plan is a DDPlan object that contains all the information needed to compute the real FFT quickly.
"""
function AbstractFFTs.plan_rfft(
    dd::AbstractDimArray{T,N}, dd_dims=ntuple(identity, N); kwargs...
) where {N,T}
    dims = DD.dimnum(dd, dd_dims)
    p = AbstractFFTs.plan_rfft(reinterpret_into_datatype(T, parent(dd)), dims; kwargs...)
    s = get_scale_factor(p, dd)
    unitless_s = s / oneunit(s)
    return DDPlan{typeof(s),Forward,RealFFT}(
        AbstractFFTs.ScaledPlan(p, unitless_s), similar(dd, complex(T))
    )
end

"""
    plan_ifft(dd::AbstractDimArray{T, N}, dd_dims = ntuple(identity, N); kwargs...) where {N, T}

Return the plan for performing a multidimensional inverse FFT on the input DimensionalData array `dd`. The optional `dd_dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to transform along. The plan is a DDPlan object that contains all the information needed to compute the inverse FFT quickly.
"""
function AbstractFFTs.plan_ifft(
    dd::AbstractDimArray{T,N}, dd_dims=ntuple(identity, N); kwargs...
) where {N,T}
    dims = DD.dimnum(dd, dd_dims)

    p = AbstractFFTs.plan_bfft(reinterpret_into_datatype(T, parent(dd)), dims; kwargs...)
    s = get_scale_factor(p, dd)
    unitless_s = s / oneunit(s)
    return DDPlan{typeof(s),Inverse,ComplexFFT}(
        AbstractFFTs.ScaledPlan(p, unitless_s), similar(dd)
    )
end

function AbstractFFTs.plan_inv(plan::DDPlan)
    throw(
        ErrorException(
            "The plan_inv function is not implemented yet for DDPlan. Use plan_ifft or plan_irfft instead.",
        ),
    )
end

function LinearAlgebra.inv(plan::DDPlan)
    throw(
        ErrorException(
            "The plan_inv function is not implemented yet for DDPlan. Use plan_ifft or plan_irfft instead.",
        ),
    )
end

"""
    plan_irfft(dd::AbstractDimArray{T, N}, len::Integer, dd_dims = ntuple(identity, N); kwargs...) where {N, T}

Return the plan for performing a multidimensional inverse real FFT on the input DimensionalData array `dd`. The optional `dd_dims` argument specifies an iterable subset of dimensions (e.g. an integer, range, tuple, or array) to transform along. The plan is a DDPlan object that contains all the information needed to compute the inverse real FFT quickly.
"""
function AbstractFFTs.plan_irfft(
    dd::AbstractDimArray{T,N}, len::Integer, dd_dims=ntuple(identity, N); kwargs...
) where {N,T}
    dims = DD.dimnum(dd, dd_dims)
    p = AbstractFFTs.plan_brfft(
        reinterpret_into_datatype(T, parent(dd)), len, dims; kwargs...
    )
    s = get_scale_factor(p, dd)
    unitless_s = s / oneunit(s)
    return DDPlan{typeof(s),Inverse,RealFFT}(
        AbstractFFTs.ScaledPlan(p, unitless_s), similar(dd)
    )
end

for f in (:fftshift, :ifftshift)
    docsstring_dd = """
        $(f)(dd::DD.AbstractDimArray{<:Any, N}, dims = ntuple(identity, N)) where N
        Applies the $(f) operation to the input DimensionalData array `dd` along the specified dimensions `dims`. The $(f) operation is applied to both the lookup dimensions and the data of the DimensionalData array.
        """
    docsstring_look = """
        $(f)(lookup::DD.Dimensions.Dimension)
        Applies the $(f) operation to the input lookup dimension `lookup`.
        """
    @eval begin
        @doc $docsstring_look function AbstractFFTs.$f(dim::DD.Dimensions.Dimension)
            return DD.basetypeof(dim)(AbstractFFTs.$f(parent(lookup(dim))))
        end
        function $(Symbol(:apply_, f))(lookup, is_fft_dim)
            if is_fft_dim
                return AbstractFFTs.$f(lookup)
            else
                return lookup
            end
        end

        @doc $docsstring_dd function AbstractFFTs.$f(
            dd::AbstractDimArray{<:Any,N}, dd_dims=ntuple(identity, N)
        ) where {N}
            dims = DD.dimnum(dd, dd_dims)
            is_fft_dims = ntuple(i -> i in dims, N)
            dims_dd = DD.dims(dd)
            return DimArray(
                $f(parent(dd), dims),
                ntuple(i -> $(Symbol(:apply_, f))(dims_dd[i], is_fft_dims[i]), N),
            )
        end
    end
end
end

"""
    AbstractDimStack

Abstract supertype for dimensional stacks.

These have multiple layers of data, but share dimensions.

Notably, their behaviour lies somewhere between a `DimArray` and a `NamedTuple`:

- indexing with a `Symbol` as in `dimstack[:symbol]` returns a `DimArray` layer.
- iteration and `map` apply over array layers, as indexed with a `Symbol`.
- `getindex` and many base methods are applied as for `DimArray` - to avoid the need
  to always use `map`.

This design gives very succinct code when working with many-layered, mixed-dimension objects.
But it may be jarring initially - the most surprising outcome is that `dimstack[1]` will return
a `NamedTuple` of values for the first index in all layers, while `first(dimstack)` will return
the first value of the iterator - the `DimArray` for the first layer.

See [`DimStack`](@ref) for the concrete implementation.
Most methods are defined on the abstract type.

To extend `AbstractDimStack`, implement argument and keyword version of
[`rebuild`](@ref) and also [`rebuild_from_arrays`](@ref).

The constructor of an `AbstractDimStack` must accept a `NamedTuple`.
"""
abstract type AbstractDimStack{K,T,N,L,D} end
const AbstractVectorDimStack = AbstractDimStack{K,T,1} where {K,T}
const AbstractMatrixDimStack = AbstractDimStack{K,T,2} where {K,T}

DimArray(st::AbstractDimStack; kw...) = dimarray_from_dimstack(DimArray, st; kw...) 

dimarray_from_dimstack(T, st; kw...) =
    T([st[D] for D in DimIndices(st)]; dims=dims(st), metadata=metadata(st), kw...)

data(s::AbstractDimStack) = getfield(s, :data)
dims(s::AbstractDimStack) = getfield(s, :dims)
name(s::AbstractDimStack) = keys(s)
refdims(s::AbstractDimStack) = getfield(s, :refdims)
metadata(s::AbstractDimStack) = getfield(s, :metadata)

layerdims(s::AbstractDimStack) = getfield(s, :layerdims)

@inline layerdims(s::AbstractDimStack, name::Symbol) = dims(s, layerdims(s)[name])
@inline layermetadata(s::AbstractDimStack) = getfield(s, :layermetadata)
@inline layermetadata(s::AbstractDimStack, name::Symbol) = layermetadata(s)[name]

layers(nt::NamedTuple) = nt
@generated function layers(s::AbstractDimStack{K}) where K
    expr = Expr(:tuple, map(k -> :(s[$(QuoteNode(k))]), K)...)
    return :(NamedTuple{K}($expr))
end
@assume_effects :foldable DD.layers(s::AbstractDimStack{K}, i::Integer) where K = s[K[i]]
@assume_effects :foldable DD.layers(s::AbstractDimStack, k::Symbol) = s[k]

@assume_effects :foldable data_eltype(nt::NamedTuple{K}) where K =
    NamedTuple{K,Tuple{unrolled_map(eltype, Tuple(nt))...}}
stacktype(s, data, dims, layerdims::NamedTuple{K}) where K =
    basetypeof(s){K,data_eltype(data),length(dims)}

const DimArrayOrStack = Union{AbstractDimArray,AbstractDimStack}

@assume_effects :foldable function hassamedims(s::AbstractDimStack)
    all(map(==(first(layerdims(s))), layerdims(s)))
end

function rebuild(
    s::AbstractDimStack, data, dims=dims(s), refdims=refdims(s),
    layerdims=layerdims(s), metadata=metadata(s), layermetadata=layermetadata(s)
)
    T = stacktype(s, data, dims, layerdims)
    return T(data, dims, refdims, layerdims, metadata, layermetadata)
end
function rebuild(s::AbstractDimStack; 
    data=data(s),
    dims=dims(s),
    refdims=refdims(s),
    layerdims=layerdims(s),
    metadata=metadata(s),
    layermetadata=layermetadata(s)
)
    T = stacktype(s, data, dims, layerdims)
    return T(data, dims, refdims, layerdims, metadata, layermetadata)
end

function rebuildsliced(f::Function, s::AbstractDimStack, layers::NamedTuple, I)
    layerdims = unrolled_map(basedims, layers)
    dims, refdims = slicedims(f, s, I)
    return rebuild(s; data=unrolled_map(parent, layers), dims, refdims, layerdims)
end
rebuildsliced(f::Function, s::AbstractDimStack{K}, layers::Tuple, I) where K =
    rebuildsliced(f, s, NamedTuple{K}(layers), I)

"""
    rebuild_from_arrays(s::AbstractDimStack, das::NamedTuple{<:Any,<:Tuple{Vararg{AbstractDimArray}}}; kw...)

Rebuild an `AbstractDimStack` from a `Tuple` or `NamedTuple` of `AbstractDimArray`
and an existing stack.

# Keywords

Keywords are simply the common fields of an `AbstractDimStack` object:

- `data`
- `dims`
- `refdims`
- `metadata`
- `layerdims`
- `layermetadata`

There is no promise that these keywords will be used in all cases.
"""
function rebuild_from_arrays(
    s::AbstractDimStack{Keys}, das::Tuple{Vararg{AbstractBasicDimArray}}; kw...
) where Keys
    rebuild_from_arrays(s, NamedTuple{Keys}(das), kw...)
end
function rebuild_from_arrays(
    s::AbstractDimStack, das::NamedTuple{<:Any,<:Tuple{Vararg{AbstractBasicDimArray}}};
    data=map(parent, das),
    refdims=refdims(s),
    metadata=DD.metadata(s),
    dims=nothing,
    layerdims=map(DD.basedims, das),
    layermetadata=map(DD.metadata, das),
)
    if isnothing(dims)
        Base.invokelatest() do
            dims = DD.combinedims(collect(das))
        end
        rebuild(s; data, dims, refdims, layerdims, metadata, layermetadata)
    else
        rebuild(s; data, dims, refdims, layerdims, metadata, layermetadata)
    end
end

# Dispatch on Tuple of Dimension, and map
for func in INTERFACE_QUERY_FUNCTION_NAMES 
    @eval ($func)(s::AbstractDimStack, args...) = ($func)(dims(s), args...)
end

Base.parent(s::AbstractDimStack) = data(s)
# Only compare data and dim - metadata and refdims can be different
Base.:(==)(s1::AbstractDimStack, s2::AbstractDimStack) =
    dims(s1) == dims(s2) && layerdims(s1) == layerdims(s2) && data(s1) == data(s2)
Base.isequal(s1::AbstractDimStack, s2::AbstractDimStack) =
    isequal(dims(s1), dims(s2)) && isequal(layerdims(s1), layerdims(s2)) && isequal(data(s1), data(s2))
Base.read(s::AbstractDimStack) = maplayers(read, s)

# Array-like
Base.size(s::AbstractDimStack) = map(length, dims(s))
Base.size(s::AbstractDimStack, dims::DimOrDimType) = size(s, dimnum(s, dims))
Base.size(s::AbstractDimStack, dims::Integer) = size(s)[dims]
Base.length(s::AbstractDimStack) = prod(size(s))
Base.axes(s::AbstractDimStack) = map(first ∘ axes, dims(s))
Base.axes(s::AbstractDimStack, dims::DimOrDimType) = axes(s, dimnum(s, dims))
Base.axes(s::AbstractDimStack, dims::Integer) = axes(s)[dims]
Base.eltype(::AbstractDimStack{<:Any,T}) where T = T
Base.ndims(::AbstractDimStack{<:Any,<:Any,N}) where N = N
Base.CartesianIndices(s::AbstractDimStack) = CartesianIndices(dims(s))
Base.LinearIndices(s::AbstractDimStack) = 
    LinearIndices(CartesianIndices(map(l -> axes(l, 1), lookup(s))))
Base.IteratorSize(::AbstractDimStack{<:Any,<:Any,N}) where N = Base.HasShape{N}()
function Base.eachindex(s::AbstractDimStack)
    li = LinearIndices(s)
    first(li):last(li)
end
Base.firstindex(s::AbstractDimStack) = first(LinearIndices(s))
Base.lastindex(s::AbstractDimStack) = last(LinearIndices(s))
Base.first(s::AbstractDimStack) = s[firstindex((s))]
Base.last(s::AbstractDimStack) = s[lastindex(LinearIndices(s))]
Base.copy(s::AbstractDimStack) = modify(copy, s)
# all of methods.jl is also Array-like...

# NamedTuple-like
@assume_effects :foldable Base.getproperty(s::AbstractDimStack, x::Symbol) = s[x]
Base.haskey(s::AbstractDimStack{K}, k) where K = k in K
Base.values(s::AbstractDimStack) = _values_gen(s)
@generated function _values_gen(s::AbstractDimStack{K}) where K
    Expr(:tuple, map(k -> :(s[$(QuoteNode(k))]), K)...)
end
Base.checkbounds(s::AbstractDimStack, I...) = checkbounds(CartesianIndices(s), I...)
Base.checkbounds(T::Type, s::AbstractDimStack, I...) = checkbounds(T, CartesianIndices(s), I...)

@inline Base.keys(s::AbstractDimStack{K}) where K = K
@inline Base.propertynames(s::AbstractDimStack{K}) where K = K
@inline Base.setindex(s::AbstractDimStack, val::AbstractBasicDimArray, name::Symbol) =
    rebuild_from_arrays(s, Base.setindex(layers(s), val, name))
Base.NamedTuple(s::AbstractDimStack) = NamedTuple(layers(s))
Base.collect(st::AbstractDimStack) = parent([st[D] for D in DimIndices(st)])
Base.Array(st::AbstractDimStack) = collect(st)
Base.vec(st::AbstractDimStack) = vec(collect(st))
Base.get(st::AbstractDimStack, k::Symbol, default) =
    haskey(st, k) ? st[k] : default
Base.get(f::Base.Callable, st::AbstractDimStack, k::Symbol) =
    haskey(st, k) ? st[k] : f()
@propagate_inbounds Base.iterate(st::AbstractDimStack) = iterate(st, 1)
@propagate_inbounds Base.iterate(st::AbstractDimStack, i) =
    i > length(st) ? nothing : (st[DimIndices(st)[i]], i + 1)

Base.similar(s::AbstractDimStack) = similar(s, eltype(s))
Base.similar(s::AbstractDimStack, dims::Dimension...) = similar(s, dims)
Base.similar(s::AbstractDimStack, ::Type{T},dims::Dimension...) where T =
    similar(s, T, dims)
Base.similar(s::AbstractDimStack, dims::Tuple{Vararg{Dimension}}) = 
    similar(s, eltype(s), dims)
Base.similar(s::AbstractDimStack, ::Type{T}) where T = 
    similar(s, T, dims(s))
function Base.similar(s::AbstractDimStack, ::Type{T}, dims::Tuple) where T
    # Any dims not in the stack are added to all layers
    ods = otherdims(dims, DD.dims(s))
    maplayers(s) do A
        # Original layer dims are maintained, other dims are added
        D = DD.commondims(dims, (DD.dims(A)..., ods...))
        similar(A, T, D)
    end
end
function Base.similar(s::AbstractDimStack, ::Type{T}, dims::Tuple) where T<:NamedTuple
    ods = otherdims(dims, DD.dims(s))
    maplayers(s, _nt_types(T)) do A, Tx 
        D = DD.commondims(dims, (DD.dims(A)..., ods...))
        similar(A, Tx, D)
    end
end

@generated function _nt_types(::Type{NamedTuple{K,T}}) where {K,T}
    expr = Expr(:tuple, T.parameters...)
    return :(NamedTuple{K}($expr))
end

# `merge` for AbstractDimStack and NamedTuple.
# One of the first three arguments must be an AbstractDimStack for dispatch to work.
Base.merge(s::AbstractDimStack) = s
function Base.merge(
    x1::AbstractDimStack,
    x2::Union{AbstractDimStack,NamedTuple},
    xs::Union{AbstractDimStack,NamedTuple}...;
    kw...
)
    rebuild_from_arrays(x1, merge(map(layers, (x1, x2, xs...))...); kw...)
end
function Base.merge(
    x1::NamedTuple, x2::AbstractDimStack, xs::Union{AbstractDimStack,NamedTuple}...;
)
    merge(map(layers, (x1, x2, xs...))...)
end
function Base.merge(
    x1::NamedTuple, x2::NamedTuple, x3::AbstractDimStack,
    xs::Union{AbstractDimStack,NamedTuple}...;
    kw...
)
    merge(map(layers, (x1, x2, x3, xs...))...)
end

"""
    maplayers(f, s::Union{AbstractDimStack,NamedTuple}...)

Map function `f` over the layers of `s`.
"""
maplayers(f, s::AbstractDimStack) =
    _maybestack(s, unrolled_map(f, values(s)))
function maplayers(
    f, x1::Union{AbstractDimStack,NamedTuple}, xs::Union{AbstractDimStack,NamedTuple}...
)
    stacks = (x1, xs...)
    _check_same_names(stacks...)
    vals = map(f, map(values, stacks)...)
    return _maybestack(_firststack(stacks...), vals)
end

# Other interfaces

Extents.extent(A::AbstractDimStack, args...) = Extents.extent(dims(A), args...)

ConstructionBase.getproperties(s::AbstractDimStack) = layers(s)
ConstructionBase.setproperties(s::AbstractDimStack, patch::NamedTuple) =
    ConstructionBase.constructorof(typeof(s))(ConstructionBase.setproperties(layers(s), patch))

function mergedims(st::AbstractDimStack, dim_pairs::Pair...)
    dim_pairs = map(dim_pairs) do (as, b)
        basedims(as) => b
    end
    isempty(dim_pairs) && return st
    # Extend missing dimensions in all layers
    maplayers(st) do layer
        extended_layer = if all(map((ds...) -> all(hasdim(layer, ds)), map(first, dim_pairs)...))
            layer
        else
            DimExtensionArray(layer, dims(st))
        end
        mergedims(extended_layer, dim_pairs...)
    end
end

function unmergedims(s::AbstractDimStack, original_dims)
    return maplayers(A -> unmergedims(A, original_dims), s)
end

@noinline _stack_size_mismatch() = throw(ArgumentError("Arrays must have identical axes. For mixed dimensions, use DimArrays`"))

function _layerkeysfromdim(A, dim)
    map(lookup(A, dim)) do x
        if x isa Number
            Symbol(string(name(dim), "_", x))
        else
            Symbol(x)
        end
    end
end

_check_same_names(::Union{AbstractDimStack{names},NamedTuple{names}},
    ::Union{AbstractDimStack{names},NamedTuple{names}}...) where {names} = nothing
_check_same_names(::Union{AbstractDimStack,NamedTuple}, ::Union{AbstractDimStack,NamedTuple}...) =
    throw(ArgumentError("Named tuple names do not match."))

_firststack(s::AbstractDimStack, args...) = s
_firststack(arg1, args...) = _firststack(args...)
_firststack() = nothing

_maybestack(s::AbstractDimStack{<:NamedTuple{K}}, xs::Tuple) where K = NamedTuple{K}(xs)
_maybestack(s::AbstractDimStack, xs::Tuple) = NamedTuple{keys(s)}(xs)
# Without the `@nospecialise` here this method is also compile with the above method
# on every call to _maybestack. And `rebuild_from_arrays` is expensive to compile.
function _maybestack(
    s::AbstractDimStack, das::Tuple{AbstractDimArray,Vararg{AbstractDimArray}}
)
    # Avoid compiling this in the simple cases in the above method
    Base.invokelatest(() -> rebuild_from_arrays(s, das))
end
function _maybestack(
    s::AbstractDimStack{<:NamedTuple{K}}, das::Tuple{AbstractDimArray,Vararg{AbstractDimArray}}
) where K
    Base.invokelatest(() -> rebuild_from_arrays(s, das))
end


"""
    DimStack <: AbstractDimStack

    DimStack(table, [dims]; kw...)
    DimStack(data::AbstractDimArray...; kw...)
    DimStack(data::Union{AbstractArray,Tuple,NamedTuple}, [dims::DimTuple]; kw...)
    DimStack(data::AbstractDimArray; layersfrom, kw...)

DimStack holds multiple objects sharing some dimensions, in a `NamedTuple`.

## Arguments

- `data`: `AbstractDimArray` or an `AbstractArray`, `Tuple` or `NamedTuple` of `AbstractDimArray`s or `AbstractArray`s.
- `dims`: `DimTuple` of `Dimension`s. Required when `data` is not `AbstractDimArray`s.

## Keywords

- `name`: `Array` or `Tuple` of `Symbol` names for each layer. By default
    the names of `DimArrays` are or keys of a `NamedTuple` are used, 
    or `:layer1`, `:layer2`, etc.
- `metadata`: `AbstractDict` or `NamedTuple` metadata for the stack. 
- `layersfrom`: A dimension to slice layers from if data is a single
    `DimArray`. Defaults to `nothing`. 

(These are for advanced uses)
- `layerdims`: `Array`, `Tuple` or `NamedTuple` of dimension tuples to match the
    dimensions of each layer. Dimensions in `layerdims` must also be in `dims`.
- `layermetadata`: `Array`, `Tuple` or `NamedTuple` of metadata for each layer.
- `refdims`: `NamedTuple` of `Dimension`s for each layer, `()` by default.

## Details

`DimStack` behaviour lies somewhere between a `DimArray` and a `NamedTuple`:

- indexing with a `Symbol` as in `dimstack[:layername]` or using `getproperty` 
    `dimstack.layername` returns a `DimArray` layer.
- A `DimStack` iterates `NamedTuple`s corresponding to the value of each layer. This means functions like `map`, `broadcast`, and `collect` behave as if the `DimStack` were a `DimArray{<:NamedTuple}`
- `getindex` or `view` with a `Vector` or `Colon` will return another `DimStack` where
    all data layers have been sliced, unless this resolves to a single element, in which case 
    `getindex` returns a `NamedTuple`
- `setindex!` must pass a `Tuple` or `NamedTuple` matching the layers.
- many base and `Statistics` methods (`sum`, `mean` etc) will work as for a `DimArray`,
    applied to all layers separately.
- to apply a function to each layer of a `DimStack`, use [`maplayers`](@ref).


```julia
function DimStack(A::AbstractDimArray;
    layersfrom=nothing, name=nothing, metadata=metadata(A), refdims=refdims(A), kw...
)
```

For example, here we take the mean over the time dimension for all layers:

```julia
mean(mydimstack; dims=Ti)
```

And this equivalent to:

```julia
maplayers(A -> mean(A; dims=Ti), mydimstack)
```

This design gives succinct code when working with many-layered, mixed-dimension objects.

But it may be jarring initially - the most surprising outcome is that `dimstack[1]` will return
a `NamedTuple` of values for the first index in all layers, while `first(dimstack)` will return
the first value of the iterator - the `DimArray` for the first layer.

`DimStack` can be constructed from multiple `AbstractDimArray` or a `NamedTuple`
of `AbstractArray` and a matching `dims` tuple.

Most `Base` and `Statistics` methods that apply to `AbstractArray` can be used on
all layers of the stack simulataneously. The result is a `DimStack`, or
a `NamedTuple` if methods like `mean` are used without `dims` arguments, and
return a single non-array value.

## Example

```jldoctest
julia> using DimensionalData

julia> A = [1.0 2.0 3.0; 4.0 5.0 6.0];

julia> dimz = (X([:a, :b]), Y(10.0:10.0:30.0))
(↓ X [:a, :b],
→ Y 10.0:10.0:30.0)

julia> da1 = DimArray(1A, dimz; name=:one);

julia> da2 = DimArray(2A, dimz; name=:two);

julia> da3 = DimArray(3A, dimz; name=:three);

julia> s = DimStack(da1, da2, da3);

julia> s[At(:b), At(10.0)]
(one = 4.0, two = 8.0, three = 12.0)

julia> s[X(At(:a))] isa DimStack
true
```
"""
struct DimStack{K,T,N,L,D<:Tuple,R<:Tuple,LD,M,LM} <: AbstractDimStack{K,T,N,L,D}
    data::L
    dims::D
    refdims::R
    layerdims::NamedTuple{K,LD}
    metadata::M
    layermetadata::NamedTuple{K,LM}
    function DimStack(
        data, dims, refdims, layerdims::LD, metadata, layermetadata::NamedTuple{K}
    ) where LD<:NamedTuple{K} where K
        T = data_eltype(data)
        N = length(dims)
        DimStack{K,T,N}(data, dims, refdims, layerdims, metadata, layermetadata)
    end
    function DimStack{K,T,N}(
        data::L, dims::D, refdims::R, layerdims::NamedTuple{K,LD}, metadata::M, layermetadata::NamedTuple{K,LM}
    ) where {K,T,N,L,D,R,LD,M,LM}
        new{K,T,N,L,D,R,LD,M,LM}(data, dims, refdims, layerdims, metadata, layermetadata)
    end
end
DimStack(@nospecialize(das::AbstractDimArray...); kw...) = DimStack(collect(das); kw...)
DimStack(@nospecialize(das::Tuple{Vararg{AbstractDimArray}}); kw...) = DimStack(collect(das); kw...)
function DimStack(@nospecialize(das::AbstractArray{<:AbstractDimArray});
    metadata=NoMetadata(),
    refdims=(),
    name=uniquekeys(das),
)
    dims = DD.combinedims(das)
    name_tuple = Tuple(name)
    data = NamedTuple{name_tuple}(map(parent, das))
    layerdims = NamedTuple{name_tuple}(map(basedims, das))
    layermetadata = NamedTuple{name_tuple}(map(DD.metadata, das))

    DimStack(data, dims, refdims, layerdims, metadata, layermetadata)
end
function DimStack(A::AbstractDimArray;
    layersfrom=nothing, 
    metadata=metadata(A), 
    refdims=refdims(A), 
    name=nothing,
    kw...
)
    layers = if isnothing(layersfrom)
        name = if isnothing(name)
            DD.name(A) in (NoName(), Symbol(""), Name(Symbol(""))) ? (:layer1,) : (DD.name(A),)
        else
            name
        end
        NamedTuple{name}((A,))
    else
        name = if isnothing(name)
            Tuple(_layerkeysfromdim(A, layersfrom))
        else
            name
        end
        slices = Tuple(eachslice(A; dims=layersfrom))
        NamedTuple{name}(slices)
    end
    return DimStack(layers; refdims, metadata, kw...)
end
function DimStack(das::NamedTuple{<:Any,<:Tuple{Vararg{AbstractDimArray}}};
    data=map(parent, das), 
    dims=combinedims(collect(das)), 
    layerdims=map(basedims, das),
    refdims=(), 
    metadata=NoMetadata(), 
    layermetadata=map(DD.metadata, das)
)
    return DimStack(data, dims, refdims, layerdims, metadata, layermetadata)
end
DimStack(data::Union{Tuple,AbstractArray,NamedTuple}, dim::Dimension; name=uniquekeys(data), kw...) = 
    DimStack(NamedTuple{Tuple(name)}(data), (dim,); kw...)
DimStack(data::Union{Tuple,AbstractArray{<:AbstractArray}}, dims::Tuple; name=uniquekeys(data), kw...) = 
    DimStack(NamedTuple{Tuple(name)}(data), dims; kw...)
function DimStack(data::NamedTuple{K}, dims::Tuple;
    refdims=(), 
    metadata=NoMetadata(),
    layermetadata=nothing,
    layerdims=nothing
) where K
    if length(data) > 0 && Tables.istable(data) && all(d -> name(d) in keys(data), dims)
        return dimstack_from_table(DimStack, data, dims; refdims, metadata)
    end
    layerdims = if isnothing(layerdims) 
        all(map(d -> axes(d) == axes(first(data)), data)) || _stack_size_mismatch()
        map(_ -> basedims(dims), data)
    else
        NamedTuple{K}(map(basedims, layerdims))
    end
    layermetadata = if isnothing(layermetadata)
        map(_ -> NoMetadata(), data)
    else
        NamedTuple{K}(layermetadata)
    end
    dims1 = isempty(data) ? () : format(dims, first(data))
    return DimStack(data, dims1, refdims, layerdims, metadata, layermetadata)
end
# From another stack
function DimStack(st::AbstractDimStack;
    data=data(st), 
    dims=dims(st), 
    refdims=refdims(st), 
    layerdims=layerdims(st), 
    metadata=metadata(st),
    layermetadata=layermetadata(st),
)
    DimStack(data, dims, refdims, layerdims, metadata, layermetadata)
end

# Write each column from a table with one or more coordinate columns to a layer in a DimStack
function DimStack(data, dims::Tuple; kw...
)
    if Tables.istable(data)
        table = Tables.columns(data)
        all(map(d -> Dimensions.name(d) in Tables.columnnames(table), dims)) || throw(ArgumentError(
            "All dimensions in dims must be in the table columns."
        ))
        dims = guess_dims(table, dims; kw...)
        return dimstack_from_table(DimStack, table, dims; kw...)
    else
        throw(ArgumentError(
            """data must be a table with coordinate columns, an AbstractArray, 
            or a Tuple or NamedTuple of AbstractArrays"""
        ))

    end
end
function DimStack(table; kw...)
    if Tables.istable(table)
        table = Tables.columns(table)
        dimstack_from_table(DimStack, table, guess_dims(table; kw...); kw...)
    else
        throw(ArgumentError(
            """data must be a table with coordinate columns, an AbstractArray, 
            or a Tuple or NamedTuple of AbstractArrays"""
        ))    end
end

function dimstack_from_table(::Type{T}, table, dims; 
    name=nothing, 
    selector=nothing, 
    precision=6, 
    missingval=missing, 
    kw...
) where T<:AbstractDimStack
    table = Tables.columnaccess(table) ? table : Tables.columns(table)
    data_cols = isnothing(name) ? data_col_names(table, dims) : name
    dims = guess_dims(table, dims; precision)
    indices = coords_to_indices(table, dims; selector)
    layers = map(data_cols) do col
        d = Tables.getcolumn(table, col)
        restore_array(d, indices, dims, missingval)
    end
    return T(layers, dims; name = data_cols, kw...)
end

layerdims(s::DimStack{<:Any,<:Any,<:Any,<:Any,<:Any,<:Any,Nothing}, name::Symbol) = dims(s)

### Stack as Array 
"""
    DimStackArray <: AbstractDimArrayGenerator

A wrapper that makes a `DimStack` behave like an `AbstractArray`.

Provides array-like access to a `DimStack`, where each element is a `NamedTuple` containing 
values from all layers at that position.

# Examples
```julia
using DimensionalData 

# Create a DimStack
da1 = DimArray(ones(2,2), (X(1:2), Y(1:2)); name=:temp)
da2 = DimArray(2ones(2,2), (X(1:2), Y(1:2)); name=:precip) 
stack = DimStack((da1, da2))

# Wrap as DimStackArray
arr = DimStackArray(stack)

# Get values from all layers at position [1,1]
arr[1,1]  # Returns (temp=1.0, precip=2.0)

# Views maintain DimStack structure
view(arr, 1:2, 1) 
```
"""
struct DimStackArray{T,N,D,S<:AbstractDimStack{<:Any,T,N,<:Any,D}} <: AbstractDimArrayGenerator{T,N,D}
    stack::S
end

# Forward key methods to the wrapped stack
Base.parent(x::DimStackArray) = x.stack
dims(x::DimStackArray) = dims(parent(x))
refdims(x::DimStackArray) = refdims(parent(x))
metadata(x::DimStackArray) = metadata(parent(x))
Base.size(x::DimStackArray) = size(parent(x))

rebuild(x::DimStackArray; kw...) = 
    DimStackArray(rebuild(parent(x); kw...))

@propagate_inbounds function Base.getindex(A::DimStackArray, i::Integer...)
    return parent(A)[i...]
end

@propagate_inbounds function rebuildsliced(f::Function, A::DimStackArray, I)
    DimStackArray(f(parent(A), I...))
end
### Skipmissing on DimStacks

"""
    skipmissing(itr::AbstractDimStack)

Returns an iterable over the elements in a `AbstractDimStack` object, skipping any values if any of the layers are missing.
"""
Base.skipmissing

# Specialized dispatch of iterate to skip values if any layer is missing.
function Base.iterate(itr::Base.SkipMissing{<:AbstractDimStack}, state...)
    y = iterate(itr.x, state...)
    y === nothing && return nothing
    item, state = y
    while any(map(ismissing, item)) # instead of ismissing(item)
        y = iterate(itr.x, state)
        y === nothing && return nothing
        item, state = y
    end
    item, state
end

Base.eltype(::Type{Base.SkipMissing{T}}) where {T<:AbstractDimStack{<:Any, NT}} where NT =
    _nonmissing_nt(NT)

@generated _nonmissing_nt(NT::Type{<:NamedTuple{K,V}}) where {K,V} =
    NamedTuple{K, Tuple{map(Base.nonmissingtype, V.parameters)...}}

Base.Broadcast.broadcastable(st::AbstractDimStack) = DimStackArray(st)

using Plots
using StatsPlots
using DimensionalData, Test, Dates
import Distributions
using Unitful, Unitful.DefaultSymbols

@testset "Plots.jl" begin


using DimensionalData: Metadata, NoMetadata, ForwardOrdered, ReverseOrdered, Unordered,
    Sampled, Categorical, NoLookup, Transformed,
    Regular, Irregular, Explicit, Points, Intervals, Start, Center, End

A1 = rand(Distributions.Normal(), 20)
ref = (Ti(Sampled(1:1; order=ForwardOrdered(), span=Regular(Day(1)), sampling=Points())),)
da1_regular = DimArray(A1, X(1:50:1000); name=:Normal, refdims=ref)
da1_noindex = DimArray(A1, X(); name=:Normal, refdims=ref)
da1_categorical = DimArray(A1, X('A':'T'); name=:Normal, refdims=ref)
da1_categorical_symbol = DimArray(A1, X(Symbol.('A':'T')); name=:Normal, refdims=ref)
da1_z = DimArray(A1, Z(1:50:1000); name=:Normal, refdims=ref)

# For manual testing
da1 = da1_categorical

for da in (da1_regular, da1_noindex, da1_categorical, da1_categorical_symbol, da1_z)
    for da1 in (da, reverse(da))
        # Plots
        plot(da1)
        bar(da1)
        sticks(da1)
        histogram(da1)
        stephist(da1)
        barhist(da1)
        scatterhist(da1)
        histogram2d(da1)
        hline(da1)
        vline(da1)
        plot(da1; seriestype=:line)
        plot(da1; seriestype=:path)
        plot(da1; seriestype=:shape)
        plot(da1; seriestype=:steppost)
        plot(da1; seriestype=:steppre)
        plot(da1; seriestype=:scatterbins)
        # StatsPlots
        dotplot(da1)
        boxplot(da1)
        violin(da1)
        # broken in StatsPlots marginalhist(da1)
        ea_histogram(da1)
        density(da1)
    end
end

A2 = rand(Distributions.Normal(), 40, 20)
da2_regular = DimArray(A2, (X(1:10:400), Y(1:5:100)); name=:Normal)
da2_noindex = DimArray(A2, (X(), Y()); name=:Normal)
da2_ni_r = DimArray(A2, (X(), Y(1:5:100)); name=:Normal)
da2_r_ni = DimArray(A2, (X(1:10:400), Y()); name=:Normal)
da2_c_c = DimArray(A2, (X('A':'h'), Y('a':'t')); name=:Normal)
da2_XY = DimArray(A2, (X(1:10:400), Y(1:5:100)); name=:Normal)
da2_YX = DimArray(A2, (Y(1:10:400), X(1:5:100)); name=:Normal)
da2_ZY = DimArray(A2, (Z(1:10:400), Y(1:5:100)); name=:Normal)
da2_XTi = DimArray(A2, (X(1:10:400), Ti(Date(1):Year(5):Date(100))); name=:Normal)
da2_other = DimArray(A2, (X=1:10:400, other=1:5:100); name=:Normal)

# For manual testing
da2 = da2_XTi
da2 = da2_c_c
da2 = da2_other

for da in (da2_regular, da2_noindex, da2_ni_r, da2_r_ni, da2_c_c, da2_YX, da2_XY, da2_ZY)
    for da2 in (da, reverse(da, dims=first(dims(da))), reverse(da, dims=first(dims(da))))
        # Plots
        plot(da2)
        bar(da2)
        violin(da2)
        boxplot(da2)
        sticks(da2)
        histogram(da2)
        stephist(da2)
        barhist(da2)
        scatterhist(da2)
        histogram2d(da2)
        hline(da2)
        vline(da2)
        plot(da2; seriestype=:line)
        heatmap(da2)
        contour(da2)
        wireframe(da2)
        # StatsPlots
        density(da2)
        dotplot(da2)
        boxplot(da2)
        violin(da2)
        ea_histogram(da2)
    end
end

A3 = rand(Distributions.Normal(), 40, 20, 10)
da3_regular = DimArray(A3, (X(1:10:400), Y(1:5:100), Z(1:2:20)); name=:Normal)
da3_noindex = DimArray(A3, (X(), Y(), Z()); name=:Normal)
da3_ni_r_ni = DimArray(A3, (X(), Y(1:5:100), Z()); name=:Normal)
da3_c_c_c = DimArray(A3, (X('A':'h'), Y('a':'t'), Z('0':'9')); name=:Normal)
da3_XYZ = DimArray(A3, (X(1:10:400), Y(1:5:100), Z(1:10:100)); name=:Normal)
da3_XTiZ = DimArray(A3, (X(1:10:400), Ti(1s:5s:100s), Z(1:10:100)); name=:Normal)
da3_other = DimArray(A3, (X=1:10:400, other=1:5:100, anothing=NoLookup()); name=:Normal)
da3 = da3_other
da3 = da3_XYZ
da3 = da3_XTiZ

for da in (da3_regular, da3_noindex, da3_ni_r_ni, da3_c_c_c, da3_XYZ, da3_XTiZ, da3_other)
    for da3 in (da, reverse(da, dims=first(dims(da))), reverse(da, dims=first(dims(da))))
        # Plots
        @test_throws ArgumentError plot(da3)
        # bar(da3)
        violin(da3)
        boxplot(da3)
        @test_throws ArgumentError sticks(da3)
        @test_throws ArgumentError histogram(da3)
        @test_throws ArgumentError stephist(da3)
        @test_throws ArgumentError barhist(da3)
        @test_throws ArgumentError scatterhist(da3)
        @test_throws ArgumentError histogram2d(da3)
        hline(da3)
        vline(da3)
        @test_throws ArgumentError plot(da3; seriestype=:line)
        @test_throws ArgumentError heatmap(da3)
        @test_throws ArgumentError contour(da3)
        @test_throws ArgumentError wireframe(da3)
        # StatsPlots
        @test_throws ArgumentError density(da3)
        dotplot(da3)
        boxplot(da3)
        violin(da3)
        @test_throws ArgumentError ea_histogram(da3)
    end
end

# Not sure how recipes work for this
# andrewsplot(da2)

# TODO handle everything

# These don't seem to work for plot(parent(da2))
# path3d(da2)
# hexbin(parent(da1))
# plot(da2; seriestype=:histogram3d)

# Crashes GR
# groupedbar(parent(da2))

# surface(da2)
# plot(da2; seriestype=:bins2d)
# plot(da2; seriestype=:volume)
# plot(da2; seriestype=:stepbins)
# plot(parent(da2); seriestype=:barbins)
# plot(parent(da2); seriestype=:contour3d)
# pie(da2)
#
# Crashes GR for some reason
# im2 = RGB24.(rand(10, 10))
# da_im2 = DimArray(im2, (X(10:10:100), Y(10:10:100)), "Image")
# da_im2 |> plot

end

"""
    LookupTrait

Abstract supertype of all traits of a [`Lookup`](@ref).

These modify the behaviour of the lookup index.

The term "Trait" is used loosely - these may be fields of an object
of traits hard-coded to specific types.
"""
abstract type LookupTrait end

"""
    Order <: LookupTrait

Traits for the order of a [`Lookup`](@ref). These determine how
`searchsorted` finds values in the index, and how objects are plotted.
"""
abstract type Order <: LookupTrait end

"""
    Ordered <: Order

Supertype for the order of an ordered [`Lookup`](@ref),
including [`ForwardOrdered`](@ref) and [`ReverseOrdered`](@ref).
"""
abstract type Ordered <: Order end

"""
    AutoOrder <: Order

    AutoOrder()

Specifies that the `Order` of a `Lookup` will be found automatically
where possible.
"""
struct AutoOrder <: Order end

"""
    ForwardOrdered <: Ordered

    ForwardOrdered()

Indicates that the `Lookup` index is in the normal forward order.
"""
struct ForwardOrdered <: Ordered end

"""
    ReverseOrdered <: Ordered

    ReverseOrdered()

Indicates that the `Lookup` index is in the reverse order.
"""
struct ReverseOrdered <: Ordered end

"""
    Unordered <: Order

    Unordered()

Indicates that `Lookup` is unordered.

This means the index cannot be searched with `searchsortedfirst`
or similar optimised methods - instead it will use `findfirst`.
"""
struct Unordered <: Order end

isrev(x::Order) = isrev(typeof(x))
isrev(::Type{<:ReverseOrdered}) = true
isrev(::Type{<:Order}) = false

"""
    Position <: LookupTrait

Abstract supertype of types that indicate the locus of index values
where they represent [`Intervals`](@ref).

These allow for values array cells to align with the [`Start`](@ref),
[`Center`](@ref), or [`End`](@ref) of values in the lookup index.

This means they can be plotted with correct axis markers, and allows automatic
conversions to between formats with different standards (such as NetCDF and GeoTiff).
"""
abstract type Position <: LookupTrait end

"""
    Center <: Position

    Center()

Used to specify lookup values correspond to the center locus in an interval.
"""
struct Center <: Position end

"""
    Start <: Position

    Start()

Used to specify lookup values correspond to the start locus of an interval.
"""
struct Start <: Position end

"""
    Begin <: Position

    Begin()

Used to specify the `begin` index of a `Dimension` axis, 
as regular `begin` will not work with named dimensions.

Can be used with `:` to create a `BeginEndRange` or 
`BeginEndStepRange`.
"""
struct Begin <: Position end

"""
    End <: Position

    End()

Used to specify the `end` index of a `Dimension` axis, 
as regular `end` will not work with named dimensions.
Can be used with `:` to create a `BeginEndRange` or 
`BeginEndStepRange`.

Also used to specify lookup values correspond to the end 
locus of an interval.
"""
struct End <: Position end

"""
    AutoPosition <: Position

    AutoPosition()

Indicates a interval where the index locus is not yet known.
This will be filled with a default value on object construction.
"""
struct AutoPosition <: Position end

# Locus does not include `Begin` 
const Locus = Union{AutoPosition,Start,Center,End}
const AutoLocus = AutoPosition

"""
    Sampling <: LookupTrait

Indicates the sampling method used by the index: [`Points`](@ref)
or [`Intervals`](@ref).
"""
abstract type Sampling <: LookupTrait end

struct NoSampling <: Sampling end
locus(sampling::NoSampling) = Center()

struct AutoSampling <: Sampling end
locus(sampling::AutoSampling) = AutoPosition()

"""
    Points <: Sampling

    Points()

[`Sampling`](@ref) lookup where single samples at exact points.

These are always plotted at the center of array cells.
"""
struct Points <: Sampling end

locus(sampling::Points) = Center()

"""
    Intervals <: Sampling

    Intervals(locus::Position)

[`Sampling`](@ref) specifying that sampled values are the mean (or similar)
value over an _interval_, rather than at one specific point.

Intervals require a [`locus`](@ref) of [`Start`](@ref), [`Center`](@ref) or
[`End`](@ref) to define the location in the interval that the index values refer to.
"""
struct Intervals{P} <: Sampling
    locus::P
end
Intervals() = Intervals(AutoPosition())

locus(sampling::Intervals) = sampling.locus
rebuild(::Intervals, locus) = Intervals(locus)

"""
    Span <: LookupTrait

Defines the type of span used in a [`Sampling`](@ref) index.
These are [`Regular`](@ref) or [`Irregular`](@ref).
"""
abstract type Span <: LookupTrait end

struct NoSpan <: Span end

"""
    AutoSpan <: Span

    AutoSpan()

The span will be guessed and replaced in `format` or `set`.
"""
struct AutoSpan <: Span end

struct AutoStep end
struct AutoBounds end
struct AutoDim end

Base.step(::AutoSpan) = AutoStep()

"""
    Regular <: Span

    Regular(step=AutoStep())

`Points` or `Intervals` that have a fixed, regular step.
"""
struct Regular{S} <: Span
    step::S
end
Regular() = Regular(AutoStep())

val(span::Regular) = span.step

Base.step(span::Regular) = span.step
Base.:(==)(l1::Regular, l2::Regular) = val(l1) == val(l2)

"""
    Irregular <: Span

    Irregular(bounds::Tuple)
    Irregular(lowerbound, upperbound)

`Points` or `Intervals` that have an `Irregular` step size. To enable bounds tracking
and accurate selectors, the starting bounds are provided as a 2 tuple, or 2 arguments.
`(nothing, nothing)` is acceptable input, the bounds will be guessed from the index,
but may be inaccurate.
"""
struct Irregular{B<:Union{<:Tuple{<:Any,<:Any},AutoBounds}} <: Span
    bounds::B
end
Irregular() = Irregular(AutoBounds())
Irregular(lowerbound, upperbound) = Irregular((lowerbound, upperbound))

bounds(span::Irregular) = span.bounds
val(span::Irregular) = span.bounds

Base.:(==)(l1::Irregular, l2::Irregular) = val(l1) == val(l2)

"""
    Explicit(bounds::AbstractMatrix)

Intervals where the span is explicitly listed for every interval.

This uses a matrix where with length 2 columns for each index value,
holding the lower and upper bounds for that specific index.
"""
struct Explicit{B} <: Span
    val::B
end
Explicit() = Explicit(AutoBounds())

val(span::Explicit) = span.val
Base.:(==)(l1::Explicit, l2::Explicit) = val(l1) == val(l2)

"""
    AutoValues

Detect `Lookup` values from the context. This is used in `NoLookup` to simply
use the array axis as the index when the array is constructed, and in `set` to
change the `Lookup` type without changing the index values.
"""
struct AutoValues <: AbstractVector{Int} end

Base.size(::AutoValues) = (0,)

using DimensionalData
using DimensionalData.Dimensions: Dim, DimUnitRange, basetypeof
using OffsetArrays
using Test

struct AxesArrayWrapper{T,N} <: AbstractArray{T,N}
    data::AbstractArray{T,N}
    axes
end
Base.size(A::AxesArrayWrapper) = size(A.data)
Base.axes(A::AxesArrayWrapper) = A.axes
Base.getindex(A::AxesArrayWrapper, i::Int) = A.data[i]
Base.getindex(A::AxesArrayWrapper, I::Vararg{Int,N}) where {N} = A.data[I...]

axdims = [
    (Base.OneTo(3), X(["x", "y", "z"])),
    (axes(OffsetVector(ones(2), 0:1), 1), Dim{:f}([:a, :b])),
]
@testset for (ax, dim) in axdims
    r = DimUnitRange(ax, dim)
    r2 = DimUnitRange(Base.OneTo(5), Dim{:g}(6:10))
    @test r isa DimUnitRange
    @test parent(r) === ax
    @test dims(r) === r.dim
    @test dims((r, r2)) === (r.dim, r2.dim)
    @test sprint(show, "text/plain", r) == "$(basetypeof(r.dim))($(r.range))"
    @test length(r) == length(ax)
    @test !isempty(r)
    @test first(r) == first(ax)
    @test last(r) == last(ax)
    @test axes(r) === (r,)
    @test axes(r, 1) === r
    @test Base.axes1(r) === r
    @test iterate(r) === iterate(ax)
    @test iterate(r, iterate(r)[2]) === iterate(ax, iterate(r)[2])
    @test r[begin] == ax[begin]
    @test r[1] == ax[1]
    @test checkindex(Bool, r, 1)
    @test checkindex(Bool, r, 0) == checkindex(Bool, ax, 0)
    bigr = DimUnitRange{BigInt}(r)
    @test eltype(bigr) === BigInt
    @test eltype(parent(bigr)) === BigInt
    @test dims(bigr) === dim
    @test bigr == ax
    @test DimUnitRange{eltype(r)}(r) === r
    @test Base.OrdinalRange{Int,Int}(r) == r
    @test AbstractUnitRange{BigInt}(r) isa DimUnitRange{BigInt}
    @test parent(AbstractUnitRange{BigInt}(r)) == AbstractUnitRange{BigInt}(parent(r))
    @test dims(AbstractUnitRange{BigInt}(r)) === dim
end

@testset "CartesianIndices/LinearIndices for BigInt ranges" begin
    r = DimUnitRange(1:2, X(["x", "y"]))
    rbig = DimUnitRange(big(1):big(2), X(["x", "y"]))
    @test CartesianIndices(rbig) == CartesianIndices(r)
    @test LinearIndices(rbig) == LinearIndices(r)
    @test eachindex(rbig) == eachindex(r)
end

@testset "similar" begin
    dim = X(["x", "y", "z"])
    r = DimUnitRange(Base.OneTo(3), dim)
    da_sim = similar(r)
    @test da_sim isa DimArray{Int,1}
    @test dims(da_sim) == (dim,)
    @test dims(da_sim) !== (dim,)

    da_sim2 = similar(r, Missing)
    @test da_sim2 isa DimArray{Missing,1}
    @test dims(da_sim2) == (dim,)
    @test dims(da_sim2) !== (dim,)
end

@testset "map" begin
    dim = X(["x", "y", "z"])
    r = DimUnitRange(Base.OneTo(3), dim)
    y = map(one, r)
    @test y isa DimArray{Int,1}
    @test y == ones(3)
    @test dims(y) == (dim,)
end

@testset "broadcast" begin
    dim = X(["x", "y", "z"])
    r = DimUnitRange(Base.OneTo(3), dim)
    y = sin.(r)
    @test y isa DimArray{Float64,1}
    @test y == sin.(1:3)
    @test dims(y) == (dim,)
end

@testset "dims for array with DimUnitRange indices" begin
    xdim = X(["x", "y", "z"])
    ydim = Y(2.0:6.0)
    xi = DimUnitRange(Base.OneTo(3), xdim)
    yi = DimUnitRange(Base.OneTo(5), ydim)

    @testset "dims is not nothing if all indices are DimUnitRange" begin
        A = AxesArrayWrapper(Array(rand(xdim, ydim)), (xi, yi))
        @test axes(A) == (xi, yi)
        @test !isnothing(dims(A))
        @test Dimensions.comparedims(Bool, dims(A), (xdim, ydim))

        A2 = AxesArrayWrapper(Array(rand(xdim)), (xi,))
        @test axes(A2) == (xi,)
        @test !isnothing(dims(A2))
        @test Dimensions.comparedims(Bool, dims(A2), (xdim,))

    end

    @testset "dims is nothing if any indices are not DimUnitRange" begin
        A = AxesArrayWrapper(Array(rand(xdim, ydim)), (xi, Base.OneTo(length(ydim))))
        @test isnothing(dims(A))

        A2 = AxesArrayWrapper(Array(rand(xdim, ydim)), (Base.OneTo(length(xdim)), yi))
        @test isnothing(dims(A2))
    end
end

BENCHMARK_ENV = abspath((@__DIR__) * "/..")
BENCHMARK_RESULTS_DIR = (@__DIR__) * "/results"
PACKAGE_DIR = BENCHMARK_ENV

using Pkg
Pkg.activate(BENCHMARK_ENV)

using DimensionalData, BenchmarkTools, Unitful, SparseArrays, Dates, Statistics, LibGit2

if !isdir(BENCHMARK_RESULTS_DIR)
    mkdir(BENCHMARK_RESULTS_DIR)
end

# Utils

"""Generate a path for benchmarking results using current repository status"""
function gen_results_pth()
    repo = LibGit2.GitRepo(PACKAGE_DIR)
    head = LibGit2.head(repo)
    branchname = replace(LibGit2.shortname(head), "/" => "\\/")  # Normalize paths
    hash_str = string(LibGit2.GitHash(LibGit2.peel(LibGit2.GitCommit, head)))
    basename = "$(BENCHMARK_RESULTS_DIR)/$(branchname)-$(hash_str)"
    if LibGit2.isdirty(repo)
        basename *= "-dirty"
    end
    if isfile(basename * ".json")
        i = 1
        while isfile(basename * "-$i.json")
            i += 1
        end
        basename *= "-$i"
    end
    basename *= ".json"
end


#= Benchmarks

Test how much the recalculation of coordinates and dim types
costs over standard getindex/view.

Indexing with Y(1) has no overhead at all, but ranges
have an overhead for slicing the dimensions. =#

const suite = BenchmarkGroup()

suite["view"] = BenchmarkGroup(["view"])
g = DimArray(rand(100, 50), (X(51:150), Y(-40:9)))

vi1(g) = view(data(g), 1, 2)
vd1(g) = view(g, X(1), Y(2))
vi2(g) = view(data(g), :, :)
vd2(g) = view(g, X(:), Y(:))
vi3(g) = view(data(g), 10:40, 1:20)
vd3(g) = view(g, X(10:40), Y(1:20))

suite["view"]["Parent indices with Number"] = @benchmarkable vi1($g)
suite["view"]["Dims with Number"] = @benchmarkable vd1($g)
suite["view"]["Parent indices with Colon"] = @benchmarkable vi2($g);
suite["view"]["Dims with Colon"] = @benchmarkable vd2($g);
suite["view"]["Parent indices with UnitRange"] = @benchmarkable vi3($g);
suite["view"]["Dims with UnitRange"] = @benchmarkable vd3($g);

suite["getindex"] = BenchmarkGroup()
i1(g) = data(g)[10, 20]
d1(g) = g[Y(10), X(20)]
i2(g) = data(g)[:, :]
d2(g) = g[Y(:), X(:)]
i3(g) = data(g)[1:20, 10:40]
d3(g) = g[Y(1:20), X(10:40)]

suite["getindex"]["Parent indices with Number"] = @benchmarkable i1($g)
suite["getindex"]["Dims with Number"] = @benchmarkable d1($g)
suite["getindex"]["Parent indices with Colon"] = @benchmarkable i2($g)
suite["getindex"]["Dims with Colon"] = @benchmarkable d2($g)
suite["getindex"]["Parent indices with UnitRange"] = @benchmarkable i3($g)
suite["getindex"]["Dims with UnitRange"] = @benchmarkable d3($g);

a = rand(5, 4, 3);
da = DimArray(a, (Y((1u"m", 5u"m")), X(1:4), Ti(1:3)))
dimz = dims(da)

suite["eachslice"] = BenchmarkGroup()
suite["eachslice"]["array_intdim"] = @benchmarkable (()->eachslice($a; dims = 2))();
suite["eachslice"]["dimarray_intdim"] = @benchmarkable (()->eachslice($da; dims = 2))();
suite["eachslice"]["dimarray_dim"] = @benchmarkable (()->eachslice($da; dims = Y()))();
suite["eachslice_to_vector"] = BenchmarkGroup()
suite["eachslice_to_vector"]["array_intdim"] = @benchmarkable [slice for slice in eachslice($a; dims = 2)];
suite["eachslice_to_vector"]["dimarray_intdim"] = @benchmarkable [slice for slice in eachslice($da; dims = 2)];
suite["eachslice_to_vector"]["dimarray_dim"] = @benchmarkable [slice for slice in eachslice($da; dims = X())];
# @test [slice for slice in eachslice(da; dims=1)] == [slice for slice in eachslice(da; dims=Y)]



suite["mean"] = BenchmarkGroup()
suite["mean"]["array_intdim"] = @benchmarkable mean($a; dims = 2);
suite["mean"]["dimarray_intdim"] = @benchmarkable mean($da; dims = 2);
suite["mean"]["dimarray_dim"] = @benchmarkable mean($da; dims = X());
suite["permutedims"] = BenchmarkGroup()
suite["permutedims"]["array_intdim"] = @benchmarkable permutedims($a, (2, 1, 3))
suite["permutedims"]["dimarray_intdim"] = @benchmarkable permutedims($da, (2, 1, 3))
suite["permutedims"]["dimarray_dim"] = @benchmarkable permutedims($da, (Y(), X(), Ti()))
suite["reverse"] = BenchmarkGroup()
suite["reverse"]["array_intdim"] = @benchmarkable reverse($a; dims = 1) 
suite["reverse"]["dimarray_intdim"] = @benchmarkable reverse($da; dims = 1) 
suite["reverse"]["dimarray_dim"] = @benchmarkable reverse($da; dims = Y()) 

# Sparse (and similar specialised arrays)

@dim Var "Variable"
@dim Obs "Observation"

sparse_a = sprand(1000, 1000, 0.1)
sparse_d = DimArray(sparse_a, (Var <| 1:1000, Obs <| 1:1000))

suite["sparse"] = BenchmarkGroup()
# Benchmarks
suite["sparse"]["mean with dims arge: regular sparse"] = @benchmarkable mean($sparse_a, dims = $1)
suite["sparse"]["mean with dims arge: dims sparse"] = @benchmarkable mean($sparse_d, dims = $(Var()))

suite["sparse"]["mean: regular sparse"] = @benchmarkable mean($sparse_a)
suite["sparse"]["mean: dims sparse"] = @benchmarkable mean($sparse_d)

suite["sparse"]["copy: regular sparse"] = @benchmarkable copy($sparse_a)
suite["sparse"]["copy: dims sparse"] = @benchmarkable copy($sparse_d)

suite["sparse"]["reduce: regular sparse"] = @benchmarkable reduce(+, $sparse_a)
suite["sparse"]["reduce: dims sparse"] = @benchmarkable reduce(+, $sparse_a)

suite["sparse"]["map: regular sparse"] = @benchmarkable map(sin, $sparse_a)
suite["sparse"]["map: dims sparse"] = @benchmarkable map(sin, $sparse_a)

paramspath = joinpath(dirname(@__FILE__), "params.json")
resultpath = gen_results_pth()

if isfile(paramspath)
    println("Found tuning info at $(paramspath)")
    loadparams!(suite, BenchmarkTools.load(paramspath)[1], :evals);
else
    println("Running tuning...")
    tune!(suite)
    BenchmarkTools.save(paramspath, params(suite));
    println("Tuning results cached to $(paramspath)")
end

results = run(suite, verbose = true)
println("Writing results to: $(resultpath)")
BenchmarkTools.save(resultpath, results)

using Colors
using CairoMakie
using Random
Random.seed!(13)
CairoMakie.activate!()

rpyz = [Rect3f(Vec3f(0, j-0.8,k), Vec3f(0.1, 0.8,0.8))
    for j in 1:7 for k in 1:7]
rmyz = [Rect3f(Vec3f(j-0.8, 0,k), Vec3f(0.8, 0.1,0.8))
    for j in 1:7 for k in 1:7]

colors = ["#ff875f", "#0087d7", "#5fd7ff", "#ff5f87", "#b2b2b2", "#d75f00", "#00afaf"]
base_points = [Point3f(i,j,0) for i in range(0.5,6.0,7) for j in range(0.5,6.0,7)]
z = 2.0*rand(length(base_points))
fig = Figure(; size=(500,500),
    backgroundcolor=:transparent,
    fonts = (; regular = "Barlow"))
ax = LScene(fig[1,1]; show_axis=false)

wireframe!.(ax, rpyz; color = colors[3], transparency=true) # shading=NoShading # bug!
poly!.(ax, rmyz; color=0.85*colorant"#ff875f", transparency=true, shading=NoShading)

meshscatter!(ax, [Point3f(0.1,0.1,0.8), Point3f(0.1+7,0.1,0.8),
    Point3f(0.1,0.1+7,0.8), Point3f(0.1+7,0.1+7,0.8)]; color = colors[4],
    markersize=0.25, shading=FastShading)

lines!(ax, [Point3f(0.1,0.1,0.8), Point3f(0.1+7,0.1,0.8), Point3f(0.1+7,0.1+7,0.8), 
    Point3f(0.1,0.1+7,0.8), Point3f(0.1,0.1,0.8)]; color = colors[4],
    linewidth=2, transparency=true)
meshscatter!(ax, Point3f(4,4,-0.01); color=:transparent)
meshscatter!(ax, [Point3f(0.1,0.1,8), Point3f(0.1+7,0.1,8), Point3f(0.1,0.1+7,8), Point3f(0.1+7,0.1+7,8)]; color = colors[2], markersize=0.2, shading=FastShading)

lines!(ax, [ Point3f(0.1+7,0.1,8), Point3f(0.1+7,0.1+7,8), 
    Point3f(0.1,0.1+7,8),
    ];
    color = colors[2],
    linewidth=2, transparency=true)
meshscatter!(ax, base_points; marker=Rect3f(Vec3f(-0.5,-0.5,0), Vec3f(1,1,1)),
    markersize = Vec3f.(0.5,0.5, z), color=z, colormap=tuple.(colors, 1), transparency=false)

mkpath(joinpath(@__DIR__, "src", "assets"))
save(joinpath(@__DIR__, "src", "assets", "logo.svg"), fig; pt_per_unit=0.75)
save(joinpath(@__DIR__, "src", "assets", "logo.png"), fig; px_per_unit=2)
save(joinpath(@__DIR__, "src", "assets", "favicon.png"), fig; px_per_unit=0.25)
mv(joinpath(@__DIR__, "src", "assets", "favicon.png"), joinpath(@__DIR__, "src", "assets", "favicon.ico"))

using Test, DimensionalData, Dates

using DimensionalData.Lookups, DimensionalData.Dimensions
const DD = DimensionalData

@testset "predicates on Lookup" begin
    @test DD.issampled(Cyclic(1:10; order=ForwardOrdered(), cycle=10)) == true
    @test DD.issampled(NoLookup()) == false
    @test DD.issampled(Categorical(1:10)) == false
    @test DD.iscategorical(Categorical(1:10)) == true
    @test DD.iscategorical(Sampled(1:10)) == false
    @test DD.iscategorical(Cyclic(1:10; order=ForwardOrdered(), cycle=10)) == false
    @test DD.iscategorical(NoLookup()) == false
    @test DD.iscyclic(Cyclic(1:10; order=ForwardOrdered(), cycle=10)) == true
    @test DD.iscyclic(Sampled(1:10)) == false
    @test DD.iscyclic(NoLookup()) == false
    @test DD.iscyclic(Categorical(1:10)) == false
end

@testset "predicates on Lookup traits" begin
    @test DD.isordered(ForwardOrdered()) == true
    @test DD.isordered(ReverseOrdered()) == true
    @test DD.isordered(Unordered()) == false
    @test DD.isforward(ForwardOrdered()) == true
    @test DD.isforward(ReverseOrdered()) == false
    @test DD.isforward(Unordered()) == false
    @test DD.isreverse(ReverseOrdered()) == true
    @test DD.isreverse(ForwardOrdered()) == false
    @test DD.isreverse(Unordered()) == false
    @test DD.isregular(Regular(1.0)) == true
    @test DD.isregular(Irregular((1.0, 2.0))) == false
    @test DD.isregular(Explicit([1 2])) == false
    @test DD.isexplicit(Explicit([1 2])) == true
    @test DD.isexplicit(Regular(1.0)) == false
    @test DD.isexplicit(Irregular((1, 2))) == false
    @test DD.ispoints(Points()) == true
    @test DD.ispoints(Intervals()) == false
    @test DD.isintervals(Intervals()) == true
    @test DD.isintervals(Points()) == false
    @test DD.isstart(Start()) == true
    @test DD.isstart(Center()) == false
    @test DD.isstart(End()) == false
    @test DD.iscenter(Center()) == true
    @test DD.iscenter(Start()) == false
    @test DD.iscenter(End()) == false
    @test DD.isend(End()) == true
    @test DD.isend(Start()) == false
    @test DD.isend(Center()) == false
end

@testset "predicates on Array or dimensions" begin
    A = rand(X(10:20), Y(10:20))
    for x in (A, dims(A))
        @test DD.issampled(x) == true
        @test DD.iscategorical(x) == false
        @test DD.iscyclic(x) == false
        @test DD.isordered(x) == true
        @test DD.isforward(x) == true
        @test DD.isreverse(x) == false
        @test DD.isregular(x) == true
        @test DD.isexplicit(x) == false
        @test DD.ispoints(x) == true
        @test DD.isintervals(x) == false
        @test DD.isstart(x) == false
        @test DD.iscenter(x) == true
        @test DD.isend(x) == false
    end
end

@testset "predicates on subsets of dimensions" begin
    ds = X(10:20), 
         Ti(Cyclic([DateTime(2001), DateTime(2002), DateTime(2003)]; order=ForwardOrdered(), cycle=Year(3), sampling=Intervals(Start()))), 
         Y(20:-1:10; sampling=Intervals(End())), 
         Dim{:cat}(["a", "z", "b"])
    A = rand(ds)
    @test DD.issampled(A) == false
    @test DD.iscategorical(A) == false
    @test DD.iscyclic(A) == false
    @test DD.isordered(A) == false
    @test DD.isforward(A) == false
    @test DD.isreverse(A) == false
    @test DD.isregular(A) == false
    @test DD.isexplicit(A) == false
    @test DD.ispoints(A) == false
    @test DD.isintervals(A) == false
    @test DD.isstart(A) == false
    @test DD.iscenter(A) == false
    @test DD.isend(A) == false

    @test DD.issampled(A, (X, Y, Ti)) == true
    @test DD.iscategorical(A, :cat) == true
    @test DD.iscyclic(A, Ti) == true
    @test DD.isordered(A, (X, Y, Ti)) == true
    @test DD.isforward(A, (X, Ti)) == true
    @test DD.isreverse(A, Y) == true
    @test DD.isregular(A, (X, Y)) == true
    @test DD.ispoints(A, X) == true
    @test DD.isintervals(A, (Ti, Y)) == true
    @test DD.isstart(A, Ti) == true
    @test DD.iscenter(A, X) == true
    @test DD.isend(A, Y) == true
end

using DimensionalData, Statistics, Test, Unitful, SparseArrays, Dates, LinearAlgebra

using DimensionalData: AnonDim
using Combinatorics: combinations

@testset "*" begin
    timespan = DateTime(2001):Month(1):DateTime(2001,12)
    A1 = DimArray(rand(12), (Ti(timespan),))
    A2 = DimArray(rand(12, 1), (Ti(timespan), X(10:10:10)))

    @test length.(dims(A1)) == size(A1)
    @test dims(parent(A1) * permutedims(A1)) isa Tuple{<:AnonDim,<:Ti}
    @test parent(A1) * permutedims(A1) == parent(A1) * permutedims(parent(A1))
    @test dims(permutedims(A1) * parent(A1)) isa Tuple{<:AnonDim}
    @test permutedims(A1) * parent(A1) == permutedims(parent(A1)) * parent(A1)

    @test length.(dims(permutedims(A1) * parent(A1))) == size(permutedims(parent(A1)) * parent(A1))
    @test length.(dims(permutedims(A1) * A1)) == size(permutedims(parent(A1)) * parent(A1))
    @test length.(dims(permutedims(parent(A1)) * A1)) == size(permutedims(parent(A1)) * parent(A1))

    @test length.(dims(parent(A1) * permutedims(A1))) == size(parent(A1) * permutedims(parent(A1)))
    @test length.(dims(A1 * permutedims(A1))) == size(parent(A1) * permutedims(parent(A1)))
    @test length.(dims(A1 * permutedims(parent(A1)))) == size(parent(A1) * permutedims(parent(A1)))

    @test length.(dims(A2)) == size(A2)
    @test length.(dims(A2')) == size(A2')

    sze1 = (12, 12)
    @test size(parent(A2) * parent(A2)') == sze1
    @test length.(dims(A2 * A2')) == sze1
    @test length.(dims(parent(A2) * A2')) == sze1
    @test length.(dims(A2 * parent(A2'))) == sze1
    sze2 = (1, 1)
    @test size(parent(A2') * parent(A2)) == sze2
    @test length.(dims(A2' * A2)) == sze2
    @test length.(dims(parent(A2') * A2)) == sze2
    @test length.(dims(A2' * parent(A2))) == sze2

    B1 = DimArray(rand(12, 6), (Ti(timespan), X(1:6)))
    B2 = DimArray(rand(8, 12), (Y(1:8), Ti(timespan)))
    b1 = DimArray(rand(12), Ti(timespan))

    # Test dimension propagation
    @test (B2 * B1) == (parent(B2) * parent(B1))
    @test dims(B2 * B1) isa Tuple{<:Y, <:X}
    @test length.(dims(B2 * B1)) == (8, 6)

    # Test where results have an empty dim
    true_result = (parent(b1)' * parent(B1))
    flip = adjoint
    for flip in (adjoint, transpose, permutedims)
        result = flip(b1) * B1
        @test result ≈ true_result
        # Permute dims is not exactly transpose
        @test dims(result) isa Tuple{<:AnonDim, <:X}
        @test length.(dims(result)) == (1, 6)
    end

    # Test flipped * flipped
    for (flip1, flip2) in combinations((adjoint, transpose, permutedims), 2)
        result = flip1(B1) * flip2(B2)
        @test result == flip1(parent(B1)) * flip2(parent(B2))
        @test dims(result) isa Tuple{<:X, <:Y}
        @test size(result) == (6, 8)
    end

    @testset "strictness" begin
        B2c = DimArray(rand(8, 12), (Y('a':'h'), Ti(1.0:12.0)))
        DimensionalData.strict_matmul!(false)
        @test !DimensionalData.strict_matmul()
        @test_nowarn B2c * b1
        DimensionalData.strict_matmul!(true)
        @test DimensionalData.strict_matmul()
        @test_throws DimensionMismatch B2c * b1
    end
end

@testset "some matmul ambiguity methods" begin
    special_types = (Adjoint, Transpose, Diagonal, Symmetric, Tridiagonal, SymTridiagonal, BitArray,)

    @testset "DimMatrix" begin
        da = DimArray(ones(5,5), (:a, :b))
        @testset "$T" for T in special_types
            x = T(ones(5,5))
            @test dims(x * da) isa Tuple{<:AnonDim, Dim{:b}}
            @test lookup(dims(x * da, 1)) == axes(x, 1)
            @test dims(da * x) isa Tuple{Dim{:a}, <:AnonDim}
            @test lookup(dims(da * x, 2)) == axes(x, 2)
            @test typeof(x * da) <: DimArray
            @test typeof(da * x) <: DimArray
            @test parent(da' * x) == parent(da)' * x
            @test parent(x * da) == x * parent(da) 
        end
    end

    @testset "DimVector" begin
        dv = DimArray(ones(5), :vec)
        @testset "$T" for T in special_types
            x = T(ones(5,5))
            @test dims(x * dv) isa Tuple{<:AnonDim}
            @test lookup(dims(x * dv)[1]) == axes(x, 1)
            @test dims(dv' * x) isa Tuple{<:AnonDim,<:AnonDim}
            @test lookup(dims(dv' * x)) == (axes(dv, 2), axes(x, 2))
            @test typeof(x * dv) <: DimArray
            @test typeof(dv' * x) <: DimArray
            @test parent(dv' * x) == parent(dv)' * x
            @test parent(x * dv) == x * parent(dv) 
        end
        @testset "$T" for T in (Adjoint, Transpose)
            x = T(1:5)
            @test x * dv === 15.0
            @test typeof(dv * x) <: DimArray
            @test dims(dv * x) isa Tuple{<:Dim{:vec},AnonDim}
            @test lookup(dims(dv * x, 2)) === axes(x, 2)
            @test dv * x == vcat(x, x, x, x, x)
        end

    end

end

struct ArrayMulWrapper{T,N} <: AbstractArray{T,N}
    data::AbstractDimArray{T,N}
end
VecOrMatMulWrapper{T} = Union{ArrayMulWrapper{T,1},ArrayMulWrapper{T,2}}
Base.size(x::ArrayMulWrapper) = size(x.data)
Base.axes(x::ArrayMulWrapper) = axes(x.data)
Base.getindex(x::ArrayMulWrapper, i::Int) = x.data[i]
Base.getindex(x::ArrayMulWrapper, I::Vararg{Int, N}) where {N} = x.data[I...]
Base.:*(A::VecOrMatMulWrapper, B::VecOrMat) = A.data * B
Base.:*(A::VecOrMat, B::VecOrMatMulWrapper) = A * B.data

@testset "DimArrays constructed with DimUnitRange axes" begin
    x = X(0f0:2f0)
    y = Y(5.0:7.0)
    z = Z(['a', 'b'])
    t = Ti([:c])

    @testset for ((Adims, Bdims), Cdims) in [
        ((x, y), (y, z)) => (x, z),
        ((x, y), (y,)) => (x,),
        ((x,), (t, z)) => (x, z),
    ]
        A = rand(Adims...)
        B = rand(Bdims...)
        C = ArrayMulWrapper(A) * B
        @test C isa DimArray
        @test C ≈ A * B
        @test Dimensions.comparedims(Bool, C, Cdims)
        C2 = A * ArrayMulWrapper(B)
        @test C2 isa DimArray
        @test C ≈ A * B
        @test Dimensions.comparedims(Bool, C2, Cdims)
    end

    yalt = Y(3.0:5.0)
    @test length(yalt) == length(y)
    @testset for (Adims, Bdims) in [
        ((x, y), (yalt, z)),
        ((x, y), (yalt,)),
    ]
        A = rand(Adims...)
        B = rand(Bdims...)
        @test_throws DimensionMismatch ArrayMulWrapper(A) * B
        @test_throws DimensionMismatch A * ArrayMulWrapper(B)
    end
end

using DimensionalData, Test
using DimensionalData: X, Y
using BenchmarkTools

for N ∈ (10, 100, 1000)
    x = X(range(1; length = N))
    y = Y(range(1; length = N))
    d = (x, y)
    A = DimArray(rand(length.(d)...), d)

    println("N=$(N). Time to access via X(1:3)")
    @btime $(A)[$(X(1:3))];
end

println("Time to access if X(1:3) is not interpolated constant")
@btime $(A)[X(1:3)];
println("Time to just access A.data")
@btime $(A)[1:3, :]
@btime $(A)[1, 1]

# println("Time to do A+A")
# @btime $(A) .+ $(A);
# println("Time to do A.data + A.data")
# @btime $(A.data) .+ $(A.data);

PrecompileTools.@compile_workload begin
    buffer = IOContext(IOBuffer(), :color=>true)
    f = zeros
    for f in (zeros, ones, falses, trues, rand)
        x, y, z = X([:a, :b]), Y(10.0:10.0:30.0), Z()
        dimz = x, y
        A = f(x, y)
        da1 = DimArray(A, (x, y); name=:one)
        da2 = DimArray(Float32.(2A), (x, y); name=:two)
        da3 = DimArray(round.(Int, 3A), (x, y); name=:three)
        da4 = DimArray(cat(4A, 5A, 6A, 7A; dims=Z()); name=:extradim);
        show(buffer, MIME"text/plain"(), da1)
        show(buffer, MIME"text/plain"(), da2)
        show(buffer, MIME"text/plain"(), da3)
        show(buffer, MIME"text/plain"(), da4)
        st1 = DimStack(da1, da2)
        show(buffer, MIME"text/plain"(), st1)
        st2 = DimStack(da1, da2, da3)
        show(buffer, MIME"text/plain"(), st2)
        st3 = DimStack(da1, da2, da3, da4)
        show(buffer, MIME"text/plain"(), st3)
        mst1 = merge(st1, st2)
        mst2 = merge(st1, st3)
    end
end

# Define predicates directly on lookup traits
isregular(::Regular) = true
isregular(::Sampling) = false
isexplicit(::Explicit) = true
isexplicit(::Sampling) = false
isaligned(::Lookup) = false
isaligned(::Aligned) = true
issampled(::AbstractSampled) = true
issampled(::Lookup) = false
iscategorical(::AbstractCategorical) = true
iscategorical(::Lookup) = false
iscyclic(::AbstractCyclic) = true
iscyclic(::Lookup) = false
isnolookup(::Lookup) = false
isnolookup(::NoLookup) = true
isstart(::Start) = true
isstart(::Locus) = false
iscenter(::Center) = true
iscenter(::Locus) = false
isend(::End) = true
isend(::Locus) = false
isforward(::ForwardOrdered) = true
isforward(::Order) = false
isreverse(::ReverseOrdered) = true
isreverse(::Order) = false
isordered(::Ordered) = true
isordered(::Order) = false
isintervals(::Intervals) = true
isintervals(::Points) = false
ispoints(::Points) = true
ispoints(::Intervals) = false
hasinternaldimensions(::Lookup) = false
hasinternaldimensions(::Any) = false  # Fallback for non-Lookup types (e.g., raw arrays)

# Forward them from lookups
for f in (:isregular, :isexplicit)
    @eval $f(l::Lookup) = $f(span(l))
end
for f in (:isintervals, :ispoints)
    @eval $f(l::Lookup) = $f(sampling(l))
end
for f in (:isstart, :isend)
    @eval $f(l::AbstractSampled) = $f(locus(l))
    @eval $f(l::Lookup) = false
end
iscenter(l::AbstractSampled) = iscenter(locus(l))
iscenter(l::Lookup) = true

for f in (:isordered, :isforward, :isreverse)
    @eval $f(l::Lookup) = $f(order(l))
end


# Docs
@doc """
    hasinternaldimensions(l::Lookup)::Bool

Return `true` if the lookup has internal dimensions, `false` otherwise.

If this is `true` for your lookup, then it must:
- Implement `DD.dims(lookup)::Tuple{Vararg{Dimension}}`
- Return a tuple of bounds, one per internal dimension, from `DD.bounds(lookup)`.  
  This means a length-`n` tuple of 2-tuples, where `n` is the number of internal dimensions.
"""
hasinternaldimensions

"""
    AbstractDimTree

Abstract supertype for tree-like dimensional data.

These objects are mutable and fast compiled, as
an alternative to the flat, immutable `AbstractDimStack`.
"""
abstract type AbstractDimTree end

(::Type{T})(As::Tuple{Vararg{AbstractDimArray}}) where T<:AbstractDimTree = 
    T(collect(As))
(::Type{T})(As::AbstractArray{<:AbstractDimArray}) where T<:AbstractDimTree = 
    T(OrderedDict(Symbol(name(A)) => A for A in As))
(::Type{T})(data, dims::DimTuple; kw...) where T <:AbstractDimTree = 
    T(; data, dims, kw...)
function (::Type{T})(pairs::AbstractDict{<:Symbol,<:AbstractDimArray}; 
    data=DataDict((k => parent(v) for (k, v) in pairs)),
    dims=DD.combinedims(collect(dims(A) for (k, A) in pairs)),
    layerdims=TupleDict((k => basedims(v) for (k, v) in pairs)),
    layermetadata=DataDict((k => metadata(v) for (k, v) in pairs)),
    kw...
) where T <:AbstractDimTree
    T(data, dims; layerdims, layermetadata, kw...)
end
function (::Type{T})(stack::AbstractDimStack;
    metadata=metadata(stack),
    layerdims=TupleDict(pairs(layerdims(stack))),
    layermetadata=DataDict(pairs(layermetadata(stack))),
    kw...
) where T<:AbstractDimTree
    data = DataDict(pairs(parent(stack)))
    T(data, dims(stack); metadata, layerdims, layermetadata, kw...)
end

data(dt::AbstractDimTree) = getfield(dt, :data)::DataDict
data(dt::AbstractDimTree, key::Symbol) = data(dt)[key]
tree(dt::AbstractDimTree) = getfield(dt, :tree)
branches(dt::AbstractDimTree) = getfield(dt, :branches)

const TupleDict = OrderedDict{Symbol,Tuple}
const DataDict = OrderedDict{Symbol,Any}
const TreeDict = OrderedDict{Symbol,AbstractDimTree}
const PairKeys = Pair{Symbol,<:Union{<:Pair,Symbol}}

# TODO fix the order to match the arrays
function dims(dt::AbstractDimTree)
    ds = _dims(dt)
    t = tree(dt)
    return isnothing(t) ? ds : (dims(t)..., ds...)
end
_dims(dt::AbstractDimTree) = getfield(dt, :dims)

layermetadata(dt::AbstractDimTree) = getfield(dt, :layermetadata)
layermetadata(dt::AbstractDimTree, key::Symbol) = layermetadata(dt)[key]
layerdims(dt::AbstractDimTree) = getfield(dt, :layerdims)
layerdims(dt::AbstractDimTree, key::Symbol) = layerdims(dt)[key]
layers(dt::AbstractDimTree) = DataDict((pn => dt[pn] for pn in keys(dt)))

# DimStack constructors on DimTree
# If this method has ambiguities, define it for the DimStack type and call dimstack_from_tree
(::Type{T})(dt::AbstractDimTree; kw...) where {T<:AbstractDimStack} =
    dimstack_from_tree(T, dt; kw...)
DimStack(dt::AbstractDimTree; kw...) = dimstack_from_tree(DimStack, dt; kw...)

function dimstack_from_tree(T, dt; keep=nothing)
    if isnothing(keep)
        T(dt[Tuple(keys(dt))])
    else
        pruned = DD.prune(dt; keep)
        T(pruned[Tuple(keys(pruned))])
    end
end

function Extents.extent(dt::AbstractDimTree)
    ext = Extents.extent(dims(dt))
    for (_, branch) in pairs(branches(dt))
        ext = Extents.union(ext, Extents.extent(branch))
    end
    return ext
end

for func in INTERFACE_QUERY_FUNCTION_NAMES  
    @eval ($func)(s::AbstractDimTree, args...) = ($func)(dims(s), args...)
end

Base.pairs(dt::AbstractDimTree) = (k => dt[k] for k in keys(dt))
Base.keys(dt::AbstractDimTree) = collect(keys(data(dt)))
Base.length(dt::AbstractDimTree) = length(data(dt))
Base.haskey(dt::AbstractDimTree, key::Symbol) = haskey(data(dt), key::Symbol)
Base.isempty(dt::AbstractDimTree) = Base.isempty(data(dt))
Base.iterate(dt::AbstractDimTree, args...) = Base.iterate(data(dt), args...)
Base.propertynames(dt::AbstractDimTree) = collect(keys(branches(dt)))
function Base.copy(dt::AbstractDimTree) 
    rebuild(dt; 
        data=copy(data(dt)),
        layerdims=copy(layerdims(dt)),
        layermetadata=copy(layermetadata(dt)),
        branches=copy(branches(dt)),
        tree=(t = getfield(dt, :tree); isnothing(t) ? t : copy(t))
    )
end
# If we select a single name we get a DimArray
function Base.getproperty(dt::AbstractDimTree, name::Symbol)
    haskey(branches(dt), name) ||throw(KeyError(name))
    return branches(dt)[name]
end
function Base.:(==)(dt1::AbstractDimTree, dt2::AbstractDimTree) 
    data(dt1) == data(dt2) &&
    layerdims(dt1) === layerdims(dt2) &&
    dims(dt2) == dims(dt2) &&
    branches(dt2) == branches(dt2)
end
Base.only(dt::AbstractDimTree) = dt[only(keys(data(dt)))]
Base.get(dt::AbstractDimTree, name::Symbol, default) =
    haskey(dt, name) ? dt[name] : default
Base.get(f::Base.Callable, dt::AbstractDimTree, name::Symbol) =
    haskey(dt, name) ? dt[name] : f()
function Base.filter!(pred, dt::AbstractDimTree)
    for (k, v) in pairs(dt)
        pred(v) || delete!(dt, k)
    end
end
function Base.get!(f::Base.Callable, dt::AbstractDimTree, name::Symbol)
    if haskey(dt, name) 
        return dt[name] 
    else
        x = f()
        dt[name] = x
        return x
    end
end

# Index with `Symbol` name and we get a DimArray
function Base.getindex(dt::AbstractDimTree, name::Symbol)
    data = DD.data(dt, name)
    dims = DD.dims(dt, layerdims(dt, name))
    refdims = DD.refdims(dt)
    metadata = layermetadata(dt, name)
    return DimArray(data, dims; refdims, name, metadata) 
end
# Index with Tuple or Vector of Symbol and we get a DimStack
function Base.getindex(
    dt::AbstractDimTree, names::Union{AbstractArray{Symbol},NTuple{<:Any,Symbol}}
)
    N = Tuple(names)
    data = map(n -> DD.data(dt, n), names) |> NamedTuple{N}
    layerdims = map(names) do n
        DD.layerdims(dt, n)
    end |> NamedTuple{N}
    layermetadata = map(names) do n
        DD.layermetadata(dt, n)
    end |> NamedTuple{N}
    dims = reduce(names; init=Symbol[]) do acc, n
        union(acc, collect(DD.layerdims(dt, n)))
    end |> Tuple
    return DimStack(data, DD.dims(dt, dims); 
        refdims=DD.refdims(dt),
        metadata=metadata(dt),
        layerdims,
        layermetadata,
    ) 
end
# Otherwise we can use a Selector and get a DimTree
for f in (:getindex, :view)
    @eval function Base.$f(dt::AbstractDimTree; kw...)
        Base.$f(dt::AbstractDimTree, Dimensions.kw2dims(kw)...)
    end
    @eval function Base.$f(dt::AbstractDimTree, D::Dimension{<:SelectorOrInterval}...)
        newlayers = Vector{Pair{Symbol,Any}}(undef, length(layers(dt)))
        newbranches = Vector{Pair{Symbol,Any}}(undef, length(branches(dt)))
        for (i, (name, A)) in enumerate(pairs(layers(dt)))
            newlayers[i] = name => $f(A, D...)
        end
        for (i, (name, branch)) in enumerate(pairs(branches(dt)))
            newbranches[i] = name => $f(branch, D...)
        end
        rebuild_from_arrays(dt, newlayers; branches=TreeDict(newbranches))
    end
end

# A DimArray and a symbol sets a layer
function Base.setindex!(dt::AbstractDimTree, A::AbstractDimArray, key::Symbol)
    _adddims!(dt, dims(A))
    data(dt)[key] = parent(A)
    layerdims(dt)[key] = basedims(A)
    layermetadata(dt)[key] = metadata(A)
    return A
end

function _adddims!(dt::AbstractDimTree, newdims::Tuple)
    # Check first so we don't change anything before we error
    _checkbranchdims(dt, newdims)
    # Add new dims to the tree
    if length(dims(dt)) == 0
        setfield!(dt, :dims, newdims)
    else
        # If there are already dims, check they match before we do anything
        cd = commondims(dt, newdims)
        comparedims(dims(dt, cd), dims(newdims, cd))
        setfield!(dt, :dims, (dims(dt)..., otherdims(newdims, dims(dt))...))
    end
    # If any of the branches already had these 
    # dims, we need to remove them now
    _removebranchdims!(dt, newdims)
end
function _checkbranchdims(dt::AbstractDimTree, newdims)
    for (key, branch) in pairs(branches(dt))
        comparedims(newdims, dims(_dims(branch), newdims))
    end
end
function _removebranchdims!(dt::AbstractDimTree, newdims)
    # Remove dims now present on a lower branch
    for (key, branch) in pairs(branches(dt))
        # Keep only dims not in the tree
        setfield!(branch, :dims, otherdims(dims(branch), newdims))
        _removebranchdims!(branch, newdims)
    end
end

# A DimTree or DimStack and a symbol sets a branch
Base.setindex!(tr::AbstractDimTree, br::Union{AbstractDimTree,AbstractDimStack}, key::Symbol) =
    branches(tr)[key] = br
function Base.setindex!(tr::AbstractDimTree, layers::Union{AbstractDimTree,AbstractDimStack})
    for key in keys(layers)
        tr[key] = layers[key]
    end
    return layers
end
Base.setproperty!(dt::T, key::Symbol, A::AbstractDimArray) where T<:AbstractDimTree =
    setproperty!(dt, key, T(A))
Base.setproperty!(dt::T, key::Symbol, newbranch::AbstractDimStack) where T<:AbstractDimTree  =
    setproperty!(dt, key, T(newbranch))
function Base.setproperty!(dt::AbstractDimTree, key::Symbol, newbranch::AbstractDimTree)
    if dt == newbranch
        newbranch = copy(newbranch)
    end
    comparedims(commondims(dt, dims(newbranch)), dims(newbranch, dims(dt)))
    # The branch only holds dimensions not in the tree
    setfield!(newbranch, :dims, otherdims(newbranch, dims(dt)))
    # Set the tree in the new branch
    setfield!(newbranch, :tree, dt)
    # Add the branch to the data Dict
    branches(dt)[key] = newbranch
    return newbranch
end

function Base.empty!(dt::AbstractDimTree) 
    empty!(data(dt))
    empty!(layerdims(dt))
    empty!(layermetadata(dt))
    dt.dims = ()
    return dt
end
function Base.sort!(dt::AbstractDimTree, args...; kw...)
    sort!(data(dt), args...; kw...)
    sort!(layerdims(dt), args...; kw...)
    sort!(layermetadata(dt), args...; kw...)
    return dt
end
function Base.delete!(tr::AbstractDimTree)
    trunk = tree(tr)
    if isnothing(trunk)
        return tr
    else
        for (key, branch) in pairs(branches(trunk))
            if branch === tr 
                delete!(branches(trunk), key)
            end
        end
    end
    return trunk
end
function Base.delete!(tr::AbstractDimTree, key::Symbol)
    delete!(data(tr), key) 
    delete!(layerdims(tr), key) 
    delete!(layermetadata(tr), key) 
    _repairdims!(tr)
    return tr
end
function Base.pop!(tr::AbstractDimTree, key::Symbol)
    l = tr[key]
    delete!(data(tr), key) 
    delete!(layerdims(tr), key) 
    delete!(layermetadata(tr), key) 
    _repairdims!(tr)
    return l
end
Base.pop!(tr::AbstractDimTree, key::Symbol, default) =
    haskey(tr, key) ? pop!(tr, key) : default
function Base.pop!(dt::AbstractDimTree)
    ks = keys(dt)
    length(ks) > 0 || throw(ArgumentError("$(basetypeof(dt)) must be non-empty"))
    key = last(ks)
    return key => pop!(dt, key)
end

function _repairdims!(tr::AbstractDimTree)
    if isempty(layerdims(tr))
        tr.dims = ()
        return tr
    end
    ldims = reduce(layerdims(tr); init=Dimension[]) do acc, (k, v)
        union(v, acc)
    end
    if length(ldims) != length(_dims(tr))
        setfield!(tr, :dims, dims(_dims(tr), Tuple(ldims)))
    end
    return tr
end

"""
    prune(dt::AbstractDimTree; keep::Union{Symbol,Pair{Symbol}})

Prune a tree to remove branches.

`keep` specifies a branch to incorprate into the tree, after
it is also pruned. A `Pair` can be used to specify a branch
to keep in that branch, and these may be chained as e.g.
`keep=:branch => :smallbranch => :leaf`.

`prune` results in a DimTree that is completely convertable to a 
[`DimStack`](@ref), as it no longer has branches with divergent dimensions.

# Example 

```julia
pruned = prune(dimtree; keep=:branch => :leaf)
DimStack(pruned)
```
"""
function prune(dt::AbstractDimTree; 
    keep::Union{Nothing,Symbol,PairKeys}=nothing
)
    # No kept branches, just make a new `branches` dict
    isnothing(keep) && return rebuild(dt; branches=TreeDict(), tree=nothing)

    # Otherwise prune the kept branch
    branch = if keep isa Symbol
        # Symbol keeps one pruned branch
        prune(getproperty(dt, keep))
    else
        # Pairs will also keep a branch of the branch
        prune(getproperty(dt, first(keep)); keep=last(keep))
    end
    if isempty(dt)  && isempty(branch)
        layerdims = TupleDict()
        layermetadata = DataDict()
        data = DataDict()
    else
        if isempty(dt)
            layerpairs = collect(pairs(branch))
        else
            layerpairs = hcat(collect(pairs(dt)), collect(pairs(branch)))
        end
        layerdims = TupleDict(map(x -> first(x) => basedims(last(x)), layerpairs))
        layermetadata = DataDict(map(x -> first(x) => metadata(x), layerpairs))
        data = DataDict(map(p -> p[1] => parent(p[2]), layerpairs))
    end
    return rebuild(dt; 
        data,
        layerdims,
        layermetadata,
        dims=dims(branch), # The branch has all the dims already
        branches=TreeDict(), # There a no branches after flattening
        tree=nothing,
    ) 
end

"""
    DimTree 

A nested tree of dimensional arrays.

Still in expermental stage: breaking changes may occurr without 
a major version bump to DimensionalData. Please report any issues and 
feedback on GitHub to push this towards a stable implementation.

`DimTree` is loosely typed and based on `OrderedDict` rather
than `NamedTuple` of `DimStack`, so it is slower to index
but very fast to compile, and very flexible.

Trees can be nested indefinately, branches inheriting dimensions
from the tree. 

# Getting and setting layers and branches

Local layers are accessed with `getindex` and a `Symbol`, returning
a `DimArray`, e.g. `dt[:layer]` or a `DimStack` with `dt[(:layer1, :layer2)]`. 

Branches are accessed with `getproperty`,
e.g. `dt.branch`. 

Layers and branches can be set with `setindex!` and `setproperty!` respectively.

## Dimensions and branches

Dimensions that are shared with the base of the tree must be identical.
They are stored at the base level of the tree that they are used in, 
and propagate out to branches.

Within a branch, all layers use a subset of the dimensions available
to the branch.

Accross branches, there may be versions of the same dimensions with 
different lookup values. These may cover different extents, resolutions, 
or whatever properties of lookups are required to vary.

This property can be used for tiles with differen X/Y extents or pyramid
layers with different resolutions, for example.

## Example

```julia
xdim, ydim = X(1:10), Y(1:15)
z1, z2 = Z([:a, :b, :c]), Z([:d, :e, :f])
a = rand(xdim, ydim)
b = rand(Float32, xdim, ydim)
c = rand(Int, xdim, ydim, z1)
d = rand(Int, xdim, z2)
DimTree(a, b)
```
"""
@kwdef mutable struct DimTree <: AbstractDimTree
    data::DataDict = DataDict()
    dims::Tuple = ()
    refdims::Tuple = ()
    layerdims::TupleDict = TupleDict()
    layermetadata::DataDict = DataDict(Base.keys(layerdims) .=> NoMetadata()) 
    metadata::Any = NoMetadata()
    branches::TreeDict = TreeDict()
    tree::Union{Nothing,AbstractDimTree} = nothing
    function DimTree(data, dims, refdims, layerdims, layermetadata, metadata, branches, tree)
        @assert keys(data) == keys(layerdims) == keys(layermetadata) 
        new(data, dims, refdims, layerdims, layermetadata, metadata, branches, tree)
    end
end
DimTree(p1::Pair, pairs::Pair...) = DimTree(OrderedDict((p1, pairs...)))
DimTree(A1::AbstractDimArray, As::AbstractDimArray...) = DimTree([A1, As...])

function rebuild(dt::AbstractDimTree; 
    data=data(dt), 
    dims=dims(dt),
    refdims=refdims(dt), 
    metadata=metadata(dt), 
    layerdims=layerdims(dt), 
    layermetadata=layermetadata(dt),
    tree=tree(dt),
    branches=branches(dt),
)
    basetypeof(dt)(; 
        data, 
        dims, 
        refdims,
        metadata,
        layerdims,
        layermetadata,
        tree,
        branches,
    )
end

function rebuild_from_arrays(dt::AbstractDimTree, layers::AbstractArray{<:Pair}; 
    data=DataDict(k => parent(v) for (k, v) in layers),
    dims=DD.combinedims(map(last, layers)),
    refdims=refdims(dt), 
    metadata=metadata(dt), 
    layerdims=layerdims(layers), 
    layermetadata=layermetadata(layers),
    branches=branches(dt),
    tree=nothing,
)
    rebuild(dt; data, dims, refdims, layerdims, metadata, layermetadata, branches, tree)
end

layerdims(layers::AbstractArray{<:Pair}) = 
    TupleDict(map(((k, v),) -> k => basedims(v), layers))
layermetadata(layers::AbstractArray{<:Pair}) = 
    DataDict(map(((k, v),) -> k => metadata(v), layers))

# This lets use switch array of NamedTupleto NamedTuple of Array
struct LayerArray{K,T,N,A} <: AbstractArray{T,N}
    data::A
end
function LayerArray{K}(a::A) where {A<:AbstractArray{<:NamedTuple,N}} where {K,N}
    T = typeof(a[1][K])
    LayerArray{K,T,N,A}(a)
end
Base.parent(A::LayerArray) = parent(A.data)
Base.size(A::LayerArray) = size(parent(A))
@propagate_inbounds Base.getindex(A::LayerArray{K}, I::Integer...) where K =
    getproperty(getindex(parent(A), I...), K)

function layerarrays(A::AbstractDimArray{<:NamedTuple{K}}) where K
    map(K) do k
        rebuild(A; data=LayerArray{k}(A))
    end |> NamedTuple{K}
end

"""
    AbstractDimTable <: Tables.AbstractColumns

Abstract supertype for dim tables
"""
abstract type AbstractDimTable <: Tables.AbstractColumns end

struct Columns end
struct Rows end

# Tables.jl interface for AbstractDimStack and AbstractDimArray

DimTableSources = Union{AbstractDimStack,AbstractDimArray}

Tables.istable(::Type{<:DimTableSources}) = true
Tables.columnaccess(::Type{<:DimTableSources}) = true
Tables.columns(x::DimTableSources) = DimTable(x)
Tables.columnnames(x::DimTableSources) = _colnames(x)
Tables.schema(x::DimTableSources) = Tables.schema(DimTable(x))

@inline Tables.getcolumn(x::DimTableSources, i::Int) = Tables.getcolumn(DimTable(x), i)
@inline Tables.getcolumn(x::DimTableSources, key::Symbol) =
    Tables.getcolumn(DimTable(x), key)
@inline Tables.getcolumn(x::DimTableSources, ::Type{T}, i::Int, key::Symbol) where T =
    Tables.getcolumn(DimTable(x), T, i, key)
@inline Tables.getcolumn(x::DimTableSources, key::DimOrDimType) =
    Tables.getcolumn(DimTable(x), key)

_alldims(x) = combinedims(dims(x), refdims(x))

function _colnames(s::AbstractDimStack, dims::Tuple=_alldims(s))
    dimkeys = map(name, dims)
    # The data is always the last column/s
    (dimkeys..., keys(s)...)
end
function _colnames(A::AbstractDimArray, dims::Tuple=_alldims(A))
    n = Symbol(name(A)) == Symbol("") ? :value : Symbol(name(A))
    (map(name, dims)..., n)
end
_colnames(A::AbstractDimArray{T}, dims::Tuple=_alldims(A)) where T<:NamedTuple =
    (map(name, dims)..., _colnames(T)...)
_colnames(::Type{<:NamedTuple{Keys}}) where Keys = Keys

# DimTable

"""
    DimTable <: AbstractDimTable

    DimTable(s::AbstractDimStack; mergedims=nothing[, refdims])
    DimTable(x::AbstractDimArray; layersfrom=nothing, mergedims=nothing[, refdims])
    DimTable(xs::Vararg{AbstractDimArray}; layernames=nothing, mergedims=nothing[, refdims])

Construct a Tables.jl/TableTraits.jl compatible object out of an `AbstractDimArray` or `AbstractDimStack`.

This table will have columns for the array data and columns for each
`Dimension` lookup, as a [`DimColumn`]. These are lazy, and generated
as required.

Column names are converted from the dimension types using
[`DimensionalData.name`](@ref). This means type `Ti` becomes the
column name `:Ti`, and `Dim{:custom}` becomes `:custom`.

To get dimension columns, you can index with `Dimension` (`X()`) or
`Dimension` type (`X`) as well as the regular `Int` or `Symbol`.

# Keywords
- `mergedims`: Combine two or more dimensions into a new dimension.
- `preservedims`: Preserve one or more dimensions from flattening into the table.
    `DimArray`s of views with these dimensions will be present in the layer column,
    rather than scalar values.
- `layersfrom`: Treat a dimension of an `AbstractDimArray` as layers of an `AbstractDimStack`
    by specifying a dimension to use as layers.
- `refdims`: Additional reference dimensions to add to the table, defaults to reference
    dimensions of the table source. Use `refdims=()` for none.

# Example

Here we generate a GeoInterface.jl compatible table with `:geometry`
column made of `(X, Y)` points, and data columns from `:band` slices.

```julia
julia> using DimensionalData, Tables

julia> A = ones(X(4), Y(3), Dim{:band}('a':'d'); name=:data);

julia> DimTable(A; layersfrom=:band, mergedims=(X, Y)=>:geometry)
DimTable with 12 rows, 5 columns, and schema:
 :geometry  Tuple{Int64, Int64}
 :band_a    Float64
 :band_b    Float64
 :band_c    Float64
 :band_d    Float64
```

And here bands for each X/Y position are kept as vectors, using `preservedims`.
This may be useful if e.g. bands are color components of spectral images.

```julia
julia> DimTable(A; preservedims=:band)
DimTable with 12 rows, 3 columns, and schema:
 :X     …  Int64
 :Y        Int64
 :data     DimVector{Float64, Tuple{Dim{:band, Categorical{Char, StepRange{Char, Int64}, ForwardOrdered, NoMetadata}}}, Tuple{X{NoLookup{UnitRange{Int64}}}, Y{NoLookup{UnitRange{Int64}}}}, SubArray{Float64, 1, Array{Float64, 3}, Tuple{Int64, Int64, Slice{OneTo{Int64}}}, true}, Symbol, NoMetadata} (alias for DimArray{Float64, 1, Tuple{Dim{:band, DimensionalData.Dimensions.Lookups.Categorical{Char, StepRange{Char, Int64}, DimensionalData.Dimensions.Lookups.ForwardOrdered, DimensionalData.Dimensions.Lookups.NoMetadata}}}, Tuple{X{DimensionalData.Dimensions.Lookups.NoLookup{UnitRange{Int64}}}, Y{DimensionalData.Dimensions.Lookups.NoLookup{UnitRange{Int64}}}}, SubArray{Float64, 1, Array{Float64, 3}, Tuple{Int64, Int64, Base.Slice{Base.OneTo{Int64}}}, true}, Symbol, DimensionalData.Dimensions.Lookups.NoMetadata})
```

```julia
julia> DimTable(A[X(3), Y(2)])  # slice X and Y (included as reference dimensions)
DimTable with 3 rows, 4 columns, and schema:
 :band   Int64
 :X      Int64
 :Y      Int64
 :value  Float64
```
"""
struct DimTable{Mode} <: AbstractDimTable
    parent::Union{AbstractDimArray,AbstractDimStack}
    dims::Tuple{Vararg{Dimension}}
    colnames::Vector{Symbol}
    dimcolumns::Vector{AbstractVector}
    dimarraycolumns::Vector
end
function DimTable(s::AbstractDimStack;
    mergedims=nothing,
    preservedims=nothing,
    refdims=refdims(s),
)
    s = isnothing(mergedims) ? s : DD.mergedims(s, mergedims)
    s = if isnothing(preservedims)
        s
    else
        maplayers(s) do A
            _maybe_presevedims(A, preservedims)
        end
    end
    alldims = combinedims(dims(s), refdims)
    dimcolumns = collect(_dimcolumns(alldims))
    dimarraycolumns = if hassamedims(s) && isempty(refdims)
        map(vec, layers(s))
    else
        map(A -> vec(_maybe_dimextended(A, alldims)), layers(s))
    end |> collect
    keys = collect(_colnames(s, alldims))
    return DimTable{Columns}(s, alldims, keys, dimcolumns, dimarraycolumns)
end
function DimTable(As::AbstractVector{<:AbstractDimArray};
    layernames=nothing,
    mergedims=nothing,
    preservedims=nothing,
    refdims=refdims(first(As)),
)
    # Check that dims are compatible
    comparedims(As)
    # Construct Layer Names
    layernames = isnothing(layernames) ? uniquekeys(As) : layernames
    # Construct dimension and array columns with DimExtensionArray
    As = isnothing(mergedims) ? As : map(x -> DimensionalData.mergedims(x, mergedims), As)
    As = if isnothing(preservedims)
        As
    else
        map(As) do A
            _maybe_presevedims(A, preservedims)
        end
    end
    alldims = combinedims(dims(first(As)), refdims)
    dimcolumns = collect(_dimcolumns(alldims))
    dimnames = collect(map(name, alldims))
    dimarraycolumns = collect(map(vec ∘ Base.Fix2(_maybe_dimextended, alldims), As))
    colnames = vcat(dimnames, layernames)

    # Return DimTable
    return DimTable{Columns}(first(As), alldims, colnames, dimcolumns, dimarraycolumns)
end
function DimTable(A::AbstractDimArray;
    layersfrom=nothing,
    mergedims=nothing,
    preservedims=nothing,
    refdims=refdims(A),
)
    if !isnothing(layersfrom) && any(hasdim(A, layersfrom))
        d = dims(A, layersfrom)
        nlayers = size(A, d)
        layers = [view(A, rebuild(d, i)) for i in 1:nlayers]
        layernames = if iscategorical(d)
            Symbol.((name(d),), '_', lookup(d))
        else
            Symbol.(("$(name(d))_$i" for i in 1:nlayers))
        end
        return DimTable(layers; layernames, mergedims, preservedims, refdims)
    else
        A1 = isnothing(mergedims) ? A : DD.mergedims(A, mergedims)
        if eltype(A1) <: NamedTuple
            if isnothing(preservedims)
                alldims = combinedims(dims(A1), refdims)
                dimcolumns = collect(_dimcolumns(alldims))
                colnames = collect(_colnames(A1, alldims))
                dimarrayrows = vec(_maybe_dimextended(A1, alldims))
                return DimTable{Rows}(A1, alldims, colnames, dimcolumns, dimarrayrows)
            else
                las = layerarrays(A1)
                layernames = collect(keys(las))
                return DimTable(collect(las); layernames, mergedims, preservedims, refdims)
            end
        else
            A2 = _maybe_presevedims(A1, preservedims)
            alldims = combinedims(dims(A2), refdims)
            dimcolumns = collect(_dimcolumns(alldims))
            colnames = collect(_colnames(A2, alldims))
            dimarraycolumns = [vec(_maybe_dimextended(A2, alldims))]
            return DimTable{Columns}(A2, alldims, colnames, dimcolumns, dimarraycolumns)
        end
    end
end

function _maybe_dimextended(A, dims)
    return dimsmatch(Dimensions.dims(A), dims) ? A : DimExtensionArray(A, dims)
end

_maybe_presevedims(A, preservedims::Nothing) = A
function _maybe_presevedims(A, preservedims)
    S = DimSlices(A; dims=otherdims(A, preservedims))
    rebuild(A; data=OpaqueArray(S), dims=dims(S))
end

_dimcolumns(x) = map(d -> _dimcolumn(x, d), dims(x))
function _dimcolumn(x, d::Dimension)
    lookupvals = parent(lookup(d))
    if length(dims(x)) == 1
        lookupvals
    else
        dim_as_dimarray = DimArray(lookupvals, d)
        vec(_maybe_dimextended(dim_as_dimarray, dims(x)))
    end
end

dimcolumns(t::DimTable) = getfield(t, :dimcolumns)
dimarraycolumns(t::DimTable) = getfield(t, :dimarraycolumns)
colnames(t::DimTable) = Tuple(getfield(t, :colnames))

Base.parent(t::DimTable) = getfield(t, :parent)

for func in (:dims, :val, :metadata, INTERFACE_QUERY_FUNCTION_NAMES...)
    @eval $func(t::DimTable, args...) = $func(parent(t), args...)
end

_dims(t::DimTable) = getfield(t, :dims)

Tables.istable(::DimTable) = true
Tables.columnaccess(::Type{<:DimTable}) = true
Tables.columns(t::DimTable) = t
Tables.columnnames(c::DimTable) = colnames(c)

function Tables.schema(t::DimTable)
    types = vcat([map(eltype, dimcolumns(t))...], _dimarraycolumn_eltypes(t))
    Tables.Schema(colnames(t), types)
end

_dimarraycolumn_eltypes(t::DimTable{Columns}) = [map(eltype, dimarraycolumns(t))...]
_dimarraycolumn_eltypes(t::DimTable{Rows}) = _eltypes(eltype(dimarraycolumns(t)))
_eltypes(::Type{T}) where T<:NamedTuple = collect(T.types)

@inline function Tables.getcolumn(t::DimTable{Rows}, i::Int)
    nkeys = length(colnames(t))
    if i > length(_dims(t))
        map(nt -> nt[i], dimarraycolumns(t))
    elseif i > 0 && i < nkeys
        dimcolumns(t)[i]
    else
        throw(ArgumentError("There is no table column $i"))
    end
end
@inline function Tables.getcolumn(t::DimTable{Columns}, i::Int)
    nkeys = length(colnames(t))
    if i > length(_dims(t))
        dimarraycolumns(t)[i - length(_dims(t))]
    elseif i > 0 && i < nkeys
        dimcolumns(t)[i]
    else
        throw(ArgumentError("There is no table column $i"))
    end
end
@inline function Tables.getcolumn(t::DimTable, dim::Union{Dimension,Type{<:Dimension}})
    dimcolumns(t)[dimnum(_dims(t), dim)]
end
@inline function Tables.getcolumn(t::DimTable{Rows}, key::Symbol)
    key in colnames(t) || throw(ArgumentError("There is no table column $key"))
    if hasdim(_dims(t), key)
        dimcolumns(t)[dimnum(_dims(t), key)]
    else
        # Function barrier
        _col_from_rows(dimarraycolumns(t), key)
    end
end
@inline function Tables.getcolumn(t::DimTable{Columns}, key::Symbol)
    keys = colnames(t)
    i = findfirst(==(key), keys)
    if isnothing(i)
        throw(ArgumentError("There is no table column $key"))
    else
        return Tables.getcolumn(t, i)
    end
end
@inline function Tables.getcolumn(t::DimTable, ::Type{T}, i::Int, key::Symbol) where T
    Tables.getcolumn(t, key)
end

_col_from_rows(rows, key) = map(row -> row[key], rows)

# TableTraits.jl interface
TableTraits.isiterabletable(::DimTableSources) = true
TableTraits.isiterabletable(::DimTable) = true

# IteratorInterfaceExtensions.jl interface
IteratorInterfaceExtensions.getiterator(x::DimTableSources) =
    Tables.datavaluerows(Tables.dictcolumntable(x))
IteratorInterfaceExtensions.getiterator(t::DimTable) =
    Tables.datavaluerows(Tables.dictcolumntable(t))
IteratorInterfaceExtensions.isiterable(::DimTableSources) = true
IteratorInterfaceExtensions.isiterable(::DimTable) = true

using DimensionalData, Test 
using DimensionalData.Lookups, DimensionalData.Dimensions

using DimensionalData: unsafe_set
using DimensionalData: layerdims

a = [1 2; 3 4]
dimz = (X(143.0:2.0:145.0; lookup=Sampled(order=ForwardOrdered()), metadata=Metadata(Dict(:meta => "X"))),
        Y(-38.0:2.0:-36.0; lookup=Sampled(order=ForwardOrdered()), metadata=Metadata(Dict(:meta => "Y"))))
da = DimArray(a, dimz; name=:test)
interval_da = set(da, X => Intervals(), Y => Intervals())

a2 = [1 2 3 4
      3 4 5 6
      4 5 6 7]
dimz2 = (Dim{:row}(10.0:10.0:30.0), Dim{:column}(-2:1.0:1.0))
da2 = DimArray(a2, dimz2; name=:test2)

s = DimStack(da2, DimArray(2a2, dimz2; name=:test3))
da2slice = set(da2[:,1], name=:onedim)
sslice  = DimStack(da2, DimArray(2a2, dimz2; name=:test3), da2slice)
smix = DimStack(da, da2)
ssame = DimStack(da, set(da, X=>Z))

@testset "set DimArray parent" begin
    a = fill(9, 3, 4)
    @test parent(set(da2, a)) === a
    # A differently sized array can't be set
    a_bad = [9 9; 9 9]
    @test_throws DimensionMismatch parent(set(da2, a_bad))
    @test parent(unsafe_set(da2, a_bad)) === a_bad
end

@testset "set DimStack parent" begin
    s2 = set(s, (test2=zero(a2), test3=3a2))
    s3 = unsafe_set(s, (test2=zero(a2), test3=3a2))
    @test keys(s2) == keys(s3) == (:test2, :test3)
    @test parent(s2) == parent(s3) == (test2=zero(a2), test3=3a2)
    @test_throws ArgumentError set(s, (x=a2,))
    @test_throws ArgumentError set(s, (x=a2, y=3a2))
    @test_throws DimensionMismatch set(s, (test2=a2, test3=hcat(a2, a2)))
    @testset "set subset of layers" begin
        a = ones(size(a2))
        @test parent(set(s, (; test2=a))) === (; test2=a, test3=parent(s).test3)
        @test parent(unsafe_set(s, (; test2=a))) === (; test2=a)
    end
end

@testset "set DimStack Dimension type" begin
    s1 = set(s, :row => X, :column => Z)
    @test typeof(dims(s1)) <: Tuple{<:X,<:Z}
    @test layerdims(s1) == (; test2=(X(), Z()), test3=(X(), Z()))
    @test typeof(dims(set(s, :row => X(), :column => Z()))) <: Tuple{<:X,<:Z}
    # This should throw but doesn't at the moment.
    #@test_throws ArgumentError set(smix, :row => X, :column => Z)
    s1 = set(s, :row => :row2, :column => :column2)
    @test typeof(dims(s1)) <: Tuple{<:Dim{:row2},<:Dim{:column2}}
    @test layerdims(s1) == (; test2=(Dim{:row2}(), Dim{:column2}()), test3=(Dim{:row2}(), Dim{:column2}()))
    s1 = set(ssame, :Z=>X)
    @test typeof(dims(s1)) <: Tuple{<:X,<:Y}
    
    @test typeof(dims(set(s, :column => Ti(), :row => Z))) <: Tuple{<:Z,<:Ti}
    @test typeof(dims(set(s, Dim{:row}(Y()), Dim{:column}(X())))) <: Tuple{<:Y,<:X}
    @test typeof(dims(set(s, (Dim{:row}(Y), Dim{:column}(X))))) <: Tuple{<:Y,<:X}
    @test lookup(set(s, Dim{:row}([:x, :y, :z])), :row) == [:x, :y, :z] 
    @test lookup(set(s, Dim{:row}([:x, :y, :z])), :row) isa Sampled
end

@testset "set DimArray Dimension type" begin
    @test typeof(dims(set(da, X => :a, Y => :b))) <: Tuple{<:Dim{:a},<:Dim{:b}}
    @test typeof(dims(set(da2, Dim{:row}(Y()), Dim{:column}(X())))) <: Tuple{<:Y,<:X}
    @test typeof(dims(set(da, X => Ti(), Y => Z()))) <: Tuple{<:Ti,<:Z}
    @test typeof(dims(set(da2, :column => Ti(), :row => Z()))) <: Tuple{<:Z,<:Ti}
    @test typeof(dims(set(da2, (Dim{:row}(Y), Dim{:column}(X))))) <: Tuple{<:Y,<:X}
    @test typeof(dims(set(da2, :row=>X, :column=>Z))) <: Tuple{<:X,<:Z}
    @test typeof(dims(set(da2, :row=>X(), :column=>Z()))) <: Tuple{<:X,<:Z}
    @test typeof(dims(set(da2, :row=>:row2, :column=>:column2))) <: Tuple{<:Dim{:row2},<:Dim{:column2}}
    @test lookup(set(da2, Dim{:row}([:x, :y, :z])), :row) == [:x, :y, :z] 
end

@testset "set Lookup values" begin
    dimz3 = (Dim{:row}(10.0:10.0:30.0), Dim{:column}(2.0:-1.0:-1.0))
    da3 = DimArray(a2, dimz3; name=:test2)
    @testset "Order maintained" begin
        c = [8, 4, 2, 1]
        r = 4:6
        da_set = set(da3, :column => c, :row => r)
        da_uset = unsafe_set(da3, :column => c, :row => r)
        @test parent.(lookup(da_uset)) === parent.(lookup(da_set)) === (r, c)
        @test order(da_set) == order(da_uset) == (ForwardOrdered(), ReverseOrdered())
        @test sampling(da_set) == sampling(da_uset) == (Points(), Points())
        @test span(da_set) == (Regular(1), Irregular((nothing, nothing)))
        @test span(da_uset) === (Regular(10.0), Regular(-1.0))
    end
    @testset "Order reversed" begin
        c = [1, 2, 4, 8]
        r = 6:-1:4
        da_set = set(da3, :column => c, :row => r)
        da_uset = unsafe_set(da3, :column => c, :row => r)
        @test parent.(lookup(da_uset)) === parent.(lookup(da_set)) === (r, c)
        @test sampling(da_set) == sampling(da_uset) == (Points(), Points())
        @test span(da_set) == (Regular(-1), Irregular((nothing, nothing)))
        @test span(da_uset) === (Regular(10.0), Regular(-1.0))
        @test order(da_set) == (ReverseOrdered(), ForwardOrdered())
        @test order(da_uset) == (ForwardOrdered(), ReverseOrdered())
    end
    @testset "Ordered to Unordered" begin
        c = [8, 2, 4, 1]
        r = [6, 4, 5]
        da_set = set(da3, :column => c, :row => r)
        da_uset = unsafe_set(da3, :column => c, :row => r)
        @test parent.(lookup(da_uset)) === parent.(lookup(da_set)) === (r, c)
        @test sampling(da_set) == sampling(da_uset) == (Points(), Points())
        @test span(da_set) == (Irregular((nothing, nothing)), Irregular((nothing, nothing)))
        @test span(da_uset) === (Regular(10.0), Regular(-1.0))
        @test order(da_set) == (Unordered(), Unordered())
        @test order(da_uset) == (ForwardOrdered(), ReverseOrdered())
    end
    @testset "Unordered to Ordered" begin
        # First define the unordered DimArray
        c = [8, 2, 4, 1]
        r = [6, 4, 5]
        da4 = set(da3, :column => c, :row => r)
        c = 8:-2:2
        r = 4:6
        da_set = set(da4, :column => c, :row => r)
        da_uset = unsafe_set(da4, :column => c, :row => r)
        @test parent.(lookup(da_uset)) === parent.(lookup(da_set)) === (r, c)
        @test order(da_set) == (ForwardOrdered(), ReverseOrdered())
        @test order(da_uset) == (Unordered(), Unordered())
        @test sampling(da_set) == sampling(da_uset) == (Points(), Points())
        @test span(da_set) == (Regular(1), Regular(-2))
        @test span(da_uset) == (Irregular((nothing, nothing)), Irregular((nothing, nothing)))
    end
end

@testset "Dimension index" begin
    @test lookup(set(da2, :column => [:a, :b, :c, :d], :row => 4:6)) == 
        (4:6, [:a, :b, :c, :d])
    @test lookup(set(s, :column => 10:5:20, :row => 4:6)) == (4:6, 10:5:20)
    @test step.(span(set(da2, :column => 10:5:20, :row => 4:6))) == (1, 5)
end

@testset "set Lookup" begin
    @testset "to NoLookup" begin
        @test lookup(set(dims(da2), NoLookup())) == 
            (NoLookup(Base.OneTo(3)), NoLookup(Base.OneTo(4)))
        @test lookup(set(da2, NoLookup())) == 
            (NoLookup(Base.OneTo(3)), NoLookup(Base.OneTo(4)))
    end
    @test lookup(set(da2, Categorical)) == 
        (Categorical(10.0:10.0:30.0, ForwardOrdered(), NoMetadata()), 
         Categorical(-2.0:1.0:1.0, ForwardOrdered(), NoMetadata())) 
    @test lookup(set(da2, :column => NoLookup(), :row => Sampled(sampling=Intervals(Center())))) == 
        (Sampled(10.0:10.0:30.0, ForwardOrdered(), Regular(10.0), Intervals(Center()), NoMetadata()), NoLookup(Base.OneTo(4)))
    @test lookup(set(da2, Dim{:column}(NoLookup()))) == 
        (Sampled(10.0:10.0:30.0, ForwardOrdered(), Regular(10.0), Points(), NoMetadata()), NoLookup(Base.OneTo(4)))
    cat_da2 = set(da2, Categorical)
    cat_da2_sample = set(da2, Sampled)
    @test cat_da2_sample == da2
    @test lookup(set(da2, :column => NoLookup(), :row => Sampled())) == 
        (Sampled(10.0:10.0:30.0, ForwardOrdered(), Regular(10.0), Points(), NoMetadata()), NoLookup(Base.OneTo(4)))
    cat_da = set(da, X=>NoLookup(), Y=>Categorical())
    @test lookup(cat_da) ==
        (NoLookup(Base.OneTo(2)), Categorical(-38.0:2.0:-36.0, ForwardOrdered(), NoMetadata())) 
    # cat_da = set(da, X=NoLookup(), Y=Categorical())
    # @test lookup(cat_da) == 
    #     (NoLookup(Base.OneTo(2)), Categorical(-38.0:2.0:-36.0, ForwardOrdered(), NoMetadata())) 
    cat_da_m = set(dims(cat_da, Y), X(DimensionalData.AutoValues(); metadata=Dict()))
    @test cat_da_m isa X
    @test metadata(cat_da_m) == Dict()
end
 
@testset "set Span" begin
    @test set(Regular(), AutoSpan()) == Regular()
    @test set(Regular(), Irregular()) == Irregular()
    @test set(Irregular(), Regular()) == Regular()

    @test set(Sampled(), Irregular()) == Sampled(; span=Irregular())
    @test set(Sampled(), Regular()) == Sampled(; span=Regular())
    @test set(Sampled(1:2:10), Regular()) == Sampled(1:2:10; span=Regular(2))
    @test set(Sampled([3, 6, 9, 12]), Regular()) == Sampled([3, 6, 9, 12]; span=Regular(3))

    @test span(set(da2, Irregular)) ==
        (Irregular((10.0, 30.0)), Irregular((-2.0, 1.0)))
    @test span(set(da2, Regular)) == (Regular(10.0), Regular(1.0))
    # TODO: should this error? the span step doesn't match the index step
    @test span(set(da2, :row=>Irregular(10, 12), :column=>Regular(9.9))) == 
        (Irregular(10, 12), Regular(9.9))
end

@testset "set Locus" begin
    @test locus(set(interval_da, X(End()), Y(Center()))) == (End(), Center())
    @test locus(set(interval_da, X => End(), Y => Center())) == (End(), Center())
    @test set(set(interval_da, End), Center) == interval_da
    @test set(set(interval_da, Start()), Center) == interval_da
    @test locus(set(da, Y=>Center())) == (Center(), Center())
    @test set(Points(), Intervals()) == Intervals(Center())
    @test set(Intervals(Center()), Start()) == Intervals(Start())
    @test set(Intervals(Center()), AutoLocus()) == Intervals(Center())
    @test set(Points(), Center()) == Points()
    @test_throws ArgumentError set(Points(), Start())
    @test_throws ArgumentError set(Points(), End())
end

@testset "set Sampling" begin
    @test sampling(interval_da) == (Intervals(Center()), Intervals(Center()))
    @test sampling(set(da, (X(Intervals(End())), Y(Intervals(Start()))))) == 
        (Intervals(End()), Intervals(Start())) 
    @test set(Sampled(), AutoSampling()) == Sampled()
    @test set(Sampled(), Intervals) == Sampled(; sampling=Intervals())
    @test set(Points(), AutoSampling()) == Points()
    @test set(AutoSampling(), Intervals()) == Intervals()
    @test set(AutoSampling(), AutoSampling()) == AutoSampling()
end

@testset "set Order" begin
    a = [1 2 3; 4 5 6; 7 8 9]
    dimz = (X(Sampled(100.0:10.0:120.0; metadata=Metadata(Dict(:meta => "X")))),
            Y(Categorical([:a, :b, :c]; metadata=Metadata(Dict(:meta => "Y")))))
    da_o = DimArray(a, dimz; name=:test)
    @testset "new Order is taken" begin
        @test set(ForwardOrdered(), Unordered()) == Unordered()
    end
    @testset "old Order is kep for AutoOrder" begin
        @test set(ReverseOrdered(), AutoOrder()) == ReverseOrdered()
    end
    @testset "Unordered does not affect parent" begin
        uda = set(da_o, Unordered())
        uuda = unsafe_set(da_o, Unordered())
        # Span is unchanged - it describes spacing, not ordering
        @test span(uda) == span(uuda) == (Regular(10.0), NoSpan())
        @test order(uda) == order(uuda) == (Unordered(), Unordered())
        @test parent(uda) == parent(uuda) == parent(da_o)
        @test lookup(uda) == (100.0:10.0:120.0, [:a, :b, :c])
        @test lookup(uuda) == (100.0:10.0:120.0, [:a, :b, :c])
    end
    @testset "Ordered reverses ordered parent" begin
        uda = set(da_o, Unordered())  # define uda in this scope
        rda = set(da_o, ReverseOrdered())
        urda = unsafe_set(uda, ReverseOrdered())
        @test order(rda) == (ReverseOrdered(), ReverseOrdered())
        @test lookup(rda) == (120.0:-10.0:100.0, [:c, :b, :a])
        @test lookup(urda) == (100.0:10.0:120.0, [:a, :b, :c])  # unsafe_set doesn't change lookup values
        @test parent(rda) == parent(reverse(da_o; dims=(X, Y)))
        @test parent(urda) == parent(da_o)
    end
    @testset "Ordered sorts unordered parent" begin
        da_u = set(da_o[X=[2, 3, 1], Y=[3, 1, 2]], Unordered())
        fda = set(da_u, ForwardOrdered())
        ufda = unsafe_set(da_u, ForwardOrdered())
        rda = set(da_u, ReverseOrdered())
        urda = unsafe_set(da_u, ReverseOrdered())
        @test order(fda) == order(ufda) == (ForwardOrdered(), ForwardOrdered())
        @test order(rda) == order(urda) == (ReverseOrdered(), ReverseOrdered())
        @test lookup(fda) == (100.0:10.0:120.0, [:a, :b, :c])
        @test lookup(rda) == (120.0:-10.0:100.0, [:c, :b, :a])
        @test map(parent, lookup(ufda)) == map(parent, lookup(urda)) == ([110.0, 120.0, 100.0], [:c, :a, :b])
        @test parent(fda) == parent(da_o)
        @test parent(rda) == parent(reverse(da_o; dims=(X, Y)))
        @test parent(ufda) == parent(urda) == parent(da_u)
    end
end

# issue #478
@testset "tuple dims and/or Symbol/Dim{Colon}/Colon replacement" begin
    @test set(Dim{:foo}(), :bar) === Dim{:bar}()
    @test set(Dim{:foo}(2:11), :bar) === Dim{:bar}(2:11)
    @test set(Dim{:foo}(), Dim{:bar}()) === Dim{:bar}()
    @test set(Dim{:foo}(2:11), Dim{:bar}()) === Dim{:bar}(2:11)
    @test set(Dim{:foo}(Lookups.Sampled(2:11)), Dim{:bar}(Lookups.Sampled(0:9))) ===
        set(set(Dim{:foo}(Lookups.Sampled(2:11)), :bar), Lookups.Sampled(0:9))
    @test set((Dim{:foo}(),), :foo => :bar) === (Dim{:bar}(),)
    @test set((Dim{:foo}(2:11),), :foo => :bar) === (Dim{:bar}(2:11),)
    @test set(dimz, :X => :foo, :Y => :bar) ===
        (set(dims(dimz, :X), :foo), set(dims(dimz, :Y), :bar))
end

@testset "set metadata" begin
    @test metadata(set(Sampled(), Metadata(Dict(:a=>1, :b=>2)))).val == Dict(:a=>1, :b=>2)
    dax = set(da, X => Metadata(Dict(:a=>1, :b=>2)))
    @test metadata(dims(dax), X).val == Dict(:a=>1, :b=>2)
    @test metadata(dims(dax), Y).val == Dict(:meta => "Y") 
    dax = set(da, X => Metadata(Dict(:a=>1, :b=>2)))
    @test metadata(dims(dax, X)).val == Dict(:a=>1, :b=>2)
    dax = set(da2, :row=>Metadata(Dict(:a=>1, :b=>2)))
    @test metadata(dims(dax, :row)).val == Dict(:a=>1, :b=>2)
    dax = set(da2, :column=>Dict(:a=>1, :b=>2))
    @test metadata(dims(dax, :column)) == Dict(:a=>1, :b=>2)
end

@testset "all lookup fields updated" begin
    md = Metadata(Dict(:a=>1, :b=>2))
    dax = set(da, X(20:-10:10; metadata=md))
    x = dims(dax, X)
    @test order(x) === ReverseOrdered()
    @test span(x) === Regular(-10)
    @test lookup(x) == Sampled(20:-10:10, ReverseOrdered(), Regular(-10), Points(), md)
    @test parent(lookup(x)) === 20:-10:10
    @test metadata(x).val == Dict(:a=>1, :b=>2) 
    @test lookup(x) == Sampled(20:-10:10, ReverseOrdered(), Regular(-10), Points(), md)

    # Or not with `unsafe_set`...
    da_uset = DimensionalData.unsafe_set(da, X(20:-10:10; metadata=md));
    x = dims(da_uset, X)
    @test order(x) === ForwardOrdered()
    @test span(x) === Regular(2.0)
    @test metadata(x).val == Dict(:a=>1, :b=>2) 
    @test lookup(x) == Sampled(20:-10:10, ForwardOrdered(), Regular(2.0), Points(), md)
end

@testset "reordering with set" begin
    # set changes the data, order and span
    @test parent(set(da, ForwardOrdered)) === parent(da)
    @test parent(set(da, ReverseOrdered)) == parent(reverse(da; dims=(X, Y)))
    @test span(set(da, ReverseOrdered)) === map(reverse, span(da))
    # unsafe_set does not change the data or span  
    @test parent(unsafe_set(da, ForwardOrdered)) === parent(unsafe_set(da, ReverseOrdered)) === parent(da)
    @test span(unsafe_set(da, ForwardOrdered)) === span(unsafe_set(da, ReverseOrdered)) === span(da)
    # But it changes the order
    @test order(unsafe_set(da, ForwardOrdered)) === (ForwardOrdered(), ForwardOrdered())
    @test order(unsafe_set(da, ReverseOrdered)) === (ReverseOrdered(), ReverseOrdered())
    # Setting Unordered is the same for set and unsafe_set
    @test set(da, Unordered) === unsafe_set(da, Unordered)
    @test parent(set(da, Unordered)) == parent(unsafe_set(da, Unordered)) == da
    @test order(set(da, Unordered)) == order(unsafe_set(da, Unordered)) == (Unordered(), Unordered())
end

@testset "errors with set" begin
    @test_throws ArgumentError set(dims(da, X), X(7))
    @test_throws ArgumentError set(da, notafield=Sampled())
end

# @testset "_set nothing" begin
#     @test _set(nothing, nothing) == nothing
#     @test _set(1, nothing) == 1
#     @test _set(nothing, 2) == 2
# end

@testset "set with keyword arguments" begin
    @testset "set DimArray name" begin
        da_named = set(da; name=:newname)
        @test DimensionalData.name(da_named) === :newname
        @test parent(da_named) === parent(da)
        @test dims(da_named) === dims(da)
    end
    @testset "set DimArray data via keyword" begin
        newdata = fill(99, size(da))
        da_new = set(da; data=newdata)
        @test parent(da_new) === newdata
        @test dims(da_new) === dims(da)
    end
    @testset "set DimArray multiple keywords" begin
        newdata = fill(99, size(da))
        da_new = set(da; data=newdata, name=:updated)
        @test parent(da_new) === newdata
        @test DimensionalData.name(da_new) === :updated
    end
    @testset "set DimStack name" begin
        # Stacks don't have a single name, but we can test other keywords work
        s_new = set(s; metadata=Dict(:info => "test"))
        @test metadata(s_new) == Dict(:info => "test")
    end
end

@testset "_detect_step" begin
    using DimensionalData.Lookups: _detect_step
    @testset "AbstractRange" begin
        @test _detect_step(1:10) == 1
        @test _detect_step(1:2:10) == 2
        @test _detect_step(10:-1:1) == -1
        @test _detect_step(1.0:0.5:5.0) == 0.5
    end
    @testset "Regular Vector" begin
        @test _detect_step([1, 2, 3, 4]) == 1.0
        @test _detect_step([0.0, 0.5, 1.0, 1.5]) == 0.5
        @test _detect_step([10.0, 8.0, 6.0, 4.0]) == -2.0
    end
    @testset "Irregular Vector" begin
        @test _detect_step([1, 2, 4, 8]) === nothing
        @test _detect_step([1.0, 2.0, 2.5, 3.0]) === nothing
    end
    @testset "AutoValues" begin
        @test _detect_step(Lookups.AutoValues()) === Lookups.AutoStep()
    end
end

@testset "Sampling transitions" begin
    pts_da = da  # da has Points sampling
    int_da = interval_da  # interval_da has Intervals sampling

    @testset "Points to Intervals" begin
        # Setting Intervals on Points should work
        da_int = set(pts_da, X => Intervals(Center()), Y => Intervals(Start()))
        @test sampling(da_int) == (Intervals(Center()), Intervals(Start()))
        @test order(da_int) == order(pts_da)
    end
    @testset "Intervals to Points" begin
        # Setting Points on Intervals should work
        da_pts = set(int_da, X => Points(), Y => Points())
        @test sampling(da_pts) == (Points(), Points())
        @test order(da_pts) == order(int_da)
    end
    @testset "Locus shifting with Intervals" begin
        # Start, Center, End should shift lookup values appropriately
        start_da = set(int_da, Start())
        center_da = set(start_da, Center())
        end_da = set(start_da, End())
        @test locus(start_da) == (Start(), Start())
        @test locus(center_da) == (Center(), Center())
        @test locus(end_da) == (End(), End())
        # Round-trip should give same result
        @test set(end_da, Start()) ≈ start_da
    end
end

@testset "set with Explicit span" begin
    # Create a lookup with known bounds
    sampled = Sampled(1.0:3.0, ForwardOrdered(), Regular(1.0), Intervals(Center()), NoMetadata())
    dim_explicit = set(X(sampled), Explicit())
    @test span(dim_explicit) isa Explicit
    @test sampling(dim_explicit) isa Intervals
end

@testset "Categorical order detection" begin
    cat_lookup = Categorical([:z, :a, :m], Unordered(), NoMetadata())
    # Setting ForwardOrdered should sort the categorical
    sorted = set(cat_lookup, ForwardOrdered())
    @test order(sorted) == ForwardOrdered()
    @test parent(sorted) == [:a, :m, :z]

    # Setting ReverseOrdered should reverse-sort
    rsorted = set(cat_lookup, ReverseOrdered())
    @test order(rsorted) == ReverseOrdered()
    @test parent(rsorted) == [:z, :m, :a]
end

@testset "checkaxis" begin
    using DimensionalData.Dimensions: checkaxis
    d = X(1:5)
    @test checkaxis((d,), (Base.OneTo(5),)) == true
    @test_throws DimensionMismatch checkaxis((d,), (Base.OneTo(3),))
end

@testset "AutoValues handling" begin
    # AutoValues should be preserved (no-op)
    @test set(da, Lookups.AutoValues()) === da
    @test unsafe_set(da, Lookups.AutoValues()) === da
end

@testset "set dimension then lookup in one call" begin
    # Setting both dimension type and lookup properties together
    da_both = set(da, X => Ti(Sampled(sampling=Intervals(Start()))))
    @test dims(da_both, 1) isa Ti
    @test sampling(dims(da_both, 1)) == Intervals(Start())
end

using DimensionalData, Test, Dates
using AlgebraOfGraphics
using CairoMakie
using CairoMakie: ComputePipeline
using ColorTypes
using Unitful, Unitful.DefaultSymbols
import Distributions
import DimensionalData as DD


using DimensionalData: Metadata, NoMetadata, ForwardOrdered, ReverseOrdered, Unordered,
    Sampled, Categorical, NoLookup, Transformed,
    Regular, Irregular, Explicit, Points, Intervals, Start, Center, End

@testset "1D plots" begin 
    dd_vec = DimArray((1:5).^2, Ti(1:5), name=:test)
    dd_range = DimArray(1:5, Ti(1:5), name=:test) # test for #949
    dd_vec_mis = DimArray([missing, 2, 3, 4, 5], Ti('A':'E'), name= "test")
    dd_vec_uni = DimArray(.√(1:5) .* m, Ti((1:5) .* F), name= "test")

    fig = Figure()
    @test_throws MethodError lines(fig, dd_vec) # error as in lines(fig, 1:10)
    ax, plt = lines(fig[1,1], dd_vec)
    @test_throws ErrorException lines(fig[1,1], dd_vec)
    lines!(ax, dd_vec)
    
    fig = Figure()
    @test lines(fig[1,1][1,1], dd_vec) isa Makie.AxisPlot

    f = Figure()
    ga = f[1, 1] = GridLayout()
    @test lines(ga[1, 1], dd_vec) isa Makie.AxisPlot
  
    for dd_i in (dd_vec, dd_vec_uni, dd_range)
        for obs in (Observable, identity)
            for plot_i in (plot, lines, scatter, scatterlines, linesegments, stairs, stem, waterfall)
                x = parent(lookup(to_value(dd_i), 1))
                y = collect(parent(to_value(dd_i)))
                fig, ax, plt = plot_i(obs(dd_i))
                @test all(first.(plt[1][]) .== ustrip.(x)) 
                @test all(last.(plt[1][]) .== ustrip.(y))
                @test ax.xlabel[] == "Time"
                @test ax.ylabel[] == "test"
                @test plt.label[] == "test"
            end
        end
    end

    dd_char_vec = DimArray((1:5).^2, X(Char.(70:74)), name=:test)
    dd_symbol_vec = DimArray((1:5).^2, X(Symbol.(Char.(70:74))), name=:test)
    for dd_i in (dd_char_vec, dd_symbol_vec)
        for obs in (Observable, identity)
            for plot_i in (plot, lines, scatter, scatterlines, linesegments, stairs, stem, waterfall)
                x = parent(lookup(to_value(dd_i), 1))
                y = collect(parent(to_value(dd_i)))
                fig, ax, plt = plot_i(dd_i)
                @test ax.xlabel[] == "X"
                @test ax.ylabel[] == "test"
                @test plt.label[] == "test"
                @test all(last.(plt[1][]) .== Int.(y))
                if dd_i isa DimArray{<:AbstractChar}
                    @test all(first.(plt[1][]) .== Int.(x)) 
                else
                    @test all(first.(plt[1][]) .== sum.(Int, string.(x)))
                end
            end
        end
    end

    dd_i = DimArray([missing, 2, 3, 4, 5], Ti('A':'E'), name= "test")
    for plot_i in (plot, lines, scatter, scatterlines, linesegments, stairs, stem, waterfall)
        for obs in (Observable, identity)
            x = parent(lookup(to_value(dd_i), 1))
            y = collect(parent(to_value(dd_i)))
            fig, ax, plt = plot_i(obs(dd_i))
            @test ax.xlabel[] == "Time"
            @test ax.ylabel[] == "test"
            @test plt.label[] == "test"
            @test all(first.(plt[1][]) .== Int.(x))
            @test all(last.(plt[1][]) .=== replace(y, missing => NaN)) 
        end
    end


    fig, ax, plt = lines(dd_vec_mis; axis = (;xlabel = "new_x", ylabel = "new_y", title = "new_title"), figure = (;size = (1000, 1000)), linewidth = 5)
    @test plt.linewidth[] == 5
    @test ax.xlabel[] == "new_x"
    @test ax.ylabel[] == "new_y"
    @test ax.title[] == "new_title"
    @test fig.content[2] isa Makie.Legend
    @test fig.content[1] isa Makie.Axis

    fig, ax, plt = lines(dd_vec_mis, axislegend = (;unique = false))
    @test fig.content[2] isa Makie.Legend

    fig, ax, plt = lines(dd_vec_mis, axis = (;type = LScene), axislegend = false)
    @test fig.content[1] isa Makie.LScene
    @test length(fig.content) == 1

    fig, ax, plt = plot(dd_vec_mis)
    @test plt isa Makie.Scatter
    fig = Figure()
    @test plot(fig[1,1], dd_vec_mis) isa Makie.AxisPlot
    @test_throws ErrorException plot(fig[1,1], dd_vec_mis)

    fig = Figure()
    @test plot(fig[1,1][1,1], dd_vec_mis) isa Makie.AxisPlot
    @test_throws ErrorException plot(fig[1,1][1,1], dd_vec_mis)

    fig = Figure()
    ax = Axis(fig[1,1])
    @test plot!(ax, dd_vec) isa Makie.Scatter

    dd_cat = rand(X('a':'b'), Y(1:6), name = :test)
    
    for obs in (Observable, identity)
        for plot_i in (rainclouds, violin, boxplot)
            x = parent(lookup(to_value(dd_cat), Y))
            y = collect(parent(to_value(dd_cat)))
            fig, ax, plt = plot_i(obs(dd_cat))
            @test all(plt[1][] .== repeat(97:98, outer = 6)) 
            @test all(plt[2][] .== vec(y'))
            @test ax.xlabel[] == "X"
            @test ax.ylabel[] == "test"
            @test plt.label[] == "test"

            fig, ax, plt = plot_i(obs(dd_cat), categoricaldim = Y)
            @test all(plt[1][] .== repeat(1:6, outer = 2))
        end
    end


    dd_cat = DimArray((1:6).^2, X(cat(fill('A', 3), fill('B', 3), dims = 1)), name = :test)
    for plot_i in (rainclouds, violin, boxplot)
        fig, ax, plt = plot_i(dd_cat)
        @test all(plt[1][] .== Int.(lookup(dd_cat, X)))
        @test all(plt[2][] .== Int.(parent(dd_cat)))
        @test_throws ArgumentError plot_i(dd_cat, categoricaldim = Y) 
    end


    for dd_i in (dd_vec_mis, dd_vec_uni) # These plot do not work with missing and unitful due to Makie limitations
        for plt_i in ( rainclouds, violin, boxplot)
            @test plt_i(dd_i) broken = true
        end
    end

    # Test if update plots with Observable works 
    x = Observable(X(collect(1:5)))
    y = Observable(11:15)
    label = Observable("test")
    dd_vec = lift((x, y, label) -> DimArray(y, (x,); name = label), x, y, label)
    fig, ax, plt = lines(dd_vec)
    @test all(first.(plt[1][]) .== x[])
    @test all(last.(plt[1][]) .== y[])
    @test plt.label[] == label[]

    label[] = "new_test"
    x[] = X(collect(11:15))  
    y[] = 21:25

    @test all(first.(plt[1][]) .== 11:15)
    @test all(last.(plt[1][]) .== 21:25)
    @test plt.label[] == "new_test" 
end

@testset "Series" begin
    dd_mat_cat = DimArray(rand(2, 3), (Y('a':'b'), X(1:3)); name = :test)
    dd_mat_sym = DimArray(rand(2, 3), (Y(Symbol.('a':'b')), X(1:3)); name = :test)
    dd_mat_num = DimArray(rand(2, 3), (Y(1:2), X(1:3)); name = :test)
    dd_mat_uni = DimArray(ones(2, 3) .* m, (Y((1:2) .* s), X((1:3) .*  F)); name = :test)

    fig = Figure()
    @test_throws MethodError series(fig, dd_mat_cat) # as lines(fig, 1:10)
    ax, plt = series(fig[1,1], dd_mat_cat)
    @test_throws ErrorException series(fig[1,1], dd_mat_cat)
    series!(ax, dd_mat_cat)
    
    for dd_i in (dd_mat_cat, dd_mat_num, dd_mat_sym, dd_mat_uni) 
        fig, ax, plt = series(dd_i)
        @test ax.ylabel[] == "test"
        @test ax.xlabel[] == "X"
        @test all(first.(plt[1][][1]) .== ustrip.(lookup(dd_i, X)))
        @test all(first.(plt[1][][2]) .== ustrip.(lookup(dd_i, X)))
        @test all(last.(plt[1][][1]) .== ustrip.(dd_i[1,:]))
        @test all(last.(plt[1][][2]) .== ustrip.(dd_i[2,:]))
    end

    # Check that colors are resampled if categorical size is bigger than the default colormap size
    dd_big = rand(X(10), Y(10))
    fig, ax, plt = series(rand(X(10), Y(5)))
    @test plt.color[] == Makie.resample_cmap(Makie.to_colormap(:lighttest), 7)
    fig, ax, plt = series(dd_big)
    @test plt.color[] == Makie.resample_cmap(Makie.to_colormap(:lighttest), 10)
    fig, ax, plt = series(Observable(dd_big))
    @test plt.color[] == Makie.resample_cmap(Makie.to_colormap(:lighttest), 10)
    fig, ax, plt = series(Observable(dd_big), color = Makie.wong_colors())
    @test plt.color[] == Makie.resample_cmap(Makie.wong_colors(), 10)
    fig, ax, plt = series(Observable(dd_big), color = :inferno)
    @test plt.color[] == Makie.resample_cmap(Makie.to_colormap(:inferno), 10)

    fig, ax, plt = series(dd_mat_cat; axis = (;xlabel = "new_x", ylabel = "new_y", title = "new_title"), figure = (;size = (1000, 1000)), linewidth = 5)
    @test plt.linewidth[] == 5
    @test ax.xlabel[] == "new_x"
    @test ax.ylabel[] == "new_y"
    @test ax.title[] == "new_title"
    @test fig.content[2] isa Makie.Legend
    @test fig.content[1] isa Makie.Axis

    fig, ax, plt = series(dd_mat_cat, axis = (;type = LScene), axislegend = false)
    @test fig.content[1] isa Makie.LScene
    @test length(fig.content) == 1

    fig, ax, plt = series(dd_mat_cat, axis = (;type = LScene), axislegend = (; unique = false))
    
    x = Observable(X(collect(1:5)))
    y = Observable(Y('A':'B'))
    z = Observable(rand(5, 2))
    dd_mat = lift((x,y,z) -> DimArray(z, (x, y); name = "test"), x, y, z)

    fig, ax, plt = series(dd_mat)
    @test all(first.(plt[1][][1]) .== lookup(dd_mat[], X))
    @test all(first.(plt[1][][2]) .== lookup(dd_mat[], X))
    @test all(last.(plt[1][][1]) .≈  dd_mat[][:,1])
    @test all(last.(plt[1][][2]) .== dd_mat[][:,2])

    x[] = X(collect(11:15))
    y[] = Y('C':'D')
    z[] = rand(5, 2)
    @test all(first.(plt[1][][1]) .== 11:15)    
    @test all(first.(plt[1][][2]) .== 11:15)
    @test all(last.(plt[1][][1]) .==  dd_mat[][:,1])
    @test all(last.(plt[1][][2]) .== dd_mat[][:,2])

    dd_vec = DimArray(rand(5, 2), (X(1:5), Y('A':'B')), name=:test)
    fig, ax, plt = series(dd_vec)
    @test length(plt[1][]) == 2 

    fig, ax, plt = series(dd_vec, labeldim = X)
    @test length(plt[1][]) == 5

    dd_vec = DimArray(rand(5, 2), (Y(1:5), X('A':'B')), name=:test)
    fig, ax, plt = series(dd_vec)
    @test length(plt[1][]) == 2
end

@testset "2D plots" begin
    x = 1:5
    y = 10:20
    dd_mat = DimArray( x.^1/2 .+ 0y'.^1/3, (X(x), Y(y)), name=:test)
    dd_mat_perm = DimArray( x.^1/2 .+ 0y'.^1/3, (Y(x), X(y)), name=:test)
    dd_mat_uni = DimArray( (x.^1/2 .+ 0y'.^1/3) .* F, (Y(x .* m), X(y .* s)), name=:test)
    dd_mat_char = DimArray( x.^1/2 .+ 0y'.^1/3, (Y('a':'e'), X(y)), name=:test)
    dd_mat_sym = DimArray( x.^1/2 .+ 0y'.^1/3, (Y(Symbol.('a':'e')), X(y)), name=:test)

    fig = Figure()
    @test_throws MethodError contour(fig, dd_mat) # as lines(fig, 1:10)
    ax, plt = contour(fig[1,1], dd_mat)
    contourf!(ax, dd_mat)
    @test_throws ErrorException contour(fig[1,1], dd_mat)

    fig, ax, plt = contour(dd_mat)
    for dd_i in (dd_mat, dd_mat_perm)
        for obs_i in (Observable, identity)
            for plt_i in (contour3d, surface, contour, contourf)
                fig, ax, plt = contour(obs_i(dd_i))
                @test plt[1][] == lookup(to_value(dd_i), X)
                @test plt[2][] == lookup(to_value(dd_i), Y)
                @test plt[3][] == permutedims(to_value(dd_i), (X, Y))
                @test ax.xlabel[] == "X"
                @test ax.ylabel[] == "Y"
            end
        end
    end
    
    for dd_i in (dd_mat, dd_mat_perm)
        for obs_i in (Observable, identity)
            for plt_i in (image, spy)
                fig, ax, plt = plt_i(dd_i)
                @test plt[1][] == extrema(lookup(to_value(dd_i), X))
                @test plt[2][] == extrema(lookup(to_value(dd_i), Y))
                @test plt[3][] == permutedims(to_value(dd_i), (X, Y))
                @test ax.xlabel[] == "X"
                @test ax.ylabel[] == "Y"
            end
        end
    end

    for dd_i in (dd_mat, dd_mat_perm)
        for obs_i in (Observable, identity)
            fig, ax, plt = heatmap(dd_i)
            @test plt[1][][2:end] == lookup(to_value(dd_i), X) .+ .5
            @test plt[2][][2:end] == lookup(to_value(dd_i), Y) .+ .5
            @test plt[3][] == permutedims(to_value(dd_i), (X, Y))
            @test ax.xlabel[] == "X"
            @test ax.ylabel[] == "Y"
        end
    end

    dd_mat_char = DimArray( x.^1/2 .+ 0y'.^1/3, (Y('a':'e'), X(y)), name=:test)
    fig, ax, plt = contourf(dd_mat_char)
    @test plt[1][] == lookup(dd_mat_char, X)
    @test plt[2][] == Int.(lookup(dd_mat_char, Y))
    @test ax.yticks[][2] == string.(lookup(dd_mat_char, Y))

    dd_mat_sym = DimArray( x.^1/2 .+ 0y'.^1/3, (X(Symbol.('a':'e')), Y(y)), name=:test)
    fig, ax, plt = contourf(dd_mat_sym)
    @test plt[1][] == Int.(first.(string.(lookup(dd_mat_sym, X))))
    @test plt[2][] == Int.(lookup(dd_mat_sym, Y))
    @test ax.xticks[][2] == string.(lookup(dd_mat_sym, X))

    dd_mat_uni = DimArray( (x.^1/2 .+ 0y'.^1/3) .* F, (Y(x .* m), X(y .* s)), name=:test)
    @test heatmap(dd_mat_uni)[3] isa Heatmap broken = true # Makie limitation
    @test contourf(dd_mat_uni)[3] isa Contourf broken = true # Makie limitation
    @test image(dd_mat_uni)[3] isa Contourf broken = true # Makie limitation

    # test if arguments are overwritten
    fig, ax, plt = contourf(dd_mat; axis = (;xlabel = "new_x", ylabel = "new_y", title = "new_title"), figure = (;size = (1000, 1000)), colormap = :inferno)
    @test plt.colormap[] == :inferno
    @test ax.xlabel[] == "new_x"
    @test ax.ylabel[] == "new_y"
    @test ax.title[] == "new_title"
    @test fig.content[2] isa Makie.Colorbar    
    @test fig.content[2].label[] == "test"

    fig, ax, plt = contourf(dd_mat; xdim = Y, ydim = X)
    @test plt[1][] == lookup(dd_mat, Y)
    @test plt[2][] == lookup(dd_mat, X)
    @test plt[3][] == permutedims(dd_mat, (Y, X))
    @test ax.xlabel[] == "Y"
    @test ax.ylabel[] == "X"

    fig, ax, plt = heatmap(dd_mat; colorbar = false)
    @test length(fig.content) == 1

    fig, ax, plt = heatmap(dd_mat; axis = (;type = LScene))
    @test ax isa Makie.LScene
    for plt_i in (heatmap, contourf, spy, surface)
        fig, ax, plt = plt_i(dd_mat)
        @test fig.content[2] isa Colorbar
    end

    fig, ax, plt = heatmap(dd_mat; axis = (;type = PolarAxis))
    @test ax isa Makie.PolarAxis

    @test_throws Makie.InvalidAttributeError surface(dd_mat; axis = (;xlabel = "new")) # Throws an error as normal makie would

    dd_rgb = rand(RGB, X(1:10), Y(1:5))
    fig, ax, plt = heatmap(dd_rgb)
    @test plt isa Heatmap
    fig, ax, plt = image(dd_rgb)
    @test plt isa Image
    
    x = Observable(1:5)
    y = Observable(1:6)
    z = lift((x,y) -> x.^2 .+ y', x, y)
    name_string = Observable("test")
    dd_obs = lift((x,y,z,name_string) -> DimArray(z, (X(x), Y(y)), name = name_string), x, y, z, name_string)

    fig, ax, plt = contourf(dd_obs)
    @test all(plt[1][] .== x[])
    @test all(plt[2][] .== y[])
    @test all(plt[3][] .== permutedims(dd_obs[], (X, Y)))
    @test fig.content[2].label[] == "test"

    x[] = 6:10
    y[] = 6:11
    @test all(plt[1][] .== 6:10)
    @test all(plt[2][] .== 6:11)
    @test all(plt[3][] .== permutedims(dd_obs[], (X, Y)))
    
    name_string[] = "new_test"
    @test fig.content[2].label[] == "new_test"
end

@testset "3D plots" begin
    dd_3d = DimArray(rand(5, 5, 5), (X(1:5), Y(1:5), Z(1:5)), name=:test)
    dd_3d_mis = DimArray(reshape(vcat([missing], rand(7)), 2, 2, 2), (X(1:2), Y(1:2), Z(1:2)), name=:test)
    dd_3d_uni = DimArray(rand(5, 5, 5) .* m, (X(1:5), Y(1:5), Z(1:5)), name=:test)
    dd_3d_rgb = DimArray(rand(RGB, 5, 5, 5), (X(1:5), Y(1:5), Z(1:5)), name=:test)
    dd_3d = DimArray(rand(5, 5, 5), (Z(1:5), X(1:5), Y(1:5)), name=:test)
    
    fig = Figure()
    @test_throws MethodError volume(fig, dd_3d) # as lines(fig, 1:10)
    ax, plt = volume(fig[1,1], dd_3d)
    @test_throws ErrorException volume(fig[1,1], dd_3d)
    @test volume!(ax, dd_3d) isa Makie.Volume

    fig = Figure()
    lines(fig[1,2], rand(10))
    volume(fig[1,1], dd_3d)
    fig
    
    for dd_i in (dd_3d, dd_3d_mis)
        for plt_i in (volume, plot)
            for obs_i in (identity, Observable)
                fig, ax, plt = plt_i(obs_i(dd_i))
                @test plt[1][] == extrema(lookup(to_value(dd_i), X)) 
                @test plt[2][] == extrema(lookup(to_value(dd_i), Y))
                @test plt[3][] == extrema(lookup(to_value(dd_i), Z)) 
                @test all(plt[4][] .=== Float32.(replace(parent(permutedims(to_value(dd_i), (X, Y, Z))), missing => NaN32)))
                @test ax isa Makie.LScene
                @test fig.content[2] isa Makie.Colorbar
                @test fig.content[2].label[] == "test"
            end
        end
    end

    for obs_i in (identity, Observable)
        fig, ax, plt = volumeslices(obs_i(dd_3d))
        @test plt[1][] == lookup(to_value(dd_3d), X)
        @test plt[2][] == lookup(to_value(dd_3d), Y)
        @test plt[3][] == lookup(to_value(dd_3d), Z)
        @test plt[4][] == parent(permutedims(to_value(dd_3d), (X, Y, Z)))
        @test ax isa Makie.LScene
        @test fig.content[2] isa Makie.Colorbar
        @test fig.content[2].label[] == "test"
    end

    dd_3d_char = DimArray(rand(5, 5, 5), (X('A':'E'), Y(1:5), Z(1:5)), name=:test)
    @test volume(dd_3d_char) isa Makie.FigureAxisPlot
    @test volumeslices(dd_3d_char) isa Makie.FigureAxisPlot

    # Due to limitations on Makie
    # Event the broken test is broken in Makie due to errors while throwing the error
    # @test volumeslices(dd_3d_mis) broken = true 
    @test volumeslices(dd_3d_uni) broken = true
    @test volumeslices(dd_3d_rgb) broken = true
    @test volume(dd_3d_uni) broken = true
    @test volume(dd_3d_rgb) broken = true

    fig, ax, plt = volume(dd_3d; xdim = Y, ydim = Z, zdim = X)
    @test plt[1][] == extrema(lookup(to_value(dd_3d), Y))
    @test plt[2][] == extrema(lookup(to_value(dd_3d), Z))
    @test plt[3][] == extrema(lookup(to_value(dd_3d), X))
    @test_throws ArgumentError volume(dd_3d; xdim = Y, ydim = Z, zdim = Y)

    # Test that axis attributes filter type keyword (issue #1167)
    @testset "axis attributes correctly filtered" begin
        @testset for plt_fn in (volume, volumeslices),
            (axis_type, axis_att) in (
                (LScene, (; show_axis=false)),
                (Axis3, (; title="test title"))
            )
            fig, ax, plt = plt_fn(dd_3d; axis = (; type=axis_type, axis_att...))
            @test ax isa axis_type
        end
    end

    x = Observable(1:5)
    y = Observable(11:15)
    z = Observable(21:25)
    c = Observable(rand(Int, 5, 5, 5))
    dd_3d_obs = lift((c, x, y, z) -> DimArray(c, (Y(y), Z(z), X(x)), name = "test"), c, x, y, z)

    fig, ax, plt = volumeslices(dd_3d_obs)
    @test plt[1][] == lookup(dd_3d_obs[], X)
    @test plt[2][] == lookup(dd_3d_obs[], Y)
    @test plt[3][] == lookup(dd_3d_obs[], Z)
    @test plt[4][] == parent(permutedims(dd_3d_obs[], (X, Y, Z)))

    x[] = 6:10
    y[] = 16:20
    z[] = 26:30
    c[] = rand(Int, 5, 5, 5)
    @test plt[1][] == lookup(dd_3d_obs[], X)
    @test plt[2][] == lookup(dd_3d_obs[], Y)
    @test plt[3][] == lookup(dd_3d_obs[], Z)
    @test plt[4][] == parent(permutedims(dd_3d_obs[], (X, Y, Z)))
end

# end

@testset "AlgebraOfGraphics" begin

    # 1d
    A1 = rand(X(1:5); name=:test)
    A1c = rand(X('a':'e'); name=:test)

    @testset "1d, symbol indexing" begin
        @test_nowarn data(A1) * mapping(:X, :test) * visual(CairoMakie.Lines) |> draw
        @test_nowarn data(A1c) * mapping(:X, :test) * visual(CairoMakie.Lines) |> draw
    end

    @testset "1d, dim indexing" begin
        @test_nowarn data(A1) * mapping(X, :test) * visual(CairoMakie.Lines) |> draw
        @test_nowarn data(A1c) * mapping(X, :test) * visual(CairoMakie.Lines) |> draw
    end

    @testset "1d with refdims" begin
        @test_nowarn data(rebuild(A1; refdims=(Y(['a', 'b']),))) * mapping(
            X, :test; linestyle=Y
        ) * visual(CairoMakie.Lines) |> draw
    end

    A3 = DimArray(rand(21, 5, 4), (X, Y, Dim{:p}); name = :RandomData)
    
    @testset "3d faceting" begin
        @test_nowarn data(A3) * visual(CairoMakie.Heatmap) * mapping(X, :RandomData, Dim{:p}, layout = Y => nonnumeric) |> draw
        fg = data(A3) * visual(CairoMakie.Heatmap) * mapping(X, :RandomData, Dim{:p}, layout = Y => nonnumeric) |> draw
        # Test that the number of axes is equal to the size of A3 in the y dimension.
        @test sum(x -> x isa AlgebraOfGraphics.Makie.Axis, AlgebraOfGraphics.Makie.contents(fg.figure.layout)) == size(A3, Y)
    end

    @testset "DimPoints" begin
        DimPoints(rand(X(10), Y(1.0:0.1:2.0))) |> Makie.scatter
        DimPoints(rand(X(10), Y(1.0:0.1:2.0))) |> Makie.plot
        DimPoints(rand(X(10), Y(1.0:0.1:2.0), Z(10:10:40))) |> Makie.scatter
        DimPoints(rand(X(10), Y(1.0:0.1:2.0), Z(10:10:40))) |> Makie.plot
    end
end


@testset "Makie" begin
    # 1d
    A1 = rand(X('a':'e'); name=:test)
    A1m = rand([missing, (1:3.)...], X('a':'e'); name=:test)
    A1u = rand([missing, (1:3.)...], X(1s:1s:3s); name=:test)
    A1ui = rand([missing, (1:3.)...], X(1s:1s:3s; sampling=Intervals(Start())); name=:test)
    A1num = rand(X(-10:10))
    A1v = DimArray(view(A1.data, :), DD.dims(A1))
    A1m .= A1
    A1m[3] = missing
    fig, ax, _ = plot(A1)
    plot!(ax, A1)
    fig, ax, _ = plot(A1m)
    fig, ax, _ = plot(parent(A1m))
    plot!(ax, A1m)
    fig, ax, _ = plot(A1u)
    #plot!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = plot(A1ui)
    #plot!(ax, A1ui) # Does not work due to Makie limitation related with missing
    fig, ax, _ = plot(A1v)
    plot!(ax, A1v)
    plot!(A1v)
    fig, ax, _ = plot(A1num)
    reset_limits!(ax)
    org = first(ax.finallimits.val.origin)
    wid = first(widths(ax.finallimits.val))
    # This tests for #714
    @test org <= -10
    @test org + wid >= 10
    fig, ax, _ = scatter(A1)
    scatter!(ax, A1)
    scatter!(A1)
    fig, ax, _ = scatter(A1m)
    scatter!(ax, A1m)
    scatter!(A1m)
    fig, ax, _ = scatter(A1v)
    scatter!(ax, A1v)
    scatter!(A1v)
    fig, ax, _ = lines(A1)
    lines!(ax, A1)
    lines!(A1)
    fig, ax, _ = lines(A1u)
    # lines!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = lines(A1m)
    lines!(ax, A1m)
    lines!(A1m)
    fig, ax, _ = lines(A1v)
    lines!(ax, A1v)
    lines!(A1v)
    fig, ax, _ = scatterlines(A1v)
    scatterlines!(ax, A1v)
    fig, ax, _ = scatterlines(A1)
    scatterlines!(ax, A1)
    scatterlines!(A1)
    fig, ax, _ = scatterlines(A1u)
    # scatterlines!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = scatterlines(A1m)
    scatterlines!(ax, A1m)
    scatterlines!(A1m)
    fig, ax, _ = stairs(A1)
    stairs!(ax, A1)
    stairs!(A1)
    fig, ax, _ = stairs(A1u)
    # stairs!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = stairs(A1m)
    stairs!(ax, A1m)
    stairs!(A1m)
    fig, ax, _ = stairs(A1v)
    stairs!(ax, A1v)
    fig, ax, _ = stem(A1)
    stem!(ax, A1)
    fig, ax, _ = stem(A1v)
    stem!(ax, A1v)
    fig, ax, _ = stem(A1u)
    # stem!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = stem(A1m)
    stem!(ax, A1m)
    stem!(A1m)
    fig, ax, _ = barplot(A1)
    barplot!(ax, A1)
    barplot!(A1)
    fig, ax, _ = barplot(A1v)
    barplot!(ax, A1v)
    fig, ax, _ = barplot(A1u)
    # barplot!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = barplot(A1m)
    barplot!(ax, A1m)
    barplot!(A1m)
    fig, ax, _ = waterfall(A1)
    waterfall!(ax, A1)
    fig, ax, _ = waterfall(A1v)
    waterfall!(ax, A1v)
    fig, ax, _ = waterfall(A1u)
    # waterfall!(ax, A1u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = waterfall(A1m)
    waterfall!(ax, A1m)
    waterfall!(A1m)

    # 2d
    A2 = rand(X(10:10:100), Y(['a', 'b', 'c']))
    A2r = rand(Y(10:10:100), X(['a', 'b', 'c']))
    A2m = rand([missing, (1:5)...], Y(10:10:100), X(['a', 'b', 'c']))
    A2u = rand(Y(10km:10km:100km), X(['a', 'b', 'c']))
    A2ui = rand(Y(10km:10km:100km; sampling=Intervals(Start())), X(['a', 'b', 'c']))
    A2m[3] = missing
    A2rgb = rand(RGB, X(10:10:100), Y(['a', 'b', 'c']))

    fig, ax, _ = plot(A2)
    plot!(ax, A2)
    plot!(A2)
    fig, ax, _ = plot(A2m)
    plot!(ax, A2m)
    plot!(A2m)
    # fig, ax, _ = plot(A2u) # Does not work due to Makie limitation
    # e.g. heatmap((1:10)m, (1:10)m, rand(10,10))

    # plot!(ax, A2u)
    # fig, ax, _ = plot(A2ui)
    # plot!(ax, A2ui)
    fig, ax, _ = plot(A2rgb)
    plot!(ax, A2rgb)
    plot!(A2rgb)
    fig, ax, _ = heatmap(A2)
    heatmap!(ax, A2)
    heatmap!(A2)
    fig, ax, _ = heatmap(A2m)
    heatmap!(ax, A2m)
    heatmap!(A2m)
    fig, ax, _ = heatmap(A2rgb)
    heatmap!(ax, A2rgb)
    heatmap!(A2rgb)
    fig, ax, _ = image(A2)
    image!(ax, A2)
    image!(A2)
    fig, ax, _ = image(A2m)
    image!(ax, A2m)
    image!(A2m)
    fig, ax, _ = image(A2rgb)
    image!(ax, A2rgb)
    image!(A2rgb)
    fig, ax, _ = violin(A2r)
    violin!(ax, A2r)
    violin!(A2r)
    @test_throws ComputePipeline.ResolveException{ArgumentError} violin(A2m)
    @test_throws ComputePipeline.ResolveException{ArgumentError} violin!(ax, A2m)

    fig, ax, _ = rainclouds(A2)
    rainclouds!(ax, A2)
    fig, ax, _ = rainclouds(A2u)
    rainclouds!(ax, A2u)
    @test_throws ErrorException rainclouds(A2m) # MethodError ? missing values in data not supported

    fig, ax, _ = surface(A2)
    surface!(ax, A2)
    # fig, ax, _ = surface(A2ui) # Does not work due to Makie limitation
    # surface!(ax, A2ui)

    # Broken with missing
    # fig, ax, _ = surface(A2m)
    # surface!(ax, A2m)
    # Series also puts Categories in the legend no matter where they are
    # TODO: method series! is incomplete, we need to include the colors logic, as in series. There should not be any issue if the correct amount of colours is provided.
    fig, ax, _ = series(A2)
    series!(ax, A2)
    fig, ax, _ = series(A2u)
    # series!(ax, A2u) # Does not work due to Makie limitation related with missing
    fig, ax, _ = series(A2ui)
    # series!(ax, A2u)
    fig, ax, _ = series(A2r)
    # series!(ax, A2r)
    fig, ax, _ = series(A2r; labeldim=Y)
    # series!(ax, A2r; labeldim=Y)
    fig, ax, _ = series(A2m)
    # series!(ax, A2m)
    @test_throws ArgumentError plot(A2; ydim=:c)
    # @test_throws ArgumentError plot!(ax, A2; y=:c)

    # x/y can be specified
    A2ab = DimArray(rand(6, 10), (:a, :b); name=:stuff)
    fig, ax, _ = plot(A2ab)
    plot!(ax, A2ab)
    plot!(A2ab)
    fig, ax, _ = contourf(A2ab; xdim=:a)
    contourf!(ax, A2ab, xdim=:a)
    contourf!(A2ab, xdim=:a)
    fig, ax, _ = heatmap(A2ab; ydim=:b)
    heatmap!(ax, A2ab; ydim=:b)
    heatmap!(A2ab, ydim=:b)
    fig, ax, _ = series(A2ab)
    series!(ax, A2ab)
    series!(A2ab)
    fig, ax, _ = boxplot(A2ab)
    boxplot!(ax, A2ab)
    boxplot!(A2ab)
    fig, ax, _ = violin(A2ab)
    violin!(ax, A2ab)
    violin!(A2ab)
    # fig, ax, _ = rainclouds(A2ab) # Does not work due to Makie limitation
    # rainclouds!(ax, A2ab) # Does not work due to Makie limitation
    fig, ax, _ = surface(A2ab)
    surface!(ax, A2ab)
    surface!(A2ab)
    fig, ax, _ = series(A2ab)
    series!(ax, A2ab)
    series!(A2ab)
    fig, ax, _ = series(A2ab; labeldim=:a)
    series!(ax, A2ab; labeldim=:a)
    series!(A2ab; labeldim=:a)

    fig, ax, _ = series(A2ab; labeldim=:b)
    # series!(ax, A2ab; labeldim=:b) This fails because the number of colors is not enough

    # 3d, all these work with GLMakie
    A3 = rand(X(7), Z(10), Y(5))
    A3u = rand(X((1:7)m), Z((1.0:1:10.0)m), Y((1:5)g))
    A3m = rand([missing, (1:7)...], X(7), Z(10), Y(5))
    A3m[3] = missing
    A3rgb = rand(RGB, X(7), Z(10), Y(5))
    fig, ax, _ = volume(A3)
    volume!(ax, A3)
    volume!(A3)
    fig, ax, _ = volume(A3m)
    volume!(ax, A3m)
    volume!(A3m)
    # Units are broken in Makie ?
    # fig, ax, _ = volume(A3u)
    # volume!(ax, A3u)

    fig, ax, _ = volumeslices(A3)
    volumeslices!(ax, A3)
    volumeslices!(A3)
    # Need to manually specify colorrange
    fig, ax, _ = volumeslices(A3m; colorrange=(1, 7))
    volumeslices!(ax, A3m; colorrange=(1, 7))
    volumeslices!(A3m, colorrange=(1,7))
    # Unitful volumeslices broken in Makie ?
    # fig, ax, _ = volumeslices(A3u)
    # volumeslices!(ax, A3u)

    # RGB volumeslices broken in Makie ?
    # fig, ax, _ = volumeslices(A3rgb)
    # volumeslices!(ax, A3rgb)
    # fig, ax, _ = volumeslices(A3rgb)
    # volumeslices!(ax, A3rgb)
    # x/y/z can be specified
    A3abc = DimArray(rand(10, 10, 7), (:a, :b, :c); name=:stuff)
    fig, ax, _ = volume(A3abc; xdim=:c)
    fig, ax, _ = volumeslices(A3abc; xdim=:c)
    fig, ax, _ = volumeslices(A3abc; zdim=:a)
    volumeslices!(ax, A3abc; zdim=:a)
    volumeslices!(A3abc;zdim=:a)

    #LScene support 
    f, a, p = heatmap(A2ab; axis=(; type=LScene, show_axis=false))
    @test a isa LScene
    @test isnothing(a.scene[OldAxis])

    #Colorbar support
    fig, ax, _ = plot(A2ab; colorbar=(; width=50))
    colorbars = filter(x -> x isa Colorbar, fig.content)
    @test length(colorbars) == 1
    @test colorbars[1].label[] == "stuff"
    @test colorbars[1].width[] == 50

    A2ab_unnamed = DimArray(A2ab.data, DD.dims(A2ab))
    fig, ax, _ = plot(A2ab_unnamed)
    colorbars = filter(x -> x isa Colorbar, fig.content)
    @test length(colorbars) == 1
    @test colorbars[1].label[] == ""
end

Base.show(io::IO, mime::MIME"text/plain", lookup::AutoLookup) = nothing

Base.show(io::IO, mime::MIME"text/plain", lookup::NoLookup) = print(io, "NoLookup")
Base.show(io::IO, mime::MIME"text/plain", lookup::Length1NoLookup) = print(io, "Length1NoLookup")

function Base.show(io::IO, mime::MIME"text/plain", lookup::Transformed)
    show_compact(io, mime, lookup)
    show(io, mime, lookup.f)
    print(io, " ")
    ctx = IOContext(io, :compact => true)
    show(ctx, mime, dim(lookup))
end

function Base.show(io::IO, mime::MIME"text/plain", lookup::ArrayLookup)
    show_compact(io, mime, lookup)
    if !get(io, :compact, false)
        println(io)
        ctx = IOContext(io, :compact => true)
        show(ctx, mime, lookup.matrix)
        show(ctx, mime, dim(lookup))
    end
end

function Base.show(io::IO, mime::MIME"text/plain", lookup::Lookup)
    show_compact(io, mime, lookup)
    get(io, :compact, false) && print_lookup_values(io, mime, parent(lookup))
    show_properties(io, mime, lookup)
    if !get(io, :compact, false) 
        println(io)
        printstyled(io, "wrapping: "; color=:light_black)
        Base.show(io, mime, parent(lookup))
    end
end

show_properties(io::IO, mime, lookup) = show_properties(io, lookup)
function show_properties(io::IO, lookup::AbstractSampled)
    print(io, " ")
    print_order(io, lookup)
    print(io, " ")
    print_span(io, lookup)
    print(io, " ")
    print_sampling(io, lookup)
end

function show_properties(io::IO, lookup::AbstractCategorical)
    print(io, " ")
    print_order(io, lookup)
end

function Base.show(io::IO, mime::MIME"text/plain", lookups::Tuple{Lookup,Vararg{Lookup}})
    length(lookups) > 0 || return 0
    ctx = IOContext(io, :compact=>true)
    if all(l -> l isa AbstractNoLookup, lookups)
        for l in lookups[begin:end-1]
            show(ctx, mime, l)
            print(io, ", ")
        end
        show(ctx, mime, lookups[end])
        return 0
    else # Dims get a line each
        lines = 3
        haskey(io, :inset) && print(io, "\n")
        inset = get(io, :inset, "")
        for l in lookups[begin:end-1]
            print(io, inset)
            show(ctx, mime, l)
            print(io, ",")
            lines += 2 # Often they wrap
            print(io, "\n")
        end
        print(io, inset)
        show(ctx, mime, lookups[end])
        return lines
    end
end

function show_compact(io, mime, lookup::Lookup)
    print(io, nameof(typeof(lookup)))
    print(io, "{")
    print(io, string(eltype(lookup)))
    print(io, "}")
end

print_order(io, lookup) = printstyled(io, nameof(typeof(order(lookup))); color=244)
print_span(io, lookup) = printstyled(io, nameof(typeof(span(lookup))); color=244)
print_sampling(io, lookup) = printstyled(io, typeof(sampling(lookup)); color=244)
function print_metadata(io, lookup)
    metadata(lookup) isa NoMetadata && return nothing
    print(io, nameof(typeof(metadata(lookup))))
end

function print_lookup_values(io, mime, A::AbstractRange, nchars=0)
    print(io, " ")
    printstyled(io, repr(A); color=get(io, :dimcolor, :white))
end
function print_lookup_values(io, mime, v::AbstractVector, nchars=0)
    print(io, " ")
    # Maximum 2 values
    vals = if length(v) > 2
        join((repr(v[begin]), "…", repr(v[end])), ", ")
    else
        join((repr(va) for va in v), ", ")
    end
    printstyled(io, "[", string(vals), "]"; color=get(io, :dimcolor, :white))
end

using DimensionalData, Test, Unitful
using DimensionalData.Lookups, DimensionalData.Dimensions

using .Dimensions: _format
using Base: OneTo

struct Unsortable
    val::Int
end

@testset "format Lookup" begin
   @testset "format Categorical from AutoLookup" begin
        A = [:a, :b]
        @test format(AutoLookup(A), X, OneTo(2)) === Categorical(A, ForwardOrdered(), NoMetadata())
        A = [:a, :c, :b]
        @test format(AutoLookup(A), X, OneTo(3)) === Categorical(A, Unordered(), NoMetadata())
        A = ["a", "b"]
        @test format(AutoLookup(A), X, OneTo(2)) === Categorical(A, ForwardOrdered(), NoMetadata())
        A = ['b', 'a']
        @test format(A, X, OneTo(2)) === Categorical(A, ReverseOrdered(), NoMetadata())
        A = ['b', 'a']
        @test format(AutoLookup(A; order=ReverseOrdered()), X, OneTo(2)) ==
            Categorical(A, ReverseOrdered(), NoMetadata())
        # Mixed types are Categorical Unordered
        A = ['b', 2]
        @test format(AutoLookup(A; order=ReverseOrdered()), X, OneTo(2)) ==
            Categorical(A; order=Unordered())
    end

    @testset "format Categorical order" begin
        A = [1, 2]
        @test format(Categorical(A, order=ForwardOrdered()), X, OneTo(2)) ===
            Categorical(A, ForwardOrdered(), NoMetadata())
        @test format(Categorical(A), X, OneTo(2)) ==
            Categorical(A, ForwardOrdered(), NoMetadata())
    end

    @testset "format Sampled Order, Span and Sampling from AutoLookup" begin
        @testset "format vectors" begin
            A = [1, 2, 3, 4, 5]
            @test format(A, X, OneTo(5)) ===
                Sampled(A, ForwardOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())
            A = [5, 4, 3, 2, 1]
            @test format(A, X, OneTo(5)) ===
                Sampled(A, ReverseOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())
            A = [500, 3, 7, 99, 1]
            @test format(A, X, OneTo(5)) ===
                Sampled(A, Unordered(), Irregular(nothing, nothing), Points(), NoMetadata())
        end
    end

    @testset "format Sampled" begin
        @testset "format Locus" begin
            @test format(Sampled(1:2:9; sampling=Intervals()), X, OneTo(5)) ===
                Sampled(1:2:9, ForwardOrdered(), Regular(2), Intervals(Center()), NoMetadata())
            @test format(Sampled(1:2:9; span=Regular(), sampling=Intervals()), Ti, OneTo(5)) ===
                Sampled(1:2:9, ForwardOrdered(), Regular(2), Intervals(Start()), NoMetadata())
        end
        @testset "format Regular span step" begin
            @test format(Sampled(1:2:9; span=Regular()), X, OneTo(5)) ===
                Sampled(1:2:9, ForwardOrdered(), Regular(2), Points(), NoMetadata())
            @test format(Sampled(9:-2:1; span=Regular()), X, OneTo(5)) ===
                Sampled(9:-2:1, ReverseOrdered(), Regular(-2), Points(), NoMetadata())
            A = [1, 2, 3]
            @test format(Sampled(A; span=Regular(1)), X, OneTo(3)) ===
                Sampled(A, ForwardOrdered(), Regular(1), Points(), NoMetadata())
            @test format(Sampled(A; span=Irregular()), X, OneTo(3)) ===
                Sampled(A, ForwardOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())
            @test_throws ArgumentError format(X(Sampled([1, 2, 3], span=Regular())), OneTo(3))
            @test_throws ArgumentError format(X(Sampled(1:4; span=Regular(2))), OneTo(4))
        end
        @testset "format Irregular span step" begin
            # TODO clarify this. For `Points` the bounds in
            # Irregular aren't used so `nothing` is a reasonable value.
            # for `Intervals` they are used, and will return `(nothing, nothing)`
            # from `bounds`. After slicing the `bounds` will be correct, so
            # it may be fine to leave this behaviour up to the user.
            A = [2, 4, 8]
            @test format(Sampled(A; span=Irregular()), X, OneTo(3)) ===
                Sampled(A, ForwardOrdered(), Irregular((nothing, nothing)), Points(), NoMetadata())
        end
    end

    @testset "An unsortable index is Unordered" begin
        A = [Unsortable(1), Unsortable(2)]
        @test format(A, X, OneTo(2)) ===
            Sampled(A, Unordered(), Irregular(nothing, nothing), Points(), NoMetadata())
    end

    @testset "Zero length LinRange is handled" begin
        l = LinRange(2.0, 3.0, 2)
        @test format(l, X, Base.OneTo(2)) === Sampled(l, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())
        l = LinRange(2.0, 2.0, 1)
        @test format(l, X, Base.OneTo(2)) === Sampled(l, ForwardOrdered(), Regular(0.0), Points(), NoMetadata())
    end

    @testset "Lookup conversion errors" begin
        @test_throws ArgumentError DimArray(rand(5, 4), (X(1), Y(1:4)))
        @test_throws ArgumentError DimArray(rand(5), X(1; foo=:bar))
    end

end

module DimensionalDataSparseArraysExt

using DimensionalData
using SparseArrays
using LinearAlgebra

const DD = DimensionalData

# SparseArrays copyto! methods
Base.copyto!(dst::DD.AbstractDimArray{T,2}, src::SparseArrays.CHOLMOD.Dense{T}) where T<:Union{Float64,ComplexF64} =
    (copyto!(parent(dst), src); dst)
Base.copyto!(dst::DD.AbstractDimArray{T}, src::SparseArrays.CHOLMOD.Dense{T}) where T<:Union{Float64,ComplexF64} =
    (copyto!(parent(dst), src); dst)
Base.copyto!(dst::DD.AbstractDimArray, src::SparseArrays.CHOLMOD.Dense) =
    (copyto!(parent(dst), src); dst)
Base.copyto!(dst::SparseArrays.AbstractCompressedVector, src::DD.AbstractDimArray{T, 1} where T) =
    (copyto!(dst, parent(src)); dst)
Base.copyto!(dst::DD.AbstractDimArray{T,2} where T, src::SparseArrays.AbstractSparseMatrixCSC) =
    (copyto!(parent(dst), src); dst)
Base.copyto!(
    dst::DD.AbstractDimArray{<:Any,2}, 
    dst_i::CartesianIndices{2, R} where R<:Tuple{OrdinalRange{Int64, Int64}, OrdinalRange{Int64, Int64}}, 
    src::SparseArrays.AbstractSparseMatrixCSC{<:Any}, 
    src_i::CartesianIndices{2, R} where R<:Tuple{OrdinalRange{Int64, Int64}, OrdinalRange{Int64, Int64}}
) = begin
    copyto!(parent(dst), dst_i, src, src_i)
    return dst
end

# SparseArrays copy! methods
Base.copy!(dst::SparseArrays.AbstractCompressedVector{T}, src::DD.AbstractDimArray{T, 1}) where T =
    (copy!(dst, parent(src)); dst)
Base.copy!(dst::SparseArrays.SparseVector, src::DD.AbstractDimArray{T,1}) where T =
    (copy!(dst, parent(src)); dst)

end # module

"""
    DimGroupByArray <: AbstractDimArray

`DimGroupByArray` is essentially a `DimArray` but holding
the results of a `groupby` operation.

Its dimensions are the sorted results of the grouping functions
used in `groupby`.

This wrapper allows for specialisations on later broadcast or
reducing operations, e.g. for chunk reading with DiskArrays.jl,
because we know the data originates from a single array.
"""
struct DimGroupByArray{T,N,D,R,A,Na,Me} <: AbstractRebuildableDimArrayGenerator{T,N,D,R}
    _data::A
    dims::D
    refdims::R
    name::Na
    metadata::Me
end
function DimGroupByArray(_data::A, dims::D, refdims::R, name::Na, metadata::Me) where {D,R,A,Na,Me}
    T = typeof(view(_data, firstgroupinds(dims)...))
    N = length(dims) 
    DimGroupByArray{T,N,D,R,A,Na,Me}(_data, dims, refdims, name, metadata)
end
function DimGroupByArray(data::AbstractArray, dims::Union{Tuple,NamedTuple};
    refdims=(), name=NoName(), metadata=NoMetadata()
)
    DimGroupByArray(data, format(dims, data), refdims, name, metadata)
end

name(A::DimGroupByArray) = A.name
metadata(A::DimGroupByArray) = A.metadata
refdims(A::DimGroupByArray) = A.refdims

function groupinds(A::DimGroupByArray, I::Integer...)
    # Get the group indices for each dimension
    D = groupinds(dims(A), I...) 
    # And the indices in refdims
    R = map(refdims(A)) do d
        rebuild(d, only(hiddenparent(d)))
    end
    # And combine them, dim indexing will fix the order later
    return (D..., R...)
end
function groupinds(dims::MaybeDimTuple, I::Integer...)
    map(dims, I) do d, i
        rebuild(d, hiddenparent(d)[i])
    end
end

firstgroupinds(dims::MaybeDimTuple) =
    groupinds(dims, ntuple(_ -> 1, length(dims))...)

@inline function rebuild(
    A::DimGroupByArray, data::AbstractArray, dims::Tuple, refdims::Tuple, name, metadata
)
    # Rebuild as a regular DimArray
    dimconstructor(dims)(data, dims, refdims, name, metadata)
end
@inline function rebuild(A::DimGroupByArray;
    data=parent(A), dims=dims(A), refdims=refdims(A), name=name(A), metadata=metadata(A)
)
    rebuild(A, data, dims, refdims, name, metadata) # Rebuild as a regular DimArray
end

Base.size(A::DimGroupByArray) = map(length, dims(A))

@propagate_inbounds function Base.getindex(A::DimGroupByArray, i1::Integer, i2::Integer, Is::Integer...)
    I = (i1, i2, Is...)
    return view(A._data, groupinds(A, I...)...)
end
# Dispatch to avoid linear indexing in multidimensional DimIndices
@propagate_inbounds Base.getindex(A::DimGroupByArray{<:Any,1}, i::Integer) =
    view(A._data, groupinds(A, i)...)
@propagate_inbounds Base.getindex(A::DimGroupByArray{<:Any,0}) =
    view(A._data, groupinds(A)...)

function Base.summary(io::IO, A::DimGroupByArray{T,N}) where {T<:AbstractArray{T1,N1},N} where {T1,N1}
    print_ndims(io, size(A))
    print(io, string(nameof(typeof(A)), "{$(nameof(T)){$T1,$N1},$N}"))
end

function show_after(io::IO, mime, A::DimGroupByArray)
    displayheight, displaywidth = displaysize(io)
    blockwidth = get(io, :blockwidth, 0)
    separatorwidth = min(displaywidth - 2, textwidth(sprint(summary, A)) + 2)
    if length(A) > 0 && isdefined(parent(A), 1)
        x = A[1]
        sorteddims = (dims(A)..., otherdims(x, dims(A))...)
        colordims = dims(map(rebuild, sorteddims, ntuple(dimcolor, Val(length(sorteddims)))), dims(x))
        colors = collect(map(val, colordims))
        lines, new_blockwidth, _ = print_dims_block(io, mime, basedims(x);
            displaywidth, blockwidth, separatorwidth, label="group dims", colors
        )
        A1 = map(x -> DimSummariser(x, colors), A)
        ctx = IOContext(io,
            :blockwidth => blockwidth,
            :displaysize => (displayheight - lines, displaywidth)
        )
        show_after(ctx, mime, A1)
    else
        A1 = map(eachindex(A)) do i
            isdefined(parent(A), i) ? DimSummariser(A[i], colors) : Base.undef_ref_str 
        end
        ctx = IOContext(io, :blockwidth => blockwidth)
        show_after(ctx, mime, parent(A))
    end
    return nothing
end

mutable struct DimSummariser{T}
    obj::T
    colors::Vector{Int}
end
function Base.show(io::IO, s::DimSummariser)
    print_ndims(io, size(s.obj); colors=s.colors)
    print(io, string(nameof(typeof(s.obj))))
end
Base.alignment(io::IO, s::DimSummariser) = (textwidth(sprint(show, s)), 0)


abstract type AbstractBins <: Function end

(bins::AbstractBins)(x) = bins.f(x)

"""
    Bins(f, bins; labels, pad)
    Bins(bins; labels, pad)

Specify bins to reduce groups after applying function `f`.

- `f`: a grouping function of the lookup values, by default `identity`.
- `bins`:
   * an `Integer` will divide the group values into equally spaced sections.
   * an `AbstractArray` of values will be treated as exact
       matches for the return value of `f`. For example, `1:3` will create 3 bins - 1, 2, 3.
   * an `AbstractArray` of `IntervalSets.Interval` can be used to
       explicitly define the intervals. Overlapping intervals have undefined behaviour.

## Keywords

- `pad`: fraction of the total interval to pad at each end when `Bins` contains an
   `Integer`. This avoids losing the edge values. Note this is a messy solution -
   it will often be prefereble to manually specify a `Vector` of chosen `Interval`s
   rather than relying on passing an `Integer` and `pad`.
- `labels`: a list of descriptive labels for the bins. The labels need to have the same length as `bins`.

When the return value of `f` is a tuple, binning is applied to the _last_ value of the tuples.
"""
struct Bins{F<:Callable,B<:Union{Integer,AbstractVector,Tuple},L,P} <: AbstractBins
    f::F
    bins::B
    labels::L
    pad::P
end
Bins(bins; labels=nothing, pad=0.001) = Bins(identity, bins, labels, pad)
Bins(f, bins; labels=nothing, pad=0.001) = Bins(f, bins, labels, pad)

Base.show(io::IO, bins::Bins) =
    println(io, nameof(typeof(bins)), "(", bins.f, ", ", bins.bins, ")")

abstract type AbstractCyclicBins end

"""
    CyclicBins(f; cycle, start, step, labels)

Cyclic bins to reduce groups after applying function `f`. Groups can wrap around
the cycle. This is used for grouping in [`seasons`](@ref), [`months`](@ref)
and [`hours`](@ref) but can also be used for custom cycles.

- `f`: a grouping function of the lookup values, by default `identity`.

## Keywords

- `cycle`: the length of the cycle, in return values of `f`.
- `start`: the start of the cycle: a return value of `f`.
- `step` the number of sequential values to group.
- `labels`: either a vector of labels matching the number of groups, 
    or a function that generates labels from `Vector{Int}` of the selected bins.

When the return value of `f` is a tuple, binning is applied to the _last_ value of the tuples.
"""
struct CyclicBins{F,C,Sta,Ste,L} <: AbstractBins
    f::F
    cycle::C
    start::Sta
    step::Ste
    labels::L
end
CyclicBins(f; cycle, step, start=1, labels=nothing) = CyclicBins(f, cycle, start, step, labels)
CyclicBins(; kw...) = CyclicBins(identity; kw...)

Base.show(io::IO, bins::CyclicBins) =
    println(io, nameof(typeof(bins)), "(", bins.f, "; ", join(map(k -> "$k=$(getproperty(bins, k))", (:cycle, :step, :start)), ", "), ")")

yearhour(x) = year(x), hour(x)

"""
    seasons(; [start=Dates.December, labels])

Generates `CyclicBins` for three month periods.

## Keywords

- `start`: By default seasons start in December, but any integer `1:12` can be used.
- `labels`: either a vector of four labels, or a function that generates labels from `Vector{Int}` of the selected quarters.
"""
seasons(; start=December, kw...) = months(3; start, kw...)

"""
    months(step; [start=Dates.January, labels])

Generates `CyclicBins` for grouping to arbitrary month periods. 
These can wrap around the end of a year.

- `step` the number of months to group.

## Keywords

- `start`: By default months start in January, but any integer `1:12` can be used.
- `labels`: either a vector of labels matching the number of groups, 
    or a function that generates labels from `Vector{Int}` of the selected months.
"""
months(step; start=January, labels=Dict(1:12 .=> monthabbr.(1:12))) = CyclicBins(month; cycle=12, step, start, labels)

"""
    hours(step; [start=0, labels])

Generates `CyclicBins` for grouping to arbitrary hour periods. 
These can wrap around the end of the day.

- `steps` the number of hours to group.

## Keywords

- `start`: By default seasons start at `0`, but any integer `1:24` can be used.
- `labels`: either a vector of four labels, or a function that generates labels
    from `Vector{Int}` of the selected hours of the day.
"""
hours(step; start=0, labels=nothing) = CyclicBins(hour; cycle=24, step, start, labels)

"""
    groupby(A::Union{AbstractDimArray,AbstractDimStack}, dims::Pair...; name=:groupby)
    groupby(A::Union{AbstractDimArray,AbstractDimStack}, dims::Dimension{<:Callable}...; name=:groupby)

Group `A` by grouping functions or [`Bins`](@ref) over multiple dimensions.

## Arguments

- `A`: any `AbstractDimArray` or `AbstractDimStack`.
- `dims`: `Pair`s such as `groups = groupby(A, :dimname => groupingfunction)` or wrapped
  [`Dimension`](@ref)s like `groups = groupby(A, DimType(groupingfunction))`. Instead of
  a grouping function [`Bins`](@ref) can be used to specify group bins.

## Keywords

- `name`: name that is applied to the resulting [`DimGroupByArray`](@ref)

## Return value

A [`DimGroupByArray`](@ref) is returned, which is basically a regular `AbstractDimArray`
but holding the grouped `AbstractDimArray` or `AbstractDimStack`. Its `dims`
hold the sorted values returned by the grouping function/s.

Base julia and package methods work on `DimGroupByArray` as for any other
`AbstractArray` of `AbstractArray`.

It is common to broadcast or `map` a reducing function over groups,
such as `mean` or `sum`, like `mean.(groups)` or `map(mean, groups)`.
This will return a regular `DimArray`, or `DimGroupByArray` if `dims`
keyword is used in the reducing function or it otherwise returns an
`AbstractDimArray` or `AbstractDimStack`.

# Example

Group some data along the time dimension:

```jldoctest groupby; setup = :(using Random; Random.seed!(123))
julia> using DimensionalData, Dates

julia> A = rand(X(1:0.1:20), Y(1:20), Ti(DateTime(2000):Day(3):DateTime(2003)));

julia> groups = groupby(A, Ti => month) # Group by month
┌ 12-element DimGroupByArray{DimArray{Float64,3},1} ┐
├───────────────────────────────────────────────────┴──────── dims ┐
  ↓ Ti Sampled{Int64} [1, …, 12] ForwardOrdered Irregular Points
├──────────────────────────────────────────────────────── metadata ┤
  Dict{Symbol, Any} with 1 entry:
  :groupby => :Ti=>month
├───────────────────────────────────────────────────┴── group dims ┐
  ↓ X, → Y, ↗ Ti
└──────────────────────────────────────────────────────────────────┘
  1  191×20×32 DimArray
  2  191×20×28 DimArray
  ⋮
 12  191×20×31 DimArray
```

And take the mean:

```jldoctest groupby; setup = :(using Statistics)
julia> groupmeans = mean.(groups) # Take the monthly mean
┌ 12-element DimArray{Float64, 1} ┐
├─────────────────────────────────┴────────────────────────── dims ┐
  ↓ Ti Sampled{Int64} [1, …, 12] ForwardOrdered Irregular Points
└──────────────────────────────────────────────────────────────────┘
  1  0.500064
  2  0.499762
  3  0.500083
  4  0.499985
  5  0.500511
  ⋮
  8  0.500257
  9  0.500868
 10  0.500874
 11  0.498704
 12  0.50047
```

Calculate daily anomalies from the monthly mean. Notice we map a broadcast
`.-` rather than `-`. This is because the size of the arrays to not
match after application of `mean`.

```jldoctest groupby
julia> map(.-, groupby(A, Ti=>month), mean.(groupby(A, Ti=>month), dims=Ti));
```

Or do something else with Y:

```jldoctest groupby
julia> groupmeans = mean.(groupby(A, Ti=>month, Y=>isodd))
┌ 12×2 DimArray{Float64, 2} ┐
├───────────────────────────┴──────────────────────────────── dims ┐
  ↓ Ti Sampled{Int64} [1, …, 12] ForwardOrdered Irregular Points,
  → Y Sampled{Bool} [false, true] ForwardOrdered Irregular Points
└──────────────────────────────────────────────────────────────────┘
  ↓ →  false         true
  1        0.499594     0.500533
  2        0.498145     0.501379
  3        0.499871     0.500296
  4        0.500921     0.49905
  ⋮
  9        0.500715     0.501021
 10        0.501105     0.500644
 11        0.498606     0.498801
 12        0.501643     0.499298
```
"""
DataAPI.groupby(A::DimArrayOrStack, x; name=:groupby) = groupby(A, dims(x); name)
DataAPI.groupby(A::DimArrayOrStack, dimfuncs::Dimension...; name=:groupby) = groupby(A, dimfuncs; name)
function DataAPI.groupby(
    A::DimArrayOrStack, p1::Pair{<:Any,<:Base.Callable}, ps::Pair{<:Any,<:Base.Callable}...;
    name=:groupby
)
    dims = map((p1, ps...)) do (d, v)
        rebuild(basedims(d), v)
    end
    return groupby(A, dims; name)
end
function DataAPI.groupby(A::DimArrayOrStack, dimfuncs::DimTuple; name=:groupby)
    length(otherdims(dimfuncs, dims(A))) > 0 &&
        Dimensions._extradimserror(otherdims(dimfuncs, dims(A)))

    # Get groups for each dimension
    group_dims = map(dimfuncs) do d
        _group_indices(dims(A, d), DD.val(d))
    end
    # Put the groupby query in metadata
    meta = map(d -> DD.name(d) => val(d), dimfuncs)
    metadata = Dict{Symbol,Any}(:groupby => length(meta) == 1 ? only(meta) : meta)
    # Return a DimGroupByArray
    return DimGroupByArray(A, map(format, group_dims), (), name, metadata)
end

# An array that holds another secret array that is indexed along with it.
# We use this to put groupings inside lookups so they are handled by `slicedims`
struct HiddenVector{T,A<:AbstractArray{T,1},H<:AbstractArray{<:Any,1}} <: AbstractArray{T,1}
    data::A
    hidden::H
end

Base.getindex(A::HiddenVector, i::Int) = getindex(A.data, i)
Base.view(A::HiddenVector, i::Int) = 
    HiddenVector(view(A.data, i...), view(A.hidden, i))
for f in (:view, :getindex)
    @eval Base.$f(A::HiddenVector, i::Union{Colon,AbstractArray}) =
        HiddenVector(Base.$f(A.data, i), Base.$f(A.hidden, i))
end
Base.parent(A::HiddenVector) = A.hidden
Base.size(A::HiddenVector) = size(A.data)

hiddenparent(A::HiddenVector) = A.hidden
hiddenparent(A::Dimension) = hiddenparent(parent(A))
hiddenparent(A::AbstractArray) = hiddenparent(parent(A))
hiddenparent(A::Array) = error("HiddenVector not found")

# Define the groups and find all the indices for values that fall in them
function _group_indices(dim::Dimension, f::Base.Callable; labels=nothing)
    orig_lookup = lookup(dim)
    k1 = f(first(orig_lookup))
    # TODO: using a Dict here is a bit slow
    indices_dict = Dict{typeof(k1),Vector{Int}}()
    for (i, x) in enumerate(orig_lookup)
         k = f(x)
         inds = get!(() -> Int[], indices_dict, k)
         push!(inds, i)
    end
    ps = sort!(collect(pairs(indices_dict)))
    lookupvals = _maybe_label(labels, first.(ps))
    indices = last.(ps)
    # We combine lookup values and indices into on array
    lookup_and_indices = HiddenVector(lookupvals, indices)
    # And wrap and format them as a dimension
    return format(rebuild(dim, lookup_and_indices))
end
function _group_indices(dim::Dimension, group_lookup::Lookup; labels=nothing)
    orig_lookup = lookup(dim)
    indices = map(_ -> Int[], 1:length(group_lookup))
    for (i, v) in enumerate(orig_lookup)
        n = selectindices(group_lookup, Contains(v); err=Lookups._False())
        isnothing(n) || push!(indices[n], i)
    end
    lookupvals = if isnothing(labels)
        group_lookup
    else
        _maybe_label(labels, group_lookup)
    end
    # We combine lookup values and indices into on array
    lookup_and_indices = HiddenVector(lookupvals, indices)
    # And wrap and format them as a dimension
    return format(rebuild(dim, lookup_and_indices))
end
function _group_indices(dim::Dimension, bins::AbstractBins; labels=bins.labels)
    l = lookup(dim)
    # Apply the function first unless its `identity`
    transformed = bins.f == identity ? parent(l) : map(bins.f, parent(l))
    # Calculate the bin groups
    groups = if eltype(transformed) <: Tuple
        # Get all values of the tuples but the last one and take the union
        outer_groups = union!(map(t -> t[1:end-1], transformed))
        inner_groups = _groups_from(transformed, bins)
        # Combine the groups
        mapreduce(vcat, outer_groups) do og
            map(ig -> (og..., ig), inner_groups)
        end
    else
        _groups_from(transformed, bins)
    end
    group_lookup = lookup(format(rebuild(dim, groups)))
    transformed_lookup = rebuild(dim, transformed)

    # Call the Lookup version to do the work using selectors
    return _group_indices(transformed_lookup, group_lookup; labels)
end

# Get a vector of intervals for the bins
_groups_from(_, bins::Bins{<:Any,<:AbstractArray}) = bins.bins
function _groups_from(transformed, bins::Bins{<:Any,<:Integer})
    # With an Integer, we calculate evenly-spaced bins from the extreme values
    a, b = extrema(last, transformed)
    # pad a tiny bit so the top open interval includes the top value (xarray also does this)
    b_p = b + (b - a) * bins.pad
    # Create a range
    rng = range(IntervalSets.Interval{:closed,:open}(a, b_p), bins.bins)
    # Return a Vector of Interval{:closed,:open} for the range
    return IntervalSets.Interval{:closed,:open}.(rng, rng .+ step(rng))
end
function _groups_from(_, bins::CyclicBins)
    map(bins.start:bins.step:bins.start+bins.cycle-1) do g
        map(0:bins.step-1) do n
            rem(n + g - 1, bins.cycle) + 1
        end
    end
end

_maybe_label(vals) = vals
_maybe_label(f::Function, vals) = f.(vals)
_maybe_label(::Nothing, vals) = vals
function _maybe_label(labels::AbstractArray, vals)
    @assert length(labels) == length(vals)
    return labels
end
function _maybe_label(labels::Dict, vals)
    map(vals) do val
        if haskey(labels, val)
            labels[val]
        else
            Symbol(join(map(v -> string(labels[v]), val), '_'))
        end
    end
end

"""
    intervals(A::AbstractRange)

Generate a `Vector` of `UnitRange` with length `step(A)`
"""
intervals(rng::AbstractRange) =
    IntervalSets.Interval{:closed,:open}.(rng, rng .+ step(rng))

"""
    ranges(A::AbstractRange{<:Integer})

Generate a `Vector` of `UnitRange` with length `step(A)`
"""
ranges(rng::AbstractRange{<:Integer}) = map(x -> x:x+step(rng)-1, rng)

"""
    combine(f::Function, gb::DimGroupByArray; dims=:)

Combine the `DimGroupByArray` using function `f` over the group dimensions.
Unlike broadcasting a reducing function over a `DimGroupByArray`, this function
always returns a new flattened `AbstractDimArray` even where not all dimensions 
are reduced. It will also work over grouped `AbstractDimStack`.

If `dims` is given, it will combine only the dimensions in `dims`, the 
others will be present in the final array. Note that all grouped dimensions
must be reduced and included in `dims`.

The reducing function `f` must also accept a `dims` keyword.

# Example

```jldoctest groupby
````
"""
function combine(f::Function, gb::DimGroupByArray{G}; dims=:) where G
    targetdims = DD.commondims(first(gb), dims)
    all(hasdim(first(gb), targetdims)) || throw(ArgumentError("dims must be a subset of the groupby dimensions"))
    all(hasdim(targetdims, DD.dims(gb))) || throw(ArgumentError("grouped dimensions $(DD.basedims(gb)) must be included in dims"))
    # This works for both arrays and stacks
    # Combine the remaining dimensions after reduction and the group dimensions
    destdims = (otherdims(DD.dims(first(gb)), dims)..., DD.dims(gb)...)
    # Get the output eltype 
    T = Base.promote_op(f, G)
    # Create a output array with the combined dimensions
    dest = similar(first(gb), T, destdims)
    for D in DimIndices(gb)
        if all(hasdim(targetdims, DD.dims(first(gb))))
            # Assigned reduced scalar to dest
            dest[D...] = f(gb[D])
        else
            # Reduce with `f` and drop length 1 dimensions
            xs = dropdims(f(gb[D]; dims); dims)
            # Broadcast the reduced array to dest
            broadcast_dims!(identity, view(dest, D...), xs)
        end
    end
    return dest
end

using DimensionalData, FFTW, Test, LinearAlgebra, Unitful


@testset "FFT freqs" begin
    ext = Base.get_extension(DimensionalData, :DimensionalDataAbstractFFTsExt)

    # Test with even length
    x = dims(rand(X(-5:4)), 1)
    fx = ext._fftfreq(x)
    @test ext._ifftfreq(fx) == X(0:9)
    
    # Test with odd length
    x = dims(rand(X(-5:5)), 1)
    fx = ext._fftfreq(x)
    @test ext._ifftfreq(fx) == X(0:10)
    
    x = dims(rand(X(-5:5)), 1)
    fx = ext._rfftfreq(x)
    @test ext._irfftfreq(fx, length(x)) == X(0:10)
    
    x = dims(rand(X(-5:4)), 1)
    fx = ext._rfftfreq(x)
    @test ext._irfftfreq(fx, length(x)) == X(0:9)
end


@testset "1D FFT" begin
    gauss(x, a, x0) = exp(-a * (x - x0)^2)
    fourier_gauss(k, a, x0) = √(π / a) * exp(-π^2 * k^2 / a - 2π * im * x0 * k) # Fourier transform of a Gaussian
    
    unit_x = u"m"
    unit_y = u"g"
    unit = unit_x * unit_y
    
    x = range(-1, 10, length = 1000) .* unit_x
    y = gauss.(X(x), 5 / unit_x^2, 5 .* unit_x) .* unit_y
    
    fft_y = fft(y)
    ref_values = fourier_gauss.(dims(fft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y
    
    @test all(isapprox.(fft_y, fourier_gauss.(dims(fft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit))
    shift_fft_y = fftshift(fft_y)
    @test all(isapprox.(shift_fft_y, fourier_gauss.(dims(shift_fft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit))
    shift_shift_fft_y = fftshift(shift_fft_y)
    @test all(isapprox.(shift_shift_fft_y, fft_y, atol = 1E-9 * unit))
    
    ifft_y = ifft(fft_y)
    @test all(isapprox.(ifft_y, gauss.(lookup(ifft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit_y))
    @test all(isapprox.(lookup(ifft(fft_y), 1) |> parent |> step, step(x), atol = 1E-9 * unit_x))
    
    # Double test to ensure that the plan uses correctly the temporary arrays used to avoid allocations
    p = plan_fft(y)
    @test all(isapprox.(mul!(fft_y, p, complex.(y)), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(fft_y, p, complex.(y)), ref_values, atol = 1E-9 * unit))
    pinv = plan_ifft(fft_y)
    @test all(isapprox.(mul!(ifft_y, pinv, fft_y), gauss.(lookup(ifft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit_y))
    @test all(isapprox.(mul!(ifft_y, pinv, fft_y), gauss.(lookup(ifft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit_y))
    
    
    fft_y = rfft(y)
    ref_values = fourier_gauss.(dims(fft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y
    
    @test all(isapprox.(fft_y, fourier_gauss.(dims(fft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit))
    
    ifft_y = irfft(fft_y, length(y))
    @test all(isapprox.(ifft_y, gauss.(lookup(ifft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y, atol = 1E-9 * unit_y))
    @test all(isapprox.(lookup(ifft_y, 1) |> parent |> step, step(x), atol = 1E-9 * unit_x))
    
    # Double test to ensure that the plan uses correctly the temporary arrays used to avoid allocations
    p = plan_rfft(y)
    @test all(isapprox.(mul!(fft_y, p, y), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(fft_y, p, y), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(rand(typeof((1.0 .+ im)*u"kg*m"), dims(fft_y, X)), p, y), ref_values, atol = 1E-9 * unit)) # Check output with different unit works correctly

    @test_throws Unitful.DimensionError mul!(rand(typeof((1.0 .+ im)u"V"), dims(fft_y, X)), p, y)
    @test_throws ArgumentError mul!(rand(typeof(fft_y[1]), X(x)), p, y)


    pinv = plan_irfft(fft_y, length(y))
    ifft_refvalues = gauss.(lookup(ifft_y, 1), 5 / unit_x^2, 5 * unit_x) * unit_y
    @test all(isapprox.(mul!(ifft_y, pinv, fft_y), ifft_refvalues, atol = 1E-9 * unit_y))
    @test all(isapprox.(mul!(ifft_y, pinv, fft_y), ifft_refvalues, atol = 1E-9 * unit_y))
    @test all(isapprox.(mul!(rand(typeof((1.0)*u"kg"), dims(ifft_y, X)), pinv, fft_y), ifft_refvalues, atol = 1E-9 * unit_y)) # Check output with different unit works correctly
    @test_throws Unitful.DimensionError mul!(rand(typeof((1.0)*u"V"), dims(ifft_y, X)), pinv, fft_y)
    @test_throws ArgumentError mul!(rand(typeof(ifft_y[1]), X(x)), pinv, fft_y)
end


@testset "2D FFT" begin

    gauss(x, y, σx, σy, x0, y0) = exp(-((x - x0)^2 / (2σx^2) + (y - y0)^2 / (2σy^2)))

    fourier_gauss(kx, ky, σx, σy, x0, y0) = 2π * σx * σy * exp(-2π^2 * (σx^2 * kx^2 + σy^2 * ky^2)) * exp(-2π * im * (x0 * kx + y0 * ky))


    unit_x = u"m"
    unit_y = u"g"
    unit_z = u"F"
    unit = unit_x * unit_y * unit_z
    
    x0 = 3 * unit_x
    y0 = 5.5 * unit_y
    wx = 0.5 * unit_x
    wy = 0.25 * unit_y
    x = range(0, 10, length = 1000) .* unit_x
    y = range(0, 10, length = 2000) .* unit_y
    z = @d gauss.(X(x), Y(y), wx, wy, x0, y0) .* unit_z
    
    fft_z = fft(z)
    ref_values = @d fourier_gauss.(dims(fft_z, X), dims(fft_z, Y), wx, wy, x0, y0) .* unit_z
    
    @test all(isapprox.(fft_z, ref_values, atol = 1E-9 * unit))
    shift_fft_z = fftshift(fft_z)
    @test all(isapprox.(shift_fft_z, (@d fourier_gauss.(dims(shift_fft_z, X), dims(shift_fft_z, Y), wx, wy, x0, y0)) * unit_z, atol = 1E-9 * unit))
    shift_shift_fft_z = fftshift(shift_fft_z)
    @test all(isapprox.(shift_shift_fft_z, fft_z, atol = 1E-5 * unit))

    ifft_z = ifft(fft_z)
    @test all(isapprox.(ifft_z, (@d gauss.(dims(ifft_z, X), dims(ifft_z, Y), wx, wy, x0, y0)) * unit_z, atol = 1E-9 * unit_z))
    @test all(isapprox.(lookup(ifft_z, X) |> parent |> step, step(x), atol = 1E-9 * unit_x))
    @test all(isapprox.(lookup(ifft_z, Y) |> parent |> step, step(y), atol = 1E-9 * unit_y))

    p = plan_fft(z)
    @test all(isapprox.(mul!(fft_z, p, complex.(z)), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(fft_z, p, complex.(z)), ref_values, atol = 1E-9 * unit))
    pinv = plan_ifft(fft_z)

    ifft_refvalues = (@d gauss.(dims(ifft_z, X), dims(ifft_z, Y), wx, wy, x0, y0)) * unit_z
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))

    fft_z = rfft(z)
    ref_values = @d fourier_gauss.(dims(fft_z, X), dims(fft_z, Y), wx, wy, x0, y0) .* unit_z
    
    @test all(isapprox.(fft_z, ref_values, atol = 1E-9 * unit))
    
    ifft_z = irfft(fft_z, size(z, X))
    ifft_refvalues = @d gauss.(dims(ifft_z, X), dims(ifft_z, Y), wx, wy, x0, y0) .* unit_z
    @test all(isapprox.(ifft_z, ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(lookup(ifft_z, X) |> parent |> step, step(x), atol = 1E-9 * unit_x))
    @test all(isapprox.(lookup(ifft_z, Y) |> parent |> step, step(y), atol = 1E-9 * unit_y))
    
    # Double test to ensure that the plan uses correctly the temporary arrays used to avoid allocations
    p = plan_rfft(z)
    @test all(isapprox.(mul!(fft_z, p, z), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(fft_z, p, z), ref_values, atol = 1E-9 * unit))
    pinv = plan_irfft(fft_z, size(z, X))
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))
end

@testset "Single dimension on multidimensional array" begin
    gauss(x, a, x0) = exp(-a * (x - x0)^2)
    fourier_gauss(k, a, x0) = √(π / a) * exp(-π^2 * k^2 / a - 2π * im * x0 * k) # Fourier transform of a Gaussian
    
    unit_x = u"m"
    unit_z = u"g"
    unit = unit_x * unit_z
    
    x = range(-1, 10, length = 1000) .* unit_x
    y = range(4, 7, length = 5) .* unit_x
    z = @d gauss.(X(x), 5 / unit_x^2, Y(y)) .* unit_z
    
    fft_z = fft(z, X)
    @test fft_z == fft(z, 1)
    ref_values = @d fourier_gauss.(dims(fft_z, X), 5 / unit_x^2, Y(y)) .* unit_z

    @test all(isapprox.(fft_z, ref_values, atol = 1E-9 * unit))
    shift_fft_z = fftshift(fft_z, X)
    @test all(isapprox.(shift_fft_z, (@d fourier_gauss.(dims(shift_fft_z, X), 5 / unit_x^2, Y(y))) .* unit_z, atol = 1E-9 * unit))
    shift_shift_fft_z = fftshift(shift_fft_z, X)
    @test all(isapprox.(shift_shift_fft_z, fft_z, atol = 1E-9 * unit))

    ifft_z = ifft(fft_z, X)
    @test ifft_z == ifft(fft_z, 1)
    ifft_refvalues = @d gauss.(dims(ifft_z, X), 5 / unit_x^2, Y(y)) .* unit_z
    @test all(isapprox.(ifft_z, ifft_refvalues, atol = 1E-9 * unit_z))

    @test all(isapprox.(lookup(ifft_z, X) |> parent |> step, step(x), atol = 1E-9 * unit_x))
    @test all(isapprox.(lookup(ifft_z, Y) |> parent, y, atol = 1E-9 * unit_x))

    p = plan_fft(z, X)
    @test plan_fft(z, 1) isa Any
    @test all(isapprox.(mul!(fft_z, p, complex.(z)), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(fft_z, p, complex.(z)), ref_values, atol = 1E-9 * unit))
    pinv = plan_ifft(fft_z, X)
    @test plan_ifft(fft_z, 1) isa Any
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))

    fft_z = rfft(z, X)
    @test fft_z == rfft(z, 1)
    ref_values = @d fourier_gauss.(dims(fft_z, X), 5 / unit_x^2, Y(y)) .* unit_z
    @test all(isapprox.(fft_z, ref_values, atol = 1E-9 * unit))

    ifft_z = irfft(fft_z, size(z, X), X)
    @test ifft_z == irfft(fft_z, size(z, X), X)
    ifft_refvalues = @d gauss.(dims(ifft_z, X), 5 / unit_x^2, Y(y)) .* unit_z
    @test all(isapprox.(ifft_z, ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(lookup(ifft_z, X) |> parent |> step, step(x), atol = 1E-9 * unit_x))
    @test all(isapprox.(lookup(ifft_z, Y) |> parent, y, atol = 1E-9 * unit_x))

    # Double test to ensure that the plan uses correctly the temporary arrays used to avoid allocations
    p = plan_rfft(z, X)
    @test plan_rfft(z, 1) isa Any
    @test all(isapprox.(mul!(fft_z, p, z), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(fft_z, p, z), ref_values, atol = 1E-9 * unit))
    @test all(isapprox.(mul!(rand(typeof((1.0 .+ im)*u"kg*m"), dims(fft_z, X), dims(fft_z, Y)), p, z), ref_values, atol = 1E-9 * unit)) # Check output with different unit works correctly
    @test_throws Unitful.DimensionError mul!(rand(typeof((1.0 .+ im)u"kg"), dims(fft_z, X), dims(fft_z, Y)), p, z)
    @test_throws ArgumentError mul!(rand(typeof(fft_z[1]), X(x), Y(y)), p, z)

    pinv = plan_irfft(fft_z, size(z, X), X)
    @test plan_irfft(fft_z, size(z, X), 1) isa Any
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(mul!(ifft_z, pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z))
    @test all(isapprox.(mul!(rand(typeof((1.0)*u"kg"), dims(ifft_z, X), dims(ifft_z, Y)), pinv, fft_z), ifft_refvalues, atol = 1E-9 * unit_z)) # Check output with different unit works correctly
    @test_throws Unitful.DimensionError mul!(rand(typeof((1.0)*u"kg * m"), dims(ifft_z, X), dims(ifft_z, Y)), pinv, fft_z)
    @test_throws ArgumentError mul!(rand(typeof(ifft_z[1]), X(x), Y(y)), pinv, fft_z)
end

@testset "Different data precision" begin
    dd = ones(Float32, X(Float64(1):Float64(1000)))
    
    @test eltype(rfft(dd)) == ComplexF32
    
    dd_uni = ones(Float32, X(Float64(1u"m"):1u"m":Float64(1000u"m")))
    @test eltype(rfft(dd_uni)) == Quantity{ComplexF32, dimension(u"m"), typeof(u"m")}
end

for f in (:shiftlocus, :maybeshiftlocus)
    @eval begin
        function Lookups.$f(locus::Locus, x; dims=Dimensions.dims(x))
            newdims = map(Dimensions.dims(x, dims)) do d
                Lookups.$f(locus, d)
            end
            return setdims(x, newdims)
        end
        function Lookups.$f(locus::Locus, d::Dimension)
            rebuild(d, Lookups.$f(locus, lookup(d)))
        end
    end
end

reorder(dim::Dimension, o::Order) = rebuild(dim, reorder(lookup(dim), o))

# AbstractDimArrayGenerator <: AbstractBasicDimArray

# Abstract supertype for all AbstractBasicDimArrays that
# generate their `data` on demand during `getindex`.
abstract type AbstractDimArrayGenerator{T,N,D} <: AbstractBasicDimArray{T,N,D} end

dims(dg::AbstractDimArrayGenerator)::Tuple{Vararg{Dimension}} = dg.dims

# Dims that contribute to the element type.
# May be larger than `dims` after slicing
eldims(di::AbstractDimArrayGenerator) = dims((dims(di)..., refdims(di)...), orderdims(di))
eldims(di::AbstractDimArrayGenerator, d) = dims(eldims(di), d)

Base.size(dg::AbstractDimArrayGenerator) = map(length, dims(dg))
Base.axes(dg::AbstractDimArrayGenerator) = map(d -> axes(d, 1), dims(dg))

@inline Base.permutedims(A::AbstractDimArrayGenerator{<:Any,2}) =
    rebuild(A; dims=reverse(dims(A)))
@inline Base.permutedims(A::AbstractDimArrayGenerator{<:Any,1}) =
    rebuild(A; dims=(AnonDim(Base.OneTo(1)), dims(A)...))
@inline function Base.permutedims(A::AbstractDimArrayGenerator, perm)
    length(perm) == length(dims(A)) || throw(ArgumentError("permutation must be same length as dims"))
    rebuild(A; dim=sortdims(dims(A), Tuple(perm)))
end

@inline function Base.PermutedDimsArray(A::AbstractDimArrayGenerator{T,N}, perm) where {T,N}
    perm_inds = dimnum(A, Tuple(perm))
    rebuild(A; dims=dims(dims(A), Tuple(perm)))
end

# AbstractRebuildableDimArrayGenerator <: AbstractDimArrayGenerator

# Abstract supertype for all AbstractDimArrayGenerator that
# can be rebuilt when subsetted with `view` or `getindex`.

# These arrays must have `dims` and `refdims` fields that defined the data
# They do not need to define `rebuildsliced` methods as this is defined
# as simply doing `slicedims` on `dims` and `refdims` and rebuilding.
abstract type AbstractRebuildableDimArrayGenerator{T,N,D,R<:MaybeDimTuple} <: AbstractDimArrayGenerator{T,N,D} end

refdims(A::AbstractRebuildableDimArrayGenerator) = A.refdims

_refdims_firsts(A::AbstractRebuildableDimArrayGenerator) = map(d -> rebuild(d, first(d)), refdims(A))

# Custom rebuildsliced where data is ignored, and just dims and refdims are slices
# This makes sense for AbstractRebuildableDimArrayGenerator because Arrays are
# generated in getindex from the dims/refdims combination.
# `f` is ignored, and views are always used
@propagate_inbounds function rebuildsliced(f::Function, A::AbstractRebuildableDimArrayGenerator, I)
    dims, refdims = slicedims(view, A, I)
    return rebuild(A; dims, refdims)
end

abstract type AbstractDimIndices{T,N,D,R,O<:MaybeDimTuple} <: AbstractRebuildableDimArrayGenerator{T,N,D,R} end

orderdims(di::AbstractDimIndices) = di.orderdims

"""
    DimIndices <: AbstractArray

    DimIndices(x)
    DimIndices(dims::Tuple)
    DimIndices(dims::Dimension)

Like `CartesianIndices`, but for `Dimension`s. Behaves as an `Array` of `Tuple`
of `Dimension(i)` for all combinations of the axis indices of `dims`.

This can be used to view/index into arbitrary dimensions over an array, and
is especially useful when combined with `otherdims`, to iterate over the
indices of unknown dimension.

`DimIndices` can be used directly in `getindex` like `CartesianIndices`,
and freely mixed with individual `Dimension`s or tuples of `Dimension`.

## Example

Index a `DimArray` with `DimIndices`.

Notice that unlike CartesianIndices, it doesn't matter if the dimensions
are not in the same order. Or even if they are not all contained in each.

```jldoctest; setup = :(using DimensionalData, Random; Random.seed!(123))
julia> A = rand(Y(0.0:0.3:1.0), X('a':'f'))
┌ 4×6 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────── dims ┐
  ↓ Y Sampled{Float64} 0.0:0.3:0.9 ForwardOrdered Regular Points,
  → X Categorical{Char} 'a':1:'f' ForwardOrdered
└──────────────────────────────────────────────────────────────────┘
 ↓ →   'a'       'b'       'c'        'd'        'e'       'f'
 0.0  0.9063    0.253849  0.0991336  0.0320967  0.774092  0.893537
 0.3  0.443494  0.334152  0.125287   0.350546   0.183555  0.354868
 0.6  0.745673  0.427328  0.692209   0.930332   0.297023  0.131798
 0.9  0.512083  0.867547  0.136551   0.959434   0.150155  0.941133

julia> di = DimIndices((X(1:2:4), Y(1:2:4)))
┌ 2×2 DimIndices{Tuple{X{Int64}, Y{Int64}}, 2} ┐
├──────────────────────────────────────── dims ┤
  ↓ X 1:2:3,
  → Y 1:2:3
└──────────────────────────────────────────────┘
 ↓ →  1                3
 1     (↓ X 1, → Y 1)   (↓ X 1, → Y 3)
 3     (↓ X 3, → Y 1)   (↓ X 3, → Y 3)

julia> A[di] # Index A with these indices
┌ 2×2 DimArray{Float64, 2} ┐
├──────────────────────────┴───────────────────────────────── dims ┐
  ↓ Y Sampled{Float64} 0.0:0.6:0.6 ForwardOrdered Regular Points,
  → X Categorical{Char} 'a':2:'c' ForwardOrdered
└──────────────────────────────────────────────────────────────────┘
 ↓ →   'a'       'c'
 0.0  0.9063    0.0991336
 0.6  0.745673  0.692209
```
"""
struct DimIndices{T<:MaybeDimTuple,N,D,R,O} <: AbstractDimIndices{T,N,D,R,O}
    dims::D
    refdims::R
    orderdims::O
    # Manual inner constructor for ambiguity only
    function DimIndices(dims::D, refdims::R, orderdims::O) where {D<:MaybeDimTuple,R<:MaybeDimTuple,O<:MaybeDimTuple}
        eldims = DD.dims((dims..., refdims...), orderdims)
        T = typeof(map(d -> rebuild(d, 1), eldims))
        N = length(dims)
        new{T,N,D,R,O}(dims, refdims, orderdims)
    end
end
function DimIndices(dims::MaybeDimTuple)
    dims = length(dims) > 0 ? _dimindices_format(dims) : dims
    return DimIndices(dims, (), basedims(dims))
end
DimIndices(x) = DimIndices(dims(x))
DimIndices(dim::Dimension) = DimIndices((dim,))
DimIndices(::Nothing) = throw(ArgumentError("Object has no `dims` method"))

# Forces multiple indices not linear
function Base.getindex(A::DimIndices, i1::Integer, i2::Integer, I::Integer...)
    dis = map(dims(A), (i1, i2, I...)) do d, i
        rebuild(d, d[i])
    end
    dims((dis..., _refdims_firsts(A)...), orderdims(A))
end
# Dispatch to avoid linear indexing in multidimensional DimIndices
function Base.getindex(A::DimIndices{<:Any,1}, i::Integer)
    d = dims(A, 1)::Dimension
    di = rebuild(d, d[i])
    return dims((di, _refdims_firsts(A)...), orderdims(A))
end
Base.getindex(A::DimIndices{<:Any,0}) = dims(_refdims_firsts(A), orderdims(A))

_dimindices_format(dims::Tuple{}) = ()
_dimindices_format(dims::Tuple) = map(rebuild, dims, map(_dimindices_axis, dims))

_dimindices_axis(x::Integer) = Base.OneTo(x)
_dimindices_axis(x::AbstractRange{<:Integer}) = x
_dimindices_axis(x::Dimension) = _dimindices_axis(val(x))
_dimindices_axis(x::Lookup) = axes(x, 1)
_dimindices_axis(x) =
    throw(ArgumentError("`$x` is not a valid input for `DimIndices`. Use `Dimension`s wrapping `Integer`, `AbstractArange{<:Integer}`, or a `Lookup` (the `axes` will be used)"))

abstract type AbstractDimVals{T,N,D,R,O} <: AbstractDimIndices{T,N,D,R,O} end

(::Type{T})(::Nothing; kw...) where T<:AbstractDimVals = throw(ArgumentError("Object has no `dims` method"))
(::Type{T})(x; kw...) where T<:AbstractDimVals = T(dims(x); kw...)
(::Type{T})(dim::Dimension; kw...) where T<:AbstractDimVals = T((dim,); kw...)

"""
    DimPoints <: AbstractArray

    DimPoints(x; order)
    DimPoints(dims::Tuple; order)
    DimPoints(dims::Dimension; order)

Like `CartesianIndices`, but for the point values of the dimension index.
Behaves as an `Array` of `Tuple` lookup values (whatever they are) for all
combinations of the lookup values of `dims`.

Either a `Dimension`, a `Tuple` of `Dimension` or an object `x`
that defines a `dims` method can be passed in.

# Keywords

- `order`: determines the order of the points, the same as the order of `dims` by default.
"""
struct DimPoints{T<:Tuple,N,D,R,O} <: AbstractDimVals{T,N,D,R,O}
    dims::D
    refdims::R
    orderdims::O
    function DimPoints(dims::D, refdims::R, orderdims::O) where {D<:MaybeDimTuple,R<:MaybeDimTuple,O<:MaybeDimTuple}
        eldims = DD.dims((dims..., refdims...), orderdims)
        T = Tuple{map(eltype, eldims)...}
        N = length(dims)
        new{T,N,D,R,O}(dims, refdims, orderdims)
    end
end
DimPoints(dims::Tuple; order=dims) = DimPoints(dims, order)
function DimPoints(dims::Tuple, order::Tuple)
    dims = length(dims) > 0 ? format(dims) : dims
    DimPoints(dims, (), basedims(order))
end

function Base.getindex(A::DimPoints, i1::Integer, i2::Integer, I::Integer...)
    # Get dim-wrapped point values at i1, I...
    pointdims = map(dims(A), (i1, i2, I...)) do d, i
        rebuild(d, d[i])
    end
    # Return the unwrapped point sorted by orderdims
    return map(val, DD.dims((pointdims..., _refdims_firsts(A)...), orderdims(A)))
end
function Base.getindex(A::DimPoints{<:Any,1}, i::Integer) 
    # Get dim-wrapped point values at i1, I...
    d1 = dims(A, 1)
    pointdim = rebuild(d1, d1[i])
    # Return the unwrapped point sorted by orderdims
    D = dims((pointdim, _refdims_firsts(A)...), orderdims(A))
    return map(val, D)
end
Base.getindex(A::DimPoints{<:Any,0}) = map(val, dims(_refdims_firsts(A), orderdims(A)))

"""
    DimSelectors <: AbstractArray

    DimSelectors(x; selectors, atol...)
    DimSelectors(dims::Tuple; selectors, atol...)
    DimSelectors(dims::Dimension; selectors, atol...)

Like [`DimIndices`](@ref), but returns `Dimensions` holding
the chosen [`Selector`](@ref)s.

Indexing into another `AbstractDimArray` with `DimSelectors`
is similar to doing an interpolation.

## Keywords

- `selectors`: `Near`, `At` or `Contains`, or a mixed tuple of these.
  `At` is the default, meaning only exact or within `atol` values are used.
- `atol`: used for `At` selectors only, as the `atol` value. Ignored where 
    `atol` is set inside individual `At` selectors.

## Example

Here we can interpolate a `DimArray` to the lookups of another `DimArray`
using `DimSelectors` with `Near`. This is essentially equivalent to
nearest neighbour interpolation.

```jldoctest; setup = :(using DimensionalData, Random; Random.seed!(123))
julia> A = rand(X(1.0:3.0:30.0), Y(1.0:5.0:30.0), Ti(1:2));

julia> target = rand(X(1.0:10.0:30.0), Y(1.0:10.0:30.0));

julia> A[DimSelectors(target; selectors=Near), Ti=2]
┌ 3×3 DimArray{Float64, 2} ┐
├──────────────────────────┴────────────────────────────────────── dims ┐
  ↓ X Sampled{Float64} [1.0, …, 22.0] ForwardOrdered Irregular Points,
  → Y Sampled{Float64} [1.0, …, 21.0] ForwardOrdered Irregular Points
└───────────────────────────────────────────────────────────────────────┘
  ↓ →  1.0        11.0       21.0
  1.0  0.691162    0.218579   0.539076
 10.0  0.0303789   0.420756   0.485687
 22.0  0.0967863   0.864856   0.870485
```

Using `At` would make sure we only use exact interpolation,
while `Contains` with sampling of `Intervals` would make sure that
each values is taken only from an Interval that is present in the lookups.
"""
struct DimSelectors{T<:MaybeDimTuple,N,D,R,O,S<:Tuple} <: AbstractDimVals{T,N,D,R,O}
    dims::D
    refdims::R
    orderdims::O
    selectors::S
    function DimSelectors(dims::D, refdims::R, orderdims::O, selectors::S) where {D<:Tuple,R<:Tuple,O<:Tuple,S<:Tuple}
        eldims = DD.dims((dims..., refdims...), orderdims)
        T = _selector_eltype(eldims, selectors)
        N = length(dims)
        new{T,N,D,R,O,S}(dims, refdims, orderdims, selectors)
    end
end
function DimSelectors(dims::MaybeDimTuple; atol=nothing, selectors=At())
    s = _format_selectors(dims, selectors, atol)
    DimSelectors(dims, s)
end
function DimSelectors(dims::MaybeDimTuple, selectors::Tuple)
    dims = length(dims) > 0 ? format(dims) : dims
    orderdims = basedims(dims)
    refdims = ()
    length(dims) == length(selectors) || throw(ArgumentError("`length(dims) must match  `length(selectors)`, got $(length(dims)) and $(length(selectors))"))
    DimSelectors(dims, refdims, orderdims, selectors)
end


@propagate_inbounds function Base.getindex(A::DimSelectors, i1::Integer, i2::Integer, I::Integer...)
    D = map(dims(A), (i1, i2, I...)) do d, i
        rebuild(d, d[i])
    end
    return _rebuild_selectors(A, D)
end
@propagate_inbounds function Base.getindex(A::DimSelectors{<:Any,1}, i::Integer)
    d1 = dims(A, 1)
    d = rebuild(d1, d1[i])
    return _rebuild_selectors(A, (d,))
end
@propagate_inbounds Base.getindex(A::DimSelectors{<:Any,0}) =
    _rebuild_selectors(A, ())

function _rebuild_selectors(A, D)
    sorteddims = dims((D..., _refdims_firsts(A)...), orderdims(A))
    map(sorteddims, A.selectors) do d, s
        rebuild(d, rebuild(s; val=val(d)))
    end
end

_selector_eltype(dims::Tuple, selectors::Tuple) =
    Tuple{map(_selector_eltype, dims, selectors)...}
_selector_eltype(d::D, ::S) where {D,S} =
    basetypeof(D){basetypeof(S){eltype(d)}}
_selector_eltype(d::D, ::At{<:Any,A}) where {D,A} =
    basetypeof(D){At{eltype(d),A}}

function show_after(io::IO, mime, A::DimSelectors)
    _, displaywidth = displaysize(io)
    blockwidth = get(io, :blockwidth, 0)
    selector_lines = split(sprint(show, mime, A.selectors), "\n")
    new_blockwidth = min(displaywidth-2, max(blockwidth, maximum(length, selector_lines) + 4))
    new_blockwidth = print_block_separator(io, "selectors", blockwidth, new_blockwidth)
    println(io)
    print(io, "  ")
    show(io, mime, A.selectors)
    println(io)
    print_block_close(io, new_blockwidth)
    ndims(A) > 0 && println(io)
    print_array(io, mime, A)
end

@inline _format_selectors(dims::Tuple, selector, atol) =
    _format_selectors(dims, map(_ -> selector, dims), atol)
@inline _format_selectors(dims::Tuple, selectors::Tuple, atol) =
    _format_selectors(dims, selectors, map(_ -> atol, dims))
@inline _format_selectors(dims::Tuple, selectors::Tuple, atol::Tuple) =
    map(_format_selectors, dims, selectors, atol)
@inline _format_selectors(d::Dimension, T::Type, atol) = _format_selectors(d, T(), atol)
@inline _format_selectors(d::Dimension, ::Near, atol) = Near(nothing)
@inline _format_selectors(d::Dimension, ::Contains, atol) = Contains(nothing)
@inline function _format_selectors(d::Dimension, at::At, atol)
    atolx = _atol(eltype(d), Lookups.atol(at), atol)
    At(nothing; atol=atolx)
end

_atol(::Type, atol1, atol2) = atol1
_atol(T::Type{<:AbstractFloat}, atol, ::Nothing) = atol
_atol(T::Type{<:AbstractFloat}, ::Nothing, atol) = atol
_atol(T::Type{<:AbstractFloat}, ::Nothing, ::Nothing) = eps(T)

# Deprecated
const DimKeys = DimSelectors

const SliceDim = Dimension{<:Union{<:AbstractVector{Int},<:AbstractVector{<:AbstractVector{Int}}}}

"""
    DimSlices <: AbstractRebuildableDimArrayGenerator

    DimSlices(x, dims; drop=true)

A `Base.Slices` like object for returning view slices from a DimArray.

This is used for `eachslice` on `AbstractDimStack`.

`dims` must be a `Tuple` of `Dimension` holding `AbstractVector{Int}`
or `AbstractVector{<:AbstractVector{Int}}`.

# Keywords

- `drop`: whether to drop dimensions from the outer array or keep the 
    same dimensions as the inner view, but with length 1.
"""
struct DimSlices{T,N,D,R,P,U} <: AbstractRebuildableDimArrayGenerator{T,N,D,R}
    _data::P
    dims::D
    refdims::R
    reduced::U
end
DimSlices(x; dims, drop=true) = DimSlices(x, dims; drop)
DimSlices(x, dim; kw...) = DimSlices(x, (dim,); kw...)
function DimSlices(x, dims::Tuple; drop::Union{Bool,Nothing}=nothing)
    dims = DD.dims(x, dims)
    refdims = ()
    inds = if length(dims) == 0
        map(d -> rebuild(d, :), DD.dims(x))
    else
        map(d -> rebuild(d, firstindex(d)), dims)
    end
    slicedims, reduced = if isnothing(drop) || drop
        # We have to handle filling in colons for no dims because passing 
        # no dims at all is owned by base to mean A[] not A[D1(:), D2(:), D3(:)]
        dims, ()
    else
        # Get other dimensions as length 1
        reduced = map(otherdims(x, dims)) do o
            reducedims(o)
        end
        # Re-sort to x dim order
        slicedims = DD.dims((reduced..., dims...), DD.dims(x))
        sliceddims, basedims(reduced)
    end
    T = typeof(view(x, inds...))
    N = length(slicedims)
    D = typeof(slicedims)
    R = typeof(refdims)
    A = typeof(x)
    U = typeof(reduced)
    return DimSlices{T,N,D,R,A,U}(x, slicedims, refdims, reduced)
end

function rebuild(ds::DimSlices{T,N}; 
    dims::D, refdims::R, reduced::U=ds.reduced
) where {T,N,D,R,U}
    A = typeof(ds._data)
    DimSlices{T,N,D,R,A,U}(ds._data, dims, refdims, reduced)
end
@propagate_inbounds function rebuildsliced(::Function, A::DimSlices, I)
    @boundscheck checkbounds(A, I...)
    # We use `unafe_view` to force always wrapping as a view, even for ranges
    # Then in `_refdims_firsts` we can use `first(parentindices(d))` to get the offset
    dims, refdims = slicedims(Base.unsafe_view, A, I)
    return rebuild(A; dims, refdims)
end

# We need to get the vist index from the view, so define this custom for DimSlices
_refdims_firsts(A::DimSlices) = map(d -> rebuild(d, first(parentindices(d))), refdims(A))

function Base.summary(io::IO, A::DimSlices{T,N}) where {T,N}
    print_ndims(io, size(A))
    print(io, string(nameof(typeof(A)), "{$(nameof(T)),$N}"))
end

@propagate_inbounds function Base.getindex(A::DimSlices, i1::Integer, i2::Integer, Is::Integer...)
    I = (i1, i2, Is...)
    D = map(dims(A), I) do d, i
        i1 = if hasdim(A.reduced, d) 
            @boundscheck checkbounds(d, i)
            Colon()
        else
            eachindex(d)[i]
        end
        return rebuild(d, i1)
    end
    R = _refdims_firsts(A)
    return view(A._data, D..., R...)
end
# Dispatch to avoid linear indexing in multidimensional DimIndices
@propagate_inbounds function Base.getindex(A::DimSlices{<:Any,1}, i::Integer)
    d1 = dims(A, 1)
    d = if hasdim(A.reduced, d1)
        @boundscheck checkbounds(d1, i)
        rebuild(d1, :)
    else
        rebuild(d1, eachindex(d1)[i])
    end
    return view(A._data, d, _refdims_firsts(A)...)
end
@propagate_inbounds function Base.getindex(A::DimSlices{<:Any,0})
    R = _refdims_firsts(A)
    # Need to manually force the Colons in case there are no dims at all
    D = map(otherdims(A._data, R)) do d
        rebuild(d, :)
    end
    view(A._data, D..., R...)
end

# Extends the dimensions of any `AbstractBasicDimArray`
# as if the array assigned into a larger array across all dimensions,
# but without the copying. Theres is a cost for linear indexing these objects
# as we need to convert to Cartesian.
struct DimExtensionArray{
   T,N,D<:MaybeDimTuple,R<:MaybeDimTuple,A<:AbstractBasicDimArray{T}
} <: AbstractDimArrayGenerator{T,N,D}
    _data::A
    dims::D
    refdims::R
    function DimExtensionArray(A::AbstractBasicDimArray{T}, dims::Tuple, refdims::Tuple) where T
        all(hasdim(dims, DD.dims(A))) || throw(ArgumentError("all dim in array must also be in `dims`"))
        comparedims(A, DD.dims(dims, DD.dims(A)))
        fdims = format(dims, CartesianIndices(map(length, dims)))
        N = length(dims)
        new{T,N,typeof(fdims),typeof(refdims),typeof(A)}(A, fdims, refdims)
    end
end
DimExtensionArray(A::AbstractBasicDimArray, dims::Tuple; refdims=refdims(A)) =
    DimExtensionArray(A, dims, refdims)

name(A::DimExtensionArray) = name(A._data)
metadata(A::DimExtensionArray) = metadata(A._data)

@propagate_inbounds function rebuildsliced(f::Function, de::DimExtensionArray, I)
    newdims, newrefdims = slicedims(dims(de), refdims(de), I)
    D = map(rebuild, dims(de), I)
    A = de._data
    realdims = dims(D, dims(A))
    if all(map(d -> val(d) isa Colon, realdims))
        rebuild(de; dims=newdims, refdims=newrefdims)
    else
        newrealparent = begin
            x = f(parent(A), dims2indices(A, realdims)...)
            x isa AbstractArray ? x : fill(x)
        end
        newrealdims = dims(newdims, realdims)
        newdata = rebuild(A; data=newrealparent, dims=newrealdims)
        rebuild(de; _data=newdata, dims=newdims, refdims=newrefdims)
    end
end
@propagate_inbounds function rebuildsliced(
    f::Function, de::DimExtensionArray{<:Any,1}, I::Tuple{<:Union{Colon,AbstractRange}}
)
    newdims, _ = slicedims(dims(de), I)
    A = de._data
    D = rebuild(only(dims(de)), only(I))
    rebuild(de; dims=newdims, _data=A[D...])
end

# Integer indexing
function Base.getindex(de::DimExtensionArray, i1::Integer, i2::Integer, Is::Integer...)
    D = map(rebuild, dims(de), (i1, i2, Is...))
    A = de._data
    return getindex(A, dims(D, dims(A))...)
end
Base.getindex(de::DimExtensionArray{<:Any,1}, i::Integer) = getindex(de._data, rebuild(dims(de, 1), i))
Base.getindex(de::DimExtensionArray{<:Any,0}) = de._data[]

function mergedims(A::DimExtensionArray, dim_pairs::Pair...)
    all_dims = dims(A)
    dims_new = mergedims(all_dims, dim_pairs...)
    dimsmatch(all_dims, dims_new) && return A
    dims_perm = _unmergedims(dims_new, map(last, dim_pairs))
    Aperm = PermutedDimsArray(A, dims_perm)
    data_merged = reshape(parent(Aperm), map(length, dims_new))
    return DimArray(data_merged, dims_new)
end

for f in (:getindex, :view, :dotview)
    @eval begin
        # Int and CartesianIndex forward to the parent
        @propagate_inbounds Base.$f(l::Lookup, i::Union{Int,CartesianIndex}) =
            Base.$f(parent(l), i)
        # AbstractArray, Colon and CartesianIndices: the lookup is rebuilt around a new parent
        @propagate_inbounds Base.$f(l::Lookup, i::Union{AbstractArray,Colon}) = 
            rebuild(l; data=Base.$f(parent(l), i))
        # Selector gets processed with `selectindices`
        @propagate_inbounds Base.$f(l::Lookup, i::SelectorOrInterval) = Base.$f(l, selectindices(l, i))
        @propagate_inbounds function Base.$f(l::Lookup, i)
            x = Base.$f(parent(l), i)
            x isa AbstractArray ? rebuild(l; data=x) : x
        end
    end
end

using DimensionalData, Test, Extents
using DimensionalData.Lookups

xdim, ydim = X(1:10), Y(1:15)
a = rand(xdim, ydim)
b = rand(Float32, xdim, ydim)
c = rand(Int, xdim, ydim)
st = DimStack((; a, b, c))

@testset "detlete!, pop!, only" begin
     dt = DimTree()
     dt.m = DimTree()
     dt.m.n = st
     @test_throws ArgumentError only(dt.m.n)
     @test DimStack(dt.m.n) === st
     delete!(dt.m.n, :c)
     x = pop!(dt.m.n, :b) 
     @test x === st.b
     @test only(dt.m.n) === st.a
     @test delete!(dt.m.n) == dt.m
     @test isempty(DimensionalData.branches(dt.m))
end

# We get an identical DimStack back out after conversion to/from DimTree
@testset "DimStack -> DimTree -> DimStack" begin
     dt = DimTree(st)
     dt.b1 = st
     dt.b2 = st
     @test DimStack(dt.b1) === DimStack(dt.b2) === st
end
      
@testset "extent" begin
     dt = DimTree()
     dt.b1 = st
     @test extent(dt) == extent(st)
end
      
@testset "interface methods" begin
     dt = DimTree(st)
     @test lookup(dt, X) == lookup(st, X)
     @test order(dt, Y) == order(st, Y) == ForwardOrdered()
     @test span(dt, X) == span(st, X) == Regular(1)
     @test sampling(dt, (X(), Y())) == sampling(st, (X(), Y()))
end

@testset "Indexing matches stack indexing" begin
     dt = DimTree(st)
     dt.b1 = st
     dt.b2 = st
     dt_sliced = view(dt, X=Between(2, 4))
     @test DimStack(dt_sliced) === view(DimStack(dt), X(Between(2, 4)))
     @test DimStack(dt_sliced.b1) === view(DimStack(dt.b1), X(Between(2, 4)))
     @test DimStack(dt_sliced.b2) === view(DimStack(dt.b2), X(Between(2, 4)))
     dt_sliced = getindex(dt, X=Between(2, 4))
     @test DimStack(dt_sliced) == getindex(DimStack(dt), X(Between(2, 4)))
     @test DimStack(dt_sliced.b1) == getindex(DimStack(dt.b1), X(Between(2, 4)))
     @test DimStack(dt_sliced.b2) == getindex(DimStack(dt.b2), X(Between(2, 4)))
end

@testset "Mixed dim branches" begin
     xdim, ydim = map(DimensionalData.format, (X(1:10), Y(1:15)))
     z1, z2 = map(DimensionalData.format, (Z(["A", "B", "C"]), Z(["C", "D"])))
     a = rand(xdim, ydim; name=:a)
     b = rand(Float32, xdim, ydim; name=:b)
     c = rand(Int, xdim, ydim, z1; name=:c)
     d = rand(Int, xdim, z2; name=:d)
     dt = DimTree(a, b)
     dt.z1 = c
     dt.z2 = d
     @test dims(dt) == (xdim, ydim)
     @test dims(dt.z1) == (xdim, ydim, z1)
     @test dims(dt.z2) == (xdim, ydim, z2)
     @testset "Selectors must be shared by branches" begin
          @test dt[Z=At("C")] isa DimTree
          @test_throws DimensionalData.Lookups.SelectorError dt[Z=At("D")]
          # Not clear if this should warn when branches lack dims?
          @test_warn "dims were not found in object" dt[Y=At(10)]
     end
end

@testset "setindex!" begin
     xdim, ydim = X(1:10), Y(1:15)
     a = rand(xdim)
     b = rand(Float32, xdim, ydim)
     b2 = rand(X(1:2:10), Y(1:2:15))
     a2 = rand(X(1:2:10))
     sub1 = DimTree()
     sub1[:a] = a
     sub1[:b] = b
     @test sub1[:b] == b 
     @test sub1[:a] == a
     @test dims(sub1) == (xdim, ydim)
     @test length(sub1) == 2
     sub2 = DimTree()
     sub2[:a] = a2
     sub2[:b] = b2 
     dt = DimTree()
     dt.sub1 = sub1
     dt.sub2 = sub2
     @test dt.sub2[:a] == a2
     dt2 = DimTree()
     dt2[:a] = rand(xdim, ydim)
     dt2[:b] = b
     @test dt2[:b] == b
end

@testset "prune" begin
     @testset "prune with leaves" begin
          b1 = rand(Y(1:15), X(1:10))
          b2 = rand(Y(1:2:15), X(1:2:10))
          sub1 = DimTree()
          sub2 = DimTree()
          sub1[:b] = b1
          sub2[:b] = b2 
          dt = DimTree()
          dt.sub1 = sub1 
          dt.sub2 = sub2
          dp1 = prune(dt, keep=:sub1)
          @test dp1[:b] == b1
          @test DimStack(dt, keep=:sub1) == DimStack(sub1[:b])       
     end

     @testset "prune dt with subbranches" begin
          b1 = rand(Y(1:15), X(1:10); name=:leaf)
          b2 = rand(Y(1:2:15), X(1:2:10); name=:leaf)
          sub1 = DimTree()
          sub2 = DimTree()
          sub1.b = b1
          sub2.b = b2 
          dt = DimTree()
          dt.sub1 = sub1 
          dt.sub2 = sub2
          dp1 = prune(dt, keep=:sub1=>:b)
          @test dp1[:leaf] == b1
          @test DimStack(dt; keep=:sub1=>:b) == DimStack(sub1.b) == DimStack(sub1.b[:leaf])
     end
end

# TODO move to doctests, but useful here for now

using DimensionalData, Test, Extents, Dates

xdim, ydim = X(1:10), Y(1:15)
t = Ti(DateTime(2000):Month(1):DateTime(2000, 12))

# Define DimArrays
a = rand(xdim, ydim, t; name=:a)
b = rand(Float32, xdim, ydim; name=:b)
c = rand(Int, xdim, ydim, t; name=:c)

# And a DimStack
st = DimStack((; a, b, c))

# Define an empty tree with a common time dimension
tree = DimTree(; dims=(t,))

# Set a branch to be the stack
tree.branch1 = st

# Add another branch with a different set of dimensions
xdim2, ydim2 = X(11:2:20), Y(15:2:30)
d = rand(xdim2, ydim2, t; name=:d)
tree.branch2 = d

# Get an array from a leaf
tree.branch2[:d]

# Get a stack from a branch
DimStack(tree.branch1)

# Check dimensions
dims(tree)
dims(tree.branch1)

# Slice the X dimension of all branches
tree[X = 5 .. 20]

# This one empties branch1
tree[X = 15 .. 20]

using DimensionalData, Test, Unitful, Adapt

using DimensionalData.Lookups, DimensionalData.Dimensions

struct CustomArray{T,N} <: AbstractArray{T,N}
    arr::Array
end

CustomArray(x::Array{T,N}) where {T,N} = CustomArray{T,N}(x)
Adapt.adapt_storage(::Type{<:CustomArray}, xs::Array) = CustomArray(xs)

Base.size(x::CustomArray, y...) = size(x.arr, y...)
Base.getindex(x::CustomArray, y...) = getindex(x.arr, y...)
Base.count(x::CustomArray) = count(x.arr)

@testset "Metadata" begin
    @test adapt(CustomArray, Metadata(:a=>"1", :b=>"2")) == NoMetadata()
end

@testset "Lookup" begin
    l = Sampled([1:10...]; metadata=Metadata(:a=>"1", :b=>"2"))
    l1 = Adapt.adapt(CustomArray, l)
    @test parent(parent(l1)) isa CustomArray
    @test parent(parent(l1)).arr == [1:10...]
    @test metadata(l1) == NoMetadata()
    E = permutedims(cat(1:10, 2:11; dims=2))
    l = Sampled([1:10...]; metadata=Metadata(:a=>"1", :b=>"2"), span=Explicit(E))
    l1 = Adapt.adapt(CustomArray, l)
    @test parent(parent(l1)) isa CustomArray
    @test parent(parent(l1)).arr == [1:10...]
    @test DimensionalData.span(l1) == Explicit(CustomArray(E))
    @test metadata(l1) == NoMetadata()
    l = Categorical('a':1:'n'; metadata=Metadata(:a=>"1", :b=>"2"))
    l1 = Adapt.adapt(CustomArray, l)
    @test parent(parent(l1)) isa StepRange
    @test metadata(l1) == NoMetadata()
    l = Categorical(['a', 'e', 'n']; metadata=Metadata(:a=>"1", :b=>"2"))
    l1 = Adapt.adapt(CustomArray, l)
    @test parent(parent(l1)) isa CustomArray
    @test metadata(l1) == NoMetadata()
    l = NoLookup(Base.OneTo(10))
    l1 = Adapt.adapt(CustomArray, l)
    @test parent(parent(l1)) isa Base.OneTo
    l = AutoLookup()
    l1 = Adapt.adapt(CustomArray, l)
    @test parent(l1) isa AutoValues
end

@testset "Dimension" begin
    d = X(Sampled([1:10...]; metadata=Metadata(:a=>"1", :b=>"2")))
    d1 = Adapt.adapt(CustomArray, d)
    @test parent(parent(d1)) isa CustomArray
    @test parent(parent(d1)).arr == [1:10...]
    @test metadata(d1) == NoMetadata()
end

@testset "DimArray" begin
    A = rand(4, 5)
    da = DimArray(A, (X, Y))
    da1 = adapt(CustomArray, da)
    @test parent(da1) isa CustomArray
    @test parent(da1).arr == A
    @test metadata(da1) == NoMetadata()
end

@testset "DimStack" begin
    A = rand(4, 5)
    B = rand(4, 5)
    ds = DimStack((a=A, b=B), (X, Y))
    ds1 = adapt(CustomArray, ds)
    @test parent(ds1[:a]) isa CustomArray
    @test parent(ds1[:a]).arr == A
    @test parent(ds1[:b]) isa CustomArray
    @test parent(ds1[:b]).arr == B
    @test metadata(ds) == NoMetadata()
end

using DimensionalData
using Test
using Dates
using JLArrays
using GPUArrays

using DimensionalData.Lookups
using DimensionalData.Dimensions

using DimensionalData: NoLookup

GPUArrays.allowscalar(false)

# Tests taken from NamedDims. Thanks @oxinabox

da = ones(X(3))
dajl = rebuild(da, JLArray(parent(da)));
@test Base.BroadcastStyle(typeof(da)) isa DimensionalData.DimensionalStyle

@testset "standard case" begin
    @test (@inferred da .+ da) == 2ones(3)
    @test dims(da .+ da) == dims(da)
    @test (@inferred da .+ da .+ da) == 3ones(3)
    @test dims(da .+ da .+ da) == dims(da)
end

@testset "broadcast over length one dimension" begin
    da2 = DimArray((1:4) * (1:2:8)', (X, Y))
    @test (@inferred da2 .* da2[:, 1:1]) == [1, 4, 9, 16] * (1:2:8)'
    @test (@inferred da2[:, 1:1] .* da2) == [1, 4, 9, 16] * (1:2:8)'
end

@testset "JLArray broadcast over length one dimension" begin
    da2 = DimArray(JLArray((1:4) * (1:2:8)'), (X, Y))
    @test Array(da2 .* da2[:, 1:1]) == [1, 4, 9, 16] * (1:2:8)'
end

@testset "in place" begin
    @test parent(copy(da) .= 1 .* da .+ 7) == 8 * ones(3)
    @test (@inferred dims(copy(da .= 1 .* da .+ 7))) == dims(da)
end

@testset "JLArray in place" begin
    @test Array(parent(dajl .= 1 .* dajl .+ 7)) == 8 * ones(3)
    @test dims(dajl .= 1 .* dajl .+ 7) == dims(da)
end

@testset "Dimension disagreement" begin
    @test_throws DimensionMismatch zeros(X(3), Y(3), Z(3)) .+ ones(Y(3), Z(3), X(3))
    @test_throws DimensionMismatch zeros(X(3), Y(3), Z(3)) .+ ones(X(3), Z(3))
end

@testset "Lookup promotion" begin
    @testset "NoLookup resolves conflicts" begin
        @test isnolookup(zeros(X([:a, :b, :c]), Y(1.0:2.0:10.0)) .* zeros(X(3), Y(5)))
        @test_throws DimensionMismatch zeros(X(1.0:3.0), Y('a':'e')) .* zeros(X(3), Y(DateTime.(2001:2005)))
    end
    # TODO test the rest
    @testset "Categorical" begin
        @test_throws DimensionMismatch lookup(zeros(X([:a, :b, :c]),) .* zeros(X([:x, :y, :z]),), X)
        ls = (
            Sampled([10, 20, 30]; span=Irregular((nothing, nothing)), sampling=Points(), order=ForwardOrdered()),
            Categorical([:a, :b, :c]; order=ForwardOrdered()), 
            Categorical(["foo", "bar", "foobar"]; order=Unordered()), 
            Sampled(1.0:1:3.0; span=Regular(1.0), sampling=Points(), order=ForwardOrdered()),
            Sampled(1.0:1:3.0; span=Regular(1.0), sampling=Intervals(Start()), order=ForwardOrdered()),
        )
        for l in ls
            @test (@inferred lookup(zeros(X(l),) .* zeros(X(3),), X)) == NoLookup(Base.OneTo(3))
            @test (@inferred lookup(zeros(X(l),) .* zeros(X(1),), X)) == NoLookup(Base.OneTo(3))
            @test (@inferred lookup(zeros(X(l),) .* zeros(X(l),), X)) === l
            @test (@inferred lookup(zeros(X(l[1:1]),) .* zeros(X(l),), X)) == l
            @test (@inferred lookup(zeros(X(l),) .* zeros(X(l[1:1]),), X)) == l
        end
        @testset "Lookup types are promoted" begin
            a = zeros(Y((Int8(1):Int8(2):Int8(9)))) 
            b = zeros(Y(1:2:9))
            c = @inferred a .+ b
            @test lookup(c) === lookup(b)
            a = zeros(Y(LinRange(1.0, 10.0, 10)))
            b = zeros(Y(1:1:10))
            c = @inferred a .+ b
            @test lookup(c) === lookup(a)
            a = zeros(Y((Float16(1):Float16(2):Float16(9)))) 
            b = zeros(Y(1:2:9))
            c = @inferred a .+ b
            @test lookup(c) === lookup(a)
            a = zeros(Y(DateTime(2000):Year(1):DateTime(2003)))
            b = zeros(Y(Date(2000):Year(1):Date(2003)))
            c = @inferred a .+ b
            @test lookup(c) === lookup(a)
        end
    end
end

@testset "JLArray Dimension disagreement" begin
    @test_throws DimensionMismatch begin
        DimArray(JLArray(zeros(3, 3, 3)), (X, Y, Z)) .+
        DimArray(JLArray(ones(3, 3, 3)), (Y, Z, X))
    end
end

@testset "dims and regular" begin
    da = DimArray(ones(3, 3, 3), (X, Y, Z))
    left_sum = da .+ ones(3, 3, 3)
    @test left_sum == fill(2, 3, 3, 3)
    @test dims(left_sum) == dims(da)
    right_sum = ones(3, 3, 3) .+ da
    @test right_sum == fill(2, 3, 3, 3)
    @test dims(right_sum) == dims(da)
end

@testset "JLArray dims and regular" begin
    da = DimArray(JLArray(ones(3, 3, 3)), (X, Y, Z))
    left_sum = da .+ ones(3, 3, 3)
    @test Array(left_sum) == fill(2, 3, 3, 3)
    @test dims(left_sum) == dims(da)
    right_sum = ones(3, 3, 3) .+ da
    @test Array(right_sum) == fill(2, 3, 3, 3)
    @test dims(right_sum) == dims(da)
end

@testset "changing type" begin
    @test (da .> 0) isa DimArray
    @test (da .* da .> 0) isa DimArray
    @test (da  .> 0 .> rand(3)) isa DimArray
    @test (da .* rand(3) .> 0.0) isa DimArray
    @test (0 .> da .> 0 .> rand(3)) isa DimArray
    @test (rand(3) .> da  .> 0 .* rand(3)) isa DimArray
    @test (rand(3) .> 1 .> 0 .* da) isa DimArray
end

@testset "JLArray changing type" begin
    @test (dajl .> 0) isa DimArray
    @test (dajl .* dajl .> 0) isa DimArray
    @test (dajl  .> 0 .> rand(3)) isa DimArray
    @test (dajl .* rand(3) .> 0.0) isa DimArray
    @test (0 .> dajl .> 0 .> rand(3)) isa DimArray
    @test (rand(3) .> dajl  .> 0 .* rand(3)) isa DimArray
    @test (rand(3) .> 1 .> 0 .* dajl) isa DimArray
end

@testset "trailing dimensions" begin
    a = @inferred zeros(X(10), Y(5)) .* zeros(X(10), Y(1))
    b = @inferred zeros(X(10), Y(5)) .* zeros(X(1), Y(1))
    c = @inferred zeros(X(1), Y(1)) .* zeros(X(10), Y(5))
    d = @inferred zeros(X(10), Y(5)) .* zeros(X(1), Y(5))
    e = @inferred zeros(X(10), Y(1)) .* zeros(X(1), Y(5))
    f = @inferred zeros(X(10), Y(5)) .* zeros(X(1))
    g = @inferred zeros(X(1), Y(5)) .* zeros(X(10))
    @test a == b == c == d == e == f == g
end

@testset "mixed order fails" begin
    @test_throws DimensionMismatch zeros(X(1:3), Y(5)) .* zeros(X(3:-1:1), Y(5))
    @test_throws DimensionMismatch zeros(X([1, 3, 2]), Y(5)) .* zeros(X(3:-1:1), Y(5))
end

@testset "broadcasting" begin
    v = DimArray(zeros(3,), X)
    m = DimArray(ones(3, 3), (X, Y))
    s = 0
    @test v .+ m == ones(3, 3) == m .+ v
    @test s .+ m == ones(3, 3) == m .+ s
    @test s .+ v .+ m == ones(3, 3) == m .+ s .+ v
    @test dims(v .+ m) == dims(m .+ v)
    @test dims(s .+ m) == dims(m .+ s)
    @test dims(s .+ v .+ m) == dims(m .+ s .+ v)
end

@testset "JLArray broadcasting" begin
    v = DimArray(JLArray(zeros(3,)), X)
    m = DimArray(JLArray(ones(3, 3)), (X, Y))
    s = 0
    @test Array(v .+ m) == ones(3, 3) == Array(m .+ v)
    @test Array(s .+ m) == ones(3, 3) == Array(m .+ s)
    @test Array(s .+ v .+ m) == ones(3, 3) == Array(m .+ s .+ v)
    @test dims(v .+ m) == dims(m .+ v)
    @test dims(s .+ m) == dims(m .+ s)
    @test dims(s .+ v .+ m) == dims(m .+ s .+ v)
end

@testset "adjoint broadcasting" begin
    a = DimArray(reshape(1:12, (4, 3)), (X, Y))
    b = DimArray(1:3, Y)
    @test_throws DimensionMismatch a .* b
    @test_throws DimensionMismatch parent(a) .* parent(b)
    @test parent(a) .* parent(b)' == parent(a .* b')
    @test dims(a .* b') == dims(a)
end

@testset "JLArray adjoint broadcasting" begin
    a = DimArray(JLArray(reshape(1:12, (4, 3))), (X, Y))
    b = DimArray(JLArray(1:3), Y)
    @test_throws DimensionMismatch a .* b
    @test_throws DimensionMismatch parent(a) .* parent(b)
    @test_nowarn Array(parent(a) .* parent(b)') == Array(parent(a .* b'))
    @test_nowarn dims(a .* b') == dims(a)
end


@testset "Mixed array types" begin
    casts = (
        A -> DimArray(A, (X, Y)),  # Named Matrix
        A -> DimArray(A[:, 1], X),  # Named Vector
        A -> DimArray(A[:, 1:1], (X, Y)),  # Named Single Column Matrix
        identity, # Matrix
        A -> A[:, 1], # Vector
        A -> A[:, 1:1], # Single Column Matrix
        first, # Scalar
     )
    for (T1, T2, T3) in Iterators.product(casts, casts, casts)
        all(isequal(identity), (T1, T2, T3)) && continue
        !any(isequal(DimArray), (T1, T2, T3)) && continue
        total = T1(ones(3, 6)) .+ T2(2ones(3, 6)) .+ T3(3ones(3, 6))
        @test total == 6ones(3, 6)
        @test dims(total) == (X(), Y())
    end
end

@testset "in-place assignment .=" begin
    ab = DimArray(rand(2,2), (X, Y))
    ba = DimArray(rand(2,2), (Y, X))
    ac = DimArray(rand(2,2), (X, Z))
    a_ = DimArray(rand(2,2), (X(), DimensionalData.AnonDim()))
    z = zeros(2, 2)

    @test_throws DimensionMismatch z .= ab .+ ba
    @test_throws DimensionMismatch z .= ab .+ ac
    # Maybe this should work...
    # @test_throws DimensionMismatch a_ .= ab .+ ac
    @test_throws DimensionMismatch ab .= a_ .+ ac
    @test_throws DimensionMismatch ac .= ab .+ ba

    # check that dest is written into:
    z .= ab .+ ba'
    @test z == (ab.data .+ ba.data')
end

@testset "JLArray in-place assignment .=" begin
    ab = DimArray(JLArray(rand(2,2)), (X, Y))
    ba = DimArray(JLArray(rand(2,2)), (Y, X))
    ac = DimArray(JLArray(rand(2,2)), (X, Z))
    a_ = DimArray(JLArray(rand(2,2)), (X(), DimensionalData.AnonDim()))
    z = JLArray(zeros(2,2))

    @test_throws DimensionMismatch z .= ab .+ ba
    @test_throws DimensionMismatch z .= ab .+ ac
    @test_throws DimensionMismatch a_ .= ab .+ ac
    @test_throws DimensionMismatch ab .= a_ .+ ac
    @test_throws DimensionMismatch ac .= ab .+ ba

    # check that dest is written into:
    z .= ab .+ ba'
    @test z == (ab.data .+ ba.data')
    @test z == (ab.data .+ ba.data')
end

@testset "assign using named indexing and dotview" begin
    A = DimArray(zeros(3,2), (X, Y))
    A[X=1:2] .= [1, 2]
    A[X=3] .= 7
    @test A == [1.0 1.0; 2.0 2.0; 7.0 7.0]
end

@testset "JLArray assign using named indexing and dotview" begin
    A = DimArray(JLArray(zeros(3,2)), (X, Y))
    A[X=1:2] .= JLArray([1, 2])
    A[X=3] .= 7
    @test Array(A) == [1.0 1.0; 2.0 2.0; 7.0 7.0]
end

@testset "0-dimensional array broadcasting" begin
    x = DimArray(fill(3), ())
    y = DimArray(fill(4), ())
    z = fill(3)
    @test @inferred(x .- y) === -1
    @test !(x ≈ y)
    @test x ≈ x
    @test @inferred(x .+ z) === 6
    @test @inferred(z .+ x) === 6
end

@testset "DimIndices broadcasting" begin
    ds = X(1.0:0.2:2.0), Y(10:2:20)
    A = rand(ds)
    B = zeros(ds)
    C = zeros(ds)
    B[DimIndices(B)] .+= A
    C[DimSelectors(C)] .+= A
    @test A == B == C
    sub = A[1:4, 1:3]
    B .= 0
    C .= 0
    B[DimIndices(sub)] .+= sub
    C[DimSelectors(sub)] .+= sub
    @test A[DimIndices(sub)] == B[DimIndices(sub)] == C[DimIndices(sub)]
    sub = A[2:4, 2:5]
    C .= 0
    C[DimSelectors(sub)] .+= sub
    @test A[DimSelectors(sub)] == C[DimSelectors(sub)]
end

@testset "JLArray DimIndices broadcasting" begin
    ds = X(1.0:0.2:2.0), Y(10:2:20)
    _A = (rand(ds))
    _B = (zeros(ds))
    _C = (zeros(ds))

    A = rebuild(_A, JLArray(parent(_A)))
    B = rebuild(_B, JLArray(parent(_B)))
    C = rebuild(_C, JLArray(parent(_C)))

    B[DimIndices(B)] .+= A
    C[DimSelectors(C)] .+= A
    @test Array(A) == Array(B) == Array(C)
    sub = A[1:4, 1:3]
    B .= 0
    C .= 0
    B[DimIndices(sub)] .+= sub
    C[DimSelectors(sub)] .+= sub
    @test Array(A[DimIndices(sub)]) == Array(B[DimIndices(sub)]) == Array(C[DimIndices(sub)])
    sub = A[2:4, 2:5]
    C .= 0
    C[DimSelectors(sub)] .+= sub
    @test Array(A[DimSelectors(sub)]) == Array(C[DimSelectors(sub)])
end

@testset "@d macro" begin
    f(x, y) = x * y
    p(da1, da2, da3) = @d da3 .* f.(da2, da1) .* f.(da1 ./ 1, da2) (dims=(X(), Y(), Z()), name=:test, metadata=Dict(:a => 1))

    da1 = ones(X(3))
    da2 = fill(2, X(3), Y(4))
    da2a = fill(2, Y(4), X(3))
    da3 = fill(3, Y(4), Z(5), X(3))

    # # Shape and permutaton do not matter
    @test p(da1, da2, da3) == 
        p(da1, permutedims(da2, (Y, X)), da3)
        p(da1, da2, permutedims(da3, (X, Y, Z)))
    @test name(p(da1, da2, da3)) == :test
    @test metadata(p(da1, da2, da3)) == Dict(:a => 1)

    @test (@d da2) === da2
    @test (@d da1 .* da2) == parent(da1) .* parent(da2)
    @test (@d da1 .* da2a) == parent(da1) .* permutedims(parent(da2a))
    @test (@d f.(da1, da2)) == f.(parent(da1), parent(da2))
    @test (@d f.(da1, da2a)) == f.(parent(da1), permutedims(parent(da2a)))
    @test (@d 0 .+ f.(da2, da1) .* f.(da1 ./ 1, da2a)) == 0 .+ f.(parent(da2), parent(da1)) .* f.(parent(da1) ./ 1, permutedims(parent(da2a)))
    @test (@d da3 .+ f.(da2, da1) .* f.(da1 ./ 1, da2a) dims=(X, Y, Z)) ==
        parent(permutedims(da3, (X, Y, Z))) .+ f.(parent(da2), parent(da1)) .* f.(parent(da1) ./ 1, parent(permutedims(da2a)))
    @test (@d da3 .+ f.(da2, da1) .* f.(da1 ./ 1, da2a)) ==
        permutedims(parent(permutedims(da3, (X, Y, Z))) .+ f.(parent(da2), parent(da1)) .* f.(parent(da1) ./ 1, parent(permutedims(da2a))), [2, 3, 1])

    @test_throws ArgumentError xy = @d da3 .+ f.(da2, da1) .* f.(da1 ./ 1, da2a) dims=(X, Y)
    xyz = @d da3 .* f.(da2, da1) .* f.(da1 ./ 1, da2a) (; dims=(X, Y, Z),)

    @test all(==(12.0), xyz)
    @test DimensionalData.basedims(xyz) == (X(), Y(), Z())
    @test size(xyz) == (3, 4, 5)

    @testset "permuted values give same results" begin
        x, y, z = X(1:3), Y(StepRangeLen(DateTime(2000), Month(2), 7)), Z(5)
        da1 = ones(y) .* (1.0:7.0)
        da2 = fill(2, x, y) .* (1:3)
        da3 = fill(3, y, z, x) .* (1:7)

        @test p(da1, da2, da3) == 
            p(da1, permutedims(da2, (Y, X)), da3)
            p(da1, da2, permutedims(da3, (X, Y, Z)))
    end

    @testset "Lookups are maintained" begin
        x = format(X(-5.0:5.0))
        y = format(Y(-10.0:2:12.0))
        z = format(Z(-3.0:0.5:4.0))

        u = @d x .* y
        v = @d x .* z
        w = @d y .* z

        f(u, v, w) = u + v + w

        A = @d f.(u, v, w)
        @test dims(A) == (x, y, z)
    end

    @testset "strict" begin
        @test_nowarn @d rand(X(1:3)) .* rand(X([:a, :b, :c])) strict=false
        @test_throws DimensionMismatch @d rand(X(1:3)) .* rand(X([:a, :b, :c])) strict=true
        # NoLookup is never a strict comparison
        @test_nowarn @d rand(X(1:3)) .* rand(X(3)) strict=true
        @test_nowarn @d rand(X(1:3)) .* rand(X(3)) strict=false
    end

    @testset "set Dim properties" begin
        @test isnolookup(@d rand(X([:a, :b, :c])) .* rand(X([:a, :b, :c])) dims=(X(NoLookup()),))
        @test issampled(@d rand(X([:a, :b, :c])) .* rand(X([:a, :b, :c])) dims=(X(Sampled(1:3)),))
    end

    @testset "With @. macro" begin
        @test (@d (@. da1 * da3 + 1)) == (@d da1 .* da3 .+ 1)
        @test name(@d (@. da1 * da3 + 1) name=:test) == :test
    end

    @testset "Dimension" begin
        @test (@d X(1:3) .* X(10:10:30) strict=false) == [10, 40, 90]
        da = @d string.(X(10:10:30), Y([:a, :b, :c]), Z(1:2:5))
        @test da == (xs -> string(xs...)).(DimPoints((X(10:10:30), Y([:a, :b, :c]), Z(1:2:5))))
    end

    @testset "stack fields" begin
        xs = 1.0:10.0
        v1 = DimVector(identity, X(xs); name=:v1)
        v2 = DimVector(x -> 2x, X(xs); name=:v2)
        ds = DimStack(v1)
        @test (@d v1 .* v2) == (@d ds.v1 .* v2)
    end

    @testset "numbers etc" begin
        dv = DimArray(identity, X(1.0:10.0); name=:x)
        @test (@d dv .* 2) == (dv .* 2) 
    end

    @testset "keywords" begin
        f1(a; b=1) = a * b
        z = Z(1:10)
        @test f1.(z; b = 2) == @d f1.(z; b = 2)
    end

    @testset "strict=false in assignment" begin
        dv1 = rand(X(1:3))
        dv2 = rand(X(2:4))
        dv3 = rand(X(7:9))
        @test_throws DimensionMismatch dv1 .= dv2 .* dv3
        @d dv1 .= dv2 strict = false
        @test dv1 == parent(dv2)
        @d dv1 .= dv2 .* dv3 strict=false
        @test dv1 == parent(dv2) .* parent(dv3)
    end

    @testset "single arg" begin
        a = 3
        @d max.(1)
    end

    @testset "dot infix assignment" begin
        x, y, t = X(1:100), Y(1:25), Ti(DateTime(2000):Month(1):DateTime(2000, 12))
        A = rand(x, y, t)
        B = A[At(50), :, :]
        C = copy(A)
        @d A .-= B
        @test A == @d C .- B
        @d A .+= B
        @test A == C
    end
end

@testset "Concise error messages for dimension mismatches" begin
    # Test that dimension mismatch errors are concise, not verbose
    x = DimArray(ones(1000), X(1:2:2000))
    y1 = DimArray(ones(1001), X(1:2:2001))
    y2 = DimArray(ones(1000), X(2:1001))

    for y in (y1, y2)
        err = nothing
        try
            x .+ y
        catch e
            err = e
        end

        @test err isa DimensionMismatch
        @test length(string(err)) < 250
    end
end

@testset "broadcast over DimStack returns DimArray" begin
    # 1D case: broadcasting `first` over a stack should return the first layer
    da1 = DimArray([1, 2, 3], X(1:3); name=:a)
    da2 = DimArray([10, 20, 30], X(1:3); name=:b)
    s = DimStack((da1, da2))
    res = first.(s)
    res2 = getfield.(s, :a)
    @test res isa DimArray
    @test res2 isa DimArray
    @test res == res2 == da1
end

# @testset "Competing Wrappers" begin
#     da = DimArray(ones(4), X)
#     ta = TrackedArray(5 * ones(4))
#     dt = DimArray(TrackedArray(5 * ones(4)), X)
#     arrays = (da, ta, dt)
#     @testset "$a .- $b" 
#     for (a, b) in Iterators.product(arrays, arrays)
#         a === b && continue
#         @test typeof(da .- ta) <: DimArray
#         @test typeof(parent(da .- ta)) <: TrackedArray
#     end
# end

import Base.Broadcast: BroadcastStyle, DefaultArrayStyle, Style, AbstractArrayStyle, Unknown

const STRICT_BROADCAST_CHECKS = Ref(true)
const STRICT_BROADCAST_DOCS = """
With `strict=true` we check [`Lookup`](@ref) [`Order`](@ref) and values 
before brodcasting, to ensure that dimensions match closely. 

An exception to this rule is when dimension are of length one, 
as these is ignored in broadcasts.

We always check that dimension names match in broadcasts.
If you don't want this either, explicitly use `parent(A)` before
broadcasting to remove the `AbstractDimArray` wrapper completely.
"""

"""
    strict_broadcast()

Check if strict broadcasting checks are active.

$STRICT_BROADCAST_DOCS
"""
strict_broadcast() = STRICT_BROADCAST_CHECKS[]

"""
    strict_broadcast!(x::Bool)

Set global broadcasting checks to `strict`, or not for all `AbstractDimArray`.

$STRICT_BROADCAST_DOCS
"""
strict_broadcast!(x::Bool) = STRICT_BROADCAST_CHECKS[] = x

# This is a `BroadcastStyle` for AbstractAbstractDimArray's
# It preserves the dimension names.
# `S` should be the `BroadcastStyle` of the wrapped type.
# Copied from NamedDims.jl (thanks @oxinabox).
struct DimensionalStyle{S <: AbstractArrayStyle, N} <: AbstractArrayStyle{N} end
DimensionalStyle(::S) where S<:AbstractArrayStyle{N} where N = DimensionalStyle{S, N}()
DimensionalStyle(::S) where {S<:DimensionalStyle} = S() # avoid nested dimensionalstyle
DimensionalStyle(::S, ::Val{N}) where {S,N} = DimensionalStyle(S(Val(N)))
DimensionalStyle(::Val{N}) where N = DimensionalStyle{DefaultArrayStyle{N}}()
function DimensionalStyle(a::BroadcastStyle, b::BroadcastStyle)
    inner_style = BroadcastStyle(a, b)
    # if the inner style is Unknown then so is the outer style
    if inner_style isa Unknown
        return Unknown()
    else
        return DimensionalStyle(inner_style)
    end
end

BroadcastStyle(::Type{<:AbstractDimArray{T,N,D,A}}) where {T,N,D,A} =
    DimensionalStyle(BroadcastStyle(A))
BroadcastStyle(::Type{<:AbstractBasicDimArray{T,N,D}}) where {T,N,D} =
    DimensionalStyle(DefaultArrayStyle{N}())
BroadcastStyle(::DimensionalStyle, ::Base.Broadcast.Unknown) = Unknown()
BroadcastStyle(::DimensionalStyle{A}, ::DimensionalStyle{B}) where {A, B} = DimensionalStyle(A(), B())
BroadcastStyle(::DimensionalStyle{A}, b::AbstractArrayStyle{N}) where {A,N} = DimensionalStyle(A(), b)
BroadcastStyle(::DimensionalStyle{A}, b::DefaultArrayStyle{N}) where {A,N} = DimensionalStyle(A(), b) # ambiguity
BroadcastStyle(::DimensionalStyle{A}, b::Style{Tuple}) where {A} = DimensionalStyle(A(), b)

# override base instantiate to check dimensions as well as axes
@inline function Broadcast.instantiate(bc::Broadcasted{<:DimensionalStyle{S}}) where S
    A = _firstdimarray(bc)
    # check if there is any DimArray and unwrap immediately if no
    isnothing(A) && return Broadcast.instantiate(_unwrap_broadcasted(bc))
    bdims = _broadcasted_dims(bc)
    if bc.axes isa Nothing
        axes = Base.Broadcast.combine_axes(_unwrap_broadcasted(bc).args...)
        ds = Dimensions.promotedims(bdims...; skip_length_one=true)
        length(axes) == length(ds) || 
            throw(ArgumentError("Number of broadcasted dimensions $(length(axes)) larger than $(ds)"))
        axes = map(Dimensions.DimUnitRange, axes, ds)
    else # bc already has axes which might have dimensions, e.g. when assigning to a DimArray
        axes = bc.axes
        Base.Broadcast.check_broadcast_axes(axes, bc.args...)
        ds = dims(axes)
        isnothing(ds) || _comparedims_broadcast(A, ds, bdims...)
    end
    _comparedims_broadcast(A, bdims...)
    return Broadcasted(bc.style, bc.f, bc.args, axes)
end
# Define copy because the inner style S might override copy (e.g. DiskArrays)
function Base.copy(bc::Broadcasted{<:DimensionalStyle{S}}) where S
    data = copy(_unwrap_broadcasted(bc))
    data isa AbstractArray || return data # in the 0-d case data can be a scalar
    # let similar do the work - it will usually call rebuild unless A isa AbstractBasicDimArray
    A = _firstdimarray(bc)
    similar(A; data, dims = dims(axes(bc)))
end
# similar is usually only called in broadcast_preserving_zero_d
function Base.similar(bc::Broadcasted{<:DimensionalStyle{S}}, ::Type{T}) where {S,T}
    A = _firstdimarray(bc)
    data = similar(_unwrap_broadcasted(bc), T)
    similar(A; data, dims = dims(axes(bc)))
end

@inline function Base.materialize!(::DimensionalStyle, dest, bc::Broadcasted)
    # check dimensions
    bci = Broadcast.instantiate(Broadcasted(bc.style, bc.f, bc.args, axes(dest)))
    # unwrap before copying
    Base.copyto!(_unwrap_broadcasted(dest), _unwrap_broadcasted(bci))
    return dest
end

"""
    @d broadcast_expression options

Dimensional broadcast macro extending Base Julia
broadcasting to work with missing and permuted dimensions.

Will permute and reshape singleton dimensions
so that all [`AbstractDimArray`](@ref) in a broadcast will
broadcast over matching dimensions.

It is possible to pass options as the second argument of 
the macro to control the behaviour, as a single assignment
or as a NamedTuple. Options names must be written explicitly,
not passed in namedtuple variable.

# Options

- `dims`: Pass a Tuple of `Dimension`s, `Dimension` types or `Symbol`s
    to fix the dimension order of the output array. Otherwise dimensions
    will be in order of appearance. If dims with lookups are passed, these will 
    be applied to the returned array with  `set`.
- `strict`: `true` or `false`. Check that all lookup values match explicitly.

All other keywords are passed to `DimensionalData.rebuild`. This means
`name`, `metadata`, etc for the returned array can be set here, 
or for example `missingval` in Rasters.jl.

# Example

```julia
using DimensionalData
da1 = ones(X(3))
da2 = fill(2, Y(4), X(3))

@d da1 .* da2
@d da1 .* da2 .+ 5 dims=(Y, X)
@d da1 .* da2 .+ 5 (dims=(Y, X), strict=false, name=:testname)
```

## Use with `@.`

`@d` does not imply `@.`. You need to specify each broadcast. 
But `@.` can be used with `@d` as the _inner_ macro.

```julia
using DimensionalData
da1 = ones(X(3))
da2 = fill(2, Y(4), X(3))

@d @. da1 * da2
# Use parentheses around `@.` if you need to pass options
@d (@. da1 * da2 .+ 5) dims=(Y, X)
```

"""
macro d(expr::Expr, options::Union{Expr,Nothing}=nothing)
    options_dict, options_expr = _process_d_macro_options(options)
    broadcast_expr, var_list = _find_broadcast_vars(expr)
    var_list_assignments = map(var_list) do (name, expr)
        Expr(:(=), name, expr)
    end
    vars_expr = esc(Expr(:tuple, map(first, var_list)...))
    var_list_expr = esc(Expr(:block, var_list_assignments...))
    dims_expr = if haskey(options_dict, :dims)
        order_dims = options_dict[:dims]
        quote
            order_dims = $order_dims
            found_dims = _find_dims(vars)
            all(hasdim(order_dims, found_dims)) || 
                throw(ArgumentError("order $(basedims(order_dims)) dont match dimensions found in arrays $(basedims(found_dims))"))
            dims = $DimensionalData.dims(found_dims, order_dims)
        end
    else
        quote
            dims = _find_dims(vars)
        end
    end
    quote
        let
            options = $options_expr
            $var_list_expr
            vars = $vars_expr
            $dims_expr
            $broadcast_expr
        end
    end
end
macro d(sym::Symbol, options::Union{Expr,Nothing}=nothing)
    esc(sym)
end

# Process the options named tuple passed to the @d macro
# returning a Dict of options, and an expression that makes
# a NamedTuple of options
_process_d_macro_options(::Nothing) = Dict{Symbol,Any}(), :(nothing)
function _process_d_macro_options(options::Expr)
    options_dict = Dict{Symbol,Any}()
    if options.head == :tuple
        if options.args[1].head == :parameters
            # Keyword syntax `(; dims=..., strict=false)
            for arg in options.args[1].args
                arg.head == :kw || throw(ArgumentError("Malformed options in $options"))
                options_dict[arg.args[1]] = esc(arg.args[2])
            end
        else
            # Tuple syntax `(dims=..., strict=false)`
            for arg in options.args
                arg.head == :(=) || throw(ArgumentError("Malformed options in $options"))
                options_dict[arg.args[1]] = esc(arg.args[2])
            end
        end
    elseif options.head == :(=)
        # Single assignment `strict=false`
        options_dict[options.args[1]] = esc(options.args[2])
    end

    options_params = Expr(:parameters)
    for (k, v) in options_dict
        push!(options_params.args, Expr(:kw, k, v))
    end
    options_expr = Expr(:tuple, options_params) 

    return options_dict, options_expr
end

# Handle existing variable names
_find_broadcast_vars(sym::Symbol)::Tuple{Expr,Vector{Pair{Symbol,Any}}} = 
    esc(sym), Pair{Symbol,Any}[]
# Handle e.g. 1 in the expression
function _find_broadcast_vars(x)::Tuple{Expr,Vector{Pair{Symbol,Any}}}
    var = Symbol(gensym(), :_d)
    esc(var), Pair{Symbol,Any}[var => x]
end
# Walk the broadcast expression, finding broadcast arguments and 
# pulling them out of the main broadcast into separate variables. 
# This lets us get `dims` from all of them and use it to reshape 
# and permute them so they all match.
function _find_broadcast_vars(expr::Expr)::Tuple{Expr,Vector{Pair{Symbol,Any}}}
    # Integrate with dot macro
    if expr.head == :macrocall && expr.args[1] == Symbol("@__dot__")
        return _find_broadcast_vars(Base.Broadcast.__dot__(expr.args[3]))
    end
    mdb = :($DimensionalData._maybe_dimensional_broadcast)
    arg_list = Pair{Symbol,Any}[]

    # Dot broadcast syntax `f.(x)`
    if expr.head == :. && !(expr.args[2] isa QuoteNode) # function dot broadcast
        mdb_args = map(expr.args[2].args) do arg
            if arg isa Expr && arg.head == :parameters
                arg
            else
                var = Symbol(gensym(), :_d)
                expr1, arg_list1 = _find_broadcast_vars(arg)
                out = if isempty(arg_list1)
                    push!(arg_list, var => arg)
                    esc(var)
                else
                    append!(arg_list, arg_list1)
                    expr1
                end
                Expr(:call, mdb, out, :dims, :options)
            end
        end
        expr2 = Expr(expr.head, esc(expr.args[1]), Expr(:tuple, mdb_args...))
        return expr2, arg_list
    # Dot assignment broadcast syntax `x .= ...`
    elseif !isnothing(match(r"\..*=", string(expr.head)))
        # Destination array
        dest_var = Symbol(gensym(), :_d)
        push!(arg_list, dest_var => expr.args[1])
        mdb_dest_expr = Expr(:call, mdb, esc(dest_var), :dims, :options)
        # Source expression
        expr2, arg_list2 = _find_broadcast_vars(expr.args[2])
        source_expr = if isempty(arg_list2)
            var2 = Symbol(gensym(), :_d)
            push!(arg_list, var2 => expr.args[2])
            esc(var2)
        else
            append!(arg_list, arg_list2)
            expr2
        end
        mbd_source_expr = Expr(:call, mdb, source_expr, :dims, :options)
        return Expr(expr.head, mdb_dest_expr, mbd_source_expr), arg_list
    # Infix broadcast syntax `x .* y`
    elseif expr.head == :call && string(expr.args[1])[1] == '.'
        mdb_args = map(expr.args[2:end]) do arg
            var = Symbol(gensym(), :_d)
            expr1, arg_list1 = _find_broadcast_vars(arg)
            out = if isempty(arg_list1)
                push!(arg_list, var => arg)
                esc(var)
            else
                append!(arg_list, arg_list1)
                expr1
            end
            Expr(:call, mdb, out, :dims, :options)
        end
        expr2 = Expr(expr.head, expr.args[1], mdb_args...)
        return expr2, arg_list
    else # Not part of the broadcast, just return it
        expr2 = esc(expr)
        return expr2, arg_list
    end
end

# A wrapper AbstractDimArray only to be used in @d broadcasts. 
# It should never escape
# options are both for broadcast tweaks and for keywords to the new DimArray
struct BroadcastOptionsDimArray{T,N,D<:Tuple,A<:AbstractBasicDimArray{T,N,D},O} <: AbstractDimArray{T,N,D,A}
    data::A
    options::O
    function BroadcastOptionsDimArray(
        data::A, options::O
    ) where {A<:AbstractDimArray{T,N,D},O} where {T,N,D}
        new{T,N,D,A,O}(data, options)
    end
end

# Get keywords from options
_rebuild_kw(A::BroadcastOptionsDimArray) = _rebuild_kw(; broadcast_options(A)...)
_rebuild_kw(; dims=nothing, strict=nothing, kw...) = kw

# Forward DD methods to the parent array
dims(A::BroadcastOptionsDimArray) = dims(parent(A))
refdims(A::BroadcastOptionsDimArray) = refdims(parent(A))
name(A::BroadcastOptionsDimArray) = name(parent(A))
metadata(A::BroadcastOptionsDimArray) = metadata(parent(A))

# Rebuild returns the parent AbstractDimArray rebuilt with options keywords. 
# Dimensions are updated with `set` if there is a dims keyword
function rebuild(A::BroadcastOptionsDimArray; kw...) 
    A1 = rebuild(parent(A); kw..., _rebuild_kw(A)...) 
    D = get(broadcast_options(A), :dims, nothing)
    if D isa DimTuple 
        return set(A1, broadcast_options(A).dims...)
    else
        return A1
    end
end
rebuild(A::BroadcastOptionsDimArray, args...) = rebuild(parent(A), args...) 
@inline function rebuild(
    A::BroadcastOptionsDimArray, data, dims::Tuple=dims(A), refdims=refdims(A), name=name(A), metadata=metadata(A),
)
    rebuild(A; data, dims, refdims, name, metadata, _rebuild_kw(A)...)
end

# Get the options NamedTuple from BroadcastOptionsDimArray
broadcast_options(_) = NamedTuple()
broadcast_options(A::BroadcastOptionsDimArray) = A.options



# Utils

# Run comparedims with settings depending on stictness
@inline function _comparedims_broadcast(A, dims...)
    isstrict = _is_strict(A)
    comparedims(dims...; 
        ignore_length_one=isstrict, order=isstrict, val=isstrict, length=false
    )
end

# Check if a broadcast is strict, or use the global setting
_is_strict(A::AbstractArray) = _is_strict(broadcast_options(A))
function _is_strict(options::NamedTuple) 
    if haskey(options, :strict)
        options[:strict]
    else
        strict_broadcast()
    end
end

# Recursively unwraps `AbstractDimArray`s and `DimensionalStyle`s.
# replacing the `AbstractDimArray`s with the wrapped array,
# and `DimensionalStyle` with the wrapped `BroadcastStyle`.

function _unwrap_broadcasted(bc::Broadcasted{<:DimensionalStyle{S}}) where {S}
    innerargs = map(_unwrap_broadcasted, bc.args)
    return Broadcasted{S}(bc.f, innerargs, _unwrap_broadcasted(bc.axes))
end
_unwrap_broadcasted(x) = x
_unwrap_broadcasted(nda::AbstractDimArray) = parent(nda)
_unwrap_broadcasted(bda::AbstractBasicDimArray) = OpaqueArray(bda)
_unwrap_broadcasted(boda::BroadcastOptionsDimArray) = _unwrap_broadcasted(parent(boda))
_unwrap_broadcasted(t::Tuple) = map(_unwrap_broadcasted, t)
_unwrap_broadcasted(du::Dimensions.DimUnitRange) = parent(du)
# Get the first dimensional array in the broadcast
_firstdimarray(x::Broadcasted) = _firstdimarray(x.args)
function _firstdimarray(x::Tuple)
    found = _firstdimarray(x[1])
    if found isa Nothing
        _firstdimarray(tail(x))
    else
        found
    end
end
_firstdimarray(x::Tuple{}) = nothing
_firstdimarray(ext::Base.Broadcast.Extruded) = _firstdimarray(ext.x)
_firstdimarray(x::AbstractBasicDimArray) = x
_firstdimarray(x) = nothing

# Make sure all arrays have the same dims, and return them
_broadcasted_dims(bc::Broadcasted) = _broadcasted_dims(bc.args...)
_broadcasted_dims(a, bs...) = (_broadcasted_dims(a)..., _broadcasted_dims(bs...)...)
_broadcasted_dims(a::AbstractBasicDimArray) = (dims(a),)
_broadcasted_dims(a) = ()

# If an object is an AbstractBasicDimArray or a Dimension, reshape and permute 
# its dimensions to match the rest of the @d broadcast, otherwise do nothing.
_maybe_dimensional_broadcast(x, _, _) = x
function _maybe_dimensional_broadcast(A::AbstractBasicDimArray, dest_dims, options) 
    # Reshape first to avoid a ReshapedArray wrapper if possible
    A1 = _maybe_insert_length_one_dims(A, dest_dims)
    # Then permute and reorder
    A2 = _maybe_lazy_permute(A1, dest_dims)
    # Then rebuild with the new data and dims
    data = parent(A2)
    A3 = rebuild(A; data, dims=format(dims(A2), data))
    if isnothing(options)
        return A3
    else
        return BroadcastOptionsDimArray(A3, options)
    end
end
_maybe_dimensional_broadcast(d::Dimension, dims, options) = 
    _maybe_dimensional_broadcast(DimArray(parent(d), d), dims, options)

# Permute lazily if we need to
function _maybe_lazy_permute(A::AbstractBasicDimArray, dest)
    if dimsmatch(commondims(dims(A), dims(dest)), commondims(dims(dest), dims(A)))
        A
    else
        PermutedDimsArray(A, commondims(dims(dest), dims(A)))
    end
end

function _maybe_insert_length_one_dims(A::AbstractBasicDimArray, dims)
    if all(hasdim(A, dims)) 
        A 
    else
        _insert_length_one_dims(A, dims)
    end
end
# Insert `Length1NoLookup` and reshape the array where needed so 
# that missing dimensions are not a problem.
function _insert_length_one_dims(A::AbstractBasicDimArray, alldims)
    if basedims(dims(A)) == basedims(dims(A), alldims)
        lengths = map(alldims) do d 
            hasdim(A, d) ? size(A, d) : 1
        end
        newdims = map(alldims) do d 
            hasdim(A, d) ? dims(A, d) : rebuild(d, Lookups.Length1NoLookup())
        end
    else
        odims = otherdims(alldims, DD.dims(A))
        lengths = (size(A)..., map(_ -> 1, odims)...) 
        newdims = (dims(A)..., map(d -> rebuild(d, Lookups.Length1NoLookup()), odims)...)
    end
    newdata = reshape(parent(A), lengths)
    A1 = rebuild(A; data=newdata, dims=format(newdims, newdata))
    return A1
end

# Find dimensions in the list of brodcast arguments
# The returned dimension order is taken from the order dimensions 
# are found, but this algorithm could be improved 
@inline function _find_dims((A, args...)::Tuple{<:AbstractBasicDimArray,Vararg})::DimTupleOrEmpty
    expanded = _find_dims(args)
    if expanded === ()
        dims(A)
    else
        (dims(A)..., otherdims(expanded, dims(A))...)
    end
end
@inline _find_dims((d, args...)::Tuple{<:Dimension,Vararg}) =
    (d, otherdims(_find_dims(args), (d,))...)
@inline _find_dims(::Tuple{}) = ()
@inline _find_dims((_, args...)::Tuple) = _find_dims(args)

using Test
using DimensionalData
using ChainRulesCore

@testset "chainrules.jl" begin

    @testset "ProjectTo" begin
        data = rand(3)
        A = DimArray(data, (:a,); name=:title, refdims=(), metadata=Dict(:info=>"data"))
        p = ProjectTo(A)
        @test p(data) == A

        @test p(NoTangent()) == NoTangent()

        data = rand(3, 4)
        A = DimArray(data, (:a, :b))
        p = ProjectTo(A)
        @test p(data) == A

        @test p(NoTangent()) == NoTangent()
    end

    @testset "parent rrule" begin
        data = rand(3)
        A = DimArray(data, (:a,))
        y, pb = rrule(parent, A)
        @test y === parent(A)
        # raw array tangent
        ȳ = rand(3)
        _, Ā = pb(ȳ)
        @test Ā == DimArray(ȳ, dims(A))
        # DimArray tangent
        ȳ2 = DimArray(rand(3), dims(A))
        _, Ā2 = pb(ȳ2)
        @test Ā2 == DimArray(parent(ȳ2), dims(A))
        # Zero tangent
        _, Āz = pb(NoTangent())
        @test Āz === NoTangent()

        data = rand(3, 4)
        A = DimArray(data, (:a, :b))
        y, pb = rrule(parent, A)
        @test y === parent(A)
        ȳ = rand(3, 4)
        _, Ā = pb(ȳ)
        @test Ā == DimArray(ȳ, dims(A))
        ȳ2 = DimArray(rand(3, 4), dims(A))
        _, Ā2 = pb(ȳ2)
        @test Ā2 == DimArray(parent(ȳ2), dims(A))
        _, Āz = pb(NoTangent())
        @test Āz === NoTangent()
    end
    @testset "getindex rrule with selectors" begin
        A = DimArray(rand(3, 4), (Y([:a, :b, :c]), X(1:4)))
        
        # Test At selector
        y, pb = rrule(getindex, A; Y=At(:b))
        @test size(y) == (4,)  # Only X dimension remains
        
        ȳ = ones(4)
        _, grad = pb(ȳ)
        @test size(grad) == size(A)
        @test all(grad[1, :] .== 0)
        @test all(grad[2, :] .== 1)  # Y=:b 
        @test all(grad[3, :] .== 0)
        
        # Test multiple selectors
        y2, pb2 = rrule(getindex, A; Y=At(:b), X=At(2))
        @test y2 isa Number
        
        ȳ2 = 1.0
        _, grad2 = pb2(ȳ2)
        @test grad2[2, 2] == 1  # Y=:b, X=2
        @test sum(grad2) == 1   # Only one element should be 1
    end

end

using DimensionalData, Test

using DimensionalData.Lookups: Metadata, NoMetadata, units, val

@testset "Metadata" begin
    nt = (a="test1", units="km")
    d = (:a=>"test1", :units=>"km")
    @test val(Metadata(nt)) isa NamedTuple
    @test val(Metadata(d)) isa Dict
    @test val(Metadata()) isa Dict
    @test Metadata(nt) == Metadata(; nt...)
    @test Metadata(d) == Metadata(d...) == Metadata(Dict(d))
    dm = Metadata(d)
    dm[:c] = "added metadata"
    @test dm[:c] == "added metadata"
    @test units(nothing) === nothing
    @test units(NoMetadata()) === nothing

    for md in (Metadata(; nt...), Metadata{:Test}(; nt...), Dict(pairs(nt)))
        @test units(md) == "km"
        @test length(md) == 2
        @test haskey(md, :a)
        @test haskey(md, :c) == false 
        @test get(md, :a, nothing) == "test1" 
        @test md[:a] == "test1" 
        @test md[:units] == "km" 
        if md isa Dict || val(md) isa Dict
            @test [x for x in md] == [:a=>"test1", :units=>"km"]
            @test all(keys(md) .== [:a, :units])
            @test eltype(md) == Pair{Symbol,String}
            @test iterate(md) == (:a => "test1", 2)
            @test iterate(md, 2) == (:units => "km", 3)
        else
            @test [x for x in md] == ["test1", "km"]
            @test keys(md) == (:a, :units)
            @test eltype(md) == String
            @test iterate(md) == ("test1", 2)
            @test iterate(md, 2) == ("km", 3)
        end
        @test iterate(md, 3) == nothing
        @test Base.IteratorSize(md) == Base.HasLength()
        @test Base.IteratorEltype(md) == Base.HasEltype()
    end

    # allow string keys
    @test Metadata("a"=>"test1")["a"] == "test1"

    # Can't mix arguments and keywords
    @test_throws ArgumentError Metadata{:Test}(:a => "1"; units="km")
end

@testset "NoMetadata" begin
    @test val(NoMetadata()) == NamedTuple()
    @test keys(NoMetadata()) == ()
    @test haskey(NoMetadata(), :a) == false
    @test get(NoMetadata(), :a, :x) == :x
    @test length(NoMetadata()) == 0
    @test [x for x in NoMetadata()] == []
end

@testset "metadatadict" begin
    @test DimensionalData.Lookups.metadatadict(Dict("a"=>"A", "b"=>"B")) == Dict(:a=>"A", :b=>"B")
end

abstract type Safety end
struct Safe <: Safety end
struct Unsafe <: Safety end

const LookupSetters = Union{AllMetadata,Lookup,LookupTrait,AbstractArray}

set(x, ::Type{T}) where T = set(x, T())
set(lookup::Lookup, x::LookupSetters) =_set(Safe(), lookup, x)
set(a::LookupTrait, b::LookupTrait) =_set(Safe(), a, b)
set(lookup::Lookup, ::Type{T}) where T =_set(Safe(), lookup, T())

unsafe_set(lookup::Lookup, x::LookupSetters) =_set(Unsafe(), lookup, x)
unsafe_set(a::LookupTrait, b::LookupTrait) =_set(Unsafe(), a, b)
unsafe_set(lookup::Lookup, ::Type{T}) where T =_set(Unsafe(), lookup, T())

# Set with no keywords or arguments does nothing
_set(::Safety, x) = x
_set(s::Safety, lookup::Lookup, newlookup::Lookup) = _set_lookup(s, lookup, newlookup)
_set(s::Safety, lookup::Lookup, newlookup::AbstractArray) = _set_lookup_parent(s, lookup, newlookup)
_set(::Safety, lookup::Lookup, ::AutoValues) = lookup  # AutoValues means keep existing
_set(s::Safety, lookup::Lookup, prop::LookupSetters) = _set_lookup_property(s, lookup, prop)
# Lookup values
_set(::Safety, values::AbstractArray, newvalues::AbstractArray) = newvalues
_set(::Safety, values::AbstractArray, newvalues::Colon) = values
_set(::Safety, values::AbstractArray, ::AutoValues) = values
_set(::Safety, values::Colon, newvalues::AbstractArray) = newvalues
_set(::Safety, values::Colon, newvalues::Colon) = values

_set_lookup(s::Safety, lookup::Lookup, newlookup::AutoLookup) = 
    _set_lookup_parent(s, lookup, parent(newlookup))
_set_lookup(s::Safety, lookup::AbstractCategorical, newlookup::AutoLookup) = begin
    # With autolookup we have to allow for missing fields and detect them
    l1 = _set(Unsafe(), lookup, order(newlookup))
    l2 =_set(Unsafe(), l1, parent(newlookup))
    l3 = _set(s, l2, order(newlookup))
    _set(s, l3, metadata(newlookup))
end
_set_lookup(s::Safety, lookup::AbstractSampled, newlookup::AutoLookup) = begin
    # With autolookup we have to allow for missing fields and detect them
    # First force the new order to avoid unnecessary reordering of arrays
    # Then update lookup values
    lookup1 =_set(s, lookup, parent(newlookup))
    # Then set the order
    lookup2 =_set(s, lookup1, order(newlookup))
    # Then set the span
    lookup3 =_set(s, lookup2, span(newlookup))
    # Then set traits that dont affect each other
    sa =_set(s, sampling(lookup3), sampling(newlookup))
    md =_set(s, metadata(lookup3), metadata(newlookup))
    rebuild(lookup3; sampling=sa, metadata=md)
end
_set_lookup(s::Unsafe, lookup::Lookup, newlookup::AbstractCategorical) = begin
    lookup =_set(s, lookup, parent(newlookup))
    o = _set(s, order(lookup), order(newlookup))
    md = _set(s, metadata(lookup), metadata(newlookup))
    rebuild(newlookup; data=parent(lookup), order=o, metadata=md)
end
_set_lookup(s::Safe, lookup::Lookup, newlookup::AbstractCategorical) = begin
    # We need to handle the new lookup having unfilled auto fields
    o = if order(newlookup) isa AutoOrder
        _detect_order(parent(lookup))
    else
        order(newlookup)
    end
    md = _set(s, metadata(lookup), metadata(newlookup))
    # Rebuild the new lookup with updated values
    rebuild(newlookup; data=parent(lookup), order=o, metadata=md)
end
_set_lookup(s::Unsafe, lookup::Lookup, newlookup::AbstractSampled) = 
   _set_lookup_parent(s, lookup, parent(newlookup))
_set_lookup(s::Safe, lookup::Lookup, newlookup::AbstractSampled) = begin
    # Update each field separately. The old lookup may not have these fields, or may have
    # a subset with the rest being traits. The new lookup may have some auto fields.
    data = _set(s, parent(lookup), parent(newlookup))
    o = if order(newlookup) isa AutoOrder
        # Use existing data for order detection (data may still be AutoValues if unchanged)
        data isa AutoValues ? order(lookup) : _detect_order(data)
    else
        order(newlookup)
    end
    sp = if span(newlookup) isa AutoSpan
        if data isa AutoValues
            span(lookup)
        elseif data isa AbstractRange
            Regular(step(data))
        else
            Irregular(nothing, nothing)
        end
    else
        span(newlookup)
    end
    sa = _set(s, sampling(lookup), sampling(newlookup))
    md = _set(s, metadata(lookup), metadata(newlookup))
    # Rebuild the new lookup with the merged fields
    rebuild(newlookup; data, order=o, span=sp, sampling=sa, metadata=md)
end
_set_lookup(::Safety, lookup::Lookup, newlookup::NoLookup{<:AutoValues}) = NoLookup(axes(lookup, 1))
_set_lookup(::Safety, lookup::Lookup, newlookup::AbstractNoLookup) = newlookup

# Set the lookup values
_set_lookup_parent(::Safety, lookup::AbstractCategorical, newlookup::AutoValues) = lookup
_set_lookup_parent(::Safety, lookup::Lookup, values::Colon) = lookup
_set_lookup_parent(::Safety, lookup::Lookup, values::AutoValues) = lookup
_set_lookup_parent(::Safety, lookup::Lookup, values::AbstractVector) = rebuild(lookup; data=values)
_set_lookup_parent(::Safe, lookup::AbstractCategorical, ::AutoValues) = lookup
_set_lookup_parent(s::Safe, lookup::AbstractCategorical, values::AbstractVector) =
    rebuild(lookup; data=_set(s, parent(lookup), values), order=orderof(values))
# Safe detects order and updates span
_set_lookup_parent(::Safe, lookup::AbstractSampled, ::AutoValues) = lookup
_set_lookup_parent(s::Safe, lookup::AbstractSampled, values::AbstractRange) = begin
    data =_set(s, parent(lookup), values)
    order = orderof(values)
    span = Regular(step(values))
    rebuild(lookup; data, span, order)
end
_set_lookup_parent(s::Safe, lookup::AbstractSampled, values::AbstractVector) = begin
    data =_set(s, parent(lookup), values)
    order = orderof(values)
    span = if sampling(lookup) isa Start
        Irregular((first(values), nothing))
    elseif sampling(lookup) isa End
        Irregular((nothing, last(values)))
    else
        Irregular((nothing, nothing))
    end
    return rebuild(lookup; data, span, order)
end

# Order
# AutoOrder does nothing for both Safe and Unsafe
_set_lookup_property(::Safe, lookup::Lookup, ::AutoOrder) = lookup
_set_lookup_property(::Unsafe, lookup::Lookup, ::AutoOrder) = lookup
# AbstractNoLookup ignores order changes (more specific methods to avoid ambiguity)
_set_lookup_property(::Safe, lookup::AbstractNoLookup, ::Order) = lookup
_set_lookup_property(::Safe, lookup::AbstractNoLookup, ::AutoOrder) = lookup
_set_lookup_property(::Unsafe, lookup::AbstractNoLookup, ::Order) = lookup
_set_lookup_property(::Unsafe, lookup::AbstractNoLookup, ::AutoOrder) = lookup
# Unsafe just sets the order field without reordering data
_set_lookup_property(s::Unsafe, lookup::Lookup, neworder::Order) =
    rebuild(lookup; order=_set(s, order(lookup), neworder))
# Safe actually reorders the data to match neworder
_set_lookup_property(::Safe, lookup::Lookup, neworder::Order) =
    reorder(lookup, neworder)
# Lookup Span
_set_lookup_property(::Safety, lookup::AbstractSampled, ::Irregular{AutoBounds}) = begin
    bnds = if parent(lookup) isa AutoValues || span(lookup) isa AutoSpan
        AutoBounds()
    else
        bounds(lookup)
    end
    rebuild(lookup; span=Irregular(bnds))
end
_set_lookup_property(s::Safety, lookup::AbstractSampled, ::Regular{AutoStep}) = begin
    stp = if span(lookup) isa Regular
        step(lookup)
    else
        stp = _detect_step(parent(lookup))
        isnothing(stp) && throw(ArgumentError("Can't set an irregular lookup values to Regular"))
        stp
    end
    rebuild(lookup; span=Regular(stp))
end
_set_lookup_property(::Safety, lookup::AbstractSampled, newspan::AutoSpan) = lookup
_set_lookup_property(s::Safety, lookup::AbstractSampled, newspan::Span) =
    _set_lookup_property(s, lookup, span(lookup), newspan)
function _set_lookup_property(
    s::Safe, lookup::AbstractSampled, ::Span, ::Explicit{<:AutoBounds}
)
    # Generate a new bounds matrix
    span = Explicit(reinterpret(reshape, Float64, intervalbounds(lookup)))
    # Explicit has to be Intervals
    sampling = Intervals(locus(lookup))
    return rebuild(lookup; span, sampling)
end
_set_lookup_property(::Safe, lookup::AbstractSampled, ::Explicit, ::Explicit{<:AutoBounds}) =
    lookup
function _set_lookup_property(::Safety, lookup::AbstractSampled, ::Span, span::Explicit)
    rebuild(lookup; span, sampling=Intervals(locus(lookup)))
end
_set_lookup_property(::Safety, lookup::AbstractSampled, ::Span, newspan::Span) =
    rebuild(lookup; span=newspan)
# Lookup Sampling
_set_lookup_property(::Safe, lookup::AbstractSampled, ::AutoSampling) = lookup
_set_lookup_property(::Unsafe, lookup::AbstractSampled, ::AutoSampling) = lookup
function _set_lookup_property(s::Safe, lookup::AbstractSampled, newsampling::Sampling)
    sa = _set(s, sampling(lookup), newsampling)
    # If sampling is Auto, just set it directly without shifting
    if sampling(lookup) isa AutoSampling
        return rebuild(lookup; sampling=sa)
    # If the locus is currently points, make it Center Intervals
    elseif sampling(lookup) isa Points
        if sa isa Intervals # Points => Intervals
            span1 = if span(lookup) isa Irregular
                # We don't know the bounds
                Irregular(nothing, nothing)
            else
                span(lookup)
            end
            lookup1 = rebuild(lookup; sampling=Intervals(Center()))
        else # Points => Points, Nothing to do here
            return lookup
        end
    else # Intervals => Points
        span1 = if span(lookup) isa Union{Irregular,Explicit}
            # We don't need bounds for Points
            Irregular(nothing, nothing)
        else # Regular stays the same
            span(lookup)
        end
        lookup1 = lookup
    end
    # For Intervals this will shift the locus
    # For Points always convert all loci to Center()
    return rebuild(shiftlocus(locus(sa), lookup1); sampling=sa)
end
_set_lookup_property(s::Unsafe, lookup::AbstractSampled, sampling::Sampling) =
    rebuild(lookup; sampling=_set(s, sampling(lookup), sampling))
# Lookup Locus
_set_lookup_property(s::Unsafe, lookup::AbstractSampled, locus::Locus) =
    rebuild(lookup; sampling=_set(s, sampling(lookup), locus))
_set(::Safe, lookup::AbstractSampled, locus::Locus) = maybeshiftlocus(locus, lookup)
# Lookup Metadata
_set_lookup_property(::Safety, lookup::Lookup, newmetadata::AllMetadata) = 
    rebuild(lookup; metadata=newmetadata)

# Order
_set(::Safety, order::Order, neworder::Order) = neworder 
_set(::Safety, order::Order, neworder::AutoOrder) = order
# Span
_set(::Safety, span::Span, newspan::Span) = newspan
_set(::Safety, span::Span, newspan::AutoSpan) = span
# Sampling
_set(::Safety, sampling::Sampling, newsampling::Sampling) = newsampling
_set(::Safety, sampling::Sampling, newsampling::AutoSampling) = sampling
_set(s::Safety, sampling::Sampling, newsampling::Intervals) =
   _set(s, newsampling,_set(s, locus(sampling), locus(newsampling)))
# Locus
_set(::Safety, sampling::Points, locus::Union{AutoPosition,Center}) = Points()
_set(::Safety, sampling::Points, locus::Locus) = _locuserror()
_set(::Safety, sampling::Intervals, locus::Locus) = Intervals(locus)
_set(::Safety, sampling::Intervals, locus::AutoPosition) = sampling
_set(::Safety, locus::Locus, newlocus::Locus) = newlocus
_set(::Safety, locus::Locus, newlocus::AutoPosition) = locus
# Metadata
_set(::Safety, metadata::AllMetadata, newmetadata::AllMetadata) = newmetadata

# Other things error
_set(::Safety, A, x) = _cantseterror(A, x)

@noinline _locuserror() = throw(ArgumentError("Can't set a locus for `Points` sampling other than `Center` - the lookup values are the exact points"))
@noinline _cantseterror(a, b) = throw(ArgumentError("Can not set any fields of $(typeof(a)) to $(typeof(b))"))

_detect_step(::AutoValues) = AutoStep()
_detect_step(A::AbstractRange) = step(A)
function _detect_step(A::AbstractVector)
    step = (last(A) - first(A)) / (length(A) - 1)
    for i in eachindex(A)
        isapprox(A[i], first(A) + step * (i - 1)) || return nothing
    end
    return step
end

_detect_order(values) =
    first(values) <= last(values) ? ForwardOrdered() : ReverseOrdered()

module DimensionalDataRecipesBaseExt

using DimensionalData
using DimensionalData: Dimension, Lookup, NoLookup, Categorical, ForwardOrdered,
    refdims_title, label, forward_order_plot_dims, reverse_order_plot_dims
using RecipesBase: RecipesBase, @recipe

abstract type DimPlotMode end
struct HeatMapLike <: DimPlotMode seriestype::Symbol end
struct WireframeLike <: DimPlotMode seriestype::Symbol end
struct SeriesLike <: DimPlotMode seriestype::Symbol end
struct HistogramLike <: DimPlotMode seriestype::Symbol end
struct ViolinLike <: DimPlotMode seriestype::Symbol end

struct DimensionalPlot end

@recipe function f(A::AbstractDimArray)
    DimensionalPlot(), A
end

@recipe function f(::DimensionalPlot, A::AbstractDimArray)
    A_fwd = reorder(A, ForwardOrdered())
    sertype = get(plotattributes, :seriestype, :none)::Symbol
    if !(sertype in (:marginalhist,))
        :title --> refdims_title(A_fwd)
    end
    if ndims(A) > 3
        parent(A)
    elseif sertype in (:heatmap, :contour, :volume, :marginalhist,
                       :surface, :contour3d, :wireframe, :scatter3d)
        HeatMapLike(sertype), A_fwd
    elseif sertype in (:histogram, :stephist, :density, :barhist, :scatterhist, :ea_histogram)
        HistogramLike(sertype), A_fwd
    elseif sertype in (:hline,)
        :yguide --> label(A_fwd)
        parent(A_fwd)
    elseif sertype in (:vline, :andrews)
        :xguide --> label(A_fwd)
        parent(A_fwd)
    elseif sertype in (:violin, :dotplot, :boxplot)
        ViolinLike(sertype), A_fwd
    elseif sertype in (:plot, :histogram2d, :none, :line, :path, :shape, :steppre, 
                       :steppost, :sticks, :scatter, :hexbin, :barbins, :scatterbins, 
                       :stepbins, :bins2d, :bar)
        SeriesLike(sertype), A_fwd
    else
        parent(A_fwd)
    end
end

@recipe function f(s::SeriesLike, A::AbstractDimArray{T,1}) where T
    dim = dims(A, 1)
    :xguide --> label(dim)
    :yguide --> label(A)
    :label --> string(label(A))
    _xticks!(plotattributes, s, dim)
    _withaxes(dim, A)
end
@recipe function f(s::SeriesLike, A::AbstractDimArray{T,2}) where T
    A = permutedims(A, forward_order_plot_dims(A))
    ind, dep = dims(A)
    :xguide --> label(ind)
    :yguide --> label(A)
    :legendtitle --> label(dep)
    :label --> string.(permutedims(val(dep)))
    :tickfontalign --> :left
    _xticks!(plotattributes, s, ind)
    _withaxes(ind, A)
end

@recipe function f(s::HistogramLike, A::AbstractDimArray{T,1}) where T
    dim = dims(A, 1)
    :xguide --> label(A)
    _withaxes(dim, A)
end
@recipe function f(s::HistogramLike, A::AbstractDimArray{T,2}) where T
    ds = reverse_order_plot_dims(A)
    A = permutedims(A, ds)
    ind, dep = dims(A)
    :xguide --> label(A)
    :legendtitle --> label(dep)
    :label --> string.(permutedims(parent(lookup(dep))))
    _withaxes(ind, A)
end

@recipe function f(::ViolinLike, A::AbstractDimArray{T,1}) where T
    dim = dims(A, 1)
    :yguide --> label(A)
    parent(A)
end
@recipe function f(s::ViolinLike, A::AbstractDimArray{T,2}) where T
    ds = reverse_order_plot_dims(A)
    A = permutedims(A, ds)
    dep, ind = dims(A)
    :xguide --> label(ind)
    :yguide --> label(A)
    :legendtitle --> label(ind)
    :label --> string.(permutedims(parent(lookup(ind))))
    _xticks!(plotattributes, s, ind)
    parent(A)
end
@recipe function f(s::ViolinLike, A::AbstractDimArray{T,3}) where T
    ds = reverse_order_plot_dims(A)
    A = permutedims(A, ds)
    dep2, dep1, ind = dims(A)
    :xguide --> label(ind)
    :yguide --> label(A)
    :legendtitle --> label(ind)
    :label --> string.(permutedims(parent(lookup(ind))))
    _xticks!(plotattributes, s, ind)
    parent(A)
end

@recipe function f(s::HeatMapLike, A::AbstractDimArray{T,1}) where T
    dim = dims(A, 1)
    :xguide --> label(dim)
    :yguide --> label(A)
    _xticks!(plotattributes, s, dim)
    parent(A)
end
@recipe function f(s::HeatMapLike, A::AbstractDimArray{T,2}) where T
    ds = reverse_order_plot_dims(A)
    A = permutedims(A, ds)
    y, x = dims(A)
    :xguide --> label(x)
    :yguide --> label(y)
    :zguide --> label(A)
    :colorbar_title --> label(A)
    _xticks!(plotattributes, s, x)
    _yticks!(plotattributes, s, y)
    _withaxes(x, y, A)
end
@recipe function f(x::DimPlotMode, A::AbstractDimArray{T,N}) where {T,N}
    throw(ArgumentError("$(x.seriestype) not implemented in $N dimensions"))
end


_withaxes(dim::Dimension, A::AbstractDimArray) =
    _withaxes(lookup(dim), parent(lookup(dim)), parent(A))
_withaxes(::NoLookup, values, A::AbstractArray) = A
_withaxes(::Lookup, values, A::AbstractArray) = values, A
_withaxes(::Categorical, values, A::AbstractArray) = eachindex(values), A

_withaxes(dx::Dimension, dy::Dimension, A::AbstractDimArray) =
    _withaxes(lookup(dx), lookup(dy), parent(lookup(dx)), parent(lookup(dy)), parent(A))
_withaxes(::Lookup, ::Lookup, ix, iy, A) = ix, iy, A
_withaxes(::NoLookup, ::Lookup, ix, iy, A) = axes(A, 2), iy, A
_withaxes(::Lookup, ::NoLookup, ix, iy, A) = ix, axes(A, 1), A
_withaxes(::NoLookup, ::NoLookup, ix, iy, A) = axes(A, 2), axes(A, 1), A

_xticks!(attr, s, d::Dimension) = _xticks!(attr, s, lookup(d), parent(lookup(d)))
_xticks!(attr, s, ::Categorical, values) =
    RecipesBase.is_explicit(attr, :xticks) || (attr[:xticks] = (eachindex(values), values))
_xticks!(attr, s, ::Lookup, values) = nothing

_yticks!(attr, s, d::Dimension) = _yticks!(attr, s, lookup(d), parent(lookup(d)))
_yticks!(attr, s, ::Categorical, values) =
    RecipesBase.is_explicit(attr, :yticks) || (attr[:yticks] = (eachindex(values), values))
_yticks!(attr, s, ::Lookup, values) = nothing

end

using DimensionalData.Dimensions: dimcolor, dimsymbol, print_dims

# Base show
function Base.summary(io::IO, A::AbstractBasicDimArray{T,N}) where {T,N}
    print_ndims(io, size(A))
    print_type(io, A)
    print_name(io, name(A))
end

# Fancy show for text/plain
function Base.show(io::IO, mime::MIME"text/plain", A::AbstractBasicDimArray{T,N}) where {T,N}
    lines, blockwidth, istop = show_main(io, mime, A::AbstractBasicDimArray)
    # Printing the array data is optional, subtypes can
    # show other things here instead.
    ds = displaysize(io)
    ctx = IOContext(io, 
        :blockwidth => blockwidth, 
        :displaysize => (ds[1] - lines, ds[2]), 
        :isblocktop => istop
    )
    show_after(ctx, mime, A)
    return nothing
end
# Defer simple 2-arg show to the parent array
Base.show(io::IO, A::AbstractDimArray) = show(io, parent(A))

Base.print_matrix(io::IO, A::AbstractBasicDimArray) =
    Base.print_matrix(io, LazyLabelledPrintMatrix(A))


"""
    show_main(io::IO, mime, A::AbstractDimArray)
    show_main(io::IO, mime, A::AbstractDimStack)

Interface methods for adding the main part of `show`.

At the least, you likely want to call:

```julia
print_top(io, mime, A)
```

`show_main` will also call `print_metadata_block`.

But read the DimensionalData.jl `show.jl` code for details.
"""
function show_main(io, mime, A::AbstractBasicDimArray;
    blockwidth=0,
    displaywidth=displaysize(io)[2],
)
    iobuf = IOBuffer()
    _, blockwidth, _ = print_metadata_block(iobuf, mime, metadata(A); 
        blockwidth, displaywidth,
    )
    lines_t, blockwidth, displaywidth, separatorwidth, istop = print_top(io, mime, A; blockwidth, displaywidth)
    lines_m, blockwidth, stilltop = print_metadata_block(io, mime, metadata(A); 
        blockwidth, displaywidth, separatorwidth, istop
    )
    return lines_t + lines_m, blockwidth, stilltop
end

"""
    show_after(io::IO, mime, A::AbstractDimArray)
    show_after(io::IO, mime, A::AbstractDimStack)

Interface methods for adding additional `show` text
for AbstractDimArray/AbstractDimStack subtypes.

*Always include `kw` to avoid future breaking changes*

Additional keywords may be added at any time.


`blockwidth` is passed in context

```julia
blockwidth = get(io, :blockwidth, 10000)
```

Note - a ANSI box is left unclosed. This method needs to close it,
or add more. `blockwidth` is the maximum length of the inner text.

Most likely you always want to at least close the show blocks with:

```julia
print_block_close(io, blockwidth)
```

But read the DimensionalData.jl `show.jl` code for details.
"""
function show_after(io::IO, mime, A::AbstractBasicDimArray)
    blockwidth = get(io, :blockwidth, 0)
    print_block_close(io, blockwidth)
    can_show_data(parent(A)) || return
    ndims(A) > 0 && println(io)
    any(==(0), size(A)) && return
    print_array(io, mime, A)
end

can_show_data(A) = true

function print_ndims(io, size::Tuple;
    colors=map(dimcolor, ntuple(identity, length(size)))
)
    if length(size) > 1
        print_sizes(io, size; colors)
        print(io, ' ')
    elseif length(size) == 1
        printstyled(io, Base.dims2string(size), " "; color=first(colors))
    else
        print(io, Base.dims2string(size), " ")
    end
end

print_type(io, x::AbstractArray{T,N}) where {T,N} = print(io, string(nameof(typeof(x)), "{$T, $N}"))
print_type(io, x) = print(io, string(nameof(typeof(x))))

function print_top(io, mime, A; 
    blockwidth::Int=0,
    displaywidth::Int=displaysize(io)[2],
)
    separatorwidth = min(displaywidth - 2, textwidth(sprint(summary, A)) + 2)
    blockwidth = max(blockwidth, separatorwidth)
    printstyled(io, "┌ "; color=:light_black)
    summary(io, A)
    printstyled(io, " ┐"; color=:light_black)
    println(io)
    n, blockwidth, separatorwidth, istop = print_dims_block(io, mime, dims(A); displaywidth, blockwidth, separatorwidth)
    lines = 2 + n
    return lines, blockwidth, displaywidth, separatorwidth, istop
end

function print_sizes(io, size;
    colors=map(dimcolor, ntuple(identity, length(size)))
)
    if !isempty(size)
        foreach(enumerate(size[1:end-1])) do (n, s)
            printstyled(io, s; color=colors[n])
            print(io, '×')
        end
        printstyled(io, last(size); color=colors[length(size)])
    end
end

function print_dims_block(io, mime, dims; 
    displaywidth, blockwidth, separatorwidth, label="dims", istop=true, kw...
)
    lines = 0
    if isempty(dims)
        printed = false
        new_separatorwidth = separatorwidth
        new_blockwidth = max(blockwidth, separatorwidth)
    else
        ctx = IOContext(io, :compact => true, :dim_brackets => false)
        printed=false
        dim_width = maximum(textwidth, split(sprint(print_dims, mime, dims), '\n'))
        new_blockwidth = max(blockwidth, min(displaywidth - 2, dim_width))
        new_separatorwidth = print_block_separator(ctx, label, separatorwidth, new_blockwidth; istop)
        println(io)
        lines += print_dims(ctx, mime, dims; kw...)
        println(io)
        lines += 3
        printed = true
        new_separatorwidth = new_blockwidth = max(new_blockwidth, new_separatorwidth)
    end
    return lines, new_blockwidth, new_separatorwidth, !printed
end

function print_metadata_block(io, mime, metadata; 
    blockwidth=0, displaywidth, separatorwidth=blockwidth, istop=false
)
    lines = 0
    if metadata isa NoMetadata || isempty(metadata)
        new_blockwidth = blockwidth
        stilltop=istop
    else
        metadata_lines = split(sprint(show, mime, metadata), "\n")
        new_blockwidth = min(displaywidth-2, max(blockwidth, maximum(length, metadata_lines) + 4))
        new_blockwidth = print_block_separator(io, "metadata", separatorwidth, new_blockwidth; istop)
        println(io)
        print(io, "  ")
        show(io, mime, metadata)
        println(io)
        lines += length(metadata_lines) + 2
        stilltop=false
    end
    return lines, new_blockwidth, stilltop
end

# Block lines
function print_block_separator(io, label, prev_width, new_width=prev_width; istop=false)
    if istop
        corner = (new_width > prev_width) ? '┐' : '┤'
        top_line = if new_width > prev_width
            string(
                '├', '─'^(prev_width), '┴',
                '─'^max(0, (new_width - textwidth(label) - 3 - prev_width)),
                ' ', label, ' ', corner
            )
        else
            string('├', '─'^max(0, new_width - textwidth(label) - 2), ' ', label, ' ', corner)
        end
        printstyled(io, top_line; color=:light_black)
        return length(top_line) - 2
    end
    if new_width > prev_width
        line = string('├', '─'^max(0, prev_width), '┴', '─'^max(0, new_width - prev_width - textwidth(label) - 3) )
        corner = '┐'
    else
        line = string('├', '─'^max(0, new_width - textwidth(label) - 2))
        corner = '┤'
    end
    full = string(line, ' ', label, ' ', corner)
    printstyled(io, full; color=:light_black)
    return length(full) - 2
end

function print_block_close(io, blockwidth)
    closing_line = string('└', '─'^blockwidth, '┘')
    printstyled(io, closing_line; color=:light_black)
end

# Showing the array is optional for AbstractDimArray
# `print_array` must be called from `show_after`.
function print_array(io::IO, mime, A::AbstractBasicDimArray{T,0}) where T
    print(_print_array_ctx(io, T), "\n", A[])
end
function print_array(io::IO, mime, A::AbstractBasicDimArray{T,1}) where T
    Base.print_matrix(_print_array_ctx(io, T), A)
end
function print_array(io::IO, mime, A::AbstractBasicDimArray{T,2}) where T
    Base.print_matrix(_print_array_ctx(io, T), A)
end
function print_array(io::IO, mime, A::AbstractBasicDimArray{T,3}) where T
    i3 = firstindex(A, 3)
    frame = view(A, :, :, i3)

    _print_indices_vec(io, i3)
    Base.print_matrix(_print_array_ctx(io, T), frame)
end
function print_array(io::IO, mime, A::AbstractBasicDimArray{T,N}) where {T,N}
    o = ntuple(x -> firstindex(A, x + 2), N-2)
    frame = view(A, :, :, o...)

    _print_indices_vec(io, o...)
    Base.print_matrix(_print_array_ctx(io, T), frame)
end

function _print_indices_vec(io, o...)
    print(io, "[")
    printstyled(io, ":"; color=dimcolor(1))
    print(io, ", ")
    printstyled(io, ":"; color=dimcolor(2))
    foreach(enumerate(o)) do (i, fi)
        print(io, ", ")
        printstyled(io, fi; color=dimcolor(i + 2))
    end
    println(io, "]")
end

function _print_array_ctx(io, T)
    IOContext(io, :compact=>true, :typeinfo=>T)
end
# print a name of something, in yellow
function print_name(io::IO, name)
    if !(name == Symbol("") || name isa NoName)
        printstyled(io, string(" ", name); color=dimcolor(7))
    end
end

# A wrapper to show objects with dimension colors or arrows
struct ShowWith <: AbstractString
    val::Any
    mode::Symbol
    color::Union{Int,Symbol}
end
ShowWith(val; mode=:nothing, color=:light_black) = ShowWith(val, mode, color)

showrowlabel(x) = ShowWith(x, :nothing, dimcolor(1))
showcollabel(x) = ShowWith(x, :nothing, dimcolor(2))
showarrows() = ShowWith(1.0, :print_arrows, :nothing)

function Base.show(io::IO, mime::MIME"text/plain", x::ShowWith; kw...)
    if x.mode == :print_arrows
        printstyled(io, dimsymbol(1); color=dimcolor(1))
        print(io, " ")
        printstyled(io, dimsymbol(2); color=dimcolor(2))
    else
        s = sprint(show, mime, x.val; context=io, kw...)
        printstyled(io, s; color=x.color)
    end
end
function Base.show(io::IO, x::ShowWith)
    printstyled(io, string(x.val); color = x.color, hidden = x.mode == :hide)
end

function Base.alignment(io::IO, x::ShowWith)
    # Base bug means we need to special-case this
    if x.val isa DateTime
        0, textwidth(sprint(print, x.val))
    else
        Base.alignment(io, x.val)
    end
end
function Base.print(io::IO, x::ShowWith)
    printstyled(io, string(x.val); color = x.color, hidden = x.mode == :hide)
end

Base.iterate(x::ShowWith) = iterate(string(x.val))
Base.iterate(x::ShowWith, i::Int) = iterate(string(x.val), i::Int)

# A lazy array wrapper to print lookup values as an extra row and/or column
struct LazyLabelledPrintMatrix{A,LL,LT} <: AbstractArray{Any,2}
    data::A
    rowlabels::LL
    collabels::LT
end
function LazyLabelledPrintMatrix(A::AbstractBasicDimArray{<:Any,1})
    LazyLabelledPrintMatrix(parent(A), lookup(A, 1), lookup(A, 1))
end
function LazyLabelledPrintMatrix(A::AbstractBasicDimArray{<:Any,2})
    LazyLabelledPrintMatrix(parent(A), lookup(A, 1), lookup(A, 2))
end

function Base.size(A::LazyLabelledPrintMatrix)
    n = ndims(A.data)
    if n == 1
        return length(A.data), A.rowlabels isa NoLookup ? 1 : 2
    else
        labelsize = A.collabels isa NoLookup ? 0 : 1, A.rowlabels isa NoLookup ? 0 : 1
        return map(+, labelsize, size(A.data))
    end
end

@propagate_inbounds function Base.getindex(A::LazyLabelledPrintMatrix, i::Integer, j::Integer)
    @boundscheck checkbounds(A, i, j)
    oi = i + firstindex(A.data, 1) - 1
    if ndims(A.data) == 1
        if A.rowlabels isa NoLookup
            A.data[oi]
        else
            if j == 1
                showrowlabel(A.rowlabels[oi])
            elseif j == 2
                A.data[oi]
            end
        end
    else # N == 2
        oj = j + firstindex(A.data, 2) - 1
        if A.rowlabels isa NoLookup
            if A.collabels isa NoLookup
                A.data[oi, oj]
            else
                if i == 1
                    showcollabel(A.collabels[oj])
                else # i > 1
                    A.data[oi - 1, oj]
                end
            end
        else # !(A.rowlabels isa NoLookup)
            if A.collabels isa NoLookup
                if j == 1
                    showrowlabel(A.rowlabels[oi])
                else # j > 1
                    A.data[oi, oj - 1]
                end
            else
                if j == 1
                    if i == 1
                        showarrows()
                    else # i > 1
                        showrowlabel(A.rowlabels[oi - 1])
                    end
                else # j > 1
                    if i == 1
                        showcollabel(A.collabels[oj - 1])
                    else # i > 1
                        A.data[oi - 1, oj - 1]
                    end
                end
            end
        end
    end
end

module DimensionalDataChainRulesCoreExt

using DimensionalData
import DimensionalData as DD
using ChainRulesCore

function ChainRulesCore.ProjectTo(x::DD.AbstractDimArray)
    return ProjectTo{DD.DimArray}(
        data = ProjectTo(parent(x)),
        dims = dims(x),
        name = name(x),
        refdims = refdims(x),
        metadata = metadata(x)
    )
end

(project::ProjectTo{DD.DimArray})(dx::DD.AbstractDimArray) =
    DD.DimArray(project.data(parent(dx)), project.dims; name=project.name, refdims=project.refdims, metadata=project.metadata)

(project::ProjectTo{DD.DimArray})(dx::AbstractArray) =
    DD.DimArray(project.data(dx), project.dims; name=project.name, refdims=project.refdims, metadata=project.metadata)

(project::ProjectTo{DD.DimArray})(dx::AbstractZero) = dx

DimArray_pullback(ȳ, project) = (NoTangent(), project(ȳ))
DimArray_pullback(ȳ::Tangent, project) = DimArray_pullback(ȳ.data, project)
DimArray_pullback(ȳ::AbstractThunk, project) = DimArray_pullback(unthunk(ȳ), project)

function ChainRulesCore.rrule(::typeof(parent), x::DD.AbstractDimArray)
    project = ProjectTo(x)
    function parent_pullback(ȳ)
        return DimArray_pullback(ȳ, project)
    end
    return parent(x), parent_pullback
end

#! rrule for keyword getindex with selectors
function ChainRulesCore.rrule(::typeof(getindex), A::DD.AbstractDimArray; kwargs...)
    dimsA = dims(A)
    selectors = ntuple(i -> begin
        dim = dimsA[i]
        key = name(dim)
        if haskey(kwargs, key)
            kwargs[key]  # the Selector passed by the user
        else
            Colon()
        end
    end, length(dimsA))

    indices = DD.Dimensions.dims2indices(dimsA, selectors)

    B = getindex(A, indices...)

    function pb(ȳ)
        grad = zero(A)
        if ȳ isa Number && length(grad[indices...]) == 1
            grad[indices...] = ȳ
        else
            grad[indices...] .= ȳ
        end
        return (NoTangent(), grad)
    end

    return B, pb
end

end

module DimensionalDataCategoricalArraysExt

import DimensionalData, CategoricalArrays
const DD = DimensionalData
const CAs = CategoricalArrays
CategoricalDimArray = DD.AbstractDimArray{<:Union{Missing, CAs.CategoricalValue}}

# categorical and cut take a dimarray and return a categorical dim array
function CAs.categorical(x::DD.AbstractDimArray; kw...)
    ca = CAs.categorical(Base.parent(x); kw...)
    DD.rebuild(x; data = ca)
end

# Need to define these separately to avoid ambiguity
CAs.cut(x::DD.AbstractDimArray, ng::Integer; kw...) = DD.rebuild(x; data = CAs.cut(Base.parent(x),ng; kw...))
CAs.cut(x::DD.AbstractDimArray, breaks::AbstractVector; kw...) = DD.rebuild(x; data = CAs.cut(Base.parent(x),breaks; kw...))

CAs.recode(x::DD.AbstractDimArray, pairs::Pair...) = CAs.recode(x, nothing, pairs...)
CAs.recode(x::DD.AbstractDimArray, default::Any, pairs::Pair...) = DD.rebuild(x; data = CAs.recode(Base.parent(x),default, pairs...))

# function that mutate in-place
for f in [:levels!, :droplevels!, :fill!, :ordered!]
    @eval function CAs.$f(x::CategoricalDimArray, args...; kw...)
        CAs.$f(Base.parent(x), args...; kw...)
        return x
    end
end

# functions that rebuild the categorical array
for f in [:compress, :decompress]
    @eval CAs.$f(x::CategoricalDimArray, args...; kw...) = 
        DD.rebuild(x; data = CAs.$f(Base.parent(x), args...; kw...))
end

# functions that do not mutate
for f in [:levels, :leveltype, :pool, :refs, :isordered]
    @eval CAs.$f(x::CategoricalDimArray, args...; kw...) = CAs.$f(Base.parent(x), args...; kw...)
end

## Recode! methods
# methods without a default - needed to avoid ambiguity
CAs.recode!(dest::DD.AbstractDimArray, src::AbstractArray, pairs::Pair...) = CAs.recode!(dest, src, nothing, pairs...)
CAs.recode!(dest::AbstractArray, src::DD.AbstractDimArray, pairs::Pair...) = CAs.recode!(dest, src, nothing, pairs...)
CAs.recode!(dest::DD.AbstractDimArray, src::CAs.CategoricalArray, pairs::Pair...) = CAs.recode!(dest, src, nothing, pairs...)
CAs.recode!(dest::CAs.CategoricalArray, src::DD.AbstractDimArray, pairs::Pair...) = CAs.recode!(dest, src, nothing, pairs...)
CAs.recode!(dest::DD.AbstractDimArray, src::DD.AbstractDimArray, pairs::Pair...) = CAs.recode!(dest, src, nothing, pairs...)
# methods with a single array
CAs.recode!(a::DD.AbstractDimArray, default::Any, pairs::Pair...) = CAs.recode!(a, a, default, pairs...)
CAs.recode!(a::DD.AbstractDimArray, pairs::Pair...) = CAs.recode!(a, a, nothing, pairs...)

# methods with default
function CAs.recode!(dest::DD.AbstractDimArray, src::AbstractArray, default, pairs::Pair...)
    CAs.recode!(Base.parent(dest), src, default, pairs...)
    return dest
end
function CAs.recode!(dest::AbstractArray, src::DD.AbstractDimArray, default, pairs::Pair...)
    CAs.recode!(dest, Base.parent(src), default, pairs...)
    return dest
end
function CAs.recode!(dest::DD.AbstractDimArray, src::CAs.CategoricalArray, default, pairs::Pair...)
    CAs.recode!(Base.parent(dest), src, default, pairs...)
    return dest
end
function CAs.recode!(dest::CAs.CategoricalArray, src::DD.AbstractDimArray, default, pairs::Pair...)
    CAs.recode!(dest, Base.parent(src), default, pairs...)
    return dest
end
function CAs.recode!(dest::DD.AbstractDimArray, src::DD.AbstractDimArray, default, pairs::Pair...)
    CAs.recode!(Base.parent(dest), Base.parent(src), pairs...)
    return dest
end

end

using DocumenterVitepress
using Documenter
using DimensionalData
using Dates
using DimensionalData.Dimensions
using DimensionalData.Lookups

# Names are available everywhere so that [`function`](@ref) works.
# ====================

doctest_setup = quote
    using DimensionalData
    using DimensionalData.Dimensions
    using DimensionalData.Dimensions.Lookups
end
DocMeta.setdocmeta!(DimensionalData, :DocTestSetup, doctest_setup; recursive=true)

# Build documentation.
# ====================

makedocs(; sitename="DimensionalData", authors="Rafael Schouten et al.",
    modules=[DimensionalData],
    checkdocs=:all,
    format=DocumenterVitepress.MarkdownVitepress(
        repo = "github.com/rafaqz/DimensionalData.jl",
        devbranch = "main", 
        devurl = "dev", 
    ),
    draft=false,
    source="src", 
    build="build",
)

# Deploy built documentation.
# ===========================
DocumenterVitepress.deploydocs(; 
    repo="github.com/rafaqz/DimensionalData.jl",
    target="build", # this is where Vitepress stores its output
    branch = "gh-pages",
    devbranch = "main",
    push_preview = true
)

using DimensionalData, Test, Unitful, Combinatorics, Dates, IntervalSets, Extents
using DimensionalData.Lookups, DimensionalData.Dimensions
using .Lookups: between, touches, at, near, contains, bounds, SelectorError, cycle_val

a = [1 2  3  4
     5 6  7  8
     9 10 11 12]

dims_ = X(Sampled(10:10:20; sampling=Intervals())),
        Y(Sampled(5:7; sampling=Intervals()))
A = DimArray([1 2 3; 4 5 6], dims_)

@testset "selector primitives" begin

    @testset "Explicit Intervals" begin
        fwdindex = 11.0:30.0
        revindex = 30.0:-1.0:11.0

        args = Intervals(Start()), NoMetadata()
        fwdmatrix = vcat(fwdindex', (fwdindex .+ 1)')
        revmatrix = vcat(revindex', (revindex .+ 1)')
        startfwd = Sampled(fwdindex, ForwardOrdered(), Explicit(fwdmatrix), args...)
        startrev = Sampled(revindex, ReverseOrdered(), Explicit(revmatrix), args...)

        args = Intervals(Center()), NoMetadata()
        fwdmatrix = vcat((fwdindex .- 0.5)', (fwdindex .+ 0.5)')
        revmatrix = vcat((revindex .- 0.5)', (revindex .+ 0.5)')
        centerfwd = Sampled(fwdindex, ForwardOrdered(), Explicit(fwdmatrix), args...)
        centerrev = Sampled(revindex, ReverseOrdered(), Explicit(revmatrix), args...)

        args = Intervals(End()), NoMetadata()
        fwdmatrix = vcat((fwdindex .- 1)', fwdindex')
        revmatrix = vcat((revindex .- 1)', revindex')
        endfwd = Sampled(fwdindex, ForwardOrdered(), Explicit(fwdmatrix), args...)
        endrev = Sampled(revindex, ReverseOrdered(), Explicit(revmatrix), args...)

        @testset "Any at" begin
            @test at(startfwd, At(30)) == 20
            @test at(startrev, At(30)) == 1
            @test at(startfwd, At(29.9; atol=0.2)) == 20
            @test at(startrev, At(29.9; atol=0.2)) == 1
            @test at(startfwd, At(30.1; atol=0.2)) == 20
            @test at(startrev, At(30.1; atol=0.2)) == 1
            @test_throws SelectorError at(startrev, At(0.0; atol=0.2))
            @test at(startrev, At(0.0; atol=0.2); err=Lookups._False()) == nothing
        end

        @testset "Start between" begin
            @test between(startfwd, 0..11.9) === 1:0
            @test between(startfwd, 0..12) === 1:1
            @test between(startfwd, 30..50) === 20:20
            @test between(startfwd, 31..50) === 21:20
            @test between(startrev, 0..11.9) === 21:20
            @test between(startrev, 0..12) === 20:20
            @test between(startrev, 30..50) === 1:1
            @test between(startrev, 30.1..50) === 1:0
            @test between(startfwd, 0..40) === 1:20
            @test between(startrev, 0..40) === 1:20
            # Bounds
            @test between(startfwd, 11.0..31.0) === 1:20
            @test between(startrev, 11.0..31.0) === 1:20
            # Input order doesn't matter with Between
            @test between(startfwd, Between(14, 11)) === 1:3
            @test between(startfwd, Between(0, 11.9)) === 1:0
            # Intervals
            @test between(startfwd, 12.0..15.0) === 2:4
            @test between(startfwd, 12.1..14.9) === 3:3
            @test between(startrev, 12.0..15.0) === 17:19
            @test between(startrev, 12.1..14.9) === 18:18
            @test between(startfwd, Interval{:open,:open}(11.9..15.1)) === 2:4
            @test between(startfwd, Interval{:open,:open}(12.0..15.0)) === 3:3
            @test between(startrev, Interval{:open,:open}(11.9..15.1)) === 17:19
            @test between(startrev, Interval{:open,:open}(12.0..15.0)) === 18:18
            @test between(startfwd, Interval{:open,:closed}(11.9..15.0)) === 2:4
            @test between(startfwd, Interval{:open,:closed}(12.0..14.9)) === 3:3
            @test between(startrev, Interval{:open,:closed}(11.9..15.0)) === 17:19
            @test between(startrev, Interval{:open,:closed}(12.0..14.9)) === 18:18
            @test between(startfwd, Interval{:closed,:open}(12.0..15.1)) === 2:4
            @test between(startfwd, Interval{:closed,:open}(12.1..15.0)) === 3:3
            @test between(startrev, Interval{:closed,:open}(12.0..15.1)) === 17:19
            @test between(startrev, Interval{:closed,:open}(12.1..15.0)) === 18:18
        end

        @testset "Center between" begin
            @test between(centerfwd, 0..11.4) === 1:0
            @test between(centerfwd, 0..11.5) === 1:1
            @test between(centerfwd, 29.5..50.0) === 20:20
            @test between(centerfwd, 29.6..50.0) === 21:20
            @test between(centerrev, 0..11.4) === 21:20
            @test between(centerrev, 0..11.5) === 20:20
            @test between(centerrev, 29.5..50.0) === 1:1
            @test between(centerrev, 29.6..50.0) === 1:0
            @test between(centerfwd, 0..40) === 1:20
            @test between(centerrev, 0..40) === 1:20
            # Bounds
            @test between(centerrev, 10.5..30.5) === 1:20
            @test between(centerrev, 10.5..30.5) === 1:20
            # Input order doesn't matter with Between
            @test between(centerfwd, Between(15, 10)) === 1:4

            @test between(centerfwd, 11.5..14.5) === 2:4
            @test between(centerfwd, 11.6..14.4) === 3:3
            @test between(centerrev, 11.5..14.5) === 17:19
            @test between(centerrev, 11.6..14.4) === 18:18
            @test between(centerfwd, Interval{:open,:open}(11.4..14.6)) === 2:4
            @test between(centerfwd, Interval{:open,:open}(11.5..14.5)) === 3:3
            @test between(centerrev, Interval{:open,:open}(11.4..14.6)) === 17:19
            @test between(centerrev, Interval{:open,:open}(11.5..14.5)) === 18:18
            @test between(centerfwd, Interval{:open,:closed}(11.4..14.5)) === 2:4
            @test between(centerfwd, Interval{:open,:closed}(11.5..14.4)) === 3:3
            @test between(centerrev, Interval{:open,:closed}(11.4..14.5)) === 17:19
            @test between(centerrev, Interval{:open,:closed}(11.5..14.4)) === 18:18
            @test between(centerfwd, Interval{:closed,:open}(11.5..14.6)) === 2:4
            @test between(centerfwd, Interval{:closed,:open}(11.6..14.5)) === 3:3
            @test between(centerrev, Interval{:closed,:open}(11.5..14.6)) === 17:19
            @test between(centerrev, Interval{:closed,:open}(11.6..14.5)) === 18:18
        end

        @testset "End between" begin
            @test between(endfwd, 0.0..10.9) === 1:0
            @test between(endfwd, 0..11) === 1:1
            @test between(endfwd, 29.0..30.0) === 20:20
            @test between(endfwd, 29.1..50.0) === 21:20
            @test between(endrev, 0.0..10.9) === 21:20
            @test between(endrev, 0.0..11.0) === 20:20
            @test between(endrev, 29.0..50.0) === 1:1
            @test between(endrev, 29.1..50.0) === 1:0
            @test between(endfwd, 0..40) === 1:20
            @test between(endrev, 0..40) === 1:20
            # Bounds
            @test between(endfwd, 10.0..30.0) === 1:20
            @test between(endrev, 10.0..30.0) === 1:20
            # Input order doesn't matter with Between
            @test between(endfwd, Between(15, 10)) === 1:5

            @test between(endfwd, 12.0..15.0) === 3:5
            @test between(endfwd, 12.1..14.9) === 4:4
            @test between(endrev, 12.0..15.0) === 16:18
            @test between(endrev, 12.1..14.9) === 17:17
            @test between(endfwd, Interval{:open,:open}(11.9..15.1)) === 3:5
            @test between(endfwd, Interval{:open,:open}(12.0..15.0)) === 4:4
            @test between(endrev, Interval{:open,:open}(11.9..15.1)) === 16:18
            @test between(endrev, Interval{:open,:open}(12.0..15.0)) === 17:17
            @test between(endfwd, Interval{:open,:closed}(11.9..15.0)) === 3:5
            @test between(endfwd, Interval{:open,:closed}(12.0..14.9)) === 4:4
            @test between(endrev, Interval{:open,:closed}(11.9..15.0)) === 16:18
            @test between(endrev, Interval{:open,:closed}(12.0..14.9)) === 17:17
            @test between(endfwd, Interval{:closed,:open}(12.0..15.1)) === 3:5
            @test between(endfwd, Interval{:closed,:open}(12.1..15.0)) === 4:4
            @test between(endrev, Interval{:closed,:open}(12.0..15.1)) === 16:18
            @test between(endrev, Interval{:closed,:open}(12.1..15.0)) === 17:17
        end

        # Essentially as `between` above but with smaller intervals
        @testset "Start touches" begin
            @test touches(startfwd, Touches(0, 10.9)) === 1:0
            @test touches(startfwd, Touches(0, 11)) === 1:1
            @test touches(startfwd, Touches(31, 31)) === 20:20
            @test touches(startfwd, Touches(31, 50)) === 20:20
            @test touches(startfwd, Touches(31.1, 50)) === 21:20
            @test touches(startrev, Touches(0, 10.9)) === 21:20
            @test touches(startrev, Touches(0, 11)) === 20:20
            @test touches(startrev, Touches(31, 50)) === 1:1
            @test touches(startrev, Touches(31.1, 50)) === 1:0
            @test touches(startfwd, Touches(0, 40)) === 1:20
            @test touches(startrev, Touches(0, 40)) === 1:20
            # Bounds
            @test touches(startfwd, Touches(12.0, 30.0)) === 1:20
            @test touches(startrev, Touches(12.0, 30.0)) === 1:20
            # Intervals
            @test touches(startfwd, Touches(13.0, 14.0)) === 2:4
            @test touches(startfwd, Touches(13.1, 13.9)) === 3:3
            @test touches(startrev, Touches(13.0, 14.0)) === 17:19
            @test touches(startrev, Touches(13.1, 13.9)) === 18:18
        end

        @testset "Center touches" begin
            @test touches(centerfwd, Touches(0, 10.4)) === 1:0
            @test touches(centerfwd, Touches(0, 10.5)) === 1:1
            @test touches(centerfwd, Touches(30.0, 30.0)) === 20:20
            @test touches(centerfwd, Touches(30.5, 50.0)) === 20:20
            @test touches(centerfwd, Touches(30.6, 50.0)) === 21:20
            @test touches(centerrev, Touches(0, 10.4)) === 21:20
            @test touches(centerrev, Touches(0, 10.5)) === 20:20
            @test touches(centerrev, Touches(30.5, 50.0)) === 1:1
            @test touches(centerrev, Touches(30.6, 50.0)) === 1:0
            @test touches(centerfwd, Touches(0, 40)) === 1:20
            @test touches(centerrev, Touches(0, 40)) === 1:20
            # Bounds
            @test touches(centerrev, Touches(11.5, 29.5)) === 1:20
            @test touches(centerrev, Touches(11.5, 29.5)) === 1:20

            @test touches(centerfwd, Touches(12.5, 13.5)) === 2:4
            @test touches(centerfwd, Touches(12.6, 13.4)) === 3:3
            @test touches(centerrev, Touches(12.5, 13.5)) === 17:19
            @test touches(centerrev, Touches(12.6, 13.4)) === 18:18
        end

        @testset "End touches" begin
            @test touches(endfwd, Touches(0.0, 9.9)) === 1:0
            @test touches(endfwd, Touches(0, 10)) === 1:1
            @test touches(endfwd, Touches(30.0, 30.0)) === 20:20
            @test touches(endfwd, Touches(30.1, 50.0)) === 21:20
            @test touches(endrev, Touches(0.0, 9.9)) === 21:20
            @test touches(endrev, Touches(0.0, 10.0)) === 20:20
            @test touches(endrev, Touches(30.0, 50.0)) === 1:1
            @test touches(endrev, Touches(30.1, 50.0)) === 1:0
            @test touches(endfwd, Touches(0, 40)) === 1:20
            @test touches(endrev, Touches(0, 40)) === 1:20
            # Bounds
            @test touches(endfwd, Touches(11.0, 29.0)) === 1:20
            @test touches(endrev, Touches(11.0, 29.0)) === 1:20

            @test touches(endfwd, Touches(13.0, 14.0)) === 3:5
            @test touches(endfwd, Touches(13.1, 13.9)) === 4:4
            @test touches(endrev, Touches(13.0, 14.0)) === 16:18
            @test touches(endrev, Touches(13.1, 13.9)) === 17:17
        end

        @testset "Start contains" begin
            @test_throws SelectorError contains(startfwd, Contains(10.9))
            @test_throws SelectorError contains(startfwd, Contains(31))
            @test_throws SelectorError contains(startrev, Contains(31))
            @test_throws SelectorError contains(startrev, Contains(10.9))
            @test contains(startrev, Contains(10.9); err=Lookups._False()) == nothing
            @test contains(startfwd, Contains(11)) == 1
            @test contains(startfwd, Contains(11.9)) == 1
            @test contains(startfwd, Contains(12.0)) == 2
            @test contains(startfwd, Contains(30.0)) == 20
            @test contains(startfwd, Contains(30.9)) == 20
            @test contains(startfwd, Contains(29.9)) == 19
            @test contains(startrev, Contains(11.9)) == 20
            @test contains(startrev, Contains(12.0)) == 19
            @test contains(startrev, Contains(30.0)) == 1
            @test contains(startrev, Contains(30.9)) == 1
            @test contains(startrev, Contains(29.0)) == 2
        end

        @testset "Center contains" begin
            @test_throws SelectorError contains(centerfwd, Contains(10.4))
            @test_throws SelectorError contains(centerfwd, Contains(30.5))
            @test_throws SelectorError contains(centerrev, Contains(10.4))
            @test_throws SelectorError contains(centerrev, Contains(30.5))
            @test contains(centerfwd, Contains(10.5)) == 1
            @test contains(centerfwd, Contains(30.4)) == 20
            @test contains(centerfwd, Contains(29.5)) == 20
            @test contains(centerfwd, Contains(29.4)) == 19
            @test contains(centerrev, Contains(10.5)) == 20
            @test contains(centerrev, Contains(30.4)) == 1
            @test contains(centerrev, Contains(29.5)) == 1
            @test contains(centerrev, Contains(29.4)) == 2
        end

        @testset "End contains" begin
            @test_throws SelectorError contains(endfwd, Contains(10))
            @test_throws SelectorError contains(endfwd, Contains(30.1))
            @test_throws SelectorError contains(endrev, Contains(10))
            @test_throws SelectorError contains(endrev, Contains(30.1))
            @test contains(endfwd, Contains(10.1)) == 1
            @test contains(endfwd, Contains(11.0)) == 1
            @test contains(endfwd, Contains(11.1)) == 2
            @test contains(endfwd, Contains(29.0)) == 19
            @test contains(endfwd, Contains(29.1)) == 20
            @test contains(endfwd, Contains(30.0)) == 20
            @test contains(endrev, Contains(10.1)) == 20
            @test contains(endrev, Contains(11.0)) == 20
            @test contains(endrev, Contains(11.1)) == 19
            @test contains(endrev, Contains(29.0)) == 2
            @test contains(endrev, Contains(29.1)) == 1
            @test contains(endrev, Contains(30.0)) == 1
            @test contains(endrev, Contains(11.0)) == 20
            @test contains(endrev, Contains(11.1)) == 19
        end

        @testset "Center near" begin
            @test near(centerfwd, Near(10.4)) == 1
            @test near(centerfwd, Near(30.5)) == 20
            @test near(centerrev, Near(10.4)) == 20
            @test near(centerrev, Near(30.5)) == 1
            @test near(centerfwd, Near(10.5)) == 1
            @test near(centerfwd, Near(30.4)) == 20
            @test near(centerfwd, Near(29.5)) == 20
            @test near(centerfwd, Near(29.4)) == 19
            @test near(centerrev, Near(10.5)) == 20
            @test near(centerrev, Near(30.4)) == 1
            @test near(centerrev, Near(29.5)) == 1
            @test near(centerrev, Near(29.4)) == 2
        end

    end

    @testset "Regular Intervals with range" begin
        args = Intervals(Start()), NoMetadata()
        startfwd = Sampled(11.0:30.0,      ForwardOrdered(), Regular(1), args...)
        startrev = Sampled(30.0:-1.0:11.0, ReverseOrdered(), Regular(-1), args...)

        args = Intervals(Center()), NoMetadata()
        centerfwd = Sampled(11.0:30.0,      ForwardOrdered(), Regular(1), args...)
        centerrev = Sampled(30.0:-1.0:11.0, ReverseOrdered(), Regular(-1), args...)

        args = Intervals(End()), NoMetadata()
        endfwd = Sampled(11.0:30.0,      ForwardOrdered(), Regular(1), args...)
        endrev = Sampled(30.0:-1.0:11.0, ReverseOrdered(), Regular(-1), args...)

        @testset "Any at" begin
            @test at(startfwd, At(30)) == 20
            @test at(startrev, At(30)) == 1
            @test at(startfwd, At(29.9; atol=0.2)) == 20
            @test at(startrev, At(29.9; atol=0.2)) == 1
            @test at(startfwd, At(30.1; atol=0.2)) == 20
            @test at(startrev, At(30.1; atol=0.2)) == 1
        end
        @testset "Start between" begin
            @test between(startfwd, 0..11.9) === 1:0
            @test between(startfwd, 0..12) === 1:1
            @test between(startfwd, 30..50) === 20:20
            @test between(startfwd, 31..50) === 21:20
            @test between(startrev, 0..11.9) === 21:20
            @test between(startrev, 0..12) === 20:20
            @test between(startrev, 30..50) === 1:1
            @test between(startrev, 30.1..50) === 1:0
            @test between(startfwd, 0..40) === 1:20
            @test between(startrev, 0..40) === 1:20
            # Bounds
            @test between(startfwd, 11.0..31.0) === 1:20
            @test between(startrev, 11.0..31.0) === 1:20

            @test between(startfwd, 11.1..13.9) === 2:2
            @test between(startfwd, 11.0..14.0) === 1:3
            @test between(startrev, 11.1..13.9) === 19:19
            @test between(startrev, 11.0..14.0) === 18:20
            @test between(startfwd, Interval{:open,:open}(11.0..14.0)) === 2:2
            @test between(startfwd, Interval{:open,:open}(10.9..14.1)) === 1:3
            @test between(startrev, Interval{:open,:open}(11.0..14.0)) === 19:19
            @test between(startrev, Interval{:open,:open}(10.9..14.1)) === 18:20
            @test between(startfwd, Interval{:open,:closed}(11.0..13.9)) === 2:2
            @test between(startfwd, Interval{:open,:closed}(10.9..14.0)) === 1:3
            @test between(startrev, Interval{:open,:closed}(11.0..13.9)) === 19:19
            @test between(startrev, Interval{:open,:closed}(10.9..14.0)) === 18:20
            @test between(startfwd, Interval{:closed,:open}(11.1..13.9)) === 2:2
            @test between(startfwd, Interval{:closed,:open}(11.0..14.1)) === 1:3
            @test between(startrev, Interval{:closed,:open}(11.1..14.0)) === 19:19
            @test between(startrev, Interval{:closed,:open}(11.0..14.1)) === 18:20
        end

        @testset "Center between" begin
            @test between(centerfwd, 0..11.4) === 1:0
            @test between(centerfwd, 0..11.5) === 1:1
            @test between(centerfwd, 29.5..50.0) === 20:20
            @test between(centerfwd, 29.6..50.0) === 21:20
            @test between(centerrev, 0..11.4) === 21:20
            @test between(centerrev, 0..11.5) === 20:20
            @test between(centerrev, 29.5..50.0) === 1:1
            @test between(centerrev, 29.6..50.0) === 1:0
            @test between(centerfwd, 0..40) === 1:20
            @test between(centerrev, 0..40) === 1:20
            # Bounds
            @test between(centerrev, 10.5..30.5) === 1:20
            @test between(centerrev, 10.5..30.5) === 1:20

            @test between(centerfwd, 10.5..14.5) === 1:4
            @test between(centerfwd, 10.6..14.4) === 2:3
            @test between(centerrev, 10.5..14.5) === 17:20
            @test between(centerrev, 10.6..14.4) === 18:19
            @test between(centerfwd, Interval{:open,:open}(10.4..14.6)) === 1:4
            @test between(centerfwd, Interval{:open,:open}(10.5..14.5)) === 2:3
            @test between(centerrev, Interval{:open,:open}(10.4..14.6)) === 17:20
            @test between(centerrev, Interval{:open,:open}(10.6..14.5)) === 18:19
            @test between(centerfwd, Interval{:open,:closed}(10.4..14.6)) === 1:4
            @test between(centerfwd, Interval{:open,:closed}(10.5..14.4)) === 2:3
            @test between(centerrev, Interval{:open,:closed}(10.4..14.6)) === 17:20
            @test between(centerrev, Interval{:open,:closed}(10.5..14.4)) === 18:19
            @test between(centerfwd, Interval{:closed,:open}(10.5..14.6)) === 1:4
            @test between(centerfwd, Interval{:closed,:open}(10.6..14.5)) === 2:3
            @test between(centerrev, Interval{:closed,:open}(10.5..14.6)) === 17:20
            @test between(centerrev, Interval{:closed,:open}(10.6..14.5)) === 18:19
        end

        @testset "End between" begin
            @test between(endfwd, 0.0..10.9) === 1:0
            @test between(endfwd, 0..11) === 1:1
            @test between(endfwd, 29.0..30.0) === 20:20
            @test between(endfwd, 29.1..50.0) === 21:20
            @test between(endrev, 0.0..10.9) === 21:20
            @test between(endrev, 0.0..11.0) === 20:20
            @test between(endrev, 29.0..50.0) === 1:1
            @test between(endrev, 29.1..50.0) === 1:0
            @test between(endfwd, 0..40) === 1:20
            @test between(endrev, 0..40) === 1:20
            # Bounds
            @test between(endfwd, 10.0..30.0) === 1:20
            @test between(endrev, 10.0..30.0) === 1:20

            @test between(endfwd, 10.0..15.0) === 1:5
            @test between(endfwd, 10.1..14.9) === 2:4
            @test between(endrev, 10.0..15.0) === 16:20
            @test between(endrev, 10.1..14.9) === 17:19
            @test between(endfwd, Interval{:open,:open}( 9.9..15.1)) === 1:5
            @test between(endfwd, Interval{:open,:open}(10.0..15.0)) === 2:4
            @test between(endrev, Interval{:open,:open}( 9.9..15.1)) === 16:20
            @test between(endrev, Interval{:open,:open}(10.0..15.0)) === 17:19
            @test between(endfwd, Interval{:open,:closed}( 9.9..15.0)) === 1:5
            @test between(endfwd, Interval{:open,:closed}(10.0..14.9)) === 2:4
            @test between(endrev, Interval{:open,:closed}( 9.9..15.0)) === 16:20
            @test between(endrev, Interval{:open,:closed}(10.0..14.9)) === 17:19
            @test between(endfwd, Interval{:closed,:open}(10.0..15.1)) === 1:5
            @test between(endfwd, Interval{:closed,:open}(10.1..15.0)) === 2:4
            @test between(endrev, Interval{:closed,:open}(10.0..15.1)) === 16:20
            @test between(endrev, Interval{:closed,:open}(10.1..15.0)) === 17:19
        end

        @testset "Start touches" begin
            @test touches(startfwd, Touches(0, 10.9)) === 1:0
            @test touches(startfwd, Touches(0, 11)) === 1:1
            @test touches(startfwd, Touches(31, 50)) === 20:20
            @test touches(startfwd, Touches(31.1, 50)) === 21:20
            @test touches(startrev, Touches(0, 10.9)) === 21:20
            @test touches(startrev, Touches(0, 11)) === 20:20
            @test touches(startrev, Touches(31, 50)) === 1:1
            @test touches(startrev, Touches(31.1, 50)) === 1:0
            @test touches(startfwd, Touches(0, 40)) === 1:20
            @test touches(startrev, Touches(0, 40)) === 1:20
            # Bounds
            @test touches(startfwd, Touches(11.0, 31.0)) === 1:20
            @test touches(startrev, Touches(11.0, 31.0)) === 1:20

            @test touches(startfwd, Touches(12.1, 12.9)) === 2:2
            @test touches(startfwd, Touches(12.0, 13.0)) === 1:3
            @test touches(startrev, Touches(12.1, 12.9)) === 19:19
            @test touches(startrev, Touches(12.0, 13.0)) === 18:20
        end

        @testset "Center touches" begin
            @test touches(centerfwd, Touches(0, 10.4)) === 1:0
            @test touches(centerfwd, Touches(0, 10.5)) === 1:1
            @test touches(centerfwd, Touches(30.5, 50.0)) === 20:20
            @test touches(centerfwd, Touches(30.6, 50.0)) === 21:20
            @test touches(centerrev, Touches(0, 10.4)) === 21:20
            @test touches(centerrev, Touches(0, 10.5)) === 20:20
            @test touches(centerrev, Touches(30.5, 50.0)) === 1:1
            @test touches(centerrev, Touches(30.6, 50.0)) === 1:0
            @test touches(centerfwd, Touches(0, 40)) === 1:20
            @test touches(centerrev, Touches(0, 40)) === 1:20
            # Bounds
            @test touches(centerrev, Touches(11.5, 29.5)) === 1:20
            @test touches(centerrev, Touches(11.5, 29.5)) === 1:20

            @test touches(centerfwd, Touches(11.5, 13.5)) === 1:4
            @test touches(centerfwd, Touches(11.6, 13.4)) === 2:3
            @test touches(centerrev, Touches(11.5, 13.5)) === 17:20
            @test touches(centerrev, Touches(11.6, 13.4)) === 18:19
        end

        @testset "End touches" begin
            @test touches(endfwd, Touches(0.0, 9.9)) === 1:0
            @test touches(endfwd, Touches(0, 10)) === 1:1
            @test touches(endfwd, Touches(30.0, 30.0)) === 20:20
            @test touches(endfwd, Touches(30.1, 50.0)) === 21:20
            @test touches(endrev, Touches(0.0, 9.9)) === 21:20
            @test touches(endrev, Touches(0.0, 10.0)) === 20:20
            @test touches(endrev, Touches(30.0, 50.0)) === 1:1
            @test touches(endrev, Touches(30.1, 50.0)) === 1:0
            @test touches(endfwd, Touches(0, 40)) === 1:20
            @test touches(endrev, Touches(0, 40)) === 1:20
            # Bounds
            @test touches(endfwd, Touches(11.0, 29.0)) === 1:20
            @test touches(endrev, Touches(11.0, 29.0)) === 1:20

            @test touches(endfwd, Touches(11.0, 14.0)) === 1:5
            @test touches(endfwd, Touches(11.1, 13.9)) === 2:4
            @test touches(endrev, Touches(11.0, 14.0)) === 16:20
            @test touches(endrev, Touches(11.1, 13.9)) === 17:19
        end

        @testset "Start contains" begin
            @test_throws SelectorError contains(startfwd, Contains(10.9))
            @test_throws SelectorError contains(startrev, Contains(31))
            @test contains(startfwd, Contains(11)) == 1
            @test contains(startfwd, Contains(11.9)) == 1
            @test contains(startfwd, Contains(12.0)) == 2
            @test contains(startfwd, Contains(30.0)) == 20
            @test contains(startfwd, Contains(29.9)) == 19
            @test contains(startrev, Contains(11.9)) == 20
            @test contains(startrev, Contains(12.0)) == 19
            @test contains(startrev, Contains(30.9)) == 1
            @test contains(startrev, Contains(30.0)) == 1
            @test contains(startrev, Contains(29.0)) == 2
        end

        @testset "Center contains" begin
            @test_throws SelectorError contains(centerfwd, Contains(10.4))
            @test_throws SelectorError contains(centerfwd, Contains(30.5))
            @test_throws SelectorError contains(centerrev, Contains(10.4))
            @test_throws SelectorError contains(centerrev, Contains(30.5))
            @test contains(centerfwd, Contains(10.5)) == 1
            @test contains(centerfwd, Contains(30.4)) == 20
            @test contains(centerfwd, Contains(29.5)) == 20
            @test contains(centerfwd, Contains(29.4)) == 19
            @test contains(centerrev, Contains(10.5)) == 20
            @test contains(centerrev, Contains(30.4)) == 1
            @test contains(centerrev, Contains(29.5)) == 1
            @test contains(centerrev, Contains(29.4)) == 2
        end

        @testset "End contains" begin
            @test_throws SelectorError contains(endfwd, Contains(10))
            @test_throws SelectorError contains(endfwd, Contains(30.1))
            @test_throws SelectorError contains(endrev, Contains(10))
            @test_throws SelectorError contains(endrev, Contains(30.1))
            @test contains(endfwd, Contains(10.1)) == 1
            @test contains(endfwd, Contains(11.0)) == 1
            @test contains(endfwd, Contains(11.1)) == 2
            @test contains(endfwd, Contains(29.0)) == 19
            @test contains(endfwd, Contains(29.1)) == 20
            @test contains(endfwd, Contains(30.0)) == 20
            @test contains(endrev, Contains(10.1)) == 20
            @test contains(endrev, Contains(11.0)) == 20
            @test contains(endrev, Contains(11.1)) == 19
            @test contains(endrev, Contains(29.0)) == 2
            @test contains(endrev, Contains(29.1)) == 1
            @test contains(endrev, Contains(30.0)) == 1
            @test contains(endrev, Contains(11.0)) == 20
            @test contains(endrev, Contains(11.1)) == 19
        end

        @testset "Start near" begin
            @test bounds(startfwd) == bounds(startrev)
            @test near(startfwd, Near(-100)) == 1
            @test near(startfwd, Near(11.9)) == 1
            @test near(startfwd, Near(12.0)) == 2
            @test near(startfwd, Near(30.0)) == 20
            @test near(startfwd, Near(29.9)) == 19
            @test near(startrev, Near(11.9)) == 20
            @test near(startrev, Near(12.0)) == 19
            @test near(startrev, Near(29.0)) == 2
            @test near(startrev, Near(30.0)) == 1
            @test near(startfwd, Near(100)) == 20
        end

        @testset "Center near" begin
            @test near(centerfwd, Near(10.4)) == 1
            @test near(centerfwd, Near(30.5)) == 20
            @test near(centerrev, Near(10.4)) == 20
            @test near(centerrev, Near(30.5)) == 1
            @test near(centerfwd, Near(10.5)) == 1
            @test near(centerfwd, Near(30.4)) == 20
            @test near(centerfwd, Near(29.5)) == 20
            @test near(centerfwd, Near(29.4)) == 19
            @test near(centerrev, Near(10.5)) == 20
            @test near(centerrev, Near(30.4)) == 1
            @test near(centerrev, Near(29.5)) == 1
            @test near(centerrev, Near(29.4)) == 2
        end

        @testset "End near" begin
            @test near(endfwd, Near(10)) == 1
            @test near(endfwd, Near(11.0)) == 1
            @test near(endfwd, Near(11.1)) == 2
            @test near(endfwd, Near(29.0)) == 19
            @test near(endfwd, Near(29.1)) == 20
            @test near(endfwd, Near(30.0)) == 20
            @test near(endfwd, Near(31.1)) == 20
            @test near(endrev, Near(10)) == 20
            @test near(endrev, Near(11.0)) == 20
            @test near(endrev, Near(11.1)) == 19
            @test near(endrev, Near(29.0)) == 2
            @test near(endrev, Near(29.1)) == 1
            @test near(endrev, Near(30.0)) == 1
            @test near(endrev, Near(31.1)) == 1
            @test near(endrev, Near(11.0)) == 20
            @test near(endrev, Near(11.1)) == 19
            @test near(endrev, Near(29.0)) == 2
            @test near(endrev, Near(29.1)) == 1
            @test near(endfwd, Near(-100)) == 1
            @test near(endfwd, Near(100)) == 20
        end

    end

    @testset "Regular Intervals with array" begin
        startfwd = Sampled([1, 3, 4, 5], ForwardOrdered(), Regular(1), Intervals(Start()), NoMetadata())
        startrev = Sampled([5, 4, 3, 1], ReverseOrdered(), Regular(-1), Intervals(Start()), NoMetadata())
        @test_throws SelectorError contains(startfwd, Contains(0.9))
        @test contains(startfwd, Contains(1.0)) == 1
        @test contains(startfwd, Contains(1.9)) == 1
        @test_throws ArgumentError contains(startfwd, Contains(2))
        @test_throws ArgumentError contains(startfwd, Contains(2.9))
        @test contains(startfwd, Contains(3)) == 2
        @test contains(startfwd, Contains(5.9)) == 4
        @test_throws SelectorError contains(startfwd, Contains(6))
        @test_throws SelectorError contains(startrev, Contains(0.9))
        @test contains(startrev, Contains(1.0)) == 4
        @test contains(startrev, Contains(1.9)) == 4
        @test_throws ArgumentError contains(startrev, Contains(2))
        @test_throws ArgumentError contains(startrev, Contains(2.9))
        @test contains(startrev, Contains(3)) == 3
        @test contains(startrev, Contains(5.9)) == 1
        @test_throws SelectorError contains(startrev, Contains(6))
    end

    @testset "Irregular Intervals with array" begin
        # Order: index, array, relation (array order is irrelevent here, it's just for plotting)
        # Varnames: locusindexorderrelation
        args = Irregular(1.0, 121.0), Intervals(Start()), NoMetadata()
        startfwd = Sampled((1.0:10.0).^2,    ForwardOrdered(), args...)
        startrev = Sampled((10.0:-1.0:1.0).^2, ReverseOrdered(), args...)

        args = Irregular(0.5, 111.5), Intervals(Center()), NoMetadata()
        centerfwd = Sampled((1.0:10.0).^2,      ForwardOrdered(), args...)
        centerrev = Sampled((10.0:-1.0:1.0).^2, ReverseOrdered(), args...)

        args = Irregular(0.0, 100.0), Intervals(End()), NoMetadata()
        endfwd = Sampled((1.0:10.0).^2,      ForwardOrdered(), args...)
        endrev = Sampled((10.0:-1.0:1.0).^2, ReverseOrdered(), args...)

        @testset "Any at" begin
            @test at(startfwd, At(25)) == 5
            @test at(startrev, At(25)) == 6
            @test at(startfwd, At(100)) == 10
            @test at(startrev, At(100)) == 1
        end

        @testset "Start between" begin
            # Handle searchorted overflow
            @test between(startfwd, 0..0) === 1:0
            @test between(startfwd, 130..130) === 11:10
            @test between(startrev, 0..0) === 11:10
            @test between(startrev, 130..130) === 1:0
            @test between(startfwd, -100..9) === 1:2
            @test between(startfwd, 80..150) === 9:10
            @test between(startrev, -100..9) === 9:10
            @test between(startrev, 80..150) === 1:2
            @test between(startfwd, -200..200) === 1:10
            @test between(startrev, -200..200) === 1:10
            # Bounds
            @test between(startfwd, 1.0..121.0) === 1:10
            @test between(startrev, 1.0..121.0) === 1:10
            @test between(startfwd, Interval{:open,:open}(1.0..121.0)) === 2:9
            @test between(startrev, Interval{:open,:open}(1.0..121.0)) === 2:9

            @test between(startfwd, 9..36) === 3:5
            @test between(startfwd, 9.1..35.0) === 4:4
            @test between(startrev, 9..36) === 6:8
            @test between(startrev, 9.1..35.9) === 7:7
            @test between(startfwd, Interval{:open,:open}(8.9..36.1)) === 3:5
            @test between(startfwd, Interval{:open,:open}(9.0..36.0)) === 4:4
            @test between(startrev, Interval{:open,:open}(8.9..36.1)) === 6:8
            @test between(startrev, Interval{:open,:open}(9..36)) === 7:7
            @test between(startfwd, Interval{:open,:closed}(8.9..36)) === 3:5
            @test between(startfwd, Interval{:open,:closed}(9.0..35.9)) === 4:4
            @test between(startrev, Interval{:open,:closed}(8.9..36)) === 6:8
            @test between(startrev, Interval{:open,:closed}(9.0..35.9)) === 7:7
            @test between(startfwd, Interval{:closed,:open}(9.0..36.1)) === 3:5
            @test between(startfwd, Interval{:closed,:open}(9.1..36.0)) === 4:4
            @test between(startrev, Interval{:closed,:open}(9.0..36.1)) === 6:8
            @test between(startrev, Interval{:closed,:open}(9.1..36.0)) === 7:7

        end


        @testset "Center between" begin
            # Handle searchorted overflow
            @test between(centerfwd, 0..0) === 1:0
            @test between(centerfwd, 0..0) === 1:0
            @test between(centerfwd, -100..9) === 1:2
            @test between(centerfwd, 70..150) === 9:10
            @test between(centerfwd, 130..130) === 11:10
            @test between(centerrev, 0..0) === 11:10
            @test between(centerrev, -100..9) === 9:10
            @test between(centerrev, 70..150) === 1:2
            @test between(centerrev, 130..130) === 1:0
            @test between(centerfwd, -200..200) === 1:10
            @test between(centerrev, -200..200) === 1:10
            # Bounds
            @test between(centerfwd, 0.5..111.5) === 1:10
            @test between(centerrev, 0.5..111.5) === 1:10
            @test between(centerfwd, Interval{:open,:open}(0.5..111.5)) === 2:9
            @test between(centerrev, Interval{:open,:open}(0.5..111.5)) === 2:9
    

            @test between(centerfwd, 6.5..30.5) === 3:5
            @test between(centerfwd, 6.6..30.4) === 4:4
            @test between(centerrev, 6.5..30.5) === 6:8
            @test between(centerrev, 6.6..30.4) === 7:7
            @test between(centerfwd, Interval{:open,:open}(6.4..30.6)) === 3:5
            @test between(centerfwd, Interval{:open,:open}(6.5..30.5)) === 4:4
            @test between(centerrev, Interval{:open,:open}(6.4..30.6)) === 6:8
            @test between(centerrev, Interval{:open,:open}(6.5..30.5)) === 7:7
            @test between(centerfwd, Interval{:open,:closed}(6.4..30.5)) === 3:5
            @test between(centerfwd, Interval{:open,:closed}(6.5..30.4)) === 4:4
            @test between(centerrev, Interval{:open,:closed}(6.4..30.5)) === 6:8
            @test between(centerrev, Interval{:open,:closed}(6.5..30.4)) === 7:7
            @test between(centerfwd, Interval{:closed,:open}(6.5..30.6)) === 3:5
            @test between(centerfwd, Interval{:closed,:open}(6.6..30.5)) === 4:4
            @test between(centerrev, Interval{:closed,:open}(6.5..30.6)) === 6:8
            @test between(centerrev, Interval{:closed,:open}(6.6..30.5)) === 7:7

        end

        @testset "End between" begin
            # Handle searchorted overflow
            @test between(endfwd, -1 .. -1) === 1:0
            @test between(endfwd, 130..130) === 11:10
            @test between(endrev, -1 .. -1) === 11:10
            @test between(endrev, 130..130) === 1:0
            @test between(endfwd, -100..4) === 1:2
            @test between(endfwd, 64..150) === 9:10
            @test between(endrev, -100..4) === 9:10
            @test between(endrev, 64..150) === 1:2
            @test between(endfwd, -200..200) === 1:10
            @test between(endrev, -200..200) === 1:10
            # Bounds
            @test between(endfwd, 0.0..100.0) === 1:10
            @test between(endrev, 0.0..100.0) === 1:10
            @test between(endfwd, Interval{:open,:open}(0.0..100.0)) === 2:9
            @test between(endrev, Interval{:open,:open}(0.0..100.0)) === 2:9

            @test between(endfwd, 4.0..25.0) === 3:5
            @test between(endrev, 4.0..25.0) === 6:8
            @test between(endfwd, 4.1..24.9) === 4:4
            @test between(endrev, 4.1..24.9) === 7:7
            @test between(endfwd, Interval{:open,:open}(3.9..25.1)) === 3:5
            @test between(endrev, Interval{:open,:open}(3.9..25.1)) === 6:8
            @test between(endfwd, Interval{:open,:open}(4.0..25.0)) === 4:4
            @test between(endrev, Interval{:open,:open}(4.0..25.0)) === 7:7
            @test between(endfwd, Interval{:open,:closed}(3.9..25.0)) === 3:5
            @test between(endrev, Interval{:open,:closed}(3.9..25.0)) === 6:8
            @test between(endfwd, Interval{:open,:closed}(4.0..24.9)) === 4:4
            @test between(endrev, Interval{:open,:closed}(4.0..24.9)) === 7:7
            @test between(endfwd, Interval{:closed,:open}(4.0..25.1)) === 3:5
            @test between(endrev, Interval{:closed,:open}(4.0..25.1)) === 6:8
            @test between(endfwd, Interval{:closed,:open}(4.1..25.0)) === 4:4
            @test between(endrev, Interval{:closed,:open}(4.1..25.0)) === 7:7
        end

        @testset "Start touches" begin
            # Handle searchorted overflow
            @test touches(startfwd, Touches(0, 0)) === 1:0
            @test touches(startfwd, Touches(130, 130)) === 11:10
            @test touches(startrev, Touches(0, 0)) === 11:10
            @test touches(startrev, Touches(130, 130)) === 1:0
            @test touches(startfwd, Touches(-100, 4)) === 1:2
            @test touches(startfwd, Touches(99, 150)) === 9:10
            @test touches(startrev, Touches(-100, 4)) === 9:10
            @test touches(startrev, Touches(99, 150)) === 1:2
            @test touches(startfwd, Touches(-200, 200)) === 1:10
            @test touches(startrev, Touches(-200, 200)) === 1:10
            # Bounds
            @test touches(startfwd, Touches(4.0, 100.0)) === 1:10
            @test touches(startrev, Touches(4.0, 100.0)) === 1:10

            @test touches(startfwd, Touches(16, 25)) === 3:5
            @test touches(startfwd, Touches(16.1, 24.9)) === 4:4
            @test touches(startrev, Touches(16, 25)) === 6:8
            @test touches(startrev, Touches(16.1, 24.9)) === 7:7
        end


        @testset "Center touches" begin
            # Handle searchorted overflow
            @test touches(centerfwd, Touches(0, 0)) === 1:0
            @test touches(centerfwd, Touches(0, 0)) === 1:0
            @test touches(centerfwd, Touches(-100, 3)) === 1:2
            @test touches(centerfwd, Touches(72.6, 150)) === 9:10 # 72.5 ?
            @test touches(centerfwd, Touches(130, 130)) === 11:10
            @test touches(centerrev, Touches(0, 0)) === 11:10
            @test touches(centerrev, Touches(-100, 4)) === 9:10
            @test touches(centerrev, Touches(72.6, 150)) === 1:2
            @test touches(centerrev, Touches(130, 130)) === 1:0
            @test touches(centerfwd, Touches(-200, 200)) === 1:10
            @test touches(centerrev, Touches(-200, 200)) === 1:10
            # Bounds
            @test touches(centerfwd, Touches(2.5, 90.5)) === 1:10
            @test touches(centerrev, Touches(2.5, 90.5)) === 1:10
            @test touches(centerfwd, Touches(2.6, 90.4)) === 2:9
            @test touches(centerrev, Touches(2.6, 90.4)) === 2:9
    
            @test touches(centerfwd, Touches(12.5, 20.5)) === 3:5
            @test touches(centerfwd, Touches(12.6, 20.4)) === 4:4
            @test touches(centerrev, Touches(12.5, 20.5)) === 6:8
            @test touches(centerrev, Touches(12.6, 20.4)) === 7:7
        end

        @testset "End touches" begin
            # Handle searchorted overflow
            @test touches(endfwd, Touches(-1 ,  -1)) === 1:0
            @test touches(endfwd, Touches(130, 130)) === 11:10
            @test touches(endrev, Touches(-1 ,  -1)) === 11:10
            @test touches(endrev, Touches(130, 130)) === 1:0
            @test touches(endfwd, Touches(-100, 1)) === 1:2
            @test touches(endfwd, Touches(81, 150)) === 9:10
            @test touches(endrev, Touches(-100, 1)) === 9:10
            @test touches(endrev, Touches(81, 150)) === 1:2
            @test touches(endfwd, Touches(-200, 200)) === 1:10
            @test touches(endrev, Touches(-200, 200)) === 1:10
            # Bounds
            @test touches(endfwd, Touches(1.0, 81.0)) === 1:10
            @test touches(endrev, Touches(1.0, 81.0)) === 1:10

            @test touches(endfwd, Touches(9.0, 16.0)) === 3:5
            @test touches(endrev, Touches(9.0, 16.0)) === 6:8
            @test touches(endfwd, Touches(9.1, 15.9)) === 4:4
            @test touches(endrev, Touches(9.1, 15.9)) === 7:7
        end

        @testset "Start contains" begin
            @test_throws SelectorError contains(startfwd, Contains(0.9))
            @test_throws SelectorError contains(startfwd, Contains(121.1))
            @test contains(startfwd, Contains(1)) == 1
            @test contains(startfwd, Contains(3.9)) == 1
            @test contains(startfwd, Contains(4.0)) == 2
            @test contains(startfwd, Contains(100.0)) == 10
            @test contains(startfwd, Contains(99.9)) == 9
            @test_throws SelectorError contains(startrev, Contains(0.9))
            @test_throws SelectorError contains(startrev, Contains(121.1))
            @test contains(startrev, Contains(3.9)) == 10
            @test contains(startrev, Contains(4.0)) == 9
            @test contains(startrev, Contains(120.9)) == 1
            @test contains(startrev, Contains(100.0)) == 1
            @test contains(startrev, Contains(99.0)) == 2
        end

        @testset "Center contains" begin
            @test_throws SelectorError contains(centerfwd, Contains(0.4))
            @test_throws SelectorError contains(centerfwd, Contains(111.5))
            @test contains(centerfwd, Contains(0.5)) == 1
            @test contains(centerfwd, Contains(111.4)) == 10
            @test contains(centerfwd, Contains(90.5)) == 10
            @test contains(centerfwd, Contains(90.4)) == 9
            @test_throws SelectorError contains(centerrev, Contains(0.4))
            @test_throws SelectorError contains(centerrev, Contains(111.5))
            @test contains(centerrev, Contains(72.5)) == 2
            @test contains(centerrev, Contains(72.4)) == 3
            @test contains(centerrev, Contains(0.5)) == 10
            @test contains(centerrev, Contains(111.4)) == 1
            @test contains(centerrev, Contains(90.5)) == 1
            @test contains(centerrev, Contains(90.4)) == 2
        end

        @testset "End contains" begin
            @test_throws SelectorError contains(endfwd, Contains(-0.1))
            @test_throws SelectorError contains(endfwd, Contains(100.1))
            @test_throws SelectorError contains(endrev, Contains(-0.1))
            @test_throws SelectorError contains(endrev, Contains(100.1))
            @test contains(endfwd, Contains(0.1)) == 1
            @test contains(endfwd, Contains(1.0)) == 1
            @test contains(endfwd, Contains(1.1)) == 2
            @test contains(endfwd, Contains(81.0)) == 9
            @test contains(endfwd, Contains(81.1)) == 10
            @test contains(endfwd, Contains(100.0)) == 10
            @test contains(endrev, Contains(0.1)) == 10
            @test contains(endrev, Contains(1.0)) == 10
            @test contains(endrev, Contains(1.1)) == 9
            @test contains(endrev, Contains(81.0)) == 2
            @test contains(endrev, Contains(81.1)) == 1
            @test contains(endrev, Contains(100.0)) == 1
        end

    end

    @testset "Points lookup" begin
        fwd = Sampled(5.0:30.0;      order=ForwardOrdered(), sampling=Points())
        rev = Sampled(30.0:-1.0:5.0; order=ReverseOrdered(), sampling=Points())

        @testset "between" begin
            @test between(fwd, 0..4.9) === 1:0
            @test between(fwd, 0..5) === 1:1
            @test between(fwd, 30..31) === 26:26
            @test between(fwd, 10..14.9) === 6:10
            @test between(fwd, 10..15) === 6:11
            @test between(rev, 10..14.9) === 17:21
            @test between(rev, 10..15) === 16:21
            @test between(rev, 0..4.9) === 27:26
            @test between(rev, 0..5) === 26:26
            @test between(rev, 30..31) === 1:1

            @test between(fwd, OpenInterval(0..5)) === 1:0
            @test between(fwd, OpenInterval(0..5.1)) === 1:1
            @test between(fwd, OpenInterval(30..31)) === 27:26
            @test between(fwd, OpenInterval(10..15)) === 7:10
            @test between(fwd, OpenInterval(10..15.1)) === 7:11
            @test between(rev, OpenInterval(10..15)) === 17:20
            @test between(rev, OpenInterval(10..15.1)) === 16:20
            @test between(rev, OpenInterval(0..5)) === 27:26
            @test between(rev, OpenInterval(0..5.1)) === 26:26
            @test between(rev, OpenInterval(30..31)) === 1:0

            @test between(fwd, Interval{:open,:closed}(0..4.9)) === 1:0
            @test between(fwd, Interval{:open,:closed}(0..5.0)) === 1:1
            @test between(fwd, Interval{:open,:closed}(30..31)) === 27:26
            @test between(fwd, Interval{:open,:closed}(10..14.9)) === 7:10
            @test between(fwd, Interval{:open,:closed}(10..15.0)) === 7:11
            @test between(rev, Interval{:open,:closed}(10..14.9)) === 17:20
            @test between(rev, Interval{:open,:closed}(10..15.0)) === 16:20
            @test between(rev, Interval{:open,:closed}(0..4.9)) === 27:26
            @test between(rev, Interval{:open,:closed}(0..5.0)) === 26:26
            @test between(rev, Interval{:open,:closed}(30..31)) === 1:0

            @test between(fwd, Interval{:closed,:open}(0..5.0)) === 1:0
            @test between(fwd, Interval{:closed,:open}(0..5.1)) === 1:1
            @test between(fwd, Interval{:closed,:open}(30..31)) === 26:26
            @test between(fwd, Interval{:closed,:open}(10..15)) === 6:10
            @test between(fwd, Interval{:closed,:open}(10..15.1)) === 6:11
            @test between(rev, Interval{:closed,:open}(10..15)) === 17:21
            @test between(rev, Interval{:closed,:open}(10..15.1)) === 16:21
            @test between(rev, Interval{:closed,:open}(0..5.0)) === 27:26
            @test between(rev, Interval{:closed,:open}(0..5.1)) === 26:26
            @test between(rev, Interval{:closed,:open}(30..31)) === 1:1
            
            fwd1 = Sampled(5.0:5.0; order=ForwardOrdered(), sampling=Points())
            rev1 = Sampled(5.0:-1.0:5.0; order=ReverseOrdered(), sampling=Points())
            @test between(fwd1, 5..5) === 1:1
            @test between(rev1, 5..5) === 1:1
            @test between(fwd1, OpenInterval(5..5)) === 1:0
            @test between(rev1, OpenInterval(5..5)) === 1:0
        end

        @testset "at" begin
            @test at(fwd, At(30)) == 26
            @test at(rev, At(30)) == 1
        end

        @testset "contains" begin
            @test contains(fwd, Contains(30)) == 26
            @test contains(rev, Contains(30)) == 1
        end

        @testset "near" begin
            @test near(fwd, Near(50))   == 26
            @test near(fwd, Near(0))    == 1
            @test near(fwd, Near(29.4)) == 25
            @test near(fwd, Near(29.5)) == 26
            @test near(rev, Near(29.4)) == 2
            @test near(rev, Near(30.1)) == 1
            @test_throws ArgumentError near(Sampled((5.0:30.0); order=Unordered(), sampling=Points()), Near(30.1))
        end

    end

end

@testset "Selectors on Sampled Points" begin
    da = DimArray(a, (Y(Sampled(10:10:30)), Ti(Sampled((1:4)u"s"))))

    @test At(10.0) == At(10.0; atol=nothing)
    @test At(10.0; atol=0.0).atol == 0.0

    @test Between(10, 20) == Between((10, 20))

    @testset "selectors with dim wrappers" begin
        @test @inferred da[Y(At([10, 30])), Ti(At([1u"s", 4u"s"]))] == [1 4; 9 12]
        @test_throws SelectorError da[Y(At([9, 30])), Ti(At([1u"s", 4u"s"]))]
        @test @inferred view(da, Y(At(20)), Ti(At((3:4)u"s"))) == [7, 8]
        @test @inferred view(da, Y(Near(17)), Ti(Near([1.5u"s", 3.1u"s"]))) == [6, 7]
        @test @inferred view(da, Y(Between(9, 21)), Ti(At((3:4)u"s"))) == [3 4; 7 8]
    end

    @testset "selectors without dim wrappers" begin
        @test @inferred da[At(20:10:30), At(1u"s")] == [5, 9]
        @test @inferred view(da, Between(9, 31), Near((3:4)u"s")) == [3 4; 7 8; 11 12]
        @test @inferred view(da, Near(22), At([3.0u"s", 4.0u"s"])) == [7, 8]
        @test @inferred view(da, At(20), At((2:3)u"s")) == [6, 7]
        @test @inferred view(da, Near(13), Near([1.3u"s", 3.3u"s"])) == [1, 3]
        # Near works with a tuple input
        @test @inferred view(da, Near([13]), Near([1.3u"s", 3.3u"s"])) == [1 3]
        @test @inferred view(da, Between(11, 20), At((2:3)u"s")) == [6 7]
        # Between also accepts a tuple input
        @test @inferred view(da, Between((11, 20)), Between((2u"s", 3u"s"))) == [6 7]
    end

    @testset "mixed selectors and standard" begin
        selectors = [
            (Between(9, 31), Near((3:4)u"s")),
            (Near(22), At([3.0u"s", 4.0u"s"])),
            (At(20), At((2:3)u"s")),
            (Near(13), Near([1.3u"s", 3.3u"s"])),
            (Near([13]), Near([1.3u"s", 3.3u"s"])),
            (Between(11, 20), At((2:3)u"s"))
        ]
        locuss =  [
            (1:3, [3, 4]),
            (2, [3, 4]),
            (2, [2, 3]),
            (1, [1, 3]),
            ([1], [1, 3]),
            (2:2, [2, 3])
        ]
        for (selector, pos) in zip(selectors, locuss)
            pairs = collect(zip(selector, pos))
            cases = [(i, j) for i in pairs[1], j in pairs[2]]
            for (case1, case2) in combinations(cases, 2)
                @test da[case1...] == da[case2...]
                @test view(da, case1...) == view(da, case2...)
                dac1, dac2 = copy(da), copy(da)
                sample = da[case1...]
                replacement  = sample isa Integer ? 100 : rand(Int, size(sample))
                # Test return value
                @test setindex!(dac1, replacement, case1...) == setindex!(dac2, replacement, case2...)
                # Test mutation
                @test dac1 == dac2
            end
        end
    end

    @testset "single-arity standard index" begin
        indices = [
            1:3,
            [1, 2, 4],
            4:-2:1,
        ]
        for idx in indices
            from2d = da[idx]
            @test from2d == parent(da)[idx]
            @test !(from2d isa AbstractDimArray)
            from1d = da[Y(At(10))][idx]
            @test from1d == parent(da)[1, :][idx]
            @test from1d isa AbstractDimArray
        end
    end

    @testset "single-arity views" begin
        indices = [
            3,
            1:3,
            [1, 2, 4],
            4:-2:1,
        ]
        for idx in indices
            from2d = view(da, idx)
            @test from2d == view(parent(da), idx)
            @test from2d isa SubArray
            from1d = view(da[Y(At(10))], idx)
            @test from1d == view(parent(da)[1, :], idx)
            @test from1d isa DimArray
        end
    end

    @testset "single-arity setindex!" begin
        indices = [
            3,
            1:3,
            [1, 2, 4],
            4:-2:1,
        ]
        for idx in indices
            idx = indices[1]
            # 2D case
            da2d = copy(da)
            a2d = copy(parent(da2d))
            replacement = zero(a2d[idx])
            @test setindex!(da2d, replacement, idx) == setindex!(a2d, replacement, idx)
            @test da2d == a2d
            # 1D array
            da1d = da[Y(At(10))]
            a1d = copy(parent(da1d))
            @test setindex!(da1d, replacement, idx) == setindex!(a1d, replacement, idx)
            @test da1d == a1d
        end
    end

    @testset "more Unitful dims" begin
        dimz = Ti(1.0u"s":1.0u"s":3.0u"s"), Y(1u"km":1u"km":4u"km")
        db = DimArray(a, dimz)
        @test db[Y(Between(2u"km", 3.9u"km")), Ti(At(3.0u"s"))] == [10, 11]
    end

    @testset "selectors work in reverse orders" begin
        a = [1 2  3  4
             5 6  7  8
             9 10 11 12]

        @testset "forward index" begin
            da_fff = DimArray(a, (Y(Sampled(10:10:30; order=ForwardOrdered())),
                                  Ti(Sampled((1:4)u"s"; order=ForwardOrdered()))))
            @test da_fff[Y(At(20)), Ti(At((3.0:4.0)u"s"))] == [7, 8]
            @test da_fff[Y(At([20, 30])), Ti(At((3.0:4.0)u"s"))] == [7 8; 11 12]
            @test da_fff[Y(Near(22)), Ti(Near([3.3u"s", 4.3u"s"]))] == [7, 8]
            @test da_fff[Y(Near([22, 42])), Ti(Near([3.3u"s", 4.3u"s"]))] == [7 8; 11 12]
            @test da_fff[Y(Between(20, 30)), Ti(Between(3.0u"s", 4.0u"s"))] == [7 8; 11 12]
        end

        @testset "reverse index" begin
            da_rff = DimArray(a, (Y(Sampled(30:-10:10; order=ReverseOrdered())),
                                  Ti(Sampled((4:-1:1)u"s"; order=ReverseOrdered()))))
            @test da_rff[Y(At(20)), Ti(At((3.0:4.0)u"s"))] == [6, 5]
            @test da_rff[Y(At([20, 30])), Ti(At((3.0:4.0)u"s"))] == [6 5; 2 1]
            @test da_rff[Y(Near(22)), Ti(Near([3.3u"s", 4.3u"s"]))] == [6, 5]
            @test da_rff[Y(Near([22, 42])), Ti(Near([3.3u"s", 4.3u"s"]))] == [6 5; 2 1]
            # Between hasn't reverse the index order
            @test da_rff[Y(Between(20, 30)), Ti(Between(3.0u"s", 4.0u"s"))] == [1 2; 5 6]
        end

    end

    @testset "setindex! with selectors" begin
        c = deepcopy(a)
        dc = DimArray(c, (Y(10:10:30), Ti((1:4)u"s")))
        dc[Near(11), At(3u"s")] = 100
        @test c[1, 3] == 100
        @inferred setindex!(dc, [200, 201, 202], Ti(Near(2.2u"s")), Y(Between(10, 30)))
        @test c[1:3, 2] == [200, 201, 202]
    end

    @testset "Where " begin
        @test val(Where(identity)) == identity
        dimz = Ti((1:1:3)u"s"), Y(10:10:40)
        da = DimArray(a, dimz)
        wda = da[Y(Where(x -> x >= 30)), Ti(Where(x -> x in([2u"s", 3u"s"])))]
        @test parent(wda) == [7 8; 11 12]
        @test all(lookup(wda) .== ([2u"s", 3u"s"], [30, 40]))
    end

    @testset "All" begin
        dimz = X(10.0:20:200.0), Ti(1u"s":5u"s":100u"s")
        A = DimArray((1:10) * (1:20)', dimz)
        aA = A[X=All(At(10.0), At(50.0)), Ti=All(1u"s"..10u"s", 90u"s"..100u"s")]
        @test parent(aA) == 
            [1  2  19  20
             3  6  57  60]
    end

    @testset "Not " begin
        dimz = X(1.0:2:10.0), Ti(1u"s":5u"s":11u"s")
        A = DimArray((1:5) * (1:3)', dimz)
        A1 = A[X=Not(Near(5.1)), Ti=Not(1u"s" .. 10u"s")]
        A2 = A[Ti=Not(At(1u"s"))]
        A3 = A[X=Not(At([1.0,3.0]))]
        @test lookup(A2, :Ti) == [6u"s", 11u"s"]
        @test lookup(A3, :X) == [5.0,7.0,9.0]
        @test A1 == permutedims([3 6 12 15]) 
        @test lookup(A1, Ti) == [11u"s"]
        @test lookup(A1, X) == [1.0, 3.0, 7.0, 9.0]
    end

end

@testset "Selectors on Sampled Intervals" begin
    da = DimArray(a, (Y(Sampled(10:10:30; sampling=Intervals())),
                      Ti(Sampled((1:4)u"s"; sampling=Intervals()))))

    @testset "Extent indexing" begin
        # These should be the same because da is the maximum size
        # we can index with `Touches`
        @test da[Near(Extents.extent(da))] == da[Touches(Extents.extent(da))] == da[Extents.extent(da)] == da
        rda = reverse(da; dims=Y)
        @test rda[Near(Extents.extent(rda))] == rda[Touches(Extents.extent(rda))] == rda[Extents.extent(rda)] == rda
    end

    @testset "with dim wrappers" begin
        @test @inferred da[Y(At([10, 30])), Ti(At([1u"s", 4u"s"]))] == [1 4; 9 12]
        @test_throws SelectorError da[Y(At([9, 30])), Ti(At([1u"s", 4u"s"]))]
        @test @inferred view(da, Y(At(20)), Ti(At((3:4)u"s"))) == [7, 8]
        @test @inferred view(da, Y(Contains(17)), Ti(Contains([1.9u"s", 3.1u"s"]))) == [5, 7]
        @test @inferred view(da, Y(Between(4, 26)), Ti(At((3:4)u"s"))) == [3 4; 7 8]
        @test @inferred view(da, Y(Touches(4, 26)), Ti(At((3:4)u"s"))) == [3 4; 7 8; 11 12]
    end

    @testset "without dim wrappers" begin
        @test @inferred da[At(20:10:30), At(1u"s")] == [5, 9]
        @test @inferred view(da, Between(4, 36), Near((3:4)u"s")) == [3 4; 7 8; 11 12]
        @test @inferred view(da, Near(22), At([3.0u"s", 4.0u"s"])) == [7, 8]
        @test @inferred view(da, At(20), At((2:3)u"s")) == [6, 7]
        @test @inferred view(da, Near(13), Near([1.3u"s", 3.3u"s"])) == [1, 3]
        @test @inferred view(da, Near([13]), Near([1.3u"s", 3.3u"s"])) == [1 3]
        @test @inferred view(da, Between(11, 26), At((2:3)u"s")) == [6 7]
        @test @inferred view(da, Touches(11, 26), At((2:3)u"s")) == [2 3; 6 7; 10 11]
        # Between also accepts a tuple input
        @test @inferred view(da, Between((11, 26)), Between((2u"s", 4u"s"))) == [6 7]
    end

    @testset "out of bounds" begin
        @test size(view(da, Between(0, 4), At((2:3)u"s"))) == (0, 2)
        @test view(da, Between(0, 4), At((2:3)u"s")) isa DimArray{Int64,2}
        @test size(view(da, Between(40, 45), At((2:3)u"s"))) == (0, 2)
        @test view(da, Between(40, 45), At((2:3)u"s")) isa DimArray{Int64,2}
    end

    @testset "with DateTime lookup" begin
        @testset "Start locus" begin
            timedim = Ti(Sampled(DateTime(2001):Month(1):DateTime(2001, 12); 
                span=Regular(Month(1)), sampling=Intervals(Start())
            ))
            da = DimArray(1:12, timedim)
            @test @inferred da[Ti(At(DateTime(2001, 3)))] == 3
            @test @inferred da[Ti(At(Date(2001, 3)))] == 3
            @test @inferred da[Near(DateTime(2001, 4, 7))] == 4
            @test @inferred da[Near(Date(2001, 4, 7))] == 4
            @test @inferred da[DateTime(2001, 4, 7) .. DateTime(2001, 8, 30)] == [5, 6, 7]
            @test @inferred da[Date(2001, 4, 7) .. Date(2001, 8, 30)] == [5, 6, 7]

            @test_throws SelectorError da[Ti(At(Date(2001, 3, 4); atol=Day(2)))]
            @test @inferred da[Ti(At(Date(2001, 3, 4); atol=Day(3)))] == 3
            @test @inferred da[Ti(At(DateTime(2001, 3, 4); atol=Day(3)))] == 3
        end
        @testset "End locus" begin
            timedim = Ti(Sampled(DateTime(2001):Month(1):DateTime(2001, 12); 
                span=Regular(Month(1)), sampling=Intervals(End()))
            )
            da = DimArray(1:12, timedim)
            @test @inferred da[Ti(At(DateTime(2001, 3)))] == 3
            @test @inferred da[Ti(At(Date(2001, 3)))] == 3
            @test @inferred da[Near(DateTime(2001, 4, 7))] == 5
            @test @inferred da[Near(Date(2001, 4, 7))] == 5
            @test @inferred da[DateTime(2001, 4, 7) .. DateTime(2001, 8, 30)] == [6, 7, 8]
            @test @inferred da[Date(2001, 4, 7) .. Date(2001, 8, 30)] == [6, 7, 8]

            timedim = Ti(Sampled(Date(2001):Month(1):Date(2001, 12); 
                span=Regular(Month(1)), sampling=Intervals(End()))
            )
            da = DimArray(1:12, timedim)
            @test @inferred da[Ti(At(DateTime(2001, 3)))] == 3
            @test @inferred da[Ti(At(Date(2001, 3)))] == 3
            @test @inferred da[Near(DateTime(2001, 4, 7))] == 5
            @test @inferred da[Near(Date(2001, 4, 7))] == 5
            @test @inferred da[DateTime(2001, 4, 7) .. DateTime(2001, 8, 30)] == [6, 7, 8]
            @test @inferred da[Date(2001, 4, 7) .. Date(2001, 8, 30)] == [6, 7, 8]
        end
    end

    # @testset "with Val index" begin
    #     valdimz = Ti(Sampled(Val(2.0:2.0:6.0))), 
    #               Y(Sampled(Val(10.0:10.0:40)))
    #     da = DimArray(a, valdimz)
    #     @test @inferred da[Ti=Val(4.0), Y=Val(40.0)] == 8
    #     @test @inferred da[At(2.0), At(20.0)] == 2
    #     @test @inferred da[Near(Val{3.2}()), At(Val{20.0}())] == 6
    #     @test @inferred da[Near(3.2), At(20.0)] == 6
    # end

end

@testset "Selectors on Sampled Explicit Intervals" begin
    span_y = Explicit(vcat((5.0:10.0:25.0)', (15.0:10.0:35.0)'))
    span_ti = Explicit(vcat(((0.5:1.0:3.5)u"s")', ((1.5:1.0:4.5)u"s")'))
    da = DimArray(a, (Y(Sampled(10:10:30; span=span_y, sampling=Intervals())),
                      Ti(Sampled((1:4)u"s"; span=span_ti, sampling=Intervals()))))

    @testset "with dim wrappers" begin
        @test @inferred da[Y(At([10, 30])), Ti(At([1u"s", 4u"s"]))] == [1 4; 9 12]
        @test_throws SelectorError da[Y(At([9, 30])), Ti(At([1u"s", 4u"s"]))]
        @test @inferred view(da, Y(At(20)), Ti(At((3:4)u"s"))) == [7, 8]
        @test @inferred view(da, Y(Contains(17)), Ti(Contains([1.4u"s", 3.1u"s"]))) == [5, 7]
    end

    @testset "without dim wrappers" begin
        @test @inferred da[At(20:10:30), At(1u"s")] == [5, 9]
        @test @inferred view(da, Between(4, 36), Contains((3:4)u"s")) == [3 4; 7 8; 11 12]
        @test @inferred view(da, Contains(22), At([3.0u"s", 4.0u"s"])) == [7, 8]
        @test @inferred view(da, At(20), At((2:3)u"s")) == [6, 7]
        @test @inferred view(da, Contains(13), Contains([1.3u"s", 3.3u"s"])) == [1, 3]
        @test @inferred view(da, Contains([13]), Contains([1.3u"s", 3.3u"s"])) == [1 3]
        @test @inferred view(da, Between(11, 26), At((2:3)u"s")) == [6 7]
        @test @inferred view(da, Touches(11, 26), At((2:3)u"s")) == [2 3; 6 7; 10 11]
        # Between also accepts a tuple input
        @test @inferred view(da, Between((11, 26)), Between((1.4u"s", 4u"s"))) == [6 7]
    end

    @testset "with DateTime lookup" begin
        span_ti = Explicit(vcat(
            reshape((DateTime(2001, 1):Month(1):DateTime(2001, 12)), 1, 12),
            reshape((DateTime(2001, 2):Month(1):DateTime(2002, 1)), 1, 12)
        ))
        timedim = Ti(Sampled(DateTime(2001, 1, 15):Month(1):DateTime(2001, 12, 15); 
            span=span_ti, sampling=Intervals(Center())
        ))
        da = DimArray(1:12, timedim)
        @test @inferred da[Ti(At(DateTime(2001, 3, 15)))] == 3
        @test @inferred da[Contains(DateTime(2001, 4, 7))] == 4
        @test @inferred da[Between(DateTime(2001, 4, 7), DateTime(2001, 8, 30))] == [5, 6, 7]
    end

end

@testset "Selectors on Categorical" begin
    a = [1 2  3  4
         5 6  7  8
         9 10 11 12]

    dimz = Ti(Categorical([:one, :two, :three]; order=ForwardOrdered())),
           Y(Categorical([:a, :b, :c, :d]; order=ForwardOrdered()))
    da = DimArray(a, dimz)
    @test @inferred da[Ti(At([:one, :two])), Y(Contains(:b))] == [2, 6]
    @test @inferred da[At(:two), Between(:b, :d)] == [6, 7, 8]
    @test @inferred da[At(:two), At(:b)] == 6
    # Near and contains are just At
    @test @inferred da[Contains([:one, :three]), Near([:b, :c, :d])] == [2 3 4; 10 11 12]

    dimz = Ti(Categorical([:one, :two, :three]; order=Unordered())),
           Y(Categorical([:a, :b, :c, :d]; order=Unordered()))
    da = DimArray(a, dimz)
    @test_throws ArgumentError da[At(:two), Between(:b, :d)] == [6, 7, 8]

    unordered_dimz = Ti(Categorical([:one, :two, :three]; order=Unordered())),
                     Y(Categorical([:a, :b, :c, :d]; order=Unordered()))
    unordered_da = DimArray(a, unordered_dimz)
    unordered_da[Near(:two), Near(:d)]

    a = [1 2  3  4
         5 6  7  8
         9 10 11 12]
end

@testset "Selectors on NoLookup" begin
    dimz = Ti(), Y()
    da = DimArray(a, dimz)
    @test @inferred da[Ti(At([1, 2])), Y(Contains(2))] == [2, 6]
    @test @inferred da[Near(2), Between(2, 4)] == [6, 7, 8]
    @test @inferred da[Contains([1, 3]), Near([2, 3, 4])] == [2 3 4; 10 11 12]
end

@testset "Selectors on Tranformed lookup" begin
    using CoordinateTransformations

    m = LinearMap([0.5 0.0; 0.0 0.5])
    dimz = X(Transformed(m)), Y(Transformed(m)), Z()
    da = DimArray(reshape(a, 3, 4, 1), dimz)
    view(da, :, :, 1)

    @testset "AutoDim attachs the dimension to " begin
        Lookups.dim(lookup(da, X))
    end

    @testset "Indexing with array dims indexes the array as usual" begin
        da2 = da[1:3, 1:1, 1:1];
        @test @inferred da2[X(3), Y(1), Z(1)] == 9
    end

    @testset "Indexing with lookup dims uses the transformation" begin
        @test @inferred da[X(Near(6.1)), Y(Near(8.5)), Z(1)] == 12
        @test @inferred da[X(At(4.0)), Y(At(2.0)), Z(1)] == 5
        @test_throws ArgumentError da[X=At(4.0)]
        @test_throws InexactError da[X(At(6.1)), Y(At(8)), Z(1)]
        # Indexing directly with lookup dims also just works, but maybe shouldn't?
        @test @inferred da[X(2), Y(2), Z(1)] == 6
    end
end

@testset "Cyclic lookup" begin
    lookups = (
        day=Cyclic(DateTime(2001):Day(1):DateTime(2002, 12, 31); cycle=Year(1), order=ForwardOrdered(), span=Regular(Day(1)), sampling=Intervals(Start())),
        week=Cyclic(DateTime(2001):Week(1):DateTime(2002, 12, 31); cycle=Year(1), order=ForwardOrdered(), span=Regular(Week(1)), sampling=Intervals(Start())),
        month=Cyclic(DateTime(2001):Month(1):DateTime(2002, 12, 31); cycle=Year(1), order=ForwardOrdered(), span=Regular(Month(1)), sampling=Intervals(Start())),
        month_month=Cyclic(DateTime(2001):Month(1):DateTime(2002, 1, 31); cycle=Month(1), order=ForwardOrdered(), span=Regular(Month(1)), sampling=Intervals(Start())),
    )

    for l in lookups 
        # Test exact cycles
        @test at(l, At(DateTime(1))) == 1
        @test at(l, At(DateTime(1999))) == 1
        @test at(l, At(DateTime(2000))) == 1
        @test at(l, At(DateTime(2001))) == 1
        @test at(l, At(DateTime(4000))) == 1
        @test near(l, Near(DateTime(1))) == 1
        @test near(l, Near(DateTime(1999))) == 1
        @test near(l, Near(DateTime(2000))) == 1
        @test near(l, Near(DateTime(2001))) == 1
        @test near(l, Near(DateTime(4000))) == 1
        @test contains(l, Contains(DateTime(1))) == 1
        @test contains(l, Contains(DateTime(1999))) == 1
        @test contains(l, Contains(DateTime(2000))) == 1
        @test contains(l, Contains(DateTime(2001))) == 1
        @test contains(l, Contains(DateTime(4000))) == 1
    end

    l = lookups.month
    @test at(l, At(DateTime(1, 12))) == 12
    @test at(l, At(DateTime(1999, 12))) == 12
    @test at(l, At(DateTime(2000, 12))) == 12
    @test at(l, At(DateTime(2001, 12))) == 12
    @test at(l, At(DateTime(3000, 12))) == 12
    l = lookups.day
    @test at(l, At(DateTime(1, 12, 31))) == 365 
    @test at(l, At(DateTime(1999, 12, 31))) == 365
    # This is kinda wrong, as there are 366 days in 2000
    # But our l has 365. Leap years would be handled
    # properly with a four year cycle
    @test at(l, At(DateTime(2000, 12, 31))) == 365
    @test at(l, At(DateTime(2001, 12, 31))) == 365
    @test at(l, At(DateTime(3000, 12, 31))) == 365

    @testset "Leap years are correct with four year cycles" begin
        l = Cyclic(DateTime(2000):Day(1):DateTime(2003, 12, 31); cycle=Year(4), order=ForwardOrdered(), span=Regular(Day(1)), sampling=Intervals(Start()))
        @test at(l, At(DateTime(1, 12, 31))) == findfirst(==(DateTime(2001, 12, 31)), l)
        @test at(l, At(DateTime(1999, 12, 31))) == findfirst(==(DateTime(1999 + 4, 12, 31)), l)
        @test at(l, At(DateTime(2000, 12, 31))) == 366 == findfirst(==(DateTime(2000, 12, 31)), l)
        @test at(l, At(DateTime(2007, 12, 31))) == findfirst(==(DateTime(2007 - 4, 12, 31)), l)
        @test at(l, At(DateTime(3000, 12, 31))) == 366 == findfirst(==(DateTime(3000 - 250 * 4, 12, 31)), l)
    end

    @testset "Cycling works with floats too" begin
        l = Cyclic(-180.0:1:179.0; cycle=360.0, order=ForwardOrdered(), span=Regular(1.0), sampling=Intervals(Start()))
        @test contains(l, Contains(360)) == 181
        @test contains(l, Contains(-360)) == 181
        @test contains(l, Contains(180)) == 1
    end
end

@testset "NoLookup" begin
    l = NoLookup(1:100)
    @test_throws SelectorError selectindices(l, At(0))
    @test_throws SelectorError selectindices(l, At(200))
    @test selectindices(l, At(50)) == 50
    @test selectindices(l, At(50.1; atol=0.3)) == 50
    @test selectindices(l, Near(200.1)) == 100
    @test selectindices(l, Near(-200.1)) == 1
    @test selectindices(l, Contains(20)) == 20
    @test_throws SelectorError selectindices(l, Contains(20.1))
    @test selectindices(l, Contains(20.1); err=Lookups._False()) === nothing
    @test_throws SelectorError selectindices(l, Contains(0)) 
    @test_throws SelectorError selectindices(l, Contains(200)) 
    @test selectindices(l, 20.1..40) == 21:40
end

@testset "selectindices" begin
    @test selectindices(A[X(1)], Contains(7)) == (3,)
    @test selectindices(A, (At(10), Contains(7))) == (1, 3)
    @test selectindices(dims_, ()) == ()
    @test selectindices((), ()) == ()
    @test selectindices(A, (At(90), Contains(7)); err=Lookups._False()) == nothing
    @test selectindices(A[X(1)], Contains(10); err=Lookups._False()) == nothing
end

@testset "selectindices with Tuple" begin
    @test selectindices(lookup(A, Y), At(6, 7)) == 2:3
    @test_throws SelectorError selectindices(lookup(A, Y), At(5.3, 8))
    @test selectindices(lookup(A, Y), At(5.1, 7.1; atol=0.1)) == 1:3
    @test selectindices(lookup(A, Y), Near(5.3, 8)) == 1:3
    @test selectindices(lookup(A, Y), Contains(4.7, 6.1)) == 1:2
    @test_throws SelectorError selectindices(lookup(A, Y), Contains(5.3, 8)) == 1:3
end

@testset "hasselection" begin
    @test hasselection(A, X(At(20)))
    @test hasselection(dims(A, X), X(At(20)))
    @test hasselection(dims(A, X), At(19; atol=2))
    @test hasselection(A, (Y(At(7)),))
    @test hasselection(A, (X(At(10)), Y(At(7))))
    @test_throws ArgumentError hasselection(dims(A), At(20))
    
    args = Intervals(Start()), NoMetadata()
    startfwd = Ti(Sampled(11.0:30.0,      ForwardOrdered(), Regular(1), args...))
    startrev = Ti(Sampled(30.0:-1.0:11.0, ReverseOrdered(), Regular(-1), args...))

    cases = (startfwd, startrev)
    @test all(map(d -> hasselection(d, At(30.0)), cases))
    @test all(map(d -> !hasselection(d, At(31.0)), cases))
    @test all(map(d -> hasselection(d, Contains(12.8)), cases))
    @test all(map(d -> !hasselection(d, Contains(400.0)), cases))
    @test all(map(d -> hasselection(d, Near(0.0)), cases))
end

@testset "ArrayLookup selectors" begin
    # Generate a warped matrix
    y = -100:100
    x = -200:200
    xs = [x + 0.01y^3 for x in x, y in y]
    ys = [y + 10cos(x/40) for x in x, y in y]
    # Define x and y lookup dimensions
    using NearestNeighbors
    xdim = X(ArrayLookup(xs))
    ydim = Y(ArrayLookup(ys))
    A = rand(xdim, ydim)
    l = lookup(A, X)
    l.dims
    xval = xs[end-10]
    yval = ys[end-10]
    @test A[Y=At(yval; atol=0.001), X=At(xval; atol=0.001)] ==
        A[Y=Near(yval), X=Near(xval)] ==
        A[Y=At(yval; atol=0.001), X=Near(xval)] ==
        A[Y=Near(yval), X=At(xval; atol=0.001)] ==
        A[X=At(xval; atol=0.001), Y=Near(yval)] ==
        A[end-10]
    xval = xs[end-10] + 0.0005
    yval = ys[end-10] + 0.0005
    @test A[Y=At(yval; atol=0.001), X=At(xval; atol=0.001)] ==
        A[Y=Near(yval), X=Near(xval)] ==
        A[Y=At(yval; atol=0.001), X=Near(xval)] ==
        A[Y=Near(yval), X=At(xval; atol=0.001)] ==
        A[end-10]
end

# OpaqueArray is an array that doesn't know what it holds, to simplify dispatch.
# One key property is that `parent(A::OpaqueArray)` returns the `OpaqueArray` `A`
# not the array it holds. 
# 
# It is often used here to hide dimensional arrays that may be generated lazily,
# To force them to act like simple Arrays without dimensional properties.
#
# OpaqueArray can also hold something that is not an AbstractArray itself.
struct OpaqueArray{T,N,P} <: AbstractArray{T,N}
    parent::P
end
OpaqueArray(A::P) where P<:AbstractArray{T,N} where {T,N} = OpaqueArray{T,N,P}(A)
OpaqueArray(st::P) where P<:AbstractDimStack{<:Any,T,N} where {T,N} = OpaqueArray{T,N,P}(st)

Base.size(A::OpaqueArray) = size(A.parent)
Base.getindex(A::OpaqueArray, I::Union{StandardIndices,Not{<:StandardIndices}}...) = 
    Base.getindex(A.parent, I...)
Base.setindex!(A::OpaqueArray, x, I::Union{StandardIndices,Not{<:StandardIndices}}...) = 
    Base.setindex!(A.parent, x, I...)

module DimensionalDataNearestNeighborsExt

using DimensionalData
using NearestNeighbors
using NearestNeighbors.StaticArrays
using DimensionalData.Lookups
using DimensionalData.Dimensions

using DimensionalData.Lookups: ArrayLookup, matrix, atol

const DD = DimensionalData
const NN = NearestNeighbors

function DD.Lookups.select_array_lookups(
    lookups::Tuple{<:ArrayLookup,<:ArrayLookup,Vararg{ArrayLookup}}, 
    selectors::Tuple{<:Union{At,Near},<:Union{Near,At},Vararg{Union{Near,At}}}
)
    f1 = first(lookups)
    vals = SVector(map(val, selectors))
    tree = Lookups.tree(f1)
    knn!(f1.idxvec, f1.distvec, tree, vals, 1)
    idx = f1.idxvec[1]
    found_vals = tree.data[idx]
    map(selectors, Tuple(found_vals)) do s, t
        s isa At ? Lookups._is_at(s, t) : true
    end |> all || throw(ArgumentError("$(selectors) not found in lookup"))
    return CartesianIndices(matrix(first(lookups)))[idx] |> Tuple
end

function DD.Dimensions.format_unaligned(
    lookups::Tuple{<:ArrayLookup,<:ArrayLookup,Vararg{ArrayLookup}}, dims::DD.DimTuple, axes,
)
    points = vec(SVector.(zip(map(matrix, lookups)...)))
    idxvec = Vector{Int}(undef, 1)
    distvec = Vector{eltype(eltype(points))}(undef, 1)
    tree = NN.KDTree(points, NN.Euclidean(); reorder=false)
    return map(lookups, dims, axes) do l, d, a
        newl = rebuild(l; 
            data=a, tree, dim=basedims(d), dims=basedims(dims), idxvec, distvec
        )
        rebuild(d, newl) 
    end
end

end

# `rebuild` and `dims` are key methods to add for a new type

"""
    rebuild(x; kw...)

Rebuild an object struct with updated field values.

`x` can be a `AbstractDimArray`, a `Dimension`, `Lookup` or other custom types.

This is an abstraction that allows inbuilt and custom types to be rebuilt
to update their fields, as most objects in DimensionalData.jl are immutable.

Rebuild is mostly automated using `ConstructionBase.setproperties`. 
It should only be defined if your object has fields with 
with different names to DimensionalData objects. Try not to do that!

The arguments required are defined for the abstract type that has a `rebuild` method.

#### `AbstractBasicDimArray`:
- `dims`: a `Tuple` of `Dimension` 

#### `AbstractDimArray`:

- `data`: the parent object - an `AbstractArray`
- `dims`: a `Tuple` of `Dimension` 
- `refdims`: a `Tuple` of `Dimension` 
- `name`: A Symbol, or `NoName` and `Name` on GPU.
- `metadata`: A `Dict`-like object

#### `AbstractDimStack`:

- `data`: the parent object, often a `NamedTuple`
- `dims`, `refdims`, `metadata`

#### `Dimension`:

- `val`: anything.

#### `Lookup`:

- `data`: the parent object, an `AbstractArray`

* Note: argument `rebuild` is deprecated on `AbstractDimArray` and 
`AbstractDimStack` in favour of always using the keyword version. 
In future the argument version will only be used on `Dimension`, which only have one argument.
"""
function rebuild end

"""
    dims(x, [dims::Tuple]) => Tuple{Vararg{Dimension}}
    dims(x, dim) => Dimension

Return a tuple of `Dimension`s for an object, in the order that matches
the axes or columns of the underlying data.

`dims` can be `Dimension`, `Dimension` types, or `Symbols` for `Dim{Symbol}`.

The default is to return `nothing`.
"""
function dims end

"""
    refdims(x, [dims::Tuple]) => Tuple{Vararg{Dimension}}
    refdims(x, dim) => Dimension

Reference dimensions for an array that is a slice or view of another
array with more dimensions.

`slicedims(a, dims)` returns a tuple containing the current new dimensions
and the new reference dimensions. Refdims can be stored in a field or discarded,
as it is mostly to give context to plots. Ignoring refdims will simply leave some
captions empty.

The default is to return an empty `Tuple` `()`.
"""
function refdims end
refdims(x, lookup) = dims(refdims(x), lookup)

"""
    val(x)
    val(dims::Tuple) => Tuple

Return the contained value of a wrapper object.

`dims` can be `Dimension`, `Dimension` types, or `Symbols` for `Dim{Symbol}`.

Objects that don't define a `val` method are returned unaltered.
"""
function val end

"""
    lookup(x::Dimension) => Lookup
    lookup(x, [dims::Tuple]) => Tuple{Vararg{Lookup}}
    lookup(x::Tuple) => Tuple{Vararg{Lookup}}
    lookup(x, dim) => Lookup

Returns the [`Lookup`](@ref) of a dimension. This dictates
properties of the dimension such as array axis and lookup order,
and sampling properties.

`dims` can be a `Dimension`, a dimension type, or a tuple of either.

This is separate from `val` in that it will only work when dimensions
actually contain an `AbstractArray` lookup, and can be used on a 
`DimArray` or `DimStack` to retrieve all lookups, as there is no ambiguity 
of meaning as there is with `val`.
"""
function lookup end

# Methods to retrieve Object/Dimension/Lookup properties
#
# These work on AbstractDimStack, AbstractDimArray, Dimension
# Lookup, and tuples of Dimension/Lookup. A `dims` argument
# can be supplied to select a subset of dimensions or a single
# Dimension.

"""
    metadata(x) => (object metadata)
    metadata(x, dims::Tuple)  => Tuple (Dimension metadata)
    metadata(xs::Tuple) => Tuple

Returns the metadata for an object or for the specified dimension(s)

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function metadata end

"""
    name(x) => Symbol
    name(xs:Tuple) => NTuple{N,Symbol}
    name(x, dims::Tuple) => NTuple{N,Symbol}
    name(x, dim) => Symbol

Get the name of an array or Dimension, or a tuple of of either as a Symbol.

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function name end

"""
    units(x) => Union{Nothing,Any}
    units(xs:Tuple) => Tuple
    unit(A::AbstractDimArray, dims::Tuple) => Tuple
    unit(A::AbstractDimArray, dim) => Union{Nothing,Any}

Get the units of an array or `Dimension`, or a tuple of of either.

Units do not have a set field, and may or may not be included in `metadata`.
This method is to facilitate use in labels and plots when units are available,
not a guarantee that they will be. If not available, `nothing` is returned.

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function units end

"""
    label(x) => String
    label(x, dims::Tuple) => NTuple{N,String}
    label(x, dim) => String
    label(xs::Tuple) => NTuple{N,String}

Get a plot label for data or a dimension. This will include the name and units
if they exist, and anything else that should be shown on a plot.

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function label end

"""
    bounds(xs, [dims::Tuple]) => Tuple{Vararg{Tuple{T,T}}}
    bounds(xs::Tuple) => Tuple{Vararg{Tuple{T,T}}}
    bounds(x, dim) => Tuple{T,T}
    bounds(dim::Union{Dimension,Lookup}) => Tuple{T,T}

Return the bounds of all dimensions of an object, of a specific dimension,
or of a tuple of dimensions.

If bounds are not known, one or both values may be `nothing`.

`dims` can be a `Dimension`, a dimension type, or a tuple of either.
"""
function bounds end

"""
    order(x, [dims::Tuple]) => Tuple
    order(xs::Tuple) => Tuple
    order(x::Union{Dimension,Lookup}) => Order

Return the `Ordering` of the dimension lookup for each dimension:
`ForwardOrdered`, `ReverseOrdered`, or [`Unordered`](@ref) 

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function order end

"""
    sampling(x, [dims::Tuple]) => Tuple
    sampling(x, dim) => Sampling
    sampling(xs::Tuple) => Tuple{Vararg{Sampling}}
    sampling(x:Union{Dimension,Lookup}) => Sampling

Return the [`Sampling`](@ref) for each dimension.

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function sampling end

"""
    span(x, [dims::Tuple]) => Tuple
    span(x, dim) => Span
    span(xs::Tuple) => Tuple{Vararg{Span,N}}
    span(x::Union{Dimension,Lookup}) => Span

Return the [`Span`](@ref) for each dimension.

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function span end

"""
    locus(x, [dims::Tuple]) => Tuple
    locus(x, dim) => Locus
    locus(xs::Tuple) => Tuple{Vararg{Locus,N}}
    locus(x::Union{Dimension,Lookup}) => Locus

Return the [`Position`](@ref) of lookup values for each dimension.

Second argument `dims` can be `Dimension`s, `Dimension` types,
or `Symbols` for `Dim{Symbol}`.
"""
function locus end

"""
    hasselection(x, selector) => Bool
    hasselection(x, selectors::Tuple) => Bool

Check if indexing into x with `selectors` can be performed, where
x is some object with a `dims` method, and `selectors` is a `Selector`
or `Dimension` or a tuple of either.
"""
function hasselection end

using DimensionalData, Test, BenchmarkTools, Dates, Statistics
using DimensionalData.Lookups, DimensionalData.Dimensions

@testset "dims2indices" begin
    a = [1 2 3; 4 5 6]
    da = DimArray(a, (X(143.0:2:145.0), Y(-38.0:-36.0)))
    dimz = dims(da)

    @test Dimensions._dims2indices(dimz[1], Y) == Colon()
    @test dims2indices(dimz, (Y(),)) == (Colon(), Colon())
    @test (@ballocated dims2indices($dimz, (Y(),))) == 0
    @test dims2indices(dimz, (Y(1),)) == (Colon(), 1)
    @test (@ballocated dims2indices($dimz, (Y(1),))) == 0
    @test dims2indices(dimz, (Ti(4), X(2))) == (2, Colon())
    @test dims2indices(dimz, (Y(2), X(3:7))) == (3:7, 2)
    @test (@ballocated dims2indices($dimz, (Y(2), X(3:7)))) == 0
    @test dims2indices(dimz, (X(2), Y([1, 3, 4]))) == (2, [1, 3, 4])
    @test dims2indices(da, (X(2), Y([1, 3, 4]))) == (2, [1, 3, 4])
    v = [1, 3, 4]
    @test (@ballocated dims2indices($da, (X(2), Y($v)))) == 0
    @test_throws ArgumentError dims2indices(nothing, (Y(2), X(3:7)))
    @test dims2indices(dimz, CartesianIndex(1, 1)) == (CartesianIndex(1, 1),)
    @test dims2indices(dimz[1], 1) == 1
    @test dims2indices(dimz[1], X(2)) == 2

    da2 = DimArray(fill(3), ())
    dimz2 = dims(da2)
    @test dims2indices(dimz2, ()) === ()
end

@testset "lookup" begin
    @testset "Points" begin
        l = Sampled(2.0:2.0:10, ForwardOrdered(), Regular(2.0), Points(), nothing)
        @test l[:] == l[Begin:End] == l[1:End] == l[Begin:5] == l[1:5] == l
        @test l[Begin+1:End-1] ==l[Begin+1:4] ==  l[2:End-1] == l[2:4]
        @test l[Begin:End] isa typeof(l)
        @test l[1:5] isa typeof(l)
        @test l[[1, 3, 4]] == view(l, [1, 3, 4]) == 
            Base.dotview(l, [1, 3, 4]) ==
            Sampled([2.0, 6.0, 8.0], ForwardOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())
        @test l[Int[]] == view(l, Int[]) == Base.dotview(l, Int[]) == 
            Sampled(Float64[], ForwardOrdered(), Irregular(nothing, nothing), Points(), nothing)
        @test l[Near(2.1)] == Base.dotview(l, Near(2.1)) == 2.0
        @test view(l, Near(2.1)) == fill(2.0)
        @test l[[false, true, true, false, true]] == 
            view(l, [false, true, true, false, true]) == 
            Base.dotview(l, [false, true, true, false, true]) == 
            Sampled([4.0, 6.0, 10.0], ForwardOrdered(), Irregular(nothing, nothing), Points(), nothing)
        @test l[2] == Base.dotview(l, 2) === 4.0
        @test view(l, 2) == fill(4.0)
        @test l[CartesianIndex((4,))] === Base.dotview(l, CartesianIndex((4,))) === 8.0
        @test view(l, CartesianIndex((4,))) == fill(8.0)
        @test l[CartesianIndices((1:3,))] == 
            view(l, CartesianIndices((1:3,))) == 
            Base.dotview(l, CartesianIndices((1:3,))) == 
            Sampled(2.0:2.0:6.0, ForwardOrdered(), Regular(2.0), Points(), NoMetadata())
        @test l[2:2:4] == 
            view(l, 2:2:4) == 
            Base.dotview(l, 2:2:4) == 
            Sampled(4.0:4.0:8.0, ForwardOrdered(), Regular(4.0), Points(), nothing)
        # End Locus
        l = Sampled(2.0:2.0:10.0, ForwardOrdered(), Regular(2.0), Points(), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([4.0, 6.0, 10.0], ForwardOrdered(), Irregular(nothing, nothing), Points(), nothing)
        # Center Locus
        l = Sampled(2.0:2.0:10.0, ForwardOrdered(), Regular(2.0), Points(), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([4.0, 6.0, 10.0], ForwardOrdered(), Irregular(nothing, nothing), Points(), nothing)
        # Center Locus DateTime
        l = Sampled(DateTime(2001, 1, 1):Day(1):DateTime(2001, 1, 5), ForwardOrdered(), Regular(Day(1)), Points(), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([DateTime(2001, 1, 2), DateTime(2001, 1, 3), DateTime(2001, 1, 5)], ForwardOrdered(), Irregular(nothing, nothing), Points(), nothing)
        # Reverse
        l = Sampled(10.0:-2.0:2.0, ReverseOrdered(), Regular(-2.0), Points(), nothing)
        @test l[:] == l
        @test l[1:5] == l
        @test l[1:5] isa typeof(l)
        @test l[[1, 3, 4]] == Sampled([10.0, 6.0, 4.0], ReverseOrdered(), Irregular(nothing, nothing), Points(), nothing)
        @test l[Int[]] == Sampled(Float64[], ReverseOrdered(), Irregular(nothing, nothing), Points(), nothing)
        @test l[Near(2.1)] == 2.0
        @test l[[false, true, true, false, true]] == 
            Sampled([8.0, 6.0, 2.0], ReverseOrdered(), Irregular(nothing, nothing), Points(), nothing)
        @test l[2] === 8.0
        @test l[CartesianIndex((4,))] == 4.0
        @test l[CartesianIndices((2:4,))] == Sampled(8.0:-2.0:4.0, ReverseOrdered(), Regular(-2.0), Points(), nothing)
        @test l[2:2:4] == Sampled(8.0:-4.0:4.0, ReverseOrdered(), Regular(-4.0), Points(), nothing)
        # End Locus
        l = Sampled(10.0:-2.0:2.0, ReverseOrdered(), Regular(-2.0), Points(), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([8.0, 6.0, 2.0], ReverseOrdered(), Irregular(nothing, nothing), Points(), nothing)
        # Center Locus
        l = Sampled(10.0:-2.0:2.0, ReverseOrdered(), Regular(-2.0), Points(), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([8.0, 6.0, 2.0], ReverseOrdered(), Irregular(nothing, nothing), Points(), nothing)
        # Center Locus DateTime
        l = Sampled(DateTime(2001, 1, 5):Day(-1):DateTime(2001, 1, 1), ReverseOrdered(), Regular(Day(-1)), Points(), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([DateTime(2001, 1, 4), DateTime(2001, 1, 3), DateTime(2001, 1, 1)], ReverseOrdered(), Irregular(nothing, nothing), Points(), nothing)
    end

    @testset "Intervals" begin
        l = Sampled(2.0:2.0:10, ForwardOrdered(), Regular(2.0), Intervals(Start()), nothing)
        @test l[:] == l[Begin:End] == l
        @test l[1:5] == l
        @test l[1:5] isa typeof(l)
        @test l[Begin:End] isa typeof(l)
        @test l[[1, 3, 4]] == Sampled([2.0, 6.0, 8.0], ForwardOrdered(), Irregular(2.0, 10.0), Intervals(Start()), nothing)
        @test l[Int[]] == Sampled(Float64[], ForwardOrdered(), Irregular(nothing, nothing), Intervals(Start()), nothing)
        @test l[Near(2.1)] == 2.0
        @test l[[false, true, true, false, true]] == 
            Sampled([4.0, 6.0, 10.0], ForwardOrdered(), Irregular(4.0, 12.0), Intervals(Start()), nothing)
        @test l[2] === 4.0
        @test l[CartesianIndex((4,))] == 8.0
        @test l[CartesianIndices((1:3,))] == 
            Sampled(2.0:2.0:6.0, ForwardOrdered(), Regular(2.0), Intervals(Start()), NoMetadata())
        @test l[2:2:4] == Sampled(4.0:4.0:8.0, ForwardOrdered(), Regular(4.0), Intervals(Start()), nothing)
        # End Locus
        l = Sampled(2.0:2.0:10.0, ForwardOrdered(), Regular(2.0), Intervals(End()), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([4.0, 6.0, 10.0], ForwardOrdered(), Irregular(2.0, 10.0), Intervals(End()), nothing)
        # Center Locus
        l = Sampled(2.0:2.0:10.0, ForwardOrdered(), Regular(2.0), Intervals(Center()), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([4.0, 6.0, 10.0], ForwardOrdered(), Irregular(3.0, 11.0), Intervals(Center()), nothing)
        # Reverse Start Locus
        l = Sampled(10.0:-2.0:2.0, ReverseOrdered(), Regular(-2.0), Intervals(Start()), nothing)
        @test l[:] == l
        @test l[1:5] == l
        @test l[1:5] isa typeof(l)
        @test l[[1, 3, 4]] == Sampled([10.0, 6.0, 4.0], ReverseOrdered(), Irregular(4.0, 12.0), Intervals(Start()), nothing)
        @test l[Near(2.1)] == 2.0
        @test l[[false, true, true, false, true]] == 
            Sampled([8.0, 6.0, 2.0], ReverseOrdered(), Irregular(2.0, 10.0), Intervals(Start()), nothing)
        @test l[2] === 8.0
        @test l[CartesianIndex((4,))] == 4.0
        @test l[CartesianIndices((1:3,))] == 
            Sampled(10.0:-2.0:6.0, ReverseOrdered(), Regular(-2.0), Intervals(Start()), nothing)
        @test l[2:2:4] == Sampled(8.0:-4.0:4.0, ReverseOrdered(), Regular(-4.0), Intervals(Start()), nothing)
        # End Locus
        l = Sampled(10.0:-2.0:2.0, ReverseOrdered(), Regular(-2.0), Intervals(End()), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([8.0, 6.0, 2.0], ReverseOrdered(), Irregular(0.0, 8.0), Intervals(End()), nothing)
        # Center Locus
        l = Sampled(10.0:-2.0:2.0, ReverseOrdered(), Regular(-2.0), Intervals(Center()), nothing)
        @test l[[false, true, true, false, true]] == 
            Sampled([8.0, 6.0, 2.0], ReverseOrdered(), Irregular(1.0, 9.0), Intervals(Center()), nothing)
    end
    @testset "NoLookup" begin
        nl = NoLookup(1:100)
        @test nl[100] == 100
        @test nl[1:5] isa typeof(nl)
        @test nl[CartesianIndex((1,))] == 1 
        @test view(nl, 50) === view(1:100, 50)
        @test Base.dotview(nl, 50) === 50
    end
end

@testset "dimension" begin
    d = X(Sampled(2.0:2.0:10, ForwardOrdered(), Regular(2.0), Points(), nothing))
    @test @inferred d[:] == d
    @test @inferred d[1:5] == d
    @test d[1:5] isa typeof(d)
    @test @inferred d[Begin:End] == d
    @test d[Begin+1:End-1] == d[2:-1+End] == d[1+Begin:4] == d[2:4]
    @test d[Begin:End] isa typeof(d)
    # TODO properly handle index mashing arrays: here Regular should become Irregular
    # @test d[[1, 3, 4]] == X(Sampled([2.0, 6.0, 8.0], ForwardOrdered(), Regular(2.0), Points(), nothing))
    # @test d[[true, false, false, false, true]] == X(Sampled([2.0, 10.0], ForwardOrdered(), Regular(2.0), Points(), nothing))
    @test @inferred d[2] === 4.0
    @test @inferred d[CartesianIndex((4,))] == 8.0
    @test @inferred d[CartesianIndices((3:4,))] isa X{<:Sampled}
    @test @inferred d[2:2:4] == X(Sampled(4.0:4.0:8.0, ForwardOrdered(), Regular(4.0), Points(), nothing))
    d = Y(NoLookup(1:100))
    @test d[100] == 100
    @test d[1:5] isa typeof(d)
    @test d[CartesianIndex((1,))] == 1 
    @test view(d, 50) === view(1:100, 50)
    @test Base.dotview(d, 50) === 50
end

@testset "array" begin
    a = [1 2; 3 4]
    xmeta = Metadata(:meta => "X")
    ymeta = Metadata(:meta => "Y")
    ameta = Metadata(:meta => "da")
    dimz = (X(Sampled(143.0:2:145.0; order=ForwardOrdered(), metadata=xmeta)),
            Y(Sampled(-38.0:2:-36.0; order=ForwardOrdered(), metadata=ymeta)))
    refdimz = (Ti(1:1),)
    da = @test_nowarn DimArray(a, dimz; refdims=refdimz, name=:test, metadata=ameta)

    @testset "getindex for single integers returns values" begin
        @test @inferred da[X(1), Y(2)] == 2
        @test @inferred da[X(2), Y(2)] == 4
        @test @inferred da[1, 2] == 2
        @test @inferred da[2] == 3
    end

    @testset "LinearIndex getindex returns an Array, except Vector" begin
        @test @inferred da[1:2] isa Array
        @test @inferred da[Begin:Begin+1] isa Array
        @test da[1:2] == da[begin:begin+1] == da[Begin:Begin+1]
        @test @inferred da[rand(Bool, length(da))] isa Array
        @test @inferred da[rand(Bool, size(da))] isa Array
        @test @inferred da[:] isa Array
        @test da[:] == da[Begin:End] == vec(da)
        b = @inferred da[[!iseven(i) for i in 1:length(da)]]
        @test b isa Array
        @test b == da[1:2:end] == da[Begin:2:End]  
        
        v = @inferred da[1, :]
        @test v isa DimVector
        @test @inferred v[1:2] isa DimArray
        @test @inferred v[rand(Bool, length(v))] isa DimArray
        b = v[[!iseven(i) for i in 1:length(v)]]
        @test b isa DimArray
        # Indexing with a Vector{Bool} returns an irregular lookup, so these are not exactly equal
        @test parent(b) == v[1:2:end]
    end

    @testset "mixed CartesianIndex and CartesianIndices indexing works" begin
        da3 = cat(da, 10da; dims=Z) 
        @test @inferred da3[1, CartesianIndex(1, 2)] == 10
        @test @inferred view(da3, 1:2, CartesianIndex(1, 2)) == [10, 30]
        @test @inferred da3[1, CartesianIndices((1:2, 1:1))] isa DimArray
        @test @inferred da3[CartesianIndices(da3), 1] isa DimArray
        @test @inferred da3[CartesianIndices(da3)] == da3
    end

    @testset "getindex returns DimensionArray slices with the right dimensions" begin
        a = da[X(Begin:Begin+1), Y(1)]
        @test a == [1, 3]
        @test typeof(a) <: DimArray{Int,1}
        @test dims(a) == (X(Sampled(143.0:2.0:145.0, ForwardOrdered(), Regular(2.0), Points(), xmeta)),)
        @test refdims(a) == 
            (Ti(1:1), Y(Sampled(-38.0:2.0:-38.0, ForwardOrdered(), Regular(2.0), Points(), ymeta)),)
        @test name(a) == :test
        @test metadata(a) === ameta
        @test metadata(dims(a, X)) === xmeta
        @test bounds(a) === ((143.0, 145.0),)
        @test bounds(a, X) === (143.0, 145.0)
        @test locus(da, X) == Center()

        a = da[(X(1), Y(1:2))] # Can use a tuple of dimensions like a CartesianIndex
        @test a == [1, 2] == da[(X(1), Y(Begin:Begin+1))]
        @test typeof(a) <: DimArray{Int,1}
        @test typeof(parent(a)) <: Array{Int,1}
        @test dims(a) == (Y(Sampled(-38.0:2.0:-36.0, ForwardOrdered(), Regular(2.0), Points(), ymeta)),)
        @test refdims(a) == 
            (Ti(1:1), X(Sampled(143.0:2.0:143.0, ForwardOrdered(), Regular(2.0), Points(), xmeta)),)
        @test name(a) == :test
        @test metadata(a) == ameta
        @test bounds(a) == ((-38.0, -36.0),)
        @test bounds(a, Y()) == (-38.0, -36.0)

        a = da[X(:), Y(:)]
        @test a == [1 2; 3 4]
        @test typeof(a) <: DimArray{Int,2}
        @test typeof(parent(a)) <: Array{Int,2}
        @test typeof(dims(a)) <: Tuple{<:X,<:Y}
        @test dims(a) == (X(Sampled(143.0:2.0:145.0,
                            ForwardOrdered(), Regular(2.0), Points(), xmeta)),
                          Y(Sampled(-38.0:2.0:-36.0,
                            ForwardOrdered(), Regular(2.0), Points(), ymeta)))
        @test refdims(a) == (Ti(1:1),)
        @test name(a) == :test
        @test bounds(a) == ((143.0, 145.0), (-38.0, -36.0))
        @test bounds(a, X) == (143.0, 145.0)

        a = da[X([2, 1]), Y([2, 1])] # Indexing with array works
        @test a == [4 3; 2 1]
    end

    @testset "dimindices and dimselectors" begin
        @test da[DimIndices(da)] == da
        da[DimIndices(da)[X(1)]]
        da[DimSelectors(da)]
        da[DimSelectors(da)[X(1)]]
        da1 = da .* 0
        da2 = da .* 0
        da1[DimIndices(da)] += da
        da2[DimSelectors(da)] += da
        @test da == da1
        @test da == da2
        da1 *= 0
        da2 *= 0
        da1[DimIndices(da)] += da
        da2[DimSelectors(da)] += da
        @test da == da1
        @test da == da2
    end
    
    @testset "selectors work" begin
        @test @inferred da[At(143), -38.0..36.0] == [1, 2]
        @test @inferred da[144.0..146.0, Near(-37.1)] == [3]
        @test @inferred da[X=At(143), Y=-38.0..36.0] == [1, 2]
        @test @inferred da[X=144.0..146.0, Y=Near(-37.1)] == [3]
    end

    @testset "view DimensionArray containing views" begin
        v = view(da, Y(1), X(1))
        @test v[] == 1
        @test typeof(v) <: DimArray{Int,0}
        @test typeof(parent(v)) <:SubArray{Int,0}
        @test typeof(dims(v)) == Tuple{}
        @test dims(v) == ()
        @test refdims(v) == 
            (Ti(1:1), X(Sampled(143.0:2.0:143, ForwardOrdered(), Regular(2.0), Points(), xmeta)),
             Y(Sampled(-38.0:2.0:-38.0, ForwardOrdered(), Regular(2.0), Points(), ymeta)))
        @test name(v) == :test
        @test metadata(v) == ameta
        @test bounds(v) == ()

        v = view(da, Y(1), X(1:2))
        @test v == [1, 3]
        @test typeof(v) <: DimArray{Int,1}
        @test typeof(parent(v)) <: SubArray{Int,1}
        @test typeof(dims(v)) <: Tuple{<:X}
        @test dims(v) == (X(Sampled(143.0:2.0:145.0, ForwardOrdered(), Regular(2.0), Points(), xmeta)),)
        @test refdims(v) == 
            (Ti(1:1), Y(Sampled(-38.0:-38.0, ForwardOrdered(), Regular(2.0), Points(), ymeta)),)
        @test name(v) == :test
        @test metadata(v) == ameta
        @test bounds(v) == ((143.0, 145.0),)

        # Test that dims are actually views using a vector
        da_vec = rebuild(da; dims=map(d -> rebuild(d, rebuild(lookup(d); data=Array(d))), dims(da)))
        v = view(da_vec, Y(1:2), X(1:1))
        @test v == [1 2]
        @test typeof(v) <: DimArray{Int,2}
        @test typeof(parent(v)) <: SubArray{Int,2}
        @test typeof(dims(v)) <: Tuple{<:X,<:Y}
        testdims = (X(Sampled(view([143.0, 143.0], 1:1), ForwardOrdered(), Regular(2.0), Points(), xmeta)),
             Y(Sampled(view([-38.0, -36.0], 1:2), ForwardOrdered(), Regular(2.0), Points(), ymeta)))
        @test typeof(dims(v)) == typeof(testdims)
        @test dims(v) == testdims
        @test bounds(v) == ((143.0, 143.0), (-38.0, -36.0))

        v = view(da, Y(Base.OneTo(2)), X(1))
        @test v == [1, 2]
        @test typeof(parent(v)) <: SubArray{Int,1}
        @test typeof(dims(v)) <: Tuple{<:Y}
        @test dims(v) == (Y(Sampled(-38.0:2.0:-36.0, ForwardOrdered(), Regular(2.0), Points(), ymeta)),)
        @test refdims(v) == 
            (Ti(1:1), X(Sampled(143.0:2.0:143.0, ForwardOrdered(), Regular(2.0), Points(), xmeta)),)
        @test bounds(v) == ((-38.0, -36.0),)

        @testset "view with all dimensions indexed returns 0-dimensional DimArray" begin
            da0 = DimArray(fill(3), ())
            da1 = DimArray(randn(2), X(1:2))
            da2 = DimArray(randn(2, 3), (X(1:2), Y(1:3)))

            for inds in ((), (1,), (1, 1), (1, 1, 1), (CartesianIndex(),), (CartesianIndices(da0),))
                a = view(da0, inds...)
                @test typeof(parent(a)) === typeof(view(parent(da0), inds...))
                @test parent(a) == view(parent(da0), inds...)
                @test a isa DimArray{eltype(da0),0}
                @test length(dims(a)) == 0
                @test length(refdims(a)) == 0
            end

            for inds in ((1,), (1, 1), (2, 1, 1), (CartesianIndex(2),))
                @test typeof(parent(view(da1, inds...))) === typeof(view(parent(da1), inds...))
                @test parent(view(da1, inds...)) == view(parent(da1), inds...)
                a = view(da1, inds...) 
                @test a isa DimArray{eltype(da1),0}
                @test length(dims(a)) == 0
                @test length(refdims(a)) == 1
            end

            for inds in ((2, 3), (1, 3, 1), (CartesianIndex(2, 1),))
                inds = (CartesianIndex(2, 1),)
                @test typeof(parent(view(da2, inds...))) === typeof(view(parent(da2), inds...))
                @test parent(view(da2, inds...)) == view(parent(da2), inds...)
                a = view(da2, inds...)
                @test a isa DimArray{eltype(da2),0}
                @test length(dims(a)) == 0
                @test length(refdims(a)) == 2
            end
        end

        @testset "@views macro and maybeview work even with kw syntax" begin
            v1 = @views da[Y(1:2), X(1)]
            v2 = @views da[Y=1:2, X=1]
            @test v1 == v2 == [1, 2]
        end
    end

    @testset "setindex!" begin
        da_set = deepcopy(da)
        da_set[X(2), Y(2)] = 77 
        @test da_set == [1 2; 3 77]
        da_set[X(1:2), Y(1)] .= 99
        @test da_set == [99 2; 99 77]
        da_set[1] = 55
        @test da_set == [55 2; 99 77]
        da_set[1, 1, 1, 1] = 66
        @test da_set == [66 2; 99 77]
        @test_throws BoundsError da_set[2, 2, 2, 2] = 66
        da_set[:, :] = [1 2; 3 4]
        @test da_set == [1 2; 3 4]
    end

    @testset "logical indexing" begin
        A = DimArray(zeros(40, 50), (X, Y))
        I = rand(Bool, 40, 50)
        @test all(A[I] .== 0.0)
        A[I] .= 3
        @test all(A[I] .== 3.0)
        @test all(view(A, I .== 3.0))
    end

    @testset "zero dim dim getindex doesn't unwrap" begin
        A = DimArray(fill(1), ())
        @test A[notadim=1] isa DimArray{Int,0,Tuple{}}
        @test A[X(1)] isa DimArray{Int,0,Tuple{}}
        @test A[notadim=1] == A[X(1)] == A
    end

    @testset "Empty getindedex/view/setindex throws a BoundsError" begin
        @test_throws BoundsError da[]
        @test_throws BoundsError view(da)
        @test_throws BoundsError da[] = 1
    end

    @testset "Cartesian indices work as usual" begin
        @test da[CartesianIndex(2, 2)] == 4 
        @test view(da, CartesianIndex(2, 2)) == view(parent(da), 2, 2) 
        da_set = deepcopy(da)
        da_set[CartesianIndex(2, 2)] = 5
        @test da_set[2, 2] == 5
    end

    a2 = [1 2 3 4
          3 4 5 6
          4 5 6 7]
    b2 = [4 4 4 4
          4 4 4 4
          4 4 4 4]

    @testset "indexing into NoLookup dims is just regular indexing" begin
        ida = DimArray(a2, (X(), Y()))
        ida[Y(3:4), X(2:3)] = [5 6; 6 7]
    end

    dimz2 = (Dim{:row}(10:10:30), Dim{:column}(-20:10:10))
    da2 = DimArray(a2, dimz2; refdims=refdimz, name=:test2)

    @testset "lookup step is updated when indexed with a range" begin
        @test step.(lookup(da2)) == (10.0, 10.0)
        @test step.(lookup(da2[1:3, 1:4])) == (10.0, 10.0)
        @test step.(lookup(da2[1:2:3, 1:3:4])) == (20.0, 30.0)
        @test step.(lookup(da2[column=1:2:4, row=1:3:3])) == (30.0, 20.0)
    end

    @testset "Symbol dimension names also work for indexing" begin
        @test da2[Dim{:row}(2)] == [3, 4, 5, 6]
        @test da2[Dim{:column}(4)] == [4, 6, 7]
        @test da2[column=4] == [4, 6, 7]
        @test da2[Dim{:column}(1), Dim{:row}(3)] == 4
        @test da2[column=1, Dim{:row}(3)] == 4
        @test da2[Dim{:column}(1), row=3] == 4
        @test da2[column=1, row=3] == 4
        @test view(da2, column=1, row=3) == fill(4)
        @test view(da2, column=1, Dim{:row}(1)) == fill(1)
        da2_set = deepcopy(da2)
        da2_set[Dim{:column}(1), Dim{:row}(1)] = 99
        @test da2_set[1, 1] == 99
        da2_set[column=2, row=2] = 88
        @test da2_set[2, 2] == 88
        da2_set[Dim{:row}(3), column=3] = 77
        @test da2_set[3, 3] == 77

        # We can also construct without using `Dim{X}`
        @test dims(DimArray(a2, (:a, :b))) == dims(DimArray(a2, (Dim{:a}, Dim{:b})))
    end

    @testset "Type inference holds indexing with Symbol dimension names" begin
        da2_set = deepcopy(da2)
        # Inrerence
        @inferred getindex(da2, column=1, row=3)
        @inferred view(da2, column=1, row=3)
        @inferred setindex!(da2_set, 77, Dim{:row}(1), column=2)

        # With a large type
        da4 = DimArray(zeros(1, 2, 3, 4, 5, 6, 7, 8), (:a, :b, :c, :d, :d, :f, :g, :h))
        @inferred getindex(da2, a=1, b=2, c=3, d=4, e=5)
        # Type inference breaks with 6 arguments.
        # @inferred getindex(da2, a=1, b=2, c=3, d=4, e=5, f=6)
        # @code_warntype getindex(da2, a=1, b=2, c=3, d=4, e=5, f=6)
    
    end

    @testset "trailing colon" begin
        @test da[X(1), Y(2)] == 2
        @test da[X(2), Y(2)] == 4
        @test da[1, 2] == 2
        @test da[2] == 3
        @inferred getindex(da, X(2), Y(2))
    end

    @testset "mixed dimensions" begin
        a = [[1 2 3; 4 5 6];;; [11 12 13; 14 15 16];;;]
        da = DimArray(a, (X(143.0:2:145.0), Y(-38.0:-36.0), Ti(100:100:200)); name=:test)
        da[1, End(), Begin(), 1]
        da[Ti=1, DimIndices(da[Ti=1])]
        da[DimIndices(da[Ti=1]), Ti(2)]
        da[DimIndices(da[Ti=1])[:], Ti(2)]
        da[DimIndices(da[Ti=1])[:], DimIndices(da[X=1, Y=1])]
        da[DimIndices(da[X=1, Y=1]), DimIndices(da[Ti=1])[:]]
        da[DimIndices(da[X=1, Y=1])[:], DimIndices(da[Ti=1])[:]]
    end
end

@testset "stack" begin
    A = [1.0 2.0 3.0;
         4.0 5.0 6.0]
    dimz = (X([:a, :b]), Y(10.0:10.0:30.0))
    da1 = DimArray(A, dimz; name=:one)
    da2 = DimArray(Float32.(2A), dimz; name=:two)
    da3 = DimArray(Int.(3A), dimz; name=:three)
    da4 = rebuild(Int.(4da1)[Y=1]; name=:four)

    s = DimStack((da1, da2, da3))
    s_mixed = DimStack((da1, da2, da3, da4))

    @testset "cartesian Int" begin
        @inferred s[1, 1]
        @inferred view(s, 1, 1)
        @test view(s, Begin, Begin)[] === view(s, 1, 1)[] === 
            s[Begin, Begin] === s[1, 1] === (one=1.0, two=2.0f0, three=3)
        @test view(s_mixed, 1, 1)[] == view(s_mixed, 1, 1)[] == 
            s_mixed[Begin, Begin] == (one=1.0, two=2.0f0, three=3, four=4)
    end
    @testset "cartesian mixed" begin
        @inferred s[At(:a), :] 
        @inferred view(s, At(:a), :)
        @inferred s_mixed[At(:a), :] 
        @inferred view(s_mixed, At(:a), :)

        @test s[At(:a), :] == view(s, At(:a), :) == 
              s[1, :] == view(s, 1, :) == 
              s[Begin, :] == view(s, Begin, :) == 
              s[1, 1:3] == view(s, 1, 1:3) == 
              s[1, Begin:End] == view(s, 1, Begin:End) == 
              s[X=1, Y=Begin:End] == view(s, X=1, Y=Begin:End) ==
              s[X=At(:a), Y=Begin:End] == view(s, X=At(:a), Y=Begin:End) ==
              s[Y=Begin:End, X=1] == view(s, Y=Begin:End, X=1) ==
                  DimStack((one=[1.0, 2.0, 3.0], two=[2.0f0, 4.0f0, 6.0f0], three=[3, 6, 9]), (Y(10.0:10:30.0),))

        y = dims(s, Y)
        @test s_mixed[At(:a), :] == view(s_mixed, At(:a), :) == 
              s_mixed[1, :] == view(s_mixed, 1, :) == 
              s_mixed[Begin, :] == view(s_mixed, Begin, :) == 
              s_mixed[1, 1:3] == view(s_mixed, 1, 1:3) == 
              s_mixed[1, Begin:End] == view(s_mixed, 1, Begin:End) == 
              s_mixed[X=1, Y=Begin:End] == view(s_mixed, X=1, Y=Begin:End) ==
              s_mixed[X=At(:a), Y=Begin:End] == view(s_mixed, X=At(:a), Y=Begin:End) ==
              s_mixed[Y=Begin:End, X=1] == view(s_mixed, Y=Begin:End, X=1) ==
                  DimStack((one=DimArray([1.0, 2.0, 3.0], y), two=DimArray([2.0f0, 4.0f0, 6.0f0], y), three=DimArray([3, 6, 9], y), four=DimArray(fill(4), ())))
    end

    @testset "linear" begin
        s1d = s[X(2)]
        @inferred s[1]
        @inferred s[:]
        @inferred s[[1, 2]] 
        @inferred s[1:2]
        @inferred s1d[1]
        @inferred s1d[:]
        @inferred s1d[1:2]
        # @inferred s[[1, 2]] # Irregular bounds are not type-stable
        @inferred view(s, 1)
        @inferred view(s, :)
        @inferred view(s, 1:2)
        @inferred view(s, [1, 2])
        @inferred view(s1d, 1)
        @inferred view(s1d, :)
        @inferred view(s1d, 1:2)
        # @inferred view(s1d, [1, 2])

        @testset "Integer indexing" begin
            @test s[1] == view(s, 1)[] == (one=1.0, two=2.0f0, three=3)
            @test s1d[1] == view(s1d, 1)[] == (one=4.0, two=8.0f0, three=12)
            @test s1d[1] isa NamedTuple
            @test s[1] isa NamedTuple
            @test view(s1d, 1) isa DimStack
            @test view(s, 1) isa SubArray{<:NamedTuple,0}
        end

        @testset "Colon and Vector{Int/Bool} indexing" begin
            b = [false, false, false, true, false, true]
            v = [4, 6]
            @test s[:][b] == s[b] == 
                s[:][v] == s[v] == [s[4], s[6]] == 
                view(s, :)[b] == view(s, b) ==
                view(s, :)[v] == view(s, v) == [
                (one = 5.0, two = 10.0, three = 15),
                (one = 6.0, two = 12.0, three = 18),
            ]
            @test s_mixed[:][b] == s_mixed[b] ==
                s_mixed[:][v] == s_mixed[v] == [s_mixed[4], s_mixed[6]] ==
                view(s_mixed, :)[b] == view(s_mixed, b) == 
                view(s_mixed, :)[v] == view(s_mixed, v) == [
                (one = 5.0, two = 10.0, three = 15, four=16),
                (one = 6.0, two = 12.0, three = 18, four=16),
            ]
            m = [false true false; false false true]
            @test s[m] == view(s, m) == [
               (one = 2.0, two = 4.0, three = 6)
               (one = 6.0, two = 12.0, three = 18)
            ]
            @test s_mixed[m] == view(s_mixed, m) == [
               (one = 2.0, two = 4.0, three = 6, four=4),
               (one = 6.0, two = 12.0, three = 18, four=16),
            ]
            @test s1d[1:2] isa DimStack
            @test s[1:2] isa Vector
        end
    end

    @testset "CartesianIndex" begin
        @inferred s[CartesianIndex(2, 2)]
        @inferred view(s, CartesianIndex(2, 2))
        @test s[CartesianIndex(2, 2)] == 
            view(s, CartesianIndex(2, 2))[] == (one=5.0, two=10.0, three=15.0)
    end

    @testset "CartesianIndices" begin
        @inferred s[CartesianIndices((1, 2))]
        @inferred view(s, CartesianIndices((1, 2)))
        @test s[CartesianIndices((1, 2))] == 
            view(s, CartesianIndices((1, 2))) ==
            s[X=1:1, Y=1:2]
    end

    @testset "CartesianIndex Vector" begin
        @inferred s[[CartesianIndex(1, 2)]]
        @inferred view(s, [CartesianIndex(1, 2)]) 
        @test s[[CartesianIndex(1, 2)]] == 
            view(s, [CartesianIndex(1, 2)]) ==
            s[[3]]
    end

    @testset "Mixed CartesianIndex and CartesianIndices" begin
        da3d = cat(da1, 10da1; dims=Z) 
        s3 = merge(s, (; ten=da3d))
        @test @inferred s3[2, CartesianIndex(2, 2)] === (one=5.0, two=10.0f0, three=15, ten=50.0)
        @test @inferred view(s3, 1:2, CartesianIndex(1, 2)) isa DimStack
        @test @inferred NamedTuple(view(s3, 1:2, CartesianIndex(1, 2))) == (one=[1.0, 4.0], two=Float32[2.0, 8.0], three=[3, 12], ten=[10.0, 40.0])
        @test @inferred s3[2, CartesianIndices((1:2, 1:1))] isa DimStack
        @test @inferred s3[CartesianIndex((2,)), CartesianIndices((1:2, 1:1)), 1, 1, 1] isa DimStack
        @test @inferred s3[CartesianIndices(s3.one), CartesianIndex(2,)] isa DimStack
        @test @inferred NamedTuple(s3[CartesianIndices(s3.one), CartesianIndex(2,)]) ==
            (one=[1.0 2.0 3.0; 4.0 5.0 6.0], two=Float32[2.0 4.0 6.0; 8.0 10.0 12.0], three=[3 6 9; 12 15 18], ten=[10 20 30; 40 50 60])
        @test @inferred s3[CartesianIndices(s3.one), 2, 1, 1, 1] isa DimStack
        @test @inferred s3[CartesianIndices(s3)] == s3
    end

    @testset "getindex Symbol Tuple" begin
        @test_broken st1 = @inferred s[(:three, :one)]
        st1 = s[(:three, :one)]
        @test keys(st1) === (:three, :one)
        @test values(st1) == (da3, da1)
    end

    @testset "view" begin
        @testset "0-dimensional" begin
            sv = @inferred view(s, Begin, Begin)
            @test parent(sv) == (one=fill(1.0), two=fill(2.0f0), three=fill(3))
            @test dims(sv) == ()
            ds = @inferred view(s, X(1), Y(1))
            @test ds isa DimStack
            @test dims(ds) === ()
            @test @inferred view(s, X(1), Y(2))[:one] == view(da1, X(1), Y(2))
            @test @inferred view(s, X(1), Y(1))[:two] == view(da2, X(1), Y(1))
            @test @inferred view(s, X(2), Y(3))[:three] == view(da3, X(2), Y(3))
        end
        @testset "@views macro and maybeview work even with kw syntax" begin
            sv1 = @views s[X(1:2), Y(3:3)]
            sv2 = @views s[X=1:2, Y=3:3]
            @test parent(sv1) == parent(sv2) == (one=[3.0 6.0]', two=[6.0f0 12.0f0]', three=[9 18]')
        end
    end

    @testset "setindex!" begin
        s_set = deepcopy(s)
        s_set[1] = (one=4, two=5, three=6)
        @test s_set[1, 1] === (one=4.0, two=5.0f0, three=6)
        s_set[1, 1] = (one=9, two=10, three=11)
        @test s_set[1, 1] === (one=9.0, two=10.0f0, three=11) 
        s_set[X=At(:b), Y=At(10.0)] = (one=7, two=11, three=13)
        @test s_set[2, 1] === (one=7.0, two=11.0f0, three=13) 

        s_set = deepcopy(s)
        s_set[CartesianIndex(2, 2)] = (one=5, two=6, three=7)
        @test @inferred s_set[2, 2] === (one=5.0, two=6.0f0, three=7)
        s_set[CartesianIndex(2, 2)] = (9, 10, 11)
        @test @inferred s_set[2, 2] === (one=9.0, two=10.0f0, three=11)
        @test_throws ArgumentError s_set[CartesianIndex(2, 2)] = (seven=5, two=6, three=7)

        s_set_mixed1 = deepcopy(s_mixed)
        s_set_mixed2 = deepcopy(s_mixed)
        s_set_mixed3 = deepcopy(s_mixed)
        s_set_mixed1[1, 1] = (one=9, two=10, three=11, four=12)
        s_set_mixed2[X=1, Y=1] = (one=19, two=20, three=21, four=22)
        s_set_mixed3[Y(1), X(1)] = (one=29, two=30, three=31, four=32)
        @test @inferred s_set_mixed1[1] === (one=9.0, two=10.0f0, three=11, four=12)
        @test @inferred s_set_mixed2[1] === (one=19.0, two=20.0f0, three=21, four=22)
        @test @inferred s_set_mixed3[1] === (one=29.0, two=30.0f0, three=31, four=32)
    end

    @testset "Empty getindedex/view/setindex throws a BoundsError" begin
        @test_throws BoundsError s[]
        @test_throws BoundsError view(s)
        @test_throws BoundsError s[] = 1
    end
end

@testset "indexing irregular with bounds slice" begin
    total_time = 5
    t1 = Ti([mod1(i, 12) for i in 1:total_time]; sampling=Intervals()) # centurial averages with seasonal cycle
    t2 = Ti([Date(-26000 + ((i-1)÷12)*100, mod1(i, 12), 1) for i in 1:total_time]; sampling=Intervals()) # centurial averages with seasonal cycle
    t3 = Ti([DateTime(-26000 + ((i-1)÷12)*100, mod1(i, 12), 1) for i in 1:total_time]; sampling=Intervals()) # centurial averages with seasonal cycle
    t4 = Ti([DateTime(-26000 + ((i-1)÷12)*100, mod1(i, 12), 1) for i in 1:total_time]; sampling=Points()) # centurial averages with seasonal cycle

    p = reshape([1, 2, 3, 4, 5], 1, 1, 5)
    A1 = DimArray(p, (X, Y, t1))
    A2 = DimArray(p, (X, Y, t2))
    A3 = DimArray(p, (X, Y, t3))

    @test @inferred view(A1, Ti(5)) == permutedims([5])
    @test @inferred view(A2, Ti(5)) == permutedims([5])
    @test @inferred view(A3, Ti(5)) == permutedims([5])
end

@testset "Begin End indexing" begin
    @testset "generic indexing" begin
        @test (1:10)[Begin] == 1
        @test (1:10)[Begin()] == 1
        @test (1:10)[End] == 10
        @test (1:10)[End()] == 10
        @test (1:10)[Begin:End] == 1:10
        @test (1:10)[Begin:10] == 1:10
        @test (1:10)[1:End] == 1:10
        @test (1:10)[Begin():End()] == 1:10
        @test (1:10)[Begin+1:End-1] == 2:9
        @test (1:10)[1+Begin:End-1] == 2:9
        @test (1:10)[Begin()+1:End()-1] == 2:9
        @test (1:10)[1+Begin():End()-1] == 2:9
        @test (1:10)[Begin:End÷2] == 1:5
        @test (1:10)[2:2:End] == 2:2:10
        @test (1:10)[2:2:End-1] == 2:2:8
        @test (1:10)[Begin|3:End] == 3:10
        @test (1:10)[Begin:End&3] == 1:2
        @test (1:10)[Begin()+1:End()-1] == 2:9
        @test (1:10)[max(Begin()+1, 3):End()-1] == 3:9
        @test (1:10)[1+Begin] == 2
        @test (1:10)[1+Begin()] == 2
        @test (1:10)[End-1] == 9
        @test (1:10)[1+(End÷2)] == 6
        @test (1:10)[div(End,2)+1] == 6
        @test (1:10)[1+(Begin+2)] == 4
        @test (1:10)[max(Begin, -1)] == 1
        @test (1:10)[max(Begin, 3)] == 3
        @test (1:10)[min(End, 12)] == 10
        @test (1:10)[min(End, 3)] == 3
        @test (1:10)[max(-1, Begin)] == 1
        @test (1:10)[max(3, Begin)] == 3
        @test (1:10)[min(12,End)] == 10
        @test (1:10)[min(3, End)] == 3
    end
    @testset "dimension indexing" begin
        A = DimArray((1:5)*(6:3:20)', (X, Y))
        @test A[Begin, End] == 18
        @test A[Begin(), End()] == 18
        @test A[X=Begin, Y=End] == 18
        @test A[X=End(), Y=Begin()] == 30
        @test A[Begin:Begin+1, End] == [18, 36]
        @test A[Begin():Begin()+1, End()] == [18, 36]
        @test A[X=Begin:Begin+1, Y=End] == [18, 36]
    end
    @testset "BeginEndRange" begin
        a = Begin:End
        @test first(a) == Begin()
        @test last(a) == End()
        b = Begin:5
        @test first(b) == Begin()
        @test last(b) == 5
        d = Begin()+2:End()
        @test first(d) == Begin+2
        @test Base.checkindex(Bool, 1:10, Begin-1:End) == false
    end
    @testset "BeginEndStepRange" begin
        a = Begin:2:End
        a = Begin():2:End()
        @test first(a) == Begin()
        @test last(a) == End()
        b = Begin:3:15
        @test first(b) == Begin()
        @test last(b) == 15
        c = Begin:2:Begin+6
        @test step(c) == 2
        @test last(c) == Begin+6
        d = Begin()+2:-1:max(End(), 100) - 1
        @test first(d) == Begin+2
        @test last(d) == max(End(), 100) - 1
        @test step(d) == -1
        @test Base.checkindex(Bool, 1:10, Begin:2:8)
    end
end

"""
    AbstractName

Abstract supertype for name wrappers.
"""
abstract type AbstractName end

"""
    NoName <: AbstractName

    NoName()

NoName specifies an array is not named, and is the default `name`
value for all `AbstractDimArray`s.
"""
struct NoName <: AbstractName end

Base.Symbol(::NoName) = Symbol("")
Base.string(::NoName) = ""

"""
    Name <: AbstractName

    Name(name::Union{Symbol,Name) => Name
    Name(name::NoName) => NoName

Name wrapper. This lets arrays keep symbol names when the array wrapper needs
to be `isbits`, like for use on GPUs. It makes the name a property of the type.
It's not necessary to use in normal use, a symbol is probably easier.
"""
struct Name{X} <: AbstractName end
Name(name::Symbol) = Name{name}()
Name(name::NoName) = NoName()
Name(name::Name) = name

Base.Symbol(::Name{X}) where X = X
Base.string(::Name{X}) where X = string(X)

name(x::Name) = x

using DimensionalData, Dates, Test , BenchmarkTools
using DimensionalData.Lookups, DimensionalData.Dimensions

using .Dimensions: _dim_query, _wraparg, _reducedims, AlwaysTuple, MaybeFirst, comparedims, promotedims

@dim Tst

a = [1 2 3; 4 5 6]
da = DimArray(a, (X(143:2:145), Y(-38:-36)))
dimz = dims(da)

@testset "dimsmatch" begin
    @test (@inferred dimsmatch(Y(), Y())) == true
    @test (@inferred dimsmatch(X(), Y())) == false
    @test (@inferred dimsmatch(Y(), Y)) == true
    @test (@inferred dimsmatch(X(), Y)) == false
    @test (@inferred dimsmatch(Y, Y())) == true
    @test (@inferred dimsmatch(X, Y())) == false
    @test (@inferred dimsmatch(X, XDim)) == true
    @test (@inferred dimsmatch(Y, ZDim)) == false
    @test (@inferred dimsmatch(ZDim, Dimension)) == true
    @test (@inferred dimsmatch((Z(), ZDim), (ZDim, Dimension))) == true
    @test (@inferred dimsmatch((Z(), ZDim), (ZDim, XDim))) == false

    @test (@inferred dimsmatch(XDim, nothing)) == false
    @test (@inferred dimsmatch(X(), nothing)) == false
    @test (@inferred dimsmatch(nothing, ZDim)) == false
    @test (@inferred dimsmatch(nothing, Z())) == false
    @test (@inferred dimsmatch(nothing, nothing)) == false

    @test (@ballocated dimsmatch((Z(), ZDim), (ZDim, Dimension))) == 0
    @test (@ballocated dimsmatch(ZDim, Dimension)) == 0
    @test (@ballocated dimsmatch((Z(), ZDim), (ZDim, XDim))) == 0

    @testset "no type match but name matches" begin
        @test (@ballocated dimsmatch(Z, Dim{:Z})) == 0
        @test (@ballocated dimsmatch((Z(), Dim{:Ti}()), (Dim{:Z}(), Ti()))) == 0
    end
end

@testset "name2dim" begin
    @test name2dim(:test) == Dim{:test}()
    @test name2dim(:X) == X()
    @test name2dim(:x) == Dim{:x}()
    @test name2dim(:Ti) == Ti()
    @test name2dim(:ti) == Dim{:ti}()
    @test name2dim(:Tst) == Tst()
    @test name2dim(Ti) == Ti
    @test name2dim(Ti()) == Ti()
    @test name2dim(Val{TimeDim}()) == Val{TimeDim}()
    @test name2dim((:test, Ti, Ti())) == (Dim{:test}(), Ti, Ti())
end

@testset "_wraparg" begin
    @test @inferred _wraparg(X()) == (X(),)
    @test _wraparg((X, Y,), X,) == ((Val(X), Val(Y),), Val(X),)
    @test _wraparg((X, X(), :x), Y, Y(), :y) ==
        ((Val(X), X(), Dim{:x}()), Val(Y), Y(), Dim{:y}())
    f1 = () -> _wraparg((X(), Y()), X(), Y())
    f2 = () -> _wraparg((:x, :y), :x, :y)
    f3 = () -> _wraparg((X(), Y()), X, Y)
    f4 = () -> _wraparg((X, Y), X, Y)
    f5 = () -> _wraparg((X, X(), :x), Y, Y(), :y)
    f6 = () -> _wraparg((:x, :y, :z), :x, :y)
    f7 = () -> _wraparg((:x, :y), :x, :y, :z)
    f8 = () -> _wraparg((:x, :y, :z, :a, :b), :x, :y, :z, :a, :b)
    f9 = () -> _wraparg((:x, :y, :z, :a, :b, :c, :d, :e, :f, :g, :h), :x, :y, :z, :a, :b, :c, :d, :e, :f, :g, :h)
    @inferred f1()
    @inferred f2()
    @inferred f3()
    @inferred f4()
    @inferred f5()
    @inferred f6()
    @inferred f7()
    @inferred f8()
    @test (@inferred f9()) == (DimensionalData.name2dim.(((:x, :y, :z, :a, :b, :c, :d, :e, :f, :g, :h))),
                        DimensionalData.name2dim.(((:x, :y, :z, :a, :b, :c, :d, :e, :f, :g, :h)))...)
end

@testset "_dim_query" begin
    @test _dim_query((f, args...) -> args, AlwaysTuple(), (Z, :a, :b), Ti, XDim, :x) ==
          _dim_query((f, args...) -> args, MaybeFirst(), (Z, :a, :b), Ti, XDim, :x) ==
          ((Val(Z), Dim{:a}(), Dim{:b}()), (Val(Ti), Val(XDim), Dim{:x}()))
    @test _dim_query((f, args...) -> args, MaybeFirst(), (Z, :a, :b), Ti) ==
        (Val(Z), Dim{:a}(), Dim{:b}())
    @testset "_dim_query" begin
        f1 = t -> _dim_query((f, args...) -> args, t, (X, :a, :b), (TimeDim, X(), :a, :b, Ti))
        @inferred f1(AlwaysTuple())
        @test (@ballocated $f1(AlwaysTuple())) == 0
    end
end

@testset "sortdims" begin
    dimz = (X(), Y(), Z(), Ti())
    @test (@inferred sortdims((Y(1:2), X(1)), dimz)) == (X(1), Y(1:2), nothing, nothing)
    @test (@inferred sortdims((Ti(1),), dimz)) == (nothing, nothing, nothing, Ti(1))
    @test (@inferred sortdims((Z(), Y(), X()), dimz)) == (X(), Y(), Z(), nothing)
    @test (@inferred sortdims(dimz, (Y(), Z()))) == (Y(), Z())
    @test (@inferred sortdims((Y(), X(), Z(), Ti()), dimz)) == (X(), Y(), Z(), Ti())
    @test (@ballocated sortdims((Y(), X(), Z(), Ti()), $dimz)) == 0
    f1 = (dimz) -> sortdims((Y, X, Z, Ti), dimz)
    @test (@inferred f1(dimz)) == (X, Y, Z, Ti)
    @ballocated $f1($dimz)
    @test (@ballocated $f1($dimz)) == 0
    f2 = (dimz) -> sortdims(dimz, (Y, X, Z, Ti))
    @test (@inferred f2(dimz)) == (Y(), X(), Z(), Ti())
    @test (@ballocated $f2($dimz)) == 0
    # Val
    @inferred sortdims(dimz, (Val{Y}(), Val{Ti}(), Val{Z}(), Val{X}()))
    @test (@ballocated sortdims($dimz, (Val{Y}(), Val{Ti}(), Val{Z}(), Val{X}()))) == 0
    # Abstract
    @test sortdims((Z(), Y(), X()), (XDim, TimeDim)) == (X(), nothing)
    # Repeating
    @test sortdims((Z(:a), Y(), Z(:b)), (YDim, Z(), ZDim)) == (Y(), Z(:a), Z(:b))
end

@testset "dims" begin
    dimz = dims(da)
    @test dims(X()) == X()
    @test (@inferred dims(dimz, X())) isa X
    @test (@ballocated dims($dimz, X())) == 0
    @test (@inferred dims(dimz, Y)) isa Y
    @test (@ballocated dims($dimz, Y)) == 0
    @test dims(dimz, (X(), Y())) isa Tuple{<:X,<:Y}
    @test (@ballocated dims($dimz, (X(), Y()))) == 0
    @test dims(dimz, (XDim, YDim)) isa Tuple{<:X,<:Y}
    # It's hard to make this infer - Types in a tuple are UnionAll
    f1 = (da) -> dims(da, (XDim, YDim))
    @test (@inferred f1(da)) isa Tuple{<:X,<:Y}
    @test (@ballocated $f1($dimz)) == 0

    @test dims(da, X()) isa X
    @test dims(da, isforward) isa Tuple{<:X,<:Y}
    @test dims(da, !isforward) isa Tuple{}
    @test dims(da, Z()) isa Nothing
    @test (@inferred dims(da, XDim, YDim)) isa Tuple{<:X,<:Y}
    @test (@ballocated dims($da, XDim, YDim)) == 0
    @test dims(da, ()) == ()
    @test dims(dimz, 1) isa X
    @test dims(dimz, (2, 1)) isa Tuple{<:Y,<:X}
    # Mixed Int/dim indexing is no longer supported
    @test_broken dims(dimz, (2, Y)) isa Tuple{<:Y,<:Y}

    @testset "with Dim{X} and symbols" begin
        A = DimArray(zeros(4, 5), (:one, :two))
        @test dims(A) ==
            (Dim{:one}(NoLookup(Base.OneTo(4))),
             Dim{:two}(NoLookup(Base.OneTo(5))))
        @test dims(A, :two) == Dim{:two}(NoLookup(Base.OneTo(5)))
    end

    @testset "non matching single queries return nothing" begin
        @test dims(da, :Ti) == nothing
        @test dims(da, Ti) == nothing
        @test dims(da, 3) == nothing
    end

    @testset "non matching tuple queries return empty tuples" begin
        @test dims(da, (:Ti,)) == ()
        @test dims(da, (Ti,)) == ()
        @test dims(da, (3,)) == ()
    end

    @test_throws ArgumentError dims(nothing, X)

    @test dims(dimz) === dimz
    @test dims(dimz, X) === dimz[1]
    @test dims(dimz, Y) === dimz[2]
    TT = typeof(LinRange(1.0,1.0,1)) # TT is different for Julia 1.6 and 1.7
    @test typeof(dims(da)) ==
        Tuple{X{Sampled{Int,StepRange{Int,Int},ForwardOrdered,Regular{Int},Points,NoMetadata}},
              Y{Sampled{Int,UnitRange{Int},ForwardOrdered,Regular{Int},Points,NoMetadata}} }
end

@testset "commondims" begin
    @test commondims(da, X) == (dims(da, X),)
    @test commondims(da, x -> x isa X) == (dims(da, X),)
    # Dims are always in the base order
    @test (@inferred commondims(da, (Y(), X()))) == dims(da, (X, Y))
    @test (@ballocated commondims($da, (Y(), X()))) == 0
    f1 = (da) -> commondims(da, (X, Y))
    @test (@inferred f1(da)) == dims(da, (X, Y))
    @test (@ballocated $f1($da)) == 0
    @test (@inferred commondims(da, X, Y)) == dims(da, (X, Y))
    @test (@ballocated commondims($da, X, Y)) == 0
    @test basetypeof(commondims(da, DimArray(zeros(5), Y()))[1]) <: Y

    @testset "with Dim{X} and symbols" begin
        dimz = Dim{:a}(), Y(), Dim{:b}()
        f1 = (dimz) -> commondims((Dim{:a}(), Dim{:b}()), (:a, :c))
        @test f1(dimz) == (Dim{:a}(),)
        @test (@ballocated $f1(dimz)) == 0
        f2 = (dimz) -> commondims(dimz, (Y, Dim{:b}))
        @test f2(dimz) == (Y(), Dim{:b}())
        f3 = (dimz) -> commondims(dimz, Y, :b)
        @test (@inferred f3(dimz)) == (Y(), Dim{:b}())
        @test (@ballocated $f3($dimz)) == 0
        f4 = (dimz) -> commondims(dimz, Y, Z, Dim{:b})
        @test (@inferred f4(dimz)) == (Y(), Dim{:b}())
        @test (@ballocated $f4($dimz)) == 0
    end

    @testset "with abstract types" begin
        @test commondims((Z(), Y(), Ti()), (ZDim, Dimension)) == (Z(), Y())
        @test commondims(>:, (TimeDim, YDim), (Z(), Ti(), Dim{:a})) == (TimeDim,)
    end
end

@testset "dimnum" begin
    @test dimnum(da, Y()) == dimnum(da, 2) == 2
    @test dimnum(da, Base.Fix2(isa,Y)) == (2,)
    @test (@ballocated dimnum($da, Y())) == 0
    @test dimnum(da, X) == 1
    @test (@ballocated dimnum($da, X)) == 0
    @test dimnum(da, (Y(), X())) == (2, 1)
    @ballocated dimnum($da, (Y(), X()))
    @test (@ballocated dimnum($da, (Y(), X()))) == 0
    f1 = (da) -> dimnum(da, (Y, X()))
    @test (@inferred f1(da)) == (2, 1)
    @ballocated $f1($da)
    @test (@ballocated $f1($da)) == 0
    @test dimnum(da, Y, X) == (2, 1)
    @ballocated dimnum($da, Y, X)
    @test (@ballocated dimnum($da, Y, X)) == 0
    @testset "with Dim{X} and symbols" begin
        @test dimnum((Dim{:a}(), Dim{:b}()), :a) == 1
        @test dimnum((Dim{:a}(), Y(), Dim{:b}()), (:b, :a, Y)) == (3, 1, 2)
        dimz = (Dim{:a}(), Y(), Dim{:b}())
        @test (@ballocated dimnum($dimz, :b, :a, Y)) == 0
    end

    @testset "not present dimensions error" begin
        @test_throws ArgumentError dimnum(da, Z())
        @test_throws ArgumentError dimnum(da, 3)
        @test_throws ArgumentError dimnum(da, 0)
        @test_throws ArgumentError dimnum(da, (Y(), Z()))
    end
end

@testset "hasdim" begin
    @test hasdim(da, X()) == true
    @test hasdim(da, :X) == true
    @test hasdim(da, isforward) == (true, true) 
    @test (@ballocated hasdim($da, X())) == 0
    @test hasdim(da, Ti) == false
    @test (@ballocated hasdim($da, Ti)) == 0
    @test hasdim(dims(da), Y) == true
    @ballocated hasdim(dims($da), Y)
    @test (@ballocated hasdim(dims($da), Y)) == 0
    @test hasdim(dims(da), (X, Y)) == (true, true)
    @test hasdim(dims(da), (:X, :Y)) == (true, true)
    f1 = (da) -> hasdim(dims(da), (X, Ti, Y, Z))
    @test @inferred f1(da) == (true, false, true, false)
    @test (@ballocated $f1($da)) == 0
    f2 = (da) -> hasdim(dims(da), X, Ti, Y, Z)
    @test (@ballocated $f2($da)) == 0

    @testset "hasdim for Abstract types" begin
        @test hasdim(dims(da), (XDim, YDim)) == (true, true)
        @test hasdim(dims(da), (XDim, XDim)) == (true, false)
        @test hasdim(dims(da), (ZDim, YDim)) == (false, true)
        @test hasdim(dims(da), (ZDim, ZDim)) == (false, false)
        @test (@ballocated hasdim($da, YDim)) == 0
        @test (@ballocated hasdim($da, (ZDim, YDim))) == 0
        @test (@ballocated hasdim($da, ZDim, YDim)) == 0
    end

    @testset "with Dim{X} and symbols" begin
        @test hasdim((Dim{:a}(), Dim{:b}()), (:a, :c)) == (true, false)
        @test hasdim((Dim{:a}(), Dim{:b}()), (:b, :a, :c, :d, :e)) == (true, true, false, false, false)
        @test hasdim((Dim{:a}(), Dim{:b}()), (:b, :a, :c, :d, :e)) == (true, true, false, false, false)
        @ballocated hasdim((Dim{:a}(), Dim{:b}()), (:b, :a, :c, :d, :e))
        @test (@ballocated hasdim((Dim{:a}(), Dim{:b}()), (:b, :a, :c, :d, :e))) == 0
    end
    @test_throws ArgumentError hasdim(nothing, X)
end

@testset "otherdims" begin
    A = DimArray(ones(5, 10, 15), (X, Y, Z));
    @test otherdims(A, X()) == dims(A, (Y, Z))
    @test otherdims(A, x -> x isa X) == dims(A, (Y, Z))
    @test (@ballocated otherdims($A, X())) == 0
    @test (@ballocated otherdims($A, X)) == 0
    @test (@ballocated otherdims($A, (X, Y))) == 0
    @test (@ballocated otherdims($A, X, Y)) == 0
    @test otherdims(A, X, Y) == dims(A, (Z,))
    @test otherdims(A, Y) == dims(A, (X, Z))
    @test otherdims(A, Z) == dims(A, (X, Y))
    @test otherdims(A) == dims(A)
    @test otherdims(A, DimensionalData.ZDim) == dims(A, (X, Y))
    @test otherdims(A, (X, Z)) == dims(A, (Y,))
    f1 = A -> otherdims(A, (X, Z))
    @test (@ballocated $f1($A)) == 0
    f2 = (A) -> otherdims(A, Ti)
    @test f2(A) == dims(A, (X, Y, Z))
    @test (@ballocated $f2($A)) == 0
    @testset "with Dim{X} and symbols" begin
        dimz = (Z(), Dim{:a}(), Y(), Dim{:b}())
        f3 = (dimz) -> otherdims(dimz, (:b, :a, Y))
        @test (@inferred f3(dimz)) == (Z(),)
        @test (@ballocated $f3($dimz)) == 0
        @test otherdims((Dim{:a}(), Dim{:b}(), Ti()), (:a, :c)) == (Dim{:b}(), Ti())
    end
    @test_throws ArgumentError otherdims(nothing, X)

    @testset "non matching single queries return all dims" begin
        @test otherdims(da, :Ti) == dims(da)
        @test otherdims(da, Ti) == dims(da)
        @test otherdims(da, 3) == dims(da)
        @test otherdims(da, 0) == dims(da)
    end
end

@testset "combinedims" begin
    @test combinedims((X(1:10), Y(1:5)), (X(1:10), Z(3:10))) == (X(1:10), Y(1:5), Z(3:10))
    @test combinedims([]) == combinedims() == ()
    @test_throws DimensionMismatch combinedims((X(1:2), Y(1:5)), (X(1:10), Z(3:10)))
end

@testset "comparedims" begin

    @testset "single dimensions" begin
        z = Z(NoLookup(Base.OneTo(10)))
        @test comparedims(z) == true
        @test comparedims(z, z) == true
        @test comparedims(z, z, z) == true
    end

    @testset "default keywords" begin
        @test @inferred comparedims(Bool, X(1:2), X(1:2))
        @test @inferred !comparedims(Bool, X(1:2), Y(1:2))
        @test @inferred !comparedims(Bool, X(1:2), X(1:3))
        @test_warn "Found both lengths 2 and 3" comparedims(Bool, X(1:2), X(1:3); msg=Dimensions.Warn())
        @test_warn "X and Y dims on the same axis" comparedims(Bool, X(1:2), Y(1:2); msg=Dimensions.Warn())
        @test_throws DimensionMismatch comparedims(X(1:2), Y(1:2))
        @test_throws DimensionMismatch comparedims(X(1:2), X(1:3))
    end
    @testset "compare type" begin
        @test comparedims(Bool, X(1:2), Y(1:2); type=false)
        @test !comparedims(Bool, X(1:2), Y(1:2); type=true)
        @test_warn "X and Y dims on the same axis" comparedims(Bool, X(1:2), Y(1:2); type=true, msg=Dimensions.Warn())
        @test_throws DimensionMismatch comparedims(X(Sampled(1:2)), Y(Sampled(1:2)); type=true)
    end
    @testset "compare val type" begin
        @test @inferred !comparedims(Bool, X(Sampled(1:2)), X(Categorical(1:2)); valtype=true)
        @test_throws DimensionMismatch comparedims(X(Sampled(1:2)), X(Categorical(1:2)); valtype=true)
        @test @inferred comparedims(Bool, X(Sampled(1:2)), X(Sampled([1, 2])); valtype=false)
        @test !comparedims(Bool, X(Sampled(1:2)), X(Sampled([1, 2])); valtype=true)
        @test_throws DimensionMismatch comparedims(X(Sampled([1, 2])), X(Sampled(1:2)); valtype=true)
    end
    @testset "compare values" begin
        @test comparedims(Bool, X(1:2), X(2:3); val=false)
        @test !comparedims(Bool, X(1:2), X(2:3); val=true)
        @test_warn "do not match" comparedims(Bool, X(1:2), X(2:3); val=true, msg=Dimensions.Warn())
        @test_nowarn comparedims(Bool, X(Sampled(1:2)), X(Sampled(2:3)); val=false)
        @test !comparedims(Bool, X(Sampled(1:2)), X(Sampled(2:3)); val=true)
        @test_throws DimensionMismatch comparedims(X(Sampled(1:2)), X(Sampled(2:3)); val=true)
    end
    @testset "compare length" begin
        @test comparedims(Bool, X(1:2), X(1:3); length=false)
        @test !comparedims(Bool, X(1:2), X(1:3); length=true)
        @test_warn "Found both lengths" comparedims(Bool, X(1:2), X(1:3); length=true, msg=Dimensions.Warn())
        @test_throws DimensionMismatch comparedims(X(1:2), X(1:3); length=true)
        @test comparedims(Bool, X(1:2), X(1:1); length=true, ignore_length_one=true)
        @test !comparedims(Bool, X(1:2), X(1:1); length=true, ignore_length_one=false)
        @test_throws DimensionMismatch comparedims(X(1:2), X(1:1); length=true, ignore_length_one=false)
    end
    @testset "compare order" begin
        a, b = X(Sampled(1:2); order=ForwardOrdered()), X(Sampled(1:2); order=ReverseOrdered())
        @test comparedims(Bool, a, b; order=false)
        @test !comparedims(Bool, a, b; order=true)
        @test comparedims(Bool, a, b; order=false)
        @test_nowarn comparedims(Bool, a, b; order=true)
        @test_warn "Lookups do not all have the same order" comparedims(Bool, a, b; order=true, msg=Dimensions.Warn())
        @test_throws DimensionMismatch comparedims(a, b; order=true)
    end
end

@testset "setdims" begin
    A = setdims(da, X(Sampled(LinRange(150,152,2))))
    @test lookup(A, X()) == LinRange(150,152,2)
    @test dims(dims(A)) isa Tuple{<:X,<:Y}
    A = setdims(da, Y(Sampled(10:12)), X(Sampled(LinRange(150,152,2))))
    @test lookup(dims(dims(A), Y())) == 10:12
    @test dims(dims(A)) isa Tuple{<:X,<:Y}
    @testset "set an empty tuple" begin
        A = setdims(da, ())
        @test dims(A) === dims(da)
    end
end

@testset "swapdims" begin
    @testset "swap type wrappers" begin
        A = swapdims(da, (Z, Dim{:test1}))
        @test dims(A) isa Tuple{<:Z,<:Dim{:test1}}
        @test map(val, dims(A)) == map(val, dims(da))
        @test map(lookup, dims(A)) == map(lookup, dims(da))
    end
    @testset "swap whole dim instances" begin
        A = swapdims(da, Z(2:2:4), Dim{:test2}(3:5))
        @test dims(A) isa Tuple{<:Z,<:Dim{:test2}}
        @test map(parent, lookup(A)) === (2:2:4, 3:5)
        @test lookup(A) ===
            (Sampled(2:2:4, ForwardOrdered(), Regular(2), Points(), NoMetadata()),
             Sampled(3:5, ForwardOrdered(), Regular(1), Points(), NoMetadata()))
    end
    @testset "passing `nothing` keeps the original dim" begin
        A = swapdims(da, (Z(2:2:4), nothing))
        dims(A) isa Tuple{<:Z,<:Y}
        @test map(val, dims(A)) == (2:2:4, val(dims(da, 2)))
        A = swapdims(da, (nothing, Dim{:test3}))
        @test dims(A) isa Tuple{<:X,<:Dim{:test3}}
    end
    @testset "new instances are checked against the array" begin
        @test_throws DimensionMismatch swapdims(da, (Z(2:2:4), Dim{:test4}(3:6)))
    end
end

@testset "slicedims" begin
    @testset "Regular Points" begin
        da = DimArray(a, (X(143:2:145), Y(-20:-1:-22)))
        dimz = dims(da)
        @test slicedims(dimz, (1:2, 3)) == slicedims(dimz, 1:2, 3) == slicedims(dimz, (), (1:2, 3)) ==
            ((X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),),
              (Y(Sampled(-22:-1:-22, ReverseOrdered(), Regular(-1), Points(), NoMetadata())),))
        @test slicedims(dimz, (Z(),), (1:2, 3)) == slicedims(dimz, (Z(),), 1:2, 3) ==
            ((X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),),
             (Z(), Y(Sampled(-22:-1:-22, ReverseOrdered(), Regular(-1), Points(), NoMetadata())),))
        @test slicedims(dimz, 2:2, :) == slicedims(dimz, (), 2:2, :) ==
            ((X(Sampled(145:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
              Y(Sampled(-20:-1:-22, ReverseOrdered(), Regular(-1), Points(), NoMetadata()))), ())
        # What is this testing, it should error...
        @test_broken slicedims((), (1:2, 3)) == slicedims((), (), (1:2, 3)) ==
              slicedims((), 1:2, 3) == slicedims((), (), 1:2, 3) == ((), ())
        @test slicedims(dimz, CartesianIndex(2, 3)) ==
            ((), (X(Sampled(145:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
                  Y(Sampled(-22:-1:-22, ReverseOrdered(), Regular(-1), Points(), NoMetadata()))),)
        @test slicedims(dimz, (CartesianIndex(2, 3),)) ==
            ((), (X(Sampled(145:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
                  Y(Sampled(-22:-1:-22, ReverseOrdered(), Regular(-1), Points(), NoMetadata()))),)
    end

    @testset "Regular Intervals" begin
        irreg = DimArray(a, (X(Sampled([140.0, 142.0], ForwardOrdered(), Regular(2.0), Intervals(Start()), NoMetadata())),
                             Y(Sampled([30.0, 20.0, 10.0], ReverseOrdered(), Regular(-10.0), Intervals(Center()), NoMetadata())), ))
        irreg_dimz = dims(irreg)
        @test slicedims(irreg, (1:2, 3)) == slicedims(irreg, 1:2, 3) ==
            ((X(Sampled([140.0, 142.0], ForwardOrdered(), Regular(2.0), Intervals(Start()), NoMetadata())),),
                 (Y(Sampled([10.0], ReverseOrdered(), Regular(-10.0), Intervals(Center()), NoMetadata())),))
        @test slicedims(irreg, (2:2, 1:2)) == slicedims(irreg, 2:2, 1:2) ==
            ((X(Sampled([142.0], ForwardOrdered(), Regular(2.0), Intervals(Start()), NoMetadata())),
              Y(Sampled([30.0, 20.0], ReverseOrdered(), Regular(-10.0), Intervals(Center()), NoMetadata()))), ())
        # This should never happen, not sure why it was tested?
        @test_broken slicedims((), (1:2, 3)) == slicedims((), (), (1:2, 3)) == ((), ()) 
        @test slicedims((), (1, 1)) == slicedims((), (), (1, 1)) == ((), ()) 
    end

    @testset "Irregular Points" begin
        irreg = DimArray(a, (X(Sampled([140.0, 142.0], ForwardOrdered(), Irregular(), Points(), NoMetadata())),
                             Y(Sampled([40.0, 20.0, 10.0], ReverseOrdered(), Irregular(), Points(), NoMetadata())), ))
        irreg_dimz = dims(irreg)
        @test slicedims(irreg, (1:2, 3)) == slicedims(irreg, 1:2, 3) ==
        ((X(Sampled([140.0, 142.0], ForwardOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())),),
         (Y(Sampled([10.0], ReverseOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())),))
        @test slicedims(irreg, (2:2, 1:2)) == slicedims(irreg, 2:2, 1:2) ==
        ((X(Sampled([142.0], ForwardOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())),
          Y(Sampled([40.0, 20.0], ReverseOrdered(), Irregular(nothing, nothing), Points(), NoMetadata()))), ())
        @test_broken slicedims((), (1:2, 3)) == slicedims((), (), (1:2, 3)) == ((), ())
        @test slicedims((), (1, 1)) == slicedims((), (), (1, 1)) == ((), ())
    end

    @testset "Irregular Intervals" begin
        irreg = DimArray(a, (X(Sampled([140.0, 142.0], ForwardOrdered(), Irregular(140.0, 144.0), Intervals(Start()), NoMetadata())),
                             Y(Sampled([40.0, 20.0, 10.0], ReverseOrdered(), Irregular(0.0, 60.0), Intervals(Center()), NoMetadata())), ))
        irreg_dimz = dims(irreg)
        @test slicedims(irreg, (1:2, 3)) == slicedims(irreg, 1:2, 3) ==
            ((X(Sampled([140.0, 142.0], ForwardOrdered(), Irregular(140.0, 144.0), Intervals(Start()), NoMetadata())),),
             (Y(Sampled([10.0], ReverseOrdered(), Irregular(0.0, 15.0), Intervals(Center()), NoMetadata())),))
        @test slicedims(irreg, (2:2, 1:2)) == slicedims(irreg, 2:2, 1:2) ==
            ((X(Sampled([142.0], ForwardOrdered(), Irregular(142.0, 144.0), Intervals(Start()), NoMetadata())),
              Y(Sampled([40.0, 20.0], ReverseOrdered(), Irregular(15.0, 60.0), Intervals(Center()), NoMetadata()))), ())
        @test_broken slicedims((), (1:2, 3)) == slicedims((), (), (1:2, 3)) == ((), ())
        @test slicedims((), (1, 1)) == slicedims((), (), (1, 1)) == ((), ())
    end

    @testset "NoLookup" begin
        da = DimArray(a, (X(), Y()))
        dimz = dims(da)
        @test slicedims(dimz, (1:2, 3)) == ((X(NoLookup(1:2)),), (Y(NoLookup(3:3)),))
        @test slicedims(dimz, (2:2, :)) == ((X(NoLookup(2:2)), Y(NoLookup(Base.OneTo(3)))), ())
    end
    @testset "No slicing" begin
        da = DimArray(a, (X([143, 145]), Y([:x, :y, :z])))
        dimz = dims(da)
        @test slicedims(dimz, ()) == (dimz, ())
    end
end

@testset "reducedims" begin
    @test _reducedims((X(Sampled(3:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
                 Y(Sampled(1:5, ForwardOrdered(), Regular(1), Points(), NoMetadata()))), (X, Y)) ==
                     (X(Sampled(3.5:2:3.5, ForwardOrdered(), Regular(2.0), Points(), NoMetadata())),
                      Y(Sampled(3.0:5.0:3.0, ForwardOrdered(), Regular(5.0), Points(), NoMetadata())))
    @test _reducedims((X(Sampled(3:4, ForwardOrdered(), Regular(1), Intervals(Start()), NoMetadata())),
                       Y(Sampled(1:5, ForwardOrdered(), Regular(1), Intervals(End()), NoMetadata()))), (X, Y)) ==
        (X(Sampled(3:2:3, ForwardOrdered(), Regular(2), Intervals(Start()), NoMetadata())),
         Y(Sampled(5:5:5, ForwardOrdered(), Regular(5), Intervals(End()), NoMetadata())))

   @test _reducedims((X(Sampled(3:4, ForwardOrdered(), Irregular(2.5, 4.5), Intervals(Center()), NoMetadata())),
                      Y(Sampled(1:5, ForwardOrdered(), Irregular(0.5, 5.5), Intervals(Center()), NoMetadata()))), (X, Y))[1] ==
       (X(Sampled([3.5], ForwardOrdered(), Irregular(2.5, 4.5), Intervals(Center()), NoMetadata())),
        Y(Sampled([3.0], ForwardOrdered(), Irregular(0.5, 5.5), Intervals(Center()), NoMetadata())))[1]
   @test _reducedims((X(Sampled(3:4, ForwardOrdered(), Irregular(3, 5), Intervals(Start()), NoMetadata())),
                      Y(Sampled(1:5, ForwardOrdered(), Irregular(0, 5), Intervals(End()), NoMetadata()))), (X, Y))[1] ==
      (X(Sampled([3], ForwardOrdered(), Irregular(3, 5), Intervals(Start()), NoMetadata())),
       Y(Sampled([5], ForwardOrdered(), Irregular(0, 5), Intervals(End()), NoMetadata())))[1]

    args = ForwardOrdered(), Irregular(), Points(), NoMetadata()
    @test _reducedims((X(Sampled(3:4, args...)), Y(Sampled(1:5, args...))), (X, Y)) ==
        (X(Sampled([3.5], args...)), Y(Sampled([3.0], args...)))
    @test _reducedims((X(Sampled(3:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
                       Y(Sampled(1:5, ForwardOrdered(), Regular(1), Points(), NoMetadata()))), (X, Y)) ==
                      (X(Sampled(3.5:2.0:3.5, ForwardOrdered(), Regular(2.0), Points(), NoMetadata())),
                       Y(Sampled(3.0:5.0:3.0, ForwardOrdered(), Regular(5.0), Points(), NoMetadata())))

    @test _reducedims((X(Categorical([:a,:b])),
                       Y(Categorical(["1","2","3","4","5"]))), (X, Y)) ==
        (X(Categorical([:combined])), Y(Categorical(["combined"])))

    @test _reducedims((X(NoLookup(Base.OneTo(10))),
                 Y(NoLookup(Base.OneTo(10)))), (X(), Y())) ==
        (X(NoLookup(Base.OneTo(1))), Y(NoLookup(Base.OneTo(1))))

    @testset "Special case CompoundPeriod" begin
        step_ = Dates.CompoundPeriod([Month(1), Day(3)])
        timespan = [DateTime(2001, 1), DateTime(2001, 1, 3)]
        teststep = Dates.CompoundPeriod([Month(2), Day(6)])
        testdim = Ti(Sampled([DateTime(2001, 1, 2)], ForwardOrdered(), Regular(teststep), Points(), NoMetadata()))
        reduceddim = _reducedims((Ti(Sampled(timespan, ForwardOrdered(), Regular(step_), Points(), NoMetadata())),), (Ti,))[1]
        @test typeof(testdim) == typeof(reduceddim)
        @test testdim == reduceddim
        @test step(testdim) == step(reduceddim)
    end
end

@testset "promotedims" begin
    nl = NoLookup(Base.OneTo(2))
    c = Categorical(["a", "b"]; order=ForwardOrdered())
    c_unord = Categorical(["a", "b"]; order=Unordered())
    c_sub = Categorical([view("a", 1:1), view("b", 1:1)]; order=ForwardOrdered())
    s = Sampled(1.0:1.0:2.0; span=Regular(1.0), sampling=Points(), order=ForwardOrdered())
    s_int = Sampled(1:1:2; span=Regular(1), sampling=Points(), order=ForwardOrdered())
    s_intervals = Sampled(1.0:1.0:2.0; span=Regular(1.0), sampling=Intervals(), order=ForwardOrdered())
    s_unord = Sampled(1.0:1.0:2.0; span=Regular(1.0), sampling=Points(), order=Unordered())
    s_irreg = Sampled(1.0:1.0:2.0; span=Irregular((nothing, nothing)), sampling=Points(), order=ForwardOrdered())
    s_exp = Sampled(1.0:1.0:2.0; span=Explicit(), sampling=Intervals(Start()), order=ForwardOrdered())
    s_exp_int = Sampled(1:1:2; span=Explicit(), sampling=Intervals(Start()), order=ForwardOrdered())

    @testset "promote withe same is no change" begin
        @test promotedims(X(s), X(s)) === X(s)
        @test promotedims(X(s_int), X(s_int)) === X(s_int)
    end

    @testset "mixing returns NoLookup" begin
        @test promotedims(X(nl), X(c)) === promotedims(X(c), X(nl)) === X(nl)
        @test promotedims(X(nl), X(s)) === promotedims(X(s), X(nl)) === X(nl)
        @test promotedims(X(c), X(s)) === promotedims(X(s), X(c)) === X(nl)
    end

    @testset "eltype: Float64 wins in Real" begin
        @test promotedims(X(s), X(s_int)) === promotedims(X(s_int), X(s)) === X(s)
    end

    @testset "eltype: String wins in AbstractString" begin
        @test promotedims(X(c), X(c_sub)) == promotedims(X(c_sub), X(c)) == X(c)
        @test eltype(promotedims(X(c_sub), X(c))) == String
    end

    @testset "order: Unordered wins" begin
        @test promotedims(X(s), X(s_unord)) == X(s_unord)
        @test promotedims(X(c), X(c_unord)) == X(c_unord)
    end

    @testset "sampling: Points wins" begin
        @test promotedims(X(s), X(s_intervals)) == X(s)
        @test promotedims(X(s_intervals), X(s)) == X(s)
    end

    @testset "span: Irregular wins" begin
        @test promotedims(X(s), X(s_irreg)) == X(s_irreg)
        @test promotedims(X(s_irreg), X(s)) == X(s_irreg)
    end

    @testset "span: Explicit must be on its own" begin
        @test promotedims(X(s), X(s_exp)) == X(nl)
        @test promotedims(X(s_exp), X(s_exp)) == X(s_exp)
        @test promotedims(X(s_exp), X(s_exp_int)) == X(s_exp)
        @test promotedims(X(s_exp_int), X(s_exp)) == X(s_exp)
    end

    @testset "tuples of dims" begin
        @test promotedims((X(c), Y(s)), (X(c), Y(s))) == (X(c), Y(s))
        @test promotedims((X(c), Y(nl)), (X(nl), Y(s))) == (X(nl), Y(nl))
        @test promotedims((X(c), Y(s_int)), (X(c_sub), Y(s))) == (X(c), Y(s))
    end

    @testset "non-Lookup val" begin
        @test promotedims(X(1), X(1.0)) == promotedims(X(1.0), X(1)) == X(1.0)
        @test promotedims(X("a"), X(view("a", 1:1))) ==
            promotedims(X(view("a", 1:1)), X("a")) == X("a")
    end
end

using DataFrames
using Dates
using DimensionalData
using IteratorInterfaceExtensions
using Random
using TableTraits
using Tables
using Test

using DimensionalData.Lookups, DimensionalData.Dimensions
using DimensionalData: DimTable, DimExtensionArray

x = X([:a, :b, :c])
y = Y([10.0, 20.0])
z = Z([3, 8])
d = Dim{:test}(1.0:1.0:3.0)
dimz = x, y, d
da2 = DimArray(fill(2, (3, 2, 3)), dimz; name=:data2)

@testset "DimArray Tables interface" begin
    @testset for dim_ref in ((), (z,))
        ref_names = name(dim_ref)
        ref_num = length(dim_ref)
        ref_size = prod(length, dim_ref; init=1)
        da = DimArray(ones(3, 2, 3), dimz; name=:data, refdims=dim_ref)

        nrows = prod(size(da)) * ref_size
        col_names = (:X, :Y, :test, ref_names..., :data)
        col_eltypes = (Symbol, Float64, Float64, map(eltype, dim_ref)..., Float64)
        dim_vals = vec(collect(Iterators.product(dimz..., dim_ref...)))
        col_vals = [getindex.(dim_vals, i) for i in eachindex(first(dim_vals))]
        push!(col_vals, ones(nrows))

        ds = DimStack(da)
        t = DimTable(ds; refdims=dim_ref)
        @test t isa DimTable
        @test dims(t) === dims(da)
        @test parent(t) === ds
        t2 = Tables.columns(ds)
        @test t2 isa DimTable
        if !isempty(dim_ref)
            @test Tables.columnnames(t2) == Tables.columnnames(t)
        end

        @test Tables.columns(t) === t
        @test length(t[:X]) == length(t[:Y]) == length(t[:test]) == nrows

        @test Tables.istable(typeof(t)) == Tables.istable(t) ==
            Tables.istable(typeof(da)) == Tables.istable(da) ==
            Tables.istable(typeof(ds)) == Tables.istable(ds) == true
        @test Tables.columnaccess(t) == Tables.columnaccess(da) ==
            Tables.columnaccess(ds) == true
        @test Tables.rowaccess(t) == Tables.rowaccess(ds) == Tables.rowaccess(ds) == false
        @test Tables.columnnames(t) == col_names

        alldims = combinedims(dims(ds), dim_ref)
        col_dims = (alldims..., fill(nothing, length(col_names) - length(alldims))...)
        @testset for (i, (col, dim, col_eltype)) in enumerate(
            zip(col_names, col_dims, col_eltypes),
        )
            col_val = Tables.getcolumn(t, i)
            @test col_val == Tables.getcolumn(t, col) == col_vals[i]

            if !isnothing(dim)
                @test col_val == Tables.getcolumn(t, dim)
            end
        end
        @test_throws ArgumentError Tables.getcolumn(t, :NotAColumn)
        @test_throws BoundsError Tables.getcolumn(t, length(col_names) + 1)

        sa = Tables.schema(da)
        sds = Tables.schema(ds)
        st = Tables.schema(t)

        @testset "consistency of DimStack and DimArray Tables interfaces" begin
            @test Tables.columnnames(da) == Tables.columnnames(ds) == sa.names == sds.names == col_names
            @test sa.types == sds.types == col_eltypes
            @test Tables.columntable(da) == Tables.columntable(ds)
        end

        isempty(dim_ref) && continue
        @testset "DimTable interface with refdims consistent with DimStack/DimArray Tables interfaces" begin
            @test sa.names == col_names
            @test sa.types == col_eltypes
            @test Tables.columntable(da) == Tables.columntable(t)
            @testset for (i, (col, dim, col_eltype)) in enumerate(
                zip(col_names, col_dims, col_eltypes),
            )
                @test col_vals[i] == Tables.getcolumn(da, col) == Tables.getcolumn(ds, col) ==
                    Tables.getcolumn(da, i) == Tables.getcolumn(ds, i)

                if !isnothing(dim)
                    @test col_vals[i] == Tables.getcolumn(da, dim) ==
                        Tables.getcolumn(ds, dim) == Tables.getcolumn(da, typeof(dim)) ==
                        Tables.getcolumn(ds, typeof(dim))
                end
            end
        end
    end
end

da = DimArray(ones(3, 2, 3), dimz; name=:data)
@testset "DimArray TableTraits interface" begin
    ds = DimStack(da)
    t = DimTable(ds)
    for x in (da, ds, t)
        x = da
        @test IteratorInterfaceExtensions.isiterable(x)
        @test TableTraits.isiterabletable(x)
        @test collect(Tables.namedtupleiterator(x)) == collect(IteratorInterfaceExtensions.getiterator(x))
    end
end

@testset "DataFrame conversion" begin
    ds = DimStack(da, da2)
    @time t = DimTable(ds)
    @time df = DataFrame(t; copycols=true)
    @test names(df) == ["X", "Y", "test", "data", "data2"]
    @test Tables.columntype(df, :X) == Symbol
    @test Tables.columntype(df, :data) == Float64
    @test Tables.columntype(df, :data2) == Int

    @test Tables.getcolumn(df, 1)[:] == Tables.getcolumn(df, :X)[1:18] ==
        repeat([:a, :b, :c], 6)
    @test Tables.getcolumn(t, 2) == Tables.getcolumn(df, :Y) ==
        repeat([10.0, 10.0, 10.0, 20.0, 20.0, 20.0], 3)
    @test Tables.getcolumn(df, 3) == Tables.getcolumn(df, :test) ==
        vcat(repeat([1.0], 6), repeat([2.0], 6), repeat([3.0], 6))
    @test Tables.getcolumn(t, 4) == Tables.getcolumn(t, :data) ==
        ones(3 * 2 * 3)
    @test Tables.getcolumn(t, 5) == Tables.getcolumn(t, :data2) ==
        fill(2, 3 * 2 * 3)
end

@testset "Mixed size" begin
    da1 = DimArray(reshape(11:28, (3, 2, 3)), (x, y, d); name=:data1)
    da2 = DimArray(reshape(1.0:6.0, (2, 3)), (y, d); name=:data2)
    ds = DimStack(da1, da2)
    @time t = DimTable(ds)
    @time df = DataFrame(t; copycols=true)
    @test names(df) == ["X", "Y", "test", "data1", "data2"]
    @test Tables.columntype(df, :X) == Symbol
    @test Tables.columntype(df, :data1) == Int
    @test Tables.columntype(df, :data2) == Float64

    @test Tables.getcolumn(df, 1)[:] == Tables.getcolumn(df, :X)[1:18] ==
        repeat([:a, :b, :c], 6)
    @test Tables.getcolumn(t, 2) == Tables.getcolumn(df, :Y) ==
        repeat([10.0, 10.0, 10.0, 20.0, 20.0, 20.0], 3)
    @test Tables.getcolumn(df, 3) == Tables.getcolumn(df, :test) ==
        vcat(repeat([1.0], 6), repeat([2.0], 6), repeat([3.0], 6))
    @test Tables.getcolumn(t, 4) == Tables.getcolumn(t, :data1) == 11:28
    @test Tables.getcolumn(t, 5) == Tables.getcolumn(t, :data2) == vcat(([x, x, x] for x in 1.0:6.0)...)
end

@testset "dim methods" begin
    ds = DimStack(da)
    @test dims(ds) == dims(da)
    @test lookup(ds) == lookup(dims(da))
end

@testset "one dimension tables" begin
    a = DimVector(1:3, x; name=:a)
    b = DimVector(4:6, x; name=:b)
    s = DimStack((a, b))
    @test Tables.columntable(a) == (X=[:a, :b, :c], a=1:3,)
    @test Tables.columntable(s) == (X=[:a, :b, :c], a=1:3, b=4:6)
end

@testset "zero dimension tables" begin
    a = DimArray(fill(1), (); name=:a);
    b = DimArray(fill(2), (); name=:b);
    ds = DimStack((a, b))
    @test Tables.columntable(a) == (a = [1],)
    @test Tables.columntable(ds) == (a = [1], b = [2])
end

@testset "DimTable layersfrom" begin
    a = DimArray(rand(32, 32, 5, 3), (X,Y,Dim{:band},Ti))
    t1 = DimTable(a)
    t2 = DimTable(a, layersfrom=Dim{:band})
    @test Tables.columnnames(t1) == (:X, :Y, :band, :Ti, :value)
    @test Tables.columnnames(t2) == (:X, :Y, :Ti, :band_1, :band_2, :band_3, :band_4, :band_5)
    @test length(t1.X) == (32 * 32 * 5 * 3)
    @test length(t2.X) == (32 * 32 * 3)
end

@testset "DimTable mergelayers" begin
    a = DimStack([DimArray(rand(32, 32, 3), (X,Y,Ti)) for _ in 1:3])
    b = DimArray(rand(32, 32, 3), (X, Y, Dim{:band}))
    t1 = DimTable(a, mergedims=(:X, :Y) => :geometry)
    t2 = DimTable(a, mergedims=(:X, :Y, :Z) => :geometry) # Merge missing dimension
    t3 = DimTable(a, mergedims=(X, :Y, Ti) => :dimensions) # Mix symbols and dimensions
    t4 = DimTable(b, mergedims=(:X, :Y) => :geometry) # Test DimArray
    @test Tables.columnnames(t1) == (:Ti, :geometry, :layer1, :layer2, :layer3)
    @test Tables.columnnames(t2) == (:Ti, :geometry, :layer1, :layer2, :layer3)
    @test Tables.columnnames(t3) == (:dimensions, :layer1, :layer2, :layer3)
    @test Tables.columnnames(t4) == (:band, :geometry, :value)
end

@testset "Materialize from table" begin
    a = DimArray(rand(UInt8, 100, 100), (X(100:-1:1), Y(-250:5:249)))
    b = DimArray(rand(Float32, 100, 100), (X(100:-1:1), Y(-250:5:249)))
    c = DimArray(rand(Float64, 100, 100), (X(100:-1:1), Y(-250:5:249)))
    ds = DimStack((a=a, b=b, c=c))
    t = DataFrame(ds)
    t1 = Random.shuffle(t)
    t2 = filter(r -> r.Y != -250, t)
    t3 = copy(t1)
    t3.X .+= rand(nrow(t1)) .* 1e-7 # add some random noise to check if precision works

    tabletypes = (Tables.rowtable, Tables.columntable, DataFrame)

    for type in tabletypes
        t = type(t)
        t1 = type(t1)
        t2 = type(t2)
        t3 = type(t3)
        @testset "All dimensions passed (using $type)" begin
            # Restore DimArray from shuffled table
            for table = (t1, t3)
                @test all(DimArray(table, dims(ds)) .== a)
                @test all(DimArray(table, dims(ds), name="a") .== a)
                @test all(DimArray(table, dims(ds), name="b") .== b)
                @test all(DimArray(table, dims(ds), name="c") .== c)
            end

            # Restore DimArray from table with missing rows
            @test all(DimArray(t2, dims(ds), name="a")[Y(2:100)] .== a[Y(2:100)])
            @test all(DimArray(t2, dims(ds), name="b")[Y(2:100)] .== b[Y(2:100)])
            @test all(DimArray(t2, dims(ds), name="c")[Y(2:100)] .== c[Y(2:100)])
            @test DimArray(t2, dims(ds), name="a")[Y(1)] .|> ismissing |> all
            @test DimArray(t2, dims(ds), name="b")[Y(1)] .|> ismissing |> all
            @test DimArray(t2, dims(ds), name="c")[Y(1)] .|> ismissing |> all
            @test DimArray(t2, dims(ds), name="a")[Y(2:100)] .|> ismissing .|> (!) |> all
            @test DimArray(t2, dims(ds), name="b")[Y(2:100)] .|> ismissing .|> (!) |> all
            @test DimArray(t2, dims(ds), name="c")[Y(2:100)] .|> ismissing .|> (!) |> all

            # Restore DimStack from shuffled table
            restored_stack = DimStack(t1, dims(ds))
            @test all(restored_stack.a .== ds.a)
            @test all(restored_stack.b .== ds.b)
            @test all(restored_stack.c .== ds.c)

            # Restore DimStack from table with missing rows
            restored_stack = DimStack(t2, dims(ds))
            @test all(restored_stack.a[Y(2:100)] .== ds.a[Y(2:100)])
            @test all(restored_stack.b[Y(2:100)] .== ds.b[Y(2:100)])
            @test all(restored_stack.c[Y(2:100)] .== ds.c[Y(2:100)])
            @test restored_stack.a[Y(1)] .|> ismissing |> all
            @test restored_stack.b[Y(1)] .|> ismissing |> all
            @test restored_stack.c[Y(1)] .|> ismissing |> all
            @test restored_stack.a[Y(2:100)] .|> ismissing .|> (!) |> all
            @test restored_stack.b[Y(2:100)] .|> ismissing .|> (!) |> all
            @test restored_stack.c[Y(2:100)] .|> ismissing .|> (!) |> all
        end

        @testset "Dimensions automatically detected (using $type)" begin
            da3 = DimArray(t)
            # Awkward test, see https://github.com/rafaqz/DimensionalData.jl/issues/953
            # If Dim{:X} == X then we can just test for equality
            @test lookup(dims(da3, :X)) == lookup(dims(a, X))
            @test lookup(dims(da3, :Y)) == lookup(dims(a, Y))
            @test parent(da3) == parent(a)

            for table in (t1, t3)
                da = DimArray(table)
                @test parent(da[X = At(100:-1:1), Y = At(-250:5:249)]) == parent(a)
                ds_ = DimStack(table)
                @test keys(ds_) == (:a, :b, :c)
                @test parent(ds_.a[X = At(100:-1:1), Y = At(-250:5:249)]) == parent(a)

            end
        end

        @testset "Dimensions partially specified (using $type)" begin
            for table in (t1, t3)
                # setting the order returns ordered dimensions
                da = DimArray(table, (X(Sampled(order = ReverseOrdered())), Y(Sampled(order=ForwardOrdered()))))
                @test dims(da, X) == dims(a, X)
                @test dims(da, Y) == dims(a, Y)
            end
            # passing in dimension types works
            @test DimArray(t, (X, Y)) == a
            @test parent(DimArray(t, (:X, Y))) == parent(a)
            @test parent(DimArray(t, (:X, :Y))) == parent(a)
            # passing in dimensions works for unconventional dimension names
            A = rand(dimz, name = :a)
            table = type(A)
            @test DimArray(table, (X, Y(Sampled(span = Irregular())), :test)) == A
            # Specifying dimensions types works even if it's illogical.
            dat = DimArray(t, (X(Sampled(span = Irregular(), order = Unordered())), Y(Categorical())))
            x, y = dims(dat)
            @test !isregular(x)
            @test !isordered(x)
            @test iscategorical(y)
            @test isordered(y) # this is automatically detected
        end
    end
end

@testset "DimTable preservedims" begin
    x, y, t = X(1.0:32.0), Y(1.0:10.0), Ti(DateTime.([2001, 2002, 2003]))
    st = DimStack([rand(x, y, t; name) for name in [:a, :b, :c]])
    A = rand(x, y, Dim{:band}(1:3); name=:vals)
    t1 = DimTable(st, preservedims=(X, Y))
    a3 = Tables.getcolumn(t1, :a)[3]
    @test Tables.columnnames(t1) == propertynames(t1) == (:Ti, :a, :b, :c)
    @test a3 == st.a[Ti=3]
    @test dims(a3) == dims(st, (X, Y))
    t2 = DimTable(A; preservedims=:band)
    val10 = Tables.getcolumn(t2, :vals)[10]
    @test Tables.columnnames(t2) == propertynames(t2) == (:X, :Y, :vals)
    @test val10 == A[X(10), Y(1)]
    @test dims(val10) == dims(A, (:band,))
    @testset "preservedims with mergedims" begin
        t3 = DimTable(A; mergedims=(X, Y) => :geometry, preservedims=:band)
        @test only(dims(t3)) isa Dim{:geometry}
        @test Tables.getcolumn(t2, :vals)[1] isa DimArray
    end
    @testset "preservedims with refdims" begin
        z = Z(2:4)
        t4 = DimTable(A; preservedims=:band, refdims=(z,))
        @test comparedims(Bool, getfield(t4, :dims), (x, y, z))
        @test Tables.getcolumn(t4, :vals)[1] isa DimArray
    end
end

@testset "DimTable NamedTuple" begin
    @testset "Vector of NamedTuple" begin
        da = DimArray([(; a=1.0f0i, b=2.0i) for i in 1:10], X)
        t = DimTable(da)
        s = Tables.schema(t)
        @test s.names == (:X, :a, :b)
        @test s.types == (Int, Float32, Float64)
        @test all(t.a .=== 1.0f0:10.0f0)
        @test all(t.b .=== 2.0:2.0:20.0)

        @testset "with refdims" begin
            z = Z(4:6)
            t2 = DimTable(da; refdims=(z,))
            s2 = Tables.schema(t2)
            @test s2.names == (:X, :Z, :a, :b)
            @test all(t2.Z .== collect(Iterators.flatten(fill(zi, length(da)) for zi in z)))
            @testset for col in (:X, :a, :b)
                @test all(Tables.getcolumn(t2, col) .==
                    repeat(Tables.getcolumn(t, col), length(z)))
            end
        end
    end

    @testset "Matrix of NamedTuple" begin
        da = [(; a=1.0f0x*y, b=2.0x*y) for x in X(1:10), y in Y(1:5)]
        t = DimTable(da);
        s = Tables.schema(t)
        @test s.names == (:X, :Y, :a, :b)
        @test s.types == (Int, Int, Float32, Float64)
        @test all(t.a .=== reduce(vcat, [1.0f0y:y:10.0f0y for y in 1:5]))
        @test all(t.b .=== reduce(vcat, [2.0y:2.0y:20.0y for y in 1:5]))

        @testset "with refdims" begin
            z = Z(4:6)
            t2 = DimTable(da; refdims=(z,))
            s2 = Tables.schema(t2)
            @test s2.names == (:X, :Y, :Z, :a, :b)
            @testset for col in (:X, :Y, :a, :b)
                @test all(Tables.getcolumn(t2, col) .==
                    repeat(Tables.getcolumn(t, col), length(z)))
            end
        end
    end
    @testset "Matrix of NamedTuple with preservedims" begin
        da = [(; a=1.0f0x*y, b=2.0x*y) for x in X(1:10), y in Y(1:5)]
        t = DimTable(da; preservedims=X);
        s = Tables.schema(t)
        @test s.names == (:Y, :a, :b)
        @test s.types[1] <: Int
        @test s.types[2] <: DimVector
        @test s.types[2] <: DimVector
        @test all(t.a .== [[1.0f0x*y for x in X(1:10)] for y in Y(1:5)])
        @test all(t.b .== [[2.0x*y for x in X(1:10)] for y in Y(1:5)])

        @testset "with refdims" begin
            z = Z(4:6)
            t2 = DimTable(da; preservedims=X, refdims=(z,))
            s2 = Tables.schema(t2)
            @test s2.names == (:Y, :Z, :a, :b)
            @testset for col in (:Y, :a, :b)
                @test all(Tables.getcolumn(t2, col) .==
                    repeat(Tables.getcolumn(t, col), length(z)))
            end
        end
    end
end

using DimensionalData, CategoricalArrays

x = DimArray([1, 2, 3], X(1:3))
c = categorical(x; levels = [1,2,3,4])
x2 = DimArray([1, 2, 3, missing], X(1:4))
c2 = categorical(x2; levels = [1,2,3,4])

@test c isa DimArray
@test c2 isa DimArray

@testset "compress" begin
    c_compressed = compress(c)
    @test c_compressed isa DimArray
    @test eltype(CategoricalArrays.refs(c_compressed)) == UInt8

    c_decompressed = decompress(c_compressed)
    @test c_decompressed isa DimArray
    @test eltype(CategoricalArrays.refs(c_decompressed)) == UInt32
end

@testset "levels" begin
    @test CategoricalArrays.leveltype(c) == Int64
    @test CategoricalArrays.leveltype(c2) == Int64
    @test levels(c) == levels(c2) == [1,2,3,4]
    droplevels!(c)
    droplevels!(c2)
    @test levels(c) == levels(c2) == [1,2,3]
    c3 = levels!(c, [1,2,3,4])
    levels!(c2, [1,2,3,4])
    @test levels(c) == levels(c2) == [1,2,3,4]
    @test c3 === c

    @test !isordered(c)
    ordered!(c, true)
    @test isordered(c)

    fill!(c2, 1) |> droplevels!
    @test levels(c2) == [1]
end

@testset "recode" begin
    c = categorical(x)
    c2 = categorical(x2)
    # on a normal dim array
    rc1 = recode(x, 1 => 2) 
    @test rc1 == [2,2,3]
    @test rc1 isa DimArray
    # with a default
    rc2 = recode(x, 2, 3 => 4)
    @test rc2 == [2,2,4]
    @test rc2 isa DimArray
    # on a categorical dim array
    rc3 = recode(c, 1 => 2) 
    @test rc3 == [2,2,3]
    @test rc3 isa DimArray

    # in-place
    recode!(c, 1 => 2)
    @test c == [2,2,3]

    c3 = categorical(x)
    recode!(c3, c, 2 => 3)
    @test c3 == [3,3,3]

    # from a dim array to a normal array
    c = categorical(x)
    A = categorical([1,2,2])
    recode!(A, c, 3 => 2)
    @test A == [1,2,2]
    recode!(A, x, 2 => 1, 3 => 2)
    @test A == [1,1,2]

    # with a default
    recode!(A, c, 3, 2 => 1)
    @test A == [3,1,3]
    recode!(A, x, 3, 2 => 1)
    @test A == [3,1,3]

    ## from an array to a dim array
    A = categorical([1,2,3])
    rc = recode!(c3, A, 2 => 3)
    @test c3 == [1,3,3]
    @test c3 isa DimArray
    @test rc === c3
    recode!(x, A, 2 => 3)
    @test x == [1,3,3]
    # with a default
    recode!(c3, A, 2, 2 => 3)
    @test c3 == [2,3,2]
    recode!(x, A, 2, 2 => 3)
    @test x == [2,3,2]
end

@testset "cut" begin
    x = DimArray([0.0, 0.2, 0.4, 0.6], X(1:4))
    c = cut(x,2)
    @test c isa DimArray{<:CategoricalArrays.CategoricalValue}
    @test length(levels(c)) == 2
    @test all(CategoricalArrays.refs(c) .== [1,1,2,2])

    c2 = cut(x, [0.1, 0.5, 1.0];extend = missing)
    @test c2 isa DimArray{<:Union{Missing, <:CategoricalArrays.CategoricalValue}}
    @test length(levels(c2)) == 2
    @test all(CategoricalArrays.refs(c2) .== [0,1,1,2])
    @test ismissing(first(c2))
end

@inline Base.getindex(d::Dimension) = val(d)

for f in (:getindex, :view, :dotview)
    @eval begin
        # Int and CartesianIndex forward to the parent array
        @propagate_inbounds function Base.$f(d::Dimension{<:AbstractArray}, i::Union{Int,CartesianIndex})
            Base.$f(val(d), i)
        end
        @propagate_inbounds function Base.$f(d::Dimension{<:AbstractArray}, i::Union{AbstractArray,Colon,CartesianIndices})
            # AbstractArray/Colon return an AbstractArray - so rebuild the dimension
            rebuild(d, Base.$f(val(d), i))
        end
        # Selector gets processed with `selectindices`
        @propagate_inbounds function Base.$f(d::Dimension{<:AbstractArray}, i::SelectorOrInterval)
            Base.$f(d, selectindices(val(d), i))
        end
        @propagate_inbounds function Base.$f(d::Dimension{<:AbstractArray}, i)
            x = Base.$f(parent(d), i)
            x isa AbstractArray ? rebuild(d, x) : x
        end
    end
end

#### dims2indices ####

"""
    dims2indices(dim::Dimension, I) => NTuple{Union{Colon,AbstractArray,Int}}

Convert a `Dimension` or `Selector` `I` to indices of `Int`, `AbstractArray` or `Colon`.
"""
@inline dims2indices(dim::Dimension, I) = _dims2indices(dim, I)
@inline dims2indices(x, I) = dims2indices(dims(x), I)
@inline dims2indices(::Nothing, I) = _dimsnotdefinederror()
@inline dims2indices(::Tuple{}, I) = ()
@inline dims2indices(dims::DimTuple, I) = dims2indices(dims, (I,))
# Standard array indices are simply returned
@inline dims2indices(dims::DimTuple, I::Tuple{Vararg{StandardIndices}}) = I
@inline dims2indices(dims::DimTuple, I::Tuple{<:Extents.Extent}) = dims2indices(dims, _extent_as(Interval, first(I)))
@inline dims2indices(dims::DimTuple, I::Tuple{<:Touches{<:Extents.Extent}}) = dims2indices(dims, _extent_as(Touches, val(first(I))))
@inline dims2indices(dims::DimTuple, I::Tuple{<:Near{<:Extents.Extent}}) = dims2indices(dims, _extent_as(Near, val(first(I))))

@inline dims2indices(dims::DimTuple, I::Tuple{<:CartesianIndex}) = I
@inline dims2indices(dims::DimTuple, sel::Tuple) = 
    Lookups.selectindices(lookup(dims), sel)
@inline dims2indices(dims::DimTuple, ::Tuple{}) = ()
# Otherwise attempt to convert dims to indices
@inline function dims2indices(dims::DimTuple, I::DimTuple)
    extradims = otherdims(I, dims) # extra dims in the query, I
    # Extract "multi dimensional" lookups like MergedLookup or Rasters' GeometryLookup
    multidims = Dimensions.dims(otherdims(dims, I), x -> hasinternaldimensions(lookup(x)) && !isempty(Dimensions.dims(x, I)))
    # Warn if any dims from I were not picked up by multidims
    actuallyextradims = otherdims(extradims, x -> any(y -> hasdim(y, x), multidims)) # one way setdiff(extradims, multidims) essentially
    length(actuallyextradims) > 0 && _extradimswarn(actuallyextradims)
    # Run the query for the known one-to-one dimensions
    Isorted = Dimensions.sortdims(I, dims)
    one_to_one_idxs = split_alignments(dims2indices, unalligned_dims2indices, dims, Isorted) 
    # Finally, run the query for the multidimensional dims
    # This is basically doing an Accessors.@set on the full_dim_structure
    # one_to_one_idxs is capable of indexing the whole dataset, but 
    # it doesn't know about the merged lookups.  This keeps all one-to-one
    # things the same but injects the solutions to the merged lookups where
    # available and appropriate.
    return map(dims, one_to_one_idxs) do dim, idx
        # Note that this loop iterates over `dims` so each multidim can only be encountered once
        if hasdim(multidims, dim)
            dims2indices(dim, Dimensions.dims(I, Dimensions.dims(dim)))
        else
            idx
        end
    end
end
@inline dims2indices(dims::Tuple{}, ::Tuple{}) = ()

@inline function unalligned_dims2indices(dims::DimTuple, sel::Tuple)
    map(sel) do s
        s isa Union{Selector,Interval} && _unalligned_all_selector_error(dims)
        isnothing(s) ? Colon() : s
    end
end
@inline function unalligned_dims2indices(dims::DimTuple, sel::Tuple{Selector,Vararg{Selector}})
    Lookups.select_unalligned_indices(lookup(dims), sel)
end

# Run fa on each aligned dimension d[n] and indices i[n], 
# and fu on grouped unaligned dimensions and I.
# The result is the updated dimensions, but in the original order
split_alignments(fa, fu, dims::Tuple, I::Tuple) = 
    split_alignments(fa, fu, val(dims), dims, I)
@generated function split_alignments(
    fa, fu, lookups::Tuple, dims::Tuple, I::Tuple
)
    # We separate out Aligned and Unaligned lookups as
    # Unaligned must be selected in groups e.g. X and Y together.
    unalligned = Expr(:tuple)
    uaI = Expr(:tuple)
    alligned = Expr(:tuple)
    dimmerge = Expr(:tuple)
    a_count = ua_count = 0
    for (i, lkup) in enumerate(lookups.parameters)
        if lkup <: Unaligned
            ua_count += 1
            push!(unalligned.args, :(dims[$i]))
            push!(uaI.args, :(I[$i]))
            push!(dimmerge.args, :(uadims[$ua_count]))
        else
            a_count += 1
            push!(alligned.args, :(fa(dims[$i], I[$i])))
            # Update the merged tuple
            push!(dimmerge.args, :(adims[$a_count]))
        end
    end

    if length(unalligned.args) > 1
        # Output the `dimmerge` tuple, which will
        # combine uadimsand adims in the right order
        quote
             adims = $alligned
             # Unaligned dims have to be run together as a set
             uadims = fu($unalligned, map(_unwrapdim, $uaI))
             $dimmerge
        end
    else
        alligned
    end
end


_unalligned_all_selector_error(dims) =
    throw(ArgumentError("Unalligned dims: use selectors for all $(join(map(name, dims), ", ")) dims, or none of them"))

_unwrapdim(dim::Dimension) = val(dim)
_unwrapdim(x) = x

# Single dim methods
# Simply unwrap dimensions
@inline _dims2indices(dim::Dimension, seldim::Dimension) = _dims2indices(dim, val(seldim))
# A Dimension type always means Colon(), as if it was constructed with the default value.
@inline _dims2indices(dim::Dimension, ::Type{<:Dimension}) = Colon()
# Nothing means nothing was passed for this dimension
@inline _dims2indices(dim::Dimension, i::AbstractBeginEndRange) = i
@inline _dims2indices(dim::Dimension, i::Union{Begin,End,Type{Begin},Type{End},LazyMath}) = 
    to_indices(parent(dim), Lookups._construct_types(i))[1]
@inline _dims2indices(dim::Dimension, ::Nothing) = Colon()
@inline _dims2indices(dim::Dimension, x) = Lookups.selectindices(val(dim), x)

function _extent_as(::Type{Lookups.Interval}, extent::Extents.Extent{Keys}) where Keys
    map(map(name2dim, Keys), values(extent)) do k, v
        rebuild(k, Lookups.Interval(v...))
    end    
end
function _extent_as(::Type{T}, extent::Extents.Extent{Keys}) where {T,Keys}
    map(map(name2dim, Keys), values(extent)) do k, v
        rebuild(k, T(v))
    end    
end

module DimensionalDataAlgebraOfGraphicsExt

import AlgebraOfGraphics as AoG
import DimensionalData as DD

# We can't use `DD.Dimensions.DimOrDimType` because that's a union with Symbol,
# which causes an ambiguity and would otherwise override the dedicated Symbol 
# `select` method in AoG.
const DimOrType = Union{DD.Dimensions.Dimension, Type{<: DD.Dimensions.Dimension}}

#=

This extension allows DimensionalData `Dimension` types to be used
as column selectors for AlgebraOfGraphics.jl.

Specifically, this implements the `AoG.select` method for `Columns`
objects, which is the type that `AlgebraOfGraphics.data` returns.

=#

# The generic selector, to enable this to work even in `DataFrame(dimarray)`
function AoG.select(data::AoG.Columns, dim::DimOrType)
    name = DD.name(dim)
    v = AoG.getcolumn(data.columns, Symbol(name))
    return (v,) => identity => AoG.to_string(name) => nothing
end

# The specific selector for `DimTable`s.
# This searches the dimensions of the dimtable for the appropriate dimension,
# so that e.g. `X` also applies to any `XDim`, and so forth.
function AoG.select(data::AoG.Columns{<: DD.AbstractDimTable}, dim::DimOrType)
    # Query the dimensions in the table for the dimension
    alldims = DD._dims(data.columns)
    available_dimension = DD.dims(alldims, dim)
    # If the dimension is not found, it might be the name of the
    # underlying array.
    name = if isnothing(available_dimension)
        if DD.name(dim) in DD.name(parent(data.columns))
            error(
                "Dimension $dim not found in DimTable with dimensions $(alldims), **but** it is" *
                (length(DD.name(parent(data.columns))) > 1 ? "a layer of the parent array" : "the name of the parent array") *
                ".\n\nYou can pass this directly as a `Symbol`, i.e. **`:$(DD.name(dim))`**."
            )
        else
            error("Dimension $dim not found in DimTable with dimensions $(alldims), and neither was it the name of the array ($(DD.name(parent(data.columns)))).")
        end
    else
        # The dimension was found, so use that name.
        DD.name(available_dimension)
    end
    # Get the column from the table
    v = AoG.getcolumn(data.columns, Symbol(name))
    # Return the column, with the appropriate labels
    return (v,) => identity => AoG.to_string(name) => nothing
end

end

using DimensionalData, Test, LinearAlgebra, Statistics, ConstructionBase, Random

using DimensionalData: data
using DimensionalData: Sampled, Categorical, AutoLookup, NoLookup, Transformed,
    Regular, Irregular, Points, Intervals, Start, Center, End,
    Metadata, NoMetadata, ForwardOrdered, ReverseOrdered, Unordered, basedims, layerdims, layers, metadata

A = [1.0 2.0 3.0;
     4.0 5.0 6.0]
x, y, z = X([:a, :b]), Y(10.0:10.0:30.0; metadata=Dict()), Z()
dimz = x, y
da1 = DimArray(A, (x, y); name=:one, metadata=Metadata())
da2 = DimArray(Float32.(2A), (x, y); name=:two)
da3 = DimArray(Int.(3A), (x, y); name=:three)
da4 = DimArray(cat(4A, 5A, 6A, 7A; dims=3), (x, y, z); name=:extradim)

s = DimStack((da1, da2, da3))
mixed = DimStack(da1, da2, da4)

@testset "constructors" begin
    @test DimStack((one=A, two=2A, three=3A), dimz) ==
        DimStack(da1, da2, da3) ==
        DimStack((one=da1, two=da2, three=da3), dimz) ==
        DimStack((one=da1, two=da2, three=da3)) ==
        DimStack([da1, da2, da3]; name=(:one, :two, :three)) ==
        DimStack((da1, da2, da3); name=(:one, :two, :three)) ==
        DimStack(da1, da2, da3; name=(:one, :two, :three)) ==
        DimStack(parent.([da1, da2, da3]), dimz; name=(:one, :two, :three)) == s
    @test DimStack((one=A[:, 1], two=2A[:, 1], three=3A[:, 1]), dimz[1]) ==
        DimStack(da1[:, 1], da2[:, 1], da3[:, 1]) ==
        DimStack((one=da1[:, 1], two=da2[:, 1], three=da3[:, 1]), dimz[1]) ==
        DimStack((one=da1[:, 1], two=da2[:, 1], three=da3[:, 1])) ==
        DimStack([da1[:, 1], da2[:, 1], da3[:, 1]]; name=(:one, :two, :three)) ==
        DimStack((da1[:, 1], da2[:, 1], da3[:, 1]); name=(:one, :two, :three)) ==
        DimStack(da1[:, 1], da2[:, 1], da3[:, 1]; name=(:one, :two, :three)) ==
        DimStack(parent.([da1[:, 1], da2[:, 1], da3[:, 1]]), dimz[1]; name=(:one, :two, :three)) == s[:, 1]
    @test dims(DimStack()) == dims(DimStack(())) == dims(DimStack(DimArray[])) == 
        dims(DimStack(NamedTuple())) == dims(DimStack((), ())) == dims(DimStack(Array[], ())) == ()
    @test DimStack([A, 2A, 3A], (Z(), Ti()); name=(:one, :two, :three), layerdims=[(Z(), Ti()), (Z(), Ti()), (Z(), Ti())]) ==
        DimStack((A, 2A, 3A), (Z(), Ti()); name=(:one, :two, :three), layerdims=(one=(Z(), Ti()), two=(Z(), Ti()), three=(Z(), Ti()))) ==
        DimStack((one=A, two=2A, three=3A), (Z(), Ti()); layerdims=[(Z(), Ti()), (Z(), Ti()), (Z(), Ti())]) ==
        DimStack((one=A, two=2A, three=3A), (Z(), Ti()); layerdims=(two=(Z(), Ti()), one=(Z(), Ti()), three=(Z(), Ti())))
end

@testset "layersfrom keyword" begin
    keys(DimStack(da1; layersfrom=X)) == (:a, :b)
end

@testset "layersdims function" begin
    @test DimensionalData.layerdims(s) == (one = (X(), Y()), two = (X(), Y()), three = (X(), Y()))
    @test DimensionalData.layerdims(mixed) == (one = (X(), Y()), two = (X(), Y()), extradim = (X(), Y(), Z()))
end

@testset "ConstructionBase" begin
    s1 = ConstructionBase.setproperties(s, (one=da1, two=da2, three=da1))
    @test s1.three == s.one
    @test s1.two == s.two
    @test s1.one == s.one
end

@testset "interface methods" begin
    @test dims(s) == dims(da1)
    @test dims(s, X) == x
    @test refdims(s) === ()
    @test metadata(mixed) == NoMetadata()
    @test name(s) == (:one, :two, :three)
end

@testset "symbol key indexing" begin
    da1x = s[:one]
    @test parent(da1x) === parent(da1)
    @test typeof(da1x) === typeof(da1)
end

@testset "getproperty" begin
    @test propertynames(s) == (:one, :two, :three)
    @test hasproperty(s, :one)
    da1x = s.one
    @test parent(da1x) === parent(da1)
    @test typeof(da1x) === typeof(da1)
end

@testset "broadcast over layer" begin
    s[:one] .*= 2;
    s[:one] ./= 2;
end

@testset "low level base methods" begin
    @test keys(s) == (:one, :two, :three)
    @test keys(mixed) == (:one, :two, :extradim)
    @test eltype(mixed) === @NamedTuple{one::Float64, two::Float32, extradim::Float64}
    @test haskey(s, :one) == true
    @test haskey(s, :zero) == false
    @test get(mixed, :one, nothing) == mixed.one
    @test get(mixed, :five, nothing) == nothing
    @test get(() -> nothing, mixed, :two) == mixed.two
    @test get(() -> nothing, mixed, :ten) == nothing
    @test size(mixed) === (2, 3, 4) # size is as for Array
    @test size(mixed, Y) === 3
    @test size(mixed, 3) === 4
    @test length(mixed) === 24
    @test firstindex(mixed) === 1
    @test lastindex(mixed) === 24
    @test eachindex(mixed) === 1:24
    @test axes(mixed) == (Base.OneTo(2), Base.OneTo(3), Base.OneTo(4))
    @test eltype(axes(mixed)) <: Dimensions.DimUnitRange
    @test dims(axes(mixed)) == dims(mixed)
    @test axes(mixed, X) == Base.OneTo(2)
    @test dims(axes(mixed, X)) == dims(mixed, X)
    @test axes(mixed, 2) == Base.OneTo(3)
    @test lastindex(mixed, 2) == 3
    @test dims(axes(mixed, 2)) == dims(mixed, 2)
    @test first(mixed) == mixed[Begin] 
    @test last(mixed) == mixed[End]
    @test NamedTuple(s) == (one=da1, two=da2, three=da3)
end

@testset "similar" begin
    @test all(maplayers(similar(mixed), mixed) do s, m
        dims(s) == dims(m) && dims(s) === dims(m) && eltype(s) === eltype(m)
    end)
    @test eltype(similar(s, Int)) === 
    @NamedTuple{one::Int, two::Int, three::Int}
    @test eltype(similar(s, @NamedTuple{one::Int, two::Float32, three::Bool})) === 
        @NamedTuple{one::Int, two::Float32, three::Bool}
    st2 = similar(mixed, Bool, x, y)
    @test dims(st2) === (x, y)
    @test dims(st2[:one]) === (x, y)
    @test eltype(st2) === @NamedTuple{one::Bool, two::Bool, extradim::Bool}
    @test eltype(similar(mixed)) == eltype(mixed)
    @test size(similar(mixed)) == size(mixed)
    @test keys(similar(mixed)) == keys(mixed)
    @test layerdims(similar(mixed)) == layerdims(mixed)
    xy = (X(), Y()) 
    @test layerdims(similar(mixed, dims(mixed, (X, Y)))) == (one=xy, two=xy, extradim=xy)
    st3 = similar(mixed, @NamedTuple{one::Int, two::Float32, extradim::Bool}, (Z([:a, :b, :c]), Ti(1:12), X(1:3)))
    @test layerdims(st3) == (one=(Ti(), X()), two=(Ti(), X()), extradim=(Z(), Ti(), X()))
    @test eltype(st3) == @NamedTuple{one::Int, two::Float32, extradim::Bool}
end

@testset "merge" begin
    @test layers(s) === (; s...)
    @test layers(s) === (; one=da1, s[(:two,)]..., (three=da3,)...)
    @test layers(s) === (; (one=da1,)..., two=da2, s[(:three,)]...)
    @test typeof(s) === typeof(merge(s[(:one,:two)], (three=da3,)))
    @test s === merge(s[(:one,)], (two=da2, three=da3))
    @test merge(mixed) === mixed
    @test keys(merge(mixed, s)) == (:one, :two, :extradim, :three)
    @test keys(merge(s, mixed)) == (:one, :two, :three, :extradim)
end

@testset "setindex" begin
    s12 = DimStack((da1, da2))
    @test s === Base.setindex(s12, da3, :three)
    s423 = DimStack((one=da4, two=da2, three=da3))
    @test s === Base.setindex(s423, da1, :one)
end

@testset "copy and friends" begin
    sc = copy(s)
    @test sc == s
    @test dims(sc) == dims(s)
    @test metadata(sc) == metadata(s)
    sdc = deepcopy(s)
    @test sdc == s
    @test dims(sdc) == dims(s)
    @test metadata(sdc) == metadata(s)
    s2 = zero(s)
    @test s2[:one] == [0.0 0.0 0.0; 0.0 0.0 0.0]
    # This should do nothing
    sr = read(s)
    @test sr === s
end

@testset "copy!" begin
    dest_A = zero(da1)
    @test dest_A !== da1
    copy!(dest_A, s[:one])
    @test dest_A == s[:one]
    dest_s = zero(s)
    @test dest_s !== s
    copy!(dest_s, s)
    @test dest_s == s
end

@testset "cat" begin
    x2 = X([:c, :d])
    da1 = DimArray(A, (x2, y); name=:one, metadata=Metadata())
    da2 = DimArray(Float32.(2A), (x2, y); name=:two)
    da3 = DimArray(Int.(3A), (x2, y); name=:three)
    s2 = DimStack((da1, da2, da3))

    s_cat = cat(s, s2; dims=X())
    @test s_cat[:one] == cat(parent(s[:one]), parent(s2[:one]); dims=1)
end

@testset "eachslice" begin
    xs = (X, :X, x, 1)
    xs2 = (xs..., map(tuple, xs)...)
    ys = (Y, :Y, y, 2)
    ys2 = (ys..., map(tuple, ys)...)
    zs = (Z, :Z, z, 3)
    zs2 = (zs..., map(tuple, zs)...)

    @testset "type-inferrable due to const-propagation" begin
        f(x, dims) = eachslice(x; dims)
        @testset for ds in (x, y, z, (x,), (y,), (z,), (x, y), (y, z), (x, y, z))
            # @inferred f(mixed, ds) not consistent accross julia 1.10 versions ??
            # I can't reproduce this locally
            f(mixed, ds)
        end
    end

    @testset "error thrown if dimensions invalid" begin
        @test_throws DimensionMismatch eachslice(mixed; dims=4)
        @test_throws DimensionMismatch eachslice(mixed; dims=Ti)
        @test_throws DimensionMismatch eachslice(mixed; dims=Dim{:x})
    end

    @testset "slice over X dimension" begin
        @testset for dims in xs2
            slices = map(identity, eachslice(mixed; dims=dims))
            @test slices isa DimArray{<:DimStack,1}
            slices2 = map(l -> view(mixed, X(At(l))), lookup(Dimensions.dims(mixed, x)))
            @test slices == slices2
        end
    end

    @testset "slice over Y dimension" begin
        @testset for dims in ys2
            slices = map(identity, eachslice(mixed; dims=dims))
            @test slices isa DimArray{<:DimStack,1}
            slices2 = map(l -> view(mixed, Y(At(l))), lookup(y))
            @test slices == slices2
        end
    end

    @testset "slice over Z dimension" begin
        ds = first(zs2)
        @testset for ds in zs2
            slices = map(identity, eachslice(mixed; dims=ds))
            @test slices isa DimArray{<:DimStack,1}
            slices2 = map(l -> view(mixed, Z(l)), axes(mixed, z))
            dims(slices2)
            @test all(map(===, slices, slices2))
        end
    end

    @testset "slice over combinations of Z and Y dimensions" begin
        @testset for ds in Iterators.product(zs, ys)
            # mixtures of integers and dimensions are not supported
            rem(sum(d -> isa(d, Int), ds), length(ds)) == 0 || continue
            slices = eachslice(mixed; dims=ds)
            slices2 = map(
                l -> view(mixed, Z(l[1]), Y(l[2])),
                Iterators.product(axes(mixed, z), axes(mixed, y)),
            )
            @test basedims(slices) == basedims(slices2)
            @test collect(slices) == collect(slices2)
        end
    end
end

@testset "maplayers" begin
    @test values(maplayers(a -> a .* 2, s))[1] == values(DimStack(2da1, 2da2, 2da3))[1]
    @test dims(maplayers(a -> a .* 2, s)) == dims(DimStack(2da1, 2da2, 2da3))
    @test maplayers(a -> a[1], s) == (one=1.0, two=2.0, three=3.0)
    @test values(maplayers(a -> a .* 2, s)) == values(DimStack(2da1, 2da2, 2da3))
    @test maplayers(+, s, s, s) == maplayers(a -> a .* 3, s)
    @test_throws ArgumentError maplayers(+, s, mixed)
    @test maplayers((s, a) -> s => a[1], (one="one", two="two", three="three"), s) == 
        (one="one" => 1.0, two="two" => 2.0, three="three" => 3.0)
end

@testset "methods with no arguments" begin
    @testset "permuting methods" begin
        @test data(permutedims(s)) == 
            (one=[1.0 4.0; 2.0 5.0; 3.0 6.0],
             two=[2.0 8.0; 4.0 10.0; 6.0 12.0],
             three=[3.0 12.0; 6.0 15.0; 9.0 18.0])
        @test adjoint(s) == DimStack(adjoint(da1), adjoint(da2), adjoint(da3))
        @test transpose(s) == DimStack(transpose(da1), transpose(da2), transpose(da3))
        @test Transpose(s) == DimStack(Transpose(da1), Transpose(da2), Transpose(da3))
        @test data(rotl90(s)) ==
            (one=[3.0 6.0;  2.0 5.0;  1.0 4.0],
             two=[6.0f0 12.0f0; 4.0f0 10.0f0; 2.0f0 8.0],
           three=[9 18; 6 15; 3 12])
        @test rotl90(s) == DimStack(rotl90(da1), rotl90(da2), rotl90(da3))
        @test rotr90(s) == DimStack(rotr90(da1), rotr90(da2), rotr90(da3))
        @test rot180(s) == DimStack(rot180(da1), rot180(da2), rot180(da3))
    end

    @test cor(s) isa DimStack
    @test cov(s) isa DimStack

    @test inv(s[1:2, 1:2]) isa DimStack

    @testset "reducing methods" begin
        @test sum(s) === (one=21.0, two=42.0f0, three=63)
        @test prod(s) === (one=720.0, two=46080.0f0, three=524880)
        @test Base.minimum(s) === (one=1.0, two=2.0f0, three=3)
        @test maximum(s) === (one=6.0, two=12.0f0, three=18)
        @test extrema(s) === (one=(1.0, 6.0), two=(2.0f0, 12.0f0), three=(3, 18))
        @test mean(s) === (one=3.5, two=7.0f0, three=10.5)
        @test std(s) === (one=1.8708286933869707, two=3.7416575f0, three=5.612486080160912)
        @test var(s) === (one=3.5, two=14.0f0, three=31.5)
        @test median(s) === (one=3.5, two=7.0f0, three=10.5)
    end
end

@testset "methods with a dims keyword argument" begin
    @testset "reducing methods" begin
        sum_ = sum(s; dims=X)
        @test sum_  == DimStack(sum(da1; dims=X), sum(da2; dims=X), sum(da3; dims=X))
        @test dims(sum_) == (X(Categorical([:combined]; order=ForwardOrdered())), dims(da1, Y))
        @test prod(s; dims=X) == DimStack(prod(da1; dims=X), prod(da2; dims=X), prod(da3; dims=X))
        @test dims(maximum(s; dims=X)) == 
            dims(DimStack(maximum(da1; dims=X), maximum(da2; dims=X), maximum(da3; dims=X)))
        @test minimum(s; dims=X) == DimStack(minimum(da1; dims=X), minimum(da2; dims=X), minimum(da3; dims=X))
        @test mean(s; dims=X()) == DimStack(mean(da1; dims=X), mean(da2; dims=X), mean(da3; dims=X))
        @test std(s; dims=X) == DimStack(std(da1; dims=X), std(da2; dims=X), std(da3; dims=X))
        @test var(s; dims=X) == DimStack(var(da1; dims=X), var(da2; dims=X), var(da3; dims=X))
        @test median(s; dims=X) == DimStack(median(da1; dims=X), median(da2; dims=X), median(da3; dims=X))
        @test mean(mixed; dims=X) == DimStack((mean(da1; dims=X), mean(da2; dims=X), mean(da4; dims=X)))
        @test mean(mixed; dims=Y) == DimStack((mean(da1; dims=Y), mean(da2; dims=Y), mean(da4; dims=Y)))
        @test mean(mixed; dims=Z) == DimStack((da1, da2, mean(da4; dims=Z)))
    end

    @testset "dim duplicating methods" begin
        @test cor(s; dims=X) isa DimStack
        @test cov(s; dims=X) isa DimStack
    end

    @testset "dim dropping methods" begin
        @test DimensionalData.layers(dropdims(s[X([1])]; dims=X)) == 
            (one=DimArray([1.0, 2.0, 3.0], dims(da1, Y)), 
             two=DimArray([2.0, 4.0, 6.0], dims(da1, Y)),
             three=DimArray([3.0, 6.0, 9.0], dims(da1, Y)))
    end

end

@testset "permuting methods with an argument" begin
    @test permutedims(s, (Y, X)) == 
        DimStack(permutedims(da1, (Y, X)), permutedims(da2, (Y, X)), permutedims(da3, (Y, X)))
    @test PermutedDimsArray(s, (Y(), X())) ==
        DimStack(PermutedDimsArray(da1, (Y, X)), PermutedDimsArray(da2, (Y, X)), PermutedDimsArray(da3, (Y, X)))
    rot = rotl90(s, 1)
    @test rot isa DimStack
    @test typeof(data(rot)) == NamedTuple{(:one, :two, :three),Tuple{Matrix{Float64},Matrix{Float32},Matrix{Int64}}}
    @test data(rot) ==
        (one=[3.0 6.0;  2.0 5.0;  1.0 4.0],
         two=[6.0f0 12.0f0; 4.0f0 10.0f0; 2.0f0 8.0f0],
       three=[9 18; 6 15; 3 12])
    @test rot[:one][X(At(:a)), Y(At(10.0))] == da1[X(At(:a)), Y(At(10.0))]
    @test rotr90(s, 2) == DimStack(rotr90(da1, 2), rotr90(da2, 2), rotr90(da3, 2))
    @test rot180(s, 1) == DimStack(rot180(da1, 1), rot180(da2, 1), rot180(da3, 1))
end

@testset "reducing methods that take a function" begin
    f = x -> 2x
    @test data(minimum(f, s; dims=X)) == 
        (one=[2.0 4.0 6.0], two=[4.0 8.0 12.0], three=[6.0 12.0 18.0])
    @test data(mean(x -> 2x, s; dims=X())) ==
        (one=mean(2da1; dims=X) , two=mean(2da2; dims=X), three=mean(2da3; dims=X))
    @test mean(f, s; dims=X) == DimStack(mean(f, da1; dims=X), mean(f, da2; dims=X), mean(f, da3; dims=X))
    @test reduce(+, s; dims=X) == DimStack(reduce(+, da1; dims=X), reduce(+, da2; dims=X), reduce(+, da3; dims=X))
    @test sum(f, s; dims=X) == DimStack(sum(f, da1; dims=X), sum(f, da2; dims=X), sum(f, da3; dims=X))
    @test prod(f, s; dims=X) == DimStack(prod(f, da1; dims=X), prod(f, da2; dims=X), prod(f, da3; dims=X))
    @test maximum(f, s; dims=X) == DimStack(maximum(f, da1; dims=X), maximum(f, da2; dims=X), maximum(f, da3; dims=X))
    @test extrema(f, s; dims=X) == DimStack(extrema(f, da1; dims=X), extrema(f, da2; dims=X), extrema(f, da3; dims=X))
    @test reduce(+, s) == (one=21.0, two=42.0, three=63.0)
    @test sum(f, s) == (one=42.0, two=84.0, three=126.0)
    @test prod(f, s) == (one=46080., two=2.94912e6, three=3.359232e7)
    @test Base.minimum(f, s) == (one=2.0, two=4.0, three=6.0)
    @test maximum(f, s) == (one=12.0, two=24.0, three=36.0)
    @test extrema(f, s) == (one=(2.0, 12.0), two=(4.0, 24.0), three=(6.0, 36.0))
    @test mean(f, s) == (one=7.0, two=14.0, three=21)
end

@testset "rand sampling" begin
    @test rand(s) isa @NamedTuple{one::Float64, two::Float32, three::Int}
    @test rand(Xoshiro(), s) isa @NamedTuple{one::Float64, two::Float32, three::Int}
    @test rand(mixed) isa @NamedTuple{one::Float64, two::Float32, extradim::Float64}
    @test rand(MersenneTwister(), mixed) isa @NamedTuple{one::Float64, two::Float32, extradim::Float64}
end

# https://github.com/rafaqz/DimensionalData.jl/issues/891
@testset "DimStack of nested DimArrays" begin
    nested_da = DimArray([da1, da2], Z(1:2))
    ds = DimStack((a = nested_da, b = nested_da))
    @test ds[1] == (a = da1, b = da1)
    @test ds[Z = 1] == (a = da1, b = da1)
    @test ds[Z = 1:2] == ds

end

@testset "isequal and == with missing" begin
    a = [missing 1; 1 1]
    da1 = DimArray(a, (X(1:2), Y(1:2)))
    da2 = DimArray(copy(a), (X(2:3), Y(2:3)))
    ds1 = DimStack(da1)
    ds2 = DimStack(da2)
    @test (ds1 == ds2) == false
    @test ismissing(ds1 == ds1)
    @test isequal(ds1, ds1)
end

@testset "skipmissing" begin
    skips = skipmissing(s)
    skips2 = skipmissing(mixed)
    @test eltype(skips) === @NamedTuple{one::Float64, two::Float32, three::Int}
    @test eltype(skips2) === @NamedTuple{one::Float64, two::Float32, extradim::Float64}
    @test collect(skips) == vec(s)
    @test collect(skips2) == vec(mixed)

    da5 = DimArray([missing, 1], x)
    s2 = DimStack((one = da1, two = da5))
    @test eltype(skipmissing(s2)) === @NamedTuple{one::Float64, two::Int}
    cs2 = collect(skipmissing(s2))
    @test all(getindex.(cs2, :two) .== 1)
    @test getindex.(cs2, :one) == da1[X=2]
end

@testset "DimStack as Array" begin
    for s in (s, mixed)
        dsa = DimensionalData.DimStackArray(s)
        # Test basic array properties
        @test eltype(dsa) == eltype(s)
        @test dims(dsa) == dims(s)
        @test collect(dsa) == collect(s)
        @test refdims(dsa) == refdims(s)
        @test metadata(dsa) == metadata(s)
        
        # Test indexing methods
        @test s[1] == dsa[1] == dsa[map(one, size(s))...] == dsa[first(DimSelectors(s))]
        
        # Test view
        v = view(dsa, map(x -> (x-1):x, size(s))...)
        @test v isa DimensionalData.DimStackArray
        @test all(x -> parent(x) isa SubArray, layers(parent(v)))
        @test size(v) == Tuple((2 for _ in 1:ndims(s)))
        @test first(v) == s[map(x -> x-1, size(s))...]
        
        # Test iteration
        @test first(dsa) == first(s)
        @test collect(dsa) == collect(s)
    end
end

# These functions do most of the work in the package.
# They are all type-stable recursive methods for performance and extensibility.

"""
    dimsmatch([f], dim, query) => Bool
    dimsmatch([f], dims::Tuple, query::Tuple) => Bool

Compare 2 dimensions or `Tuple` of `Dimension` are of the same base type,
or are at least rotations/transformations of the same type.

`f` is `<:` by default, but can be `>:` to match abstract types to concrete types.
"""
function dimsmatch end
@inline dimsmatch(dims, query)::Bool = dimsmatch(<:, dims, query)
@inline function dimsmatch(f::Function, dims::Tuple, query::Tuple)::Bool
    length(dims) == length(query) || return false
    all(map((d, l) -> dimsmatch(f, d, l), dims, query))
end
@inline dimsmatch(f::Function, dim, query)::Bool = dimsmatch(f, typeof(dim), typeof(query))
@inline dimsmatch(f::Function, dim::Type, query)::Bool = dimsmatch(f, dim, typeof(query))
@inline dimsmatch(f::Function, dim, query::Type)::Bool = dimsmatch(f, typeof(dim), query)
@inline dimsmatch(f::Function, dim::Nothing, query::Type)::Bool = false
@inline dimsmatch(f::Function, dim::Type, ::Nothing)::Bool = false
@inline dimsmatch(f::Function, dim, query::Nothing)::Bool = false
@inline dimsmatch(f::Function, dim::Nothing, query)::Bool = false
@inline dimsmatch(f::Function, dim::Nothing, query::Nothing) = false
@inline dimsmatch(f::Function, dim::Type{Val{D}}, match::Type{Val{M}}) where {D,M} =
    dimsmatch(f, D, M)
@inline dimsmatch(f::Function, dim::Type{D}, match::Type{Val{M}}) where {D,M} =
    dimsmatch(f, D, M)
@inline dimsmatch(f::Function, dim::Type{Val{D}}, match::Type{M}) where {D,M} =
    dimsmatch(f, D, M)
@inline function dimsmatch(f::Function, dim::Type{D}, match::Type{M})::Bool where {D,M}
    # Match based on type and inheritance
    f(basetypeof(unwrap(D)), basetypeof(unwrap(M))) ||
    # Or match based on name so that Dim{:X} matches X
    isconcretetype(D) && isconcretetype(M) && name(D) === name(M)
end

"""
    name2dim(s::Symbol) => Dimension
    name2dim(dims...) => Tuple{Dimension,Vararg}
    name2dim(dims::Tuple) => Tuple{Dimension,Vararg}

Convert a symbol to a dimension object. `:X`, `:Y`, `:Ti` etc will be converted
to `X()`, `Y()`, `Ti()`, as with any other dims generated with the [`@dim`](@ref) macro.

All other `Symbol`s `S` will generate `Dim{S}()` dimensions.
"""
function name2dim end
@inline name2dim(t::Tuple) = map(name2dim, t)
@inline name2dim(s::Symbol) = name2dim(Val{s}())
# Allow other things to pass through
@inline name2dim(d::Val{<:Dimension}) = d
@inline name2dim(d) = d

# name2dim is defined for concrete instances in dimensions.jl

@deprecate key2dim name2dim
@deprecate dim2key name

"""
    sortdims([f], tosort, order) => Tuple

Sort dimensions `tosort` by `order`. Dimensions in `order` but
missing from `tosort` are replaced with `nothing`.

`tosort` and `order` can be `Tuple`s or `Vector`s or Dimension
or dimension type. Abstract supertypes like [`TimeDim`](@ref)
can be used in `order`.

`f` is `<:` by default, but can be `>:` to sort abstract types by concrete types.
"""
function sortdims end
@inline sortdims(a1, a2) = _dim_query(_sortdims, MaybeFirst(), a1, a2)
@inline sortdims(f::Function, a1, a2) = _dim_query(_sortdims, f, MaybeFirst(), a1, a2)

# Defined before the @generated function for world age
_asfunc(::Type{typeof(<:)}) = <:
_asfunc(::Type{typeof(>:)}) = >:

@inline function _sortdims(f, tosort::Tuple, order::Tuple{<:Integer,Vararg})
    map(order) do i
        if i in 1:length(tosort)
            tosort[i]
        else
            nothing
        end
    end
end
@inline _sortdims(f, tosort::Tuple, order::Tuple) = _sortdims_gen(f, tosort, order)

@generated function _sortdims_gen(f, tosort::Tuple, order::Tuple)
    expr = Expr(:tuple)
    allreadyfound = Int[]
    for (i, ord) in enumerate(order.parameters)
        # Make sure we don't find the same dim twice
        found = 0
        while true
            found = findnext((tosort.parameters...,), found + 1) do s
                dimsmatch(_asfunc(f), s, ord)
            end
            if found == nothing
                push!(expr.args, :(nothing))
                break
            elseif !(found in allreadyfound)
                push!(expr.args, :(tosort[$found]))
                push!(allreadyfound, found)
                break
            end
        end
    end
    return expr
end

"""
    dims(x, query) => Tuple{Vararg{Dimension}}
    dims(x, query...) => Tuple{Vararg{Dimension}}

Get the dimension(s) matching the type(s) of the query dimension.

Lookup can be an Int or an Dimension, or a tuple containing
any combination of either.

## Arguments
- `x`: any object with a `dims` method, or a `Tuple` of `Dimension`.
- `query`: Tuple or a single `Dimension` or `Dimension` `Type`.

## Example
```jldoctest
julia> using DimensionalData

julia> A = DimArray(ones(2, 3, 2), (X, Y, Z))
┌ 2×3×2 DimArray{Float64, 3} ┐
├────────────────────── dims ┤
  ↓ X, → Y, ↗ Z
└────────────────────────────┘
[:, :, 1]
 1.0  1.0  1.0
 1.0  1.0  1.0

julia> dims(A, (X, Y))
(↓ X, → Y)

```
"""
function dims end
@inline dims(a1, args...) = _dim_query(_dims, MaybeFirst(), a1, args...)
@inline dims(::Tuple{}, ::Tuple{}) = ()

@inline _dims(f, dims, query) = _remove(Nothing, _sortdims(f, dims, query)...)
@inline _dims(f, dims, query...) = _remove(Nothing, _sortdims(f, dims, query)...)

"""
    commondims([f], x, query) => Tuple{Vararg{Dimension}}

This is basically `dims(x, query)` where the order of the original is kept,
unlike [`dims`](@ref) where the query tuple determines the order

Also unlike `dims`,`commondims` always returns a `Tuple`, no matter the input.
No errors are thrown if dims are absent from either `x` or `query`.

`f` is `<:` by default, but can be `>:` to sort abstract types by concrete types.

```jldoctest
julia> using DimensionalData, .Dimensions

julia> A = DimArray(ones(10, 10, 10), (X, Y, Z));

julia> commondims(A, X)
(↓ X)

julia> commondims(A, (X, Z))
(↓ X, → Z)

julia> commondims(A, Ti)
()

```
"""
function commondims end
@inline commondims(a1, args...) = 
    _dim_query(_commondims, AlwaysTuple(), a1, args...)

_commondims(f, ds, query) = _dims(f, ds, _dims(_flip_subtype(f), query, ds))
_commondims(f, ds) = ()

_missingdims(x, query::Tuple) = filter(q -> !hasdim(x, q), query)

"""
    dimnum(x, query::Tuple) => NTuple{Int}
    dimnum(x, query) => Int

Get the number(s) of `Dimension`(s) as ordered in the dimensions of an object.

## Arguments
- `x`: any object with a `dims` method, a `Tuple` of `Dimension` or a single `Dimension`.
- `query`: Tuple, Array or single `Dimension` or dimension `Type`.

The return type will be a Tuple of `Int` or a single `Int`,
depending on whether `query` is a `Tuple` or single `Dimension`.

## Example

```jldoctest
julia> using DimensionalData

julia> A = DimArray(ones(10, 10, 10), (X, Y, Z));

julia> dimnum(A, (Z, X, Y))
(3, 1, 2)

julia> dimnum(A, Y)
2
```
"""
function dimnum end
@inline function dimnum(x, query::Tuple)
    all(hasdim(x, query)) || _extradimserror(_missingdims(x, query))
    _dim_query(_dimnum, MaybeFirst(), x, query...)
end
@inline dimnum(x, q1::Union{DimOrDimType,Integer}, query::Union{DimOrDimType,Integer}...) =
   dimnum(x, (q1, query...))
@inline dimnum(x, query::Function) =
    _dim_query(_dimnum, MaybeFirst(), x, query)
@inline dimnum(x, q1, query...) =
    throw(ArgumentError("`dimnum` accepts Dimensions, Symbols, Integers or any of these in a Tuple, or a predicate, function. not $((q1, query...))."))

@inline _dimnum(f::Function, ds::Tuple, query::Tuple{Vararg{Integer}}) = query
@inline function _dimnum(f::Function, ds::Tuple, query::Tuple)
    numbered = map(ds, ntuple(identity, length(ds))) do d, i
        rebuild(d, i)
    end
    map(val, _dims(f, numbered, query))
end
_dimnum(f::Function, ds::Tuple) = ()

"""
    hasdim([f], x, query::Tuple) => NTuple{Bool}
    hasdim([f], x, query...) => NTuple{Bool}
    hasdim([f], x, query) => Bool

Check if an object `x` has dimensions that match or inherit from the `query` dimensions.

## Arguments
- `x`: any object with a `dims` method, a `Tuple` of `Dimension` or a single `Dimension`.
- `query`: Tuple or single `Dimension` or dimension `Type`.
- `f`: `<:` by default, but can be `>:` to match abstract types to concrete types.

Check if an object or tuple contains an `Dimension`, or a tuple of dimensions.

## Example
```jldoctest
julia> using DimensionalData

julia> A = DimArray(ones(10, 10, 10), (X, Y, Z));

julia> hasdim(A, X)
true

julia> hasdim(A, (Z, X, Y))
(true, true, true)

julia> hasdim(A, Ti)
false
```
"""
function hasdim end
@inline hasdim(x, a1, args...) =
    _dim_query(_hasdim, MaybeFirst(), x, a1, args...)

@inline _hasdim(f, dims, query) =
    map(d -> !(d isa Nothing), _sortdims(f, _commondims(f, dims, query), query))
@inline _hasdim(f, dims, query::Tuple{Vararg{Int}}) =
    map(l -> l in eachindex(dims), query)

"""
    otherdims(x, query) => Tuple{Vararg{Dimension,N}}

Get the dimensions of an object _not_ in `query`.

## Arguments
- `x`: any object with a `dims` method, a `Tuple` of `Dimension`.
- `query`: Tuple or single `Dimension` or dimension `Type`.
- `f`: `<:` by default, but can be `>:` to match abstract types to concrete types.

A tuple holding the unmatched dimensions is always returned.

## Example
```jldoctest
julia> using DimensionalData, DimensionalData.Dimensions

julia> A = DimArray(ones(10, 10, 10), (X, Y, Z));

julia> otherdims(A, X)
(↓ Y, → Z)

julia> otherdims(A, (Y, Z))
(↓ X)
```
"""
function otherdims end
@inline otherdims(x, query...) =
    _dim_query(_otherdims, AlwaysTuple(), x, query...)

@inline _otherdims(f, ds) = ds
@inline function _otherdims(f, ds, query)
    sorted = sortdims(f, dims(ds, query), ds)
    _otherdims_from_nothing(f, ds, sorted)
end
# Work with a sorted query where the missing dims are `nothing`
@inline _otherdims_from_nothing(f, ds::Tuple, query::Tuple) =
    (_dimifnothing(f, first(ds), first(query))..., _otherdims_from_nothing(f, tail(ds), tail(query))...)
@inline _otherdims_from_nothing(f, ::Tuple{}, ::Tuple{}) = ()

@inline _dimifnothing(f, dim, query) = ()
@inline _dimifnothing(f, dim, query::Nothing) = (dim,)


"""
    setdims(X, newdims) => AbstractArray
    setdims(::Tuple, newdims) => Tuple{Vararg{Dimension,N}}

Replaces the first dim matching `<: basetypeof(newdim)` with newdim,
and returns a new object or tuple with the dimension updated.

## Arguments
- `x`: any object with a `dims` method, a `Tuple` of `Dimension` or a single `Dimension`.
- `newdim`: Tuple or single `Dimension`, `Type` or `Symbol`.

# Example
```jldoctest
using DimensionalData, DimensionalData.Dimensions, DimensionalData.Lookups
A = ones(X(10), Y(10:10:100))
B = setdims(A, Y(Categorical('a':'j'; order=ForwardOrdered())))
lookup(B, Y)
# output
Categorical{Char} ForwardOrdered
wrapping: 'a':1:'j'
```
"""
function setdims end
@inline setdims(x, d1, d2, ds...) = setdims(x, (d1, d2, ds...))
@inline setdims(x) = x
@inline setdims(x, newdims::Dimension) = rebuild(x; dims=setdims(dims(x), name2dim(newdims)))
@inline setdims(x, newdims::Tuple) = rebuild(x; dims=setdims(dims(x), name2dim(newdims)))
@inline setdims(dims::Tuple, newdim::Dimension) = setdims(dims, (newdim,))
@inline setdims(dims::Tuple, newdims::Tuple) = swapdims(dims, sortdims(newdims, dims))
@inline setdims(dims::Tuple, newdims::Tuple{}) = dims

"""
    swapdims(x::T, newdims) => T
    swapdims(dims::Tuple, newdims) => Tuple{Vararg{Dimension}}

Swap dimensions for the passed in dimensions, in the
order passed.

Passing in the `Dimension` types rewraps the dimension lookup,
keeping the index values and metadata, while constructed `Dimension`
objects replace the original dimension. `nothing` leaves the original
dimension as-is.

## Arguments
- `x`: any object with a `dims` method or a `Tuple` of `Dimension`.
- `newdim`: Tuple of `Dimension` or dimension `Type`.

# Example

```jldoctest
using DimensionalData
A = ones(X(2), Y(4), Z(2))
Dimensions.swapdims(A, (Dim{:a}, Dim{:b}, Dim{:c}))

# output
┌ 2×4×2 DimArray{Float64, 3} ┐
├────────────────────── dims ┤
  ↓ a, → b, ↗ c
└────────────────────────────┘
[:, :, 1]
 1.0  1.0  1.0  1.0
 1.0  1.0  1.0  1.0
```
"""
function swapdims end
@inline swapdims(x, d1, d2, ds...) = swapdims(x, (d1, d2, ds...))
@inline swapdims(x) = x
@inline swapdims(x, newdims::Tuple) =
    rebuild(x; dims=format(swapdims(dims(x), newdims), x))
@inline swapdims(dims::DimTuple, newdims::Tuple) =
    map((d, nd) -> _swapdims(d, nd), dims, newdims)

@inline _swapdims(dim::Dimension, newdim::DimType) = basetypeof(newdim)(val(dim))
@inline _swapdims(dim::Dimension, newdim::Dimension) = newdim
@inline _swapdims(dim::Dimension, newdim::Nothing) = dim

"""
    slicedims(x, I) => Tuple{Tuple,Tuple}
    slicedims(f, x, I) => Tuple{Tuple,Tuple}

Slice the dimensions to match the axis values of the new array.

All methods return a tuple containing two tuples: the new dimensions,
and the reference dimensions. The ref dimensions are no longer used in
the new struct but are useful to give context to plots.

Called at the array level the returned tuple will also include the
previous reference dims attached to the array.

# Arguments

- `f`: a function `getindex`,  `view` or `dotview`. This will be used for slicing
    `getindex` is the default if `f` is not included.
- `x`: An `AbstractDimArray`, `Tuple` of `Dimension`, or `Dimension`
- `I`: A tuple of `Integer`, `Colon` or `AbstractArray`
"""
function slicedims end
@propagate_inbounds slicedims(args...) = slicedims(getindex, args...)
@propagate_inbounds slicedims(f::Function, x, i1, i2, I...) = slicedims(f, x, (i1, i2, I...))
@propagate_inbounds slicedims(f::Function, x, I::CartesianIndex) = slicedims(f, x, Tuple(I))
@propagate_inbounds slicedims(f::Function, x, I::Tuple) = _slicedims(f, dims(x), refdims(x), I)
@propagate_inbounds slicedims(f::Function, dims::Tuple, I::Tuple) = _slicedims(f, dims, I)
@propagate_inbounds slicedims(f::Function, dims::Tuple, refdims::Tuple, i1, I...) = slicedims(f, dims, refdims, (i1, I...))
@propagate_inbounds slicedims(f::Function, dims::Tuple, refdims::Tuple, I) = _slicedims(f, dims, refdims, I)
@propagate_inbounds slicedims(f::Function, dims::Tuple, refdims::Tuple, I::CartesianIndex) =
    slicedims(f, dims, refdims, Tuple(I))

@propagate_inbounds function _slicedims(f, dims::Tuple, refdims::Tuple, I::Tuple)
    # Unaligned may need grouped slicing
    newdims, newrefdims = if any(map(d -> lookup(d) isa Unaligned, dims))
        # Separate out unaligned dims
        udims = _unalligned_dims(dims)
        odims = otherdims(dims, udims)
        oI = map(d -> I[dimnum(dims, d)], odims)
        uI = map(d -> I[dimnum(dims, d)], udims)
        d, rd = _slicedims(f, odims, oI)
        udims, urefdims = sliceunalligneddims(f, uI, udims...)
        # Recombine dims and refdims
        Dimensions.dims((d..., udims...), dims), (rd..., urefdims...)
    else
        _slicedims(f, dims, I)
    end
    return newdims, (refdims..., newrefdims...)
end

@propagate_inbounds _slicedims(f, dims::Tuple, refdims::Tuple, I::Tuple{}) = dims, refdims
@propagate_inbounds _slicedims(f, dims::DimTuple, I::Tuple{}) = dims, ()
@propagate_inbounds function _slicedims(f, dims::DimTuple, I::Tuple{<:CartesianIndex})
    return _slicedims(f, dims, Tuple(I[1]))
end
@propagate_inbounds _slicedims(f, dims::DimTuple, I::Tuple) = begin
    d = _slicedims(f, first(dims), first(I))
    ds = _slicedims(f, tail(dims), tail(I))
    (d[1]..., ds[1]...), (d[2]..., ds[2]...)
end
# Return an AnonDim where e.g. a trailing Colon was passed
@propagate_inbounds function _slicedims(f, dims::Tuple{}, I::Tuple{Base.Slice,Vararg})
    d = (AnonDim(_unwrapinds(first(I))),), ()
    ds = _slicedims(f, (), tail(I))
    (d[1]..., ds[1]...), (d[2]..., ds[2]...)
end
# Drop trailing Integers
@propagate_inbounds _slicedims(f, dims::Tuple{}, I::Tuple{Integer,Vararg}) = _slicedims(f, (), tail(I))
@propagate_inbounds _slicedims(f, dims::Tuple{}, I::Tuple{CartesianIndices{0,Tuple{}},Vararg}) = _slicedims(f, (), tail(I))
@propagate_inbounds _slicedims(f, dims::Tuple{}, I::Tuple{}) = (), ()
@propagate_inbounds _slicedims(f, d::Dimension, i::Colon) = (d,), ()
@propagate_inbounds _slicedims(f::F, d::Dimension, i::Integer) where F = (), (f(d, i:i),)
@propagate_inbounds _slicedims(f::F, d::Dimension, i) where F = (f(d, i),), ()

_unwrapinds(s::Base.Slice) = s.indices
_unwrapinds(x) = x # Not sure this can ever be hit? But just in case

_unalligned_dims(dims::Tuple) = _unalligned_dims(dims...)
_unalligned_dims(dim::Dimension{<:Unaligned}, args...) = (dim, _unalligned_dims(args...)...)
_unalligned_dims(dim::Dimension, args...) = _unalligned_dims(args...)
_unalligned_dims() = ()

# Default
function sliceunalligneddims(f, uI, udims...)
    udims, ()
end

"""
    reducedims(x, dimstoreduce) => Tuple{Vararg{Dimension}}

Replace the specified dimensions with an index of length 1.
This is usually to match a new array size where an axis has been
reduced with a method like `mean` or `reduce` to a length of 1,
but the number of dimensions has not changed.

`Lookup` traits are also updated to correspond to the change in
cell step, sampling type and order.
"""
function reducedims end
@inline reducedims(x, dimstoreduce) = _reducedims(x, name2dim(dimstoreduce))

@inline _reducedims(x, dimstoreduce) = _reducedims(x, (dimstoreduce,))
@inline _reducedims(x, dimstoreduce::Tuple) = _reducedims(dims(x), dimstoreduce)
@inline _reducedims(dims::DimTuple, dimstoreduce::Tuple) =
    map(_reducedims, dims, sortdims(dimstoreduce, dims))
# Map numbers to corresponding dims. Not always type-stable
@inline _reducedims(dims::DimTuple, dimstoreduce::Tuple{Vararg{Int}}) =
    map(_reducedims, dims, sortdims(map(i -> dims[i], dimstoreduce), dims))
# Reduce matching dims but ignore nothing vals - they are the dims not being reduced
@inline _reducedims(dim::Dimension, ::Nothing) = dim
@inline _reducedims(dim::Dimension, ::DimOrDimType) = rebuild(dim, reducelookup(lookup(dim)))

const DimTupleOrEmpty = Union{DimTuple,Tuple{}}

"""
    comparedims(A::AbstractDimArray...; kw...)
    comparedims(A::Tuple...; kw...)
    comparedims(A::Dimension...; kw...)
    comparedims(::Type{Bool}, args...; kw...)

Check that dimensions or tuples of dimensions passed as each
argument are the same, and return the first valid dimension.
If `AbstractDimArray`s are passed as arguments their dimensions are compared.

Empty tuples and `nothing` dimension values are ignored,
returning the `Dimension` value if it exists.

Passing `Bool` as the first argument means `true`/`false` will be returned,
rather than throwing an error.

# Keywords

These are all `Bool` flags:

- `type`: compare dimension type, `true` by default.
- `valtype`: compare wrapped value type, `false` by default.
- `val`: compare wrapped values, `false` by default.
- `order`: compare order, `false` by default.
- `length`: compare lengths, `true` by default.
- `ignore_length_one`: ignore length `1` in comparisons, and return whichever
    dimension is not length 1, if any. This is useful in e.g. broadcasting comparisons.
    `false` by default.
- `msg`: DimensionalData.Warn or DimensionalData.Throw. Both may contain string,
    which will be added to error or warning mesages.
"""
function comparedims end
@inline comparedims(args...; kw...)::Bool =
    _comparedims(args...; msg=Throw(), kw...)
@inline comparedims(::Type{Bool}, args...; kw...)::Bool =
    _comparedims(args...; msg=nothing, kw...)

abstract type AbstractMessage{M} end

msg(t::AbstractMessage) = t.msg
msg(::AbstractMessage{Nothing}) = ""

Base.string(m::AbstractMessage) = msg(m)

struct Warn{M<:Union{AbstractString,Nothing}} <: AbstractMessage{M}
    msg::M
end
Warn() = Warn(nothing)

struct Throw{M<:Union{AbstractString,Nothing}} <: AbstractMessage{M}
    msg::M
end
Throw() = Throw(nothing)
_limit_sprint(x) = sprint(show, x; context = :limit => true)
_dimsmismatchmsg(a, b) = "$(basetypeof(a)) and $(basetypeof(b)) dims on the same axis."
_valmsg(a, b) = "Lookup values for $(basetypeof(a)) of $(_limit_sprint(parent(a))) and $(_limit_sprint(parent(b))) do not match."
_dimsizemsg(a, b) = "Found both lengths $(length(a)) and $(length(b)) for $(basetypeof(a))."
_valtypemsg(a, b) = "Lookup for $(basetypeof(a)) of $(lookup(a)) and $(lookup(b)) do not match."
_ordermsg(a, b) = "Lookups do not all have the same order: $(order(a)), $(order(b))."

@noinline _dimsmismatchaction(err, a, b) = _failed_comparedims(err, _dimsmismatchmsg(a, b))
@noinline _valaction(err, a, b) = _failed_comparedims(err, _valmsg(a, b))
@noinline _dimsizeaction(err, a, b) = _failed_comparedims(err, _dimsizemsg(a, b))
@noinline _valtypeaction(err, a, b) = _failed_comparedims(err, _valtypemsg(a, b))
@noinline _orderaction(err, a, b) = _failed_comparedims(err, _ordermsg(a, b))

_failed_comparedims(w::Warn, msg_intro) = @warn string(msg_intro, msg(w))
_failed_comparedims(t::Throw, msg_intro) = throw(DimensionMismatch(string(msg_intro, msg(t))))

@inline _comparedims(; kw...) = true
@inline _comparedims(xs...; kw...) = _comparedims(map(dims, xs)...; kw...)
@inline _comparedims(dt1::DimTupleOrEmpty; kw...) = true
@inline _comparedims(dt1::DimTupleOrEmpty, dts::DimTupleOrEmpty...; kw...) =
    _comparedims_gen(dt1, dts; kw...)
@generated function _comparedims_gen(dt1::Tuple, dts::Tuple; kw...)
    n = length(dts.parameters)
    exprs = map(1:n) do i
        :(_comparedims2(dt1, dts[$i]; kw...))
    end
    return Expr(:call, :all, Expr(:tuple, exprs...))
end

@inline _comparedims(d1::Union{Dimension,Nothing}, d2::Union{Dimension,Nothing}; kw...) =
    _comparedims2(d1, d2; kw...)
@inline _comparedims(d1::Union{Dimension,Nothing}, d2::Union{Dimension,Nothing}, ds::Vararg{Union{Dimension,Nothing}}; kw...) =
    all((_comparedims2(d1, d2; kw...), _comparedims(d1, ds...; kw...)...))
@inline _comparedims(d1::Dimension; kw...) = true
@inline _comparedims(d1::Nothing; kw...) = true
@inline _comparedims(dt::Tuple; kw...) = true

@inline _comparedims2(as::Tuple{<:Dimension}, bs::Tuple{<:Dimension}; kw...) =
    _comparedims2(as[1], bs[1]; kw...)
@inline _comparedims2((a1, as...)::DimTuple, (b1, bs...)::DimTuple; kw...) =
    _comparedims2(a1, b1; kw...) && _comparedims2(as, bs; kw...)
@inline _comparedims2(::Nothing, b::DimTupleOrEmpty; kw...) = true
@inline _comparedims2(::Nothing, ::Nothing; kw...) = true
@inline _comparedims2(a::DimTuple, b::Tuple{}; kw...) = true
@inline _comparedims2(a::Tuple{}, b::DimTuple; kw...) = true
@inline _comparedims2(a::Tuple{}, b::Tuple{}; kw...) = true
@inline _comparedims2(a::AnonDim, b::AnonDim; kw...) = true
@inline _comparedims2(a::Dimension, b::AnonDim; kw...) = true
@inline _comparedims2(a::AnonDim, b::Dimension; kw...) = true
@inline function _comparedims2(a::Dimension, b::Dimension;
    type=true, valtype=false, val=false, length=true, order=false,
    ignore_length_one=false, msg
)
    if type && basetypeof(a) != basetypeof(b)
        isnothing(msg) || _dimsmismatchaction(msg, a, b)
        return false
    end
    if ignore_length_one && (Base.length(a) == 1 || Base.length(b) == 1)
        return true
    end
    if order && !(isnolookup(a) || isnolookup(b) || Lookups.order(a) == Lookups.order(b))
        isnothing(msg) || _orderaction(msg, a, b)
        return false
    end
    if valtype && typeof(parent(a)) != typeof(parent(b))
        isnothing(msg) || _valtypeaction(msg, a, b)
        return false
    end
    pa, pb = parent(lookup(a)), parent(lookup(b))
    if val && !(isnolookup(a) || isnolookup(b)) && pa != pb
        if eltype(pa) <: Number && eltype(pb) <: Number
            if !all(((a, b),) -> a ≈ b, zip(pa, pb))
                isnothing(msg) || _valaction(msg, a, b)
                return false
            end
        else
            isnothing(msg) || _valaction(msg, a, b)
            return false
        end
    end
    if length && Base.length(a) != Base.length(b)
        isnothing(msg) || _dimsizeaction(msg, a, b)
        return false
    end
    return true
end

"""
    promotedims(dts::DimTuple...; skip_length_one=false)
    promotedims(dts::Dimensions...; skip_length_one=false)

Promote the types of dimensions and contained lookups so that
the returned type is always the same independent of order, but
that the lookup values come from the first argument.

# Keywords

- `skip_length_one`: the returned type will remain the same,
    but the values from the first lookup with length larger than
    one will be used.
"""
# Not actually documented, maybe too internal
@inline function promotedims(d1::Dimension, ds::Dimension...; skip_length_one=false)
    vs = map(val, ds)
    v = promote_first(val(d1), vs...)
    promoted_v = if skip_length_one
        _promote_non_length_one(v, v, vs...)
    else
        v
    end

    return rebuild(d1, promoted_v)
end
promotedims(dts::DimTupleOrEmpty...; kw...) = _promotedims_gen(dts; kw...)

# Hard to get this stable without @generated
@generated function _promotedims_gen(dts::Tuple; kw...)
    isempty(dts.parameters) && return Expr(:tuple)
    maxlen = maximum(Tuple(dts.parameters)) do p
        length(p.parameters)
    end
    exprs = map(1:maxlen) do j
        expr = Expr(:call, :promotedims, Expr(:parameters, Expr(:..., :kw)))
        for (i, p) in enumerate(dts.parameters)
            if length(p.parameters) >= j
                push!(expr.args, :(dts[$i][$j]))
            end
        end
        expr
    end
    return Expr(:tuple, exprs...)
end

@inline function _promote_non_length_one(template, v1, vs...)
    if length(v1) > 1
        promote_first(v1, template)
    else
        _promote_non_length_one(template, vs...)
    end
end
@inline _promote_non_length_one(template, v1) = promote_first(v1, template)


"""
    combinedims(xs; check=true, kw...)

Combine the dimensions of each object in `xs`, in the order they are found.

Keywords are passed to [`comparedims`](@ref).
"""
function combinedims end
function combinedims(xs::Vector; kw...)
    if length(xs) > 0
        reduce(xs; init=dims(first(xs))) do ds, A
            _combinedims(ds, dims(A); kw...)
        end
    else
        ()
    end
end
combinedims(; kw...) = ()
combinedims(x1, xs...; kw...) = combinedims(map(dims, (x1, xs...))...; kw...)
combinedims(dt1::DimTupleOrEmpty; kw...) = dt1
combinedims(dt1::DimTupleOrEmpty, dt2::DimTupleOrEmpty, dimtuples::DimTupleOrEmpty...; kw...) =
    reduce((dt2, dimtuples...); init=dt1) do dims1, dims2
        _combinedims(dims1, dims2; kw...)
    end
# Cant use `map` here, tuples may not be the same length
_combinedims(a::DimTupleOrEmpty, b::DimTupleOrEmpty; check=true, kw...) = begin
    if check # Check the matching dims are the same
        common = commondims(a, b)
        comparedims(dims(a, common), dims(b, common); kw...)
    end
    # Take them from a, and add any extras from b
    (a..., otherdims(b, a)...)
end

"""
    basedims(ds::Tuple)
    basedims(d::Union{Dimension,Symbol,Type})

Returns `basetypeof(d)()` or a `Tuple` of called on a `Tuple`.

See [`basetypeof`](@ref)
"""
function basedims end
@inline basedims(x) = basedims(dims(x))
@inline basedims(::Nothing) = nothing
@inline basedims(ds::Tuple) = map(basedims, ds)
@inline basedims(d::Dimension) = basetypeof(d)()
@inline basedims(d::Symbol) = name2dim(d)
@inline basedims(T::Type{<:Dimension}) = basetypeof(T)()
@inline basedims(x, y) = basedims(dims(x, dims(y)))

@inline pairs2dims(pairs::Pair...) = map(p -> basetypeof(name2dim(first(p)))(last(p)), pairs)

@inline kw2dims(kw::Base.Iterators.Pairs) = kw2dims(values(kw))
# Convert `Symbol` keyword arguments to a `Tuple` of `Dimension`
@inline kw2dims(kw::NamedTuple{Keys}) where Keys = kw2dims(name2dim(Keys), values(kw))
@inline kw2dims(dims::Tuple, vals::Tuple) =
    (rebuild(first(dims), first(vals)), kw2dims(tail(dims), tail(vals))...)
@inline kw2dims(::Tuple{}, ::Tuple{}) = ()


# Queries

# Most primitives use these for argument handling

abstract type QueryMode end
struct MaybeFirst <: QueryMode end
struct AlwaysTuple <: QueryMode end

(::AlwaysTuple)(xs::Tuple) = xs
(::MaybeFirst)(xs::Tuple) = first(xs)
(::MaybeFirst)(::Tuple{}) = nothing

# Call the function f with standardised args
# This looks like HELL, but it removes this complexity
# from every other method and makes sure they all behave the same way.
@inline _dim_query(f::F, t::QueryMode, args...) where F<:Function =
    _dim_query(f, <:, t::QueryMode, args...)
@inline _dim_query(f::F, t::QueryMode, op::O, args...) where {F<:Function,O<:Union{typeof(<:),typeof(>:)}} =
    _dim_query(f, op, t::QueryMode, args...)
@inline _dim_query(f::F, t::QueryMode, op::O, a1, args::Tuple) where {F<:Function,O<:Union{typeof(<:),typeof(>:)}} =
    _dim_query(f, op, t::QueryMode, a1, args...)
@inline _dim_query(f::F, op::O, t::QueryMode, a1, args...) where {F<:Function,O<:Union{typeof(<:),typeof(>:)}} =
    _dim_query1(f, op, t, _wraparg(a1, args...)...)
@inline _dim_query(f::F, op::O, t::QueryMode, a1, args::Tuple) where {F<:Function,O<:Union{typeof(<:),typeof(>:)}}  =
    _dim_query1(f, op, t::QueryMode, _wraparg(a1)..., _wraparg(args...))

@inline _dim_query1(f::F, op::O, t, x, l1, l2, ls...) where {F,O} =
    _dim_query1(f, op, t, x, (l1, l2, ls...))
@inline _dim_query1(f::F, op::O, t, x) where {F,O} =
    _dim_query1(f, op, t, dims(x))
@inline _dim_query1(f::F, op::O, t, x, query::Q) where {F,O,Q} =
    _dim_query1(f, op, t, dims(x), query)
@inline _dim_query1(f::F, op::O, t, x::Nothing) where {F,O} =
    _dimsnotdefinederror()
@inline _dim_query1(f::F, op::O, t, x::Nothing, query::Q) where {F,O,Q} =
    _dimsnotdefinederror()
@inline _dim_query1(f::F, op::O, t, ds::Tuple, query::Colon) where {F,O} =
    _dim_query1(f, op, t, ds, basedims(ds))
@inline function _dim_query1(f::F, op::O, t, ds::Tuple, query::Q) where {F,O,Q<:Function}
    selection = foldl(ds; init=()) do acc, d
        query(d) ? (acc..., d) : acc
    end
    _dim_query1(f, op, t, ds, selection)
end
@inline function _dim_query1(f::F, op::O, t, d::Tuple, query::Q) where {F,O,Q}
    ds = dims(query)
    isnothing(ds) && _dims_are_not_dims()
    _dim_query1(f, op, t, d, ds)
end
@inline _dim_query1(f::F, op::O, t::QueryMode, d::Tuple, query::Union{Dimension,DimType,Val,Integer}) where {F,O} =
    _dim_query1(f, op, t, d, (query,)) |> t
@inline _dim_query1(f::F, op::O, ::QueryMode, d::Tuple, query::Tuple) where {F,O} =
    map(unwrap, f(op, d, query))
@inline _dim_query1(f::F, op::O, ::QueryMode, d::Tuple) where {F,O} =
    map(unwrap, f(op, d))

# This looks ridiculous, but gives seven arguments with constant-propagation,
# which means type stability using Symbols/types instead of objects.
@inline _wraparg(d1, d2, d3, d4, d5, d6, d7, ds...) =
    (_w(d1), _w(d2), _w(d3), _w(d4), _w(d5), _w(d6), _w(d7), _wraparg(ds...)...)
@inline _wraparg(d1, d2, d3, d4, d5, d6) = _w(d1), _w(d2), _w(d3), _w(d4), _w(d5), _w(d6)
@inline _wraparg(d1, d2, d3, d4, d5) = _w(d1), _w(d2), _w(d3), _w(d4), _w(d5)
@inline _wraparg(d1, d2, d3, d4) = _w(d1), _w(d2), _w(d3), _w(d4)
@inline _wraparg(d1, d2, d3) = _w(d1), _w(d2), _w(d3)
@inline _wraparg(d1, d2) = _w(d1), _w(d2)
@inline _wraparg(d1) = (_w(d1),)
@inline _wraparg() = ()

@inline _w(t::Tuple) = _wraparg(t...)
@inline _w(x) = x
@inline _w(s::Symbol) = name2dim(s)
@inline _w(::Type{T}) where T = Val{T}()

@inline _flip_subtype(::typeof(<:)) = >:
@inline _flip_subtype(::typeof(>:)) = <:

_astuple(t::Tuple) = t
_astuple(x) = (x,)


# Warnings and Error methods.

_extradimsmsg(::Tuple{}) = "Some dims were not found in object."
_extradimsmsg(extradims) = "$(extradims) dims were not found in object."
_metadatamsg(a, b) = "Metadata $(metadata(a)) and $(metadata(b)) do not match."
_typemsg(a, b) = "Lookups do not all have the same type: $(order(a)), $(order(b))."

# Warn
@noinline _extradimswarn(dims, msg="") = @warn string(_extradimsmsg(dims), msg)

# Error
@noinline _metadataerror(a, b) = throw(DimensionMismatch(_metadatamsg(a, b)))
@noinline _extradimserror(args) = throw(ArgumentError(_extradimsmsg(args)))
@noinline _dimsnotdefinederror() = throw(ArgumentError("Object does not define a `dims` method"))

@noinline _dims_are_not_dims() = throw(ArgumentError("`dims` are not `Dimension`s"))

for f in (
    :isnolookup,
    :issampled,
    :iscategorical,
    :iscyclic,
    :isintervals,
    :ispoints,
    :isregular,
    :isexplicit,
    :isstart,
    :iscenter,
    :isend,
    :isordered,
    :isforward,
    :isreverse,
)
    @eval begin
        Lookups.$f(x::Dimension) = $f(val(x))
        Lookups.$f(::Nothing) = false
        Lookups.$f(xs::DimTuple) = all(map($f, xs))
        Lookups.$f(x::Any) = $f(dims(x))
        Lookups.$f(x::Any, ds) = $f(dims(x, ds))
    end
end

"""
    shiftlocus(locus::Locus, x)

Shift the values of `x` from the current locus to the new locus.

We only shift `Sampled`, `Regular` or `Explicit`, `Intervals`. 
"""
function shiftlocus(locus::Locus, lookup::Lookup)
    samp = sampling(lookup)
    samp isa Intervals || error("Cannot shift locus of $(nameof(typeof(samp)))")
    newvalues = _shiftlocus(locus, lookup)
    newlookup = rebuild(lookup; data=newvalues)
    return unsafe_set(newlookup, locus)
end

# Fallback - no shifting
_shiftlocus(locus::Locus, lookup::Lookup) = parent(lookup)
# Sampled
function _shiftlocus(locus::Locus, lookup::AbstractSampled)
    _shiftlocus(locus, span(lookup), sampling(lookup), lookup)
end
# TODO:
_shiftlocus(locus::Locus, span::Irregular, sampling::Sampling, lookup::Lookup) = parent(lookup)
# Sampled Regular
function _shiftlocus(destlocus::Center, span::Regular, sampling::Intervals, l::Lookup)
    if destlocus === locus(sampling)
        return parent(l)
    else
        offset = _offset(locus(sampling), destlocus)
        shift = ((parent(l) .+ abs(step(span))) .- parent(l)) .* offset
        return parent(l) .+ shift
    end
end
function _shiftlocus(destlocus::Locus, span::Regular, sampling::Intervals, lookup::Lookup)
    parent(lookup) .+ (abs(step(span)) * _offset(locus(sampling), destlocus))
end
# Sampled Explicit
_shiftlocus(::Start, span::Explicit, sampling::Intervals, lookup::Lookup) = val(span)[1, :]
_shiftlocus(::End, span::Explicit, sampling::Intervals, lookup::Lookup) = val(span)[2, :]
function _shiftlocus(destlocus::Center, span::Explicit, sampling::Intervals, lookup::Lookup)
    _shiftlocus(destlocus, locus(lookup), span, sampling, lookup)
end
_shiftlocus(::Center, ::Center, span::Explicit, sampling::Intervals, lookup::Lookup) = parent(lookup)
function _shiftlocus(::Center, ::Locus, span::Explicit, sampling::Intervals, lookup::Lookup)
    # A little complicated so that DateTime works
    (view(val(span), 2, :)  .- view(val(span), 1, :)) ./ 2 .+ view(val(span), 1, :)
end

_offset(::Start, ::Center) = 0.5
_offset(::Start, ::End) = 1
_offset(::Center, ::Start) = -0.5
_offset(::Center, ::End) = 0.5
_offset(::End, ::Start) = -1
_offset(::End, ::Center) = -0.5
_offset(::T, ::T) where T<:Locus = 0

maybeshiftlocus(locus::Locus, l::Lookup) = _maybeshiftlocus(locus, sampling(l), l)

_maybeshiftlocus(locus::Locus, sampling::Intervals, l::Lookup) = shiftlocus(locus, l)
_maybeshiftlocus(locus::Locus, sampling::Sampling, l::Lookup) = l

"""
    basetypeof(x) => Type

Get the "base" type of an object - the minimum required to
define the object without it's fields. By default this is the full
`UnionAll` for the type. But custom `basetypeof` methods can be
defined for types with free type parameters.

In DimensionalData this is primarily used for comparing `Dimension`s,
where `Dim{:x}` is different from `Dim{:y}`.
"""
@inline basetypeof(x::T) where T = basetypeof(T)
@generated function basetypeof(::Type{T}) where T
    if T isa Union
        T
    else
        Base.unwrap_unionall(T).name.wrapper
    end
end

# unwrap
# Unwrap Val and Type{Val}, or return unchanged
unwrap(::Val{X}) where X = X
unwrap(::Type{Val{X}}) where X = X
unwrap(x) = x

# orderof
# Detect the order of an abstract array
orderof(A::AbstractUnitRange) = ForwardOrdered()
orderof(A::AbstractRange) = _order(A)
function orderof(A::AbstractArray{<:IntervalSets.Interval})
    indord = _order(A)
    sorted = issorted(A; rev=Lookups.isrev(indord), by=x -> x.left)
    return sorted ? indord : Unordered()
end
function orderof(A::AbstractArray)
    local sorted, indord
    # This is awful. But we don't know if we can
    # call `issorted` on the contents of `A`.
    # This may be resolved by: https://github.com/JuliaLang/julia/pull/37239
    try
        indord = _order(A)
        sorted = issorted(A; rev=Lookups.isrev(indord))
    catch
        sorted = false
    end
    return sorted ? indord : Unordered()
end

_order(A) = first(A) <= last(A) ? ForwardOrdered() : ReverseOrdered()
_order(A::AbstractArray{<:IntervalSets.Interval}) = first(A).left <= last(A).left ? ForwardOrdered() : ReverseOrdered()


# Remove objects of type T from a 
Base.@assume_effects :foldable _remove(::Type{T}, x, xs...) where T = (x, _remove(T, xs...)...)
Base.@assume_effects :foldable _remove(::Type{T}, ::T, xs...) where T = _remove(T, xs...)
Base.@assume_effects :foldable _remove(::Type) = ()



reorder(lookup::Lookup, neworder::Order) = _reorder(lookup, neworder)

# Reorder
_reorder(lookup::Lookup, neworder::Order) =
    _reorder(lookup, order(lookup), neworder)
# Same order, do nothing
_reorder(lookup::Lookup, ::O, ::O) where {O<:Ordered} = lookup
_reorder(lookup::Lookup, ::O, ::O) where {O<:Unordered} = lookup
# We can always convert to `Unordered` without changing the lookup
_reorder(lookup::Lookup, ::Ordered, neworder::Unordered) =
    rebuild(lookup; order=neworder)
# Different order, reverse the lookup
_reorder(lookup::Lookup, ::Ordered, neworder::Ordered) = reverse(lookup)
# To set to `Ordered` we need to sort
function _reorder(l::Lookup, ::Unordered, o::Ordered)
    # We use sortperm then index in case there is a bounds matrix
    # or similar, rather than just sort on lookup values
    idxs = sortperm(l; rev=isrev(o))
    return rebuild(l[idxs]; order=o)
end

"""
    Lookup

Types defining the behaviour of a lookup index, how it is plotted
and how [`Selector`](@ref)s like [`Between`](@ref) work.

A `Lookup` may be [`NoLookup`](@ref) indicating that there are no
lookup values, [`Categorical`](@ref) for ordered or unordered categories,
or a [`Sampled`](@ref) index for [`Points`](@ref) or [`Intervals`](@ref).
"""
abstract type Lookup{T,N} <: AbstractArray{T,N} end

const LookupArray = Lookup
const LookupTuple = Tuple{Lookup,Vararg{Lookup}}

span(lookup::Lookup) = NoSpan()
sampling(lookup::Lookup) = NoSampling()

dims(::Lookup) = nothing
val(l::Lookup) = parent(l)
locus(l::Lookup) = Center()

Base.eltype(l::Lookup{T}) where T = T
Base.parent(l::Lookup) = l.data
Base.size(l::Lookup) = size(parent(l))
Base.length(l::Lookup) = length(parent(l))
Base.axes(l::Lookup) = axes(parent(l))
Base.first(l::Lookup) = first(parent(l))
Base.last(l::Lookup) = last(parent(l))
Base.firstindex(l::Lookup) = firstindex(parent(l))
Base.lastindex(l::Lookup) = lastindex(parent(l))
Base.parentindices(l::Lookup) = parentindices(parent(l))
function Base.:(==)(l1::Lookup, l2::Lookup)
    basetypeof(l1) == basetypeof(l2) && parent(l1) == parent(l2)
end

ordered_first(l::AbstractArray) = l[ordered_firstindex(l)]
ordered_last(l::AbstractArray) = l[ordered_lastindex(l)]

ordered_firstindex(l::AbstractArray) = firstindex(l)
ordered_firstindex(l::Lookup) = ordered_firstindex(order(l), l)
ordered_firstindex(::ForwardOrdered, l::Lookup) = firstindex(parent(l))
ordered_firstindex(::ReverseOrdered, l::Lookup) = lastindex(parent(l))
ordered_firstindex(::Unordered, l::Lookup) = firstindex(parent(l))

ordered_lastindex(l::AbstractArray) = lastindex(l)
ordered_lastindex(l::Lookup) = ordered_lastindex(order(l), l)
ordered_lastindex(::ForwardOrdered, l::Lookup) = lastindex(parent(l))
ordered_lastindex(::ReverseOrdered, l::Lookup) = firstindex(parent(l))
ordered_lastindex(::Unordered, l::Lookup) = lastindex(parent(l))

function Base.searchsortedfirst(lookup::Lookup, val; lt=<, kw...)
    searchsortedfirst(parent(lookup), unwrap(val); order=ordering(order(lookup)), lt=lt, kw...)
end
function Base.searchsortedlast(lookup::Lookup, val; lt=<, kw...)
    searchsortedlast(parent(lookup), unwrap(val); order=ordering(order(lookup)), lt=lt, kw...)
end

"""
    AutoLookup <: Lookup

    AutoLookup()
    AutoLookup(values=AutoValues(); kw...)

Automatic [`Lookup`](@ref), the default lookup. It will be converted automatically
to another [`Lookup`](@ref) when it is possible to detect it from the lookup values.

Keywords will be used in the detected `Lookup` constructor.
"""
struct AutoLookup{T,A<:AbstractVector{T},K} <: Lookup{T,1}
    data::A
    kw::K
end
AutoLookup(values=AutoValues(); kw...) = AutoLookup(values, kw)

order(lookup::AutoLookup) = hasproperty(lookup.kw, :order) ? lookup.kw.order : AutoOrder()
span(lookup::AutoLookup) = hasproperty(lookup.kw, :span) ? lookup.kw.span : AutoSpan()
sampling(lookup::AutoLookup) = hasproperty(lookup.kw, :sampling) ? lookup.kw.sampling : AutoSampling()
metadata(lookup::AutoLookup) = hasproperty(lookup.kw, :metadata) ? lookup.kw.metadata : NoMetadata()

Base.step(lookup::AutoLookup) = Base.step(parent(lookup))

bounds(lookup::Lookup) = _bounds(order(lookup), lookup)
# Fallback for raw arrays (e.g., when lookup returns a raw range)
bounds(x::AbstractArray) = (first(x), last(x))

_bounds(::ForwardOrdered, l::Lookup) = first(l), last(l)
_bounds(::ReverseOrdered, l::Lookup) = last(l), first(l)
_bounds(::Unordered, l::Lookup) = (nothing, nothing)

@noinline Base.step(lookup::T) where T <: Lookup =
    error("No step provided by $T. Use a `Sampled` with `Regular`")

"""
    Aligned <: Lookup

Abstract supertype for [`Lookup`](@ref)s
where the lookup is aligned with the array axes.

This is by far the most common supertype for `Lookup`.
"""
abstract type Aligned{T,O} <: Lookup{T,1} end

order(lookup::Aligned) = lookup.order


abstract type AbstractNoLookup <: Aligned{Int,Order} end

order(::AbstractNoLookup) = ForwardOrdered()
span(::AbstractNoLookup) = Regular(1)

Base.step(lookup::AbstractNoLookup) = 1

"""
    NoLookup <: Lookup

    NoLookup()

A [`Lookup`](@ref) that is identical to the array axis.
[`Selector`](@ref)s can't be used on this lookup.

## Example

Defining a `DimArray` without passing lookup values
to the dimensions, it will be assigned `NoLookup`:

```jldoctest NoLookup
using DimensionalData

A = DimArray(rand(3, 3), (X, Y))
Dimensions.lookup(A)

# output

NoLookup, NoLookup
```

Which is identical to:

```jldoctest NoLookup
using .Lookups
A = DimArray(rand(3, 3), (X(NoLookup()), Y(NoLookup())))
Dimensions.lookup(A)

# output

NoLookup, NoLookup
```
"""
struct NoLookup{A<:AbstractVector{Int}} <: AbstractNoLookup
    data::A
end
NoLookup() = NoLookup(AutoValues())

rebuild(l::NoLookup; data=parent(l), kw...) = NoLookup(data)

# Used in @d broadcasts
struct Length1NoLookup{A<:AbstractUnitRange} <: AbstractNoLookup 
    data::A
end
Length1NoLookup() = Length1NoLookup(Base.OneTo(1))

"""
    AbstractSampled <: Aligned

Abstract supertype for [`Lookup`](@ref)s where the lookup is
aligned with the array, and is independent of other dimensions. [`Sampled`](@ref)
is provided by this package.

`AbstractSampled` must have  `order`, `span` and `sampling` fields,
or a `rebuild` method that accepts them as keyword arguments.
"""
abstract type AbstractSampled{T,O<:Order,Sp<:Span,Sa<:Sampling} <: Aligned{T,O} end

span(lookup::AbstractSampled) = lookup.span
sampling(lookup::AbstractSampled) = lookup.sampling
metadata(lookup::AbstractSampled) = lookup.metadata
locus(lookup::AbstractSampled) = locus(sampling(lookup))

Base.step(lookup::AbstractSampled) = step(span(lookup))

function Base.:(==)(l1::AbstractSampled, l2::AbstractSampled)
    order(l1) == order(l2) &&
    span(l1) == span(l2) &&
    sampling(l1) == sampling(l2) &&
    parent(l1) == parent(l2)
end

for f in (:getindex, :view, :dotview)
    @eval begin
        # span may need its step size or bounds updated
        @propagate_inbounds function Base.$f(l::AbstractSampled, i::AbstractArray)
            i1 = Base.to_indices(l, (i,))[1]
            rebuild(l; data=Base.$f(parent(l), i1), span=slicespan(l, i1))
        end
    end
end

# bounds
bounds(l::AbstractSampled) = _bounds(order(l), sampling(l), l)

_bounds(order::Order, ::Points, l::AbstractSampled) = _bounds(order, l)
_bounds(::Unordered, ::Intervals, l::AbstractSampled) = (nothing, nothing)
_bounds(::Ordered, sampling::Intervals, l::AbstractSampled) =
    _bounds(sampling, span(l), l)

_bounds(::Intervals, span::Irregular, lookup::AbstractSampled) = bounds(span)
_bounds(sampling::Intervals, span::Explicit, lookup::AbstractSampled) =
    _bounds(order(lookup), sampling, span, lookup)
_bounds(::ForwardOrdered, ::Intervals, span::Explicit, ::AbstractSampled) =
    (val(span)[1, 1], val(span)[2, end])
_bounds(::ReverseOrdered, ::Intervals, span::Explicit, ::AbstractSampled) =
    (val(span)[1, end], val(span)[2, 1])
_bounds(::Intervals, span::Regular, lookup::AbstractSampled) =
    _bounds(locus(lookup), order(lookup), span, lookup)
_bounds(::Start, ::ForwardOrdered, span::Regular, lookup) = first(lookup), last(lookup) + step(span)
_bounds(::Start, ::ReverseOrdered, span::Regular, lookup) = last(lookup), first(lookup) - step(span)
function _bounds(::Center, order::Ordered, span::Regular, lookup)
    bounds = first(lookup) - step(span) / 2, last(lookup) + step(span) / 2
    return _maybeflipbounds(order, bounds)
end
# DateTime handling
function _bounds(::Center, order::Ordered, span::Regular, lookup::Lookup{<:Dates.AbstractTime})
    f, l, s = first(lookup), last(lookup), step(span)
    bounds = (f - (f - (f - s)) / 2, l - (l - (l + s)) / 2)
    _maybeflipbounds(order, bounds)
end
_bounds(::End, ::ForwardOrdered, span::Regular, lookup) = first(lookup) - step(span), last(lookup)
_bounds(::End, ::ReverseOrdered, span::Regular, lookup) = last(lookup) + step(span), first(lookup)


const SAMPLED_ARGUMENTS_DOC = """
- `data`: An `AbstractVector` of lookup values, matching the length of the curresponding
    array axis.
- `order`: [`Order`](@ref)) indicating the order of the lookup,
    [`AutoOrder`](@ref) by default, detected from the order of `data`
    to be [`ForwardOrdered`](@ref), [`ReverseOrdered`](@ref) or [`Unordered`](@ref).
    These can be provided explicitly if they are known and performance is important.
- `span`: indicates the size of intervals or distance between points, and will be set to
    [`Regular`](@ref) for `AbstractRange` and [`Irregular`](@ref) for `AbstractArray`,
    unless assigned manually.
- `sampling`: is assigned to [`Points`](@ref), unless set to [`Intervals`](@ref) manually.
    Using [`Intervals`](@ref) will change the behaviour of `bounds` and `Selectors`s
    to take account for the full size of the interval, rather than the point alone.
- `metadata`: a `Dict` or `Metadata` wrapper that holds any metadata object adding more
    information about the array axis - useful for extending DimensionalData for specific
    contexts, like geospatial data in Rasters.jl. By default it is `NoMetadata()`.
"""

"""
    Sampled <: AbstractSampled

    Sampled(data::AbstractVector, order::Order, span::Span, sampling::Sampling, metadata)
    Sampled(data=AutoValues(); order=AutoOrder(), span=AutoSpan(), sampling=Points(), metadata=NoMetadata())

A concrete implementation of the [`Lookup`](@ref)
[`AbstractSampled`](@ref). It can be used to represent
[`Points`](@ref) or [`Intervals`](@ref).

`Sampled` is capable of representing gridded data from a wide range of sources,
allowing correct `bounds` and [`Selector`](@ref)s for points or intervals of
regular, irregular, forward and reverse lookups.

On `AbstractDimArray` construction, `Sampled` lookup is assigned for all lookups of
`AbstractRange` not assigned to [`Categorical`](@ref).

## Arguments

$SAMPLED_ARGUMENTS_DOC

## Example

Create an array with `Interval` sampling, and `Regular` span for a vector with known spacing.

We set the [`locus`](@ref) of the `Intervals` to `Start` specifying
that the lookup values are for the locus at the start of each interval.

```jldoctest Sampled
using DimensionalData, DimensionalData.Lookups

x = X(Sampled(100:-20:10; sampling=Intervals(Start())))
y = Y(Sampled([1, 4, 7, 10]; span=Regular(3), sampling=Intervals(Start())))
A = ones(x, y)

# output
┌ 5×4 DimArray{Float64, 2} ┐
├──────────────────────────┴──────────────────────────────────────── dims ┐
  ↓ X Sampled{Int64} 100:-20:20 ReverseOrdered Regular Intervals{Start},
  → Y Sampled{Int64} [1, …, 10] ForwardOrdered Regular Intervals{Start}
└─────────────────────────────────────────────────────────────────────────┘
   ↓ →  1    4    7    10
 100    1.0  1.0  1.0   1.0
  80    1.0  1.0  1.0   1.0
  60    1.0  1.0  1.0   1.0
  40    1.0  1.0  1.0   1.0
  20    1.0  1.0  1.0   1.0
```
"""
struct Sampled{T,A<:AbstractVector{T},O,Sp,Sa,M} <: AbstractSampled{T,O,Sp,Sa}
    data::A
    order::O
    span::Sp
    sampling::Sa
    metadata::M
end
function Sampled(data=AutoValues();
    order=AutoOrder(), span=AutoSpan(),
    sampling=AutoSampling(), metadata=NoMetadata()
)
    Sampled(data, order, span, sampling, metadata)
end

function rebuild(l::Sampled;
    data=parent(l), order=order(l), span=span(l), sampling=sampling(l), metadata=metadata(l), kw...
)
    Sampled(data, order, span, sampling, metadata)
end

Base.unsafe_convert(::Type{Ptr{T}}, x::Sampled) where {T} = Base.unsafe_convert(Ptr{T}, x.data)
Base.strides(x::Sampled) = strides(x.data)

# These are used to specialise dispatch:
# When Cycling, we need to modify any `Selector`. After that
# we switch to `NotCycling` and use `AbstractSampled` fallbacks.
# We could switch to `Sampled` at that point, but its less extensible.
abstract type CycleStatus end

struct Cycling <: CycleStatus end
struct NotCycling <: CycleStatus end

"""
    AbstractCyclic <: AbstractSampled

An abstract supertype for cyclic lookups.

These are `AbstractSampled` lookups that are cyclic for `Selectors`.
"""
abstract type AbstractCyclic{X,T,O,Sp,Sa} <: AbstractSampled{T,O,Sp,Sa} end

cycle(l::AbstractCyclic) = l.cycle
cycle_status(l::AbstractCyclic) = l.cycle_status

bounds(l::AbstractCyclic{<:Any,T}) where T = (typemin(T), typemax(T))

# Indexing with `AbstractArray` must rebuild the lookup as
# `Sampled` as we no longer have the whole cycle.
for f in (:getindex, :view, :dotview)
    @eval @propagate_inbounds Base.$f(l::AbstractCyclic, i::AbstractArray) =
        Sampled(rebuild(l; data=Base.$f(parent(l), i)))
end


no_cycling(l::AbstractCyclic) = rebuild(l; cycle_status=NotCycling())

function cycle_val(l::AbstractCyclic, val)
    cycle_start = ordered_first(l)
    # This formulation is necessary for dates
    ncycles = (val - cycle_start) ÷ (cycle_start + cycle(l) - cycle_start)
    res = val - ncycles * cycle(l)
    # Catch precision errors
    if (cycle_start + (ncycles + 1) * cycle(l)) <= val
        i = 1
        while i < 10000
            if (cycle_start + (ncycles + i) * cycle(l)) > val
                return val - (ncycles + i - 1) * cycle(l)
            end
            i += 1
        end
    elseif res < cycle_start
        i = 1
        while i < 10000
            res = val - (ncycles - i + 1) * cycle(l)
            res >= cycle_start && return res
            i += 1
        end
    else
        return res
    end
    error("`Cyclic` lookup too innacurate, value not found")
end



"""
    Cyclic <: AbstractCyclic

    Cyclic(data; order=AutoOrder(), span=AutoSpan(), sampling=Points(), metadata=NoMetadata(), cycle)

A `Cyclic` lookup is similar to `Sampled` but out of range `Selectors` [`At`](@ref), 
[`Near`](@ref), [`Contains`](@ref) will cycle the values to `typemin` or `typemax` 
over the length of `cycle`. [`Where`](@ref) and `..` work as for [`Sampled`](@ref).

This is useful when we are using mean annual datasets over a real time-span,
or for wrapping longitudes so that `-360` and `360` are the same.

## Arguments

$SAMPLED_ARGUMENTS_DOC
- `cycle`: the length of the cycle. This does not have to exactly match the data, 
   the `step` size is `Week(1)` the cycle can be `Years(1)`.

## Notes

1. If you use dates and e.g. cycle over a `Year`, every year will have the 
    number and spacing of `Week`s and `Day`s as the cycle year. Using `At` may not be reliable
    in terms of exact dates, as it will be applied to the specified date plus or minus `n` years.
2. Indexing into a `Cycled` with any `AbstractArray` or `AbstractRange` will return 
    a [`Sampled`](@ref) as the full cycle is likely no longer available.
3. `..` or `Between` selectors do not work in a cycled way: they work as for [`Sampled`](@ref). 
    This may change in future to return cycled values, but there are problems with this, such as
    leap years breaking correct date cycling of a single year. If you actually need this behaviour, 
    please make a GitHub issue.
"""
struct Cyclic{X,T,A<:AbstractVector{T},O,Sp,Sa,M,C} <: AbstractCyclic{X,T,O,Sp,Sa}
    data::A
    order::O
    span::Sp
    sampling::Sa
    metadata::M
    cycle::C
    cycle_status::X
    function Cyclic(
        data::A, order::O, span::Sp, sampling::Sa, metadata::M, cycle::C, cycle_status::X
    ) where {A<:AbstractVector{T},O,Sp,Sa,M,C,X} where T
        _check_ordered_cyclic(order)
        new{X,T,A,O,Sp,Sa,M,C}(data, order, span, sampling, metadata, cycle, cycle_status)
    end
end
function Cyclic(data=AutoValues();
    order=AutoOrder(), span=AutoSpan(),
    sampling=AutoSampling(), metadata=NoMetadata(),
    cycle, # Mandatory keyword, there are too many possible bugs with auto detection
)
    cycle_status = Cycling()
    Cyclic(data, order, span, sampling, metadata, cycle, cycle_status)
end

_check_ordered_cyclic(::AutoOrder) = nothing
_check_ordered_cyclic(::Ordered) = nothing
_check_ordered_cyclic(::Unordered) = throw(ArgumentError("Cyclic lookups must be `Ordered`"))

function rebuild(l::Cyclic;
    data=parent(l), order=order(l), span=span(l), sampling=sampling(l), metadata=metadata(l),
    cycle=cycle(l), cycle_status=cycle_status(l), kw...
)
    Cyclic(data, order, span, sampling, metadata, cycle, cycle_status)
end

"""
    AbstractCategorical <: Aligned

[`Lookup`](@ref)s where the values are categories.

[`Categorical`](@ref) is the provided concrete implementation.
But this can easily be extended, all methods are defined for `AbstractCategorical`.

All `AbstractCategorical` must provide a `rebuild`
method with `data`, `order` and `metadata` keyword arguments.
"""
abstract type AbstractCategorical{T,O} <: Aligned{T,O} end

order(lookup::AbstractCategorical) = lookup.order
metadata(lookup::AbstractCategorical) = lookup.metadata

const CategoricalEltypes = Union{AbstractChar,Symbol,AbstractString,DataType}


"""
    Categorical <: AbstractCategorical

    Categorical(o::Order)
    Categorical(; order=Unordered())

A [`Lookup`](@ref) where the values are categories.

This will be automatically assigned if the lookup contains `AbstractString`,
`Symbol` or `Char`. Otherwise it can be assigned manually.

[`Order`](@ref) will be determined automatically where possible.

## Arguments

- `data`: An `AbstractVector` matching the length of the corresponding
    array axis.
- `order`: [`Order`](@ref)) indicating the order of the lookup,
    [`AutoOrder`](@ref) by default, detected from the order of `data`
    to be `ForwardOrdered`, `ReverseOrdered` or `Unordered`.
    Can be provided if this is known and performance is important.
- `metadata`: a `Dict` or `Metadata` wrapper that holds any metadata object adding more
    information about the array axis - useful for extending DimensionalData for specific
    contexts, like geospatial data in Rasters.jl. By default it is `NoMetadata()`.

## Example

Create an array with [`Interval`] sampling.

```jldoctest Categorical
using DimensionalData

ds = X(["one", "two", "three"]), Y([:a, :b, :c, :d])
A = DimArray(rand(3, 4), ds)
Dimensions.lookup(A)

# output

Categorical{String} ["one", …, "three"] Unordered,
Categorical{Symbol} [:a, …, :d] ForwardOrdered
```
"""
struct Categorical{T,A<:AbstractVector{T},O<:Order,M} <: AbstractCategorical{T,O}
    data::A
    order::O
    metadata::M
end
function Categorical(data=AutoValues(); order=AutoOrder(), metadata=NoMetadata())
    Categorical(data, order, metadata)
end

function rebuild(l::Categorical;
    data=parent(l), order=order(l), metadata=metadata(l), kw...
)
    Categorical(data, order, metadata)
end

function Base.:(==)(l1::AbstractCategorical, l2::AbstractCategorical)
    order(l1) == order(l2) && parent(l1) == parent(l2)
end


"""
    Unaligned <: Lookup

Abstract supertype for [`Lookup`](@ref) where the lookup is not aligned to the grid.

Indexing an [`Unaligned`](@ref) with [`Selector`](@ref)s must provide all
other [`Unaligned`](@ref) dimensions.
"""
abstract type Unaligned{T,N} <: Lookup{T,N} end

"""
    Transformed <: Unaligned

    Transformed(f, dim::Dimension; metadata=NoMetadata())

[`Lookup`](@ref) that uses an affine transformation to convert
dimensions from `dims(lookup)` to `dims(array)`. This can be useful
when the dimensions are e.g. rotated from a more commonly used axis.

Any function can be used to do the transformation, but transformations
from CoordinateTransformations.jl may be useful.

## Arguments

- `f`: transformation function
- `dim`: a dimension to transform to.

## Keyword Arguments

- `metadata`:

## Example

```jldoctest
using DimensionalData, DimensionalData.Lookups, CoordinateTransformations

m = LinearMap([0.5 0.0; 0.0 0.5])
A = [1 2  3  4
     5 6  7  8
     9 10 11 12];
da = DimArray(A, (X(Transformed(m)), Y(Transformed(m))))

da[X(At(6.0)), Y(At(2.0))]

# output
9
```
"""
struct Transformed{T,A<:AbstractVector{T},F,D,M} <: Unaligned{T,1}
    data::A
    f::F
    dim::D
    metadata::M
end
function Transformed(f; metadata=NoMetadata())
    Transformed(AutoValues(), f, AutoDim(), metadata)
end
function Transformed(f, data::AbstractArray; metadata=NoMetadata())
    Transformed(data, f, AutoDim(), metadata)
end

function rebuild(l::Transformed;
    data=parent(l), f=transformfunc(l), dim=dim(l), metadata=metadata(l)
)
    Transformed(data, f, dim, metadata)
end

dim(lookup::Transformed) = lookup.dim

transformfunc(lookup::Transformed) = lookup.f

Base.:(==)(l1::Transformed, l2::Transformed) = typeof(l1) == typeof(l2) && l1.f == l2.f

# TODO Transformed bounds
struct ArrayLookup{T,A,D,Ds,Ma<:AbstractArray{T},Tr,IV,DV,Me} <: Unaligned{T,1}
    data::A
    dim::D
    dims::Ds
    matrix::Ma
    tree::Tr
    idxvec::IV
    distvec::DV
    metadata::Me
end
ArrayLookup(matrix; metadata=NoMetadata()) =
    ArrayLookup(AutoValues(), AutoDim(), AutoDim(), matrix, nothing, nothing, nothing, metadata)
dim(lookup::ArrayLookup) = lookup.dim
matrix(l::ArrayLookup) = l.matrix
tree(l::ArrayLookup) = l.tree

# Shared methods

intervalbounds(l::Lookup, args...) = _intervalbounds_no_interval_error()
intervalbounds(l::AbstractSampled, args...) = intervalbounds(span(l), sampling(l), l, args...)
intervalbounds(span::Span, ::Points, ls::Lookup) = map(l -> (l, l), ls) 
intervalbounds(span::Span, ::Points, ls::Lookup, i::Int) = ls[i], ls[i]
intervalbounds(span::Span, sampling::Intervals, l::Lookup, i::Int) =
    intervalbounds(order(l), locus(sampling), span, l, i)
function intervalbounds(order::ForwardOrdered, locus::Start, span::Span, l::Lookup, i::Int)
    if i == lastindex(l)
        (l[i], bounds(l)[2])
    else
        (l[i], l[i+1])
    end
end
function intervalbounds(order::ForwardOrdered, locus::End, span::Span, l::Lookup, i::Int)
    if i == firstindex(l)
        (bounds(l)[1], l[i])
    else
        (l[i-1], l[i])
    end
end
function intervalbounds(order::ReverseOrdered, locus::Start, span::Span, l::Lookup, i::Int)
    if i == firstindex(l)
        (l[i], bounds(l)[2])
    else
        (l[i], l[i-1])
    end
end
function intervalbounds(order::ReverseOrdered, locus::End, span::Span, l::Lookup, i::Int)
    if i == lastindex(l)
        (bounds(l)[1], l[i])
    else
        (l[i+1], l[i])
    end
end
# Regular Center
function intervalbounds(order::Ordered, locus::Center, span::Regular, l::Lookup, i::Int)
    halfstep = step(span) / 2
    x = l[i]
    bounds = (x - halfstep, x + halfstep)
    return _maybeflipbounds(order, bounds)
end
function intervalbounds(order::Ordered, locus::Center, span::Regular, l::LookupArray{<:Dates.AbstractTime}, i::Int)
    x = l[i]
    bounds = (x - (x - step(span))) / 2 + x, (x - (x + step(span))) / 2 + x
    return _maybeflipbounds(order, bounds)
end
# Irregular Center
function intervalbounds(order::ForwardOrdered, locus::Center, span::Irregular, l::Lookup, i::Int)
    x = l[i]
    low  = i == firstindex(l) ? bounds(l)[1] : x + (l[i - 1] - x) / 2
    high = i == lastindex(l)  ? bounds(l)[2] : x + (l[i + 1] - x) / 2
    return (low, high)
end
function intervalbounds(order::ReverseOrdered, locus::Center, span::Irregular, l::Lookup, i::Int)
    x = l[i]
    low  = i == firstindex(l) ? bounds(l)[2] : x + (l[i - 1] - x) / 2
    high = i == lastindex(l)  ? bounds(l)[1] : x + (l[i + 1] - x) / 2
    return (low, high)
end
function intervalbounds(span::Span, sampling::Intervals, l::Lookup)
    map(axes(l, 1)) do i
        intervalbounds(span, sampling, l, i)
    end
end
# Explicit
function intervalbounds(span::Explicit, ::Intervals, l::Lookup, i::Int)
    return (l[1, i], l[2, i])
end
# We just reinterpret the bounds matrix rather than allocating
function intervalbounds(span::Explicit, ::Intervals, l::Lookup)
    m = val(span)
    T = eltype(m)
    return reinterpret(reshape, Tuple{T,T}, m)
end

_intervalbounds_no_interval_error() = error("Lookup does not have Intervals, `intervalbounds` cannot be applied")

# slicespan should only be called after `to_indices` has simplified indices
slicespan(l::Lookup, i::Colon) = span(l)
slicespan(l::Lookup, i) = _slicespan(span(l), l, i)

_slicespan(span::Regular, l::Lookup, i::Union{AbstractRange,CartesianIndices}) = Regular(step(l) * step(i))
_slicespan(span::Regular, l::Lookup, i::AbstractArray) = _slicespan(Irregular(bounds(l)), l, i)
_slicespan(span::Explicit, l::Lookup, i::AbstractArray) = Explicit(val(span)[:, i])
_slicespan(span::Irregular, l::Lookup, i::AbstractArray) =
    _slicespan(sampling(l), span, l, i)
function _slicespan(span::Irregular, l::Lookup, i::Base.LogicalIndex)
    i1 = length(i) == 0 ? (1:0) : ((findfirst(i.mask)::Int):(findlast(i.mask)::Int))
    _slicespan(sampling(l), span, l, i1)
end
function _slicespan(span::Irregular, l::Lookup, i::InvertedIndices.InvertedIndexIterator)
    i1 = collect(i) # We could do something more efficient here, but I'm not sure what
    _slicespan(sampling(l), span, l, i1)
end
_slicespan(::Points, span::Irregular, l::Lookup, i::AbstractArray) = 
    Irregular(nothing, nothing)
_slicespan(::Intervals, span::Irregular, l::Lookup, i::AbstractArray) =
    Irregular(_slicebounds(span, l, i))

function _slicebounds(span::Irregular, l::Lookup, i::AbstractArray)
    length(i) == 0 && return (nothing, nothing)
    _slicebounds(locus(l), span, l, i)
end
function _slicebounds(locus::Start, span::Irregular, l::Lookup, i::AbstractArray)
    fi, la = first(i), last(i)
    if isforward(l)
        l[fi], la >= lastindex(l) ? bounds(l)[2] : l[la + 1]
    else
        l[la], fi <= firstindex(l) ? bounds(l)[2] : l[fi - 1]
    end
end
function _slicebounds(locus::End, span::Irregular, l::Lookup, i::AbstractArray)
    fi, la = first(i), last(i)
    if isforward(l)
        fi <= firstindex(l) ? bounds(l)[1] : l[fi - 1], l[la]
    else
        la >= lastindex(l) ? bounds(l)[1] : l[la + 1], l[fi]
    end
end
function _slicebounds(locus::Center, span::Irregular, l::Lookup, i::AbstractArray)
    fi, la = first(i), last(i)
    a, b = if isforward(l)
        fi <= firstindex(l) ? bounds(l)[1] : (l[fi - 1] + l[fi]) / 2,
        la >= lastindex(l)  ? bounds(l)[2] : (l[la + 1] + l[la]) / 2
    else
        la >= lastindex(l)  ? bounds(l)[1] : (l[la + 1] + l[la]) / 2,
        fi <= firstindex(l) ? bounds(l)[2] : (l[fi - 1] + l[fi]) / 2
    end
    return a, b
end
# Have to special-case date/time so we work with seconds and add to the original
function _slicebounds(locus::Center, span::Irregular, l::Lookup{T}, i::AbstractArray) where T<:Dates.AbstractTime
    op = T === Date ? div : /
    frst = if first(i) <= firstindex(l)
        _maybeflipbounds(l, bounds(l))[1]
    else
        if isrev(order(l))
            op(l[first(i)] - l[first(i) - 1], 2) + l[first(i) - 1]
        else
            op(l[first(i) - 1] - l[first(i)], 2) + l[first(i)]
        end
    end
    lst = if last(i) >= lastindex(l)
        _maybeflipbounds(l, bounds(l))[2]
    else
        if isrev(order(l))
            op(l[last(i)] - l[last(i) + 1], 2) + l[last(i) + 1]
        else
            op(l[last(i) + 1] - l[last(i)], 2) + l[last(i)]
        end
    end
    return (frst, lst)
end

# reducing methods
@inline reducelookup(lookup::NoLookup) = NoLookup(OneTo(1))
@inline reducelookup(lookup::Length1NoLookup) = NoLookup(OneTo(1))
# TODO what should this do?
@inline reducelookup(lookup::Unaligned) = NoLookup(OneTo(1))
# Categories are combined.
@inline reducelookup(lookup::Categorical{<:AbstractString}) =
    rebuild(lookup; data=["combined"])
@inline reducelookup(lookup::Categorical) = rebuild(lookup; data=[:combined])
# Sampled is resampled
@inline reducelookup(lookup::AbstractSampled) = _reducelookup(span(lookup), lookup)

@inline _reducelookup(::Irregular, lookup::AbstractSampled) = begin
    rebuild(lookup; data=_reducevalues(lookup), order=ForwardOrdered())
end
@inline _reducelookup(span::Regular, lookup::AbstractSampled) = begin
    newstep = step(span) * length(lookup)
    newvalues = _reducevalues(lookup, newstep)
    # Make sure the step type matches the new eltype
    newstep = convert(promote_type(eltype(newvalues), typeof(newstep)), newstep)
    newspan = Regular(newstep)
    rebuild(lookup; data=newvalues, order=ForwardOrdered(), span=newspan)
end
@inline _reducelookup(
    span::Regular{<:Dates.CompoundPeriod}, lookup::AbstractSampled
) = begin
    newstep = Dates.CompoundPeriod(step(span).periods .* length(lookup))
    # We don't pass the step here - the range doesn't work with CompoundPeriod
    newvalues = _reducevalues(lookup)
    # Make sure the step type matches the new eltype
    newspan = Regular(newstep)
    rebuild(lookup; data=newvalues, order=ForwardOrdered(), span=newspan)
end
@inline _reducelookup(span::Explicit, lookup::AbstractSampled) = begin
    bnds = val(span)
    newstep = bnds[2] - bnds[1]
    newvalues = _reducevalues(lookup, newstep)
    # Make sure the step type matches the new eltype
    newstep = convert(promote_type(eltype(newvalues), typeof(newstep)), newstep)
    newspan = Explicit(reshape([bnds[1, 1]; bnds[2, end]], 2, 1))
    newlookup = rebuild(lookup; data=newvalues, order=ForwardOrdered(), span=newspan)
end
# Get the lookup value at the reduced locus.
# This is the start, center or end point of the whole lookup.
@inline _reducevalues(lookup::Lookup, step=nothing) = _reducevalues(locus(lookup), lookup, step)
@inline _reducevalues(locus::Start, lookup::Lookup, step) = _mayberange(first(lookup), step)
@inline _reducevalues(locus::End, lookup::Lookup, step) = _mayberange(last(lookup), step)
@inline _reducevalues(locus::Center, lookup::Lookup, step) = begin
    values = parent(lookup)
    len = length(values)
    newval = centerval(values, len)
    _mayberange(newval, step)
end
# Ranges with a known step always return a range
_mayberange(x, step) = x:step:x
# Arrays return a vector
_mayberange(x, step::Nothing) = [x]

@inline centerval(values::AbstractArray{<:Number}, len) = (first(values) + last(values)) / 2
@inline function centerval(values::AbstractArray{<:DateTime}, len)
    f = first(values)
    l = last(values)
    if f <= l
        return (l - f) / 2 + first(values)
    else
        return (f - l) / 2 + last(values)
    end
end
@inline centerval(values::AbstractArray, len) = values[len ÷ 2 + 1]

ordering(::ForwardOrdered) = Base.Order.ForwardOrdering()
ordering(::ReverseOrdered) = Base.Order.ReverseOrdering()


# Promotion 

# General case 
promote_first(x) = x
promote_first(x1, x2, xs...) = 
    convert(promote_type(typeof(x1), typeof(x2), map(typeof, xs)...), x1)
# Fallback NoLookup if not identical type
promote_first(l1::Lookup) = l1
promote_first(l1::L, ls::L...) where L<:Lookup = rebuild(l1; metadata=NoMetadata)
promote_first(l1::L, ls::L...) where L<:AbstractNoLookup = l1
function promote_first(l1::Lookup, ls1::Lookup...)
    ls = _remove(Length1NoLookup, l1, ls1...)
    if length(ls) != length(ls1) + 1
        # If anything was removed, start again
        return promote_first(ls...)
    elseif length(ls) == 1
        # If there is only one left, use it
        return first(ls)
    end
    # Otherwise see if these have the same type
    l2, ls2... = ls
    if all(map(l -> typeof(l) == typeof(l2), ls2))
        # If so, just simplify the metadata
        rebuild(l2; metadata=NoMetadata())
    else
        # And if not, use NoLookup
        NoLookup(Base.OneTo(length(l2)))
    end
end
# Categorical lookups
promote_first(l1::AbstractCategorical) = l1
promote_first(l1::C, ls::C...) where C<:AbstractCategorical = l1
promote_first(l1::C, ::C, ::C...) where C<:AbstractCategorical = rebuild(l1; metadata=NoMetadata())
function promote_first(l1::AbstractCategorical, l2::AbstractCategorical, ls::AbstractCategorical...)
    ls = (l2, ls...)
    o = all(map(l -> order(l) == order(l1), ls)) ? order(l1) : Unordered()
    data = promote_first(parent(l1), map(parent, ls)...)
    # Check we have all the same type of AbstractCategorical
    if all(map(l -> basetypeof(l) == basetypeof(l1), ls))
        return rebuild(l1; data, order=o, metadata=NoMetadata())
    else # Otherwise fall back to Categorical
        return Categorical(data; order=o, metadata=NoMetadata())
    end
end
promote_first(l1::AbstractSampled) = l1
promote_first(l1::S, ::S, ::S...) where S<:AbstractSampled = l1
function promote_first(l1::AbstractSampled, l2::AbstractSampled, ls::AbstractSampled...)
    ls = (l2, ls...)

    # We cant always convert explicit to something else
    if any(map(isexplicit, (l1, ls...))) && !all(isexplicit, (l1, ls...))
        return NoLookup(Base.OneTo(length(l1)))
    end

    data = promote_first(parent(l1), map(parent, ls)...)
    sa = promote_first(sampling(l1), map(sampling, ls)...)
    kw = (;
        order=promote_first(order(l1), map(order, ls)...),
        sampling=sa,
        span=promote_first(l1, sa, span(l1), map(span, ls)...),
        metadata=NoMetadata(),
    )
    # Check we have all the same type of AbstractSampled
    if all(map(l -> basetypeof(l) == basetypeof(l1), ls))
        return rebuild(l1; data, kw...)
    else # Otherwise fall back to Sampled
        return Sampled(data; kw...)
    end
end

# Order
# Only matching Order remain the same
promote_first(::O, ::O...) where O<:Order = O()
# Everthing else is Unordered
promote_first(::Order, ::Order...) = Unordered()

# Sampling 
# Only matching locus Intervals remain Intervals
promote_first(i1::I, ::I...) where I<:Intervals = i1
# Any other mix is Points
promote_first(::Sampling, ::Sampling...) = Points() 

# Span
# Regular remains regular, eltype is promoted
function promote_first(::Lookup, ::Sampling, s::Regular, ss::Regular...) 
    T = promote_type(typeof(val(s)), map(typeof ∘ val, ss)...)
    Regular(convert(T, val(s)))
end
# # Matching irregular is returns
promote_first(::Lookup, ::Sampling, a::T, b::T...) where T<:Irregular = a 
# # Number and DateTime are promoted
for E in (Base.Number, Dates.AbstractTime)
    @eval function promote_first(::Lookup,
        s::Irregular{Tuple{<:$E,<:$E}}, ss::Irregular{Tuple{<:$E,<:$E}}...
    )
        T = promote_type(maps(s -> promote_type(typeof(val(s)[1]), typeof(val(s)[2])), (s, ss...))...)
        return Irregular(convert(T, val(a)[1]), convert(T, val(a)[2]))
    end
end
# Explicit promotes its matrix
promote_first(::Lookup, ::Sampling, s1::Explicit, ss::Explicit...) = 
    Explicit(promote_first(val(s1), map(val, ss)...))
# Mixed Regular/Irregular always become Irregular
promote_first(l::Lookup, sampling::Sampling, ::Union{Regular,Irregular}, ::Union{Regular,Irregular}...) = 
    _irregular(sampling, l)
   
_irregular(::Points, l) = Irregular(nothing, nothing)
_irregular(::Intervals, l) = Irregular(bounds(l))
     
# Data
promote_first(a1::A) where A<:AbstractArray = a1
promote_first(a1::A, ::A, ::A...) where A<:AbstractArray = a1
promote_first(a1::AbstractArray{<:AbstractString}, as::AbstractArray{<:AbstractString}...) = String.(a1)
function promote_first(a1::AbstractArray, as::AbstractArray...) 
    T = promote_type(eltype(a1), map(eltype, as)...)
    C = if a1 isa AbstractRange && all(map(a -> a isa AbstractRange, as))
        if a1 isa AbstractUnitRange && all(map(a -> a isa AbstractUnitRange, as))
            UnitRange
        elseif a1 isa OrdinalRange  && all(map(a -> a isa OrdinalRange, as))
            S = promote_type(typeof(step(a1)), map(typeof ∘ step, as)...)
            StepRange{T,S}
        elseif a1 isa LinRange || any(map(a -> a isa LinRange, as))
            LinRange{T}
        else
            StepRangeLen{T}
        end
    else
        Vector{T}
    end

    return convert(C, a1)
end

# Symbols and colors
function dimsymbol(i) 
    symbols = ['↓', '→', '↗', '⬔', '◩', '⬒', '⬓', '■']
    symbols[min(i, length(symbols))]
end
function dimcolor(i::Int)
    # colors = [203, 37, 162, 106, 67, 173, 91]
    # colors = [110, 216, 223, 218, 153, 79, 185, 142, 253]
    # colors = reverse([61, 153, 73, 29, 143, 186, 174, 132, 133])
    # colors = [61, 153, 73, 29, 143, 186, 174, 132, 133]
    # colors = [67, 210, 71, 185, 117, 132, 249]
    colors = [209, 32, 81, 204, 249, 166, 37]
    c = rem(i - 1, length(colors)) + 1
    colors[c]
end
dimcolor(io::IO) = get(io, :dimcolor, dimcolor(1))

@deprecate dimcolors(x) dimcolor(x) false
@deprecate dimsymbols(x) dimsymbol(x) false

# Base methods

Base.show(io::IO, dims::DimTuple) = show_dims(io, MIME"text/plain"(), dims)
Base.show(io::IO, mime::MIME"text/plain", dims::DimTuple) = show_dims(io, mime, dims)
function Base.show(io::IO, mime::MIME"text/plain", dim::Dimension)
    get(io, :compact, false) && return show_compact(io, mime, dim)
    # Print the dimension name
    print_dimname(io, dim)
    # Print whitespace after dim name, unless the val is not shown
    dimname_len = get(io, :dimname_len, 0)
    this_dimname_len = length(string(name(dim)))
    print(io, repeat(" ", max(0, dimname_len - this_dimname_len)))
    # Print the dimension value
    print_dimval(io, mime, val(dim))
end
function Base.show(io::IO, ::MIME"text/plain", 
    dim::Dimension{<:Union{AbstractNoLookup,AutoLookup,Colon}}
)
    print_dimname(io, dim)
end

function show_dims(io::IO, mime::MIME"text/plain", dims::DimTuple;
    colors=map(x -> get(io, :dimcolor, dimcolor(x)), ntuple(identity, length(dims)))
)
    ctx = IOContext(io, :compact => true)
    # Add whitespace inset
    inset = get(io, :inset, "")
    print(io, inset)
    # Print brackets
    brackets = get(io, :dim_brackets, true)
    brackets && print(io, '(')
    if all(map(d -> !(parent(d) isa AbstractArray) || (parent(d) isa AbstractNoLookup), dims))
        # No lookups, dims all go on one line
        dc = colors[1]
        # Print the first dim
        printstyled(io, dimsymbol(1), ' '; color=dc)
        show(IOContext(ctx, :dimcolor => dc, :dimname_len => 0), mime, first(dims))
        # Print the rest of the dims
        foreach(enumerate(Base.tail(dims))) do (i, d)
            n = i + 1
            print(io, ", ")
            dc = colors[n]
            printstyled(io, dimsymbol(n), ' '; color=dc)
            show(IOContext(ctx, :dimcolor => dc, :dimname_len => 0), mime, d)
        end
        # Maybe close brackets
        brackets && print(io, ')')
        return 0
    else 
        # Dims get a line each
        lines = 3
        # Print the first dim
        dc = colors[1]
        printstyled(io, dimsymbol(1), ' '; color=dc)
        # Get the maximum dim name length
        max_name_len = maximum(length ∘ string ∘ name, dims) 
        # Update context with colors and name length
        dim_ctx = IOContext(ctx, :dimcolor => dc, :dimname_len=> max_name_len)
        # Show the dim 
        show(dim_ctx, mime, first(dims))
        lines += 1
        # Print the rest of the dims
        map(Base.tail(dims), ntuple(x -> x + 1, length(dims) - 1)) do d, n
            lines += 1
            s = dimsymbol(n)
            print(io, ",\n", inset)
            dc = colors[n]
            printstyled(io, s, ' '; color=dc)
            dim_ctx = IOContext(ctx, :dimcolor => dc, :dimname_len => max_name_len)
            show(dim_ctx, mime, d)
        end
        # Maybe close brackets
        brackets && print(io, ')')
        return lines
    end
end

# compact version for dimensions
show_compact(io::IO, mime, dim::Dimension{Colon}) = print_dimname(io, dim)
function show_compact(io::IO, mime, dim::Dimension)
    # Print to a buffer and count lengths
    buf = IOBuffer()
    ctx = IOContext(buf, :compact => true)
    print_dimname(ctx, dim)
    nchars = length(String(take!(buf)))
    print_dimval(ctx, mime, parent(dim), nchars)
    nvalchars = length(String(take!(buf)))
    # Actually print to IO
    print_dimname(io, dim)
    if nvalchars > 0
        print_dimval(io, mime, val(dim), nchars)
    end
end

# print dims with description string and inset
function print_dims(io::IO, mime, dims::Tuple{}; kw...)
    @nospecialize io mime dims
    print(io, ": ")
    return 0
end
function print_dims(io::IO, mime, dims::Tuple; kw...)
    ctx = IOContext(io, :inset => "  ")
    return show_dims(ctx, mime, dims; kw...)
end
# print refdims with description string and inset
function print_refdims(io::IO, mime, refdims::Tuple)
    if isempty(refdims) 
        return 0
    end
    printstyled(io, "and reference dimensions: "; color=:light_black)
    ctx = IOContext(io, :inset => "  ", :is_ref_dim=>true, :show_dim_val=>true)
    lines = show(ctx, mime, refdims)
    return lines
end
# print a dimension name

print_dimname(io, dim::Dimension) = printstyled(io, name(dim); color=dimcolor(io))

# print the dimension value
function print_dimval(io, mime, val, nchars=0)
    val isa Colon || print(io, " ")
    printstyled(io, val; color=get(io, :dimcolor, 1))
end
print_dimval(io, mime, lookup::AbstractArray, nchars=0) =
    Lookups.print_lookup_values(io, mime, lookup, nchars)
print_dimval(io, mime, lookup::AbstractArray{<:Any,0}, nchars=0) =
    printstyled(io, " ", lookup; color=get(io, :dimcolor, 1))
print_dimval(io, mime, lookup::Union{AutoLookup,AbstractNoLookup}, nchars=0) = print(io, "")
function print_dimval(io, mime, lookup::Lookup, nchars=0)
    print(io, " ")
    ctx = IOContext(io, :nchars=>nchars)
    show(ctx, mime, lookup)
end

struct LazyMath{T,F}
    f::F
end
LazyMath{T}(f::F) where {T,F} = LazyMath{T,F}(f)
Base.show(io::IO, l::LazyMath{T}) where T = print(io, _print_f(T, l.f))

const BeginEndRangeVals = Union{Begin,End,LazyMath,Int}

# Ranges
abstract type AbstractBeginEndRange <: Function end
struct BeginEndRange{A<:BeginEndRangeVals,B<:BeginEndRangeVals} <: AbstractBeginEndRange
    start::A
    stop::B
end
struct BeginEndStepRange{A<:BeginEndRangeVals,B<:BeginEndRangeVals} <: AbstractBeginEndRange
    start::A
    step::Int
    stop::B
end

Base.first(r::AbstractBeginEndRange) = r.start
Base.last(r::AbstractBeginEndRange) = r.stop
Base.step(r::BeginEndStepRange) = r.step

(::Colon)(a::Int, b::Union{Begin,End,Type{Begin},Type{End},LazyMath}) = BeginEndRange(a, _x(b))
(::Colon)(a::Union{Begin,End,Type{Begin},Type{End},LazyMath}, b::Int) = BeginEndRange(_x(a), b)
(::Colon)(a::Union{Begin,End,Type{Begin},Type{End},LazyMath}, b::Union{Begin,End,Type{Begin},Type{End},LazyMath}) = 
    BeginEndRange(_x(a), _x(b))

(::Colon)(a::Int, step::Int, b::Union{Begin,End,Type{Begin},Type{End},LazyMath}) = BeginEndStepRange(a, step, _x(b))
(::Colon)(a::Union{Begin,End,Type{Begin},Type{End},LazyMath}, step::Int, b::Int) = BeginEndStepRange(_x(a), step, b)
(::Colon)(a::Union{Begin,End,Type{Begin},Type{End},LazyMath}, step::Int, b::Union{Begin,End,Type{Begin},Type{End},LazyMath}) = 
    BeginEndStepRange(_x(a), step, _x(b))

_x(T::Type) = T()
_x(x) = x

Base.to_indices(A, inds, (r, args...)::Tuple{BeginEndRange,Vararg}) =
    (_to_index(inds[1], r.start):_to_index(inds[1], r.stop), to_indices(A, Base.tail(inds), args)...)
Base.to_indices(A, inds, (r, args...)::Tuple{BeginEndStepRange,Vararg}) =
    (_to_index(inds[1], r.start):r.step:_to_index(inds[1], r.stop), to_indices(A, Base.tail(inds), args)...)
Base.to_indices(A, inds, (r, args...)::Tuple{<:Union{Begin,End,<:LazyMath},Vararg}) =
    (_to_index(inds[1], r), to_indices(A, Base.tail(inds), args)...)

_to_index(inds, a::Int) = a
_to_index(inds, ::Begin) = first(inds)
_to_index(inds, ::End) = last(inds)
_to_index(inds, ::Type{Begin}) = first(inds)
_to_index(inds, ::Type{End}) = last(inds)
_to_index(inds, l::LazyMath{End}) = l.f(last(inds))
_to_index(inds, l::LazyMath{Begin}) = l.f(first(inds))

Base.checkindex(::Type{Bool}, inds::AbstractUnitRange, ber::AbstractBeginEndRange) =
    Base.checkindex(Bool, inds, _to_index(inds, first(ber)):_to_index(inds, last(ber)))

for f in (:+, :-, :*, :÷, :|, :&, :max, :min)
    @eval Base.$f(::Type{T}, i::Int) where T <: Union{Begin,End} = LazyMath{T}(Base.Fix2($f, i))
    @eval Base.$f(i::Int, ::Type{T}) where T <: Union{Begin,End} = LazyMath{T}(Base.Fix1($f, i))
    @eval Base.$f(::T, i::Int) where T <: Union{Begin,End} = LazyMath{T}(Base.Fix2($f, i))
    @eval Base.$f(i::Int, ::T) where T <: Union{Begin,End} = LazyMath{T}(Base.Fix1($f, i))
    @eval Base.$f(x::LazyMath{T}, i::Int) where T = LazyMath{T}(Base.Fix2($f, i) ∘ x.f)
    @eval Base.$f(i::Int, x::LazyMath{T}) where T = LazyMath{T}(Base.Fix1($f, i) ∘ x.f)
end


Base.show(io::IO, ::MIME"text/plain", r::AbstractBeginEndRange) = show(io, r)
function Base.show(io::IO, r::BeginEndRange)  
    _show(io, first(r))
    print(io, ':')
    _show(io, last(r))
end
function Base.show(io::IO, r::BeginEndStepRange)  
    _show(io, first(r))
    print(io, ':')
    show(io, step(r))
    print(io, ':')
    _show(io, last(r))
end

_show(io, x::Union{Begin,End}) = show(io, typeof(x))
_show(io, x) = show(io, x)
# Here we recursively print `Fix1` and `Fix2` either left or right 
# to recreate the function
_print_f(T, f) = string(T, _pf(f))
_print_f(T, f::Base.ComposedFunction) = _print_f(_print_f(T, f.inner), f.outer)
_print_f(T, f::Base.Fix1) = string('(', f.x, _print_f(f.f, T), ')')
_print_f(T, f::Base.Fix2) = string('(', _print_f(T, f.f), f.x, ')')

_print_f(T, f::Base.Fix1{F}) where F<:Union{typeof(max), typeof(min)} = string(f.f, '(', f.x, ", " ,T, ')')
_print_f(T, f::Base.Fix2{F}) where F<:Union{typeof(max), typeof(min)} = string(f.f, '(', T, ", " ,f.x, ')')

_pf(::typeof(div)) = "÷"
_pf(f) = string(f)

for T in (UnitRange, AbstractUnitRange, StepRange, StepRangeLen, LinRange, Lookup)
    for f in (:getindex, :view, :dotview)
        @eval Base.$f(A::$T, i::AbstractBeginEndRange) = Base.$f(A, to_indices(A, (i,))...)
        @eval Base.$f(A::$T, i::Union{Type{Begin},Type{End},Begin,End,LazyMath}) = 
            Base.$f(A, to_indices(A, _construct_types(i))...) 
    end
end

# These methods let us use Begin End end as types without constructing them.
@inline _construct_types(::Type{Begin}, I...) = (Begin(), _construct_types(I...)...)
@inline _construct_types(::Type{End}, I...) = (End(), _construct_types(I...)...)
@inline _construct_types(i, I...) = (i, _construct_types(I...)...)
@inline _construct_types() = ()

# Base show
function Base.summary(io::IO, stack::AbstractDimStack)
    print_ndims(io, size(stack))
    print(io, nameof(typeof(stack)))
end

function Base.show(io::IO, mime::MIME"text/plain", stack::AbstractDimStack)
    # Show main blocks - summary, dims, layers, metadata
    _, blockwidth = show_main(io, mime, stack)
    # Show anything else subtypes want to append
    ctx = IOContext(io, :blockwidth => blockwidth)
    show_after(ctx, mime, stack)
    return nothing
end

# Show customisation interface
function show_main(io, mime, stack::AbstractDimStack)
    displaywidth = displaysize(io)[2]
    iobuf = IOBuffer()
    blockwidth, _ = print_layers_block(iobuf, mime, stack; blockwidth=0, displaywidth)

    lines, blockwidth, displaywidth, separatorwidth, istop = print_top(io, mime, stack; blockwidth, displaywidth)
    blockwidth, separatorwidth = print_layers_block(io, mime, stack; 
        blockwidth, displaywidth, separatorwidth, istop
    )
    _, blockwidth, istop = print_metadata_block(io, mime, metadata(stack); 
        blockwidth=min(displaywidth-2, blockwidth), displaywidth, separatorwidth, istop
    )
end

function show_after(io, mime, stack::AbstractDimStack)
    blockwidth = get(io, :blockwidth, 0)
    print_block_close(io, blockwidth)
end

# Show blocks
function print_layers_block(io, mime, stack; 
    blockwidth, displaywidth, separatorwidth=blockwidth, istop=false
)
    layers = DD.layers(stack)
    newblockwidth = blockwidth
    keylen = _keylen(Base.keys(layers))
    for key in keys(layers)
        mxbw = max(newblockwidth, length(sprint(print_layer, stack, key, keylen)))
        newblockwidth = min(displaywidth - 2, mxbw)
    end
    newblockwidth = print_block_separator(io, "layers", separatorwidth, newblockwidth; istop)
    println(io)
    for key in keys(layers)
        print_layer(io, stack, key, keylen)
    end
    return newblockwidth, newblockwidth
end

function _keylen(keys)
    if isempty(keys)
        0
    else
        reduce(max, map(length ∘ string, collect(keys)))
    end
end

function print_layer(io, stack, key::Symbol, keylen)
    layer = stack[key]
    pkey = rpad(key, keylen)
    printstyled(io, "  :$pkey", color=dimcolor(7))
    printstyled(io, " eltype: "; color=:light_black)
    print(io, string(eltype(layer)))
    field_dims = DD.dims(layer)
    colors = map(dimcolor, dimnum(stack, field_dims))
    printstyled(io, " dims: "; color=:light_black)
    if !isempty(field_dims)
        for (i, (dim, color)) in enumerate(zip(field_dims, colors))
            Dimensions.print_dimname(IOContext(io, :dimcolor => color), dim)
            i != length(field_dims) && print(io, ", ")
        end
        printstyled(io, " size: "; color=:light_black)
        print_sizes(io, size(field_dims); colors)
    end
    print(io, '\n')
end

# When an object like DimArray or DimStack is constructed,
# `format` is called on its dimensions

"""
    format(dims, x) => Tuple{Vararg{Dimension,N}}

Format the passed-in dimension(s) `dims` to match the object `x`.

Errors are thrown if dims don't match the array dims or size, 
and any fields holding `Auto-` objects are filled with guessed objects.

If a [`Lookup`](@ref) hasn't been specified, a lookup is chosen
based on the type and element type of the values.
"""
format(dims::DimOrDimType, A::AbstractVector) = format((dims,), A)
function format(dims::NamedTuple, A::AbstractArray)
    dims = map(keys(dims), values(dims)) do k, v
        rebuild(name2dim(k), v)
    end
    return format(dims, A)
end
function format(dims::Tuple{<:Pair,Vararg{Pair}}, A::AbstractArray)
    dims = map(dims) do (k, v)
        rebuild(basedims(k), v)
    end
    return format(dims, A)
end
# Make a dummy array that assumes the dims are the correct length and don't hold `Colon`s
function format(dims::DimTuple) 
    ax = map(parent ∘ first ∘ axes, dims)
    return format(dims, ax)
end
format(dims::Tuple{Vararg{Any,N}}, A::AbstractArray{<:Any,N}) where N = 
    format(dims, axes(A))
@noinline format(dims::Tuple{Vararg{Any,M}}, A::AbstractArray{<:Any,N}) where {N,M} =
    throw(DimensionMismatch("Array A has $N axes, while the number of dims is $M: $(map(basetypeof, dims))"))
function format(dims::Tuple{Vararg{Any,N}}, axes::Tuple{Vararg{Any,N}}) where N
    # We need to format first
    fdims = map(_format, dims, axes)
    # Then format any unaligned dims as a group
    split_alignments(first ∘ tuple, format_unaligned, fdims, axes)
end
format(d::Dimension{<:AbstractArray}) = _format(d, axes(val(d), 1))
format(d::Dimension, axis::AbstractRange) = _format(d, axis)
format(d::Type{<:Dimension}, axis::AbstractRange) = _format(d, axis)
format(l::Lookup) = parent(format(AnonDim(l)))

# Fallback 
function format_unaligned end
format_unaligned(dims::DimTuple, axes) = format_unaligned(val(dims), dims, axes)
format_unaligned(::Tuple, dims::DimTuple, axes) = map(format, dims, axes)

_format(dimname::Symbol, axis::AbstractRange) = Dim{dimname}(NoLookup(axes(axis, 1)))
_format(::Type{D}, axis::AbstractRange) where D<:Dimension = D(NoLookup(axes(axis, 1)))
_format(dim::Dimension{Colon}, axis::AbstractRange) = rebuild(dim, NoLookup(axes(axis, 1)))
function _format(dim::Dimension, axis::AbstractRange)
    newlookup = format(val(dim), basetypeof(dim), axes(axis, 1))
    newdim = rebuild(dim, newlookup)
    checkaxis(newdim, axis)
    return newdim
end

format(val::AbstractArray, D::Type, axis::AbstractRange) = format(AutoLookup(), D, val, axis)
format(m::Lookup, D::Type, axis::AbstractRange) = format(m, D, parent(m), axis)
format(v::AutoVal, D::Type, axis::AbstractRange) = _valformaterror(val(v), D)
format(v, D::Type, axis::AbstractRange) = _valformaterror(v, D) 

format(m::Lookups.ArrayLookup, D::Type, ::AutoValues, axis::AbstractRange) =
    rebuild(m; dim=D(), data=axis)

# Format Lookups
# No more identification required for NoLookup
format(m::Lookups.Length1NoLookup, D::Type, values, axis::AbstractRange) = m
format(m::NoLookup, D::Type, values, axis::AbstractRange) = m
format(m::NoLookup, D::Type, values::AutoValues, axis::AbstractRange) = NoLookup(axis)
# # AutoLookup
function format(m::AutoLookup, D::Type, values::AbstractArray{T}, axis::AbstractRange) where T
    # A mixed type lookup is Categorical
    m = if isconcretetype(T) 
        Sampled(; order=order(m), span=span(m), sampling=sampling(m), metadata=metadata(m))
    else
        o = order(m) isa AutoOrder ? Unordered() : order(m)
        Categorical(; order=o, metadata=metadata(m))
    end
    format(m, D, values, axis)
end
function format(m::AutoLookup, D::Type, values::AbstractArray{<:CategoricalEltypes}, axis::AbstractRange)
    o = _format(order(m), D, values)
    return Categorical(values; order=o, metadata=metadata(m))
end
function format(m::Categorical, D::Type, values, axis::AbstractRange)
    i = _format(values, axis)
    o = _format(order(m), D, values)
    return rebuild(m; data=i, order=o)
end
# Sampled
function format(m::AbstractSampled, D::Type, values, axis::AbstractRange)
    i = _format(values, axis)
    o = _format(order(m), D, values)
    sp = _format(span(m), D, values)
    sa = _format(sampling(m), sp, D, values)
    x = rebuild(m; data=i, order=o, span=sp, sampling=sa)
    return x
end
# Transformed
format(m::Transformed, D::Type, values::AutoValues, axis::AbstractRange) =
    rebuild(m; dim=D(), data=axis)
format(m::Transformed, D::Type, values, axis::AbstractRange) = rebuild(m; dim=D())

# Values
_format(values::AbstractArray, axis::AbstractRange) = values
_format(values::AutoLookup, axis::AbstractRange) = axis
# Order
_format(order::Order, D::Type, values) = order
_format(order::AutoOrder, D::Type, values) = Lookups.orderof(values)
# Span
_format(span::AutoSpan, D::Type, values::Union{AbstractArray,Val}) =
    _format(Irregular(), D, values)
_format(span::AutoSpan, D::Type, values::AbstractRange) = Regular(step(values))
_format(span::Regular{AutoStep}, D::Type, values::Union{AbstractArray,Val}) = _arraynosteperror()
_format(span::Regular{AutoStep}, D::Type, values::LinRange) = Regular(step(values))
_format(span::Regular{AutoStep}, D::Type, values::AbstractRange) = Regular(step(values))
_format(span::Regular, D::Type, values::Union{AbstractArray,Val}) = span
function _format(span::Regular, D::Type, values::AbstractRange)
    step(span) isa Number && !(step(span) ≈ step(values)) && _steperror(values, span)
    return span
end
function _format(span::Regular, D::Type, values::LinRange{T}) where T
    step(span) isa Number && step(values) > zero(T) && !(step(span) ≈ step(values)) && _steperror(values, span)
    return span
end
_format(span::Irregular{AutoBounds}, D, values) = Irregular(nothing, nothing)
_format(span::Irregular{<:Tuple}, D, values) = span
_format(span::Explicit, D, values) = span
# Sampling
_format(sampling::AutoSampling, span::Span, D::Type, values) = Points()
_format(::AutoSampling, ::Span, D::Type, ::AbstractArray{<:IntervalSets.Interval}) =
    Intervals(Start())
_format(sampling::AutoSampling, span::Explicit, D::Type, values) =
    Intervals(_format(locus(sampling), D, values))
# For ambiguity, not likely to happen in practice
_format(sampling::AutoSampling, ::Explicit, D::Type, ::AbstractArray{<:IntervalSets.Interval}) =
    Intervals(_format(locus(sampling), D, values))
_format(sampling::Points, span::Span, D::Type, values) = sampling
_format(sampling::Points, span::Explicit, D::Type, values) = _explicitpoints_error() 
_format(sampling::Intervals, span::Span, D::Type, values) =
    rebuild(sampling, _format(locus(sampling), D, values))
# Locus
_format(locus::AutoLocus, D::Type, values) = Center()
# Time dimensions need to default to the Start() locus, as that is
# nearly always the _format and Center intervals are difficult to
# calculate with DateTime step values.
_format(locus::AutoLocus, D::Type{<:TimeDim}, values) = Start()
_format(locus::Locus, D::Type, values) = locus

checkaxis(lookup::Union{Dimension,Lookup}, axis::AbstractUnitRange) = 
    first(axes(lookup)) == axis || _checkaxiserror(lookup, axis)

checkaxis(lookups::Tuple, axes::Tuple) = all(map(checkaxis, lookups, axes))

@noinline _explicitpoints_error() =
    throw(ArgumentError("Cannot use Explicit span with Points sampling"))
@noinline _steperror(values, span) =
    throw(ArgumentError("lookup step $(step(span)) does not match lookup step $(step(values))"))
@noinline _arraynosteperror() =
    throw(ArgumentError("`Regular` must specify `step` size with values other than `AbstractRange`"))
@noinline _checkaxiserror(dimorlookup::Union{Dimension,Lookup}, axis) =
    throw(DimensionMismatch(
        "axes of $(basetypeof(dimorlookup)) of $(first(axes(dimorlookup))) do not match array axis of $axis"
    ))
@noinline _valformaterror(v, D::Type) =
    throw(ArgumentError(
        "Lookup value of `$v` for dimension $D cannot be converted to a `Lookup`. Did you mean to pass a range or array?"
    ))

using LinearAlgebra: AbstractTriangular, AbstractRotation

const STRICT_MATMUL_CHECKS = Ref(true)
const STRICT_MATMUL_DOCS = """
With `strict=true` we check [`Lookup`](@ref) [`Order`](@ref) and values 
before attempting matrix multiplication, to ensure that dimensions match closely. 

We always check that dimension names match in matrix multiplication.
If you don't want this either, explicitly use `parent(A)` before
multiplying to remove the `AbstractDimArray` wrapper completely.
"""

"""
    strict_matmul()

Check if strickt broadcasting checks are active.

$STRICT_MATMUL_DOCS
"""
strict_matmul() = STRICT_MATMUL_CHECKS[]

"""
    strict_matmul!(x::Bool)

Set global matrix multiplication checks to `strict`, or not for all `AbstractDimArray`.

$STRICT_MATMUL_DOCS
"""
strict_matmul!(x::Bool) = STRICT_MATMUL_CHECKS[] = x

# Copied from symmetric.jl
const AdjTransVec = Union{Transpose{<:Any,<:AbstractVector},Adjoint{<:Any,<:AbstractVector}}
const RealHermSym{T<:Real,S} = Union{Hermitian{T,S}, Symmetric{T,S}}
const RealHermSymComplexHerm{T<:Real,S} = Union{Hermitian{T,S}, Symmetric{T,S}, Hermitian{Complex{T},S}}
const RealHermSymComplexSym{T<:Real,S} = Union{Hermitian{T,S}, Symmetric{T,S}, Symmetric{Complex{T},S}}

# Ambiguities
for (a, b) in (
    (AbstractDimVector, AbstractDimMatrix),
    (AbstractDimMatrix, AbstractDimVector),
    (AbstractDimMatrix, AbstractDimMatrix),
    (AbstractDimMatrix, AbstractVector),
    (AbstractDimVector, AbstractMatrix),
    (AbstractDimMatrix, AbstractMatrix),
    (AbstractMatrix, AbstractDimVector),
    (AbstractVector, AbstractDimMatrix),
    (AbstractMatrix, AbstractDimMatrix),
    (AbstractDimVector, Adjoint{<:Any,<:AbstractMatrix}),
    (AbstractDimVector, AdjTransVec),
    (AbstractDimVector, Transpose{<:Any,<:AbstractMatrix}),
    (AbstractDimMatrix, Diagonal),
    (AbstractDimMatrix, Adjoint{<:Any,<:RealHermSymComplexHerm}),
    (AbstractDimMatrix, Adjoint{<:Any,<:AbstractTriangular}),
    (AbstractDimMatrix, Transpose{<:Any,<:AbstractTriangular}),
    (AbstractDimMatrix, Transpose{<:Any,<:RealHermSymComplexSym}),
    (AbstractDimMatrix, AbstractTriangular),
    (Diagonal, AbstractDimVector),
    (Diagonal, AbstractDimMatrix),
    (Transpose{<:Any,<:AbstractTriangular}, AbstractDimVector),
    (Transpose{<:Any,<:AbstractTriangular}, AbstractDimMatrix),
    (Transpose{<:Any,<:AbstractVector}, AbstractDimVector),
    (Transpose{<:Real,<:AbstractVector}, AbstractDimVector),
    (Transpose{<:Any,<:AbstractVector}, AbstractDimMatrix),
    (Transpose{<:Any,<:RealHermSymComplexSym}, AbstractDimMatrix),
    (Transpose{<:Any,<:RealHermSymComplexSym}, AbstractDimVector),
    (AbstractTriangular, AbstractDimVector),
    (AbstractTriangular, AbstractDimMatrix),
    (Adjoint{<:Any,<:AbstractTriangular}, AbstractDimVector),
    (Adjoint{<:Any,<:AbstractVector}, AbstractDimMatrix),
    (Adjoint{<:Any,<:RealHermSymComplexHerm}, AbstractDimMatrix),
    (Adjoint{<:Any,<:AbstractTriangular}, AbstractDimMatrix),
    (Adjoint{<:Number,<:AbstractVector}, AbstractDimVector{<:Number}),
    (AdjTransVec, AbstractDimVector),
    (Adjoint{<:Any,<:RealHermSymComplexHerm}, AbstractDimVector),
)
    @eval Base.:*(A::$a, B::$b) = _rebuildmul(A, B)
end


Base.:*(A::AbstractDimVector, B::Adjoint{T,<:AbstractRotation}) where T = _rebuildmul(A, B)
Base.:*(A::Adjoint{T,<:AbstractRotation}, B::AbstractDimMatrix) where T = _rebuildmul(A, B)
Base.:*(A::Transpose{<:Any,<:AbstractMatrix{T}}, B::AbstractDimArray{S,1}) where {T,S} = _rebuildmul(A, B)
Base.:*(A::Adjoint{<:Any,<:AbstractMatrix{T}}, B::AbstractDimArray{S,1}) where {T,S} = _rebuildmul(A, B)

function _rebuildmul(A::AbstractDimVector, B::AbstractDimMatrix)
    # Vector has no dim 2 to compare
    out_dims = (_leading_dim_mul(A), _trailing_dim_mul(B))
    rebuild(B, parent(A) * parent(B), out_dims)
end
function _rebuildmul(A::AbstractDimMatrix, B::AbstractDimVector)
    _comparedims_mul(A, B)
    out_dims = (_leading_dim_mul(A),)
    rebuild(B, parent(A) * parent(B), out_dims)
end
function _rebuildmul(A::AbstractDimMatrix, B::AbstractDimMatrix)
    _comparedims_mul(A, B)
    out_dims = (_leading_dim_mul(A), _trailing_dim_mul(B))
    rebuild(A, parent(A) * parent(B), out_dims)
end
function _rebuildmul(A::AbstractDimVector, B::AbstractMatrix)
    out_dims = (_leading_dim_mul(A), _trailing_dim_mul(B))
    rebuild(A, parent(A) * B, out_dims)
end
function _rebuildmul(A::AbstractDimMatrix, B::AbstractVector)
    _comparedims_mul(A, B)
    newdata = parent(A) * B
    if newdata isa AbstractArray
        out_dims = (_leading_dim_mul(A),)
        rebuild(A, newdata, out_dims)
    else
        newdata
    end
end
function _rebuildmul(A::AbstractDimMatrix, B::AbstractMatrix)
    _comparedims_mul(A, B)
    out_dim = _leading_dim_mul(A)
    rebuild(A, parent(A) * B, (out_dim, AnonDim(Base.OneTo(size(B, 2)))))
end
function _rebuildmul(A::AbstractVector, B::AbstractDimMatrix)
    # Vector has no dim 2 to compare
    out_dims = (_leading_dim_mul(A), _trailing_dim_mul(B))
    rebuild(B, A * parent(B), out_dims)
end
function _rebuildmul(A::AbstractMatrix, B::AbstractDimVector)
    _comparedims_mul(A, B)
    newdata = A * parent(B)
    if newdata isa AbstractArray
        out_dim = _leading_dim_mul(A)
        rebuild(B, newdata, (out_dim,))
    else
        newdata
    end
end
function _rebuildmul(A::AbstractMatrix, B::AbstractDimMatrix)
    _comparedims_mul(A, B)
    out_dim1 = _leading_dim_mul(A)
    rebuild(B, A * parent(B), (out_dim1, last(dims(B))))
end

function _comparedims_mul(a, b)
    adims = dims(a)
    adims === nothing && return true
    bdims = dims(b)
    bdims === nothing && return true
    # Dont need to compare length if we compare values
    isstrict = strict_matmul()
    comparedims(last(adims), first(bdims);
        order=isstrict, val=isstrict, length=false
    )
end

function _leading_dim_mul(a::AbstractVecOrMat)
    adims = dims(a)
    adims === nothing && return AnonDim(axes(a, 1))
    first(adims)
end

function _trailing_dim_mul(a::AbstractMatrix)
    adims = dims(a)
    adims === nothing && return AnonDim(axes(a, 2))
    last(adims)
end

using DimensionalData, Test, Aqua, SafeTestsets

# Dirty hack to ensure that PythonCall.jl doesn't attempt to load an
# incompatible version of OpenSSL: load OpenSSL first.
import OpenSSL

@time @testset "Aqua" begin
    Aqua.test_ambiguities([DimensionalData, Base, Core])
    Aqua.test_unbound_args(DimensionalData)
    Aqua.test_undefined_exports(DimensionalData)
    Aqua.test_project_extras(DimensionalData)
    Aqua.test_stale_deps(DimensionalData)
    Aqua.test_deps_compat(DimensionalData)
end

@time @safetestset "FFT" begin include("abstractffts.jl") end
@time @safetestset "interface" begin include("interface.jl") end
@time @safetestset "metadata" begin include("metadata.jl") end
@time @safetestset "name" begin include("name.jl") end
@time @safetestset "dimension" begin include("dimension.jl") end
@time @safetestset "primitives" begin include("primitives.jl") end
@time @safetestset "lookup" begin include("lookup.jl") end
@time @safetestset "selector" begin include("selector.jl") end
@time @safetestset "merged" begin include("merged.jl") end
@time @safetestset "multidimensional_lookups" begin include("multidimensional_lookups.jl") end
@time @safetestset "DimUnitRange" begin include("dimunitrange.jl") end
@time @safetestset "format" begin include("format.jl") end
@time @safetestset "array" begin include("array.jl") end
@time @safetestset "stack" begin include("stack.jl") end
@time @safetestset "tree" begin include("tree.jl") end
@time @safetestset "indexing" begin include("indexing.jl") end
@time @safetestset "methods" begin include("methods.jl") end
@time @safetestset "broadcast" begin include("broadcast.jl") end
@time @safetestset "matmul" begin include("matmul.jl") end
@time @safetestset "dimindices" begin include("dimindices.jl") end
@time @safetestset "set" begin include("set.jl") end
@time @safetestset "tables" begin include("tables.jl") end
@time @safetestset "utils" begin include("utils.jl") end
@time @safetestset "groupby" begin include("groupby.jl") end
@time @safetestset "show" begin include("show.jl") end
@time @safetestset "adapt" begin include("adapt.jl") end
@time @safetestset "ecosystem" begin include("ecosystem.jl") end
@time @safetestset "categorical" begin include("categorical.jl") end
@time @safetestset "xarray" begin include("xarray.jl") end
@time @safetestset "chainrules" begin include("chainrules.jl") end


if Sys.islinux()
    # Unfortunately this can hang on other platforms.
    # Maybe ram use of all the plots on the small CI machine? idk
    @time @safetestset "SparseArrays" begin include("sparsearrays.jl") end
    @time @safetestset "Plots" begin include("plots.jl") end
    @time @safetestset "Makie" begin include("makie.jl") end
end

const StandardIndices = Union{
    AbstractArray{<:Integer},
    Colon,
    Integer,
    CartesianIndex,
    CartesianIndices,
    BeginEndRange,
}

struct SelectorError{L,S} <: Exception
    lookup::L
    selector::S
end

function Base.showerror(io::IO, ex::SelectorError)
    if isordered(ex.lookup)
        println(io, "SelectorError: attempt to select $(ex.selector) from lookup $(typeof(ex.lookup)) with bounds $(bounds(ex.lookup))")
    else
        println(io, "SelectorError: attempt to select $(ex.selector) from lookup $(typeof(ex.lookup)) with values $(ex.lookup)")
    end
end
Base.showerror(io::IO, ex::SelectorError{<:Categorical}) =
    println(io, "SelectorError: attempt to select $(ex.selector) from lookup $(typeof(ex.lookup)) with categories $(ex.lookup)")

"""
    Selector

Abstract supertype for all selectors.

Selectors are wrappers that indicate that passed values are not the array indices,
but values to be selected from the dimension lookup, such as `DateTime` objects for
a `Ti` dimension.

Selectors provided in DimensionalData are:

- [`At`](@ref)
- [`Between`](@ref)
- [`Touches`](@ref)
- [`Near`](@ref)
- [`Where`](@ref)
- [`Contains`](@ref)

Note: Selectors can be modified using:
- `Not`: as in `Not(At(x))`
And IntervalSets.jl `Interval` can be used instead of `Between`
- `..`
- `Interval`
- `OpenInterval`
- `ClosedInterval`
"""
abstract type Selector{T} end

val(sel::Selector) = sel.val
rebuild(sel::Selector, val) = basetypeof(sel)(val)

Base.parent(sel::Selector) = sel.val
Base.to_index(sel::Selector) = sel

abstract type Selector{T} end

"""
    IntSelector <: Selector

Abstract supertype for [`Selector`](@ref)s that return a single `Int` index.

IntSelectors provided by DimensionalData are:

- [`At`](@ref)
- [`Contains`](@ref)
- [`Near`](@ref)
"""
abstract type IntSelector{T} <: Selector{T} end

"""
    ArraySelector <: Selector

Abstract supertype for [`Selector`](@ref)s that return an `AbstractArray`.

ArraySelectors provided by DimensionalData are:

- [`Between`](@ref)
- [`Touches`](@ref)
- [`Where`](@ref)
"""
abstract type ArraySelector{T} <: Selector{T} end

const SelectorOrInterval = Union{Selector,Interval,Not}

const SelTuple = Tuple{SelectorOrInterval,Vararg{SelectorOrInterval}}

"""
    At <: IntSelector

    At(x; atol=nothing)
    At(a, b; kw...)

Selector that exactly matches the value on the passed-in dimensions, or throws an error.
For ranges and arrays, every intermediate value must match an existing value -
not just the end points.

`x` can be any value to select a single index, or a `Vector` of values to select vector of indices.
If two values `a` and `b` are used, the range between them will be selected.

Keyword `atol` is passed to `isapprox`.

## Example

```jldoctest
using DimensionalData

A = DimArray([1 2 3; 4 5 6], (X(10:10:20), Y(5:7)))
A[X(At(20)), Y(At(6))]

# output

5
```
"""
struct At{T,A} <: IntSelector{T}
    val::T
    atol::A
    At(val::T; atol::A=nothing) where {T,A} = new{T,A}(val, atol)
end
At(a, b; atol=nothing) = At((a, b); atol)
At(; kw...) = At(nothing; kw...)

ConstructionBase.constructorof(::Type{<:At}) = (val, atol) -> At(val; atol)

rebuild(sel::At, val) = At(val; atol=sel.atol)

atol(sel::At) = sel.atol

function Base.show(io::IO, x::At)
    print(io, "At(")
    isnothing(val(x)) || print(io, val(x))
    isnothing(atol(x)) || print(io, "; atol=", atol(x))
    print(io, ")")
end

struct _True end
struct _False end

function at(lookup::AbstractCyclic{Cycling}, sel::At; kw...)
    cycled_sel = rebuild(sel, cycle_val(lookup, val(sel)))
    return at(no_cycling(lookup), cycled_sel; kw...)
end
function at(lookup::NoLookup, sel::At; err=_True(), kw...)
    v = val(sel)
    r = round(Int, v)
    if isnothing(atol(sel))
        v == r || _selnotfound_or_nothing(err, lookup, v)
    else
        atol(sel) >= 0.5 && error("atol must be small than 0.5 for NoLookup")
        isapprox(v, r; atol=atol(sel)) || _selnotfound_or_nothing(err, lookup, v)
    end
    if r in lookup 
        return r
    else
        if err isa _False
            return nothing
        else
            throw(SelectorError(lookup, sel))
        end
    end
end
function at(lookup::Lookup, sel::At; kw...)
    at(order(lookup), span(lookup), lookup, val(sel), atol(sel); kw...)
end
function at(
    ::Ordered, span::Regular, lookup::Lookup{<:Integer}, selval, atol::Nothing;
    err=_True()
)
    x = unwrap(selval)
    Δ = step(span)
    i, remainder = divrem(x - first(lookup), Δ)
    i += firstindex(lookup)
    if remainder == 0 && checkbounds(Bool, lookup, i)
        return i
    else
        return _selnotfound_or_nothing(err, lookup, selval)
    end
end
function at(
    ::Ordered, ::Span, lookup::Lookup{<:IntervalSets.Interval}, selval, atol;
    err=_True()
)
    x = unwrap(selval)
    i = searchsortedlast(lookup, x; lt=(a, b) -> a.left < b.left)
    if lookup[i].left == x.left && lookup[i].right == x.right
        return i
    else
        return _selnotfound_or_nothing(err, lookup, selval)
    end
end
function at(
    ::Ordered, ::Span, lookup::Lookup{<:Union{Number,Dates.AbstractTime,AbstractString}}, selval, atol;
    err=_True()
)
    x = unwrap(selval)
    i = searchsortedlast(lookup, x)
    # Try the current index
    if i == firstindex(lookup) - 1
        i1 = i + 1
        if checkbounds(Bool, lookup, i1) && _is_at(x, lookup[i1], atol)
            return i1
        else
            return _selnotfound_or_nothing(err, lookup, selval)
        end
    elseif _is_at(x, lookup[i], atol)
        return i
    else
        # Try again with the next index
        i1 = i + 1
        if checkbounds(Bool, lookup, i1) && _is_at(x, lookup[i1], atol)
            return i1
        else
            return _selnotfound_or_nothing(err, lookup, selval)
        end
    end
end
# catch-all for an unordered index
function at(::Order, ::Span, lookup::Lookup, selval, atol; err=_True())
    i = findfirst(x -> _is_at(x, unwrap(selval), atol), parent(lookup))
    if i === nothing
        return _selnotfound_or_nothing(err, lookup, selval)
    else
        return i
    end
end


_is_at(at::At, v) = _is_at(val(at), v, atol(at))
@inline _is_at(x, y, atol) = x == y
@inline _is_at(x::Dates.AbstractTime, y::Dates.AbstractTime, atol::Dates.Period) = 
    x >= y - atol && x <= y + atol 
@inline _is_at(x::Real, y::Real, atol::Real) = abs(x - y) <= atol
@inline _is_at(x::Real, ys::AbstractArray, atol) = any(y -> _is_at(x, y, atol), ys)
@inline _is_at(xs::AbstractArray, y::Real, atol) = any(x -> _is_at(x, y, atol), xs)

_selnotfound_or_nothing(err::_True, lookup, selval) = _selnotfound(lookup, selval)
_selnotfound_or_nothing(err::_False, lookup, selval) = nothing
@noinline _selnotfound(l, selval) = throw(SelectorError(l, selval))

"""
    Near <: IntSelector

    Near(x)
    Near(a, b)

Selector that selects the nearest index to `x`.

With [`Points`](@ref) this is simply the lookup values nearest to the `x`,
however with [`Intervals`](@ref) it is the interval _center_ nearest to `x`.
This will be offset from the index value for `Start` and [`End`](@ref) locus.

`x` can be any value to select a single index, or a `Vector` of values to select vector of indices.
If two values `a` and `b`  are used, the range between the nearsest value
to each of them will be selected.

## Example

```jldoctest
using DimensionalData

A = DimArray([1 2 3; 4 5 6], (X(10:10:20), Y(5:7)))
A[X(Near(23)), Y(Near(5.1))]

# output
4
```
"""
struct Near{T} <: IntSelector{T}
    val::T
end
Near() = Near(nothing)
Near(a, b) = Near((a, b))

Base.show(io::IO, x::Near) = print(io, "Near(", val(x), ")")
Base.show(io::IO, x::Near{Nothing}) = print(io, "Near()")

function near(lookup::AbstractCyclic{Cycling}, sel::Near; kw...)
    cycled_sel = rebuild(sel, cycle_val(lookup, val(sel)))
    near(no_cycling(lookup), cycled_sel; kw...)
end
near(lookup::NoLookup, sel::Near{<:Real}; kw...) = max(1, min(round(Int, val(sel)), lastindex(lookup)))
function near(lookup::Lookup, sel::Near; kw...)
    # We ignore err keyword in near, as these are a different class of errors
    if !isregular(lookup) && !iscenter(lookup)
        throw(ArgumentError("Near is not implemented for Irregular or Explicit with Start or End locus. Use Contains"))
    end
    val(sel) isa AbstractFloat && isnan(val(sel)) && throw(ArgumentError("NaN not allowed in `Near`"))
    return near(order(lookup), sampling(lookup), lookup, sel; kw...)
end
near(order::Order, ::NoSampling, lookup::Lookup, sel::Near; kw...) = at(lookup, At(val(sel)); kw...)
function near(order::Ordered, ::Union{Intervals,Points}, lookup::Lookup, sel::Near; kw...)
    # Unwrap the selector value and adjust it for interval locus if necessary
    v = unwrap(val(sel))
    # Allow Date and DateTime to be used interchangeably
    if v isa Union{Dates.DateTime,Dates.Date}
        v = eltype(lookup)(v)
    end
    v_adj = _adjust_locus(locus(lookup), v, lookup)
    # searchsortedfirst or searchsortedlast
    searchfunc = _searchfunc(order)
    # Search for the value
    found_i = _inbounds(searchfunc(lookup, v_adj), lookup)

    # Check if this is the lowest possible value already, and return if so
    if order isa ForwardOrdered
        found_i <= firstindex(lookup) && return found_i
    elseif order isa ReverseOrdered
        found_i >= lastindex(lookup) && return found_i
    end

    # Find which index is nearest, the found index or previous index
    prev_i = found_i - _ordscalar(order)
    dist_to_prev = abs(v_adj - lookup[prev_i])
    dist_to_found = abs(v_adj - lookup[found_i])
    # Compare distance to the found and previous index values
    # We have to use the correct >/>= for Start/End locus
    lessthan = _lt(locus(lookup))
    closest_i = lessthan(dist_to_prev, dist_to_found) ? prev_i : found_i

    return closest_i
end
function near(order::Ordered, ::Intervals, lookup::Lookup{<:IntervalSets.Interval}, sel::Near; kw...)
    throw(ArgumentError("`Near` is not yet implemented for lookups of `IntervalSets.Interval`"))
end
function near(::Unordered, ::Union{Intervals,Points}, lookup::Lookup, sel::Near; kw...)
    throw(ArgumentError("`Near` has no meaning in an `Unordered` lookup"))
end

_adjust_locus(locus::Center, v, lookup) = v
_adjust_locus(locus::Start, v, lookup) = v - abs(step(lookup)) / 2
_adjust_locus(locus::End, v, lookup) = v + abs(step(lookup)) / 2
_adjust_locus(locus::Start, v::Dates.AbstractTime, lookup) = v - (v - (v - abs(step(lookup)))) / 2
_adjust_locus(locus::End, v::Dates.AbstractTime, lookup) = v + (v + abs(step(lookup)) - v) / 2
_adjust_locus(locus::Start, v::Dates.Date, lookup) = v - (v - (v - abs(step(lookup)))) ÷ 2
_adjust_locus(locus::End, v::Dates.Date, lookup) = v + (v + abs(step(lookup)) - v) ÷ 2

"""
    Contains <: IntSelector

    Contains(x)
    Contains(a, b)

Selector that selects the interval the value is contained by. If the
interval is not present in the lookup, an error will be thrown.

Can only be used for [`Intervals`](@ref) or [`Categorical`](@ref).
For [`Categorical`](@ref) it falls back to using [`At`](@ref).
`Contains` should not be confused with `Base.contains` - use `Where(contains(x))` 
to check for if values are contain in categorical values like strings.

`x` can be any value to select a single index, or a `Vector` of values to select vector of indices.
If two values `a` and `b`  are used, the range between them will be selected.

## Example

```jldoctest
using DimensionalData; const DD = DimensionalData
dims_ = X(10:10:20; sampling=DD.Intervals(DD.Center())),
        Y(5:7; sampling=DD.Intervals(DD.Center()))
A = DimArray([1 2 3; 4 5 6], dims_)
A[X(Contains(8)), Y(Contains(6.8))]

# output
3
```
"""
struct Contains{T} <: IntSelector{T}
    val::T
end
Contains() = Contains(nothing)
Contains(a, b) = Contains((a, b))
@inline _selectvec(l, sel; kw...) = [selectindices(l, rebuild(sel, v); kw...) for v in val(sel)]
@inline function _selecttuple(l, sel; kw...) 
    v1, v2 = _maybeflipbounds(l, val(sel))
    selectindices(l, rebuild(sel, v1); kw...):selectindices(l, rebuild(sel, v2); kw...)
end

Base.show(io::IO, x::Contains) = print(io, "Contains(", val(x), ")")
Base.show(io::IO, x::Contains{Nothing}) = print(io, "Contains()")

function contains(lookup::AbstractCyclic{Cycling}, sel::Contains; kw...)
    cycled_sel = rebuild(sel, cycle_val(lookup, val(sel)))
    return contains(no_cycling(lookup), cycled_sel; kw...)
end
function contains(l::NoLookup, sel::Contains; err=_True(), kw...)
    if isinteger(val(sel))
        i = Int(val(sel))
        i in l && return i
    end
    if err isa _False
        return nothing
    else
        throw(SelectorError(l, val(sel)))
    end
end
function contains(l::Lookup, sel::Contains; kw...)
    val(sel) isa AbstractFloat && isnan(val(sel)) && throw(ArgumentError("NaN not allowed in `Contains`"))
    contains(sampling(l), l, sel; kw...)
end
# NoSampling (e.g. Categorical) just uses `at`
function contains(::NoSampling, l::Lookup, sel::Contains; kw...)
    at(l, At(val(sel)); kw...)
end
# Points --------------------------------------
function contains(sampling::Points, l::Lookup, sel::Contains; kw...)
    contains(order(l), sampling, l, sel; kw...)
end
function contains(::Order, ::Points, l::Lookup, sel::Contains; kw...)
    at(l, At(val(sel)); kw...)
end
function contains(::Order, ::Points, l::Lookup{<:AbstractArray}, sel::Contains{<:AbstractArray};
    kw...
)
    at(l, At(val(sel)); kw...)
end
# Intervals -----------------------------------
function contains(sampling::Intervals, l::Lookup, sel::Contains; err=_True())
    _checkbounds_locus(l, sel) || return _selector_error_or_nothing(err, l, sel)
    contains(order(l), span(l), sampling, locus(l), l, sel; err)
end
function contains(
    sampling::Intervals, l::Lookup{<:IntervalSets.Interval}, sel::Contains;
    kw...
)
    v = val(sel)
    interval_sel = Contains(Interval{:closed,:open}(v, v))
    contains(sampling, l, interval_sel; kw...)
end
function contains(
    ::Intervals,
    l::Lookup{<:IntervalSets.Interval},
    sel::Contains{<:IntervalSets.Interval};
    err=_True()
)
    v = val(sel)
    i = searchsortedlast(l, v; by=_by)

    if i in eachindex(l) && _in(v, l[i])
        return i
    else
        return _notcontained_or_nothing(err, v)
    end
end
# Regular Intervals ---------------------------
function contains(
    o::Ordered, span::Regular, ::Intervals, locus::Locus, l::Lookup, sel::Contains;
    err=_True()
)
    v = val(sel)
    i = _searchfunc(locus, o)(l, v)
    return check_regular_contains(span, locus, l, v, i, err)
end
function contains(
    o::Ordered, span::Regular, ::Intervals, locus::Center, l::Lookup, sel::Contains;
    err=_True()
)
    v = val(sel) + abs(val(span)) / 2
    i = _searchfunc(locus, o)(l, v)
    return check_regular_contains(span, locus, l, v, i, err)
end

function check_regular_contains(span::Span, locus::Locus, l::Lookup, v, i, err)
    absstep = abs(val(span))
    if (parent(l) isa AbstractRange) || _lt(locus)(v, l[i] + absstep)
        return i
    else
        return _notcontained_or_nothing(err, v)
    end
end

# Explicit Intervals ---------------------------
function contains(
    o::Ordered, span::Explicit, ::Intervals, locus, l::Lookup, sel::Contains;
    err=_True()
)
    v = val(sel)
    searchfunc = _searchfunc(_Upper(), o)
    i = searchfunc(view(val(span), 1, :), v; order=ordering(o), lt=_lt(locus))
    if i === 0 || val(span)[2, i] < v
        return _notcontained_or_nothing(err, v)
    else
        return i
    end
end
# Irregular Intervals -------------------------
function contains(
    o::Ordered, span::Irregular, ::Intervals, locus::Locus, l::Lookup, sel::Contains;
    err=_True()
)
    return _searchfunc(locus, o)(l, val(sel))
end
function contains(
    o::Ordered, span::Irregular, ::Intervals, locus::Center, l::Lookup, sel::Contains;
    err=_True()
)
    _order_lt(::ForwardOrdered) = (<)
    _order_lt(::ReverseOrdered) = (<=)

    v = val(sel)
    i = searchsortedfirst(l, v)
    i = if i <= firstindex(l)
        firstindex(l)
    elseif i > lastindex(l)
        lastindex(l)
    else
        interval = abs(l[i] - l[i - 1])
        distance = abs(l[i] - v)
        _order_lt(o)(interval / 2, distance) ? i - 1 : i
    end
    return i
end

_selector_error_or_nothing(err::_True, l, i) = throw(SelectorError(l, i))
_selector_error_or_nothing(err::_False, l, i) = nothing

_notcontained_or_nothing(err::_True, selval) = _notcontainederror(selval)
_notcontained_or_nothing(err::_False, selval) = nothing

_notcontainederror(v) = throw(ArgumentError("No interval contains $v"))

_searchfunc(::Locus, ::ForwardOrdered) = searchsortedlast
_searchfunc(::End, ::ForwardOrdered) = searchsortedfirst
_searchfunc(::Locus, ::ReverseOrdered) = searchsortedfirst
_searchfunc(::End, ::ReverseOrdered) = searchsortedlast

"""
    Between <: ArraySelector

    Between(a, b)


Depreciated: use `a..b` instead of `Between(a, b)`. Other `Interval`
objects from IntervalSets.jl, like `OpenInterval(a, b) will also work,
giving the correct open/closed boundaries.

`Between` will e removed in future to avoid clashes with `DataFrames.Between`.

Selector that retrieve all indices located between 2 values,
evaluated with `>=` for the lower value, and `<` for the upper value.
This means the same value will not be counted twice in 2 adjacent
`Between` selections.

For [`Intervals`](@ref) the whole interval must be lie between the
values. For [`Points`](@ref) the points must fall between
the values. Different [`Sampling`](@ref) types may give different
results with the same input - this is the intended behaviour.

`Between` for [`Irregular`](@ref) intervals is a little complicated. The
interval is the distance between a value and the next (for `Start` locus)
or previous (for [`End`](@ref) locus) value.

For [`Center`](@ref), we take the mid point between two index values
as the start and end of each interval. This may or may not make sense for
the values in your index, so use `Between` with `Irregular` `Intervals(Center())`
with caution.

## Example

```jldoctest
using DimensionalData

A = DimArray([1 2 3; 4 5 6], (X(10:10:20), Y(5:7)))
A[X(Between(15, 25)), Y(Between(4, 6.5))]

# output

┌ 1×2 DimArray{Int64, 2} ┐
├────────────────────────┴────────────────────────────── dims ┐
  ↓ X Sampled{Int64} 20:10:20 ForwardOrdered Regular Points,
  → Y Sampled{Int64} 5:6 ForwardOrdered Regular Points
└─────────────────────────────────────────────────────────────┘
  ↓ →  5  6
 20    4  5
```
"""
struct Between{T<:Union{<:AbstractVector{<:Tuple{Any,Any}},Tuple{Any,Any},Nothing}} <: ArraySelector{T}
    val::T
end
Between(a, b) = Between((a, b))

Base.show(io::IO, x::Between) = print(io, "Between(", val(x), ")")
Base.first(sel::Between) = first(val(sel))
Base.last(sel::Between) = last(val(sel))

abstract type _Side end
struct _Upper <: _Side end
struct _Lower <: _Side end

# between
# returns a UnitRange from an Interval
function between(l::Lookup, sel::Between)
    a, b = _sorttuple(sel)
    return between(l, a .. b)
end
# NoIndex behaves like `Sampled` `ForwardOrdered` `Points` of 1:N Int
function between(l::NoLookup, sel::Interval)
    x = intersect(sel, first(axes(l, 1))..last(axes(l, 1)))
    return ceil(Int, x.left):floor(Int, x.right)
end
# function between(l::AbstractCyclic{Cycling}, sel::Interval)
#     cycle_val(l, sel.x)..cycle_val(l, sel.x)
#     cycled_sel = rebuild(sel; val=)
#     near(no_cycling(lookup), cycled_sel; kw...)
# end
function between(l::Lookup, interval::Interval)
    interval.left isa AbstractFloat && (isnan(interval.left) || isnan(interval.right)) &&
        throw(ArgumentError("NaN not allowed in selectors"))
    between(sampling(l), l, interval)
end
# This is the main method called above
function between(sampling::Sampling, l::Lookup, interval::Interval)
    isordered(l) || throw(ArgumentError("Cannot use an interval or `Between` with `Unordered`"))
    between(sampling, order(l), l, interval)
end

function between(sampling::NoSampling, o::Ordered, l::Lookup, interval::Interval)
    between(Points(), o, l, interval)
end

function between(sampling, o::Ordered, l::Lookup, interval::Interval)
    lowerbound, upperbound = bounds(l)
    lowsel, highsel = endpoints(interval)
    a = if lowsel > upperbound
        ordered_lastindex(l) + _ordscalar(o)
    elseif lowsel < lowerbound
        ordered_firstindex(l)
    else
        _between_side(_Lower(), o, span(l), sampling, l, interval, lowsel)
    end
    b = if highsel < lowerbound
        ordered_firstindex(l) - _ordscalar(o)
    elseif highsel > upperbound
        ordered_lastindex(l)
    else
        _between_side(_Upper(), o, span(l), sampling, l, interval, highsel)
    end
    a, b = _maybeflipbounds(o, (a, b))
    # Fix empty range values
    if a > b
        if b < firstindex(l)
            return firstindex(l):(firstindex(l) - 1)
        elseif a > lastindex(l)
            return (lastindex(l) + 1):lastindex(l)
        end
    else
        return a:b
    end
    return a:b
end

# Points -------------------------
function _between_side(side::_Lower, o::Ordered, span, ::Points, l, interval, v)
    i = v <= bounds(l)[1] ? ordered_firstindex(l) : _searchfunc(side, o)(l, v)
    return _close_interval(side, l, interval, l[i], i)
end
function _between_side(side::_Upper, o::Ordered, span, ::Points, l, interval, v)
    i = v >= bounds(l)[2] ? ordered_lastindex(l) : _searchfunc(side, o)(l, v)
    return _close_interval(side, l, interval, l[i], i)
end

# Regular Intervals -------------------------
# Adjust the value for the lookup locus before search
function _between_side(side, o::Ordered, ::Regular, ::Intervals, l, interval, v)
    adj = _adjust_locus(side, l)
    v1 = v + adj
    i = _searchfunc(side, o)(l, v1)
    # Sideshift (1 or -1) expands the selection to the outside of any touched intervals
    # We multiply by ordscalar (1 or -1) to allow for reversed lookups.
    i1 = i # + _sideshift(side) * _ordscalar(o)
    # Now find the edge of the cell and check that is not the edge of
    # an open interval. If so shrink the selected range.
    cellbound = if i > lastindex(l)
        l[end] + adj
    elseif i < firstindex(l)
        l[begin] + adj
    else
        l[i] - adj
    end
    return _close_interval(side, l, interval, cellbound, i)
end

# Explicit Intervals -------------------------
function _between_side(side, o::Ordered, span::Explicit, ::Intervals, l, interval, v)
    # Rebuild the lookup with the lower or upper bounds matrix values before searching
    boundsvec = side isa _Lower ? view(val(span), 1, :) : view(val(span), 2, :)
    l1 = rebuild(l; data=boundsvec)
    # Search for the cell boundary
    i = _searchfunc(side, o)(l1, v)
    # Add sideshift (1 or -1) to expand the selection to the outside of any touched intervals
    # If i is in bounds, check the cell boundary is not the edge of an open interval
    return if checkbounds(Bool, l1, i)
        @inbounds cellbound = l1[i]
        _close_interval(side, l1, interval, cellbound, i)
    else
        i
    end
end

# Irregular Intervals -----------------------
#
# This works a little differently to Regular variants,
# as we have to work with unequal step sizes, calculating them
# as we find close values.
#
# Find the interval the value falls in.
# We need to special-case Center locus for Irregular
_between_side(side, o, span::Irregular, ::Intervals, l, interval, v) =
    _between_irreg_side(side, locus(l), o, l, interval, v)

function _between_irreg_side(side, locus::Union{Start,End}, o, l, interval, v)
    if v == bounds(l)[1]
        i = ordered_firstindex(l)
        cellbound = v
    elseif v == bounds(l)[2]
        i = ordered_lastindex(l)
        cellbound = v
    else
        s = _ordscalar(o)
        # Search for the value and offset per order/locus/side
        i = _searchfunc(o)(l, v; lt=_lt(side))
        i -= s * (_posscalar(locus) + _sideshift(side))
        # Get the value on the interval edge
        cellbound = if i < firstindex(l)
            _maybeflipbounds(l, bounds(l))[1]
        elseif i > lastindex(l)
            _maybeflipbounds(l, bounds(l))[2]
        elseif side isa _Lower && locus isa End
            l[i-s]
        elseif side isa _Upper && locus isa Start
            l[i+s]
        else
            l[i]
        end
    end
    return _close_interval(side, l, interval, cellbound, i)
end
function _between_irreg_side(side, locus::Center, o, l, interval, v)
    if v == bounds(l)[1]
        i = ordered_firstindex(l)
        cellbound = v
    elseif v == bounds(l)[2]
        i = ordered_lastindex(l)
        cellbound = v
    else
        r = _ordscalar(o)
        sh = _sideshift(side)
        i = _searchfunc(o)(l, v; lt=_lt(side))
        (i - r < firstindex(l) ||  i - r > lastindex(l)) && return i
        half_step = abs(l[i] - l[i-r]) / 2
        distance = abs(l[i] - v)
        # Use the right less than </<= to match interval bounds
        i = if _lt(side)(distance, half_step)
            i - sh * r
        else
            i - (1 + sh) * r
        end
        shift = side isa _Lower ? -half_step : half_step
        cellbound = l[i] + shift
    end
    return _close_interval(side, l, interval, cellbound, i)
end


_close_interval(side, l, interval, cellbound, i) = i
function _close_interval(side::_Lower, l, interval::Interval{:open,<:Any}, cellbound, i)
    cellbound == interval.left ? i + _ordscalar(l) : i
end
function _close_interval(side::_Upper, l, interval::Interval{<:Any,:open}, cellbound, i)
    cellbound == interval.right ? i - _ordscalar(l) : i
end

_adjust_locus(side, l) = _adjust_locus(side, locus(l), abs(step(span(l))))
_adjust_locus(::_Lower, locus::Start, step) = zero(step)
_adjust_locus(::_Upper, locus::Start, step) = -step
_adjust_locus(::_Lower, locus::Center, step) = step/2
_adjust_locus(::_Upper, locus::Center, step) = -step/2
_adjust_locus(::_Lower, locus::End, step) = step
_adjust_locus(::_Upper, locus::End, step) = -zero(step)

_posscalar(::Start) = 1
_posscalar(::End) = 0
_sideshift(::_Lower) = -1
_sideshift(::_Upper) = 1
_ordscalar(l) = _ordscalar(order(l))
_ordscalar(::ForwardOrdered) = 1
_ordscalar(::ReverseOrdered) = -1

_lt(::_Lower) = (<)
_lt(::_Upper) = (<=)

_maybeflipbounds(m::Lookup, bounds) = _maybeflipbounds(order(m), bounds)
_maybeflipbounds(o::ForwardOrdered, (a, b)) = (a, b)
_maybeflipbounds(o::ReverseOrdered, (a, b)) = (b, a)
_maybeflipbounds(o::Unordered, (a, b)) = (a, b)

"""
    Touches <: ArraySelector

    Touches(a, b)

Selector that retrieves all indices touching the closed interval 2 values,
for the maximum possible area that could interact with the supplied range.

This can be better than `..` when e.g. subsetting an area to rasterize, as
you may wish to include pixels that just touch the area, rather than those
that fall within it.

Touches is different to using closed intervals when the lookups also
contain intervals - if any of the intervals touch, they are included.
With `..` they are discarded unless the whole cell interval falls inside
the selector interval.

## Example

```jldoctest
using DimensionalData

A = DimArray([1 2 3; 4 5 6], (X(10:10:20), Y(5:7)))
A[X(Touches(15, 25)), Y(Touches(4, 6.5))]

# output
┌ 1×2 DimArray{Int64, 2} ┐
├────────────────────────┴────────────────────────────── dims ┐
  ↓ X Sampled{Int64} 20:10:20 ForwardOrdered Regular Points,
  → Y Sampled{Int64} 5:6 ForwardOrdered Regular Points
└─────────────────────────────────────────────────────────────┘
  ↓ →  5  6
 20    4  5
```
"""
struct Touches{T<:Union{<:AbstractVector{<:Tuple{Any,Any}},Tuple{Any,Any},Nothing,Extents.Extent}} <: ArraySelector{T}
    val::T
end
Touches(a, b) = Touches((a, b))

Base.first(sel::Touches) = first(val(sel))
Base.last(sel::Touches) = last(val(sel))

# touches for tuple intervals
# returns a UnitRange like Touches/Interval but for cells contained
# NoIndex behaves like `Sampled` `ForwardOrdered` `Points` of 1:N Int
touches(l::NoLookup, sel::Touches) = between(l, Interval(val(sel)...))
touches(l::Lookup, sel::Touches) = touches(sampling(l), l, sel)
# This is the main method called above
function touches(sampling::Sampling, l::Lookup, sel::Touches)
    o = order(l)
    o isa Unordered && throw(ArgumentError("Cannot use an sel or `Between` with Unordered"))
    touches(sampling, o, l, sel)
end

function touches(sampling::NoSampling, o::Ordered, l::Lookup, sel::Touches)
    touches(Points(), o, l, sel)
end

function touches(sampling, o::Ordered, l::Lookup, sel::Touches)
    lowerbound, upperbound = bounds(l)
    lowsel, highsel = val(sel)
    a = if lowsel > upperbound
        ordered_lastindex(l) + _ordscalar(o)
    elseif lowsel < lowerbound
        ordered_firstindex(l)
    else
        _touches(_Lower(), o, span(l), sampling, l, sel, lowsel)
    end
    b = if highsel < lowerbound
        ordered_firstindex(l) - _ordscalar(o)
    elseif highsel > upperbound
        ordered_lastindex(l)
    else
        _touches(_Upper(), o, span(l), sampling, l, sel, highsel)
    end
    a, b = _maybeflipbounds(o, (a, b))
    # Fix empty range values
    if a > b
        if b < firstindex(l)
            return firstindex(l):(firstindex(l) - 1)
        elseif a > lastindex(l)
            return (lastindex(l) + 1):lastindex(l)
        end
    else
        return a:b
    end
    return a:b
end

# Points -------------------------
function _touches(side::_Lower, o::Ordered, span, ::Points, l, sel, v)
    i = v <= bounds(l)[1] ? ordered_firstindex(l) : _searchfunc(side, o)(l, v)
    return i
end
function _touches(side::_Upper, o::Ordered, span, ::Points, l, sel, v)
    i = v >= bounds(l)[2] ? ordered_lastindex(l) : _searchfunc(side, o)(l, v)
    return i
end

# Regular Intervals -------------------------
# Adjust the value for the lookup locus before search
function _touches(side, o::Ordered, ::Regular, ::Intervals, l, sel, v)
    adj = _adjust_locus(side, l)
    v1 = v + adj
    i = _searchfunc(side, o)(l, v1)
    # Sideshift (1 or -1) expands the selection to the outside of any touched sels
    # We multiply by ordscalar (1 or -1) to allow for reversed lookups.
    i1 = i + _sideshift(side) * _ordscalar(o)
    # Finally we need to make sure i2 is still inbounds after adding sideshift
    return min(max(i1, firstindex(l)), lastindex(l))
end

# Explicit Intervals -------------------------
function _touches(side, o::Ordered, span::Explicit, ::Intervals, l, sel, v)
    # Rebuild the lookup with the lower or upper bounds matrix values before searching
    boundsvec = side isa _Lower ? view(val(span), 1, :) : view(val(span), 2, :)
    l1 = rebuild(l; data=boundsvec)
    # Search for the cell boundary
    i = _searchfunc(side, o)(l1, v)
    # Add sideshift (1 or -1) to expand the selection to the outside of any touched sels
    i1 = i + _sideshift(side) * _ordscalar(o)
    # Finally we need to make sure i2 is still inbounds after adding sideshift
    return min(max(i1, firstindex(l)), lastindex(l))
end

# Irregular Intervals -----------------------
#
# This works a little differently to Regular variants,
# as we have to work with unequal step sizes, calculating them
# as we find close values.
#
# Find the interval the value falls in.
# We need to special-case Center locus for Irregular
_touches(side, o, span::Irregular, ::Intervals, l, sel, v) =
    _touches_irreg_side(side, locus(l), o, l, sel, v)

function _touches_irreg_side(side, locus::Union{Start,End}, o, l, sel, v)
    i = if v == bounds(l)[1]
        ordered_firstindex(l)
    elseif v == bounds(l)[2]
        ordered_lastindex(l)
    else
        # Search for the value and offset per order/locus/side
        _searchfunc(o)(l, v; lt=_lt(side)) - _ordscalar(o) * _posscalar(locus)
    end
    return i
end
function _touches_irreg_side(side, locus::Center, o, l, sel, v)
    if v == bounds(l)[1]
        i = ordered_firstindex(l)
    elseif v == bounds(l)[2]
        i = ordered_lastindex(l)
    else
        i = _searchfunc(o)(l, v; lt=_lt(side))
        i1 = i - _ordscalar(o)
        # We are at the start or end, return i
        if (i1 < firstindex(l) ||  i1 > lastindex(l))
            i
        else
            # Calculate the size of the current step
            half_step = abs(l[i] - l[i1]) / 2
            distance = abs(l[i] - v)
            # Use the correct less than </<= to match sel bounds
            i = if _lt(side)(distance, half_step)
                i
            else
                i1
            end
        end
    end
    return i
end


"""
    Where <: ArraySelector

    Where(f::Function)

Selector that filters a dimension lookup by any function that
accepts a single value and returns a `Bool`.

## Example

```jldoctest
using DimensionalData

A = DimArray([1 2 3; 4 5 6], (X(10:10:20), Y(19:21)))
A[X(Where(x -> x > 15)), Y(Where(x -> x in (19, 21)))]

# output

┌ 1×2 DimArray{Int64, 2} ┐
├────────────────────────┴─────────────────────────────── dims ┐
  ↓ X Sampled{Int64} [20] ForwardOrdered Irregular Points,
  → Y Sampled{Int64} [19, 21] ForwardOrdered Irregular Points
└──────────────────────────────────────────────────────────────┘
  ↓ →  19  21
 20     4   6
```
"""
struct Where{T} <: ArraySelector{T}
    f::T
end

val(sel::Where) = sel.f

Base.show(io::IO, x::Where) = print(io, "Where(", repr(val(x)), ")")

# Yes this is everything. `Where` doesn't need lookup specialisation
@inline function _selectindices(lookup::Lookup, sel::Where)
    [i for (i, v) in enumerate(parent(lookup)) if sel.f(v)]
end

"""
    All <: Selector

    All(selectors::Selector...)

Selector that combines the results of other selectors.
The indices used will be the union of all result sorted in ascending order.

## Example

```jldoctest
using DimensionalData, Unitful

dimz = X(10.0:20:200.0), Ti(1u"s":5u"s":100u"s")
A = DimArray((1:10) * (1:20)', dimz)
A[X=All(At(10.0), At(50.0)), Ti=All(1u"s"..10u"s", 90u"s"..100u"s")]

# output

┌ 2×4 DimArray{Int64, 2} ┐
├────────────────────────┴─────────────────────────────────────────────── dims ┐
  ↓ X Sampled{Float64} [10.0, 50.0] ForwardOrdered Irregular Points,
  → Ti Sampled{Unitful.Quantity{Int64, 𝐓, Unitful.FreeUnits{(s,), 𝐓, nothing}}} [1 s, …, 96 s] ForwardOrdered Irregular Points
└──────────────────────────────────────────────────────────────────────────────┘
  ↓ →  1 s  6 s  91 s  96 s
 10.0  1    2    19    20
 50.0  3    6    57    60
```
"""
struct All{S<:Tuple{Vararg{SelectorOrInterval}}} <: Selector{S}
    selectors::S
end
All(args::SelectorOrInterval...) = All(args)

Base.show(io::IO, x::All) = print(io, "All(", x.selectors, ")")

@inline function _selectindices(lookup::Lookup, sel::All)
    results = map(s -> selectindices(lookup, s), sel.selectors)
    sort!(union(results...))
end

# selectindices ==========================================================================


"""
    selectindices(lookups, selectors)

Converts [`Selector`](@ref) to regular indices.
"""
function selectindices end
@inline selectindices(lookups::LookupTuple, s1, ss...; kw...) =
    selectindices(lookups, (s1, ss...); kw...)
@inline selectindices(lookups::LookupTuple, selectors::Tuple; kw...) =
    map((l, s) -> selectindices(l, s; kw...), lookups, selectors)
@inline selectindices(lookups::LookupTuple, selectors::Tuple{}; kw...) = ()
# @inline selectindices(dim::Lookup, sel::Val) = selectindices(val(dim), At(sel))
# Standard indices are just returned.
@inline selectindices(::Lookup, sel::StandardIndices; kw...) = sel

# Vectors are mapped
@inline selectindices(lookup::Lookup, sel::Selector{<:AbstractVector}; kw...) =
    Int[selectindices(lookup, rebuild(sel; val=v); kw...) for v in val(sel)]
# Tuples may become ranges, unless the lookup is a tuple
@inline selectindices(l::Lookup, sel::IntSelector{<:Tuple}; kw...) = 
    _selecttuple(l, sel; kw...)
@inline selectindices(l::Lookup{<:Tuple}, sel::IntSelector{<:Tuple}; kw...) = 
    _selectindices(l, sel; kw...)
@inline selectindices(l::Lookup{<:Tuple}, sel::IntSelector{<:Tuple{<:Tuple,<:Tuple}}; kw...) = 
    _selecttuple(l, sel; kw...)
selectindices(l::Lookup, sel::SelectorOrInterval; kw...) = _selectindices(l, sel; kw...)
# @inline function selectindices(l::Lookup, sel; kw...)
#     selstr = sprint(show, sel)
#     throw(ArgumentError("Invalid index `$selstr`. Did you mean `At($selstr)`? Use stardard indices, `Selector`s, or `Val` for compile-time `At`."))
# end

# Separated _selectindices methods reduce ambiguity issues

# `Not` form InvertedIndices.jl
@inline function _selectindices(l::Lookup, sel::Not; kw...)
    indices = selectindices(l, sel.skip; kw...)
    return first(to_indices(l, (Not(indices),)))
end
@inline _selectindices(l::Lookup, sel::Touches) = touches(l, sel)
@inline _selectindices(l::Lookup, sel::Union{Between{<:Tuple},Interval}) = 
    between(l, sel)
@inline function _selectindices(lookup::Lookup, sel::Between{<:AbstractVector})
    inds = Int[]
    for v in val(sel)
        append!(inds, selectindices(lookup, rebuild(sel, v)))
    end
end
@inline _selectindices(l::Lookup, sel::Contains; kw...) = contains(l, sel; kw...)
@inline _selectindices(l::Lookup, sel::Near; kw...) = near(l, sel; kw...)
@inline _selectindices(l::Lookup, sel::At; kw...) = at(l, sel; kw...)

# Unaligned Lookup ------------------------------------------

# select_unalligned_indices is called directly from dims2indices

# We use the transformation from the first unaligned dim.
# In practice the others could be empty.
function select_unalligned_indices(
    lookups::LookupTuple, sel::Tuple{IntSelector,Vararg{IntSelector}}
)
    transformed = transformfunc(lookups[1])(map(val, sel))
    map(_transform2int, lookups, sel, transformed)
end
function select_unalligned_indices(
    lookups::LookupTuple, sel::Tuple{Selector,Vararg{Selector}}
)
    throw(ArgumentError("only `Near`, `At` or `Contains` selectors currently work on `Unalligned` lookups"))
end
function select_unalligned_indices(
    lookups::Tuple{<:ArrayLookup,<:ArrayLookup,Vararg{ArrayLookup}}, 
    selectors::Tuple{<:IntSelector,<:IntSelector,Vararg{IntSelector}}
)
    select_array_lookups(lookups, selectors)
end

# This implementation is extremely slow,
# it's expected user will use the NearestNeighbors.jl extension
function select_array_lookups(
    lookups::Tuple{<:ArrayLookup,<:ArrayLookup,Vararg{ArrayLookup}}, 
    selectors::Tuple
)
    throw(ArgumentError("Load NearestNeighbors.jl to use `At` on `ArrayLookup`s"))
end

_transform2int(lookup::AbstractArray, ::Near, x) = min(max(round(Int, x), firstindex(lookup)), lastindex(lookup))
_transform2int(lookup::AbstractArray, ::Contains, x) = round(Int, x)
_transform2int(lookup::AbstractArray, sel::At, x) = _transform2int(sel, x, atol(sel))
_transform2int(::At, x, atol::Nothing) = convert(Int, x)
function _transform2int(::At, x, atol)
    i = round(Int, x)
    abs(x - i) <= atol ? i : _transform_notfound(x)
end

@noinline _transform_notfound(x) = throw(ArgumentError("$x not found in Transformed lookups"))


# Shared utils ============================================================================

# Return an inbounds index
_inbounds(is::Tuple, lookup::Lookup) = map(i -> _inbounds(i, lookup), is)
function _inbounds(i::Int, lookup::Lookup)
    if i > lastindex(lookup)
        lastindex(lookup)
    elseif i <= firstindex(lookup)
        firstindex(lookup)
    else
        i
    end
end

_sorttuple(sel::Between) = _sorttuple(val(sel))
_sorttuple((a, b)::Tuple{<:Any,<:Any}) = a < b ? (a, b) : (b, a)

_lt(::Locus) = (<)
_lt(::End) = (<=)
_gt(::Locus) = (>=)
_gt(::End) = (>)

_checkbounds_locus(l::Lookup, sel::Selector) =  _checkbounds_locus(locus(l), bounds(l), val(sel))
_checkbounds_locus(pos, (l, h)::Tuple, v) = !(_lt(pos)(v, l) || _gt(pos)(v, h))

_searchfunc(::ForwardOrdered) = searchsortedfirst
_searchfunc(::ReverseOrdered) = searchsortedlast

_searchfunc(::_Lower, ::ForwardOrdered) = searchsortedfirst
_searchfunc(::_Lower, ::ReverseOrdered) = searchsortedlast
_searchfunc(::_Upper, ::ForwardOrdered) = searchsortedlast
_searchfunc(::_Upper, ::ReverseOrdered) = searchsortedfirst

# by helpers so sort and searchsorted works on more types
_by(x::Pair) = _by(x[1])
_by(x::Tuple) = map(_by, x)
_by(x::AbstractRange) = first(x)
_by(x::IntervalSets.Interval) = x.left
_by(x) = x

_in(needle::Dates.AbstractTime, haystack::Dates.AbstractTime) = needle == haystack
_in(needle, haystack) = needle in haystack
_in(needles::Tuple, haystacks::Tuple) = all(map(_in, needles, haystacks))
_in(needle::Interval, haystack::ClosedInterval) = needle.left in haystack && needle.right in haystack
_in(needle::Interval{<:Any,:open}, haystack::Interval{:closed,:open}) = needle.left in haystack && needle.right in haystack
_in(needle::Interval{:open,<:Any}, haystack::Interval{:open,:closed}) = needle.left in haystack && needle.right in haystack
_in(needle::OpenInterval, haystack::OpenInterval) = needle.left in haystack && needle.right in haystack

@inline hasselection(lookup::Lookup, sel::At) = at(lookup, sel; err=_False()) === nothing ? false : true
@inline hasselection(lookup::Lookup, sel::Contains) = contains(lookup, sel; err=_False()) === nothing ? false : true
# Near and Between only fail on Unordered
# Otherwise Near returns the nearest index, and Between an empty range
@inline hasselection(lookup::Lookup, ::Near) = isordered(lookup) ? true : false
@inline hasselection(lookup::Lookup, ::Union{Interval,Between}) = isordered(lookup) ? true : false

using DimensionalData, Test, Unitful, BenchmarkTools
using DimensionalData.Lookups, DimensionalData.Dimensions

@dim TestDim "Testname"

@testset "dims creation macro" begin
    @test parent(TestDim(1:10)) == 1:10
    @test val(TestDim(1:10)) == 1:10
    @test name(TestDim) == :TestDim
    @test val(TestDim(:testval)) == :testval
    @test metadata(TestDim(Sampled(1:1; metadata=Metadata(a=1)))) == Metadata(a=1)
    @test units(TestDim) == nothing
    @test label(TestDim) == "Testname"
    @test label(TestDim()) == "Testname"
    @test eltype(TestDim(1)) == Int
    @test eltype(TestDim([1, 2, 3])) <: Int
    @test length(TestDim(1)) == 1
    @test length(TestDim([1, 2, 3])) == 3
    @test eachindex(TestDim(10:10:30)) == Base.OneTo(3)
    @test eachindex(TestDim(1)) == Base.OneTo(1)
    @test step(TestDim(1:2:3)) == 2
    @test step(TestDim(Base.OneTo(10))) == 1
    @test step(TestDim(1:2:3)) == 2
    @test step(TestDim(Sampled(1:2:3; span=Regular(2)))) == 2
    @test first(TestDim(5)) == 5
    @test last(TestDim(5)) == 5
    @test first(TestDim(10:20)) == 10
    @test last(TestDim(10:20)) == 20
    @test firstindex(TestDim(5)) == 1
    @test lastindex(TestDim(5)) == 1
    @test firstindex(TestDim(10:20)) == 1
    @test lastindex(TestDim(10:20)) == 11
    @test eachindex(TestDim(10:20)) == Base.OneTo(11)
    @test size(TestDim(10:20)) == (11,)
    @test ndims(TestDim(10:20)) == 1
    @test ndims(TestDim(1)) == 0
    @test Array(TestDim(10:15)) == [10, 11, 12, 13, 14, 15]
    @test iterate(TestDim(10:20)) == iterate(10:20)
    @test TestDim(5.0:7.0)[2] == 6.0
    @test TestDim(10)[] == 10
    @test TestDim(Sampled(5.0:7.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))[At(6.0)] == 6.0
end

@testset "name" begin
    @test name(X()) == :X
    @test name(Dim{:x}) == :x
    @test name(TestDim()) == :TestDim
    @test name(Dim{:test}()) == :test
    @test (@ballocated name(Dim{:test}())) == 0
    @test name(Val{TimeDim}()) == :TimeDim
end

@testset "format" begin
    A = [1 2 3; 4 5 6]
    @test format((X, Y), A) == (X(NoLookup(Base.OneTo(2))), Y(NoLookup(Base.OneTo(3))))
    @test format(Ti, zeros(3)) == (Ti(NoLookup(Base.OneTo(3))),)
    @test format((:a, :b), A) == (Dim{:a}(NoLookup(Base.OneTo(2))),
                                  Dim{:b}(NoLookup(Base.OneTo(3))))
    @test format(:c, 51:100) == (Dim{:c}(NoLookup(Base.OneTo(50))),)
    @test format((a=[:A, :B], b=(10.0:10.0:30.0)), A) ==
        (Dim{:a}(Categorical([:A, :B], ForwardOrdered(), NoMetadata())),
         Dim{:b}(Sampled(10.0:10:30.0, ForwardOrdered(), Regular(10.0), Points(), NoMetadata())))
    @test format((X([:A, :B]; metadata=Metadata(a=5)),
           Y(Categorical(10.0:10.0:30.0, ForwardOrdered(), Metadata("metadata"=>1)))), A) ==
          (X(Categorical([:A, :B], ForwardOrdered(), Metadata(a=5))),
           Y(Categorical(10.0:10.0:30.0, ForwardOrdered(), Metadata("metadata"=>1))))
    @test format((X(Sampled(Base.OneTo(2); order=ForwardOrdered(), span=Regular(), sampling=Points())), Y), A) == 
        (X(Sampled(Base.OneTo(2), ForwardOrdered(), Regular(1), Points(), NoMetadata())), 
         Y(NoLookup(Base.OneTo(3))))
end

@testset "Val" begin
    @test dims(Val{X}()) == Val{X}()
    @test lookup(Val{X}()) == NoLookup()
end

@testset "AnonDim" begin
    @test val(AnonDim()) == Colon()
    @test lookup(AnonDim(NoLookup())) == NoLookup()
    @test metadata(AnonDim()) == NoMetadata()
    @test name(AnonDim()) == :AnonDim
end

@testset "Basic dim and array initialisation and methods" begin
    a = ones(5, 4)

    @test_throws DimensionMismatch DimArray(a, X)
    @test_throws DimensionMismatch DimArray(a, (X, Y, Z))

    da = DimArray(a, (X(LinRange(140, 148, 5)), Y(LinRange(2, 11, 4))))
    dimz = dims(da)

    for args in ((dimz,), 
                 (dimz, (X(), Y())), 
                 (dimz, X(), Y()), 
                 (dimz, (X, Y)) , 
                 (dimz, X, Y), 
                 (dimz, (1, 2)), 
                 (dimz, 1, 2)
        )
        @test name(args...) == (:X, :Y)
        @test units(args...) == (nothing, nothing)
        @test label(args...) == ("X", "Y")
        @test sampling(args...) == (Points(), Points())
        @test span(args...) == (Regular(2.0), Regular(3.0))
        @test locus(args...) == (Center(), Center())
        @test order(args...) == (ForwardOrdered(), ForwardOrdered())
        @test bounds(args...) == ((140, 148), (2, 11))
        @test lookup(args...) == (Sampled(LinRange(140, 148, 5), ForwardOrdered(), Regular(2.0), Points(), NoMetadata()), 
                                Sampled(LinRange(2, 11, 4), ForwardOrdered(), Regular(3.0), Points(), NoMetadata()))
    end

    @test val(dimz, ()) == ()
    @test val(dimz, 1) == val(dimz, X) == val(dimz, X()) == val(dimz[1])

    @test dims(dimz, Y) === dimz[2]
    @test slicedims(dimz, (2:4, 3)) ==
        ((X(Sampled(LinRange(142, 146, 3), ForwardOrdered(), Regular(2.0), Points(), NoMetadata())),),
         (Y(Sampled(LinRange(8.0, 8.0, 1), ForwardOrdered(), Regular(3.0), Points(), NoMetadata())),))

    @test lookup(X) == NoLookup()
end

@testset "repeating dims of the same type is allowed" begin
    dimz = X((143, 145)), X((-38, -35))
    @test dims(dimz, X) === dimz[1]
    @test dims(dimz, (X, X)) === dimz
    @test dimnum(dimz, (X, X)) === (1, 2)
    @test hasdim(dimz, (X, X)) === (true, true)
    @test sortdims(dimz, (X, X)) === dimz
end

@testset "constructing with keywords" begin
    @test X(1; foo=:bar) == X(DimensionalData.AutoVal(1, (; foo=:bar)))
    @test X(1:10; foo=:bar) == X(DimensionalData.AutoLookup(1:10, (; foo=:bar)))
    @test Dim{:x}(1; foo=:bar) == Dim{:x}(DimensionalData.AutoVal(1, (; foo=:bar)))
    @test Dim{:x}(1:10; foo=:bar) == Dim{:x}(DimensionalData.AutoLookup(1:10, (; foo=:bar)))
end

@testset "applying function on a dimension" begin
    d = X(0:0.01:2π)
    a = DimArray(cos, d)
    @test length(dims(a)) == 1
    @test typeof(dims(a)[1]) <: X
    @test a.data == cos.(d.val)
end

@testset "dims(::Array) is nothing" begin
    sz = ntuple(identity, 4)
    @testset for ndims in eachindex(sz)
        @test isnothing(dims(randn(sz[1:ndims])))
    end
end

using DimensionalData, Statistics, Test, Unitful, SparseArrays, Dates
using DimensionalData.Lookups, DimensionalData.Dimensions
using JLArrays
using LinearAlgebra: Transpose
using GPUArrays

GPUArrays.allowscalar(false)

xs = (1, X, X(), :X)
ys = (2, Y, Y(), :Y)
xys = ((1, 2), (X, Y), (X(), Y()), (:X, :Y), (:X, :Y))

@testset "map" begin
    a = [1 2; 3 4]
    dimz = X(143:2:145), Y(Sampled(-38:2:-36; span=Explicit([-38 -36; -36 -34])))
    da = DimArray(a, dimz)
    @test map(x -> 2x, da) == [2 4; 6 8]
    @test map(x -> 2x, da) isa DimArray{Int64,2}
    @test map(*, da, da) == [1 4; 9 16]
    @test map(*, da, da) isa DimArray{Int64,2}
end

@testset "JLArray map" begin
    a = JLArray([1 2; 3 4])
    dimz = X(143:2:145), Y(Sampled(-38:2:-36; span=Explicit([-38 -36; -36 -34])))
    da = DimArray(a, dimz)
    @test Array(map(x -> 2x, da)) == [2 4; 6 8]
    @test map(x -> 2x, da) isa DimArray{Int64,2}
    @test Array(map(*, da, da)) == [1 4; 9 16]
    @test map(*, da, da) isa DimArray{Int64,2}
end

@testset "dimension reducing methods" begin

    # Test some reducing methods with Explicit spans
    a = [1 2; 3 4]
    dimz = X(143:2:145), Y(Sampled(-38:2:-36; span=Explicit([-38 -36; -36 -34])))
    da = DimArray(a, dimz)

    # Test all dime combinations with maxium
    for dims in xs
        @test sum(da; dims) == [4 6]
        @test minimum(da; dims) == [1 2]

        testdims = (X(Sampled(144.0:2.0:144.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())),
                    Y(Sampled(-38:2:-36, ForwardOrdered(), Explicit([-38 -36; -36 -34]), Intervals(Center()), NoMetadata())))
        @test typeof(DimensionalData.dims(minimum(da; dims))) == typeof(testdims)
        @test val.(span(minimum(da; dims))) == val.(span(testdims))
    end
    for dims in ys
        @test minimum(da; dims) == [1 3]'
        @test maximum(da; dims) == [2 4]'
        @test maximum(x -> 2x, da; dims) == [4 8]'
        testdims = (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:4.0:-37.0, ForwardOrdered(), Explicit(reshape([-38, -34], 2, 1)), Intervals(Center()), NoMetadata())))
        @test typeof(DimensionalData.dims(sum(da; dims))) == typeof(testdims)
        @test lookup(sum(da; dims)) == lookup.(testdims)
        @test val.(span(sum(da; dims))) == val.(span(testdims))
    end
    for dims in xys
        @test maximum(da; dims) == [4]'
        @test maximum(x -> 2x, da; dims) == [8]'
    end

    @test minimum(da; dims=:) == 1
    @test maximum(da; dims=:) == 4
    @test sum(da; dims=:) == 10
    @test sum(x -> 2x, da; dims=:) == 20

    a = [1 2; 3 4]
    dimz = X(143:2:145), Y(-38:2:-36)
    da = DimArray(a, dimz)

    @test reduce(+, da) == reduce(+, a)
    @test mapreduce(x -> x > 3, +, da; dims=:) == 1
    @test std(da) === std(a)

    for dims in xs
        @test prod(da; dims) == [3 8]
        @test mean(da; dims) == [2.0 3.0]
        @test mean(x -> 2x, da; dims) == [4.0 6.0]
        @test reduce(+, da; dims) == [4 6]
        @test mapreduce(x -> x > 3, +, da; dims) == [0 1]
        @test var(da; dims) == [2.0 2.0]
        @test std(da; dims) == [1.4142135623730951 1.4142135623730951]
        @test extrema(da; dims) == [(1, 3) (2, 4)]
        resultdimz =
            (X(Sampled(144.0:2.0:144.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())),
             Y(Sampled(-38:2:-36, ForwardOrdered(), Regular(2), Points(), NoMetadata())))
        @test typeof(DimensionalData.dims(prod(da; dims))) == typeof(resultdimz)
        @test bounds(DimensionalData.dims(prod(da; dims))) == bounds(resultdimz)
    end
    for dims in ys
        @test prod(da; dims=2) == [2 12]'
        @test mean(da; dims) == [1.5 3.5]'
        @test mean(x -> 2x, da; dims) == [3.0 7.0]'
        @test DimensionalData.dims(mean(da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:4.0:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test DimensionalData.dims(reduce(+, da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:2.0:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test DimensionalData.dims(mapreduce(x -> x > 3, +, da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:2:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test std(da; dims) == [0.7071067811865476 0.7071067811865476]'
        @test var(da; dims) == [0.5 0.5]'
        @test DimensionalData.dims(var(da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:4.0:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test extrema(da; dims) == permutedims([(1, 2) (3, 4)])
    end
    for dims in xys
        @test mean(da; dims) == [2.5]'
        @test mean(x -> 2x, da; dims) == [5.0]'
        @test reduce(+, da; dims) == [10]'
        @test mapreduce(x -> x > 3, +, da; dims)  == [1]'
        @test extrema(da; dims) == reshape([(1, 4)], 1, 1)
    end

    # Test errors on invalid dimensions. These specific methods are chosen
    # because they're each defined slightly differently (see
    # src/array/methods.jl).
    @test_throws ArgumentError sum(da; dims=Z)
    @test_throws ArgumentError std(da; dims=Z)
    @test_throws ArgumentError median(da; dims=Z)

    a = [1 2 3; 4 5 6]
    dimz = X(143:2:145), Y(-38:-36)
    da = DimArray(a, dimz)
    @test @inferred median(da) == 3.5
    @test @inferred median(da; dims=X()) == [2.5 3.5 4.5]
    @test @inferred median(da; dims=2) == [2.0 5.0]'

    a = Bool[0 1 1; 0 0 0]
    da = DimArray(a, dimz)
    @test any(da) === true
    @test any(da; dims=Y) == reshape([true, false], 2, 1)
    @test all(da) === false
    @test all(da; dims=Y) == reshape([false, false], 2, 1)
    @test all(da; dims=(X, Y)) == reshape([false], 1, 1)

    @testset "inference" begin
        x = DimArray(randn(2, 3, 4), (X, Y, Z));
        foo(x) = maximum(x; dims=(X, Y))
        # TODO: this test recently broke
        # @inferred foo(x)
    end
end

@testset "JLArray dimension reducing methods" begin

    # Test some reducing methods with Explicit spans
    a = JLArray([1 2; 3 4])
    dimz = X(143:2:145), Y(Sampled(-38:2:-36; span=Explicit([-38 -36; -36 -34])))
    da = DimArray(a, dimz)

    # Test all dime combinations with maxium
    for dims in xs
        @test Array(sum(da; dims)) == [4 6]
        @test Array(minimum(da; dims)) == [1 2]

        testdims = (X(Sampled(144.0:2.0:144.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())),
                    Y(Sampled(-38:2:-36, ForwardOrdered(), Explicit([-38 -36; -36 -34]), Intervals(Center()), NoMetadata())))
        @test typeof(DimensionalData.dims(minimum(da; dims))) == typeof(testdims)
        # @test val.(span(minimum(da; dims))) == val.(span(testdims))
    end
    for dims in ys
        @test Array(minimum(da; dims)) == [1 3]'
        @test Array(maximum(da; dims)) == [2 4]'
        @test Array(maximum(x -> 2x, da; dims)) == [4 8]'
        testdims = (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:4.0:-37.0, ForwardOrdered(), Explicit(reshape([-38, -34], 2, 1)), Intervals(Center()), NoMetadata())))
        @test typeof(DimensionalData.dims(sum(da; dims))) == typeof(testdims)
        @test lookup(sum(da; dims)) == lookup.(testdims)
        # @test val.(span(sum(da; dims))) == val.(span(testdims))
    end
    for dims in xys
        @test Array(maximum(da; dims)) == [4]'
        @test Array(maximum(x -> 2x, da; dims)) == [8]'
    end

    @test minimum(da; dims=:) == 1
    @test maximum(da; dims=:) == 4
    @test sum(da; dims=:) == 10
    @test sum(x -> 2x, da; dims=:) == 20

    a = JLArray([1 2; 3 4])
    dimz = X(143:2:145), Y(-38:2:-36)
    da = DimArray(a, dimz)

    @test reduce(+, da) == reduce(+, a)
    @test mapreduce(x -> x > 3, +, da; dims=:) == 1
    @test std(da) === std(a)

    for dims in xs
        @test Array(prod(da; dims)) == [3 8]
        @test Array(mean(da; dims)) == [2.0 3.0]
        @test Array(mean(x -> 2x, da; dims)) == [4.0 6.0]
        @test Array(reduce(+, da; dims)) == [4 6]
        @test Array(mapreduce(x -> x > 3, +, da; dims)) == [0 1]
        @test Array(var(da; dims)) == [2.0 2.0]
        @test Array(std(da; dims)) == [1.4142135623730951 1.4142135623730951]
        @test Array(extrema(da; dims)) == [(1, 3) (2, 4)]
        resultdimz =
            (X(Sampled(144.0:2.0:144.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())),
             Y(Sampled(-38:2:-36, ForwardOrdered(), Regular(2), Points(), NoMetadata())))
        @test typeof(DimensionalData.dims(prod(da; dims))) == typeof(resultdimz)
        @test bounds(DimensionalData.dims(prod(da; dims))) == bounds(resultdimz)
    end
    for dims in ys
        @test Array(prod(da; dims=2)) == [2 12]'
        @test Array(mean(da; dims)) == [1.5 3.5]'
        @test Array(mean(x -> 2x, da; dims)) == [3.0 7.0]'
        @test DimensionalData.dims(mean(da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:4.0:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test DimensionalData.dims(reduce(+, da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:2.0:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test DimensionalData.dims(mapreduce(x -> x > 3, +, da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:2:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test Array(std(da; dims)) == [0.7071067811865476 0.7071067811865476]'
        @test Array(var(da; dims)) == [0.5 0.5]'
        @test DimensionalData.dims(var(da; dims)) ==
            (X(Sampled(143:2:145, ForwardOrdered(), Regular(2), Points(), NoMetadata())),
             Y(Sampled(-37.0:4.0:-37.0, ForwardOrdered(), Regular(4.0), Points(), NoMetadata())))
        @test Array(extrema(da; dims)) == permutedims([(1, 2) (3, 4)])
    end
    for dims in xys
        @test Array(mean(da; dims=dims)) == [2.5]'
        @test Array(mean(x -> 2x, da; dims=dims)) == [5.0]'
        @test Array(reduce(+, da; dims)) == [10]'
        @test Array(mapreduce(x -> x > 3, +, da; dims))  == [1]'
        @test Array(extrema(da; dims)) == reshape([(1, 4)], 1, 1)
    end

    a = JLArray([1 2 3; 4 5 6])
    dimz = X(143:2:145), Y(-38:-36)
    da = DimArray(a, dimz)
    @test @inferred median(da) == 3.5
    # median along a dimension doesn't have a gpu implementation
    @test_broken @inferred Array(median(da; dims=X())) == [2.5 3.5 4.5]
    @test_broken @inferred Array(median(da; dims=2)) == [2.0 5.0]'

    a = JLArray(Bool[0 1 1; 0 0 0])
    da = DimArray(a, dimz);
    @test_broken any(da) === true # This is broken because GPUArrays didn't support any(da, dims=:) only any(da)
    @test_broken any(da; dims=Y) == reshape([true, false], 2, 1)
    @test_broken all(da) === false
    @test_broken all(da; dims=Y) == reshape([false, false], 2, 1)
    @test_broken all(da; dims=(X, Y)) == reshape([false], 1, 1)

    @testset "inference" begin
        x = DimArray(randn(2, 3, 4), (X, Y, Z));
        foo(x) = maximum(x; dims=(1, 2))
        # TODO: this test recently broke
        # @inferred foo(x)
    end
end

@testset "dimension dropping methods" begin
    a = [1 2 3; 4 5 6]
    dimz = X(143:2:145), Y(-38:-36)
    da = DimArray(a, dimz)
    # Dimensions must have length 1 to be dropped
    @test dropdims(da[X(1:1)]; dims=X) == [1, 2, 3]
    @test dropdims(da[2:2, 1:1]; dims=(X(), Y()))[] == 4
    @test typeof(dropdims(da[2:2, 1:1]; dims=(X(), Y()))) <: DimArray{Int,0,Tuple{}}
    @test refdims(dropdims(da[X(1:1)]; dims=X)) == 
        (X(Sampled(143:2:143, ForwardOrdered(), Regular(2), Points(), NoMetadata())),)
    dropped = dropdims(da[X(1:1)]; dims=X)
    @test dropped[1:2] == [1, 2]
    @test length.(dims(dropped[1:2])) == size(dropped[1:2])
end

@testset "JLArray dimension dropping methods" begin
    a = JLArray([1 2 3; 4 5 6])
    dimz = X(143:2:145), Y(-38:-36)
    da = DimArray(a, dimz);
    # Dimensions must have length 1 to be dropped
    @test Array(dropdims(da[X(1:1)]; dims=X)) == [1, 2, 3]
    @test Array(dropdims(da[2:2, 1:1]; dims=(X(), Y())))[] == 4
    @test typeof(dropdims(da[2:2, 1:1]; dims=(X(), Y()))) <: DimArray{Int,0,Tuple{}}
    @test refdims(dropdims(da[X(1:1)]; dims=X)) == 
        (X(Sampled(143:2:143, ForwardOrdered(), Regular(2), Points(), NoMetadata())),)
    dropped = dropdims(da[X(1:1)]; dims=X)
    @test Array(dropped[1:2]) == [1, 2]
    @test length.(dims(dropped[1:2])) == size(dropped[1:2])
end

@testset "eachslice" begin
    a = [1 2 3 4
         3 4 5 6
         5 6 7 8]
    y = Y(10:10:30)
    ti = Ti(1:4)
    da = DimArray(a, (y, ti))
    ys = (1, Y, Y(), :Y, y)
    ys2 = (ys..., map(tuple, ys)...)
    tis = (2, Ti, Ti(), :Ti, ti)
    tis2 = (tis..., map(tuple, tis)...)

    @testset "type-inferrable due to const-propagation" begin
        f(x, dims) = eachslice(x; dims=dims)
        f2(x, dims) = eachslice(x; dims=dims, drop=false)
        @testset for dims in (y, ti, (y,), (ti,), (y, ti), (ti, y))
            @inferred f(da, dims)
            @inferred f2(da, dims)
        end
    end

    @testset "error thrown if dimensions invalid" begin
        @test_throws DimensionMismatch eachslice(da; dims=3)
        @test_throws DimensionMismatch eachslice(da; dims=X)
        @test_throws DimensionMismatch eachslice(da; dims=(4,))
        @test_throws DimensionMismatch eachslice(da; dims=(Z,))
        @test_throws DimensionMismatch eachslice(da; dims=(y, ti, Z))
    end

    @testset "slice over last dimension" begin
        @testset for dims in tis2
            da2 = map(mean, eachslice(da; dims=dims)) == DimArray([3.0, 4.0, 5.0, 6.0], ti)
            slices = map(x -> x*2, eachslice(da; dims=dims))
            @test slices isa DimArray
            @test Dimensions.dims(slices) == (ti,)
            @test slices[1] == DimArray([2, 6, 10], y)
            @test eachslice(da; dims=dims) isa Slices
            slices = eachslice(da; dims=dims, drop=false)
            @test slices isa Slices
            @test slices == eachslice(parent(da); dims=dimnum(da, dims), drop=false)
            @test axes(slices) == axes(sum(da; dims=otherdims(da, Dimensions.dims(da, dims))))
            @test slices[1] == DimArray([1, 3, 5], y)
            
        end
    end

    @testset "slice over first dimension" begin
        @testset for dims in ys2
            slices = map(x -> x*2, eachslice(da; dims=dims))
            @test slices isa DimArray
            @test Dimensions.dims(slices) == (y,)
            @test slices[1] == DimArray([2, 4, 6, 8], ti)
            @test slices[2] == DimArray([6, 8, 10, 12], ti)
            @test slices[3] == DimArray([10, 12, 14, 16], ti)
            @test eachslice(da; dims=dims) isa Slices
            slices = eachslice(da; dims=dims, drop=false)
            @test slices isa Slices
            @test slices == eachslice(parent(da); dims=dimnum(da, dims), drop=false)
            @test axes(slices) == axes(sum(da; dims=otherdims(da, Dimensions.dims(da, dims))))
            @test slices[1] == DimArray([1, 2, 3, 4], ti)
        
        end
    end

    @testset "slice over all permutations of both dimensions" begin
        @testset for dims in Iterators.flatten((Iterators.product(ys, tis), Iterators.product(tis, ys)))
            # mixtures of integers and dimensions are not supported
            rem(sum(d -> isa(d, Int), dims), length(dims)) == 0 || continue
            slices = map(x -> x*3, eachslice(da; dims=dims))
            @test slices isa DimArray
            @test Dimensions.dims(slices) == Dimensions.dims(da, dims)
            @test size(slices) == map(x -> size(da, x), dims)
            @test axes(slices) == map(x -> axes(da, x), dims)
            @test eltype(slices) <: DimArray{Int, 0}
            @test map(first, slices) == permutedims(da * 3, dims)
            @test eachslice(da; dims=dims) isa Slices
            slices = eachslice(da; dims=dims, drop=false)
            @test slices isa Slices
            @test slices == eachslice(parent(da); dims=dimnum(da, dims), drop=false)
            @test axes(slices) == axes(sum(da; dims=otherdims(da, Dimensions.dims(da, dims))))
        
        end
    end
    @testset "eachslice with empty tuple dims" begin
        A = rand(X(10))
        @test ndims(eachslice(A; dims=())) == 0
    end
end

@testset "simple dimension permuting methods" begin
    da = DimArray(zeros(5, 4), (Y(LinRange(10, 20, 5)), X(1:4)))
    tda = @inferred transpose(da)
    @test tda == transpose(parent(da))
    resultdims = (X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
                  Y(Sampled(LinRange(10.0, 20.0, 5), ForwardOrdered(), Regular(2.5), Points(), NoMetadata())))
    @test typeof(dims(tda)) == typeof(resultdims) 
    @test dims(tda) == resultdims
    @test size(tda) == (4, 5)

    tda = @inferred Transpose(da)
    @test tda == Transpose(parent(da))
    @test dims(tda) == (X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
                        Y(Sampled(LinRange(10.0, 20.0, 5), ForwardOrdered(), Regular(2.5), Points(), NoMetadata())))
    @test size(tda) == (4, 5)
    @test typeof(tda) <: DimArray

    ada = @inferred adjoint(da)
    @test ada == adjoint(parent(da))
    @test dims(ada) == (X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
                        Y(Sampled(LinRange(10.0, 20.0, 5), ForwardOrdered(), Regular(2.5), Points(), NoMetadata())))
    @test size(ada) == (4, 5)

    dsp = @inferred permutedims(da)
    @test permutedims(parent(da)) == parent(dsp)
    @test dims(dsp) == reverse(dims(da))
end

@testset "dimension permuting methods with specified permutation" begin
    da = DimArray(ones(5, 2, 4), (Y(LinRange(10, 20, 5)), Ti(10:11), X(1:4)))
    dsp = permutedims(da, [3, 1, 2])
    @test permutedims(da, [X, Y, Ti]) == permutedims(da, (X, Y, Ti))
    @test permutedims(da, [X(), Y(), Ti()]) == permutedims(da, (X(), Y(), Ti()))
    dsp = @inferred permutedims(da, (X(), Y(), Ti()))
    @test dsp == permutedims(parent(da), (3, 1, 2))
    @test dims(dsp) == (X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
                        Y(Sampled(LinRange(10.0, 20.0, 5), ForwardOrdered(), Regular(2.5), Points(), NoMetadata())),
                        Ti(Sampled(10:11, ForwardOrdered(), Regular(1), Points(), NoMetadata())))

    dsp = PermutedDimsArray(da, (3, 1, 2))
    @test dsp == PermutedDimsArray(parent(da), (3, 1, 2))
    @test typeof(dsp) <: DimArray

    dims_perm = dims(da, (3, 2, 1))
    dsp2 = @inferred PermutedDimsArray(da, dims_perm)
    @test dsp2 == PermutedDimsArray(parent(da), (3, 2, 1))
    @test typeof(dsp2) <: DimArray
end

@testset "dimension rotating methods" begin
    da = DimArray([1 2; 3 4], (X([:a, :b]), Y([1.0, 2.0])))

    l90 = @inferred rotl90(da)
    r90 = @inferred rotr90(da)
    r180_1 = @inferred rot180(da)
    r180_2 = rotl90(da, 2)
    r180_3 = rotr90(da, 2)
    r270 = rotl90(da, 3)
    r270_2 = rotl90(da, -1)
    r360 = rotr90(da, 4)
    r360_2 = rotr90(da, 40)

    da[X(At(:a)), Y(At(2.0))]
    @test l90[X(At(:a)), Y(At(2.0))] == 2
    @test r90[X(At(:a)), Y(At(2.0))] == 2
    @test r180_1[X(At(:a)), Y(At(2.0))] == 2
    @test r180_2[X(At(:a)), Y(At(2.0))] == 2
    @test r180_3[X(At(:a)), Y(At(2.0))] == 2
    @test r270[X(At(:a)), Y(At(2.0))] == 2
    @test r270_2[X(At(:a)), Y(At(2.0))] == 2
    @test r360[X(At(:a)), Y(At(2.0))] == 2
    @test r360_2[X(At(:a)), Y(At(2.0))] == 2

end

@testset "dimension mirroring methods" begin
    a = rand(5, 4)
    da = DimArray(a, (Y(LinRange(10, 20, 5)), X(1:4)))
    xs = (X, X(), :X)
    ys = (Y, Y(), :Y)
    for dims in xs
        cvda = cov(da; dims)
        @test cvda == cov(a; dims=2)
        @test DimensionalData.dims(cvda) == 
            (Y(Sampled(LinRange(10.0, 20.0, 5), ForwardOrdered(), Regular(2.5), Points(), NoMetadata())),
             Y(Sampled(LinRange(10.0, 20.0, 5), ForwardOrdered(), Regular(2.5), Points(), NoMetadata())))
    end
    for dims in ys
        crda = cor(da; dims)
        @test crda == cor(a; dims=1)
        @test DimensionalData.dims(crda) == 
            (X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())),
             X(Sampled(1:4, ForwardOrdered(), Regular(1), Points(), NoMetadata())))
    end
end

@testset "mapslices" begin
    a = [1 2 3 4
         3 4 5 6
         5 6 7 8]
    y = Y(Sampled(10:10:30; sampling=Intervals())) 
    ti = Ti(Sampled(1:4; sampling=Intervals()))
    da = DimArray(a, (y, ti))
    ys = (1, Y, Y(), :Y, y)
    tis = (2, Ti, Ti(), :Ti, ti)
    for dims in ys
        ms = mapslices(sum, da; dims)
        @test ms == [9 12 15 18]
        @test DimensionalData.dims(ms) == 
            (Y(NoLookup(Base.OneTo(1))), Ti(Sampled(1:4, ForwardOrdered(), Regular(1), Intervals(Start()), NoMetadata())))
        @test refdims(ms) == ()
    end
    for dims in tis
        ms = mapslices(sum, da; dims)
        @test parent(ms) == [10 18 26]'
    end

    @testset "size changes" begin
        x = DimArray(randn(4, 100, 2), (:chain, :draw, :x_dim_1));
        y = mapslices(vec, x; dims=(:chain, :draw))
        @test size(y) == size(dims(y))
        x = rand(X(1:10), Y([:a, :b, :c]), Ti(10))
        y = mapslices(sum, x; dims=(X, Y))
        @test size(y) == size(dims(y))
        @test dims(y) == (X(NoLookup(Base.OneTo(1))), Y(NoLookup(Base.OneTo(1))), Ti(NoLookup(Base.OneTo(10))))

        y = mapslices(A -> A[2:9, :], x; dims=(X, Y))
        @test size(y) == size(dims(y))
        @test dims(y) == dims(x[2:9, :, :])
    end

    @testset "single dim" begin
        x = X(1:10)
        A = DimArray(ones(10), x)
        @test mapslices(sum, A; dims=X) == fill(10.0, X(1))
    end
end

@testset "cumsum" begin
    v = DimArray([10:-1:1...], X)
    @test cumsum(v) == cumsum(parent(v))
    @test dims(cumsum(v)) == dims(v)
    A = rand((X(5:-1:1), Y(11:15)))
    @test cumsum(A; dims=X) == cumsum(parent(A); dims=1)
    @test dims(cumsum(A; dims=X)) == dims(A)
end

@testset "cumsum!" begin
    v = DimArray([10:-1:1...], X)
    @test cumsum!(copy(v), v) == cumsum(parent(v))
    A = rand((X(5:-1:1), Y(11:15)))
    @test cumsum!(copy(A), A; dims=X) == cumsum(parent(A); dims=1)
end

@testset "sort" begin
    v = DimArray([10:-1:1...], X)
    @test sort(v) == sort(parent(v))
    @test dims(sort(v)) == (X(NoLookup(Base.OneTo(10))),)
    A = rand((X(5:-1:1), Y(11:15)))
    @test sort(A; dims=X) == sort(parent(A); dims=1)
    @test dims(sort(A; dims=X)) == (X(NoLookup(Base.OneTo(5))), dims(A, Y)) 
end

@testset "sortslices" begin
    M = rand((X(5:-1:1), Y(11:15)))
    @test sortslices(M; dims=X) == sortslices(parent(M); dims=1)
    @test dims(sort(M; dims=X)) == (X(NoLookup(Base.OneTo(5))), dims(M, Y)) 
    M = rand((X(5:-1:1), Y(11:15), Ti(3:10)))
    @test sortslices(M; dims=(X, Y)) == sortslices(parent(M); dims=(1, 2))
    @test dims(sortslices(M; dims=(X, Y))) == (X(NoLookup(Base.OneTo(5))), Y(NoLookup(Base.OneTo(5))), dims(M, Ti))
end

@testset "cat" begin
    a = [1 2 3; 4 5 6]
    da = DimArray(a, (X(4.0:5.0), Y(6.0:8.0)))
    b = [7 8 9; 10 11 12]
    db = DimArray(b, (X(6.0:7.0), Y(6.0:8.0)))
    dc = DimArray(b, (X(6.0:7.0), Y(10.0:12.0)))
    dd = DimArray(b, (X(8.0:9.0), Y(6.0:8.0)))
    de = DimArray(b, (Z(6.0:7.0), Y(6.0:8.0)))

    @testset "Regular Sampled" begin
        @test cat(da, db; dims=X()) == [1 2 3; 4 5 6; 7 8 9; 10 11 12]
        @test_warn "Lookup values for Y" cat(da, dc; dims=X)
        @test_warn "" cat(da, dd; dims=X)
        @test_warn "Y and Z dims on the same axis" cat(da, de; dims=X)
        @test_throws DimensionMismatch vcat(dims(da, 1), dims(de, 1))
        testdims = (X(Sampled([4.0, 5.0, 6.0, 7.0], ForwardOrdered(), Regular(1.0), Points(), NoMetadata())),
                    Y(Sampled(6.0:8.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())))
        @test cat(da, db; dims=(X(),)) == cat(da, db; dims=X()) 
        @test cat(da, db; dims=X) == cat(da, db; dims=(X,)) == cat(da, db; dims=1) == cat(da, db; dims=(1,))
        @test dims(cat(da, db; dims=X)) == testdims
        @test val(dims(cat(da, db; dims=X))) == val(testdims)
        @test lookup(cat(da, db; dims=X)) == lookup(testdims)
        @test_warn "Lookup values for X" cat(da, db; dims=Y())
        @test cat(da, da; dims=Z(1:2)) == cat(a, a; dims=3)
        @test cat(da, da; dims=(Z(1:2), Ti(1:2))) == cat(a, a; dims=(3, 4))
        @test_warn "Lookup values for X" cat(da, db; dims=(Z(1:2), Ti(1:2)))
        @test cat(da, db; dims=(X(), Ti(1:2))) == cat(a, b; dims=(1, 3))
        dx = cat(da, db; dims=(X, Ti(1:2)))
        @test all(map(==, lookup(dx), lookup(DimensionalData.format((X([4.0, 5.0, 6.0, 7.0]; span=Regular(1.0)), Y(6:8), Ti(1:2)), dx))))
        @test_warn "lookups are mixed `ForwardOrdered` and `ReverseOrdered`" vcat(da, reverse(db; dims=X))
        @test_warn "lookups are misaligned" vcat(db, da)
        @testset "lookup array in dims" begin
            @test dims(cat(da, da; dims=Ti(1:2)), Ti) == Ti(Sampled(1:2, ForwardOrdered(), Regular(1), Points(), NoMetadata()))
            @test dims(cat(da, da; dims=Ti(Categorical(1:2))), Ti) == Ti(Categorical(1:2, ForwardOrdered(), NoMetadata()))
            # Categorical is taken from refdims
            dr1 = rebuild(da; refdims=(Z(Categorical([1], ForwardOrdered(), NoMetadata())),))
            dr2 = rebuild(da; refdims=(Z(Categorical([2], ForwardOrdered(), NoMetadata())),))
            @test dims(cat(dr1, dr2; dims=Z), Z) == Z(Categorical([1, 2], ForwardOrdered(), NoMetadata()))
        end
    end

    # https://github.com/rafaqz/DimensionalData.jl/issues/451
    @testset "dims passed as Symbols" begin
        Xcatdim = X(Sampled([4.0, 5.0, 6.0, 7.0], ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))
        da2 = DimArray(a, (X(4.0:5.0), :y))
        db2 = DimArray(b, (X(4.0:5.0), :y))
        @test cat(da2, db2; dims=:y) == cat(da2, db2; dims=Dim{:y}) == cat(da2, db2; dims=Dim{:y}())
        @test typeof(dims(cat(da2, db2; dims=:y))) === typeof(dims(da2))
        @test lookup(cat(da2, db2; dims=:y)) == (lookup(da2)[1], NoLookup(1:6))
        da3 = DimArray(a, (X(4.0:5.0), :y))
        db3 = DimArray(b, (X(6.0:7.0), :y))
        @test cat(da3, db3; dims=(X(), :y)) == cat(da3, db3; dims=(X(), Dim{:y}()))
        @test typeof(dims(cat(da3, db3; dims=(X, :y)))) === typeof((Xcatdim, dims(da3, :y)))
        @test lookup(cat(da3, db3; dims=(X, :y))) == (lookup(Xcatdim), 1:6)
    end

    @testset "Irregular Sampled" begin
        @testset "Intervals" begin
            d1 = X(Sampled([1, 3, 4], ForwardOrdered(), Irregular(1, 5), Intervals(), NoMetadata())) 
            d2 = X(Sampled([7, 8], ForwardOrdered(), Irregular(7, 9), Intervals(), NoMetadata()))
            iri_dim = vcat(d1, d2)
            @test span(iri_dim) == Irregular(1, 9)
            @test lookup(iri_dim) == [1, 3, 4, 7, 8]
            @test lookup(iri_dim) == Sampled([1, 3, 4, 7, 8], ForwardOrdered(), Irregular(1, 9), Intervals(), NoMetadata())
            @test bounds(lookup(iri_dim)) == (1, 9)
            @test_warn "lookups are mixed `ForwardOrdered` and `ReverseOrdered`" vcat(d1, reverse(d2))
            @test_warn "lookups are misaligned" vcat(d2, d1)
        end
        @testset "Points" begin
            d1 = X(Sampled([1, 3, 4], ForwardOrdered(), Irregular(1, 5), Points(), NoMetadata()))
            d2 = X(Sampled([7, 8], ForwardOrdered(), Irregular(7, 9), Points(), NoMetadata()))
            irp_dim = vcat(d1, d2)
            @test span(irp_dim) == Irregular(nothing, nothing)
            @test lookup(irp_dim) == [1, 3, 4, 7, 8]
            @test lookup(irp_dim) == Sampled([1, 3, 4, 7, 8], ForwardOrdered(), Irregular(nothing, nothing), Points(), NoMetadata())
            @test bounds(irp_dim) == (1, 8)
            @test_warn "lookups are mixed `ForwardOrdered` and `ReverseOrdered`" vcat(d1, reverse(d2))
            @test_warn "lookups are misaligned" vcat(d2, d1)
        end

        @testset "vcat time axis" begin
            t1 = Ti(DateTime(2000):Day(1):DateTime(2001)-Day(1))
            d1 = rand(t1)
            t2 = Ti(DateTime(2001):Day(1):DateTime(2002))
            d2 = rand(t2)
            t3 = Ti(DateTime(2001,3,1):Day(1):DateTime(2002))
            d3 = rand(t3)
            v = vcat(d1, d2)
            @test length(v) == 732
            @test v[1:366] == d1[:]
            @test v[367:end] == d2[:]
            @test_warn "lookups do not join with the correct step size" vcat(d1,d3)
        end
    end

    @testset "Explicit" begin
        d1 = X(Sampled([2, 3.5, 5], ForwardOrdered(), Explicit([1 3 4; 3 4 7]), Intervals(Center()), NoMetadata()))
        d2 = X(Sampled([7.5, 9], ForwardOrdered(), Explicit([7 8; 8 10]), Intervals(Center()), NoMetadata()))
        ed = vcat(d1, d2)
        @test span(ed) == Explicit([1 3 4 7 8; 3 4 7 8 10])
        @test lookup(ed) == [2, 3.5, 5, 7.5, 9] 
        @test lookup(ed) == Sampled([2, 3.5, 5, 7.5, 9], ForwardOrdered(), Explicit([1 3 4 7 8; 3 4 7 8 10]), Intervals(Center()), NoMetadata())
        @test_warn "lookups are mixed `ForwardOrdered` and `ReverseOrdered`" vcat(d1, reverse(d2))
        @test_warn "lookups are misaligned" vcat(d2, d1)
    end

    @testset "NoLookup" begin
        d1 = X(NoLookup(Base.OneTo(10)))
        d2 = X(NoLookup(Base.OneTo(10)))
        ni_dim = vcat(d1, d2)
        @test lookup(ni_dim) == NoLookup(Base.OneTo(20))
        # Order doesn't matter
        @test vcat(d2, d1) == ni_dim
        @test vcat(d1, reverse(d2)) == ni_dim
    end

    @testset "rebuild dim lookup from refdims" begin
        slices = map(i -> view(da, Y(i)), 1:3)
        cat_da = cat(slices...; dims=Y)
        @test all(cat_da .== da)
        # The range is rebuilt as a Vector during `cat`
        @test all(lookup(cat_da) .== (4.0:5.0, [6.0, 7.0, 8.0]))
        @test map(parent, lookup(cat_da)) isa Tuple{<:StepRangeLen,<:Vector{Float64}}
    end

    @testset "use lookup from dims" begin
        @test_warn "lookups are misaligned" cat(da, db; dims=2)
        @test dims(cat(da, db; dims=X()), X) === X(NoLookup(Base.OneTo(4)))
        @test dims(cat(da, db; dims=X(NoLookup())), X) === X(NoLookup(Base.OneTo(4)))
        @test dims(cat(da, db; dims=X(1.0:4.0)), X) === X(Sampled(1.0:4.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))
    end

    @testset "cat empty dimarrays" begin
        a = rand(X([1, 2, 3]))
        b = rand(X(Int64[]))
        c = cat(a, b; dims=X)
        @test c == a
        @test dims(c) == dims(a)
        a = rand(X(Int64[]; order=DimensionalData.ForwardOrdered()))
        b = rand(X([1, 2, 3]))
        c = cat(a, b; dims=X)
        @test c == b
        @test dims(c) == dims(b)
        a = rand(X(1:3))
        b = rand(X(4:0))
        c = cat(a, b; dims=X)
        @test c == a
        @test dims(c) == dims(a)
        a = rand(X(1:0))
        b = rand(X(1:3))
        c = cat(a, b; dims=X)
        @test c == b
        @test dims(c) == dims(b)
    end

    @testset "empty DimArrays" begin
        empty = rand(X(Int64[]))
        @test cat(empty, empty, dims=X) == empty
        empty = rand(X(Int64[]), Y(Int64[]))
        @test cat(empty, empty, dims=X) == empty
    end
end

@testset "vcat" begin
    @testset "1d" begin
        a = [1, 2]
        da = DimArray(a, X(4.0:5.0))
        b = [3, 4]
        db = DimArray(b, X(6.0:7.0))
        c = [5, 6]
        dc = DimArray(c, X(8.0:9.0))
        dd = DimArray(c, Y(8.0:9.0))

        @test vcat(da) isa DimArray{Int,1}
        @test vcat(da) == da
        @test dims(vcat(da)) == 
            dims(cat(da; dims=1)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())),)
        @test vcat(da, db) == cat(da, db; dims=1)
        @test dims(vcat(da, db)) == 
            dims(cat(da, db; dims=1)) ==
            (X(Sampled(4.0:7.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())),)
        @test_warn "X and Y dims on the same axis" hcat(da, dd)
        @test vcat(da, db, dc) == cat(da, db, dc; dims=1)
        @test dims(vcat(da, db, dc)) == 
            dims(cat(da, db, dc; dims=1)) ==
            (X(Sampled(4.0:9.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())),)
        @test_warn "do not match" hcat(da, db, dd)
    end

    @testset "2d" begin
        a = [1 2 3; 4 5 6]
        da = DimArray(a, (X(4.0:5.0), Y(6.0:8.0)))
        dims(da)
        b = [7 8 9; 10 11 12]
        db = DimArray(b, (X(6.0:7.0), Y(6.0:8.0)))
        c = [13 14 15; 16 17 18]
        dc = DimArray(c, (X(8.0:9.0), Y(6.0:8.0)))
        dd = DimArray(c, (X(8.0:9.0), Z(6.0:8.0)))

        @test vcat(da) == da
        @test dims(vcat(da)) == 
            dims(cat(da; dims=1)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), 
             Y(Sampled(6.0:8.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))) 
        @test vcat(da, db) == cat(da, db; dims=1)
        @test dims(vcat(da, db)) == 
            dims(cat(da, db; dims=1)) ==
            (X(Sampled(4.0:7.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), 
             Y(Sampled(6.0:8.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))) 
        @test_warn "lookups are misaligned" hcat(da, dd)
        @test vcat(da, db, dc) == cat(da, db, dc; dims=1)
        @test dims(vcat(da, db, dc)) == 
            dims(cat(da, db, dc; dims=1)) ==
            (X(Sampled(4.0:9.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), 
             Y(Sampled(6.0:8.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))) 
        @test_warn "lookups are misaligned" hcat(da, db, dd)
    end
end

@testset "hcat" begin
    @testset "1d" begin
        a = [1, 2]
        da = DimArray(a, X(4.0:5.0))
        b = [3, 4]
        db = DimArray(b, X(4.0:5.0))
        c = [5, 6]
        dc = DimArray(c, X(4.0:5.0))
        dd = DimArray(c, X(8.0:9.0))

        @test hcat(da) == permutedims([1 2])
        @test dims(hcat(da)) == 
            dims(cat(da; dims=2)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), AnonDim(NoLookup(Base.OneTo(1))))
        @test hcat(da, db) == cat(da, db; dims=2)
        @test dims(hcat(da, db)) == 
            dims(cat(da, db; dims=2)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), AnonDim(NoLookup(Base.OneTo(2))))
        @test_warn "do not match" hcat(da, dd)
        @test hcat(da, db, dc) == cat(da, db, dc; dims=2)
        @test dims(hcat(da, db, dc)) == 
            dims(cat(da, db, dc; dims=2)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), AnonDim(NoLookup(Base.OneTo(3))))
        @test_warn "do not match" hcat(da, db, dd)
    end
    @testset "2d" begin
        a = [1 2 3; 4 5 6]
        da = DimArray(a, (X(4.0:5.0), Y(6.0:8.0)))
        b = [7 8 9; 10 11 12]
        db = DimArray(b, (X(4.0:5.0), Y(9.0:11.0)))
        c = [13 14 15; 16 17 18]
        dc = DimArray(c, (X(4.0:5.0), Y(12.0:14.0)))
        dd = DimArray(c, (X(12.0:13.0), Y(12.0:14.0)))

        @test hcat(da) isa DimArray{Int,2}
        @test hcat(da) == da
        @test dims(hcat(da)) == 
            dims(cat(da; dims=2)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), 
             Y(Sampled(6.0:8.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))) 
        @test hcat(da, db) == cat(da, db; dims=2)
        @test dims(hcat(da, db)) == 
            dims(cat(da, db; dims=2)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), 
             Y(Sampled(6.0:11.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))) 
        @test_warn "do not join with the correct step size" hcat(da, dd)
        @test hcat(da, db, dc) == cat(da, db, dc; dims=2)
        @test dims(hcat(da, db, dc)) == dims(cat(da, db, dc; dims=2)) ==
            (X(Sampled(4.0:5.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata())), 
             Y(Sampled(6.0:14.0, ForwardOrdered(), Regular(1.0), Points(), NoMetadata()))) 
        @test_warn "do not match" hcat(da, db, dd)
    end
end

@testset "unique" begin
    a = [1 1 6; 1 1 6]
    xs = (X, X(), :X)
    ys = (Y, Y(), :Y)
    da = DimArray(a, (X(1:2), Y(1:3)))
    for dims in xs
        @test unique(da; dims) == [1 1 6]
    end
    for dims in ys
        @test unique(da; dims) == [1 6; 1 6]
    end
    @test unique(da; dims=:) == [1, 6]
    @test unique(da[X(1)]) == [1, 6]
end

@testset "diff" begin
    @testset "Array 2D" begin
        y = Y(['a', 'b', 'c'])
        ti = Ti(DateTime(2021, 1):Month(1):DateTime(2021, 4))
        ys = (1, Y, Y(), :Y, y)
        tis = (2, Ti, Ti(), :Ti, ti)
        data = [-87  -49  107  -18
                24   44  -62  124
                122  -11   48   -7]
        A = DimArray(data, (y, ti))
        for dims in ys
            @test diff(A; dims) == DimArray([111 93 -169 142; 98 -55 110 -131], (Y(['a', 'b']), ti))
        end
        for dims in tis
            @test diff(A; dims) == 
                DimArray([38 156 -125; 20 -106 186; -133 59 -55], (y, Ti(DateTime(2021, 1):Month(1):DateTime(2021, 3))))
        end
        @test_throws ArgumentError diff(A; dims='X')
        @test_throws ArgumentError diff(A; dims=Z)
        @test_throws ArgumentError diff(A; dims=3)
    end
    @testset "Vector" begin
        x = DimArray([56, -123, -60, -44, -64, 70, 52, -48, -74, 86], X(2:2:20))
        for dims in xs
            @test diff(x) == diff(x; dims) ==
                DimArray([-179, 63, 16, -20, 134, -18, -100, -26, 160], X(2:2:18))
        end
    end
end

@testset "mapreduce" begin
    @testset "Array 2D" begin
        y = Y(['a', 'b', 'c'])
        ti = Ti(DateTime(2021, 1):Month(1):DateTime(2021, 4))
        ys = (1, Y, Y(), :Y, y)
        tis = (2, Ti, Ti(), :Ti, ti)
        data = [-87  -49  107  -18
                24   44  -62  124
                122  -11   48   -7]
        A = DimArray(data, (y, ti))


        @test mapreduce(identity, +, A) ≈ mapreduce(identity, +, parent(A))
        @test mapreduce(x->x^3+5, +, A) ≈ mapreduce(x->x^3+5, +, parent(A))

        for dims in ys
            @test mapreduce(identity, +, A; dims) ≈ mapreduce(identity, +, parent(A); dims=1)
        end

        for dims in tis
            @test mapreduce(identity, +, A; dims) ≈ mapreduce(identity, +, parent(A); dims=2)
        end

        @test mapreduce(identity, +, A; dims=Y) ≈ mapreduce(identity, +, parent(A); dims=1)
        @test mapreduce(identity, +, A; dims=Ti) ≈ mapreduce(identity, +, parent(A); dims=2)
        @test mapreduce(identity, +, A; dims=(Y, Ti)) ≈ mapreduce(identity, +, parent(A); dims=(1, 2))

        init = 5.0
        @test mapreduce(identity, +, A; init) ≈ mapreduce(identity, +, parent(A); init)
        @test mapreduce(x->x^3+5, +, A; init) ≈ mapreduce(x->x^3+5, +, parent(A); init)
        @test mapreduce(identity, +, A; dims=Y, init) ≈ mapreduce(identity, +, parent(A); dims=1, init)
        @test mapreduce(identity, +, A; dims=Ti, init) ≈ mapreduce(identity, +, parent(A); dims=2, init)
        @test mapreduce(identity, +, A; dims=(Y, Ti), init) ≈ mapreduce(identity, +, parent(A); dims=(1, 2), init)
    end
    @testset "Vector" begin
        x = DimArray([56, -123, -60, -44, -64, 70, 52, -48, -74, 86], X(2:2:20))
        @test mapreduce(x->x^2, +, x) ≈ mapreduce(x->x^2, +, parent(x))
        @test mapreduce(identity, +, x) ≈ mapreduce(identity, +, parent(x))
        @test mapreduce(identity, +, x; dims=X) ≈ mapreduce(identity, +, parent(x); dims=1)
        @test mapreduce(x->x^2, +, x; dims=X) ≈ mapreduce(x->x^2, +, parent(x); dims=1)
        @test mapreduce(identity, +, x; init=5.0) ≈ mapreduce(identity, +, parent(x); init=5.0)
    end

    @testset "JLArray" begin
        y = Y(['a', 'b', 'c'])
        ti = Ti(DateTime(2021, 1):Month(1):DateTime(2021, 4))
        ys = (1, Y, Y(), :Y, y)
        tis = (2, Ti, Ti(), :Ti, ti)
        data = JLArray([-87  -49  107  -18
                24   44  -62  124
                122  -11   48   -7])
        A = DimArray(data, (y, ti))

        @test mapreduce(identity, +, A) ≈ mapreduce(identity, +, parent(A))
        @test mapreduce(x->x^3+5, +, A) ≈ mapreduce(x->x^3+5, +, parent(A))
        # Using parent since JLArray errors
        for dims in ys
            @test parent(mapreduce(identity, +, A; dims)) ≈ mapreduce(identity, +, parent(A); dims=1)
        end

        for dims in tis
            @test parent(mapreduce(identity, +, A; dims)) ≈ mapreduce(identity, +, parent(A); dims=2)
        end

        @test parent(mapreduce(identity, +, A; dims=Y)) ≈ mapreduce(identity, +, parent(A); dims=1)
        @test parent(mapreduce(identity, +, A; dims=Ti)) ≈ mapreduce(identity, +, parent(A); dims=2)
        @test parent(mapreduce(identity, +, A; dims=(Y, Ti))) ≈ mapreduce(identity, +, parent(A); dims=(1, 2))

        init = 5.0
        @test mapreduce(identity, +, A; init) ≈ mapreduce(identity, +, parent(A); init)
        @test mapreduce(x->x^3+5, +, A; init) ≈ mapreduce(x->x^3+5, +, parent(A); init)
        @test parent(mapreduce(identity, +, A; dims=Y, init)) ≈ mapreduce(identity, +, parent(A); dims=1, init)
        @test parent(mapreduce(identity, +, A; dims=Ti, init)) ≈ mapreduce(identity, +, parent(A); dims=2, init)
        @test parent(mapreduce(identity, +, A; dims=(Y, Ti), init)) ≈ mapreduce(identity, +, parent(A); dims=(1, 2), init)
    end
end

"""
    AbstractMetadata{X,T}

Abstract supertype for all metadata wrappers.

Metadata wrappers allow tracking the contents and origin of metadata. This can 
facilitate conversion between metadata types (for saving a file to a different format)
or simply saving data back to the same file type with identical metadata.

Using a wrapper instead of `Dict` or `NamedTuple` also lets us pass metadata 
objects to [`set`](@ref) without ambiguity about where to put them.
"""
abstract type AbstractMetadata{X,T} end

const _MetadataContents = Union{AbstractDict,NamedTuple}
const AllMetadata = Union{AbstractMetadata,AbstractDict}

Base.get(m::AbstractMetadata, args...) = get(val(m), args...)
Base.getindex(m::AbstractMetadata, key) = getindex(val(m), key)
Base.setindex!(m::AbstractMetadata, x, key) = setindex!(val(m), x, key)
Base.haskey(m::AbstractMetadata, key) = haskey(val(m), key)
Base.keys(m::AbstractMetadata) = keys(val(m))
Base.iterate(m::AbstractMetadata, args...) = iterate(val(m), args...)
Base.IteratorSize(m::AbstractMetadata) = Base.IteratorSize(val(m))
Base.IteratorEltype(m::AbstractMetadata) = Base.IteratorEltype(val(m))
Base.eltype(m::AbstractMetadata) = eltype(val(m))
Base.length(m::AbstractMetadata) = length(val(m))
Base.:(==)(m1::AbstractMetadata, m2::AbstractMetadata) = m1 isa typeof(m2) && val(m1) == val(m2)

"""
    Metadata <: AbstractMetadata

    Metadata{X}(val::Union{Dict,NamedTuple})
    Metadata{X}(pairs::Pair...) => Metadata{Dict}
    Metadata{X}(; kw...) => Metadata{NamedTuple}

General [`Metadata`](@ref) object. The `X` type parameter
categorises the metadata for method dispatch, if required. 
"""
struct Metadata{X,T<:_MetadataContents} <: AbstractMetadata{X,T}
    val::T
end
Metadata(val::T) where {T<:_MetadataContents} = Metadata{Nothing,T}(val)
Metadata{X}(val::T) where {X,T<:_MetadataContents} = Metadata{X,T}(val)

# NamedTuple/Dict constructor
# We have to combine these because the no-arg method is overwritten by empty kw.
function (::Type{M})(ps...; kw...) where M <: Metadata
    if length(ps) > 0 && length(kw) > 0
        throw(ArgumentError("Metadata can be constructed with args of Pair to make a Dict, or kw for a NamedTuple. But not both."))
    end
    length(kw) > 0 ? M((; kw...)) : M(Dict(ps...))
end

ConstructionBase.constructorof(::Type{<:Metadata{X}}) where X = Metadata{X}

val(m::Metadata) = m.val

"""
    NoMetadata <: AbstractMetadata

    NoMetadata()

Indicates an object has no metadata. But unlike using `nothing`, 
`get`, `keys` and `haskey` will still work on it, `get` always
returning the fallback argument. `keys` returns `()` while `haskey`
always returns `false`.
"""
struct NoMetadata <: AbstractMetadata{Nothing,NamedTuple{(),Tuple{}}} end

val(m::NoMetadata) = NamedTuple()

Base.keys(::NoMetadata) = ()
Base.haskey(::NoMetadata, args...) = false
Base.get(::NoMetadata, key, fallback) = fallback
Base.length(::NoMetadata) = 0

function Base.show(io::IO, mime::MIME"text/plain", metadata::Metadata{N}) where N
    print(io, "Metadata")
    if N !== Nothing
        print(io, "{")
        show(io, N)
        print(io, "}")
    end
    printstyled(io, " of "; color=:light_black)
    show(io, mime, val(metadata))
end

# Metadata utils

function metadatadict(dict)
    symboldict = Dict{Symbol,Any}()
    for (k, v) in dict
        symboldict[Symbol(k)] = v
    end
    symboldict
end

metadata(x) = NoMetadata()

units(x) = units(metadata(x))
units(m::NoMetadata) = nothing
units(m::Nothing) = nothing
units(m::Metadata) = get(m, :units, nothing)
units(m::AbstractDict) = get(m, :units, nothing)

module DimensionalDataMakieExt

using DimensionalData
using Makie
using IntervalSets
using DimensionalData.Dimensions, DimensionalData.Lookups

const DD = DimensionalData

# Shared docstrings: keep things consistent.

function Makie_attribute_names(P)
    if isdefined(Makie, :MakieCore) # To work with Makie <0.24
        Makie.MakieCore.attribute_names(P)
    else
        Makie.attribute_names(P) # For Makie >=0.24
    end
end

const AXISLEGENDKW_DOC = """
- `axislegend`: attributes to pass to `axislegend`.
"""
_keyword_heading_doc(f) = """
# Keywords

Keywords for $f work as usual.
"""

_xy(f) = """
- `x`: A `Dimension`, `Dimension` type or `Symbol` for the `Dimension` that should go on the x axis of the plot.
- `y`: A `Dimension`, `Dimension` type or `Symbol` for the `Dimension` that should go on the y axis of the plot.
"""
_z(f) = """
- `z`: A `Dimension`, `Dimension` type or `Symbol` for the `Dimension` that should go on the z axis of the plot.
"""

_labeldim_detection_doc(f) = """
Labels are found automatically, following this logic:
1. Use the `labeldim` keyword if it is passsed in.
2. Find the first dimension with a `Categorical` lookup.
3. Find the first `<: DependentDim` dimension, which will include
    `Ti` (time), `X` and any other `<: XDim` dimensions.
4. Fallback: just use the first dimension of the array for labels.

$(_keyword_heading_doc(f))

- `labeldim`: manual specify the dimension to use as series and get 
    the `labels` attribute from. Can be a `Dimension`, `Type`, `Symbol` or `Int`.
"""

# Only `heatmap` and `contourf` get a colorbar
function _maybe_colorbar_doc(f) 
    if f in (:heatmap, :contourf)
        """
        - `colorbar`: keywords to pass to `Makie.Colorbar`.
        """
    else
        ""
    end
end

obs_f(f, A::Observable) = lift(x -> f(x), A)
obs_f(f, A) = f(A)

const MayObs{T} = Union{T, Makie.Observable{<:T}}

const MakieGrids = Union{Makie.GridPosition, Makie.GridSubposition}

PlotTypes_1D = (Lines, Scatter, ScatterLines, Stairs, Stem, BarPlot,  Waterfall, LineSegments)
PlotTypes_Cat_1D = (BoxPlot, Violin, RainClouds)
PlotTypes_2D = (Heatmap, Image, Contour, Contourf, Contour3d, Spy, Surface) 
PlotTypes_3D = (Volume, VolumeSlices)

for p in (PlotTypes_1D..., PlotTypes_2D..., PlotTypes_3D..., Series, PlotTypes_Cat_1D...)
    f = Makie.plotkey(p)
    @eval begin
        function Makie.$f(A::MayObs{<:AbstractDimArray}; figure = (;), attributes...)
            fig = Figure(; figure...)
            ax, plt = $f(fig[1,1], A; attributes...)
            return Makie.FigureAxisPlot(fig, ax, plt)
        end
    end
end

function error_if_has_content(grid::G) where G
    G <: GridSubposition && Makie.GridLayoutBase.get_layout_at!(grid.parent; createmissing=true)
    c = contents(grid; exact=true) # Error from Makie
    if !isempty(c)
        error("""
        You have used the non-mutating plotting syntax with a GridPosition, which requires an empty GridLayout slot to create an axis in, but there are already the following objects at this layout position:
        $(c)
        If you meant to plot into an axis at this position, use the plotting function with `!` (e.g. `func!` instead of `func`).
        If you really want to place an axis on top of other blocks, make your intention clear and create it manually.
        """)
    end
end


# 1d plots are scatter by default
for (p1) in PlotTypes_1D
    f1 = Makie.plotkey(p1)
    f1! = Symbol(f1, '!')
    
    docstring = """
        $f1(A::AbstractDimVector; attributes...)
        
    Plot a 1-dimensional `AbstractDimArray` with `Makie`.

    The X axis will be labelled with the dimension name and and use ticks from its lookup.

    """
    @eval begin
        @doc $docstring
        function Makie.$f1(fig::MakieGrids, A::MayObs{AbstractDimArray}; axislegend =(;merge = false, unique = false), axis = (;), plot_user_attributes...)
            error_if_has_content(fig)

            ax_type = haskey(axis, :type) ? axis[:type] : default_axis_type($p1, A)
            axis_att = axis_attributes($p1, A)
            axis_att_for_function = filter_keywords(merge(filter_keywords_axis!(ax_type, axis_att), axis), (:type,), !)

            plot_attr = merge(plot_attributes($p1, A), plot_user_attributes)

            ax = ax_type(fig; axis_att_for_function...)
            p = $f1!(ax, A; plot_attr...)
            
            add_labels_to_lscene(ax, axis_att)

            axislegend != false && Makie.axislegend(ax; axislegend...)
            return Makie.AxisPlot(ax, p)
        end
    end
end


function Makie.series(fig::MakieGrids, A::MayObs{AbstractDimMatrix}; color = :lighttest, labeldim = nothing, axislegend = (;merge = false, unique = false), axis = (;), plot_user_attributes...)
    error_if_has_content(fig)

    ax_type = haskey(axis, :type) ? axis[:type] : default_axis_type(Series, A)
    axis_att = axis_attributes(Series, A; labeldim = labeldim)
    axis_att_for_function = filter_keywords(merge(filter_keywords_axis!(ax_type, axis_att), axis), (:type,), !)

    plot_attr = merge(plot_attributes(Series, A; labeldim = labeldim), plot_user_attributes)

    ax = ax_type(fig; axis_att_for_function...)

    n_colors = size(to_value(A), _categorical_or_dependent(to_value(A), labeldim))
    default_colormap = Makie.to_colormap(color)
    colormap = n_colors > 7 ? Makie.resample_cmap(default_colormap, n_colors) : default_colormap
    
    p = series!(ax, A; labeldim = labeldim, color = colormap, plot_attr...)
            
    add_labels_to_lscene(ax, axis_att)

    axislegend != false && Makie.axislegend(ax; axislegend...)
    return Makie.AxisPlot(ax, p)
end

for (p1) in PlotTypes_Cat_1D
    f1 = Makie.plotkey(p1)
    f1! = Symbol(f1, '!')
    
    @eval begin
        function Makie.$f1(fig::MakieGrids, A::MayObs{AbstractDimMatrix}; categoricaldim = nothing, axis = (;), plot_user_attributes...)
            error_if_has_content(fig)

            ax_type = haskey(axis, :type) ? axis[:type] : default_axis_type($p1, A)
            axis_att = axis_attributes($p1, A; categoricaldim = categoricaldim)
            axis_att_for_function = filter_keywords(merge(filter_keywords_axis!(ax_type, axis_att), axis), (:type,), !)

            plot_attr = merge(plot_attributes($p1, A), plot_user_attributes)

            ax = ax_type(fig; axis_att_for_function...)

            p = $f1!(ax, A; categoricaldim = categoricaldim, plot_attr...)

            add_labels_to_lscene(ax, axis_att)

            return Makie.AxisPlot(ax, p)
        end
    end
end


function axis_attributes(::Type{P}, A::MayObs{DD.AbstractDimArray}) where P <: Union{Lines, LineSegments, Scatter, ScatterLines, Stairs, Stem, BarPlot, Waterfall}
    lookup_attributes = get_axis_ticks(obs_f(i -> dims(i, 1), A), 1)
    merge(
        lookup_attributes,
        (;
            xlabel = obs_f(i -> string(label(dims(i, 1))), A), 
            ylabel = obs_f(DD.label, A),
            title = obs_f(DD.refdims_title, A),
        ),
    )
end

function plot_attributes(::Type{P}, A::MayObs{<:DD.AbstractDimMatrix}; labeldim = nothing) where P <: Union{Makie.Series}
    categoricaldim = obs_f(i -> _categorical_or_dependent(i, labeldim), A)
    plot_attributes = (; 
        labels=obs_f(i -> string.(parent(i)), categoricaldim),
    )
end

function axis_attributes(::Type{Series}, A::MayObs{DD.AbstractDimMatrix}; labeldim)
    categoricaldim = _categorical_or_dependent(to_value(A), labeldim)
    isnothing(categoricaldim) && throw(ArgumentError("No dimensions have Categorical lookups"))
    otherdim = only(otherdims(to_value(A), categoricaldim))

    lookup_attributes = get_axis_ticks((dims(to_value(A), otherdim),))

    merge(
        lookup_attributes,
        (;
            xlabel=obs_f(i -> string(label(dims(i, otherdim))), A), 
            ylabel=obs_f(DD.label, A),
            title=obs_f(DD.refdims_title, A),
        ),
    )
end

function axis_attributes(::Type{<:Union{RainClouds, BoxPlot, Violin}}, A::MayObs{DD.AbstractDimMatrix}; categoricaldim)
    categoricaldim = _categorical_or_dependent(to_value(A), categoricaldim)
    isnothing(categoricaldim) && throw(ArgumentError("No dimensions have Categorical lookups"))

    lookup_attributes = get_axis_ticks((dims(to_value(A), categoricaldim),))

    merge(
        lookup_attributes,
        (;
            xlabel=obs_f(i -> string(label(dims(i, categoricaldim))), A), 
            ylabel=obs_f(DD.label, A),
            title=obs_f(DD.refdims_title, A),
        ),
    )
end

function plot_attributes(::Type{P}, A::MayObs{<:DD.AbstractDimArray}) where P <: Union{Lines, Scatter, ScatterLines, Stairs, Stem, BarPlot, BoxPlot, Waterfall, RainClouds, Violin, LineSegments}
    plot_attributes = (; 
        label=obs_f(plot_label, A),
    )
    plot_attributes
end


""" 
    plot_label(A::AbstractDimArray)

Returns the label of a `DimensionalData` object, or a space if no label is found. This function is needed because an empty label passed to the Legend leds to an error in Makie.
"""
function plot_label(A)
    lab = DD.label(A)
    if isempty(lab)
        return " "
    else
        lab
    end
end


for p1 in PlotTypes_2D
    f1 = Makie.plotkey(p1)
    f1! = Symbol(f1, '!')
    docstring = """
        $f1(A::AbstractDimMatrix; attributes...)
        
    Plot a 2-dimensional `AbstractDimArray` with `Makie.$f1`.

    $(_keyword_heading_doc(f1))
    $(_xy(f1))
    $(_maybe_colorbar_doc(f1))
    """
    @eval begin
        @doc $docstring
        function Makie.$f1(fig::MakieGrids, A::MayObs{AbstractDimMatrix{T}}; 
            xdim = nothing, ydim = nothing, colorbar=(;), axis = (;), plot_attributes...
        ) where T
            error_if_has_content(fig)

            ax_type = haskey(axis, :type) ? axis[:type] : default_axis_type($p1, to_value(A); xdim = xdim, ydim = ydim)
            axis_att = axis_attributes($p1, A; xdim = xdim, ydim = ydim)
            axis_att_for_function = filter_keywords(merge(filter_keywords_axis!(ax_type, axis_att), axis), [:type], !)
            ax = ax_type(fig[1,1]; axis_att_for_function...)
            p = $f1!(ax, A; plot_attributes..., xdim = xdim, ydim = ydim)
            add_labels_to_lscene(ax, axis_att)

            if colorbar != false && $(f1 in (:heatmap, :contourf, :surface, :spy)) && T <: Real
                # T check is to not add if using RGB
                Colorbar(fig[1, 2], p;
                    label=obs_f(DD.label, A), colorbar...
                )
            end
            return Makie.AxisPlot(ax, p)
        end
    end
end

for p1 in PlotTypes_3D
    f1 = Makie.plotkey(p1)
    f1! = Symbol(f1, '!')
    docstring = """
        $f1(A::AbstractDimMatrix; attributes...)
        
    Plot a 3-dimensional `AbstractDimArray` with `Makie.$f1`.

    $(_keyword_heading_doc(f1))
    $(_xy(f1))
    $(_maybe_colorbar_doc(f1))
    """
    @eval begin
        @doc $docstring
        function Makie.$f1(fig::MakieGrids, A::MayObs{AbstractDimArray{<:Any,3}}; 
            xdim=nothing, ydim=nothing, zdim=nothing, colorbar=(;), axis = (;), plot_attributes...
        )
            error_if_has_content(fig)
            ax_type = haskey(axis, :type) ? axis[:type] : default_axis_type($p1, A; xdim = xdim, ydim = ydim, zdim = zdim)
            axis_att = axis_attributes($p1, A; xdim = xdim, ydim = ydim, zdim = zdim)
            axis_att_for_function = filter_keywords(merge(filter_keywords_axis!(ax_type, axis_att), axis), [:type], !)

            ax = ax_type(fig[1,1]; axis_att_for_function...)
            p = $f1!(ax, A; plot_attributes..., xdim = xdim, ydim = ydim, zdim = zdim)

            if colorbar != false
                Colorbar(fig[1, 2], p;
                    label=obs_f(DD.label, A), colorbar...
                )
            end
            add_labels_to_lscene(ax, axis_att)
            return Makie.AxisPlot(ax, p)
        end
    end

end

function filter_keywords_axis!(ax_type, att)
    filter_keywords(att, Makie_attribute_names(ax_type), identity)
end

function filter_keywords(collecti, to_filter, f)
    keys_filt = filter(i -> f(i in to_filter), keys(collecti))
    collecti[keys_filt]
end

function axis_attributes(::Type{P}, dd; xdim, ydim) where P <: Union{Heatmap, Image, Surface, Contour, Contourf, Contour3d, Spy}
    dims_axes = obs_f(i -> get_dimensions_of_makie_axis(i, (xdim, ydim)), dd)
    lookup_attributes = get_axis_ticks(to_value(dims_axes))

    merge(
        lookup_attributes,
        (;
        xlabel = obs_f(i -> DD.label(i[1]), dims_axes),
        ylabel = obs_f(i -> DD.label(i[2]), dims_axes),
        title = obs_f(DD.refdims_title, dd)),
    )
end

function axis_attributes(::Type{P}, dd; xdim, ydim, zdim) where P <: Union{Volume, VolumeSlices}
    dims_axes = obs_f(i -> get_dimensions_of_makie_axis(i, (xdim, ydim, zdim)), dd)

    lookup_attributes = get_axis_ticks(to_value(dims_axes))
    att = merge(
        lookup_attributes,
        (;
        xlabel = obs_f(i -> DD.label(i[1]), dims_axes),
        ylabel = obs_f(i -> DD.label(i[2]), dims_axes),
        zlabel = obs_f(i -> DD.label(i[3]), dims_axes),
        title = obs_f(DD.refdims_title, dd)),
    )
end

function default_axis_type(::Type{P}, dd; kwargs...) where P
    output = Makie.convert_arguments(P, to_value(dd); kwargs...)
    default_type = Makie.args_preferred_axis(P, output...) 
    isnothing(default_type) ? Axis : default_type
end

function add_labels_to_lscene(ax, axis_att)
    if ax isa Makie.LScene && !isnothing(ax.scene[Makie.OldAxis])
        ax.scene[Makie.OldAxis][:names, :axisnames][] = (axis_att[:xlabel], axis_att[:ylabel], haskey(axis_att, :zlabel) ? axis_att[:zlabel] : "") .|> to_value
    end
end


# Definition of plot functions 
Makie.plottype(::D) where D<:Union{<:AbstractDimArray, <:DimPoints} = _plottype(D)
_plottype(::Type{<:MayObs{AbstractDimVector}}) = Makie.Scatter
_plottype(::Type{<:MayObs{AbstractDimMatrix}}) = Makie.Heatmap
_plottype(::Type{<:MayObs{AbstractDimArray{<:Any,3}}}) = Makie.Volume
_plottype(::Type{<:MayObs{DimPoints}}) = Makie.Scatter
for DD in (AbstractDimVector, AbstractDimMatrix, AbstractDimArray{<:Any,3}, DimPoints)
    p = _plottype(DD)
    f = Makie.plotkey(p)
    f! = Symbol(f, '!')
    eval(quote
        Makie.plot(dd::MayObs{$DD}; kwargs...) = Makie.$f(dd; kwargs...)
        Makie.plot(fig::MakieGrids, dd::MayObs{$DD}; kwargs...) = Makie.$f(fig, dd; kwargs...)
        Makie.plot!(ax, dd::MayObs{$DD}; kwargs...) = Makie.$f!(ax, dd; kwargs...)
    end)
end

Makie.used_attributes(::Type{<:Series}, A::DD.AbstractDimMatrix) = (:labeldim,)
Makie.used_attributes(::Type{<:Union{RainClouds, BoxPlot, Violin}}, A::DD.AbstractDimArray) = (:categoricaldim,)
Makie.used_attributes(::Type{<:Union{Contour, Contourf, Contour3d, Image, Heatmap, Surface, Spy}}, A::DD.AbstractDimMatrix) = (:xdim, :ydim)
Makie.used_attributes(::Type{<:Union{VolumeSlices, Volume}}, A::DD.AbstractDimArray{<:Any, 3}) = (:xdim, :ydim, :zdim)

function Makie.convert_arguments(P::Type{T}, A::AbstractDimMatrix; xdim = nothing , ydim = nothing) where T<:Union{Contour, Contourf, Surface, Contour3d}
    dims_axes = get_dimensions_of_makie_axis(A, (xdim, ydim))
    xlookup, ylookup = (lookup(dims_axes[1]), lookup(dims_axes[2])) .|> parent .|> get_number_version
    z = parent(permutedims(A, (dims_axes[1], dims_axes[2]))) 
    Makie.convert_arguments(P, xlookup, ylookup, z) 
end

function Makie.convert_arguments(P::Type{<:Series}, A::AbstractDimMatrix; labeldim = nothing)
    categoricaldim = _categorical_or_dependent(A, labeldim)
    isnothing(categoricaldim) && throw(ArgumentError("No dimensions have Categorical lookups")) # This should never happen
    otherdim = only(otherdims(A, categoricaldim))
    xs = parent(lookup(A, otherdim)) |> get_number_version 
    return Makie.convert_arguments(P, xs, parent(permutedims(A, (categoricaldim, otherdim))))
end

# PointBased conversions (scatter, lines, poly, etc)
function Makie.convert_arguments(P::Makie.PointBased, A::AbstractDimVector)
    xs = parent(lookup(A, 1)) |> get_number_version
    return Makie.convert_arguments(P, xs, parent(A))
end

# PointBased conversions (scatter, lines, poly, etc)
function Makie.convert_arguments(P::Makie.PointBased, A::DimPoints)
    return Makie.convert_arguments(P, vec(A))
end
# This doesn't work, but it will at least give the normal Makie error
function Makie.convert_arguments(t::Makie.PointBased, A::DimPoints{<:Any,1})
    return Makie.convert_arguments(t, collect(A))
end

function Makie.convert_arguments(P::Makie.SampleBased, A::AbstractDimVector; categoricaldim = nothing)
    if !isnothing(categoricaldim) 
        dimnum(A, categoricaldim) # Returns an error if dim does not exist
    end
    xs = parent(lookup(A, 1)) |> get_number_version
    return Makie.convert_arguments(P, xs, parent(A))
end

function Makie.convert_arguments(P::Type{<:RainClouds}, A::AbstractDimVector; categoricaldim = nothing)
    if !isnothing(categoricaldim) 
        dimnum(A, categoricaldim) # Returns an error if dim does not exist
    end
    xs = parent(lookup(A, 1)) |> get_number_version
    return Makie.convert_arguments(P, xs, parent(A))
end

function Makie.convert_arguments(P::Type{<:Union{Makie.RainClouds, BoxPlot, Violin}}, A::AbstractDimMatrix; categoricaldim = nothing)
    dd_categoricaldim = _categorical_or_dependent(A, categoricaldim)
    isnothing(dd_categoricaldim) && throw(ArgumentError("No dimensions have Categorical lookups")) # This should never happen
    otherdim = only(otherdims(A, dd_categoricaldim))
    xs = lookup(A, dd_categoricaldim)
    matrix_xs = repeat(parent(xs), outer = (1, size(A, otherdim)))

    matrix_xs, parent(permutedims(A, (otherdim, dd_categoricaldim) ))
    return Makie.convert_arguments(P, get_number_version(vec(matrix_xs)), parent(permutedims(A, (otherdim, dd_categoricaldim))) |> vec)
end

# Grid based conversions (surface, image, heatmap, contour, meshimage, etc)

# ImageLike is for e.g. image, meshimage, etc. It uses an interval based sampling method so requires regular spacing.
function Makie.convert_arguments(P::Type{T}, A::AbstractDimMatrix; xdim = nothing, ydim = nothing) where T<:Union{Image, Spy}
    dims_axes = get_dimensions_of_makie_axis(A, (xdim, ydim))
    xlookup, ylookup = lookup(dims_axes[1]), lookup(dims_axes[2])

    _check_regular_or_categorical_sampling(xlookup; axis = :x)
    _check_regular_or_categorical_sampling(ylookup; axis = :y)

    Makie.convert_arguments(P, _lookup_to_interval(xlookup), _lookup_to_interval(ylookup), parent(permutedims(A, (dims_axes[1], dims_axes[2])))) 
end

# Needed to avoid ambiguous definition of convert_arguments
function Makie.convert_arguments(P::Type{T}, A::AbstractDimMatrix) where T<:Spy
    Makie.convert_arguments(P, A; xdim = nothing, ydim = nothing)
end

# CellGrid is for e.g. heatmap, contourf, etc. It uses vertices as corners of cells, so 
# there have to be n+1 vertices for n cells on an axis.
function Makie.convert_arguments(
    P::Type{Heatmap}, A::AbstractDimMatrix; xdim = nothing, ydim = nothing)
    dims_axes = get_dimensions_of_makie_axis(A, (xdim, ydim))
    xlookup, ylookup = (lookup(dims_axes[1]), lookup(dims_axes[2])) .|> parent .|> get_number_version
    z = parent(permutedims(A, (dims_axes[1], dims_axes[2])))
    return Makie.convert_arguments(P, xlookup, ylookup, z)
end

# VolumeLike is for e.g. volume, volumeslices, etc. It uses a regular grid.
function Makie.convert_arguments(P::Type{T}, A::AbstractDimArray{<:Any,3}; xdim = nothing, ydim = nothing, zdim = nothing) where T<:Union{Volume}
    dims_axes = get_dimensions_of_makie_axis(A, (xdim, ydim, zdim))
    map((l, ax) -> _check_regular_or_categorical_sampling(l; axis = ax, conversiontrait = P), dims_axes, (:x, :y, :z))
    xs, ys, zs = map(_lookup_to_interval, dims_axes) .|> get_number_version
    return Makie.convert_arguments(P, xs, ys, zs, parent(permutedims(A, dims_axes)))
end

function Makie.convert_arguments(P::Type{Makie.VolumeSlices}, A::AbstractDimArray{<:Any,3}; xdim = nothing, ydim = nothing, zdim = nothing)
    dims_axes = get_dimensions_of_makie_axis(A, (xdim, ydim, zdim))
    xs, ys, zs = map(_lookup_to_vector, dims_axes) .|> get_number_version
    return Makie.convert_arguments(P, xs, ys, zs, parent(permutedims(A, dims_axes)))
end

Makie.expand_dimensions(t::Makie.NoConversion, A::AbstractDimArray) = return
Makie.expand_dimensions(t::Makie.PointBased, A::Union{AbstractDimVector, AbstractDimMatrix}) = return
Makie.expand_dimensions(t::Makie.SampleBased, A::AbstractDimVector) = return
Makie.expand_dimensions(t::Makie.Series, A::AbstractDimMatrix) = return
Makie.expand_dimensions(t::Makie.VertexGrid, A::AbstractDimMatrix) = return
Makie.expand_dimensions(t::Makie.ImageLike, A::AbstractDimMatrix) = return
Makie.expand_dimensions(t::Makie.CellGrid, A::AbstractDimMatrix) = return
Makie.expand_dimensions(t::Makie.VolumeLike, A::AbstractDimArray{<:Any,3}) = return
Makie.expand_dimensions(t::Type{VolumeSlices}, A::AbstractDimArray{<:Any,3}) = return
Makie.expand_dimensions(t::Type{Spy}, A::AbstractDimArray{<:Real,2}) = return

# Utility methods

# Get Categorical lookups or DependentDim
_categorical_or_dependent(A, labeldim) = dims(A, labeldim)
function _categorical_or_dependent(A, ::Nothing)
    categoricaldim = reduce(dims(A); init=nothing) do acc, d
        if isnothing(acc)
            lookup(d) isa AbstractCategorical ? d : nothing
        else
            acc
        end
    end
    isnothing(categoricaldim) || return categoricaldim
    dependentdim = reduce(dims(A); init=nothing) do acc, d
        if isnothing(acc)
            d isa DD.DependentDim ? d : nothing
        else
            acc
        end
    end
    if isnothing(dependentdim)
        return first(dims(A)) # Fallback uses whatever is first
    else
        return dependentdim
    end
end

# Check for regular sampling on a lookup, throw an error if not.
# Here, we assume 
function _check_regular_or_categorical_sampling(l; axis = nothing, conversiontrait = ImageLike())
    if !(DD.isregular(l) || DD.iscategorical(l))
        @warn """
        DimensionalDataMakie: The $(isnothing(axis) ? "" : "$axis-axis ")lookup is not regularly spaced, which is required for $(conversiontrait) plot types in Makie.
        The lookup was:
        $l

        You can solve this by resampling your raster, or by using a more permissive plot type like `heatmap`, `surface`, `contour`, or `contourf`.
        
        Currently, DimensionalData ignores that the lookup is irregular, and assumes a regular lookup.  This may be fine,
        or it may give very incorrect results.  Be warned!
        """
    end
end

function get_axis_ticks(l::MayObs{D}, axis) where D<:DD.Dimension
    d = obs_f(lookup, l)
    if d isa MayObs{AbstractCategorical}
        dim_attr = if axis == 1
            (; xticks= obs_f(i -> (unique(get_number_version(parent(i))), 
                unique(string.(parent(lookup(i))))), l))
        elseif axis == 2
            (; yticks= obs_f(i -> (unique(get_number_version(parent(i))), 
                unique(string.(parent(lookup(i))))), l))
        else
            (; zticks= obs_f(i -> unique((get_number_version(parent(i))), 
                unique(string.(parent(lookup(i))))), l))
        end
        dim_attr
    else
        (;)
    end
end

get_number_version(x) = x
get_number_version(x::AbstractVector{<:AbstractChar}) = Int.(x)
get_number_version(x::AbstractVector{<:AbstractString}) = sum.(Int, x) # Sum all chars
get_number_version(x::AbstractVector{<:Symbol}) = get_number_version(string.(x))
get_number_version(x::IntervalSets.ClosedInterval{<:AbstractChar}) = IntervalSets.ClosedInterval((Int.(endpoints(x)) .+ (-.5, .5))...) # Needs to add half the step this do give the interval like heatmap
get_number_version(x::IntervalSets.ClosedInterval) = x

# Simplify dimension lookups and move information to axis attributes
function get_axis_ticks(A)
    get_axis_ticks(obs_f(dims, A))
end
function get_axis_ticks(dims::MayObs{DD.DimTuple})
    all_att = map((i, ax) -> get_axis_ticks(i, ax), dims, 1:length(dims))
    merge(all_att...)
end

# Returns the mapping to the axes of the Makie plot
function get_dimensions_of_makie_axis(A::AbstractDimArray{<:Any,N}, _dims_input::Tuple) where N
    length(_dims_input) == N || throw(ArgumentError("Error. Should never happen"))

    dims_input = filter(!isnothing, _dims_input)
    map(dims_input) do d
        # Make sure replacements contain X/Y/Z only
        hasdim(A, d) || throw(ArgumentError("object does not have a dimension $(basetypeof(d))"))
    end

    default_order = dims(otherdims(A, dims_input), DD.PLOT_DIMENSION_ORDER)
    index_default = 1
    dims_output = []
    for i in 1:N
        if isnothing(_dims_input[i])
            push!(dims_output, default_order[index_default])
            index_default += 1
        else
            push!(dims_output, dims(A, _dims_input[i]))
        end
    end
    (dims_output...,)
end

function _lookup_to_vector(l)
    if isintervals(l)
        bs = intervalbounds(l)
        x = first.(bs)
        push!(x, last(last(bs)))
    else # ispoints(l)
        collect(parent(l))
    end
end

function _lookup_to_vertex_vector(l)
    if isintervals(l)
        return parent(DD.shiftlocus(DD.Center(), l))
    else # ispoints(l)
        return collect(parent(l))
    end
end

function _lookup_to_interval(l)
    # TODO: warn or error if not regular sampling.
    # Maybe use Preferences.jl to determine if we should error or warn.
    l1 = if isnolookup(l)
        Sampled(parent(l); order=ForwardOrdered(), sampling=Intervals(Center()), span=Regular(1))
    elseif ispoints(l)
        set(l, Intervals()) # this sets the intervals to be `Intervals(Center())` by default.  Same as heatmap behaviour.
    else # isintervals(l)
        (l)
    end
    return IntervalSets.Interval(extrema(get_number_version(l1))...)
end
end

const Reorderable = Union{AbstractBasicDimArray,AbstractDimStack,DimTuple}
const DimensionOrLookup = Union{Dimension,Lookup}

"""
    reorder(A::Union{AbstractDimArray,AbstractDimStack}, order::Pair...)
    reorder(A::Union{AbstractDimArray,AbstractDimStack}, order)
    reorder(A::Dimension, order::Order)

Reorder every dims index/array to `order`, or reorder index for
the given dimension(s) in `order`.

`order` can be an [`Order`](@ref), `Dimension => Order` pairs.
A Tuple of Dimensions or any object that defines `dims` can be used
in which case the dimensions of this object are used for reordering.

If no axis reversal is required the same objects will be returned, without allocation.

## Example

```jldoctest
using DimensionalData

# Create a DimArray
da = DimArray([1 2 3; 4 5 6], (X(10:10:20), Y(300:-100:100)))

# Reverse it
rev = reverse(da, dims=Y)

# using `da` in reorder will return it to the original order
reorder(rev, da) == da

# output
true
```
"""
function reorder end

reorder(x::Reorderable, A::Union{AbstractDimArray,AbstractDimStack,AbstractDimIndices}) = 
    reorder(x, dims(A))
reorder(x::Reorderable, ::Nothing) = throw(ArgumentError("object has no dimensions"))
reorder(x::Reorderable, p::Pair, ps::Pair...) = reorder(x, (p, ps...))
reorder(x::Reorderable, ps::Tuple{Vararg{Pair}}) = reorder(x, Dimensions.pairs2dims(ps...))
reorder(x::Reorderable, ::Type{O}) where O<:Order = reorder(x, O())
function reorder(x::Reorderable, o::Order)
    ds = dims(x)
    isnothing(ds) && _dimsnotdefinederror()
    reorder(x, map(d -> rebuild(d, o), ds))
end
reorder(x::Reorderable, o::Tuple{Vararg{Order}}) = reorder(x, map(rebuild, dims(x), o))
# Recursive reordering. x may be reversed here
function reorder(x::Reorderable, orderdims::DimTuple)
    ods = commondims(orderdims, dims(x))
    reorder(reorder(x, ods[1]), tail(ods))
end
reorder(x::Reorderable, orderdims::Tuple{}) = x
function reorder(ds::DimTuple, orderdims::DimTuple)
    ods = commondims(orderdims, ds)
    map(ds) do d
        hasdim(ods, d) ? reorder(d, val(dims(ods, d))) : d
    end
end
reorder(ds::DimTuple, orderdims::Tuple{}) = ds

reorder(x::Reorderable, orderdim::Dimension{<:Order}) = _reorder(x, dims(x, orderdim), val(orderdim))
reorder(x::Reorderable, orderdim::Dimension{<:Lookup}) = _reorder(x, dims(x, orderdim), order(orderdim))

# AutoOrder: keep the current order unchanged
_reorder(x::Reorderable, dim::Dimension, ::AutoOrder) = x
# Unordered: do nothing, just set the order to Unordered
_reorder(x::Reorderable, dim::Dimension, o::Unordered) = unsafe_set(x, dim => o)
# Ordered: leave, reverse or sort
_reorder(x::Reorderable, dim::Dimension, o::Ordered) = _reorder(x, dim, order(dim), o)
# Order matches, nothing to do
_reorder(x::Reorderable, dim::Dimension, ::O, ::O) where O<:Ordered = x
# dimensional reverse can handle this
_reorder(x::Reorderable, dim::Dimension, ::Ordered, ::Ordered) =
    reverse(x; dims=basedims(dim))
function _reorder(x::AbstractDimIndices, dim::Dimension, o1::Unordered, o2::Ordered)
    newdim = _reorder(dims(x, dim), o1, o2)
    return unsafe_set(x, newdim)
end
# We need to sort the data along this dimension
function _reorder(
    x::Union{AbstractDimArray,AbstractDimStack}, dim::Dimension, ::Unordered, o::Ordered
)
    l = lookup(dim)
    # Sort forwards or reverse
    idxs = o isa ForwardOrdered ? sortperm(l) : sortperm(l; rev=true)
    # Reorder the values by indexing into dimension of dim
    output = x[rebuild(dim, idxs)]
    # Set the order
    return unsafe_set(output, dim => o)
end

reorder(x::Dimension, o::Order) = rebuild(x, _reorder(lookup(x), o))
reorder(x::Dimension, l::Lookup) = _reorder(x, order(l))
reorder(x::Dimension, d::Dimension) = _reorder(x, order(d))

# AutoOrder: keep the current order unchanged
_reorder(x::DimensionOrLookup, ::AutoOrder) = x
# Unordered: do nothing, just set the order to Unordered
_reorder(x::DimensionOrLookup, o::Unordered) = unsafe_set(x, o)
# Ordered: leave, reverse or sort
_reorder(x::DimensionOrLookup, o::Ordered) = _reorder(x, order(x), o)
# Order matches, nothing to do
_reorder(x::DimensionOrLookup, ::O, ::O) where O<:Ordered = x
# reverse can handle this
_reorder(x::DimensionOrLookup, ::Ordered, ::Ordered) = reverse(x)
# We need to sort
_reorder(dim::Dimension, ::Unordered, o::Ordered) =
    rebuild(dim, reorder(lookup(dim), o))
# For Lookups, delegate to Lookups.reorder which has the full implementation
_reorder(l::Lookup, ::Unordered, o::Ordered) = reorder(l, o)

"""
    modify(f, A::AbstractDimArray) => AbstractDimArray
    modify(f, s::AbstractDimStack) => AbstractDimStack
    modify(f, dim::Dimension) => Dimension
    modify(f, x, lookupdim::Dimension) => typeof(x)

Modify the parent data, rebuilding the object wrapper without
change. `f` must return a `AbstractArray` of the same size as the original.

This method is mostly useful as a way of swapping the parent array type of
an object.

## Example

If we have a previously-defined `DimArray`, we can copy it to an Nvidia GPU with:

```julia
A = DimArray(rand(100, 100), (X, Y))
modify(CuArray, A)
```

This also works for all the data layers in a `DimStack`.
"""
function modify end
modify(f, s::AbstractDimStack) = maplayers(a -> modify(f, a), s)
# Stack optimisation to avoid compilation to build all the `AbstractDimArray` 
# layers, and instead just modify the parent data directly.
modify(f, s::AbstractDimStack{<:Any,<:Any,<:NamedTuple}) = 
    rebuild(s; data=map(a -> modify(f, a), parent(s)))
function modify(f, A::AbstractDimArray)
    newdata = f(parent(A))
    size(newdata) == size(A) || error("$f returns an array with a different size")
    rebuild(A, newdata)
end
modify(f, x, dim::DimOrDimType) = set(x, modify(f, dims(x, dim)))
modify(f, dim::Dimension) = rebuild(dim, modify(f, val(dim)))
function modify(f, lookup::Lookup)
    newindex = modify(f, parent(lookup))
    rebuild(lookup; data=newindex)
end
function modify(f, index::AbstractArray)
    newindex = f(index)
    size(newindex) == size(index) || error("$f returns a vector with a different size")
    newindex
end

"""
    broadcast_dims(f, sources::AbstractDimArray...) => AbstractDimArray

Broadcast function `f` over the `AbstractDimArray`s in `sources`, permuting and reshaping
dimensions to match where required. The result will contain all the dimensions in 
all passed in arrays in the order in which they are found.

## Arguments

- `sources`: `AbstractDimArrays` to broadcast over with `f`.

This is like broadcasting over every slice of `A` if it is
sliced by the dimensions of `B`.
"""
function broadcast_dims(f, A1::AbstractBasicDimArray, As::AbstractBasicDimArray...)
    dims = combinedims(A1, As...)
    T = Base.Broadcast.combine_eltypes(f, (A1, As...))
    broadcast_dims!(f, similar(A1, T, dims), A1, As...)
end
function broadcast_dims(
    f, A1::Union{AbstractDimStack,AbstractBasicDimArray}, 
    As::Union{AbstractDimStack,AbstractBasicDimArray}...
)
    st = _firststack(A1, As...)::AbstractDimStack
    nts = _as_extended_nts(NamedTuple(st), A1, As...)
    layers = map(keys(st)) do name
        broadcast_dims(f, map(nt -> nt[name], nts)...)
    end
    rebuild_from_arrays(st, layers)
end

"""
    broadcast_dims!(f, dest::AbstractDimArray, sources::AbstractDimArray...) => dest

Broadcast function `f` over the `AbstractDimArray`s in `sources`, writing to `dest`. 
`sources` are permuting and reshaping dimensions to match where required.

The result will contain all the dimensions in all passed in arrays, in the order in
which they are found.

## Arguments

- `dest`: `AbstractDimArray` to update.
- `sources`: `AbstractDimArrays` to broadcast over with `f`.
"""
function broadcast_dims!(f, dest::AbstractDimArray{<:Any,N}, As::AbstractBasicDimArray...) where {N}
    As = map(As) do A
        isempty(otherdims(A, dims(dest))) || throw(DimensionMismatch("Cannot broadcast over dimensions not in the dest array"))
        # comparedims(dest, dims(A, dims(dest)))
        # Lazily permute B dims to match the order in A, if required
        _maybe_lazy_permute(A, dims(dest))
    end
    od = map(A -> otherdims(dest, dims(A)), As)
    return _broadcast_dims_inner!(f, dest, As, od)
end
function broadcast_dims!(f, dest::AbstractDimStack, stacks::AbstractDimStack...)
    maplayers(dest, stacks...) do d, layers...
        broadcast_dims!(f, d, layers...)
    end
end

# Function barrier
function _broadcast_dims_inner!(f, dest, As, od)
    # Broadcast over b for each combination of dimensional indices D
    if all(map(isempty, od))
        dest .= f.(As...)
    else
        not_shared_dims = combinedims(od...) 
        reshaped = map(As) do A
            _maybe_insert_length_one_dims(A, dims(dest))
        end
        dest .= f.(reshaped...)
    end
    return dest
end


# Get a tuple of unique keys for DimArrays. If they have the same
# name we call them layerI.
function uniquekeys(das::Tuple{AbstractDimArray,Vararg{AbstractDimArray}})
    uniquekeys(map(Symbol ∘ name, das))
end
function uniquekeys(das::Vector{<:AbstractDimArray})
    length(das) == 0 ? Symbol[] : uniquekeys(map(Symbol ∘ name, das))
end
function uniquekeys(keys::AbstractVector{Symbol})
    map(enumerate(keys)) do (id, k)
        count(k1 -> k == k1, keys) > 1 ? Symbol(:layer, id) : k
    end
end
function uniquekeys(keys::Tuple{Symbol,Vararg{Symbol}})
    ids = ntuple(identity, length(keys))
    map(keys, ids) do k, id
        if k == Symbol("") 
            Symbol(:layer, id)
        else
            count(k1 -> k == k1, keys) > 1 ? Symbol(:layer, id) : k
        end
    end
end
uniquekeys(t::Tuple) = ntuple(i -> Symbol(:layer, i), length(t))
uniquekeys(a::AbstractVector) = map(i -> Symbol(:layer, i), eachindex(a))
uniquekeys(nt::NamedTuple) = keys(nt)

_as_extended_nts(nt::NamedTuple{K}, A::AbstractDimArray, As...) where K = 
    (NamedTuple{K}(ntuple(x -> A, length(K))), _as_extended_nts(nt, As...)...)
function _as_extended_nts(nt::NamedTuple{K1}, st::AbstractDimStack{K2}, As...) where {K1,K2}
    K1 == K2 || throw(ArgumentError("Keys of stack $K2 do not match the keys of the first stack $K1"))
    extended_layers = map(layers(st)) do l
        if all(hasdim(l, dims(st)))
            l
        else
            DimExtensionArray(l, dims(st))
        end
    end
    return (extended_layers, _as_extended_nts(nt, As...)...)
end
_as_extended_nts(::NamedTuple) = ()


# Tuple map that is always unrolled
# mostly for stack indexing performance
_unrolled_map_inner(f, v::Type{T}) where T = 
    Expr(:tuple, (:(f(v[$i])) for i in eachindex(T.types))...)
_unrolled_map_inner(f, v1::Type{T}, v2::Type) where T = 
    Expr(:tuple, (:(f(v1[$i], v2[$i])) for i in eachindex(T.types))...)

@generated function unrolled_map(f, v::NamedTuple{K}) where K
    exp = _unrolled_map_inner(f, v)
    :(NamedTuple{K}($exp))
end
@generated function unrolled_map(f, v1::NamedTuple{K}, v2::NamedTuple{K}) where K
    exp = _unrolled_map_inner(f, v1, v2)
    :(NamedTuple{K}($exp))
end
@generated unrolled_map(f, v::Tuple) =
    _unrolled_map_inner(f, v)
@generated unrolled_map(f, v1::Tuple, v2::Tuple) = 
    _unrolled_map_inner(f, v1, v2)

module DimensionalData

# Standard lib
using Dates,
      LinearAlgebra,
      Random,
      Statistics

using Base.Broadcast: Broadcasted, BroadcastStyle, DefaultArrayStyle, AbstractArrayStyle,
      Unknown

using Base: tail, OneTo, Callable, @propagate_inbounds, @assume_effects
      
# Ecosystem
import ConstructionBase,
       DataAPI,
       Extents,
       Interfaces,
       IntervalSets,
       InvertedIndices,
       IteratorInterfaceExtensions,
       OrderedCollections,
       PrecompileTools,
       TableTraits,
       Tables

# using IntervalSets: .., Interval

include("Dimensions/Dimensions.jl")

using .Dimensions
using .Dimensions.Lookups

using .Dimensions: StandardIndices, DimOrDimType, DimTuple, DimTupleOrEmpty, DimType, AllDims


using .Dimensions: INTERFACE_QUERY_FUNCTION_NAMES
import .Lookups: metadata, reorder, set, unsafe_set, _set, rebuild, basetypeof, 
    order, span, sampling, locus, val, bounds, intervalbounds,
    hasselection, units
import .Lookups: Safety, Safe, Unsafe, SelectorOrInterval, Begin, End
import .Dimensions: dims, refdims, name, lookup, kw2dims, hasdim, label, checkaxis, _astuple

using OrderedCollections: OrderedDict

import DataAPI.groupby

export Lookups, Dimensions

# Dimension
export X, Y, Z, Ti, Dim, Coord

# Selector
export At, Between, Touches, Contains, Near, Where, All, .., Not, Bins, CyclicBins

export Begin, End

export AbstractDimArray, DimArray

export AbstractDimVector, AbstractDimMatrix, AbstractDimVecOrMat, DimVector, DimMatrix, DimVecOrMat

export AbstractDimStack, DimStack, DimStackArray

export AbstractDimTable, DimTable

export AbstractDimTree, DimTree, prune

export DimIndices, DimSelectors, DimPoints
# getter methods
export dims, refdims, metadata, name, lookup, bounds, val, layers

# Dimension/Lookup primitives
export dimnum, hasdim, hasselection, otherdims

# utils
export set, unsafe_set, rebuild, reorder, modify, broadcast_dims, broadcast_dims!,
    mergedims, unmergedims, maplayers

export groupby, combine, seasons, months, hours, intervals, ranges


export @d

const DD = DimensionalData

# Common
include("interface.jl")
include("name.jl")
include("table_ops.jl")

# Arrays
include("array/array.jl")
include("dimindices.jl")
include("array/indexing.jl")
include("array/methods.jl")
include("array/matmul.jl")
include("array/broadcast.jl")
include("array/show.jl")
# Stacks
include("stack/stack.jl")
include("stack/indexing.jl")
include("stack/methods.jl")
include("stack/show.jl")
# DataTrees
include("tree/tree.jl")
include("tree/show.jl")
# Other
include("tables.jl")
# Combined (easier to work on these in one file)
include("plotrecipes.jl")
include("utils.jl")
include("set.jl")
include("opaque.jl")
include("groupby.jl")
include("precompile.jl")
include("interface_tests.jl")

end

#=
Restore a dimensional array from its tabular representation.

- `data`: An `AbstractVector` containing the flat data to be written to a `DimArray`.
- `indices`: An `AbstractVector` containing the dimensional indices corresponding to each element in `data`.
- `dims`: The dimensions of the destination `DimArray`.
- `missingval`: The value to write for missing elements in `data`.

# Returns

An `Array` containing the ordered valued in `data` with the size specified by `dims`.
=#
function restore_array(data::AbstractVector, indices::AbstractVector, dims::Tuple, missingval)
    # Allocate Destination Array
    dst = DimArray{eltype(data)}(undef, dims)
    for (idx, d) in zip(indices, data)
        dst[idx] = d
    end

    if length(indices) !== length(dst)
        # Handle Missing Rows
        _missingval = _cast_missing(data, missingval)
        missing_rows = trues(dims)
        for idx in indices # looping is faster than broadcasting
            missing_rows[idx] = false 
        end
        return ifelse.(missing_rows, _missingval, dst)
    end
    return dst
end

#=
    coords_to_indices(table, dims; [selector, atol])

Return the dimensional index of each row in `table` based on its associated coordinates.
Dimension columns are determined from the name of each dimension in `dims`.

# Arguments

- a table 
- `dims`: A `Tuple` of `Dimension` corresponding to the source/destination array.

# Keywords 

- `selector`: The selector type to use. This defaults to `Near()` for orderd, sampled dimensions
    and `At()` for all other dimensions. 
- `atol`: The absolute tolerance to use with `At()`. This defaults to `1e-6`.
=#
coords_to_indices(table, dims::Tuple; selector=nothing, atol=1e-6) =
    _coords_to_indices(table, dims, selector, atol)

#=
    guess_dims(table; kw...)
    guess_dims(table, dims; precision=6)

Guesses the dimensions of an array based on the provided tabular representation.

# Arguments

- a table 
The dimensions will be inferred from the corresponding coordinate collumns in the table.

- `dims`: One or more dimensions to be inferred. If no dimensions are specified, then `guess_dims` will default
to any available dimensions in the set `(:X, :Y, :Z, :Ti, :Band)`. Dimensions can be given as either a singular
value or as a `Pair` with both the dimensions and corresponding order. The order will be inferred from the data
when none is given. This should work for sorted coordinates, but will not be sufficient when the table's rows are
out of order.
  
# Keywords

- `precision`: Specifies the number of digits to use for guessing dimensions (default = `6`).

# Returns
A tuple containing the inferred dimensions from the table.
=#
guess_dims(table; kw...) = guess_dims(table, _dim_col_names(table); kw...)
guess_dims(table, dims::Tuple; precision=6, kw...) =
    map(dim -> _guess_dims(get_column(table, name(dim)), dim, precision), dims)

#Retrieve the coordinate data stored in the column specified by `dim`.
get_column(table, x) = Tables.getcolumn(table, name(x))


#Return the names of all columns that don't match the dimensions given by `dims`.
function data_col_names(table, dims::Tuple)
    dim_cols = name(dims)
    return filter(x -> !(x in dim_cols), Tables.columnnames(table))
end

_guess_dims(coords::AbstractVector, dim::Type{<:Dimension}, args...) = 
    _guess_dims(coords, name(dim), args...)
_guess_dims(coords::AbstractVector, dim::Pair, args...) = 
    _guess_dims(coords, first(dim), last(dim), args...)
function _guess_dims(coords::AbstractVector, dim::Symbol, ::Type{T}, precision::Int) where {T <: Order}
    return _guess_dims(coords, dim, T(), precision)
end
function _guess_dims(coords::AbstractVector, dim::Symbol, precision::Int)
    dim_vals = _dim_vals(coords, dim, precision)
    return format(Dim{dim}(dim_vals))
end
function _guess_dims(coords::AbstractVector, dim::Type{<:Dimension}, precision::Int)
    dim_vals = _dim_vals(coords, dim, precision)
    return format(dim(dim_vals))
end
function _guess_dims(coords::AbstractVector, dim::Dimension, precision::Int) 
    newl = _guess_dims(coords, lookup(dim), precision)
    return format(rebuild(dim, newl))
end
function _guess_dims(coords::AbstractVector, l::Lookup, precision::Int)
    dim_vals = _dim_vals(coords, l, precision)
    return rebuild(l; data = dim_vals)
end
# lookup(dim) could just return a vector - then we keep those values
_guess_dims(coords::AbstractVector, l::AbstractVector, precision::Int) = l

# Extract coordinate columns from table
function _dim_cols(table, dims::Tuple)
    dim_cols = name(dims)
    return NamedTuple{dim_cols}(Tables.getcolumn(table, col) for col in dim_cols)
end

# Extract dimension column names from the given table
_dim_col_names(table) = filter(x -> x in Tables.columnnames(table), (:X,:Y,:Z,:Ti,:Band))
_dim_col_names(table, dims::Tuple) = map(col -> Tables.getcolumn(table, col), name(dims))

_coords_to_indices(table, dims::Tuple, sel, atol) = 
    _coords_to_indices(_dim_cols(table, dims), dims, sel, atol)
# Determine the ordinality of a set of coordinates
function _coords_to_indices(coords::Tuple, dims::Tuple, sel, atol)
    map(zip(coords...)) do coords
        map(coords, dims) do c, d
            _coords_to_indices(c, d, sel, atol)
        end
    end
end
_coords_to_indices(coords::NamedTuple, dims::Tuple, sel, atol) = _coords_to_indices(map(x -> coords[x], name(dims)), dims, sel, atol)
# implement some default selectors
_coords_to_indices(coord, dim::Dimension, sel::Nothing, atol) = 
    _coords_to_indices(coord, dim, _default_selector(dim), atol)

# get indices of the coordinates
_coords_to_indices(coord, dim::Dimension, sel::Selector, atol) = 
    return rebuild(dim, selectindices(dim, rebuild(sel, coord)))
# get indices of the coordinates
_coords_to_indices(coord, dim::Dimension, sel::At, atol) = 
    return rebuild(dim, selectindices(dim, rebuild(sel; val = coord, atol)))

function _default_selector(dim::Dimension{<:AbstractSampled})
    if sampling(dim) isa Intervals
        Contains()
    elseif isordered(dim) && !(eltype(dim) <: Integer)
        Near()
    else 
        At()
    end
end
_default_selector(dim::Dimension{<:AbstractCategorical}) = At()
_default_selector(dim::Dimension) = Near()

# Extract dimension value from the given vector of coordinates
function _dim_vals(coords::AbstractVector, dim, precision::Int)
    vals = _unique_vals(coords, precision)
    return _maybe_as_range(vals, precision)
end
function _dim_vals(coords::AbstractVector, l::Lookup, precision::Int)
    val(l) isa AutoValues || return val(l) # do we want to have some kind of check that the values match?
    vals = _unique_vals(coords, precision)
    _maybe_order!(vals, order(l))
    return _maybe_as_range(vals, precision)
end
_dim_vals(coords::AbstractVector, l::AbstractVector, precision::Int) = l # same comment as above?

_maybe_order!(A::AbstractVector, ::Order) = A
_maybe_order!(A::AbstractVector, ::ForwardOrdered) = sort!(A)
_maybe_order!(A::AbstractVector, ::ReverseOrdered) = sort!(A, rev=true)

# Extract all unique coordinates from the given vector
_unique_vals(coords::AbstractVector, ::Int) = unique(coords)
_unique_vals(coords::AbstractVector{<:Real}, precision::Int) = round.(coords, digits=precision) |> unique
_unique_vals(coords::AbstractVector{<:Integer}, ::Int) = unique(coords)

# Estimate the span between consecutive coordinates
_maybe_as_range(A::AbstractVector, precision) = A # for non-numeric types
function _maybe_as_range(A::AbstractVector{<:Real}, precision::Int)
    A_r = range(first(A), last(A), length(A))
    atol = 10.0^(-precision)
    return all(i -> isapprox(A_r[i], A[i]; atol), eachindex(A)) ? A_r : A
end
function _maybe_as_range(A::AbstractVector{<:Integer}, precision::Int)
    idx1, idxrest = Iterators.peel(eachindex(A))
    step = A[idx1+1] - A[idx1]
    for idx in idxrest
        A[idx] - A[idx-1] == step || return A
    end
    return first(A):step:last(A)
end
function _maybe_as_range(A::AbstractVector{<:Dates.AbstractTime}, precision::Int)
    steps = (@view A[2:end]) .- (@view A[1:end-1])
    span = argmin(abs, steps)
    isregular = all(isinteger, round.(steps ./ span, digits=precision))
    return isregular ? range(first(A), last(A), length(A)) : A
end

_cast_missing(::AbstractArray, missingval::Missing) = missing
function _cast_missing(::AbstractArray{T}, missingval) where {T}
    try
        return convert(T, missingval)
    catch e
        return missingval
    end
end

```@meta
Description = "Complete API reference for DimensionalData.jl - arrays, stacks, dimensions, selectors, and utility functions documentation"
```

# API Reference

## Arrays

```@docs
DimensionalData.AbstractBasicDimArray
AbstractDimArray
DimArray
```

Shorthand `AbstractDimArray` constructors:

```@docs
Base.fill
Base.rand
Base.zeros
Base.ones
```

Functions for getting information from objects:

```@docs
dims
refdims
metadata
name
otherdims
dimnum
hasdim
```

## Multi-array datasets

```@docs
AbstractDimStack
DimStack
maplayers
DimStackArray
```

## DimTree 

These objects and methods are still experimental and
subject to breaking changes _without_ breaking versions.

```@docs
AbstractDimTree
DimTree
prune
```

## Dimension generators

```@docs
DimIndices
DimSelectors
DimPoints
DimensionalData.DimSlices
```

## Tables.jl/TableTraits.jl interface

```@docs
DimensionalData.AbstractDimTable
DimTable
```

## Group by methods

For transforming DimensionalData objects:

```@docs
groupby
combine
DimensionalData.DimGroupByArray
Bins
ranges
intervals
CyclicBins
seasons
months
hours
```

## Utility methods

For transforming DimensionalData objects:

```@docs
set
unsafe_set
rebuild
modify
@d
broadcast_dims
broadcast_dims!
mergedims
unmergedims
reorder
```

## Global lookup strictness settings

Control how strict DimensionalData when comparing [`Lookup`](@ref)s
before doing broadcasts and matrix multipications.

In some cases (especially `DimVector` and small `DimArray`) checking 
lookup values match may be too costly compared to the operations.
You can turn check the current setting and turn them on or off with these
methods.

```@docs
DimensionalData.strict_broadcast
DimensionalData.strict_broadcast!
DimensionalData.strict_matmul
DimensionalData.strict_matmul!
```

## Base methods

```@docs
Base.cat
Base.copy!
Base.eachslice
Base.skipmissing
```

Most base methods work as expected, using `Dimension` wherever a `dims`
keyword is used. They are not all specifically documented here.

## Name

```@docs
DimensionalData.AbstractName
DimensionalData.Name
DimensionalData.NoName
```

## Internal interface

```@docs
DimensionalData.DimArrayInterface
DimensionalData.DimStackInterface
DimensionalData.rebuild_from_arrays
DimensionalData.rebuildsliced
DimensionalData.show_main
DimensionalData.show_after
DimensionalData.refdims_title
```

```@meta
Description = "Learn the basics of DimensionalData.jl - installation, creating dimensional arrays, indexing with named dimensions in Julia"
```

## Installation

If you want to use this package you need to install it first. You can do it using the following commands:

````julia-repl
julia> ] # ']' should be pressed
pkg> add DimensionalData
````

or

````julia-repl
julia> using Pkg
julia> Pkg.add("DimensionalData")
````

Additionally, it is recommended to check the version that you have installed with the status command.

````julia-repl
julia> ]
pkg> status DimensionalData
````

## Basics

Start using the package:

````@example basics
using DimensionalData
````

and create your first DimArray

````@ansi basics
A = DimArray(rand(4,5), (a=1:4, b=1:5))
````

or

````@ansi basics
C = DimArray(rand(Int8, 10), (alpha='a':'j',))
````

or something a little bit more complicated:

````@ansi basics
data = rand(Int8, 2, 10, 3) .|> abs
B = DimArray(data, (channel=[:left, :right], time=1:10, iter=1:3))
````

```@raw html
---
# https://vitepress.dev/reference/default-theme-home-page
layout: home

hero:
  name: "DimensionalData.jl"
  text: "Julia datasets with named dimensions"
  tagline: High performance named indexing for Julia
  image:
    src: '/logo.png'
  actions:
    - theme: brand
      text: Getting Started
      link: /basics
    - theme: alt
      text: API reference
      link: /api/reference
    - theme: alt
      text: View on Github
      link: https://github.com/rafaqz/DimensionalData.jl
features:
  - title: Intelligent indexing
    details: DimensionalData.jl provides no-cost abstractions for named indexing, and fast index lookups.
    link: /selectors
  - title: Powerful Array manipulation
    details: broadcast, reduce, permutedims, and groupby operations.
    link: /groupby
  - title: Seamlessly integrated with the julia ecosystem
    details: Works with most methods that accept a regular Array. If a method accepts numeric indices or dims=X in base, you should be able to use DimensionalData.jl dims.
    link: /integrations
---
```

```@meta
Description = "DimArrays in DimensionalData.jl - wrap Julia arrays with named dimensions and lookups for intuitive indexing and operations"
```

# DimArrays

`DimArray`s are wrappers for other kinds of `AbstractArray` that
add named dimension lookups.


Here we define a `Matrix` of `Float64`, and give it `X` and `Y` dimensions

```@ansi dimarray
using DimensionalData
A = rand(5, 10)
da = DimArray(A, (X, Y))
```

We can access a value with the same dimension wrappers:

```@ansi dimarray
da[Y(1), X(2)]
```

There are shortcuts for creating `DimArray`:

::: tabs

== DimArray

```@ansi dimarray
A = rand(5, 10)
DimArray(A, (X, Y))
DimArray(A, (X, Y); name=:DimArray, metadata=Dict())
```

== zeros

```@ansi dimarray
zeros(X(5), Y(10))
zeros(X(5), Y(10); name=:zeros, metadata=Dict())
```

== ones

```@ansi dimarray
ones(X(5), Y(10))
ones(X(5), Y(10); name=:ones, metadata=Dict())
```

== rand

```@ansi dimarray
rand(X(5), Y(10))
rand(X(5), Y(10); name=:rand, metadata=Dict())
```

== fill

```@ansi dimarray
fill(7, X(5), Y(10))
fill(7, X(5), Y(10); name=:fill, metadata=Dict())
```

== generator construction

```@ansi dimarray
[x + y for x in X(1:5), y in Y(1:10)]
DimArray(x + y for x in X(1:5), y in Y(1:10))
DimArray(x + y for x in X(1:5), y in Y(1:10); name=:sum, metadata=Dict())
```

:::

## Constructing DimArray with arbitrary dimension names

For arbitrary names, we can use the `Dim{:name}` dims
by using `Symbol`s, and indexing with keywords:

```@ansi dimarray
da1 = DimArray(rand(5, 5), (:a, :b))
```

and get a value, here another smaller `DimArray`:

```@ansi dimarray
da1[a=3, b=1:3]
```

## Dimensional Indexing

When used for indexing, dimension wrappers free us from knowing the
order of our objects axes. These are the same:

```@ansi dimarray
da[X(2), Y(1)] == da[Y(1), X(2)]
```

We also can use `Tuples` of dimensions, like `CartesianIndex`,
but they don't have to be in order of consecutive axes.

```@ansi dimarray
da2 = rand(X(10), Y(7), Z(5))
da2[(X(3), Z(5))]
```

We can index with `Vector` of `Tuple{Vararg(Dimension}}` like vectors of
`CartesianIndex`. This will merge the dimensions in the tuples:

```@ansi dimarray
inds = [(X(3), Z(5)), (X(7), Z(4)), (X(8), Z(2))]
da2[inds]
```

`DimIndices` can be used like `CartesianIndices` but again, without the
constraint of consecutive dimensions or known order.

```@ansi dimarray
da2[DimIndices(dims(da2, (X, Z))), Y(3)]
```

The `Dimension` indexing layer sits on top of regular indexing and _can not_ be combined
with it! Regular indexing specifies order, so doesn't mix well with our dimensions.

Mixing them will throw an error:

```@ansi dimarray
da1[X(3), 4]
```

## Begin End indexing

>[!WARNING]
>
>In base julia the keywords `begin` and `end` can be used to
>index the first or last element of an array. But this doesn't 
>work when named indexing is used. Instead you can use the types
>`Begin` and `End`.

```@ansi dimarray
da[X=Begin+1, Y=End]
```

It also works in ranges, even with basic math:

```@ansi dimarray
da[X=Begin:Begin+1, Y=Begin+1:End-1]
```

::: info Indexing

Indexing `AbstractDimArray`s works with `getindex`, `setindex!` and
`view`. The result is still an `AbstracDimArray`, unless using all single
`Int` or `Selector`s that resolve to `Int` inside `Dimension`.

:::

## `dims` keywords

In many Julia functions like, `size` or `sum`, you can specify the dimension
along which to perform the operation as an `Int`. It is also possible to do this
using [`Dimension`](@ref) types with `AbstractDimArray`:

```@ansi dimarray
da5 = rand(X(3), Y(4), Ti(5))
sum(da5; dims=Ti)
```

::: info Dims keywords

Methods where dims, dim types, or `Symbol`s can be used to indicate the array dimension:

- `size`, `axes`, `firstindex`, `lastindex`
- `cat`, `reverse`, `dropdims`
- `reduce`, `mapreduce`
- `sum`, `prod`, `maximum`, `minimum`
- `mean`, `median`, `extrema`, `std`, `var`, `cor`, `cov`
- `permutedims`, `adjoint`, `transpose`, `Transpose`
- `mapslices`, `eachslice`

:::


## Performance

Indexing with `Dimension`s has no runtime cost. Let's benchmark it:

```@ansi dimarray
using BenchmarkTools
da4 = ones(X(3), Y(3))
@benchmark $da4[X(1), Y(2)]
```

the same as accessing the parent array directly:

```@ansi dimarray
@benchmark parent($da4)[1, 2]
```

```@meta
Description = "DimensionalData.jl integrations - works with Rasters.jl for GIS, YAXArrays.jl for large datasets, ClimateBase.jl and more Julia packages"
```

# Integrations

## Rasters.jl

[Rasters.jl](https://rafaqz.github.io/Rasters.jl/stable) extends DimensionalData for geospatial data manipulation, providing file load/save capabilities for a wide range of raster data sources and common GIS tools like polygon rasterization and masking. `Raster` types are aware of their `crs` and their `missingval` (which is often not `missing` for performance and storage reasons).

Rasters.jl is also the reason DimensionalData.jl exists at all! But it always made sense to separate out spatial indexing from GIS tools and dependencies.

A `Raster` is a `AbstractDimArray`, a `RasterStack` is a `AbstractDimStack`, and `Projected` and `Mapped` are `AbstractSampled` lookups.

## YAXArrays.jl

[YAXArrays.jl](https://juliadatacubes.github.io/YAXArrays.jl/dev/) is another spatial data package aimed more at (very) large datasets. Its functionality is slowly converging with Rasters.jl (both wrapping DiskArrays.jl/DimensionalData.jl) and we work closely with the developers.

`YAXArray` is a `AbstractDimArray` and inherits its behaviours.

## ClimateBase.jl

[ClimateBase.jl](https://juliaclimate.github.io/ClimateBase.jl/dev/)
Extends DimensionalData.jl with methods for analysis of climate data.

## ArviZ.jl

[ArviZ.jl](https://arviz-devs.github.io/ArviZ.jl/dev/) 
Is a Julia package for exploratory analysis of Bayesian models.

An `ArviZ.Dataset` is an `AbstractDimStack`!

## JuMP.jl

[JuMP.jl](https://jump.dev/) is a powerful optimization DSL. 
It defines its own named array types but now accepts any `AbstractDimArray` 
too, through a package extension.

## CryoGrid.jl

[CryoGrid.jl](https://juliahub.com/ui/Packages/General/CryoGrid)
A Julia implementation of the CryoGrid permafrost model.

`CryoGridOutput` uses `DimArray` for views into output data.

## DynamicGrids.jl

[DynamicGrids.jl](https://github.com/cesaraustralia/DynamicGrids.jl)
is a spatial simulation engine, for cellular automata and spatial process
models.

All DynamicGrids.jl `Outputs` are `<: AbstractDimArray`, and 
`AbstractDimArray` are used for auxiliary data to allow temporal 
synchronisation during simulations. Notably, this all works on GPUs!

## AstroImages.jl

[AstroImages.jl](http://juliaastro.org/dev/modules/AstroImages)
Provides tools to load and visualise astronomical images.
`AstroImage` is `<: AbstractDimArray`.

## TimeseriesTools.jl

[TimeseriesTools.jl](https://juliahub.com/ui/Packages/General/TimeseriesTools)
Uses `DimArray` for time-series data.

## NaNStatistics.jl

Most functions in
[NaNStatistics.jl](https://github.com/brenhinkeller/NaNStatistics.jl) support
`DimArray`'s, see [the
README](https://github.com/brenhinkeller/NaNStatistics.jl?tab=readme-ov-file#dimensionaldata-support)
for details.

```@meta
Description = "DimStacks in DimensionalData.jl - collections of arrays sharing dimensions, combining NamedTuple and array-like behavior"
```

# DimStacks

An `AbstractDimStack` represents a collection of `AbstractDimArray`
layers that share some or all dimensions. For any two layers, a dimension
of the same name must have the identical lookup - in fact, only one is stored
for all layers to enforce this consistency.


````@ansi stack
using DimensionalData
x, y = X(1.0:10.0), Y(5.0:10.0)
st = DimStack((a=rand(x, y), b=rand(x, y), c=rand(y), d=rand(x)))
````

The behavior of a `DimStack` is at times like a `NamedTuple` of
`DimArray` and, at other times, an `AbstractArray` of `NamedTuple`.

## NamedTuple-like indexing

::: tabs

== getting layers

Layers can be accessed with `.name` or `[:name]`

````@ansi stack
st.a
st[:c]
````

== subsetting layers

We can subset layers with a `Tuple` of `Symbol`:

````@ansi stack
st[(:a, :c)]
````

== inverted subsets

`Not` works on `Symbol` keys just like it does on `Selector`:
It inverts the keys to give you a `DimStack` with all the other layers:

````@ansi stack
st[Not(:b)]
st[Not((:a, :c))]
````

== merging

We can merge a `DimStack` with another `DimStack`:

````@ansi stack
st2 = DimStack((m=rand(x, y), n=rand(x, y), o=rand(y)))
merge(st, st2)
````

Or merge a `DimStack` with a `NamedTuple` of `DimArray`:

````@ansi stack
merge(st, (; d = rand(y, x), e = rand(y)))
````

Merging only works when dimensions match: 

````@ansi stack
merge(st, (; d = rand(Y('a':'n'))))
````

:::


## Array-like indexing

::: tabs

== scalars

Indexing with a scalar returns a `NamedTuple` of values, one for each layer:

````@ansi stack
st[X=1, Y=4]
````

== selectors

Selectors for single values also return a `NamedTuple`

````@ansi stack
st[X=At(2.0), Y=Near(20)]
````

== partial indexing

If not all dimensions are scalars, we return another `DimStack`.
The layers without another dimension are now zero-dimensional:

````@ansi stack
st[X=At(2.0)]
````

== linear indexing

If we index with `:` we get a `Vector{<:NamedTuple}`

````@ansi stack
st[:]
````

== broadcasting

Broadcasting over an `AbstractDimStack` behaves as broadcasting over an `AbstractDimArray` with `NamedTuple`

````@ansi stack
f(x) = (x.a + x.b) * x.c
f.(st)
````

Wrapping an `AbstractDimStack` with [DimStackArray](@ref) returns a generator that inherits from `AbstactArray`.

:::

## Reducing functions

Base functions like `mean`, `maximum`, `reverse` are applied to all layers of the stack.

````@example stack
using Statistics
````

::: tabs

== maximum

````@ansi stack
maximum(st)
maximum(st; dims=Y)
````

== minimum

````@ansi stack
minimum(st)
minimum(st; dims=Y)
````

== sum

````@ansi stack
sum(st)
sum(st; dims=Y)
````

== prod

````@ansi stack
prod(st)
prod(st; dims=Y)
````

== mean

````@ansi stack
mean(st)
mean(st; dims=Y)
````

== std

````@ansi stack
std(st)
std(st; dims=Y)
````

== var

````@ansi stack
var(st)
var(st; dims=Y)
````

== reduce

````@ansi stack
reduce(+, st)
reduce(+, st; dims=Y)
````

== extrema

````@ansi stack
extrema(st)
extrema(st; dims=Y)
````

== dropdims

````@ansi stack
sum_st = sum(st; dims=Y)
dropdims(sum_st; dims=Y)
````

:::

[`broadcast_dims`](@ref) broadcasts functions over any mix of `AbstractDimStack` and
`AbstractDimArray` returning a new `AbstractDimStack` with layers the size of
the largest layer in the broadcast. This will work even if dimension permutation 
does not match in the objects.


::: tabs

== rotl90

Only matrix layers can be rotated

````@ansi stack
rotl90(st[(:a, :b)])
rotl90(st[(:a, :b)], 2)
````

== rotr90

````@ansi stack
rotr90(st[(:a, :b)])
rotr90(st[(:a, :b)], 2)
````

== rot180

````@ansi stack
rot180(st[(:a, :b)])
rot180(st[(:a, :b)], 2)
````

== permutedims

````@ansi stack
permutedims(st)
permutedims(st, (2, 1))
permutedims(st, (Y, X))
````

== transpose

````@ansi stack
transpose(st)
````

== adjoint

````@ansi stack
adjoint(st)
st'
````

== PermutedDimsArray

````@ansi stack
PermutedDimsArray(st, (2, 1))
PermutedDimsArray(st, (Y, X))
````

:::

## Performance 

Indexing a stack is fast - indexing a single value and returning a `NamedTuple` from all 
layers is usually measured in nanoseconds, and no slower than manually indexing
into each parent array directly.

There are some compilation overheads to this though, and stacks with very many 
layers can take a long time to compile.

````@ansi stack
using BenchmarkTools
@btime $st[X=1, Y=4]
@btime $st[1, 4]
````

# Fast Fourier Transform (FFT)
`DimensionalData.jl` implements the Fast Fourier Transform (FFT) for `DimensionalArray` objects, allowing users to perform frequency domain analysis while preserving dimensional metadata.

It uses lookups to scale the forward and inverse transforms to remain physically meaningful. As such, it implements the following conventions. If we denote a signal as a function of time ``a(x)`` sampled at discrete intervals ``dx``, the discrete Fourier transform (DFT) is defined as:
```math
\operatorname{DFT}(A)[k] =
\sum_{n=1}^{\operatorname{length}(A)} \exp\left(i2π x[n]f[k] \right) A[n] dx.
```
The inverse discrete Fourier transform (IDFT) is defined as:
```math
\operatorname{IDFT}(A)[n] =
\sum_{k=1}^{\operatorname{length}(A)} \exp\left(-i2π x[n]f[k] \right) A[k] df.
```

These conventions ensure that the transforms are unitary, meaning that applying the DFT followed by the IDFT returns the original signal without any additional scaling factors. The scaling factors applied to the forward and inverse transforms are different from the "standard" discrete Fourier transform definitions, which typically does not scale the forward transform, and includes a normalization factor of `1/N` in the inverse transform.

## API

The following functions are provided for performing FFTs on `DimensionalArray` objects:

TODO

```@meta
Description = "Group dimensional data in Julia using DimensionalData.jl groupby - aggregate by time periods, bins, or custom functions"
```

# Group By

DimensionalData.jl provides a `groupby` function for dimensional
grouping. This guide covers:

- simple grouping with a function
- grouping with `Bins`
- grouping with another existing `AbstractDimArray` or `Dimension`


## Grouping functions

Let's look at the kind of functions that can be used to group `DateTime`.
Other types will follow the same principles, but are usually simpler.

First, load some packages:

````@example groupby
using DimensionalData
using Dates
using Statistics
const DD = DimensionalData
nothing # hide
````

Now create a demo `DateTime` range

````@ansi groupby
tempo = range(DateTime(2000), step=Hour(1), length=365*24*2)
````

Let's see how some common functions work.

The `hour` function will transform values to the hour of the day - the integers `0:23`

:::tabs

== hour

````@ansi groupby
hour.(tempo)
````

== day

````@ansi groupby
day.(tempo)
````

== month

````@ansi groupby
month.(tempo)
````

== dayofweek

````@ansi groupby
dayofweek.(tempo)
````

== dayofyear

````@ansi groupby
dayofyear.(tempo)
````

:::


Tuple groupings

::: tabs

== yearmonth

````@ansi groupby
yearmonth.(tempo)
````

== yearmonthday

````@ansi groupby
yearmonthday.(tempo)
````

== custom

We can create our own function that returns tuples

````@example groupby
yearday(x) = (year(x), dayofyear(x))
nothing # hide
````

You can probably guess what it does:

````@ansi groupby
yearday.(tempo)
````

:::


## Grouping and reducing

Let's define an array with a time dimension of the times used above:

````@ansi groupby
A = rand(X(1:0.01:2), Ti(tempo))
````

::: tabs

== basic

Group by month, using the `month` function:

````@ansi groupby
groups = groupby(A, Ti=>month)
````

We can take the mean of each group by broadcasting over them:

````@ansi groupby
mean.(groups)
````

== sum dayofyear

````@ansi groupby
sum.(groupby(A, Ti=>dayofyear))
````

== maximum yearmonthday

````@ansi groupby
maximum.(groupby(A, Ti=>yearmonthday))
````
== minimum yearmonth

````@ansi groupby
minimum.(groupby(A, Ti=>yearmonth))
````

== median hour

````@ansi groupby
median.(groupby(A, Ti=>hour))
````

== mean yearday

We can also use the function we defined above

````@ansi groupby
mean.(groupby(A, Ti=>yearday))
````

:::

## Binning

Sometimes we want to further aggregate our groups after running a function,
or just bin the raw data directly. We can use the [`Bins`](@ref) wrapper to
do this.

::: tabs

== evenly spaced

For quick analysis, we can break our groups into `N` bins.

````@ansi groupby
groupby(A, Ti=>Bins(month, 4))
````

Doing this requires slightly padding the bin edges, so the lookup
of the output is less than ideal.

== specific values as bins

When our function returns an `Int`, we can use a range of values we want to keep:

  ````@ansi groupby
mean.(groupby(A, Ti=>Bins(month, 1:2)))
````

== selected month bins

````@ansi groupby
mean.(groupby(A, Ti=>Bins(month, [1, 3, 5])))
````

== bin groups

We can also specify an `AbstractArray` of grouping `AbstractArray`:
Here we group by month, and bin the summer and winter months:

````@ansi groupby
groupby(A, Ti => Bins(month, [[12, 1, 2], [6, 7, 8]]; labels=x -> string.(x)))
````

== range bins

First, let's see what [`ranges`](@ref) does:

````@ansi groupby
ranges(1:8:370)
````

We can use this vector of ranges to group into blocks, here 8 days :

````@ansi groupby
groupby(A, Ti => Bins(dayofyear, ranges(1:8:370)))
````

Note: this only works where our function `dayofyear` returns
values exactly `in` the ranges. `7.5` would not be included!

== intervals bins

Intervals is like ranges, but for taking all values in  
an interval, not just discrete `Integer`s.

`intervals` returns closed-open `IntervalSets.Interval`:

````@ansi groupby
intervals(1:0.3:2)
````

We can use this to bin the `Float64` values on the `X` axis:

````@ansi groupby
groups = groupby(A, X => Bins(intervals(1:0.3:2)))
````

The lookup values of our final array are now `IntervalSets.Interval`:

````@ansi groupby
mean.(groups)
````

== seasons

There is a helper function for grouping by three-month seasons and getting
nice keys for them: `seasons`. Note you have to call it, not just pass it!

````@ansi groupby
groupby(A, Ti => seasons())
````

We could also start our seasons in January:

````@ansi groupby
groupby(A, Ti => seasons(; start=January))
````

== months

We can also use `months` to group into arbitrary
group sizes, starting wherever we like:

````@ansi groupby
groupby(A, Ti => months(2; start=6))
````

== hours

`hours` works a lot like `months`. Here we group into day
and night - two 12 hour blocks starting at 6am:

````@ansi groupby
groupby(A, Ti => hours(12; start=6, labels=x -> 6 in x ? :night : :day))
````

:::

## Select by Dimension
- [`Dimension`](@ref)

We can also select by `Dimension`s and any objects with `dims` methods.

::: tabs

== groupby dims

Trivially, grouping by an object's own dimension is similar to `eachslice`:

````@ansi groupby
groupby(A, dims(A, Ti))
````

== groupby AbstractDimArray

But we can also group by other objects' dimensions:

````@ansi groupby
B = A[:, 1:3:100]
C = mean.(groupby(A, B))
@assert size(C) == size(B)
````

:::

_TODO: Apply custom function (i.e. normalization) to grouped output._

```@meta
Description = "Convert between Python Xarray and DimensionalData.jl - seamless interoperability for multidimensional arrays via PythonCall.jl"
```

# Xarray and PythonCall.jl

In the Python ecosystem [Xarray](https://xarray.dev) is by far the most popular
package for working with multidimensional labelled arrays. The main data
structures it provides are:
- [DataArray](https://docs.xarray.dev/en/stable/user-guide/data-structures.html#dataarray),
  analagous to `DimArray`.
- [Dataset](https://docs.xarray.dev/en/stable/user-guide/data-structures.html#dataset),
  analagous to `DimStack`.

DimensionalData integrates with
[PythonCall.jl](https://juliapy.github.io/PythonCall.jl/stable/) to allow
converting these Xarray types to their DimensionalData equivalent:
```julia
import PythonCall: pyconvert

# By default this will share the underlying array
my_dimarray = pyconvert(DimArray, my_dataarray)

my_dimstack = pyconvert(DimStack, my_dataset)
```

Here are some things to keep in mind when converting:
- `pyconvert(DimArray, x)` is zero-copy by default, i.e. it will share the
  underlying array with Python and register itself with Pythons GC to ensure
  that the memory isn't garbage-collected prematurely. If you want to make a
  copy you can call it like `pyconvert(DimArray, x; copy=true)`.
- When doing a zero-copy conversion from `x` to `x_jl`, `parent(x_jl)` will be a
  [PyArray](https://juliapy.github.io/PythonCall.jl/stable/pythoncall-reference/#PythonCall.Wrap.PyArray). In
  most situations there should be no overhead from this but note that a
  `PyArray` is not a `DenseArray` so some operations that dispatch on
  `DenseArray` may not be performant, e.g. BLAS calls. See these issues for more
  information:
  - https://github.com/JuliaPy/PythonCall.jl/issues/319
  - https://github.com/JuliaPy/PythonCall.jl/issues/182

  When `copy=true`, `parent(x_jl)` will always be a standard `Array`. However,
  we do not consider the type of parent array covered by semver so this may
  change in the future.
- Python stores arrays in row-major order whereas Julia stores them in
  column-major order, hence the dimensions on a converted `DimArray` will be in
  reverse order from the original `DataArray`. This is done to ensure that the
  'fast axis' to iterate over is the same dimension in both Julia and Python.

```@meta
Description = "DimensionalData.jl getter methods - retrieve dimensions, lookups, metadata and values from DimArrays and DimStacks in Julia"
```

# Getters

DimensionalData.jl defines consistent methods to retrieve information
from objects like `DimArray`, `DimStack`, `Tuple`s of `Dimension`,
`Dimension`, and `Lookup`.

First, we will define an example `DimArray`.

```@example getters
using DimensionalData
using DimensionalData.Lookups
x, y = X(10:-1:1), Y(100.0:10:200.0)
```

```@ansi getters
A = rand(x, y)
```

::: tabs

== dims

`dims` retrieves dimensions from any object that has them.

What makes it so useful is that you can filter which dimensions
you want, and specify in what order, using any `Dimension`, `Type{Dimension}`
or `Symbol`.

```@ansi getters
dims(A)
dims(A, Y)
dims(A, Y())
dims(A, :Y)
dims(A, (X,))
dims(A, (Y, X))
dims(A, reverse(dims(A)))
dims(A, isregular)
```

== otherdims

`otherdims` is just like `dims` but returns whatever
`dims` would _not_ return from the same query.

```@ansi getters
otherdims(A, Y)
otherdims(A, Y())
otherdims(A, :Y)
otherdims(A, (X,))
otherdims(A, (Y, X))
otherdims(A, dims(A))
otherdims(A, isregular)
```

== lookup

Get all the `Lookup` in an object

```@ansi getters
lookup(A)
lookup(dims(A))
lookup(A, X)
lookup(dims(A, Y))
```

== val

`val` is used where there is an unambiguous single value:

```@ansi getters
val(X(7))
val(At(10.5))
```

== order

Get the order of a `Lookup`, or a `Tuple`
from a `DimArray` or `DimTuple`.

```@ansi getters
order(A)
order(dims(A))
order(A, X)
order(lookup(A, Y))
```

== sampling

Get the sampling of a `Lookup`, or a `Tuple`
from a `DimArray` or `DimTuple`.

```@ansi getters
sampling(A)
sampling(dims(A))
sampling(A, X)
sampling(lookup(A, Y))
```

== span

Get the span of a `Lookup`, or a `Tuple`
from a `DimArray` or `DimTuple`.

```@ansi getters
span(A)
span(dims(A))
span(A, X)
span(lookup(A, Y))
```

== locus

Get the locus of a `Lookup`, or a `Tuple`
from a `DimArray` or `DimTuple`.

(`locus` is our term for distinguishing if an lookup value
specifies the start, center, or end of an interval)

```@ansi getters
locus(A)
locus(dims(A))
locus(A, X)
locus(lookup(A, Y))
```

== bounds

Get the bounds of each dimension. This is different for `Points` 
and `Intervals` - the bounds for points of a `Lookup` are 
simply `(first(l), last(l))`.

```@ansi getters
bounds(A)
bounds(dims(A))
bounds(A, X)
bounds(lookup(A, Y))
```

== intervalbounds

Get the bounds of each interval along a dimension.

```@ansi getters
intervalbounds(A)
intervalbounds(dims(A))
intervalbounds(A, X)
intervalbounds(lookup(A, Y))
```

== extent

[Extents.jl](https://github.com/rafaqz/Extent) provides an `Extent` 
object that combines the names of dimensions with their bounds. 

```@ansi getters
using Extents: extent
extent(A)
extent(A, X)
extent(dims(A))
extent(dims(A, Y))
```

:::


## Predicates

These always return `true` or `false`. With multiple
dimensions, `false` means `!all` and `true` means `all`.

`dims` and all other methods listed above can use predicates
to filter the returned dimensions.

::: tabs

== issampled

```@ansi getters
issampled(A)
issampled(dims(A))
issampled(A, Y)
issampled(lookup(A, Y))
dims(A, issampled)
otherdims(A, issampled)
lookup(A, issampled)
```

== iscategorical

```@ansi getters
iscategorical(A)
iscategorical(dims(A))
iscategorical(dims(A, Y))
iscategorical(lookup(A, Y))
dims(A, iscategorical)
otherdims(A, iscategorical)
lookup(A, iscategorical)
```

== iscyclic

```@ansi getters
iscyclic(A)
iscyclic(dims(A))
iscyclic(dims(A, Y))
iscyclic(lookup(A, Y))
dims(A, iscyclic)
otherdims(A, iscyclic)
```

== isordered

```@ansi getters
isordered(A)
isordered(dims(A))
isordered(A, X)
isordered(lookup(A, Y))
dims(A, isordered)
otherdims(A, isordered)
```

== isforward

```@ansi getters
isforward(A)
isforward(dims(A))
isforward(A, X)
dims(A, isforward)
otherdims(A, isforward)
```

== isreverse

```@ansi getters
isreverse(A)
isreverse(dims(A))
isreverse(A, X)
dims(A, isreverse)
otherdims(A, isreverse)
```

== isintervals

```@ansi getters
isintervals(A)
isintervals(dims(A))
isintervals(A, X)
isintervals(lookup(A, Y))
dims(A, isintervals)
otherdims(A, isintervals)
```

== ispoints

```@ansi getters
ispoints(A)
ispoints(dims(A))
ispoints(A, X)
ispoints(lookup(A, Y))
dims(A, ispoints)
otherdims(A, ispoints)
```

== isregular

```@ansi getters
isregular(A)
isregular(dims(A))
isregular(A, X)
dims(A, isregular)
otherdims(A, isregular)
```

== isexplicit

```@ansi getters
isexplicit(A)
isexplicit(dims(A))
isexplicit(A, X)
dims(A, isexplicit)
otherdims(A, isexplicit)
```

== isstart

```@ansi getters
isstart(A)
isstart(dims(A))
isstart(A, X)
dims(A, isstart)
otherdims(A, isstart)
```

== iscenter

```@ansi getters
iscenter(A)
iscenter(dims(A))
iscenter(A, X)
dims(A, iscenter)
otherdims(A, iscenter)
```

== isend

```@ansi getters
isend(A)
isend(dims(A))
isend(A, X)
dims(A, isend)
otherdims(A, isend)
```

:::

```@meta
Description = "DimensionalData.jl selectors - flexible value-based indexing with At, Near, Between, Contains, and more for dimensional arrays"
```

# Selectors

In addition to choosing dimensions by name, we can also select values within them.

First, we can create a `DimArray` with lookup values as well as dimension names:

````@example selectors
using DimensionalData
````

````@ansi selectors
A = rand(X(1.0:0.2:2.0), Y([:a, :b, :c]))
````

Then we can use the [`Selector`](@ref) to select values from the array:

::: tabs

== At

The [`At(x)`](@ref) selector gets the index or indices exactly matching the passed in value(s). 

````@ansi selectors
A[X=At(1.2), Y=At(:c)]
````

Or within a tolerance:

````@ansi selectors
A[X=At(0.99:0.201:1.5; atol=0.05)]
````

[`At`](@ref) can also take vectors and ranges:

````@ansi selectors
A[X=At(1.2:0.2:1.5), Y=At([:a, :c])]
````

== Near

The [`Near(x)`](@ref) selector gets the closest index to the passed in value(s), indexing with an `Int`.

````@ansi selectors
A[X=Near(1.245)]
````

`Near` can also take vectors and ranges, which indexes with a `Vector{Int}`

````@ansi selectors
A[X=Near(1.1:0.25:1.5)]
````

== Contains

The [`Contains(x)`](@ref) selector gets indices where the value x falls within an interval in the lookup. 

First, set the `X` axis to be `Intervals`:

````@ansi selectors
using DimensionalData.Lookups
A_intervals = set(A, X => Intervals(Start()))
intervalbounds(A_intervals, X)
````

With a single value, it is like indexing with `Int`

````@ansi selectors
A_intervals[X=Contains(1.245)]
````

`Contains` can also take vectors and ranges, which is like indexing with `Vector{Int}`

````@ansi selectors
A_intervals[X=Contains(1.1:0.25:1.5)]
````

== ..

The `..` or `IntervalSets.Interval` selector selects a range of values:
`..` is like indexing with a `UnitRange`:

````@ansi selectors
A[X=1.2 .. 1.6]
````

````@ansi selectors
using IntervalSets
A[X=OpenInterval(1.2 .. 1.6)]
````

````@ansi selectors
A[X=Interval{:close,:open}(1.2 .. 1.6)]
````

== Touches

The [`Touches`](@ref) selector is like `..`, but for `Intervals`, it will include intervals touched by the selected interval, not inside it.

This usually means including zero, one, or two cells more than `..`
`Touches` is like indexing with a `UnitRange`

````@ansi selectors
A_intervals[X=Touches(1.1, 1.5)]
A_intervals[X=1.1 .. 1.5]
````

== Where

The [`Where(f)`](@ref) selector filters the array axis by a function of the dimension index values. 
`Where` is like indexing with a `Vector{Bool}`:

````@ansi selectors
A[X=Where(>=(1.5)), Y=Where(x -> x in (:a, :c))]
````

== Not

The `Not(x)` selector gets all indices _not_ selected by `x`, which can be another selector.
`Not` is like indexing with a `Vector{Bool}`.

````@ansi selectors
A[X=Not(Near(1.3)), Y=Not(Where(in((:a, :c))))]
````

:::

## Lookups

Selectors find indices in the `Lookup` of each dimension.
Lookups wrap other `AbstractArray` (often `AbstractRange`) but add additional traits to facilitate fast lookups or specifying point or interval behaviour. These are usually detected automatically.


````@example selectors
using DimensionalData.Lookups
````
::: tabs

== Sampled lookups

The [`Sampled(x)`](@ref) lookup holds values sampled along an axis.
They may be `Ordered`/`Unordered`, `Intervals`/`Points`, and `Regular`/`Irregular`.

Most of these properties are usually detected automatically,
but here we create a `Sampled` lookup manually:

````@ansi selectors
l = Sampled(10.0:10.0:100.0; order=ForwardOrdered(), span=Regular(10.0), sampling=Intervals(Start()))
````

To specify `Irregular` `Intervals`, we should include the outer bounds of the lookup, as we can't determine them from the vector.

````@ansi selectors
l = Sampled([13, 8, 5, 3, 2, 1]; order=ForwardOrdered(), span=Irregular(1, 21), sampling=Intervals(Start()))
````

== Categorical lookup

The [`Categorical(x)`](@ref) lookup is a categorical lookup that holds categories,
and may be ordered.

Create a [`Categorical`](@ref) lookup manually

````@ansi selectors
l = Categorical(["mon", "tue", "weds", "thur", "fri", "sat", "sun"]; order=Unordered())
````

== Cyclic lookups

The [`Cyclic(x)`](@ref) lookup is an `AbstractSampled` lookup for cyclical values.

Create a [`Cyclic`](@ref) lookup that cycles over 12 months.

````@ansi selectors
using Dates
l = Cyclic(DateTime(2000):Month(1):DateTime(2000, 12); cycle=Month(12), sampling=Intervals(Start()))
````

There is a shorthand to make a `DimArray` from a `Dimension` with a function of the lookup values. Here we convert the values to the month names:

````@ansi selectors
A = DimArray(monthabbr, X(l))
````

Now we can select any date and get the month:

````@ansi selectors
A[At(DateTime(2005, 4))]
A[At(DateTime(3047, 9))]
````

== NoLookup

The [`NoLookup(x)`](@ref) lookup has no lookup values provided, so `Selector`s will not work.
When you create a `DimArray` without a lookup array, `NoLookup` will be used.
It is also not shown in REPL printing.

Here we create a [`NoLookup`](@ref):

````@ansi selectors
l = NoLookup()
typeof(l)
````

Or even fill in the axis:
````@ansi selectors
l = NoLookup(Base.OneTo(10))
typeof(l)
````

:::

## Lookup autodetection

When we define an array, extra properties are detected:

````@ansi selectors
A = DimArray(rand(7, 5), (X(10:10:70), Y([:a, :b, :c, :d, :e])))
````

This array has a `Sampled` lookup with `ForwardOrdered` `Regular`
`Points` for `X`, and a `Categorical` `ForwardOrdered` for `Y`.

Most lookup types and properties are detected automatically like this
from the arrays and ranges used.

- Arrays and ranges of `String`, `Symbol`, and `Char` are set to `Categorical` lookup.
    - `order` is detected as `Unordered`, `ForwardOrdered`, or `ReverseOrdered`
- Arrays and ranges of `Number`, `DateTime`, and other things are set to `Sampled` lookups.
    - `order` is detected as `Unordered`, `ForwardOrdered`, or `ReverseOrdered`.
    - `sampling` is set to `Points()` unless the values are `IntervalSets.Interval`,
        then `Intervals(Center())` is used.
    - `span` is detected as `Regular(step(range))` for `AbstractRange` and
        `Irregular(nothing, nothing)` for other `AbstractArray`, where `nothing,
        nothing` are the unknown outer bounds of the lookup. They are not needed
        for `Points` as the outer values are the outer bounds. But they can be
        specified manually for `Intervals`
    - Empty dimensions or dimension types are assigned `NoLookup()` ranges that
        can't be used with selectors as they hold no values.

## `DimSelector`

We can also index with arrays of selectors [`DimSelectors`](@ref).
These are like `CartesianIndices` or [`DimIndices`](@ref), but holding
the `Selectors` `At`, `Near`, or `Contains`.

````@ansi selectors
A = rand(X(1.0:0.2:2.0), Y(10:2:20))
````

We can define another array with partly matching indices

````@ansi selectors
B = rand(X(1.0:0.04:2.0), Y(20:-1:10))
````

And we can simply select values from `B` with selectors from `A`:

````@ansi selectors
B[DimSelectors(A)]
````

If the lookups aren't aligned, we can use `Near` instead of `At`,
which is like doing a nearest neighbor interpolation:

````@ansi selectors
C = rand(X(1.0:0.007:2.0), Y(10.0:0.9:30))
C[DimSelectors(A; selectors=Near)]
````

```@meta
Description = "Extend DimensionalData.jl - create custom array types, stacks, and lookups by implementing key interface methods in Julia"
```

# Extending DimensionalData

Nearly everything in DimensionalData.jl is designed to be extensible.

- `AbstractDimArray` is easily extended to custom array types. `Raster` or
  `YAXArray` are examples from other packages.
- `AbstractDimStack` is easily extended to custom mixed array datasets.
    `RasterStack` or `ArViZ.Dataset` are examples.
- `Lookup` can have new types added, e.g. to `AbstractSampled` or
  `AbstractCategorical`. For example, `Rasters.Projected` is a lookup that knows
  its coordinate reference system, but otherwise behaves as a regular
  `Sampled` lookup.

`dims`, `rebuild` and `format` are the key interface methods in most of these cases.

## `dims`

Objects extending DimensionalData.jl that have dimensions must return 
a `Tuple` of constructed `Dimension`s from `dims(obj)`, like `(X(), Y())`.

### `Dimension` axes

Dimensions returned from `dims` should hold a `Lookup` or in some cases 
just an `AbstractArray` (like with `DimIndices`). When attached to 
multi-dimensional objects, lookups must be the _same length_ as the axis 
of the array it represents, and `eachindex(A, i)` and `eachindex(dim)` must 
return the same values. 

This means that if the array has OffsetArrays.jl axes, the array the dimension 
wraps must also have OffsetArrays.jl axes.

### `dims` keywords

To any `dims` keyword argument that usually requires the dimension I,
objects should accept any `Dimension`, `Type{<:Dimension}`, `Symbol`,
`Val{:Symbol}`, `Val{<:Type{<:Dimension}}` or also regular `Integer`. 

This is easier than it sounds, calling `DD.dims(objs, dims)` will
return the matching dimension and `DD.dimnum(obj, dims)` will return
the matching `Int` for any of these inputs as long as `dims(obj)` is
implemented.


## `rebuild`

Rebuild methods are used to rebuild immutable objects with new field values,
in a more flexible and extensible way than just using ConstructionBase.jl
reconstruction. Developers can choose to ignore some of the fields passed
by `rebuild`.

The function signature is always one of:

```julia
rebuild(obj, args...)
rebuild(obj; kw...)
```

`rebuild` has keyword versions automatically generated for all objects
using [ConstructionBase.jl](https://github.com/JuliaObjects/ConstructionBase.jl). 

These will work without further work as long as your object has the fields 
used by DimensionalData.jl objects. For example, `AbstractDimArray` will 
receive these keywords in `rebuild`: `data`, `dims`, `refdims`, `name`, `metadata`. 

If your `AbstractDimArray` does not have all these fields, you must implement
`rebuild(x::YourDimArray; kw...)` manually.

An argument method is also defined with the same arguments as the 
keyword version. For `AbstractDimArray` it should only be used for 
updating `data` and `dims`, any more that that is confusing.

For `Dimension` and `Selector` the single argument versions are easiest to use, 
as there is only one argument.


## `format`

When constructing an `AbstractDimArray` or `AbstractDimStack` 
[`DimensionalData.format`](@ref) must be called on the `dims` tuple and the parent array:

```julia
format(dims, array)
```

This lets DimensionalData detect the lookup properties, fill in missing fields
of a `Lookup`, pass keywords from `Dimension` to detected `Lookup` 
constructors, and accept a wider range of dimension inputs like tuples of `Symbol` 
and `Type`.  The way you indicate that something needs to be filled is by using the `Auto` types, like [`AutoOrder`](@ref) or `AutoSampling`.

Not calling `format` in the outer constructors of an `AbstractDimArray`
has undefined behaviour.

When creating lookup types, you need to define `DimensionalData.format` on your lookup type.


## Interfaces.jl interface testing

DimensionalData defines explicit, testable Interfaces.jl interfaces:
`DimArrayInterface` and `DimStackInterface`.

::: tabs

== array

This is the implementation definition for `DimArray`:

````@ansi interfaces
using DimensionalData, Interfaces
@implements DimensionalData.DimArrayInterface{(:refdims,:name,:metadata)} DimArray [rand(X(10), Y(10)), zeros(Z(10))]
````

See the [`DimensionalData.DimArrayInterface`](@ref) docs for options. We can test it with:

````@ansi interfaces
Interfaces.test(DimensionalData.DimArrayInterface)
````

== stack

The implementation definition for `DimStack`:

````@ansi interfaces
@implements DimensionalData.DimStackInterface{(:refdims,:metadata)} DimStack [DimStack(zeros(Z(10))), DimStack(rand(X(10), Y(10))), DimStack(rand(X(10), Y(10)), rand(X(10)))]
````

See the [`DimensionalData.DimStackInterface`](@ref) docs for options. We can test it with:

````@ansi interfaces
Interfaces.test(DimensionalData.DimStackInterface)
````

:::

```@meta
Description = "Modify DimensionalData.jl objects - rebuild immutable structs, update arrays in-place, use set and modify for transformations"
```

# Modifying Objects

DimensionalData.jl objects are all `struct` rather than
`mutable struct`. The only things you can modify in-place
are the values of the contained arrays or metadata `Dict`s if
they exist.

Everything else must be _rebuilt_ and assigned to a variable.

## `modify`

Modify the inner arrays of a `AbstractDimArray` or `AbstractDimStack`, with
[`modify`](@ref). This can be useful to e.g. replace all arrays with `CuArray`
moving the data to the GPU, `collect` all inner arrays to `Array` without losing
the outer `DimArray` wrappers, and similar things.

::::tabs

== array

````@ansi helpers
using DimensionalData
A = falses(X(3), Y(5))
parent(A)
A_mod = modify(Array, A)
parent(A_mod)
````

== stack

For a stack, this applies to all layers, and is where `modify`
starts to be more powerful:

````@ansi helpers
st = DimStack((a=falses(X(3), Y(5)), b=falses(X(3), Y(5))))
parent(st.a)
parent(modify(Array, st).a)
parent(modify(Array, st).b)
````

::::

## `reorder`

[`reorder`](@ref) is like reverse but declarative, rather than
imperative: we tell it how we want the object to be, not what to do.

::::tabs

== specific dimension/s

Reorder a specific dimension

````@ansi helpers
using DimensionalData.Lookups;
A = rand(X(1.0:3.0), Y('a':'n'));
reorder(A, X => ReverseOrdered())
````

== all dimensions

````@ansi helpers
reorder(A, ReverseOrdered())
````

::::

## `mergedims`

[`mergedims`](@ref) is like `reshape`, but simultaneously merges multiple
dimensions into a single combined dimension with a lookup holding
`Tuples` of the values of both dimensions.


## [`rebuild`](@id sec-rebuild)

[`rebuild`](@ref) is one of the core functions of DimensionalData.jl.
Basically everything uses it somewhere. And you can too, with a few caveats.

!!! warning

    `rebuild` assumes you _know what you are doing_. You can quite easily set
    values to things that don't make sense. The constructor may check a few things,
    like the number of dimensions matches the axes of the array. But not much else.

:::: tabs

== change the name

````@ansi helpers
A1 = rebuild(A; name=:my_array)
name(A1)
````

== change the metadata

````@ansi helpers
A1 = rebuild(A; metadata=Dict(:a => "foo", :b => "bar"))
metadata(A1)
````

::::

The most common use internally is the arg version on `Dimension`.
This is _very_ useful in dimension-based algorithms as a way
to transform a dimension wrapper from one object to another:

```@ansi helpers
d = X(1)
rebuild(d, 1:10)
```

`rebuild` applications are listed here. `AbstractDimArray` and
`AbstractDimStack` _always_ accept these keywords or arguments,
but those in [ ] brackets may be thrown away if not needed.
Keywords in ( ) will error if used where they are not accepted.

| Type                       | Keywords                                                                | Arguments            |
|:-------------------------- |:----------------------------------------------------------------------- |:---------------------|
| [`AbstractDimArray`](@ref) | `data`, `dims`, [`refdims`, `name`, `metadata`]                         | as with kw, in order |
| [`AbstractDimStack`](@ref) | `data`, `dims`, [`refdims`], `layerdims`, [`metadata`, `layermetadata`] | as with kw, in order |
| [`Dimension`](@ref)        | `val`                                                                   | val                  |
| [`Selector`](@ref)         | `val`, (`atol`)                                                         | val                  |
| [`Lookup`](@ref)           | `data`, (`order`, `span`, `sampling`, `metadata`)                       | keywords only        |

### `rebuild` magic

`rebuild` with keywords will even work on objects DD doesn't know about!

````@ansi helpers
nt = (a = 1, b = 2)
rebuild(nt, a = 99)
````

Really, the keyword version is just `ConstructionBase.setproperties` underneath,
but wrapped so objects can customise the DD interface without changing the
more generic ConstructionBase.jl behaviours and breaking e.g. Accessors.jl in
the process.

## `set`

[`set`](@ref) gives us a way to set the values of the immutable objects
in DD, like `Dimension` and `LookupArray`. Unlike `rebuild` it tries its best
to _do the right thing_. You don't have to specify what field you want to set.
Just pass in the object you want to be part of the lookup. Usually, there is
no possible ambiguity.

`set` is still improving. Sometimes it may not do the right thing.
If you think this is the case, create a
[GitHub issue](https://github.com/rafaqz/DimensionalData.jl/issues).

:::: tabs

=== set the dimension wrapper

````@ansi helpers
set(A, Y => Z)
````

=== clear the lookups

````@ansi helpers
set(A, X => NoLookup, Y => NoLookup)
````

=== set different lookup values

````@ansi helpers
set(A, Y => 10:10:140)
````

=== set lookup type as well as values

Change the values but also set the type to Sampled. TODO: broken

````@ansi helpers
set(A, Y => Sampled(10:10:140))
````

=== set the points in X to be intervals

````@ansi helpers
set(A, X => Intervals)
````

=== set the categories in Y to be `Unordered`

````@ansi helpers
set(A, Y => Unordered)
````

:::

```@meta
Description = "Dimensions in DimensionalData.jl - named wrapper types for array axes, including spatial (X,Y,Z) and temporal (Ti) dimensions, and more!"
```

# Dimensions

Dimensions are "wrapper types" that can be used to wrap any 
object to associate it with a named dimension. 

`X`, `Y`, `Z`, `Ti` are predefined as types:

```@ansi dimensions
using DimensionalData
X(1)
X(1), Y(2), Z(3)
```

You can also create [`Dim`](@ref) dimensions with any name:

```@ansi dimensions
Dim{:a}(1), Dim{:b}(1)
```

The wrapped value can be retrieved with `val`:

```@ansi dimensions
val(X(1))
```

DimensionalData.jl uses `Dimensions` everywhere: 

- `Dimension`s are returned from `dims` to specify the names of the dimensions of an object
- They can wrap [`Dimensions.Lookups`](@ref) to associate the lookups with those names
- To index into these objects, they can wrap indices like `Int` or a `Selector` 

This symmetry means we can ignore how data is organized, 
and label and access it by name, letting DD work out the details for us.

Dimensions are defined in the [`DimensionalData.Dimensions`](@ref) submodule, and some 
Dimension-specific methods can be brought into scope with:

```julia
using DimensionalData.Dimensions
```

```@meta
Description = "Plotting DimensionalData.jl arrays with Makie.jl and Plots.jl - automatic axis labels and dimension-aware visualizations"
```

# Plots.jl

Plots.jl and Makie.jl functions mostly work out of the box on `AbstractDimArray`,
although not with the same results - they choose to follow each packages default
behaviour as much as possible. 

This will plot a line plot with 'a', 'b' and 'c' in the legend,
and values 1-10 on the labelled X axis:


Plots.jl support is deprecated, as development is moving to Makie.jl


# Makie.jl

Makie.jl functions also mostly work with [`AbstractDimArray`](@ref) and will `permute` and 
[`reorder`](@ref) axes into the right places, especially if `X`/`Y`/`Z`/`Ti` dimensions are used.

In Makie a `DimMatrix` will plot as a heatmap by default, but it will have labels 
and axes in the right places:

```@example Makie
using DimensionalData, CairoMakie
CairoMakie.activate!(type = :svg) # hide

A = rand(X(10:10:100), Y([:a, :b, :c]))
Makie.plot(A; colormap=:inferno)
```

Other plots also work, here DD ignores the axis order and instead 
favours the categorical variable for the X axis:

```@example Makie
Makie.rainclouds(A)
```

## AlgebraOfGraphics.jl

AlgebraOfGraphics.jl is a high-level plotting library built on top of Makie.jl that provides a declarative algebra for creating complex visualizations, similar to `ggplot2`'s "grammar of graphics" in R. It allows you to construct plots using algebraic operations like `*` and `+`, making it easy to create sophisticated graphics with minimal code.

Any `DimensionalArray` is also a `Tables.jl` table, so it can be used with `AlgebraOfGraphics.jl` directly.  You can indicate columns in `mapping` with Symbols directly (like `:X` or `:Y`), **or** you can use the `Dim` type directly (like `X` or `Y`)! 

!!! note
    If your dimensional array is not named, then you can access the data as the **`:unnamed`** column.
    Otherwise, the data is accessible by its name.

Let's start with a simple example, and plot a 2-D dimarray as a scatter plot, colored by its value.

```@example Makie
using DimensionalData, AlgebraOfGraphics, CairoMakie
CairoMakie.activate!(type = :svg) # hide

A = DimArray(rand(10, 10), (X(1:10), Y(1:10)), name = :data)

data(A) * mapping(X, Y; color = :data) * visual(Scatter) |> draw
```

Don't restrict yourself to standard visualizations!  You can use all of AlgebraOfGraphics' features.

Let's plot each X-slice, faceted in Y:

```@example Makie
data(A) * mapping(X, :data; layout = Y => nonnumeric) * visual(Lines) |> draw
```

This approach is also applicable to `DimStack`s, since they also convert to DimTables.  Let's see an example here.

We'll construct a DimStack with the `:data` layer being our DimArray `A`, and an X-only variable `:color` that we'll use to color the line.

```@example Makie
color_vec = DimVector(1:10, X)
ds = DimStack((; data = A, color = color_vec))

data(ds) * mapping(X, :data; color = :color, layout = Y => nonnumeric) * visual(Lines) |> draw
```

!!! note
    If you wish to subset your DimArray, you can't pass selectors like `X(1 .. 2)` to AlgebraOfGraphics.  
    Instead, subset the DimArray you pass to `data` - this is a very cheap operation.

## Test series plots

### default colormap

```@example Makie
B = rand(X(10:10:100), Y([:a, :b, :c, :d, :e, :f, :g, :h, :i, :j]))
Makie.series(B)
```

### A different colormap
The colormap is controlled by the `color` argument, which can take as an input a named colormap, i.e. `:plasma` or a list of colours. 

```@example Makie
Makie.series(B; color=:plasma)
```

```@example Makie
Makie.series(A; color=[:red, :blue, :orange])
```
### with markers

```@example Makie
Makie.series(A; color=[:red, :blue, :orange], markersize=15)
```

A lot more is planned for Makie.jl plots in future!

```@meta
Description = "GPU computing with DimensionalData.jl - seamlessly use CUDA/GUP arrays with dimensional metadata for high-performance Julia computations with minimal effort"
```

# CUDA & GPUs

Running regular julia code on GPUs is one of the most amazing things
about the language. DimensionalData.jl leans into this as much as possible.

```julia
using DimensionalData, CUDA

# Create a Float32 array to use on the GPU
A = rand(Float32, X(1.0:1000.0), Y(1.0:2000.0))

# Move the parent data to the GPU with `modify` and the `CuArray` constructor:
cuA = modify(CuArray, A)
```

The result of a GPU broadcast is still a `DimArray`:

```julia-repl
julia> cuA2 = cuA .* 2
╭───────────────────────────────╮
│ 1000×2000 DimArray{Float32,2} │
├───────────────────────────────┴────────────────────────────── dims ┐
  ↓ X Sampled{Float64} 1.0:1.0:1000.0 ForwardOrdered Regular Points,
  → Y Sampled{Float64} 1.0:1.0:2000.0 ForwardOrdered Regular Points
└────────────────────────────────────────────────────────────────────┘
    ↓ →  1.0       2.0        3.0        4.0       …  1998.0        1999.0        2000.0
    1.0  1.69506   1.28405    0.989952   0.900394        1.73623       1.30427       1.98193
    2.0  1.73591   0.929995   0.665742   0.345501        0.162919      1.81708       0.702944
    3.0  1.24575   1.80455    1.78028    1.49097         0.45804       0.224375      0.0197492
    4.0  0.374026  1.91495    1.17645    0.995683        0.835288      1.54822       0.487601
    5.0  1.17673   0.0557598  0.183637   1.90645   …     0.88058       1.23788       1.59705
    6.0  1.57019   0.215049   1.9155     0.982762        0.906838      0.1076        0.390081
    ⋮                                              ⋱                              
  995.0  1.48275   0.40409    1.37963    1.66622         0.462981      1.4492        1.26917
  996.0  1.88869   1.86174    0.298383   0.854739  …     0.778222      1.42151       1.75568
  997.0  1.88092   1.87436    0.285965   0.304688        1.32669       0.0599431     0.134186
  998.0  1.18035   1.61025    0.352614   1.75847         0.464554      1.90309       1.30923
  999.0  1.40584   1.83056    0.0804518  0.177423        1.20779       1.95217       0.881149
 1000.0  1.41334   0.719974   0.479126   1.92721         0.0649391     0.642908      1.07277
```

But the data is on the GPU:

```julia-repl
julia> typeof(parent(cuA2))
CuArray{Float32, 2, CUDA.Mem.DeviceBuffer}
```

## GPU Integration goals

DimensionalData.jl has two GPU-related goals:

1. Work seamlessly with `Base` Julia broadcasts and other operations that already
   work on GPU.
2. Work as arguments to custom GPU kernel functions.

This means any `AbstractDimArray` must be automatically moved to the GPU and its
fields converted to GPU-friendly forms whenever required, using [Adapt.jl](https://github.com/JuliaGPU/Adapt.jl).

- The array data must convert to the correct GPU array backend 
  when `Adapt.adapt(dimarray)` is called.
- All DimensionalData.jl objects, except the actual parent array, need to be immutable `isbits` or
  convertible to them. This is one reason DimensionalData.jl uses `rebuild` and a functional style,
  rather than in-place modification of fields.
- Symbols need to be moved to the type system, so `Name{:layer_name}()` replaces `:layer_name`.
- Metadata dictionaries need to be stripped, as they are often too difficult to convert
  and not needed on GPU.

As an example, [DynamicGrids.jl](https://github.com/cesaraustralia/DynamicGrids.jl) uses `AbstractDimArray` for auxiliary 
model data that are passed into [KernelAbstractions.jl](https://github.com/JuliaGPU/KernelAbstractions.jl)/
[CUDA.jl](https://github.com/JuliaGPU/CUDA.jl) kernels.

```@meta
Description = "DiskArrays.jl integration with DimensionalData.jl - lazy chunked operations for large datasets from disk and cloud storage"
```

# DiskArrays.jl compatibility

[DiskArrays.jl](https://github.com/meggart/DiskArrays.jl) enables lazy, chunked application of:

- broadcast
- reductions
- iteration
- generators
- zip

as well as caching chunks in RAM via `DiskArrays.cache(dimarray)`.

It is rarely used directly, but is present in most 
disk and cloud based spatial data packages in julia, including:
[ArchGDAL.jl](https://github.com/yeesian/ArchGDAL.jl), 
[NetCDF.jl](https://github.com/JuliaGeo/NetCDF.jl),
[Zarr.jl](https://github.com/JuliaIO/Zarr.jl),
[NCDatasets.jl](https://github.com/Alexander-Barth/NCDatasets.jl),
[GRIBDatasets.jl](https://github.com/JuliaGeo/GRIBDatasets.jl) and
[CommonDataModel.jl](https://github.com/JuliaGeo/CommonDataModel.jl).

The combination of DiskArrays.jl and DimensionalData.jl is Julia's answer to
python's [xarray](https://xarray.dev/). [Rasters.jl](https://github.com/rafaqz/Rasters.jl) and [YAXArrays.jl](https://github.com/JuliaDataCubes/YAXArrays.jl) are user-facing 
tools building on this combination.


They have no meaningful direct dependency relationships, but are intentionally 
designed to integrate via both adherence to Julia's `AbstractArray` 
interface, and by coordination during development of both packages.

```@meta
Description = "Convert DimensionalData.jl arrays to Tables.jl format and DataFrames - seamless interoperability with Julia's data ecosystem"
```

# Tables and DataFrames

[Tables.jl](https://github.com/JuliaData/Tables.jl) provides an ecosystem-wide interface to tabular data in Julia, ensuring interoperability with [DataFrames.jl](https://dataframes.juliadata.org/stable/), [CSV.jl](https://csv.juliadata.org/stable/), and hundreds of other packages that implement the standard.

## Dimensional data are tables
DimensionalData.jl implements the Tables.jl interface for `AbstractDimArray` and `AbstractDimStack`. `DimStack` layers are unrolled so they are all the same size, and dimensions loop to match the length of the largest layer.

Columns are given the [`name`](@ref) of the array or stack layer, and the result of `DD.name(dimension)` for `Dimension` columns.

Looping of dimensions and stack layers is done _lazily_, and does not allocate unless collected.

## Materializing tables to DimArray or DimStack
`DimArray` and `DimStack` have fallback methods to materialize any `Tables.jl`-compatible table.

By default, it will treat columns such as X, Y, Z, and Band as dimensions, and other columns as data.
Pass a `name` keyword argument to determine which column(s) are used.

You have full control over which columns are dimensions - and what those dimensions look like exactly. If you pass a `Tuple` of `Symbol` or dimension types (e.g. `X`) as the second argument, those columns are treated as dimensions. Passing a `Tuple` of dimensions preserves these dimensions - with values matched to the corresponding columns.

Materializing tables will worked even if the table is not ordered, and can handle missing values.

## Example

````@example dataframe
using DimensionalData
using Dates
using DataFrames
````

Define some dimensions:

````@ansi dataframe
x, y, c = X(1:10), Y(1:10), Dim{:category}('a':'z')
````

::: tabs

== Create a `DimArray`

````@ansi dataframe
A = rand(x, y, c; name=:data)
````

== Create a `DimStack`

````@ansi dataframe
st = DimStack((data1 = rand(x, y), data2=rand(x, y, c)))
````

::: 

## Converting to DataFrame

::: tabs

== Array Default

Arrays will have columns for each dimension, and only one data column

````@ansi dataframe
DataFrame(A)
````

== Stack Default

Stacks will become a table with a column for each dimension, and one for each layer:

````@ansi dataframe
DataFrame(st)
````

== layersfrom

Using [`DimTable`](@ref) we can specify that a `DimArray` 
should take columns from one of the dimensions:

````@ansi dataframe
DataFrame(DimTable(A; layersfrom=:category))
DimStack(A; layersfrom=:category)
````

== mergedims

Using [`DimTable`](@ref) we can merge the spatial 
dimensions so the column is a tuple:

````@ansi dataframe
DataFrame(DimTable(st; mergedims=(:X, :Y)=>:XY))
````

::: 

## Converting to CSV

We can also write arrays and stacks directly to CSV.jl, or any other data type supporting the Tables.jl interface.

````@example dataframe
using CSV
CSV.write("dimstack.csv", st)
readlines("dimstack.csv")
````

## Converting a DataFrame to a DimArray or DimStack

The Dataframe we use will have 5 columns: X, Y, category, data1, and data2

````@ansi dataframe
df = DataFrame(st)
````

::: tabs

== Create a `DimArray`

Converting this DataFrame to a DimArray without other arguments will read the `category` columns as data and ignore data1 and data2:

````@ansi dataframe
DimArray(df)
````

Specify dimenion names to ensure these get treated as dimensions. Now data1 is read in instead.
````@ansi dataframe
DimArray(df, (X,Y,:category))
````

You can also pass in the actual dimensions.
````@ansi dataframe
DimArray(df, dims(st))
````

Pass in a name argument to read in data2 instead.
````@ansi dataframe
DimArray(df, dims(st); name = :data2)
````

== Create a `DimStack`

Converting the DataFrame to a `DimStack` will by default read category, data1, and data2 as layers
````@ansi dataframe
DimStack(df)
````


Specify dimenion names to ensure these get treated as dimensions. Now data1 and data2 are layers.
````@ansi dataframe
DimStack(df, (X,Y,:category))
````

You can also pass in the actual dimensions. 
````@ansi dataframe
DimStack(df, dims(st))
````

Pass in a tuple of column names to control which columns are read.
````@ansi dataframe
DimStack(df, dims(st); name = (:data2,))
````

:::

```@meta
Description = "DimensionalData.jl Lookups API - types for dimension values including Sampled, Categorical, Cyclic, and custom lookup arrays"
```

# Lookups

```@docs
Lookups.Lookups
```

```@docs
Lookups.Lookup
Lookups.Aligned
Lookups.AbstractSampled
Lookups.Sampled
Lookups.AbstractCyclic
Lookups.Cyclic
Lookups.AbstractCategorical
Lookups.Categorical
Lookups.Unaligned
Lookups.Transformed
Dimensions.MergedLookup
Lookups.NoLookup
Lookups.AutoLookup
Lookups.AutoValues
```

The generic value getter `val`

```@docs
Lookups.val
```

Lookup methods:

```@docs
bounds
hasselection
hasinternaldimensions
Lookups.sampling
Lookups.span
Lookups.order
Lookups.locus
Lookups.shiftlocus
```

## Selectors

```@docs
Lookups.Selector
Lookups.IntSelector
Lookups.ArraySelector
At
Near
Between
Touches
Contains
Where
All
```

## Lookup traits

```@docs
Lookups.LookupTrait
```

### Order

```@docs
Lookups.Order
Lookups.Ordered
Lookups.ForwardOrdered
Lookups.ReverseOrdered
Lookups.Unordered
Lookups.AutoOrder
```

### Span

```@docs
Lookups.Span
Lookups.Regular
Lookups.Irregular
Lookups.Explicit
Lookups.AutoSpan
```

### Sampling

```@docs
Lookups.Sampling
Lookups.Points
Lookups.Intervals
```

### Positions

```@docs
Position
Lookups.Center
Lookups.Start
Lookups.Begin
Lookups.End
Lookups.AutoPosition
```

## Metadata

```@docs
Lookups.AbstractMetadata
Lookups.Metadata
Lookups.NoMetadata
Lookups.units
```

```@meta
Description = "DimensionalData.jl Dimensions API reference - types and methods for spatial (X,Y,Z), temporal, and custom dimensions"
```

# Dimensions

Dimensions are kept in the sub-module `Dimensions`.

```@docs
Dimensions.Dimensions
```

Dimensions have a type-hierarchy that organises plotting and
dimension matching.

```@docs
Dimensions.Dimension
Dimensions.DependentDim
Dimensions.IndependentDim
Dimensions.XDim
Dimensions.YDim
Dimensions.ZDim
Dimensions.TimeDim
X
Y
Z
Ti
Dim
Dimensions.AnonDim
Dimensions.@dim
```

### Exported methods

These are widely useful methods for working with dimensions.

```@docs; canonical=false
dims
otherdims
dimnum
hasdim
```

### Non-exported methods

```@docs
Dimensions.lookup
Dimensions.label
Dimensions.format
Dimensions.dims2indices
Dimensions.selectindices
```

### Primitive methods

These low-level methods are really for internal use, but 
can be useful for writing dimensional algorithms.

They are not guaranteed to keep their interface, but usually will.

```@docs
Dimensions.commondims
Dimensions.name2dim
Dimensions.reducedims
Dimensions.swapdims
Dimensions.slicedims
Dimensions.comparedims
Dimensions.combinedims
Dimensions.sortdims
Dimensions.basetypeof
Dimensions.basedims
Dimensions.setdims
Dimensions.dimsmatch
```

```@meta
Description = "Dimensional broadcasting in DimensionalData.jl using @d macro and broadcast_dims for automatic dimensional array operations in Julia"
```

# Dimensional broadcasts with `@d` and `broadcast_dims`

Broadcasting over AbstractDimArray works as usual with Base Julia broadcasts,
except that dimensions are checked for compatibility with each other, and that
values match. Strict checks can be turned off globally with
`strict_broadcast!(false)`. 
To avoid even dimension name checks, broadcast over `parent(dimarray)`.

The [`@d`](@ref) macro is a dimension-aware extension to regular dot broadcasting.
[`broadcast_dims`](@ref) is analogous to Base Julia's `broadcast`. 

Because we know the names of the dimensions, there is no ambiguity in which ones
we mean to broadcast together. This means we can permute and reshape dims so
that broadcasts that would fail with a regular `Array` just work with a
`DimArray`. 

As an added bonus, `broadcast_dims` even works on `DimStack`s. Currently, `@d` 
does not work on `DimStack`.

## Example: scaling along the time dimension

Define some dimensions:

````@example bd
using DimensionalData
using Dates
using Statistics
````

````@ansi bd
x, y, t = X(1:100), Y(1:25), Ti(DateTime(2000):Month(1):DateTime(2000, 12))
````

A DimArray from 1:12 to scale with:

````@ansi bd
month_scalars = DimArray(month, t)
````

And a larger DimArray for example data:

````@ansi bd
data = rand(x, y, t)
````

A regular broadcast fails:

````@ansi bd
scaled = data .* month_scalars
````

But `@d` knows to broadcast over the `Ti` dimension:

````@ansi bd
scaled = @d data .* month_scalars
````

We can see the means of each month are scaled by the broadcast :

````@ansi bd
mean(eachslice(data; dims=(X, Y)))
mean(eachslice(scaled; dims=(X, Y)))
````

You can also use `broadcast_dims` the same way:

````@ansi bd
broadcast_dims(*, data, month_scalars)
````

And with the [`@d`](@ref) macro you can set the dimension order and other
properties of the output array, by passing a single assignment or a `NamedTuple`
argument to `@d` after the broadcast:

````@ansi bd
@d data .* month_scalars dims=(Ti, X, Y)
````

Or
````@ansi bd
@d data .* month_scalars (dims=(Ti, X, Y), name=:scaled)
````
